/* equation-lexer.c generated by valac 0.56.18, the Vala compiler
 * generated from equation-lexer.vala, do not modify */

/*
 * Copyright (C) 2012 Arth Patel
 * Copyright (C) 2012 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */
/* Enum for tokens generated by pre-lexer and lexer. */

#include "calculator.h"
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	PRE_LEXER_0_PROPERTY,
	PRE_LEXER_NUM_PROPERTIES
};
static GParamSpec* pre_lexer_properties[PRE_LEXER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	LEXER_TOKEN_0_PROPERTY,
	LEXER_TOKEN_NUM_PROPERTIES
};
static GParamSpec* lexer_token_properties[LEXER_TOKEN_NUM_PROPERTIES];
enum  {
	LEXER_0_PROPERTY,
	LEXER_NUM_PROPERTIES
};
static GParamSpec* lexer_properties[LEXER_NUM_PROPERTIES];
#define _parser_unref0(var) ((var == NULL) ? NULL : (var = (parser_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _PreLexerPrivate {
	gboolean eos;
};

struct _LexerPrivate {
	Parser* parser;
	PreLexer* prelexer;
	guint next_token;
	gint number_base;
};

static gint PreLexer_private_offset;
static gpointer pre_lexer_parent_class = NULL;
static gpointer lexer_token_parent_class = NULL;
static gint Lexer_private_offset;
static gpointer lexer_parent_class = NULL;

static void pre_lexer_finalize (GObject * obj);
static GType pre_lexer_get_type_once (void);
static void lexer_token_finalize (GObject * obj);
static GType lexer_token_get_type_once (void);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static LexerToken* lexer_insert_next_token (Lexer* self);
static gboolean lexer_check_if_function (Lexer* self);
static gboolean lexer_check_if_unit (Lexer* self);
static gboolean lexer_check_if_currency (Lexer* self);
static gboolean lexer_check_if_literal_base (Lexer* self);
static gboolean lexer_check_if_number (Lexer* self);
static LexerToken* lexer_insert_token (Lexer* self,
                                LexerTokenType type);
static LexerToken* lexer_insert_digit (Lexer* self);
static LexerToken* lexer_insert_decimal (Lexer* self);
static LexerToken* lexer_insert_hex (Lexer* self);
static LexerToken* lexer_insert_letter (Lexer* self);
static LexerToken* lexer_insert_angle_num_dm (Lexer* self);
static LexerToken* lexer_insert_angle_num_dms (Lexer* self);
static LexerToken* lexer_insert_hex_dec (Lexer* self);
static LexerToken* lexer_insert_decimal_hex (Lexer* self);
static void lexer_finalize (GObject * obj);
static GType lexer_get_type_once (void);

static GType
lexer_token_type_get_type_once (void)
{
	static const GEnumValue values[] = {{LEXER_TOKEN_TYPE_UNKNOWN, "LEXER_TOKEN_TYPE_UNKNOWN", "unknown"}, {LEXER_TOKEN_TYPE_PL_DECIMAL, "LEXER_TOKEN_TYPE_PL_DECIMAL", "pl-decimal"}, {LEXER_TOKEN_TYPE_PL_DIGIT, "LEXER_TOKEN_TYPE_PL_DIGIT", "pl-digit"}, {LEXER_TOKEN_TYPE_PL_HEX, "LEXER_TOKEN_TYPE_PL_HEX", "pl-hex"}, {LEXER_TOKEN_TYPE_PL_SUPER_DIGIT, "LEXER_TOKEN_TYPE_PL_SUPER_DIGIT", "pl-super-digit"}, {LEXER_TOKEN_TYPE_PL_SUPER_MINUS, "LEXER_TOKEN_TYPE_PL_SUPER_MINUS", "pl-super-minus"}, {LEXER_TOKEN_TYPE_PL_SUB_DIGIT, "LEXER_TOKEN_TYPE_PL_SUB_DIGIT", "pl-sub-digit"}, {LEXER_TOKEN_TYPE_PL_FRACTION, "LEXER_TOKEN_TYPE_PL_FRACTION", "pl-fraction"}, {LEXER_TOKEN_TYPE_PL_DEGREE, "LEXER_TOKEN_TYPE_PL_DEGREE", "pl-degree"}, {LEXER_TOKEN_TYPE_PL_MINUTE, "LEXER_TOKEN_TYPE_PL_MINUTE", "pl-minute"}, {LEXER_TOKEN_TYPE_PL_SECOND, "LEXER_TOKEN_TYPE_PL_SECOND", "pl-second"}, {LEXER_TOKEN_TYPE_PL_LETTER, "LEXER_TOKEN_TYPE_PL_LETTER", "pl-letter"}, {LEXER_TOKEN_TYPE_PL_EOS, "LEXER_TOKEN_TYPE_PL_EOS", "pl-eos"}, {LEXER_TOKEN_TYPE_PL_SKIP, "LEXER_TOKEN_TYPE_PL_SKIP", "pl-skip"}, {LEXER_TOKEN_TYPE_ADD, "LEXER_TOKEN_TYPE_ADD", "add"}, {LEXER_TOKEN_TYPE_SUBTRACT, "LEXER_TOKEN_TYPE_SUBTRACT", "subtract"}, {LEXER_TOKEN_TYPE_MULTIPLY, "LEXER_TOKEN_TYPE_MULTIPLY", "multiply"}, {LEXER_TOKEN_TYPE_DIVIDE, "LEXER_TOKEN_TYPE_DIVIDE", "divide"}, {LEXER_TOKEN_TYPE_MOD, "LEXER_TOKEN_TYPE_MOD", "mod"}, {LEXER_TOKEN_TYPE_L_FLOOR, "LEXER_TOKEN_TYPE_L_FLOOR", "l-floor"}, {LEXER_TOKEN_TYPE_R_FLOOR, "LEXER_TOKEN_TYPE_R_FLOOR", "r-floor"}, {LEXER_TOKEN_TYPE_L_CEILING, "LEXER_TOKEN_TYPE_L_CEILING", "l-ceiling"}, {LEXER_TOKEN_TYPE_R_CEILING, "LEXER_TOKEN_TYPE_R_CEILING", "r-ceiling"}, {LEXER_TOKEN_TYPE_ROOT, "LEXER_TOKEN_TYPE_ROOT", "root"}, {LEXER_TOKEN_TYPE_ROOT_3, "LEXER_TOKEN_TYPE_ROOT_3", "root-3"}, {LEXER_TOKEN_TYPE_ROOT_4, "LEXER_TOKEN_TYPE_ROOT_4", "root-4"}, {LEXER_TOKEN_TYPE_NOT, "LEXER_TOKEN_TYPE_NOT", "not"}, {LEXER_TOKEN_TYPE_AND, "LEXER_TOKEN_TYPE_AND", "and"}, {LEXER_TOKEN_TYPE_NAND, "LEXER_TOKEN_TYPE_NAND", "nand"}, {LEXER_TOKEN_TYPE_OR, "LEXER_TOKEN_TYPE_OR", "or"}, {LEXER_TOKEN_TYPE_NOR, "LEXER_TOKEN_TYPE_NOR", "nor"}, {LEXER_TOKEN_TYPE_XOR, "LEXER_TOKEN_TYPE_XOR", "xor"}, {LEXER_TOKEN_TYPE_XNOR, "LEXER_TOKEN_TYPE_XNOR", "xnor"}, {LEXER_TOKEN_TYPE_IN, "LEXER_TOKEN_TYPE_IN", "in"}, {LEXER_TOKEN_TYPE_NUMBER, "LEXER_TOKEN_TYPE_NUMBER", "number"}, {LEXER_TOKEN_TYPE_SUP_NUMBER, "LEXER_TOKEN_TYPE_SUP_NUMBER", "sup-number"}, {LEXER_TOKEN_TYPE_NSUP_NUMBER, "LEXER_TOKEN_TYPE_NSUP_NUMBER", "nsup-number"}, {LEXER_TOKEN_TYPE_SUB_NUMBER, "LEXER_TOKEN_TYPE_SUB_NUMBER", "sub-number"}, {LEXER_TOKEN_TYPE_FUNCTION, "LEXER_TOKEN_TYPE_FUNCTION", "function"}, {LEXER_TOKEN_TYPE_UNIT, "LEXER_TOKEN_TYPE_UNIT", "unit"}, {LEXER_TOKEN_TYPE_CURRENCY, "LEXER_TOKEN_TYPE_CURRENCY", "currency"}, {LEXER_TOKEN_TYPE_VARIABLE, "LEXER_TOKEN_TYPE_VARIABLE", "variable"}, {LEXER_TOKEN_TYPE_SHIFT_LEFT, "LEXER_TOKEN_TYPE_SHIFT_LEFT", "shift-left"}, {LEXER_TOKEN_TYPE_SHIFT_RIGHT, "LEXER_TOKEN_TYPE_SHIFT_RIGHT", "shift-right"}, {LEXER_TOKEN_TYPE_SHIFT_URIGHT, "LEXER_TOKEN_TYPE_SHIFT_URIGHT", "shift-uright"}, {LEXER_TOKEN_TYPE_ASSIGN, "LEXER_TOKEN_TYPE_ASSIGN", "assign"}, {LEXER_TOKEN_TYPE_L_R_BRACKET, "LEXER_TOKEN_TYPE_L_R_BRACKET", "l-r-bracket"}, {LEXER_TOKEN_TYPE_R_R_BRACKET, "LEXER_TOKEN_TYPE_R_R_BRACKET", "r-r-bracket"}, {LEXER_TOKEN_TYPE_L_S_BRACKET, "LEXER_TOKEN_TYPE_L_S_BRACKET", "l-s-bracket"}, {LEXER_TOKEN_TYPE_R_S_BRACKET, "LEXER_TOKEN_TYPE_R_S_BRACKET", "r-s-bracket"}, {LEXER_TOKEN_TYPE_L_C_BRACKET, "LEXER_TOKEN_TYPE_L_C_BRACKET", "l-c-bracket"}, {LEXER_TOKEN_TYPE_R_C_BRACKET, "LEXER_TOKEN_TYPE_R_C_BRACKET", "r-c-bracket"}, {LEXER_TOKEN_TYPE_ABS, "LEXER_TOKEN_TYPE_ABS", "abs"}, {LEXER_TOKEN_TYPE_POWER, "LEXER_TOKEN_TYPE_POWER", "power"}, {LEXER_TOKEN_TYPE_FACTORIAL, "LEXER_TOKEN_TYPE_FACTORIAL", "factorial"}, {LEXER_TOKEN_TYPE_PERCENTAGE, "LEXER_TOKEN_TYPE_PERCENTAGE", "percentage"}, {LEXER_TOKEN_TYPE_ARGUMENT_SEPARATOR, "LEXER_TOKEN_TYPE_ARGUMENT_SEPARATOR", "argument-separator"}, {LEXER_TOKEN_TYPE_FUNC_DESC_SEPARATOR, "LEXER_TOKEN_TYPE_FUNC_DESC_SEPARATOR", "func-desc-separator"}, {0, NULL, NULL}};
	GType lexer_token_type_type_id;
	lexer_token_type_type_id = g_enum_register_static ("LexerTokenType", values);
	return lexer_token_type_type_id;
}

GType
lexer_token_type_get_type (void)
{
	static volatile gsize lexer_token_type_type_id__once = 0;
	if (g_once_init_enter (&lexer_token_type_type_id__once)) {
		GType lexer_token_type_type_id;
		lexer_token_type_type_id = lexer_token_type_get_type_once ();
		g_once_init_leave (&lexer_token_type_type_id__once, lexer_token_type_type_id);
	}
	return lexer_token_type_type_id__once;
}

static inline gpointer
pre_lexer_get_instance_private (PreLexer* self)
{
	return G_STRUCT_MEMBER_P (self, PreLexer_private_offset);
}

PreLexer*
pre_lexer_construct (GType object_type,
                     const gchar* input)
{
	PreLexer * self = NULL;
	gchar* _tmp0_;
#line 87 "../lib/equation-lexer.vala"
	g_return_val_if_fail (input != NULL, NULL);
#line 87 "../lib/equation-lexer.vala"
	self = (PreLexer*) g_object_new (object_type, NULL);
#line 89 "../lib/equation-lexer.vala"
	_tmp0_ = g_strdup (input);
#line 89 "../lib/equation-lexer.vala"
	_g_free0 (self->stream);
#line 89 "../lib/equation-lexer.vala"
	self->stream = _tmp0_;
#line 90 "../lib/equation-lexer.vala"
	self->index = 0;
#line 91 "../lib/equation-lexer.vala"
	self->mark_index = 0;
#line 87 "../lib/equation-lexer.vala"
	return self;
#line 143 "equation-lexer.c"
}

PreLexer*
pre_lexer_new (const gchar* input)
{
#line 87 "../lib/equation-lexer.vala"
	return pre_lexer_construct (TYPE_PRE_LEXER, input);
#line 151 "equation-lexer.c"
}

static gboolean
string_get_prev_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result;
#line 1341 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1342 "glib-2.0.vapi"
	if (0 < (*index)) {
#line 165 "equation-lexer.c"
		gchar* _tmp0_;
#line 1343 "glib-2.0.vapi"
		_tmp0_ = g_utf8_prev_char (((gchar*) self) + (*index));
#line 1343 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1344 "glib-2.0.vapi"
		_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1345 "glib-2.0.vapi"
		result = TRUE;
#line 1345 "glib-2.0.vapi"
		if (c) {
#line 1345 "glib-2.0.vapi"
			*c = _vala_c;
#line 179 "equation-lexer.c"
		}
#line 1345 "glib-2.0.vapi"
		return result;
#line 183 "equation-lexer.c"
	} else {
#line 1347 "glib-2.0.vapi"
		_vala_c = (gunichar) 0;
#line 1348 "glib-2.0.vapi"
		result = FALSE;
#line 1348 "glib-2.0.vapi"
		if (c) {
#line 1348 "glib-2.0.vapi"
			*c = _vala_c;
#line 193 "equation-lexer.c"
		}
#line 1348 "glib-2.0.vapi"
		return result;
#line 197 "equation-lexer.c"
	}
}

void
pre_lexer_roll_back (PreLexer* self)
{
	gunichar c = 0U;
	const gchar* _tmp0_;
	gunichar _tmp1_ = 0U;
#line 95 "../lib/equation-lexer.vala"
	g_return_if_fail (self != NULL);
#line 97 "../lib/equation-lexer.vala"
	if (self->priv->eos) {
#line 99 "../lib/equation-lexer.vala"
		self->priv->eos = FALSE;
#line 100 "../lib/equation-lexer.vala"
		return;
#line 215 "equation-lexer.c"
	}
#line 103 "../lib/equation-lexer.vala"
	_tmp0_ = self->stream;
#line 103 "../lib/equation-lexer.vala"
	string_get_prev_char (_tmp0_, &self->index, &_tmp1_);
#line 103 "../lib/equation-lexer.vala"
	c = _tmp1_;
#line 223 "equation-lexer.c"
}

void
pre_lexer_set_marker (PreLexer* self)
{
#line 107 "../lib/equation-lexer.vala"
	g_return_if_fail (self != NULL);
#line 109 "../lib/equation-lexer.vala"
	self->mark_index = self->index;
#line 233 "equation-lexer.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 256 "equation-lexer.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 265 "equation-lexer.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 284 "equation-lexer.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 288 "equation-lexer.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 294 "equation-lexer.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 304 "equation-lexer.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 312 "equation-lexer.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 316 "equation-lexer.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 322 "equation-lexer.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 332 "equation-lexer.c"
}

gchar*
pre_lexer_get_marked_substring (PreLexer* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 113 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 115 "../lib/equation-lexer.vala"
	_tmp0_ = self->stream;
#line 115 "../lib/equation-lexer.vala"
	_tmp1_ = string_substring (_tmp0_, (glong) self->mark_index, (glong) (self->index - self->mark_index));
#line 115 "../lib/equation-lexer.vala"
	result = _tmp1_;
#line 115 "../lib/equation-lexer.vala"
	return result;
#line 351 "equation-lexer.c"
}

static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result;
#line 1302 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1303 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1304 "glib-2.0.vapi"
	if (_vala_c != ((gunichar) 0)) {
#line 367 "equation-lexer.c"
		gchar* _tmp0_;
#line 1305 "glib-2.0.vapi"
		_tmp0_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1305 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1306 "glib-2.0.vapi"
		result = TRUE;
#line 1306 "glib-2.0.vapi"
		if (c) {
#line 1306 "glib-2.0.vapi"
			*c = _vala_c;
#line 379 "equation-lexer.c"
		}
#line 1306 "glib-2.0.vapi"
		return result;
#line 383 "equation-lexer.c"
	} else {
#line 1308 "glib-2.0.vapi"
		result = FALSE;
#line 1308 "glib-2.0.vapi"
		if (c) {
#line 1308 "glib-2.0.vapi"
			*c = _vala_c;
#line 391 "equation-lexer.c"
		}
#line 1308 "glib-2.0.vapi"
		return result;
#line 395 "equation-lexer.c"
	}
}

LexerTokenType
pre_lexer_get_next_token (PreLexer* self)
{
	gunichar c = 0U;
	const gchar* _tmp0_;
	gunichar _tmp1_ = 0U;
	gboolean _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_ = FALSE;
	gboolean _tmp23_ = FALSE;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp27_ = FALSE;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp29_ = FALSE;
	gboolean _tmp30_ = FALSE;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_ = FALSE;
	gboolean _tmp33_ = FALSE;
	gboolean _tmp34_ = FALSE;
	gboolean _tmp35_ = FALSE;
	gboolean _tmp36_ = FALSE;
	gboolean _tmp37_ = FALSE;
	gboolean _tmp38_ = FALSE;
	gboolean _tmp39_ = FALSE;
	gboolean _tmp40_ = FALSE;
	gboolean _tmp41_ = FALSE;
	gboolean _tmp42_ = FALSE;
	gboolean _tmp43_ = FALSE;
	gboolean _tmp44_ = FALSE;
	gboolean _tmp45_ = FALSE;
	gboolean _tmp46_ = FALSE;
	gboolean _tmp47_ = FALSE;
	gboolean _tmp48_ = FALSE;
	gboolean _tmp49_ = FALSE;
	gboolean _tmp50_ = FALSE;
	gboolean _tmp51_ = FALSE;
	gboolean _tmp52_ = FALSE;
	gboolean _tmp53_ = FALSE;
	gboolean _tmp54_ = FALSE;
	gboolean _tmp55_ = FALSE;
	gboolean _tmp56_ = FALSE;
	gboolean _tmp57_ = FALSE;
	LexerTokenType result;
#line 119 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 122 "../lib/equation-lexer.vala"
	_tmp0_ = self->stream;
#line 122 "../lib/equation-lexer.vala"
	_tmp2_ = string_get_next_char (_tmp0_, &self->index, &_tmp1_);
#line 122 "../lib/equation-lexer.vala"
	c = _tmp1_;
#line 122 "../lib/equation-lexer.vala"
	if (!_tmp2_) {
#line 125 "../lib/equation-lexer.vala"
		self->priv->eos = TRUE;
#line 126 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_PL_EOS;
#line 126 "../lib/equation-lexer.vala"
		return result;
#line 477 "equation-lexer.c"
	}
#line 128 "../lib/equation-lexer.vala"
	self->priv->eos = FALSE;
#line 130 "../lib/equation-lexer.vala"
	if (c == ((gunichar) ',')) {
#line 130 "../lib/equation-lexer.vala"
		_tmp3_ = TRUE;
#line 485 "equation-lexer.c"
	} else {
#line 130 "../lib/equation-lexer.vala"
		_tmp3_ = c == ((gunichar) '.');
#line 489 "equation-lexer.c"
	}
#line 130 "../lib/equation-lexer.vala"
	if (_tmp3_) {
#line 131 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_PL_DECIMAL;
#line 131 "../lib/equation-lexer.vala"
		return result;
#line 497 "equation-lexer.c"
	}
#line 133 "../lib/equation-lexer.vala"
	if (g_unichar_isdigit (c)) {
#line 134 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_PL_DIGIT;
#line 134 "../lib/equation-lexer.vala"
		return result;
#line 505 "equation-lexer.c"
	}
#line 136 "../lib/equation-lexer.vala"
	if (c >= ((gunichar) 'a')) {
#line 136 "../lib/equation-lexer.vala"
		_tmp5_ = c <= ((gunichar) 'f');
#line 511 "equation-lexer.c"
	} else {
#line 136 "../lib/equation-lexer.vala"
		_tmp5_ = FALSE;
#line 515 "equation-lexer.c"
	}
#line 136 "../lib/equation-lexer.vala"
	if (_tmp5_) {
#line 136 "../lib/equation-lexer.vala"
		_tmp4_ = TRUE;
#line 521 "equation-lexer.c"
	} else {
		gboolean _tmp6_ = FALSE;
#line 136 "../lib/equation-lexer.vala"
		if (c >= ((gunichar) 'A')) {
#line 136 "../lib/equation-lexer.vala"
			_tmp6_ = c <= ((gunichar) 'F');
#line 528 "equation-lexer.c"
		} else {
#line 136 "../lib/equation-lexer.vala"
			_tmp6_ = FALSE;
#line 532 "equation-lexer.c"
		}
#line 136 "../lib/equation-lexer.vala"
		_tmp4_ = _tmp6_;
#line 536 "equation-lexer.c"
	}
#line 136 "../lib/equation-lexer.vala"
	if (_tmp4_) {
#line 137 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_PL_HEX;
#line 137 "../lib/equation-lexer.vala"
		return result;
#line 544 "equation-lexer.c"
	}
#line 139 "../lib/equation-lexer.vala"
	if (c == 8304U) {
#line 139 "../lib/equation-lexer.vala"
		_tmp15_ = TRUE;
#line 550 "equation-lexer.c"
	} else {
#line 139 "../lib/equation-lexer.vala"
		_tmp15_ = c == 185U;
#line 554 "equation-lexer.c"
	}
#line 139 "../lib/equation-lexer.vala"
	if (_tmp15_) {
#line 139 "../lib/equation-lexer.vala"
		_tmp14_ = TRUE;
#line 560 "equation-lexer.c"
	} else {
#line 139 "../lib/equation-lexer.vala"
		_tmp14_ = c == 178U;
#line 564 "equation-lexer.c"
	}
#line 139 "../lib/equation-lexer.vala"
	if (_tmp14_) {
#line 139 "../lib/equation-lexer.vala"
		_tmp13_ = TRUE;
#line 570 "equation-lexer.c"
	} else {
#line 139 "../lib/equation-lexer.vala"
		_tmp13_ = c == 179U;
#line 574 "equation-lexer.c"
	}
#line 139 "../lib/equation-lexer.vala"
	if (_tmp13_) {
#line 139 "../lib/equation-lexer.vala"
		_tmp12_ = TRUE;
#line 580 "equation-lexer.c"
	} else {
#line 139 "../lib/equation-lexer.vala"
		_tmp12_ = c == 8308U;
#line 584 "equation-lexer.c"
	}
#line 139 "../lib/equation-lexer.vala"
	if (_tmp12_) {
#line 139 "../lib/equation-lexer.vala"
		_tmp11_ = TRUE;
#line 590 "equation-lexer.c"
	} else {
#line 139 "../lib/equation-lexer.vala"
		_tmp11_ = c == 8309U;
#line 594 "equation-lexer.c"
	}
#line 139 "../lib/equation-lexer.vala"
	if (_tmp11_) {
#line 139 "../lib/equation-lexer.vala"
		_tmp10_ = TRUE;
#line 600 "equation-lexer.c"
	} else {
#line 139 "../lib/equation-lexer.vala"
		_tmp10_ = c == 8310U;
#line 604 "equation-lexer.c"
	}
#line 139 "../lib/equation-lexer.vala"
	if (_tmp10_) {
#line 139 "../lib/equation-lexer.vala"
		_tmp9_ = TRUE;
#line 610 "equation-lexer.c"
	} else {
#line 139 "../lib/equation-lexer.vala"
		_tmp9_ = c == 8311U;
#line 614 "equation-lexer.c"
	}
#line 139 "../lib/equation-lexer.vala"
	if (_tmp9_) {
#line 139 "../lib/equation-lexer.vala"
		_tmp8_ = TRUE;
#line 620 "equation-lexer.c"
	} else {
#line 139 "../lib/equation-lexer.vala"
		_tmp8_ = c == 8312U;
#line 624 "equation-lexer.c"
	}
#line 139 "../lib/equation-lexer.vala"
	if (_tmp8_) {
#line 139 "../lib/equation-lexer.vala"
		_tmp7_ = TRUE;
#line 630 "equation-lexer.c"
	} else {
#line 139 "../lib/equation-lexer.vala"
		_tmp7_ = c == 8313U;
#line 634 "equation-lexer.c"
	}
#line 139 "../lib/equation-lexer.vala"
	if (_tmp7_) {
#line 140 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_PL_SUPER_DIGIT;
#line 140 "../lib/equation-lexer.vala"
		return result;
#line 642 "equation-lexer.c"
	}
#line 142 "../lib/equation-lexer.vala"
	if (c == 8315U) {
#line 143 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_PL_SUPER_MINUS;
#line 143 "../lib/equation-lexer.vala"
		return result;
#line 650 "equation-lexer.c"
	}
#line 145 "../lib/equation-lexer.vala"
	if (c == 8320U) {
#line 145 "../lib/equation-lexer.vala"
		_tmp24_ = TRUE;
#line 656 "equation-lexer.c"
	} else {
#line 145 "../lib/equation-lexer.vala"
		_tmp24_ = c == 8321U;
#line 660 "equation-lexer.c"
	}
#line 145 "../lib/equation-lexer.vala"
	if (_tmp24_) {
#line 145 "../lib/equation-lexer.vala"
		_tmp23_ = TRUE;
#line 666 "equation-lexer.c"
	} else {
#line 145 "../lib/equation-lexer.vala"
		_tmp23_ = c == 8322U;
#line 670 "equation-lexer.c"
	}
#line 145 "../lib/equation-lexer.vala"
	if (_tmp23_) {
#line 145 "../lib/equation-lexer.vala"
		_tmp22_ = TRUE;
#line 676 "equation-lexer.c"
	} else {
#line 145 "../lib/equation-lexer.vala"
		_tmp22_ = c == 8323U;
#line 680 "equation-lexer.c"
	}
#line 145 "../lib/equation-lexer.vala"
	if (_tmp22_) {
#line 145 "../lib/equation-lexer.vala"
		_tmp21_ = TRUE;
#line 686 "equation-lexer.c"
	} else {
#line 145 "../lib/equation-lexer.vala"
		_tmp21_ = c == 8324U;
#line 690 "equation-lexer.c"
	}
#line 145 "../lib/equation-lexer.vala"
	if (_tmp21_) {
#line 145 "../lib/equation-lexer.vala"
		_tmp20_ = TRUE;
#line 696 "equation-lexer.c"
	} else {
#line 145 "../lib/equation-lexer.vala"
		_tmp20_ = c == 8325U;
#line 700 "equation-lexer.c"
	}
#line 145 "../lib/equation-lexer.vala"
	if (_tmp20_) {
#line 145 "../lib/equation-lexer.vala"
		_tmp19_ = TRUE;
#line 706 "equation-lexer.c"
	} else {
#line 145 "../lib/equation-lexer.vala"
		_tmp19_ = c == 8326U;
#line 710 "equation-lexer.c"
	}
#line 145 "../lib/equation-lexer.vala"
	if (_tmp19_) {
#line 145 "../lib/equation-lexer.vala"
		_tmp18_ = TRUE;
#line 716 "equation-lexer.c"
	} else {
#line 145 "../lib/equation-lexer.vala"
		_tmp18_ = c == 8327U;
#line 720 "equation-lexer.c"
	}
#line 145 "../lib/equation-lexer.vala"
	if (_tmp18_) {
#line 145 "../lib/equation-lexer.vala"
		_tmp17_ = TRUE;
#line 726 "equation-lexer.c"
	} else {
#line 145 "../lib/equation-lexer.vala"
		_tmp17_ = c == 8328U;
#line 730 "equation-lexer.c"
	}
#line 145 "../lib/equation-lexer.vala"
	if (_tmp17_) {
#line 145 "../lib/equation-lexer.vala"
		_tmp16_ = TRUE;
#line 736 "equation-lexer.c"
	} else {
#line 145 "../lib/equation-lexer.vala"
		_tmp16_ = c == 8329U;
#line 740 "equation-lexer.c"
	}
#line 145 "../lib/equation-lexer.vala"
	if (_tmp16_) {
#line 146 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_PL_SUB_DIGIT;
#line 146 "../lib/equation-lexer.vala"
		return result;
#line 748 "equation-lexer.c"
	}
#line 148 "../lib/equation-lexer.vala"
	if (c == 189U) {
#line 148 "../lib/equation-lexer.vala"
		_tmp38_ = TRUE;
#line 754 "equation-lexer.c"
	} else {
#line 148 "../lib/equation-lexer.vala"
		_tmp38_ = c == 8531U;
#line 758 "equation-lexer.c"
	}
#line 148 "../lib/equation-lexer.vala"
	if (_tmp38_) {
#line 148 "../lib/equation-lexer.vala"
		_tmp37_ = TRUE;
#line 764 "equation-lexer.c"
	} else {
#line 148 "../lib/equation-lexer.vala"
		_tmp37_ = c == 8532U;
#line 768 "equation-lexer.c"
	}
#line 148 "../lib/equation-lexer.vala"
	if (_tmp37_) {
#line 148 "../lib/equation-lexer.vala"
		_tmp36_ = TRUE;
#line 774 "equation-lexer.c"
	} else {
#line 148 "../lib/equation-lexer.vala"
		_tmp36_ = c == 188U;
#line 778 "equation-lexer.c"
	}
#line 148 "../lib/equation-lexer.vala"
	if (_tmp36_) {
#line 148 "../lib/equation-lexer.vala"
		_tmp35_ = TRUE;
#line 784 "equation-lexer.c"
	} else {
#line 148 "../lib/equation-lexer.vala"
		_tmp35_ = c == 190U;
#line 788 "equation-lexer.c"
	}
#line 148 "../lib/equation-lexer.vala"
	if (_tmp35_) {
#line 148 "../lib/equation-lexer.vala"
		_tmp34_ = TRUE;
#line 794 "equation-lexer.c"
	} else {
#line 148 "../lib/equation-lexer.vala"
		_tmp34_ = c == 8533U;
#line 798 "equation-lexer.c"
	}
#line 148 "../lib/equation-lexer.vala"
	if (_tmp34_) {
#line 148 "../lib/equation-lexer.vala"
		_tmp33_ = TRUE;
#line 804 "equation-lexer.c"
	} else {
#line 148 "../lib/equation-lexer.vala"
		_tmp33_ = c == 8534U;
#line 808 "equation-lexer.c"
	}
#line 148 "../lib/equation-lexer.vala"
	if (_tmp33_) {
#line 148 "../lib/equation-lexer.vala"
		_tmp32_ = TRUE;
#line 814 "equation-lexer.c"
	} else {
#line 148 "../lib/equation-lexer.vala"
		_tmp32_ = c == 8535U;
#line 818 "equation-lexer.c"
	}
#line 148 "../lib/equation-lexer.vala"
	if (_tmp32_) {
#line 148 "../lib/equation-lexer.vala"
		_tmp31_ = TRUE;
#line 824 "equation-lexer.c"
	} else {
#line 148 "../lib/equation-lexer.vala"
		_tmp31_ = c == 8536U;
#line 828 "equation-lexer.c"
	}
#line 148 "../lib/equation-lexer.vala"
	if (_tmp31_) {
#line 148 "../lib/equation-lexer.vala"
		_tmp30_ = TRUE;
#line 834 "equation-lexer.c"
	} else {
#line 148 "../lib/equation-lexer.vala"
		_tmp30_ = c == 8537U;
#line 838 "equation-lexer.c"
	}
#line 148 "../lib/equation-lexer.vala"
	if (_tmp30_) {
#line 148 "../lib/equation-lexer.vala"
		_tmp29_ = TRUE;
#line 844 "equation-lexer.c"
	} else {
#line 148 "../lib/equation-lexer.vala"
		_tmp29_ = c == 8538U;
#line 848 "equation-lexer.c"
	}
#line 148 "../lib/equation-lexer.vala"
	if (_tmp29_) {
#line 148 "../lib/equation-lexer.vala"
		_tmp28_ = TRUE;
#line 854 "equation-lexer.c"
	} else {
#line 148 "../lib/equation-lexer.vala"
		_tmp28_ = c == 8539U;
#line 858 "equation-lexer.c"
	}
#line 148 "../lib/equation-lexer.vala"
	if (_tmp28_) {
#line 148 "../lib/equation-lexer.vala"
		_tmp27_ = TRUE;
#line 864 "equation-lexer.c"
	} else {
#line 148 "../lib/equation-lexer.vala"
		_tmp27_ = c == 8540U;
#line 868 "equation-lexer.c"
	}
#line 148 "../lib/equation-lexer.vala"
	if (_tmp27_) {
#line 148 "../lib/equation-lexer.vala"
		_tmp26_ = TRUE;
#line 874 "equation-lexer.c"
	} else {
#line 148 "../lib/equation-lexer.vala"
		_tmp26_ = c == 8541U;
#line 878 "equation-lexer.c"
	}
#line 148 "../lib/equation-lexer.vala"
	if (_tmp26_) {
#line 148 "../lib/equation-lexer.vala"
		_tmp25_ = TRUE;
#line 884 "equation-lexer.c"
	} else {
#line 148 "../lib/equation-lexer.vala"
		_tmp25_ = c == 8542U;
#line 888 "equation-lexer.c"
	}
#line 148 "../lib/equation-lexer.vala"
	if (_tmp25_) {
#line 149 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_PL_FRACTION;
#line 149 "../lib/equation-lexer.vala"
		return result;
#line 896 "equation-lexer.c"
	}
#line 151 "../lib/equation-lexer.vala"
	if (c == 730U) {
#line 151 "../lib/equation-lexer.vala"
		_tmp39_ = TRUE;
#line 902 "equation-lexer.c"
	} else {
#line 151 "../lib/equation-lexer.vala"
		_tmp39_ = c == 176U;
#line 906 "equation-lexer.c"
	}
#line 151 "../lib/equation-lexer.vala"
	if (_tmp39_) {
#line 152 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_PL_DEGREE;
#line 152 "../lib/equation-lexer.vala"
		return result;
#line 914 "equation-lexer.c"
	}
#line 154 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '\'')) {
#line 154 "../lib/equation-lexer.vala"
		_tmp41_ = TRUE;
#line 920 "equation-lexer.c"
	} else {
#line 154 "../lib/equation-lexer.vala"
		_tmp41_ = c == 8242U;
#line 924 "equation-lexer.c"
	}
#line 154 "../lib/equation-lexer.vala"
	if (_tmp41_) {
#line 154 "../lib/equation-lexer.vala"
		_tmp40_ = TRUE;
#line 930 "equation-lexer.c"
	} else {
#line 154 "../lib/equation-lexer.vala"
		_tmp40_ = c == 8217U;
#line 934 "equation-lexer.c"
	}
#line 154 "../lib/equation-lexer.vala"
	if (_tmp40_) {
#line 155 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_PL_MINUTE;
#line 155 "../lib/equation-lexer.vala"
		return result;
#line 942 "equation-lexer.c"
	}
#line 157 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '"')) {
#line 157 "../lib/equation-lexer.vala"
		_tmp43_ = TRUE;
#line 948 "equation-lexer.c"
	} else {
#line 157 "../lib/equation-lexer.vala"
		_tmp43_ = c == 8243U;
#line 952 "equation-lexer.c"
	}
#line 157 "../lib/equation-lexer.vala"
	if (_tmp43_) {
#line 157 "../lib/equation-lexer.vala"
		_tmp42_ = TRUE;
#line 958 "equation-lexer.c"
	} else {
#line 157 "../lib/equation-lexer.vala"
		_tmp42_ = c == 8221U;
#line 962 "equation-lexer.c"
	}
#line 157 "../lib/equation-lexer.vala"
	if (_tmp42_) {
#line 158 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_PL_SECOND;
#line 158 "../lib/equation-lexer.vala"
		return result;
#line 970 "equation-lexer.c"
	}
#line 160 "../lib/equation-lexer.vala"
	if (g_unichar_isalpha (c)) {
#line 160 "../lib/equation-lexer.vala"
		_tmp45_ = TRUE;
#line 976 "equation-lexer.c"
	} else {
#line 160 "../lib/equation-lexer.vala"
		_tmp45_ = c == ((gunichar) '_');
#line 980 "equation-lexer.c"
	}
#line 160 "../lib/equation-lexer.vala"
	if (_tmp45_) {
#line 160 "../lib/equation-lexer.vala"
		_tmp44_ = TRUE;
#line 986 "equation-lexer.c"
	} else {
#line 160 "../lib/equation-lexer.vala"
		_tmp44_ = c == ((gunichar) '\\');
#line 990 "equation-lexer.c"
	}
#line 160 "../lib/equation-lexer.vala"
	if (_tmp44_) {
#line 161 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_PL_LETTER;
#line 161 "../lib/equation-lexer.vala"
		return result;
#line 998 "equation-lexer.c"
	}
#line 163 "../lib/equation-lexer.vala"
	if (c == 8743U) {
#line 164 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_AND;
#line 164 "../lib/equation-lexer.vala"
		return result;
#line 1006 "equation-lexer.c"
	}
#line 166 "../lib/equation-lexer.vala"
	if (c == 8892U) {
#line 167 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_NAND;
#line 167 "../lib/equation-lexer.vala"
		return result;
#line 1014 "equation-lexer.c"
	}
#line 169 "../lib/equation-lexer.vala"
	if (c == 8744U) {
#line 170 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_OR;
#line 170 "../lib/equation-lexer.vala"
		return result;
#line 1022 "equation-lexer.c"
	}
#line 172 "../lib/equation-lexer.vala"
	if (c == 8893U) {
#line 173 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_NOR;
#line 173 "../lib/equation-lexer.vala"
		return result;
#line 1030 "equation-lexer.c"
	}
#line 175 "../lib/equation-lexer.vala"
	if (c == 8891U) {
#line 175 "../lib/equation-lexer.vala"
		_tmp46_ = TRUE;
#line 1036 "equation-lexer.c"
	} else {
#line 175 "../lib/equation-lexer.vala"
		_tmp46_ = c == 8853U;
#line 1040 "equation-lexer.c"
	}
#line 175 "../lib/equation-lexer.vala"
	if (_tmp46_) {
#line 176 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_XOR;
#line 176 "../lib/equation-lexer.vala"
		return result;
#line 1048 "equation-lexer.c"
	}
#line 178 "../lib/equation-lexer.vala"
	if (c == 8857U) {
#line 179 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_XNOR;
#line 179 "../lib/equation-lexer.vala"
		return result;
#line 1056 "equation-lexer.c"
	}
#line 181 "../lib/equation-lexer.vala"
	if (c == 172U) {
#line 181 "../lib/equation-lexer.vala"
		_tmp47_ = TRUE;
#line 1062 "equation-lexer.c"
	} else {
#line 181 "../lib/equation-lexer.vala"
		_tmp47_ = c == ((gunichar) '~');
#line 1066 "equation-lexer.c"
	}
#line 181 "../lib/equation-lexer.vala"
	if (_tmp47_) {
#line 182 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_NOT;
#line 182 "../lib/equation-lexer.vala"
		return result;
#line 1074 "equation-lexer.c"
	}
#line 184 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '+')) {
#line 185 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_ADD;
#line 185 "../lib/equation-lexer.vala"
		return result;
#line 1082 "equation-lexer.c"
	}
#line 187 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '-')) {
#line 187 "../lib/equation-lexer.vala"
		_tmp49_ = TRUE;
#line 1088 "equation-lexer.c"
	} else {
#line 187 "../lib/equation-lexer.vala"
		_tmp49_ = c == 8722U;
#line 1092 "equation-lexer.c"
	}
#line 187 "../lib/equation-lexer.vala"
	if (_tmp49_) {
#line 187 "../lib/equation-lexer.vala"
		_tmp48_ = TRUE;
#line 1098 "equation-lexer.c"
	} else {
#line 187 "../lib/equation-lexer.vala"
		_tmp48_ = c == 8211U;
#line 1102 "equation-lexer.c"
	}
#line 187 "../lib/equation-lexer.vala"
	if (_tmp48_) {
#line 188 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_SUBTRACT;
#line 188 "../lib/equation-lexer.vala"
		return result;
#line 1110 "equation-lexer.c"
	}
#line 190 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '*')) {
#line 190 "../lib/equation-lexer.vala"
		_tmp50_ = TRUE;
#line 1116 "equation-lexer.c"
	} else {
#line 190 "../lib/equation-lexer.vala"
		_tmp50_ = c == 215U;
#line 1120 "equation-lexer.c"
	}
#line 190 "../lib/equation-lexer.vala"
	if (_tmp50_) {
#line 191 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_MULTIPLY;
#line 191 "../lib/equation-lexer.vala"
		return result;
#line 1128 "equation-lexer.c"
	}
#line 193 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '/')) {
#line 193 "../lib/equation-lexer.vala"
		_tmp52_ = TRUE;
#line 1134 "equation-lexer.c"
	} else {
#line 193 "../lib/equation-lexer.vala"
		_tmp52_ = c == 8725U;
#line 1138 "equation-lexer.c"
	}
#line 193 "../lib/equation-lexer.vala"
	if (_tmp52_) {
#line 193 "../lib/equation-lexer.vala"
		_tmp51_ = TRUE;
#line 1144 "equation-lexer.c"
	} else {
#line 193 "../lib/equation-lexer.vala"
		_tmp51_ = c == 247U;
#line 1148 "equation-lexer.c"
	}
#line 193 "../lib/equation-lexer.vala"
	if (_tmp51_) {
#line 194 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_DIVIDE;
#line 194 "../lib/equation-lexer.vala"
		return result;
#line 1156 "equation-lexer.c"
	}
#line 196 "../lib/equation-lexer.vala"
	if (c == 8970U) {
#line 197 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_L_FLOOR;
#line 197 "../lib/equation-lexer.vala"
		return result;
#line 1164 "equation-lexer.c"
	}
#line 199 "../lib/equation-lexer.vala"
	if (c == 8971U) {
#line 200 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_R_FLOOR;
#line 200 "../lib/equation-lexer.vala"
		return result;
#line 1172 "equation-lexer.c"
	}
#line 202 "../lib/equation-lexer.vala"
	if (c == 8968U) {
#line 203 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_L_CEILING;
#line 203 "../lib/equation-lexer.vala"
		return result;
#line 1180 "equation-lexer.c"
	}
#line 205 "../lib/equation-lexer.vala"
	if (c == 8969U) {
#line 206 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_R_CEILING;
#line 206 "../lib/equation-lexer.vala"
		return result;
#line 1188 "equation-lexer.c"
	}
#line 208 "../lib/equation-lexer.vala"
	if (c == 8730U) {
#line 209 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_ROOT;
#line 209 "../lib/equation-lexer.vala"
		return result;
#line 1196 "equation-lexer.c"
	}
#line 211 "../lib/equation-lexer.vala"
	if (c == 8731U) {
#line 212 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_ROOT_3;
#line 212 "../lib/equation-lexer.vala"
		return result;
#line 1204 "equation-lexer.c"
	}
#line 214 "../lib/equation-lexer.vala"
	if (c == 8732U) {
#line 215 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_ROOT_4;
#line 215 "../lib/equation-lexer.vala"
		return result;
#line 1212 "equation-lexer.c"
	}
#line 217 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '=')) {
#line 218 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_ASSIGN;
#line 218 "../lib/equation-lexer.vala"
		return result;
#line 1220 "equation-lexer.c"
	}
#line 220 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '(')) {
#line 221 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_L_R_BRACKET;
#line 221 "../lib/equation-lexer.vala"
		return result;
#line 1228 "equation-lexer.c"
	}
#line 223 "../lib/equation-lexer.vala"
	if (c == ((gunichar) ')')) {
#line 224 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_R_R_BRACKET;
#line 224 "../lib/equation-lexer.vala"
		return result;
#line 1236 "equation-lexer.c"
	}
#line 226 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '[')) {
#line 227 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_L_S_BRACKET;
#line 227 "../lib/equation-lexer.vala"
		return result;
#line 1244 "equation-lexer.c"
	}
#line 229 "../lib/equation-lexer.vala"
	if (c == ((gunichar) ']')) {
#line 230 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_R_S_BRACKET;
#line 230 "../lib/equation-lexer.vala"
		return result;
#line 1252 "equation-lexer.c"
	}
#line 232 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '{')) {
#line 233 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_L_C_BRACKET;
#line 233 "../lib/equation-lexer.vala"
		return result;
#line 1260 "equation-lexer.c"
	}
#line 235 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '}')) {
#line 236 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_R_C_BRACKET;
#line 236 "../lib/equation-lexer.vala"
		return result;
#line 1268 "equation-lexer.c"
	}
#line 238 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '|')) {
#line 239 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_ABS;
#line 239 "../lib/equation-lexer.vala"
		return result;
#line 1276 "equation-lexer.c"
	}
#line 241 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '^')) {
#line 242 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_POWER;
#line 242 "../lib/equation-lexer.vala"
		return result;
#line 1284 "equation-lexer.c"
	}
#line 244 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '!')) {
#line 245 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_FACTORIAL;
#line 245 "../lib/equation-lexer.vala"
		return result;
#line 1292 "equation-lexer.c"
	}
#line 247 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '%')) {
#line 248 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_PERCENTAGE;
#line 248 "../lib/equation-lexer.vala"
		return result;
#line 1300 "equation-lexer.c"
	}
#line 250 "../lib/equation-lexer.vala"
	if (c == ((gunichar) ';')) {
#line 251 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_ARGUMENT_SEPARATOR;
#line 251 "../lib/equation-lexer.vala"
		return result;
#line 1308 "equation-lexer.c"
	}
#line 253 "../lib/equation-lexer.vala"
	if (c == 8921U) {
#line 254 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_SHIFT_URIGHT;
#line 254 "../lib/equation-lexer.vala"
		return result;
#line 1316 "equation-lexer.c"
	}
#line 256 "../lib/equation-lexer.vala"
	if (c == 187U) {
#line 256 "../lib/equation-lexer.vala"
		_tmp53_ = TRUE;
#line 1322 "equation-lexer.c"
	} else {
#line 256 "../lib/equation-lexer.vala"
		_tmp53_ = c == 8811U;
#line 1326 "equation-lexer.c"
	}
#line 256 "../lib/equation-lexer.vala"
	if (_tmp53_) {
#line 257 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_SHIFT_RIGHT;
#line 257 "../lib/equation-lexer.vala"
		return result;
#line 1334 "equation-lexer.c"
	}
#line 259 "../lib/equation-lexer.vala"
	if (c == 171U) {
#line 259 "../lib/equation-lexer.vala"
		_tmp54_ = TRUE;
#line 1340 "equation-lexer.c"
	} else {
#line 259 "../lib/equation-lexer.vala"
		_tmp54_ = c == 8810U;
#line 1344 "equation-lexer.c"
	}
#line 259 "../lib/equation-lexer.vala"
	if (_tmp54_) {
#line 260 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_SHIFT_LEFT;
#line 260 "../lib/equation-lexer.vala"
		return result;
#line 1352 "equation-lexer.c"
	}
#line 262 "../lib/equation-lexer.vala"
	if (c == ((gunichar) ' ')) {
#line 262 "../lib/equation-lexer.vala"
		_tmp57_ = TRUE;
#line 1358 "equation-lexer.c"
	} else {
#line 262 "../lib/equation-lexer.vala"
		_tmp57_ = c == ((gunichar) '\r');
#line 1362 "equation-lexer.c"
	}
#line 262 "../lib/equation-lexer.vala"
	if (_tmp57_) {
#line 262 "../lib/equation-lexer.vala"
		_tmp56_ = TRUE;
#line 1368 "equation-lexer.c"
	} else {
#line 262 "../lib/equation-lexer.vala"
		_tmp56_ = c == ((gunichar) '\t');
#line 1372 "equation-lexer.c"
	}
#line 262 "../lib/equation-lexer.vala"
	if (_tmp56_) {
#line 262 "../lib/equation-lexer.vala"
		_tmp55_ = TRUE;
#line 1378 "equation-lexer.c"
	} else {
#line 262 "../lib/equation-lexer.vala"
		_tmp55_ = c == ((gunichar) '\n');
#line 1382 "equation-lexer.c"
	}
#line 262 "../lib/equation-lexer.vala"
	if (_tmp55_) {
#line 263 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_PL_SKIP;
#line 263 "../lib/equation-lexer.vala"
		return result;
#line 1390 "equation-lexer.c"
	}
#line 265 "../lib/equation-lexer.vala"
	if (c == ((gunichar) '@')) {
#line 266 "../lib/equation-lexer.vala"
		result = LEXER_TOKEN_TYPE_FUNC_DESC_SEPARATOR;
#line 266 "../lib/equation-lexer.vala"
		return result;
#line 1398 "equation-lexer.c"
	}
#line 268 "../lib/equation-lexer.vala"
	result = LEXER_TOKEN_TYPE_UNKNOWN;
#line 268 "../lib/equation-lexer.vala"
	return result;
#line 1404 "equation-lexer.c"
}

static void
pre_lexer_class_init (PreLexerClass * klass,
                      gpointer klass_data)
{
#line 80 "../lib/equation-lexer.vala"
	pre_lexer_parent_class = g_type_class_peek_parent (klass);
#line 80 "../lib/equation-lexer.vala"
	g_type_class_adjust_private_offset (klass, &PreLexer_private_offset);
#line 80 "../lib/equation-lexer.vala"
	G_OBJECT_CLASS (klass)->finalize = pre_lexer_finalize;
#line 1417 "equation-lexer.c"
}

static void
pre_lexer_instance_init (PreLexer * self,
                         gpointer klass)
{
#line 80 "../lib/equation-lexer.vala"
	self->priv = pre_lexer_get_instance_private (self);
#line 85 "../lib/equation-lexer.vala"
	self->priv->eos = FALSE;
#line 1428 "equation-lexer.c"
}

static void
pre_lexer_finalize (GObject * obj)
{
	PreLexer * self;
#line 80 "../lib/equation-lexer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PRE_LEXER, PreLexer);
#line 82 "../lib/equation-lexer.vala"
	_g_free0 (self->stream);
#line 80 "../lib/equation-lexer.vala"
	G_OBJECT_CLASS (pre_lexer_parent_class)->finalize (obj);
#line 1441 "equation-lexer.c"
}

static GType
pre_lexer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PreLexerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pre_lexer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PreLexer), 0, (GInstanceInitFunc) pre_lexer_instance_init, NULL };
	GType pre_lexer_type_id;
	pre_lexer_type_id = g_type_register_static (G_TYPE_OBJECT, "PreLexer", &g_define_type_info, 0);
	PreLexer_private_offset = g_type_add_instance_private (pre_lexer_type_id, sizeof (PreLexerPrivate));
	return pre_lexer_type_id;
}

GType
pre_lexer_get_type (void)
{
	static volatile gsize pre_lexer_type_id__once = 0;
	if (g_once_init_enter (&pre_lexer_type_id__once)) {
		GType pre_lexer_type_id;
		pre_lexer_type_id = pre_lexer_get_type_once ();
		g_once_init_leave (&pre_lexer_type_id__once, pre_lexer_type_id);
	}
	return pre_lexer_type_id__once;
}

LexerToken*
lexer_token_construct (GType object_type)
{
	LexerToken * self = NULL;
#line 273 "../lib/equation-lexer.vala"
	self = (LexerToken*) g_object_new (object_type, NULL);
#line 273 "../lib/equation-lexer.vala"
	return self;
#line 1474 "equation-lexer.c"
}

LexerToken*
lexer_token_new (void)
{
#line 273 "../lib/equation-lexer.vala"
	return lexer_token_construct (TYPE_LEXER_TOKEN);
#line 1482 "equation-lexer.c"
}

static void
lexer_token_class_init (LexerTokenClass * klass,
                        gpointer klass_data)
{
#line 273 "../lib/equation-lexer.vala"
	lexer_token_parent_class = g_type_class_peek_parent (klass);
#line 273 "../lib/equation-lexer.vala"
	G_OBJECT_CLASS (klass)->finalize = lexer_token_finalize;
#line 1493 "equation-lexer.c"
}

static void
lexer_token_instance_init (LexerToken * self,
                           gpointer klass)
{
}

static void
lexer_token_finalize (GObject * obj)
{
	LexerToken * self;
#line 273 "../lib/equation-lexer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LEXER_TOKEN, LexerToken);
#line 275 "../lib/equation-lexer.vala"
	_g_free0 (self->text);
#line 273 "../lib/equation-lexer.vala"
	G_OBJECT_CLASS (lexer_token_parent_class)->finalize (obj);
#line 1512 "equation-lexer.c"
}

static GType
lexer_token_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LexerTokenClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lexer_token_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LexerToken), 0, (GInstanceInitFunc) lexer_token_instance_init, NULL };
	GType lexer_token_type_id;
	lexer_token_type_id = g_type_register_static (G_TYPE_OBJECT, "LexerToken", &g_define_type_info, 0);
	return lexer_token_type_id;
}

GType
lexer_token_get_type (void)
{
	static volatile gsize lexer_token_type_id__once = 0;
	if (g_once_init_enter (&lexer_token_type_id__once)) {
		GType lexer_token_type_id;
		lexer_token_type_id = lexer_token_get_type_once ();
		g_once_init_leave (&lexer_token_type_id__once, lexer_token_type_id);
	}
	return lexer_token_type_id__once;
}

static inline gpointer
lexer_get_instance_private (Lexer* self)
{
	return G_STRUCT_MEMBER_P (self, Lexer_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 286 "../lib/equation-lexer.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 1547 "equation-lexer.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 286 "../lib/equation-lexer.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 1555 "equation-lexer.c"
}

static gpointer
_parser_ref0 (gpointer self)
{
#line 295 "../lib/equation-lexer.vala"
	return self ? parser_ref (self) : NULL;
#line 1563 "equation-lexer.c"
}

Lexer*
lexer_construct (GType object_type,
                 const gchar* input,
                 Parser* parser,
                 gint number_base)
{
	Lexer * self = NULL;
	PreLexer* _tmp0_;
	Parser* _tmp1_;
#line 290 "../lib/equation-lexer.vala"
	g_return_val_if_fail (input != NULL, NULL);
#line 290 "../lib/equation-lexer.vala"
	g_return_val_if_fail (parser != NULL, NULL);
#line 290 "../lib/equation-lexer.vala"
	self = (Lexer*) g_object_new (object_type, NULL);
#line 292 "../lib/equation-lexer.vala"
	_tmp0_ = pre_lexer_new (input);
#line 292 "../lib/equation-lexer.vala"
	_g_object_unref0 (self->priv->prelexer);
#line 292 "../lib/equation-lexer.vala"
	self->priv->prelexer = _tmp0_;
#line 293 "../lib/equation-lexer.vala"
	(self->tokens == NULL) ? NULL : (self->tokens = (_g_list_free__g_object_unref0_ (self->tokens), NULL));
#line 293 "../lib/equation-lexer.vala"
	self->tokens = NULL;
#line 294 "../lib/equation-lexer.vala"
	self->priv->next_token = (guint) 0;
#line 295 "../lib/equation-lexer.vala"
	_tmp1_ = _parser_ref0 (parser);
#line 295 "../lib/equation-lexer.vala"
	_parser_unref0 (self->priv->parser);
#line 295 "../lib/equation-lexer.vala"
	self->priv->parser = _tmp1_;
#line 296 "../lib/equation-lexer.vala"
	self->priv->number_base = number_base;
#line 290 "../lib/equation-lexer.vala"
	return self;
#line 1603 "equation-lexer.c"
}

Lexer*
lexer_new (const gchar* input,
           Parser* parser,
           gint number_base)
{
#line 290 "../lib/equation-lexer.vala"
	return lexer_construct (TYPE_LEXER, input, parser, number_base);
#line 1613 "equation-lexer.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 304 "../lib/equation-lexer.vala"
	return self ? g_object_ref (self) : NULL;
#line 1621 "equation-lexer.c"
}

void
lexer_scan (Lexer* self)
{
#line 299 "../lib/equation-lexer.vala"
	g_return_if_fail (self != NULL);
#line 301 "../lib/equation-lexer.vala"
	while (TRUE) {
#line 1631 "equation-lexer.c"
		LexerToken* token = NULL;
		LexerToken* _tmp0_;
		LexerToken* _tmp1_;
		LexerToken* _tmp2_;
		LexerToken* _tmp3_;
#line 303 "../lib/equation-lexer.vala"
		_tmp0_ = lexer_insert_next_token (self);
#line 303 "../lib/equation-lexer.vala"
		token = _tmp0_;
#line 304 "../lib/equation-lexer.vala"
		_tmp1_ = token;
#line 304 "../lib/equation-lexer.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 304 "../lib/equation-lexer.vala"
		self->tokens = g_list_append (self->tokens, _tmp2_);
#line 305 "../lib/equation-lexer.vala"
		_tmp3_ = token;
#line 305 "../lib/equation-lexer.vala"
		if (_tmp3_->type == LEXER_TOKEN_TYPE_PL_EOS) {
#line 306 "../lib/equation-lexer.vala"
			_g_object_unref0 (token);
#line 306 "../lib/equation-lexer.vala"
			break;
#line 1655 "equation-lexer.c"
		}
#line 301 "../lib/equation-lexer.vala"
		_g_object_unref0 (token);
#line 1659 "equation-lexer.c"
	}
	{
		GList* element = NULL;
		GList* _tmp4_;
		GList* _tmp5_;
#line 309 "../lib/equation-lexer.vala"
		_tmp4_ = self->tokens;
#line 309 "../lib/equation-lexer.vala"
		_tmp5_ = g_list_first (_tmp4_);
#line 309 "../lib/equation-lexer.vala"
		element = _tmp5_;
#line 1671 "equation-lexer.c"
		{
			gboolean _tmp6_ = FALSE;
#line 309 "../lib/equation-lexer.vala"
			_tmp6_ = TRUE;
#line 309 "../lib/equation-lexer.vala"
			while (TRUE) {
#line 1678 "equation-lexer.c"
				GList* _tmp9_;
				gboolean _tmp10_ = FALSE;
				gboolean _tmp11_ = FALSE;
				gboolean _tmp12_ = FALSE;
				gboolean _tmp13_ = FALSE;
				gboolean _tmp14_ = FALSE;
				GList* _tmp15_;
				gconstpointer _tmp16_;
#line 309 "../lib/equation-lexer.vala"
				if (!_tmp6_) {
#line 1689 "equation-lexer.c"
					GList* _tmp7_;
					GList* _tmp8_;
#line 309 "../lib/equation-lexer.vala"
					_tmp7_ = element;
#line 309 "../lib/equation-lexer.vala"
					_tmp8_ = _tmp7_->next;
#line 309 "../lib/equation-lexer.vala"
					element = _tmp8_;
#line 1698 "equation-lexer.c"
				}
#line 309 "../lib/equation-lexer.vala"
				_tmp6_ = FALSE;
#line 309 "../lib/equation-lexer.vala"
				_tmp9_ = element;
#line 309 "../lib/equation-lexer.vala"
				if (!(_tmp9_ != NULL)) {
#line 309 "../lib/equation-lexer.vala"
					break;
#line 1708 "equation-lexer.c"
				}
#line 311 "../lib/equation-lexer.vala"
				_tmp15_ = element;
#line 311 "../lib/equation-lexer.vala"
				_tmp16_ = _tmp15_->data;
#line 311 "../lib/equation-lexer.vala"
				if (((LexerToken*) _tmp16_)->type == LEXER_TOKEN_TYPE_UNIT) {
#line 311 "../lib/equation-lexer.vala"
					_tmp14_ = TRUE;
#line 1718 "equation-lexer.c"
				} else {
					GList* _tmp17_;
					gconstpointer _tmp18_;
#line 311 "../lib/equation-lexer.vala"
					_tmp17_ = element;
#line 311 "../lib/equation-lexer.vala"
					_tmp18_ = _tmp17_->data;
#line 311 "../lib/equation-lexer.vala"
					_tmp14_ = ((LexerToken*) _tmp18_)->type == LEXER_TOKEN_TYPE_CURRENCY;
#line 1728 "equation-lexer.c"
				}
#line 311 "../lib/equation-lexer.vala"
				if (_tmp14_) {
#line 1732 "equation-lexer.c"
					gboolean _tmp19_ = FALSE;
					GList* _tmp20_;
					GList* _tmp21_;
#line 312 "../lib/equation-lexer.vala"
					_tmp20_ = element;
#line 312 "../lib/equation-lexer.vala"
					_tmp21_ = _tmp20_->prev;
#line 312 "../lib/equation-lexer.vala"
					if (_tmp21_ == NULL) {
#line 312 "../lib/equation-lexer.vala"
						_tmp19_ = TRUE;
#line 1744 "equation-lexer.c"
					} else {
						GList* _tmp22_;
						GList* _tmp23_;
						gconstpointer _tmp24_;
#line 312 "../lib/equation-lexer.vala"
						_tmp22_ = element;
#line 312 "../lib/equation-lexer.vala"
						_tmp23_ = _tmp22_->prev;
#line 312 "../lib/equation-lexer.vala"
						_tmp24_ = _tmp23_->data;
#line 312 "../lib/equation-lexer.vala"
						_tmp19_ = ((LexerToken*) _tmp24_)->type != LEXER_TOKEN_TYPE_IN;
#line 1757 "equation-lexer.c"
					}
#line 312 "../lib/equation-lexer.vala"
					_tmp13_ = _tmp19_;
#line 1761 "equation-lexer.c"
				} else {
#line 311 "../lib/equation-lexer.vala"
					_tmp13_ = FALSE;
#line 1765 "equation-lexer.c"
				}
#line 311 "../lib/equation-lexer.vala"
				if (_tmp13_) {
#line 1769 "equation-lexer.c"
					gboolean _tmp25_ = FALSE;
					GList* _tmp26_;
					GList* _tmp27_;
#line 313 "../lib/equation-lexer.vala"
					_tmp26_ = element;
#line 313 "../lib/equation-lexer.vala"
					_tmp27_ = _tmp26_->next;
#line 313 "../lib/equation-lexer.vala"
					if (_tmp27_ == NULL) {
#line 313 "../lib/equation-lexer.vala"
						_tmp25_ = TRUE;
#line 1781 "equation-lexer.c"
					} else {
						GList* _tmp28_;
						GList* _tmp29_;
						gconstpointer _tmp30_;
#line 313 "../lib/equation-lexer.vala"
						_tmp28_ = element;
#line 313 "../lib/equation-lexer.vala"
						_tmp29_ = _tmp28_->next;
#line 313 "../lib/equation-lexer.vala"
						_tmp30_ = _tmp29_->data;
#line 313 "../lib/equation-lexer.vala"
						_tmp25_ = ((LexerToken*) _tmp30_)->type != LEXER_TOKEN_TYPE_IN;
#line 1794 "equation-lexer.c"
					}
#line 313 "../lib/equation-lexer.vala"
					_tmp12_ = _tmp25_;
#line 1798 "equation-lexer.c"
				} else {
#line 311 "../lib/equation-lexer.vala"
					_tmp12_ = FALSE;
#line 1802 "equation-lexer.c"
				}
#line 311 "../lib/equation-lexer.vala"
				if (_tmp12_) {
#line 1806 "equation-lexer.c"
					GList* _tmp31_;
					gconstpointer _tmp32_;
					const gchar* _tmp33_;
#line 314 "../lib/equation-lexer.vala"
					_tmp31_ = element;
#line 314 "../lib/equation-lexer.vala"
					_tmp32_ = _tmp31_->data;
#line 314 "../lib/equation-lexer.vala"
					_tmp33_ = ((LexerToken*) _tmp32_)->text;
#line 314 "../lib/equation-lexer.vala"
					_tmp11_ = !g_str_has_prefix (_tmp33_, "°");
#line 1818 "equation-lexer.c"
				} else {
#line 311 "../lib/equation-lexer.vala"
					_tmp11_ = FALSE;
#line 1822 "equation-lexer.c"
				}
#line 311 "../lib/equation-lexer.vala"
				if (_tmp11_) {
#line 1826 "equation-lexer.c"
					GList* _tmp34_;
					gconstpointer _tmp35_;
					const gchar* _tmp36_;
#line 314 "../lib/equation-lexer.vala"
					_tmp34_ = element;
#line 314 "../lib/equation-lexer.vala"
					_tmp35_ = _tmp34_->data;
#line 314 "../lib/equation-lexer.vala"
					_tmp36_ = ((LexerToken*) _tmp35_)->text;
#line 314 "../lib/equation-lexer.vala"
					_tmp10_ = !g_str_has_prefix (_tmp36_, "˚");
#line 1838 "equation-lexer.c"
				} else {
#line 311 "../lib/equation-lexer.vala"
					_tmp10_ = FALSE;
#line 1842 "equation-lexer.c"
				}
#line 311 "../lib/equation-lexer.vala"
				if (_tmp10_) {
#line 1846 "equation-lexer.c"
					GList* _tmp37_;
					gconstpointer _tmp38_;
#line 316 "../lib/equation-lexer.vala"
					_tmp37_ = element;
#line 316 "../lib/equation-lexer.vala"
					_tmp38_ = _tmp37_->data;
#line 316 "../lib/equation-lexer.vala"
					((LexerToken*) _tmp38_)->type = LEXER_TOKEN_TYPE_VARIABLE;
#line 1855 "equation-lexer.c"
				}
			}
		}
	}
}

LexerToken*
lexer_get_next_token (Lexer* self)
{
	GList* _tmp0_;
	GList* _tmp5_;
	guint _tmp6_;
	gconstpointer _tmp7_;
	LexerToken* _tmp8_;
	LexerToken* result;
#line 322 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 324 "../lib/equation-lexer.vala"
	_tmp0_ = self->tokens;
#line 324 "../lib/equation-lexer.vala"
	if (self->priv->next_token >= g_list_length (_tmp0_)) {
#line 1877 "equation-lexer.c"
		GList* _tmp1_;
		GList* _tmp2_;
		gconstpointer _tmp3_;
		LexerToken* _tmp4_;
#line 325 "../lib/equation-lexer.vala"
		_tmp1_ = self->tokens;
#line 325 "../lib/equation-lexer.vala"
		_tmp2_ = self->tokens;
#line 325 "../lib/equation-lexer.vala"
		_tmp3_ = g_list_nth_data (_tmp1_, g_list_length (_tmp2_) - 1);
#line 325 "../lib/equation-lexer.vala"
		_tmp4_ = _g_object_ref0 ((LexerToken*) _tmp3_);
#line 325 "../lib/equation-lexer.vala"
		result = _tmp4_;
#line 325 "../lib/equation-lexer.vala"
		return result;
#line 1894 "equation-lexer.c"
	}
#line 326 "../lib/equation-lexer.vala"
	_tmp5_ = self->tokens;
#line 326 "../lib/equation-lexer.vala"
	_tmp6_ = self->priv->next_token;
#line 326 "../lib/equation-lexer.vala"
	self->priv->next_token = _tmp6_ + 1;
#line 326 "../lib/equation-lexer.vala"
	_tmp7_ = g_list_nth_data (_tmp5_, _tmp6_);
#line 326 "../lib/equation-lexer.vala"
	_tmp8_ = _g_object_ref0 ((LexerToken*) _tmp7_);
#line 326 "../lib/equation-lexer.vala"
	result = _tmp8_;
#line 326 "../lib/equation-lexer.vala"
	return result;
#line 1910 "equation-lexer.c"
}

void
lexer_roll_back (Lexer* self)
{
#line 330 "../lib/equation-lexer.vala"
	g_return_if_fail (self != NULL);
#line 332 "../lib/equation-lexer.vala"
	if (self->priv->next_token > ((guint) 0)) {
#line 1920 "equation-lexer.c"
		guint _tmp0_;
#line 333 "../lib/equation-lexer.vala"
		_tmp0_ = self->priv->next_token;
#line 333 "../lib/equation-lexer.vala"
		self->priv->next_token = _tmp0_ - 1;
#line 1926 "equation-lexer.c"
	}
}

static gboolean
lexer_check_if_function (Lexer* self)
{
	gchar* name = NULL;
	PreLexer* _tmp0_;
	gchar* _tmp1_;
	Parser* _tmp2_;
	gboolean result;
#line 336 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 338 "../lib/equation-lexer.vala"
	_tmp0_ = self->priv->prelexer;
#line 338 "../lib/equation-lexer.vala"
	_tmp1_ = pre_lexer_get_marked_substring (_tmp0_);
#line 338 "../lib/equation-lexer.vala"
	name = _tmp1_;
#line 339 "../lib/equation-lexer.vala"
	_tmp2_ = self->priv->parser;
#line 339 "../lib/equation-lexer.vala"
	result = parser_function_is_defined (_tmp2_, name);
#line 339 "../lib/equation-lexer.vala"
	_g_free0 (name);
#line 339 "../lib/equation-lexer.vala"
	return result;
#line 1954 "equation-lexer.c"
}

static gboolean
lexer_check_if_unit (Lexer* self)
{
	gint super_count = 0;
	PreLexer* _tmp2_;
	gchar* name = NULL;
	PreLexer* _tmp3_;
	gchar* _tmp4_;
	Parser* _tmp5_;
	const gchar* _tmp6_;
	PreLexer* _tmp9_;
	gchar* _tmp10_;
	Parser* _tmp11_;
	const gchar* _tmp12_;
	gboolean result;
#line 342 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 344 "../lib/equation-lexer.vala"
	super_count = 0;
#line 345 "../lib/equation-lexer.vala"
	while (TRUE) {
#line 1978 "equation-lexer.c"
		PreLexer* _tmp0_;
		gint _tmp1_;
#line 345 "../lib/equation-lexer.vala"
		_tmp0_ = self->priv->prelexer;
#line 345 "../lib/equation-lexer.vala"
		if (!(pre_lexer_get_next_token (_tmp0_) == LEXER_TOKEN_TYPE_PL_SUPER_DIGIT)) {
#line 345 "../lib/equation-lexer.vala"
			break;
#line 1987 "equation-lexer.c"
		}
#line 346 "../lib/equation-lexer.vala"
		_tmp1_ = super_count;
#line 346 "../lib/equation-lexer.vala"
		super_count = _tmp1_ + 1;
#line 1993 "equation-lexer.c"
	}
#line 348 "../lib/equation-lexer.vala"
	_tmp2_ = self->priv->prelexer;
#line 348 "../lib/equation-lexer.vala"
	pre_lexer_roll_back (_tmp2_);
#line 350 "../lib/equation-lexer.vala"
	_tmp3_ = self->priv->prelexer;
#line 350 "../lib/equation-lexer.vala"
	_tmp4_ = pre_lexer_get_marked_substring (_tmp3_);
#line 350 "../lib/equation-lexer.vala"
	name = _tmp4_;
#line 351 "../lib/equation-lexer.vala"
	_tmp5_ = self->priv->parser;
#line 351 "../lib/equation-lexer.vala"
	_tmp6_ = name;
#line 351 "../lib/equation-lexer.vala"
	if (parser_unit_is_defined (_tmp5_, _tmp6_)) {
#line 352 "../lib/equation-lexer.vala"
		result = TRUE;
#line 352 "../lib/equation-lexer.vala"
		_g_free0 (name);
#line 352 "../lib/equation-lexer.vala"
		return result;
#line 2017 "equation-lexer.c"
	}
#line 354 "../lib/equation-lexer.vala"
	while (TRUE) {
#line 2021 "equation-lexer.c"
		gint _tmp7_;
		PreLexer* _tmp8_;
#line 354 "../lib/equation-lexer.vala"
		_tmp7_ = super_count;
#line 354 "../lib/equation-lexer.vala"
		super_count = _tmp7_ - 1;
#line 354 "../lib/equation-lexer.vala"
		if (!(_tmp7_ > 0)) {
#line 354 "../lib/equation-lexer.vala"
			break;
#line 2032 "equation-lexer.c"
		}
#line 355 "../lib/equation-lexer.vala"
		_tmp8_ = self->priv->prelexer;
#line 355 "../lib/equation-lexer.vala"
		pre_lexer_roll_back (_tmp8_);
#line 2038 "equation-lexer.c"
	}
#line 357 "../lib/equation-lexer.vala"
	_tmp9_ = self->priv->prelexer;
#line 357 "../lib/equation-lexer.vala"
	_tmp10_ = pre_lexer_get_marked_substring (_tmp9_);
#line 357 "../lib/equation-lexer.vala"
	_g_free0 (name);
#line 357 "../lib/equation-lexer.vala"
	name = _tmp10_;
#line 358 "../lib/equation-lexer.vala"
	_tmp11_ = self->priv->parser;
#line 358 "../lib/equation-lexer.vala"
	_tmp12_ = name;
#line 358 "../lib/equation-lexer.vala"
	result = parser_unit_is_defined (_tmp11_, _tmp12_);
#line 358 "../lib/equation-lexer.vala"
	_g_free0 (name);
#line 358 "../lib/equation-lexer.vala"
	return result;
#line 2058 "equation-lexer.c"
}

static gboolean
lexer_check_if_currency (Lexer* self)
{
	gint super_count = 0;
	PreLexer* _tmp2_;
	gchar* name = NULL;
	PreLexer* _tmp3_;
	gchar* _tmp4_;
	Parser* _tmp5_;
	const gchar* _tmp6_;
	PreLexer* _tmp9_;
	gchar* _tmp10_;
	Parser* _tmp11_;
	const gchar* _tmp12_;
	gboolean result;
#line 361 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 363 "../lib/equation-lexer.vala"
	super_count = 0;
#line 364 "../lib/equation-lexer.vala"
	while (TRUE) {
#line 2082 "equation-lexer.c"
		PreLexer* _tmp0_;
		gint _tmp1_;
#line 364 "../lib/equation-lexer.vala"
		_tmp0_ = self->priv->prelexer;
#line 364 "../lib/equation-lexer.vala"
		if (!(pre_lexer_get_next_token (_tmp0_) == LEXER_TOKEN_TYPE_PL_SUPER_DIGIT)) {
#line 364 "../lib/equation-lexer.vala"
			break;
#line 2091 "equation-lexer.c"
		}
#line 365 "../lib/equation-lexer.vala"
		_tmp1_ = super_count;
#line 365 "../lib/equation-lexer.vala"
		super_count = _tmp1_ + 1;
#line 2097 "equation-lexer.c"
	}
#line 367 "../lib/equation-lexer.vala"
	_tmp2_ = self->priv->prelexer;
#line 367 "../lib/equation-lexer.vala"
	pre_lexer_roll_back (_tmp2_);
#line 369 "../lib/equation-lexer.vala"
	_tmp3_ = self->priv->prelexer;
#line 369 "../lib/equation-lexer.vala"
	_tmp4_ = pre_lexer_get_marked_substring (_tmp3_);
#line 369 "../lib/equation-lexer.vala"
	name = _tmp4_;
#line 371 "../lib/equation-lexer.vala"
	_tmp5_ = self->priv->parser;
#line 371 "../lib/equation-lexer.vala"
	_tmp6_ = name;
#line 371 "../lib/equation-lexer.vala"
	if (parser_currency_is_defined (_tmp5_, _tmp6_)) {
#line 372 "../lib/equation-lexer.vala"
		result = TRUE;
#line 372 "../lib/equation-lexer.vala"
		_g_free0 (name);
#line 372 "../lib/equation-lexer.vala"
		return result;
#line 2121 "equation-lexer.c"
	}
#line 374 "../lib/equation-lexer.vala"
	while (TRUE) {
#line 2125 "equation-lexer.c"
		gint _tmp7_;
		PreLexer* _tmp8_;
#line 374 "../lib/equation-lexer.vala"
		_tmp7_ = super_count;
#line 374 "../lib/equation-lexer.vala"
		super_count = _tmp7_ - 1;
#line 374 "../lib/equation-lexer.vala"
		if (!(_tmp7_ > 0)) {
#line 374 "../lib/equation-lexer.vala"
			break;
#line 2136 "equation-lexer.c"
		}
#line 375 "../lib/equation-lexer.vala"
		_tmp8_ = self->priv->prelexer;
#line 375 "../lib/equation-lexer.vala"
		pre_lexer_roll_back (_tmp8_);
#line 2142 "equation-lexer.c"
	}
#line 377 "../lib/equation-lexer.vala"
	_tmp9_ = self->priv->prelexer;
#line 377 "../lib/equation-lexer.vala"
	_tmp10_ = pre_lexer_get_marked_substring (_tmp9_);
#line 377 "../lib/equation-lexer.vala"
	_g_free0 (name);
#line 377 "../lib/equation-lexer.vala"
	name = _tmp10_;
#line 379 "../lib/equation-lexer.vala"
	_tmp11_ = self->priv->parser;
#line 379 "../lib/equation-lexer.vala"
	_tmp12_ = name;
#line 379 "../lib/equation-lexer.vala"
	result = parser_currency_is_defined (_tmp11_, _tmp12_);
#line 379 "../lib/equation-lexer.vala"
	_g_free0 (name);
#line 379 "../lib/equation-lexer.vala"
	return result;
#line 2162 "equation-lexer.c"
}

static gboolean
lexer_check_if_literal_base (Lexer* self)
{
	gchar* name = NULL;
	PreLexer* _tmp0_;
	gchar* _tmp1_;
	Parser* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_;
	gboolean result;
#line 383 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 385 "../lib/equation-lexer.vala"
	_tmp0_ = self->priv->prelexer;
#line 385 "../lib/equation-lexer.vala"
	_tmp1_ = pre_lexer_get_marked_substring (_tmp0_);
#line 385 "../lib/equation-lexer.vala"
	name = _tmp1_;
#line 386 "../lib/equation-lexer.vala"
	_tmp2_ = self->priv->parser;
#line 386 "../lib/equation-lexer.vala"
	_tmp3_ = g_utf8_strdown (name, (gssize) -1);
#line 386 "../lib/equation-lexer.vala"
	_tmp4_ = _tmp3_;
#line 386 "../lib/equation-lexer.vala"
	_tmp5_ = parser_literal_base_is_defined (_tmp2_, _tmp4_);
#line 386 "../lib/equation-lexer.vala"
	_g_free0 (_tmp4_);
#line 386 "../lib/equation-lexer.vala"
	result = _tmp5_;
#line 386 "../lib/equation-lexer.vala"
	_g_free0 (name);
#line 386 "../lib/equation-lexer.vala"
	return result;
#line 2200 "equation-lexer.c"
}

static gboolean
lexer_check_if_number (Lexer* self)
{
	gint count = 0;
	gchar* text = NULL;
	PreLexer* _tmp0_;
	gchar* _tmp1_;
	Number* tmp = NULL;
	const gchar* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	gboolean result;
#line 389 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 391 "../lib/equation-lexer.vala"
	count = 0;
#line 392 "../lib/equation-lexer.vala"
	_tmp0_ = self->priv->prelexer;
#line 392 "../lib/equation-lexer.vala"
	_tmp1_ = pre_lexer_get_marked_substring (_tmp0_);
#line 392 "../lib/equation-lexer.vala"
	text = _tmp1_;
#line 394 "../lib/equation-lexer.vala"
	_tmp2_ = text;
#line 394 "../lib/equation-lexer.vala"
	_tmp3_ = mp_set_from_string (_tmp2_, self->priv->number_base, TRUE);
#line 394 "../lib/equation-lexer.vala"
	tmp = _tmp3_;
#line 395 "../lib/equation-lexer.vala"
	_tmp4_ = tmp;
#line 395 "../lib/equation-lexer.vala"
	if (_tmp4_ != NULL) {
#line 396 "../lib/equation-lexer.vala"
		result = TRUE;
#line 396 "../lib/equation-lexer.vala"
		_g_object_unref0 (tmp);
#line 396 "../lib/equation-lexer.vala"
		_g_free0 (text);
#line 396 "../lib/equation-lexer.vala"
		return result;
#line 2243 "equation-lexer.c"
	} else {
#line 400 "../lib/equation-lexer.vala"
		while (TRUE) {
#line 2247 "equation-lexer.c"
			const gchar* _tmp5_;
			const gchar* _tmp6_;
			Number* _tmp7_;
			Number* _tmp8_;
			gint _tmp9_;
			PreLexer* _tmp10_;
			PreLexer* _tmp11_;
			gchar* _tmp12_;
#line 400 "../lib/equation-lexer.vala"
			_tmp5_ = text;
#line 400 "../lib/equation-lexer.vala"
			if (!(g_strcmp0 (_tmp5_, "") != 0)) {
#line 400 "../lib/equation-lexer.vala"
				break;
#line 2262 "equation-lexer.c"
			}
#line 402 "../lib/equation-lexer.vala"
			_tmp6_ = text;
#line 402 "../lib/equation-lexer.vala"
			_tmp7_ = mp_set_from_string (_tmp6_, self->priv->number_base, TRUE);
#line 402 "../lib/equation-lexer.vala"
			_g_object_unref0 (tmp);
#line 402 "../lib/equation-lexer.vala"
			tmp = _tmp7_;
#line 403 "../lib/equation-lexer.vala"
			_tmp8_ = tmp;
#line 403 "../lib/equation-lexer.vala"
			if (_tmp8_ != NULL) {
#line 404 "../lib/equation-lexer.vala"
				result = TRUE;
#line 404 "../lib/equation-lexer.vala"
				_g_object_unref0 (tmp);
#line 404 "../lib/equation-lexer.vala"
				_g_free0 (text);
#line 404 "../lib/equation-lexer.vala"
				return result;
#line 2284 "equation-lexer.c"
			}
#line 405 "../lib/equation-lexer.vala"
			_tmp9_ = count;
#line 405 "../lib/equation-lexer.vala"
			count = _tmp9_ + 1;
#line 406 "../lib/equation-lexer.vala"
			_tmp10_ = self->priv->prelexer;
#line 406 "../lib/equation-lexer.vala"
			pre_lexer_roll_back (_tmp10_);
#line 407 "../lib/equation-lexer.vala"
			_tmp11_ = self->priv->prelexer;
#line 407 "../lib/equation-lexer.vala"
			_tmp12_ = pre_lexer_get_marked_substring (_tmp11_);
#line 407 "../lib/equation-lexer.vala"
			_g_free0 (text);
#line 407 "../lib/equation-lexer.vala"
			text = _tmp12_;
#line 2302 "equation-lexer.c"
		}
#line 411 "../lib/equation-lexer.vala"
		while (TRUE) {
#line 2306 "equation-lexer.c"
			gint _tmp13_;
			PreLexer* _tmp14_;
#line 411 "../lib/equation-lexer.vala"
			_tmp13_ = count;
#line 411 "../lib/equation-lexer.vala"
			count = _tmp13_ - 1;
#line 411 "../lib/equation-lexer.vala"
			if (!(_tmp13_ > 0)) {
#line 411 "../lib/equation-lexer.vala"
				break;
#line 2317 "equation-lexer.c"
			}
#line 412 "../lib/equation-lexer.vala"
			_tmp14_ = self->priv->prelexer;
#line 412 "../lib/equation-lexer.vala"
			pre_lexer_get_next_token (_tmp14_);
#line 2323 "equation-lexer.c"
		}
#line 414 "../lib/equation-lexer.vala"
		result = FALSE;
#line 414 "../lib/equation-lexer.vala"
		_g_object_unref0 (tmp);
#line 414 "../lib/equation-lexer.vala"
		_g_free0 (text);
#line 414 "../lib/equation-lexer.vala"
		return result;
#line 2333 "equation-lexer.c"
	}
}

static LexerToken*
lexer_insert_token (Lexer* self,
                    LexerTokenType type)
{
	LexerToken* token = NULL;
	LexerToken* _tmp0_;
	PreLexer* _tmp1_;
	gchar* _tmp2_;
	PreLexer* _tmp3_;
	PreLexer* _tmp4_;
	LexerToken* result;
#line 419 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 421 "../lib/equation-lexer.vala"
	_tmp0_ = lexer_token_new ();
#line 421 "../lib/equation-lexer.vala"
	token = _tmp0_;
#line 422 "../lib/equation-lexer.vala"
	_tmp1_ = self->priv->prelexer;
#line 422 "../lib/equation-lexer.vala"
	_tmp2_ = pre_lexer_get_marked_substring (_tmp1_);
#line 422 "../lib/equation-lexer.vala"
	_g_free0 (token->text);
#line 422 "../lib/equation-lexer.vala"
	token->text = _tmp2_;
#line 423 "../lib/equation-lexer.vala"
	_tmp3_ = self->priv->prelexer;
#line 423 "../lib/equation-lexer.vala"
	token->start_index = (guint) _tmp3_->mark_index;
#line 424 "../lib/equation-lexer.vala"
	_tmp4_ = self->priv->prelexer;
#line 424 "../lib/equation-lexer.vala"
	token->end_index = (guint) _tmp4_->index;
#line 425 "../lib/equation-lexer.vala"
	token->type = type;
#line 427 "../lib/equation-lexer.vala"
	result = token;
#line 427 "../lib/equation-lexer.vala"
	return result;
#line 2376 "equation-lexer.c"
}

static LexerToken*
lexer_insert_next_token (Lexer* self)
{
	PreLexer* _tmp0_;
	LexerTokenType type = 0;
	PreLexer* _tmp1_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_ = FALSE;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	gboolean _tmp19_ = FALSE;
	gboolean _tmp20_ = FALSE;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_ = FALSE;
	gboolean _tmp23_ = FALSE;
	gboolean _tmp24_ = FALSE;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp27_ = FALSE;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp29_ = FALSE;
	gboolean _tmp30_ = FALSE;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_ = FALSE;
	gboolean _tmp33_ = FALSE;
	gboolean _tmp34_ = FALSE;
	gboolean _tmp35_ = FALSE;
	gboolean _tmp36_ = FALSE;
	Parser* _tmp63_;
	PreLexer* _tmp64_;
	gchar* _tmp65_;
	gchar* _tmp66_;
	PreLexer* _tmp67_;
	PreLexer* _tmp68_;
	LexerToken* _tmp69_;
	LexerToken* result;
#line 431 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 434 "../lib/equation-lexer.vala"
	_tmp0_ = self->priv->prelexer;
#line 434 "../lib/equation-lexer.vala"
	pre_lexer_set_marker (_tmp0_);
#line 437 "../lib/equation-lexer.vala"
	_tmp1_ = self->priv->prelexer;
#line 437 "../lib/equation-lexer.vala"
	type = pre_lexer_get_next_token (_tmp1_);
#line 439 "../lib/equation-lexer.vala"
	while (TRUE) {
#line 2438 "equation-lexer.c"
		PreLexer* _tmp2_;
		PreLexer* _tmp3_;
#line 439 "../lib/equation-lexer.vala"
		if (!(type == LEXER_TOKEN_TYPE_PL_SKIP)) {
#line 439 "../lib/equation-lexer.vala"
			break;
#line 2445 "equation-lexer.c"
		}
#line 441 "../lib/equation-lexer.vala"
		_tmp2_ = self->priv->prelexer;
#line 441 "../lib/equation-lexer.vala"
		pre_lexer_set_marker (_tmp2_);
#line 442 "../lib/equation-lexer.vala"
		_tmp3_ = self->priv->prelexer;
#line 442 "../lib/equation-lexer.vala"
		type = pre_lexer_get_next_token (_tmp3_);
#line 2455 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_AND) {
#line 445 "../lib/equation-lexer.vala"
		_tmp36_ = TRUE;
#line 2461 "equation-lexer.c"
	} else {
#line 445 "../lib/equation-lexer.vala"
		_tmp36_ = type == LEXER_TOKEN_TYPE_OR;
#line 2465 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp36_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp35_ = TRUE;
#line 2471 "equation-lexer.c"
	} else {
#line 445 "../lib/equation-lexer.vala"
		_tmp35_ = type == LEXER_TOKEN_TYPE_XOR;
#line 2475 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp35_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp34_ = TRUE;
#line 2481 "equation-lexer.c"
	} else {
#line 445 "../lib/equation-lexer.vala"
		_tmp34_ = type == LEXER_TOKEN_TYPE_NOT;
#line 2485 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp34_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp33_ = TRUE;
#line 2491 "equation-lexer.c"
	} else {
#line 446 "../lib/equation-lexer.vala"
		_tmp33_ = type == LEXER_TOKEN_TYPE_NAND;
#line 2495 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp33_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp32_ = TRUE;
#line 2501 "equation-lexer.c"
	} else {
#line 446 "../lib/equation-lexer.vala"
		_tmp32_ = type == LEXER_TOKEN_TYPE_NOR;
#line 2505 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp32_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp31_ = TRUE;
#line 2511 "equation-lexer.c"
	} else {
#line 446 "../lib/equation-lexer.vala"
		_tmp31_ = type == LEXER_TOKEN_TYPE_XNOR;
#line 2515 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp31_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp30_ = TRUE;
#line 2521 "equation-lexer.c"
	} else {
#line 447 "../lib/equation-lexer.vala"
		_tmp30_ = type == LEXER_TOKEN_TYPE_ADD;
#line 2525 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp30_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp29_ = TRUE;
#line 2531 "equation-lexer.c"
	} else {
#line 447 "../lib/equation-lexer.vala"
		_tmp29_ = type == LEXER_TOKEN_TYPE_SUBTRACT;
#line 2535 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp29_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp28_ = TRUE;
#line 2541 "equation-lexer.c"
	} else {
#line 447 "../lib/equation-lexer.vala"
		_tmp28_ = type == LEXER_TOKEN_TYPE_MULTIPLY;
#line 2545 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp28_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp27_ = TRUE;
#line 2551 "equation-lexer.c"
	} else {
#line 447 "../lib/equation-lexer.vala"
		_tmp27_ = type == LEXER_TOKEN_TYPE_DIVIDE;
#line 2555 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp27_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp26_ = TRUE;
#line 2561 "equation-lexer.c"
	} else {
#line 448 "../lib/equation-lexer.vala"
		_tmp26_ = type == LEXER_TOKEN_TYPE_L_FLOOR;
#line 2565 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp26_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp25_ = TRUE;
#line 2571 "equation-lexer.c"
	} else {
#line 448 "../lib/equation-lexer.vala"
		_tmp25_ = type == LEXER_TOKEN_TYPE_R_FLOOR;
#line 2575 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp25_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp24_ = TRUE;
#line 2581 "equation-lexer.c"
	} else {
#line 448 "../lib/equation-lexer.vala"
		_tmp24_ = type == LEXER_TOKEN_TYPE_L_CEILING;
#line 2585 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp24_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp23_ = TRUE;
#line 2591 "equation-lexer.c"
	} else {
#line 448 "../lib/equation-lexer.vala"
		_tmp23_ = type == LEXER_TOKEN_TYPE_R_CEILING;
#line 2595 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp23_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp22_ = TRUE;
#line 2601 "equation-lexer.c"
	} else {
#line 449 "../lib/equation-lexer.vala"
		_tmp22_ = type == LEXER_TOKEN_TYPE_ROOT;
#line 2605 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp22_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp21_ = TRUE;
#line 2611 "equation-lexer.c"
	} else {
#line 449 "../lib/equation-lexer.vala"
		_tmp21_ = type == LEXER_TOKEN_TYPE_ROOT_3;
#line 2615 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp21_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp20_ = TRUE;
#line 2621 "equation-lexer.c"
	} else {
#line 449 "../lib/equation-lexer.vala"
		_tmp20_ = type == LEXER_TOKEN_TYPE_ROOT_4;
#line 2625 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp20_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp19_ = TRUE;
#line 2631 "equation-lexer.c"
	} else {
#line 449 "../lib/equation-lexer.vala"
		_tmp19_ = type == LEXER_TOKEN_TYPE_ASSIGN;
#line 2635 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp19_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp18_ = TRUE;
#line 2641 "equation-lexer.c"
	} else {
#line 450 "../lib/equation-lexer.vala"
		_tmp18_ = type == LEXER_TOKEN_TYPE_L_R_BRACKET;
#line 2645 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp18_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp17_ = TRUE;
#line 2651 "equation-lexer.c"
	} else {
#line 450 "../lib/equation-lexer.vala"
		_tmp17_ = type == LEXER_TOKEN_TYPE_R_R_BRACKET;
#line 2655 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp17_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp16_ = TRUE;
#line 2661 "equation-lexer.c"
	} else {
#line 450 "../lib/equation-lexer.vala"
		_tmp16_ = type == LEXER_TOKEN_TYPE_L_S_BRACKET;
#line 2665 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp16_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp15_ = TRUE;
#line 2671 "equation-lexer.c"
	} else {
#line 451 "../lib/equation-lexer.vala"
		_tmp15_ = type == LEXER_TOKEN_TYPE_R_S_BRACKET;
#line 2675 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp15_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp14_ = TRUE;
#line 2681 "equation-lexer.c"
	} else {
#line 451 "../lib/equation-lexer.vala"
		_tmp14_ = type == LEXER_TOKEN_TYPE_L_C_BRACKET;
#line 2685 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp14_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp13_ = TRUE;
#line 2691 "equation-lexer.c"
	} else {
#line 451 "../lib/equation-lexer.vala"
		_tmp13_ = type == LEXER_TOKEN_TYPE_R_C_BRACKET;
#line 2695 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp13_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp12_ = TRUE;
#line 2701 "equation-lexer.c"
	} else {
#line 452 "../lib/equation-lexer.vala"
		_tmp12_ = type == LEXER_TOKEN_TYPE_ABS;
#line 2705 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp12_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp11_ = TRUE;
#line 2711 "equation-lexer.c"
	} else {
#line 452 "../lib/equation-lexer.vala"
		_tmp11_ = type == LEXER_TOKEN_TYPE_POWER;
#line 2715 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp11_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp10_ = TRUE;
#line 2721 "equation-lexer.c"
	} else {
#line 452 "../lib/equation-lexer.vala"
		_tmp10_ = type == LEXER_TOKEN_TYPE_FACTORIAL;
#line 2725 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp10_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp9_ = TRUE;
#line 2731 "equation-lexer.c"
	} else {
#line 452 "../lib/equation-lexer.vala"
		_tmp9_ = type == LEXER_TOKEN_TYPE_PERCENTAGE;
#line 2735 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp9_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp8_ = TRUE;
#line 2741 "equation-lexer.c"
	} else {
#line 453 "../lib/equation-lexer.vala"
		_tmp8_ = type == LEXER_TOKEN_TYPE_ARGUMENT_SEPARATOR;
#line 2745 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp8_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp7_ = TRUE;
#line 2751 "equation-lexer.c"
	} else {
#line 453 "../lib/equation-lexer.vala"
		_tmp7_ = type == LEXER_TOKEN_TYPE_SHIFT_LEFT;
#line 2755 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp7_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp6_ = TRUE;
#line 2761 "equation-lexer.c"
	} else {
#line 453 "../lib/equation-lexer.vala"
		_tmp6_ = type == LEXER_TOKEN_TYPE_SHIFT_RIGHT;
#line 2765 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp6_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp5_ = TRUE;
#line 2771 "equation-lexer.c"
	} else {
#line 454 "../lib/equation-lexer.vala"
		_tmp5_ = type == LEXER_TOKEN_TYPE_SHIFT_URIGHT;
#line 2775 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp5_) {
#line 445 "../lib/equation-lexer.vala"
		_tmp4_ = TRUE;
#line 2781 "equation-lexer.c"
	} else {
#line 454 "../lib/equation-lexer.vala"
		_tmp4_ = type == LEXER_TOKEN_TYPE_FUNC_DESC_SEPARATOR;
#line 2785 "equation-lexer.c"
	}
#line 445 "../lib/equation-lexer.vala"
	if (_tmp4_) {
#line 2789 "equation-lexer.c"
		LexerToken* _tmp37_;
#line 455 "../lib/equation-lexer.vala"
		_tmp37_ = lexer_insert_token (self, type);
#line 455 "../lib/equation-lexer.vala"
		result = _tmp37_;
#line 455 "../lib/equation-lexer.vala"
		return result;
#line 2797 "equation-lexer.c"
	}
#line 458 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_SUPER_MINUS) {
#line 2801 "equation-lexer.c"
		PreLexer* _tmp38_;
		PreLexer* _tmp45_;
		LexerToken* _tmp46_;
#line 460 "../lib/equation-lexer.vala"
		_tmp38_ = self->priv->prelexer;
#line 460 "../lib/equation-lexer.vala"
		type = pre_lexer_get_next_token (_tmp38_);
#line 460 "../lib/equation-lexer.vala"
		if (type != LEXER_TOKEN_TYPE_PL_SUPER_DIGIT) {
#line 2811 "equation-lexer.c"
			PreLexer* _tmp39_;
			Parser* _tmp40_;
			PreLexer* _tmp41_;
			PreLexer* _tmp42_;
			LexerToken* _tmp43_;
#line 463 "../lib/equation-lexer.vala"
			_tmp39_ = self->priv->prelexer;
#line 463 "../lib/equation-lexer.vala"
			pre_lexer_roll_back (_tmp39_);
#line 464 "../lib/equation-lexer.vala"
			_tmp40_ = self->priv->parser;
#line 464 "../lib/equation-lexer.vala"
			_tmp41_ = self->priv->prelexer;
#line 464 "../lib/equation-lexer.vala"
			_tmp42_ = self->priv->prelexer;
#line 464 "../lib/equation-lexer.vala"
			parser_set_error (_tmp40_, ERROR_CODE_MP, _ ("Missing digits after negative sign"), (guint) _tmp41_->mark_index, (guint) _tmp42_->index);
#line 465 "../lib/equation-lexer.vala"
			_tmp43_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_UNKNOWN);
#line 465 "../lib/equation-lexer.vala"
			result = _tmp43_;
#line 465 "../lib/equation-lexer.vala"
			return result;
#line 2835 "equation-lexer.c"
		}
#line 469 "../lib/equation-lexer.vala"
		while (TRUE) {
#line 2839 "equation-lexer.c"
			PreLexer* _tmp44_;
#line 469 "../lib/equation-lexer.vala"
			_tmp44_ = self->priv->prelexer;
#line 469 "../lib/equation-lexer.vala"
			if (!(pre_lexer_get_next_token (_tmp44_) == LEXER_TOKEN_TYPE_PL_SUPER_DIGIT)) {
#line 469 "../lib/equation-lexer.vala"
				break;
#line 2847 "equation-lexer.c"
			}
		}
#line 470 "../lib/equation-lexer.vala"
		_tmp45_ = self->priv->prelexer;
#line 470 "../lib/equation-lexer.vala"
		pre_lexer_roll_back (_tmp45_);
#line 472 "../lib/equation-lexer.vala"
		_tmp46_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NSUP_NUMBER);
#line 472 "../lib/equation-lexer.vala"
		result = _tmp46_;
#line 472 "../lib/equation-lexer.vala"
		return result;
#line 2860 "equation-lexer.c"
	}
#line 476 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_SUPER_DIGIT) {
#line 2864 "equation-lexer.c"
		PreLexer* _tmp48_;
		LexerToken* _tmp49_;
#line 478 "../lib/equation-lexer.vala"
		while (TRUE) {
#line 2869 "equation-lexer.c"
			PreLexer* _tmp47_;
#line 478 "../lib/equation-lexer.vala"
			_tmp47_ = self->priv->prelexer;
#line 478 "../lib/equation-lexer.vala"
			if (!(pre_lexer_get_next_token (_tmp47_) == LEXER_TOKEN_TYPE_PL_SUPER_DIGIT)) {
#line 478 "../lib/equation-lexer.vala"
				break;
#line 2877 "equation-lexer.c"
			}
		}
#line 479 "../lib/equation-lexer.vala"
		_tmp48_ = self->priv->prelexer;
#line 479 "../lib/equation-lexer.vala"
		pre_lexer_roll_back (_tmp48_);
#line 481 "../lib/equation-lexer.vala"
		_tmp49_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_SUP_NUMBER);
#line 481 "../lib/equation-lexer.vala"
		result = _tmp49_;
#line 481 "../lib/equation-lexer.vala"
		return result;
#line 2890 "equation-lexer.c"
	}
#line 485 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_SUB_DIGIT) {
#line 2894 "equation-lexer.c"
		PreLexer* _tmp51_;
		LexerToken* _tmp52_;
#line 487 "../lib/equation-lexer.vala"
		while (TRUE) {
#line 2899 "equation-lexer.c"
			PreLexer* _tmp50_;
#line 487 "../lib/equation-lexer.vala"
			_tmp50_ = self->priv->prelexer;
#line 487 "../lib/equation-lexer.vala"
			if (!(pre_lexer_get_next_token (_tmp50_) == LEXER_TOKEN_TYPE_PL_SUB_DIGIT)) {
#line 487 "../lib/equation-lexer.vala"
				break;
#line 2907 "equation-lexer.c"
			}
		}
#line 488 "../lib/equation-lexer.vala"
		_tmp51_ = self->priv->prelexer;
#line 488 "../lib/equation-lexer.vala"
		pre_lexer_roll_back (_tmp51_);
#line 490 "../lib/equation-lexer.vala"
		_tmp52_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_SUB_NUMBER);
#line 490 "../lib/equation-lexer.vala"
		result = _tmp52_;
#line 490 "../lib/equation-lexer.vala"
		return result;
#line 2920 "equation-lexer.c"
	}
#line 494 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_FRACTION) {
#line 2924 "equation-lexer.c"
		LexerToken* _tmp53_;
#line 495 "../lib/equation-lexer.vala"
		_tmp53_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 495 "../lib/equation-lexer.vala"
		result = _tmp53_;
#line 495 "../lib/equation-lexer.vala"
		return result;
#line 2932 "equation-lexer.c"
	}
#line 497 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_DIGIT) {
#line 2936 "equation-lexer.c"
		LexerToken* _tmp54_;
#line 498 "../lib/equation-lexer.vala"
		_tmp54_ = lexer_insert_digit (self);
#line 498 "../lib/equation-lexer.vala"
		result = _tmp54_;
#line 498 "../lib/equation-lexer.vala"
		return result;
#line 2944 "equation-lexer.c"
	}
#line 500 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_DECIMAL) {
#line 2948 "equation-lexer.c"
		LexerToken* _tmp55_;
#line 501 "../lib/equation-lexer.vala"
		_tmp55_ = lexer_insert_decimal (self);
#line 501 "../lib/equation-lexer.vala"
		result = _tmp55_;
#line 501 "../lib/equation-lexer.vala"
		return result;
#line 2956 "equation-lexer.c"
	}
#line 503 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_HEX) {
#line 2960 "equation-lexer.c"
		LexerToken* _tmp56_;
#line 504 "../lib/equation-lexer.vala"
		_tmp56_ = lexer_insert_hex (self);
#line 504 "../lib/equation-lexer.vala"
		result = _tmp56_;
#line 504 "../lib/equation-lexer.vala"
		return result;
#line 2968 "equation-lexer.c"
	}
#line 506 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_LETTER) {
#line 2972 "equation-lexer.c"
		LexerToken* _tmp57_;
#line 507 "../lib/equation-lexer.vala"
		_tmp57_ = lexer_insert_letter (self);
#line 507 "../lib/equation-lexer.vala"
		result = _tmp57_;
#line 507 "../lib/equation-lexer.vala"
		return result;
#line 2980 "equation-lexer.c"
	}
#line 509 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_DEGREE) {
#line 2984 "equation-lexer.c"
		PreLexer* _tmp58_;
		gboolean _tmp59_ = FALSE;
		gboolean _tmp60_ = FALSE;
#line 511 "../lib/equation-lexer.vala"
		_tmp58_ = self->priv->prelexer;
#line 511 "../lib/equation-lexer.vala"
		type = pre_lexer_get_next_token (_tmp58_);
#line 512 "../lib/equation-lexer.vala"
		if (type == LEXER_TOKEN_TYPE_PL_HEX) {
#line 512 "../lib/equation-lexer.vala"
			_tmp60_ = TRUE;
#line 2996 "equation-lexer.c"
		} else {
#line 512 "../lib/equation-lexer.vala"
			_tmp60_ = type == LEXER_TOKEN_TYPE_PL_LETTER;
#line 3000 "equation-lexer.c"
		}
#line 512 "../lib/equation-lexer.vala"
		if (_tmp60_) {
#line 512 "../lib/equation-lexer.vala"
			_tmp59_ = lexer_check_if_unit (self);
#line 3006 "equation-lexer.c"
		} else {
#line 512 "../lib/equation-lexer.vala"
			_tmp59_ = FALSE;
#line 3010 "equation-lexer.c"
		}
#line 512 "../lib/equation-lexer.vala"
		if (_tmp59_) {
#line 3014 "equation-lexer.c"
			LexerToken* _tmp61_;
#line 513 "../lib/equation-lexer.vala"
			_tmp61_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_UNIT);
#line 513 "../lib/equation-lexer.vala"
			result = _tmp61_;
#line 513 "../lib/equation-lexer.vala"
			return result;
#line 3022 "equation-lexer.c"
		}
	}
#line 516 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_EOS) {
#line 3027 "equation-lexer.c"
		LexerToken* _tmp62_;
#line 517 "../lib/equation-lexer.vala"
		_tmp62_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_PL_EOS);
#line 517 "../lib/equation-lexer.vala"
		result = _tmp62_;
#line 517 "../lib/equation-lexer.vala"
		return result;
#line 3035 "equation-lexer.c"
	}
#line 520 "../lib/equation-lexer.vala"
	_tmp63_ = self->priv->parser;
#line 520 "../lib/equation-lexer.vala"
	_tmp64_ = self->priv->prelexer;
#line 520 "../lib/equation-lexer.vala"
	_tmp65_ = pre_lexer_get_marked_substring (_tmp64_);
#line 520 "../lib/equation-lexer.vala"
	_tmp66_ = _tmp65_;
#line 520 "../lib/equation-lexer.vala"
	_tmp67_ = self->priv->prelexer;
#line 520 "../lib/equation-lexer.vala"
	_tmp68_ = self->priv->prelexer;
#line 520 "../lib/equation-lexer.vala"
	parser_set_error (_tmp63_, ERROR_CODE_INVALID, _tmp66_, (guint) _tmp67_->mark_index, (guint) _tmp68_->index);
#line 520 "../lib/equation-lexer.vala"
	_g_free0 (_tmp66_);
#line 522 "../lib/equation-lexer.vala"
	_tmp69_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_UNKNOWN);
#line 522 "../lib/equation-lexer.vala"
	result = _tmp69_;
#line 522 "../lib/equation-lexer.vala"
	return result;
#line 3059 "equation-lexer.c"
}

static LexerToken*
lexer_insert_digit (Lexer* self)
{
	LexerTokenType type = 0;
	PreLexer* _tmp0_;
	LexerToken* result;
#line 525 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 527 "../lib/equation-lexer.vala"
	_tmp0_ = self->priv->prelexer;
#line 527 "../lib/equation-lexer.vala"
	type = pre_lexer_get_next_token (_tmp0_);
#line 528 "../lib/equation-lexer.vala"
	while (TRUE) {
#line 3076 "equation-lexer.c"
		PreLexer* _tmp1_;
#line 528 "../lib/equation-lexer.vala"
		if (!(type == LEXER_TOKEN_TYPE_PL_DIGIT)) {
#line 528 "../lib/equation-lexer.vala"
			break;
#line 3082 "equation-lexer.c"
		}
#line 529 "../lib/equation-lexer.vala"
		_tmp1_ = self->priv->prelexer;
#line 529 "../lib/equation-lexer.vala"
		type = pre_lexer_get_next_token (_tmp1_);
#line 3088 "equation-lexer.c"
	}
#line 531 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_FRACTION) {
#line 3092 "equation-lexer.c"
		LexerToken* _tmp2_;
#line 532 "../lib/equation-lexer.vala"
		_tmp2_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 532 "../lib/equation-lexer.vala"
		result = _tmp2_;
#line 532 "../lib/equation-lexer.vala"
		return result;
#line 3100 "equation-lexer.c"
	} else {
#line 533 "../lib/equation-lexer.vala"
		if (type == LEXER_TOKEN_TYPE_PL_SUB_DIGIT) {
#line 3104 "equation-lexer.c"
			PreLexer* _tmp4_;
			LexerToken* _tmp5_;
#line 535 "../lib/equation-lexer.vala"
			while (TRUE) {
#line 3109 "equation-lexer.c"
				PreLexer* _tmp3_;
#line 535 "../lib/equation-lexer.vala"
				_tmp3_ = self->priv->prelexer;
#line 535 "../lib/equation-lexer.vala"
				if (!(pre_lexer_get_next_token (_tmp3_) == LEXER_TOKEN_TYPE_PL_SUB_DIGIT)) {
#line 535 "../lib/equation-lexer.vala"
					break;
#line 3117 "equation-lexer.c"
				}
			}
#line 536 "../lib/equation-lexer.vala"
			_tmp4_ = self->priv->prelexer;
#line 536 "../lib/equation-lexer.vala"
			pre_lexer_roll_back (_tmp4_);
#line 537 "../lib/equation-lexer.vala"
			_tmp5_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 537 "../lib/equation-lexer.vala"
			result = _tmp5_;
#line 537 "../lib/equation-lexer.vala"
			return result;
#line 3130 "equation-lexer.c"
		} else {
#line 539 "../lib/equation-lexer.vala"
			if (type == LEXER_TOKEN_TYPE_PL_DEGREE) {
#line 3134 "equation-lexer.c"
				PreLexer* _tmp6_;
#line 541 "../lib/equation-lexer.vala"
				_tmp6_ = self->priv->prelexer;
#line 541 "../lib/equation-lexer.vala"
				type = pre_lexer_get_next_token (_tmp6_);
#line 542 "../lib/equation-lexer.vala"
				if (type == LEXER_TOKEN_TYPE_PL_DIGIT) {
#line 544 "../lib/equation-lexer.vala"
					while (TRUE) {
#line 3144 "equation-lexer.c"
						PreLexer* _tmp7_;
#line 544 "../lib/equation-lexer.vala"
						_tmp7_ = self->priv->prelexer;
#line 544 "../lib/equation-lexer.vala"
						type = pre_lexer_get_next_token (_tmp7_);
#line 544 "../lib/equation-lexer.vala"
						if (!(type == LEXER_TOKEN_TYPE_PL_DIGIT)) {
#line 544 "../lib/equation-lexer.vala"
							break;
#line 3154 "equation-lexer.c"
						}
					}
#line 545 "../lib/equation-lexer.vala"
					if (type == LEXER_TOKEN_TYPE_PL_DECIMAL) {
#line 3159 "equation-lexer.c"
						LexerToken* _tmp8_;
#line 546 "../lib/equation-lexer.vala"
						_tmp8_ = lexer_insert_angle_num_dm (self);
#line 546 "../lib/equation-lexer.vala"
						result = _tmp8_;
#line 546 "../lib/equation-lexer.vala"
						return result;
#line 3167 "equation-lexer.c"
					} else {
#line 548 "../lib/equation-lexer.vala"
						if (type == LEXER_TOKEN_TYPE_PL_MINUTE) {
#line 3171 "equation-lexer.c"
							PreLexer* _tmp9_;
#line 550 "../lib/equation-lexer.vala"
							_tmp9_ = self->priv->prelexer;
#line 550 "../lib/equation-lexer.vala"
							type = pre_lexer_get_next_token (_tmp9_);
#line 551 "../lib/equation-lexer.vala"
							if (type == LEXER_TOKEN_TYPE_PL_DIGIT) {
#line 553 "../lib/equation-lexer.vala"
								while (TRUE) {
#line 3181 "equation-lexer.c"
									PreLexer* _tmp10_;
#line 553 "../lib/equation-lexer.vala"
									_tmp10_ = self->priv->prelexer;
#line 553 "../lib/equation-lexer.vala"
									type = pre_lexer_get_next_token (_tmp10_);
#line 553 "../lib/equation-lexer.vala"
									if (!(type == LEXER_TOKEN_TYPE_PL_DIGIT)) {
#line 553 "../lib/equation-lexer.vala"
										break;
#line 3191 "equation-lexer.c"
									}
								}
#line 554 "../lib/equation-lexer.vala"
								if (type == LEXER_TOKEN_TYPE_PL_DECIMAL) {
#line 3196 "equation-lexer.c"
									LexerToken* _tmp11_;
#line 555 "../lib/equation-lexer.vala"
									_tmp11_ = lexer_insert_angle_num_dms (self);
#line 555 "../lib/equation-lexer.vala"
									result = _tmp11_;
#line 555 "../lib/equation-lexer.vala"
									return result;
#line 3204 "equation-lexer.c"
								} else {
#line 556 "../lib/equation-lexer.vala"
									if (type == LEXER_TOKEN_TYPE_PL_SECOND) {
#line 3208 "equation-lexer.c"
										LexerToken* _tmp12_;
#line 557 "../lib/equation-lexer.vala"
										_tmp12_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 557 "../lib/equation-lexer.vala"
										result = _tmp12_;
#line 557 "../lib/equation-lexer.vala"
										return result;
#line 3216 "equation-lexer.c"
									} else {
										PreLexer* _tmp13_;
										Parser* _tmp14_;
										PreLexer* _tmp15_;
										PreLexer* _tmp16_;
										LexerToken* _tmp17_;
#line 561 "../lib/equation-lexer.vala"
										_tmp13_ = self->priv->prelexer;
#line 561 "../lib/equation-lexer.vala"
										pre_lexer_roll_back (_tmp13_);
#line 562 "../lib/equation-lexer.vala"
										_tmp14_ = self->priv->parser;
#line 562 "../lib/equation-lexer.vala"
										_tmp15_ = self->priv->prelexer;
#line 562 "../lib/equation-lexer.vala"
										_tmp16_ = self->priv->prelexer;
#line 562 "../lib/equation-lexer.vala"
										parser_set_error (_tmp14_, ERROR_CODE_MP, _ ("Missing second symbol (″)"), (guint) _tmp15_->mark_index, (guint) _tmp16_->index);
#line 563 "../lib/equation-lexer.vala"
										_tmp17_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_UNKNOWN);
#line 563 "../lib/equation-lexer.vala"
										result = _tmp17_;
#line 563 "../lib/equation-lexer.vala"
										return result;
#line 3241 "equation-lexer.c"
									}
								}
							} else {
#line 566 "../lib/equation-lexer.vala"
								if (type == LEXER_TOKEN_TYPE_PL_DECIMAL) {
#line 3247 "equation-lexer.c"
									LexerToken* _tmp18_;
#line 567 "../lib/equation-lexer.vala"
									_tmp18_ = lexer_insert_angle_num_dms (self);
#line 567 "../lib/equation-lexer.vala"
									result = _tmp18_;
#line 567 "../lib/equation-lexer.vala"
									return result;
#line 3255 "equation-lexer.c"
								} else {
									PreLexer* _tmp19_;
									LexerToken* _tmp20_;
#line 570 "../lib/equation-lexer.vala"
									_tmp19_ = self->priv->prelexer;
#line 570 "../lib/equation-lexer.vala"
									pre_lexer_roll_back (_tmp19_);
#line 571 "../lib/equation-lexer.vala"
									_tmp20_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 571 "../lib/equation-lexer.vala"
									result = _tmp20_;
#line 571 "../lib/equation-lexer.vala"
									return result;
#line 3269 "equation-lexer.c"
								}
							}
						} else {
							PreLexer* _tmp21_;
							Parser* _tmp22_;
							PreLexer* _tmp23_;
							PreLexer* _tmp24_;
							LexerToken* _tmp25_;
#line 577 "../lib/equation-lexer.vala"
							_tmp21_ = self->priv->prelexer;
#line 577 "../lib/equation-lexer.vala"
							pre_lexer_roll_back (_tmp21_);
#line 578 "../lib/equation-lexer.vala"
							_tmp22_ = self->priv->parser;
#line 578 "../lib/equation-lexer.vala"
							_tmp23_ = self->priv->prelexer;
#line 578 "../lib/equation-lexer.vala"
							_tmp24_ = self->priv->prelexer;
#line 578 "../lib/equation-lexer.vala"
							parser_set_error (_tmp22_, ERROR_CODE_MP, _ ("Missing minute symbol (′)"), (guint) _tmp23_->mark_index, (guint) _tmp24_->index);
#line 579 "../lib/equation-lexer.vala"
							_tmp25_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_UNKNOWN);
#line 579 "../lib/equation-lexer.vala"
							result = _tmp25_;
#line 579 "../lib/equation-lexer.vala"
							return result;
#line 3296 "equation-lexer.c"
						}
					}
				} else {
#line 582 "../lib/equation-lexer.vala"
					if (type == LEXER_TOKEN_TYPE_PL_DECIMAL) {
#line 3302 "equation-lexer.c"
						LexerToken* _tmp26_;
#line 583 "../lib/equation-lexer.vala"
						_tmp26_ = lexer_insert_angle_num_dm (self);
#line 583 "../lib/equation-lexer.vala"
						result = _tmp26_;
#line 583 "../lib/equation-lexer.vala"
						return result;
#line 3310 "equation-lexer.c"
					} else {
						LexerToken* _tmp27_;
#line 585 "../lib/equation-lexer.vala"
						_tmp27_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 585 "../lib/equation-lexer.vala"
						result = _tmp27_;
#line 585 "../lib/equation-lexer.vala"
						return result;
#line 3319 "equation-lexer.c"
					}
				}
			} else {
#line 587 "../lib/equation-lexer.vala"
				if (type == LEXER_TOKEN_TYPE_PL_DECIMAL) {
#line 3325 "equation-lexer.c"
					LexerToken* _tmp28_;
#line 588 "../lib/equation-lexer.vala"
					_tmp28_ = lexer_insert_decimal (self);
#line 588 "../lib/equation-lexer.vala"
					result = _tmp28_;
#line 588 "../lib/equation-lexer.vala"
					return result;
#line 3333 "equation-lexer.c"
				} else {
#line 589 "../lib/equation-lexer.vala"
					if (lexer_check_if_literal_base (self)) {
#line 3337 "equation-lexer.c"
						LexerToken* _tmp29_;
#line 590 "../lib/equation-lexer.vala"
						_tmp29_ = lexer_insert_hex (self);
#line 590 "../lib/equation-lexer.vala"
						result = _tmp29_;
#line 590 "../lib/equation-lexer.vala"
						return result;
#line 3345 "equation-lexer.c"
					} else {
#line 591 "../lib/equation-lexer.vala"
						if (type == LEXER_TOKEN_TYPE_PL_HEX) {
#line 3349 "equation-lexer.c"
							LexerToken* _tmp30_;
#line 592 "../lib/equation-lexer.vala"
							_tmp30_ = lexer_insert_hex_dec (self);
#line 592 "../lib/equation-lexer.vala"
							result = _tmp30_;
#line 592 "../lib/equation-lexer.vala"
							return result;
#line 3357 "equation-lexer.c"
						} else {
							PreLexer* _tmp31_;
							LexerToken* _tmp32_;
#line 595 "../lib/equation-lexer.vala"
							_tmp31_ = self->priv->prelexer;
#line 595 "../lib/equation-lexer.vala"
							pre_lexer_roll_back (_tmp31_);
#line 596 "../lib/equation-lexer.vala"
							_tmp32_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 596 "../lib/equation-lexer.vala"
							result = _tmp32_;
#line 596 "../lib/equation-lexer.vala"
							return result;
#line 3371 "equation-lexer.c"
						}
					}
				}
			}
		}
	}
}

static LexerToken*
lexer_insert_angle_num_dm (Lexer* self)
{
	LexerTokenType type = 0;
	PreLexer* _tmp0_;
	LexerToken* result;
#line 600 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 602 "../lib/equation-lexer.vala"
	_tmp0_ = self->priv->prelexer;
#line 602 "../lib/equation-lexer.vala"
	type = pre_lexer_get_next_token (_tmp0_);
#line 603 "../lib/equation-lexer.vala"
	if (type != LEXER_TOKEN_TYPE_PL_DIGIT) {
#line 3394 "equation-lexer.c"
		PreLexer* _tmp1_;
		Parser* _tmp2_;
		PreLexer* _tmp3_;
		PreLexer* _tmp4_;
		LexerToken* _tmp5_;
#line 606 "../lib/equation-lexer.vala"
		_tmp1_ = self->priv->prelexer;
#line 606 "../lib/equation-lexer.vala"
		pre_lexer_roll_back (_tmp1_);
#line 607 "../lib/equation-lexer.vala"
		_tmp2_ = self->priv->parser;
#line 607 "../lib/equation-lexer.vala"
		_tmp3_ = self->priv->prelexer;
#line 607 "../lib/equation-lexer.vala"
		_tmp4_ = self->priv->prelexer;
#line 607 "../lib/equation-lexer.vala"
		parser_set_error (_tmp2_, ERROR_CODE_MP, _ ("Missing digits after decimal point"), (guint) _tmp3_->mark_index, (guint) _tmp4_->index);
#line 608 "../lib/equation-lexer.vala"
		_tmp5_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_UNKNOWN);
#line 608 "../lib/equation-lexer.vala"
		result = _tmp5_;
#line 608 "../lib/equation-lexer.vala"
		return result;
#line 3418 "equation-lexer.c"
	}
#line 611 "../lib/equation-lexer.vala"
	while (TRUE) {
#line 3422 "equation-lexer.c"
		PreLexer* _tmp6_;
#line 611 "../lib/equation-lexer.vala"
		if (!(type == LEXER_TOKEN_TYPE_PL_DIGIT)) {
#line 611 "../lib/equation-lexer.vala"
			break;
#line 3428 "equation-lexer.c"
		}
#line 612 "../lib/equation-lexer.vala"
		_tmp6_ = self->priv->prelexer;
#line 612 "../lib/equation-lexer.vala"
		type = pre_lexer_get_next_token (_tmp6_);
#line 3434 "equation-lexer.c"
	}
#line 614 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_MINUTE) {
#line 3438 "equation-lexer.c"
		LexerToken* _tmp7_;
#line 615 "../lib/equation-lexer.vala"
		_tmp7_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 615 "../lib/equation-lexer.vala"
		result = _tmp7_;
#line 615 "../lib/equation-lexer.vala"
		return result;
#line 3446 "equation-lexer.c"
	} else {
		PreLexer* _tmp8_;
		Parser* _tmp9_;
		PreLexer* _tmp10_;
		PreLexer* _tmp11_;
		LexerToken* _tmp12_;
#line 619 "../lib/equation-lexer.vala"
		_tmp8_ = self->priv->prelexer;
#line 619 "../lib/equation-lexer.vala"
		pre_lexer_roll_back (_tmp8_);
#line 620 "../lib/equation-lexer.vala"
		_tmp9_ = self->priv->parser;
#line 620 "../lib/equation-lexer.vala"
		_tmp10_ = self->priv->prelexer;
#line 620 "../lib/equation-lexer.vala"
		_tmp11_ = self->priv->prelexer;
#line 620 "../lib/equation-lexer.vala"
		parser_set_error (_tmp9_, ERROR_CODE_MP, _ ("Missing minute symbol (′)"), (guint) _tmp10_->mark_index, (guint) _tmp11_->index);
#line 621 "../lib/equation-lexer.vala"
		_tmp12_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_UNKNOWN);
#line 621 "../lib/equation-lexer.vala"
		result = _tmp12_;
#line 621 "../lib/equation-lexer.vala"
		return result;
#line 3471 "equation-lexer.c"
	}
}

static LexerToken*
lexer_insert_angle_num_dms (Lexer* self)
{
	LexerTokenType type = 0;
	PreLexer* _tmp0_;
	LexerToken* result;
#line 625 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 627 "../lib/equation-lexer.vala"
	_tmp0_ = self->priv->prelexer;
#line 627 "../lib/equation-lexer.vala"
	type = pre_lexer_get_next_token (_tmp0_);
#line 628 "../lib/equation-lexer.vala"
	if (type != LEXER_TOKEN_TYPE_PL_DIGIT) {
#line 3489 "equation-lexer.c"
		PreLexer* _tmp1_;
		Parser* _tmp2_;
		PreLexer* _tmp3_;
		PreLexer* _tmp4_;
		LexerToken* _tmp5_;
#line 631 "../lib/equation-lexer.vala"
		_tmp1_ = self->priv->prelexer;
#line 631 "../lib/equation-lexer.vala"
		pre_lexer_roll_back (_tmp1_);
#line 632 "../lib/equation-lexer.vala"
		_tmp2_ = self->priv->parser;
#line 632 "../lib/equation-lexer.vala"
		_tmp3_ = self->priv->prelexer;
#line 632 "../lib/equation-lexer.vala"
		_tmp4_ = self->priv->prelexer;
#line 632 "../lib/equation-lexer.vala"
		parser_set_error (_tmp2_, ERROR_CODE_MP, _ ("Missing digits after decimal point"), (guint) _tmp3_->mark_index, (guint) _tmp4_->index);
#line 633 "../lib/equation-lexer.vala"
		_tmp5_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_UNKNOWN);
#line 633 "../lib/equation-lexer.vala"
		result = _tmp5_;
#line 633 "../lib/equation-lexer.vala"
		return result;
#line 3513 "equation-lexer.c"
	}
#line 635 "../lib/equation-lexer.vala"
	while (TRUE) {
#line 3517 "equation-lexer.c"
		PreLexer* _tmp6_;
#line 635 "../lib/equation-lexer.vala"
		_tmp6_ = self->priv->prelexer;
#line 635 "../lib/equation-lexer.vala"
		type = pre_lexer_get_next_token (_tmp6_);
#line 635 "../lib/equation-lexer.vala"
		if (!(type == LEXER_TOKEN_TYPE_PL_DIGIT)) {
#line 635 "../lib/equation-lexer.vala"
			break;
#line 3527 "equation-lexer.c"
		}
	}
#line 636 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_SECOND) {
#line 3532 "equation-lexer.c"
		LexerToken* _tmp7_;
#line 637 "../lib/equation-lexer.vala"
		_tmp7_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 637 "../lib/equation-lexer.vala"
		result = _tmp7_;
#line 637 "../lib/equation-lexer.vala"
		return result;
#line 3540 "equation-lexer.c"
	} else {
		PreLexer* _tmp8_;
		Parser* _tmp9_;
		PreLexer* _tmp10_;
		PreLexer* _tmp11_;
		LexerToken* _tmp12_;
#line 641 "../lib/equation-lexer.vala"
		_tmp8_ = self->priv->prelexer;
#line 641 "../lib/equation-lexer.vala"
		pre_lexer_roll_back (_tmp8_);
#line 642 "../lib/equation-lexer.vala"
		_tmp9_ = self->priv->parser;
#line 642 "../lib/equation-lexer.vala"
		_tmp10_ = self->priv->prelexer;
#line 642 "../lib/equation-lexer.vala"
		_tmp11_ = self->priv->prelexer;
#line 642 "../lib/equation-lexer.vala"
		parser_set_error (_tmp9_, ERROR_CODE_MP, _ ("Missing second symbol (″)"), (guint) _tmp10_->mark_index, (guint) _tmp11_->index);
#line 643 "../lib/equation-lexer.vala"
		_tmp12_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_UNKNOWN);
#line 643 "../lib/equation-lexer.vala"
		result = _tmp12_;
#line 643 "../lib/equation-lexer.vala"
		return result;
#line 3565 "equation-lexer.c"
	}
}

static LexerToken*
lexer_insert_decimal (Lexer* self)
{
	LexerTokenType type = 0;
	PreLexer* _tmp0_;
	LexerToken* result;
#line 647 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 649 "../lib/equation-lexer.vala"
	_tmp0_ = self->priv->prelexer;
#line 649 "../lib/equation-lexer.vala"
	type = pre_lexer_get_next_token (_tmp0_);
#line 650 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_DIGIT) {
#line 652 "../lib/equation-lexer.vala"
		while (TRUE) {
#line 3585 "equation-lexer.c"
			PreLexer* _tmp1_;
#line 652 "../lib/equation-lexer.vala"
			_tmp1_ = self->priv->prelexer;
#line 652 "../lib/equation-lexer.vala"
			type = pre_lexer_get_next_token (_tmp1_);
#line 652 "../lib/equation-lexer.vala"
			if (!(type == LEXER_TOKEN_TYPE_PL_DIGIT)) {
#line 652 "../lib/equation-lexer.vala"
				break;
#line 3595 "equation-lexer.c"
			}
		}
#line 653 "../lib/equation-lexer.vala"
		if (type == LEXER_TOKEN_TYPE_PL_DEGREE) {
#line 3600 "equation-lexer.c"
			LexerToken* _tmp2_;
#line 654 "../lib/equation-lexer.vala"
			_tmp2_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 654 "../lib/equation-lexer.vala"
			result = _tmp2_;
#line 654 "../lib/equation-lexer.vala"
			return result;
#line 3608 "equation-lexer.c"
		} else {
#line 655 "../lib/equation-lexer.vala"
			if (type == LEXER_TOKEN_TYPE_PL_HEX) {
#line 3612 "equation-lexer.c"
				LexerToken* _tmp3_;
#line 656 "../lib/equation-lexer.vala"
				_tmp3_ = lexer_insert_decimal_hex (self);
#line 656 "../lib/equation-lexer.vala"
				result = _tmp3_;
#line 656 "../lib/equation-lexer.vala"
				return result;
#line 3620 "equation-lexer.c"
			} else {
#line 657 "../lib/equation-lexer.vala"
				if (type == LEXER_TOKEN_TYPE_PL_SUB_DIGIT) {
#line 3624 "equation-lexer.c"
					PreLexer* _tmp5_;
					LexerToken* _tmp6_;
#line 659 "../lib/equation-lexer.vala"
					while (TRUE) {
#line 3629 "equation-lexer.c"
						PreLexer* _tmp4_;
#line 659 "../lib/equation-lexer.vala"
						_tmp4_ = self->priv->prelexer;
#line 659 "../lib/equation-lexer.vala"
						if (!(pre_lexer_get_next_token (_tmp4_) == LEXER_TOKEN_TYPE_PL_SUB_DIGIT)) {
#line 659 "../lib/equation-lexer.vala"
							break;
#line 3637 "equation-lexer.c"
						}
					}
#line 660 "../lib/equation-lexer.vala"
					_tmp5_ = self->priv->prelexer;
#line 660 "../lib/equation-lexer.vala"
					pre_lexer_roll_back (_tmp5_);
#line 661 "../lib/equation-lexer.vala"
					_tmp6_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 661 "../lib/equation-lexer.vala"
					result = _tmp6_;
#line 661 "../lib/equation-lexer.vala"
					return result;
#line 3650 "equation-lexer.c"
				} else {
					PreLexer* _tmp7_;
					LexerToken* _tmp8_;
#line 665 "../lib/equation-lexer.vala"
					_tmp7_ = self->priv->prelexer;
#line 665 "../lib/equation-lexer.vala"
					pre_lexer_roll_back (_tmp7_);
#line 666 "../lib/equation-lexer.vala"
					_tmp8_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 666 "../lib/equation-lexer.vala"
					result = _tmp8_;
#line 666 "../lib/equation-lexer.vala"
					return result;
#line 3664 "equation-lexer.c"
				}
			}
		}
	} else {
#line 669 "../lib/equation-lexer.vala"
		if (type == LEXER_TOKEN_TYPE_PL_HEX) {
#line 3671 "equation-lexer.c"
			LexerToken* _tmp9_;
#line 670 "../lib/equation-lexer.vala"
			_tmp9_ = lexer_insert_decimal_hex (self);
#line 670 "../lib/equation-lexer.vala"
			result = _tmp9_;
#line 670 "../lib/equation-lexer.vala"
			return result;
#line 3679 "equation-lexer.c"
		} else {
			PreLexer* _tmp10_;
			Parser* _tmp11_;
			PreLexer* _tmp12_;
			PreLexer* _tmp13_;
			LexerToken* _tmp14_;
#line 674 "../lib/equation-lexer.vala"
			_tmp10_ = self->priv->prelexer;
#line 674 "../lib/equation-lexer.vala"
			pre_lexer_roll_back (_tmp10_);
#line 675 "../lib/equation-lexer.vala"
			_tmp11_ = self->priv->parser;
#line 675 "../lib/equation-lexer.vala"
			_tmp12_ = self->priv->prelexer;
#line 675 "../lib/equation-lexer.vala"
			_tmp13_ = self->priv->prelexer;
#line 675 "../lib/equation-lexer.vala"
			parser_set_error (_tmp11_, ERROR_CODE_MP, _ ("Missing digits after decimal point"), (guint) _tmp12_->mark_index, (guint) _tmp13_->index);
#line 676 "../lib/equation-lexer.vala"
			_tmp14_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_UNKNOWN);
#line 676 "../lib/equation-lexer.vala"
			result = _tmp14_;
#line 676 "../lib/equation-lexer.vala"
			return result;
#line 3704 "equation-lexer.c"
		}
	}
}

static LexerToken*
lexer_insert_hex (Lexer* self)
{
	LexerTokenType type = 0;
	PreLexer* _tmp0_;
	LexerToken* result;
#line 680 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 682 "../lib/equation-lexer.vala"
	_tmp0_ = self->priv->prelexer;
#line 682 "../lib/equation-lexer.vala"
	type = pre_lexer_get_next_token (_tmp0_);
#line 683 "../lib/equation-lexer.vala"
	while (TRUE) {
#line 3723 "equation-lexer.c"
		PreLexer* _tmp1_;
#line 683 "../lib/equation-lexer.vala"
		if (!(type == LEXER_TOKEN_TYPE_PL_HEX)) {
#line 683 "../lib/equation-lexer.vala"
			break;
#line 3729 "equation-lexer.c"
		}
#line 684 "../lib/equation-lexer.vala"
		_tmp1_ = self->priv->prelexer;
#line 684 "../lib/equation-lexer.vala"
		type = pre_lexer_get_next_token (_tmp1_);
#line 3735 "equation-lexer.c"
	}
#line 686 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_DIGIT) {
#line 3739 "equation-lexer.c"
		LexerToken* _tmp2_;
#line 687 "../lib/equation-lexer.vala"
		_tmp2_ = lexer_insert_hex_dec (self);
#line 687 "../lib/equation-lexer.vala"
		result = _tmp2_;
#line 687 "../lib/equation-lexer.vala"
		return result;
#line 3747 "equation-lexer.c"
	} else {
#line 688 "../lib/equation-lexer.vala"
		if (type == LEXER_TOKEN_TYPE_PL_DECIMAL) {
#line 3751 "equation-lexer.c"
			LexerToken* _tmp3_;
#line 689 "../lib/equation-lexer.vala"
			_tmp3_ = lexer_insert_decimal_hex (self);
#line 689 "../lib/equation-lexer.vala"
			result = _tmp3_;
#line 689 "../lib/equation-lexer.vala"
			return result;
#line 3759 "equation-lexer.c"
		} else {
#line 690 "../lib/equation-lexer.vala"
			if (type == LEXER_TOKEN_TYPE_PL_SUB_DIGIT) {
#line 3763 "equation-lexer.c"
				PreLexer* _tmp5_;
#line 692 "../lib/equation-lexer.vala"
				while (TRUE) {
#line 3767 "equation-lexer.c"
					PreLexer* _tmp4_;
#line 692 "../lib/equation-lexer.vala"
					_tmp4_ = self->priv->prelexer;
#line 692 "../lib/equation-lexer.vala"
					if (!(pre_lexer_get_next_token (_tmp4_) == LEXER_TOKEN_TYPE_PL_SUB_DIGIT)) {
#line 692 "../lib/equation-lexer.vala"
						break;
#line 3775 "equation-lexer.c"
					}
				}
#line 693 "../lib/equation-lexer.vala"
				_tmp5_ = self->priv->prelexer;
#line 693 "../lib/equation-lexer.vala"
				pre_lexer_roll_back (_tmp5_);
#line 695 "../lib/equation-lexer.vala"
				if (lexer_check_if_number (self)) {
#line 3784 "equation-lexer.c"
					LexerToken* _tmp6_;
#line 696 "../lib/equation-lexer.vala"
					_tmp6_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 696 "../lib/equation-lexer.vala"
					result = _tmp6_;
#line 696 "../lib/equation-lexer.vala"
					return result;
#line 3792 "equation-lexer.c"
				} else {
#line 699 "../lib/equation-lexer.vala"
					if (lexer_check_if_function (self)) {
#line 3796 "equation-lexer.c"
						LexerToken* _tmp7_;
#line 700 "../lib/equation-lexer.vala"
						_tmp7_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_FUNCTION);
#line 700 "../lib/equation-lexer.vala"
						result = _tmp7_;
#line 700 "../lib/equation-lexer.vala"
						return result;
#line 3804 "equation-lexer.c"
					} else {
#line 701 "../lib/equation-lexer.vala"
						if (lexer_check_if_currency (self)) {
#line 3808 "equation-lexer.c"
							LexerToken* _tmp8_;
#line 702 "../lib/equation-lexer.vala"
							_tmp8_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_CURRENCY);
#line 702 "../lib/equation-lexer.vala"
							result = _tmp8_;
#line 702 "../lib/equation-lexer.vala"
							return result;
#line 3816 "equation-lexer.c"
						} else {
#line 703 "../lib/equation-lexer.vala"
							if (lexer_check_if_unit (self)) {
#line 3820 "equation-lexer.c"
								LexerToken* _tmp9_;
#line 704 "../lib/equation-lexer.vala"
								_tmp9_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_UNIT);
#line 704 "../lib/equation-lexer.vala"
								result = _tmp9_;
#line 704 "../lib/equation-lexer.vala"
								return result;
#line 3828 "equation-lexer.c"
							} else {
								LexerToken* _tmp10_;
#line 706 "../lib/equation-lexer.vala"
								_tmp10_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_VARIABLE);
#line 706 "../lib/equation-lexer.vala"
								result = _tmp10_;
#line 706 "../lib/equation-lexer.vala"
								return result;
#line 3837 "equation-lexer.c"
							}
						}
					}
				}
			} else {
#line 709 "../lib/equation-lexer.vala"
				if (type == LEXER_TOKEN_TYPE_PL_LETTER) {
#line 3845 "equation-lexer.c"
					LexerToken* _tmp11_;
#line 710 "../lib/equation-lexer.vala"
					_tmp11_ = lexer_insert_letter (self);
#line 710 "../lib/equation-lexer.vala"
					result = _tmp11_;
#line 710 "../lib/equation-lexer.vala"
					return result;
#line 3853 "equation-lexer.c"
				} else {
					PreLexer* _tmp12_;
#line 713 "../lib/equation-lexer.vala"
					_tmp12_ = self->priv->prelexer;
#line 713 "../lib/equation-lexer.vala"
					pre_lexer_roll_back (_tmp12_);
#line 714 "../lib/equation-lexer.vala"
					if (lexer_check_if_number (self)) {
#line 3862 "equation-lexer.c"
						LexerToken* _tmp13_;
#line 715 "../lib/equation-lexer.vala"
						_tmp13_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 715 "../lib/equation-lexer.vala"
						result = _tmp13_;
#line 715 "../lib/equation-lexer.vala"
						return result;
#line 3870 "equation-lexer.c"
					} else {
#line 718 "../lib/equation-lexer.vala"
						if (lexer_check_if_function (self)) {
#line 3874 "equation-lexer.c"
							LexerToken* _tmp14_;
#line 719 "../lib/equation-lexer.vala"
							_tmp14_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_FUNCTION);
#line 719 "../lib/equation-lexer.vala"
							result = _tmp14_;
#line 719 "../lib/equation-lexer.vala"
							return result;
#line 3882 "equation-lexer.c"
						} else {
#line 720 "../lib/equation-lexer.vala"
							if (lexer_check_if_currency (self)) {
#line 3886 "equation-lexer.c"
								LexerToken* _tmp15_;
#line 721 "../lib/equation-lexer.vala"
								_tmp15_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_CURRENCY);
#line 721 "../lib/equation-lexer.vala"
								result = _tmp15_;
#line 721 "../lib/equation-lexer.vala"
								return result;
#line 3894 "equation-lexer.c"
							} else {
#line 722 "../lib/equation-lexer.vala"
								if (lexer_check_if_unit (self)) {
#line 3898 "equation-lexer.c"
									LexerToken* _tmp16_;
#line 723 "../lib/equation-lexer.vala"
									_tmp16_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_UNIT);
#line 723 "../lib/equation-lexer.vala"
									result = _tmp16_;
#line 723 "../lib/equation-lexer.vala"
									return result;
#line 3906 "equation-lexer.c"
								} else {
									LexerToken* _tmp17_;
#line 725 "../lib/equation-lexer.vala"
									_tmp17_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_VARIABLE);
#line 725 "../lib/equation-lexer.vala"
									result = _tmp17_;
#line 725 "../lib/equation-lexer.vala"
									return result;
#line 3915 "equation-lexer.c"
								}
							}
						}
					}
				}
			}
		}
	}
}

static LexerToken*
lexer_insert_hex_dec (Lexer* self)
{
	LexerTokenType type = 0;
	PreLexer* _tmp0_;
	LexerToken* result;
#line 730 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 732 "../lib/equation-lexer.vala"
	_tmp0_ = self->priv->prelexer;
#line 732 "../lib/equation-lexer.vala"
	type = pre_lexer_get_next_token (_tmp0_);
#line 733 "../lib/equation-lexer.vala"
	while (TRUE) {
#line 3940 "equation-lexer.c"
		gboolean _tmp1_ = FALSE;
		PreLexer* _tmp2_;
#line 733 "../lib/equation-lexer.vala"
		if (type == LEXER_TOKEN_TYPE_PL_DIGIT) {
#line 733 "../lib/equation-lexer.vala"
			_tmp1_ = TRUE;
#line 3947 "equation-lexer.c"
		} else {
#line 733 "../lib/equation-lexer.vala"
			_tmp1_ = type == LEXER_TOKEN_TYPE_PL_HEX;
#line 3951 "equation-lexer.c"
		}
#line 733 "../lib/equation-lexer.vala"
		if (!_tmp1_) {
#line 733 "../lib/equation-lexer.vala"
			break;
#line 3957 "equation-lexer.c"
		}
#line 734 "../lib/equation-lexer.vala"
		_tmp2_ = self->priv->prelexer;
#line 734 "../lib/equation-lexer.vala"
		type = pre_lexer_get_next_token (_tmp2_);
#line 3963 "equation-lexer.c"
	}
#line 736 "../lib/equation-lexer.vala"
	if (type == LEXER_TOKEN_TYPE_PL_DECIMAL) {
#line 3967 "equation-lexer.c"
		LexerToken* _tmp3_;
#line 737 "../lib/equation-lexer.vala"
		_tmp3_ = lexer_insert_decimal_hex (self);
#line 737 "../lib/equation-lexer.vala"
		result = _tmp3_;
#line 737 "../lib/equation-lexer.vala"
		return result;
#line 3975 "equation-lexer.c"
	} else {
#line 738 "../lib/equation-lexer.vala"
		if (type == LEXER_TOKEN_TYPE_PL_SUB_DIGIT) {
#line 3979 "equation-lexer.c"
			PreLexer* _tmp5_;
			LexerToken* _tmp6_;
#line 740 "../lib/equation-lexer.vala"
			while (TRUE) {
#line 3984 "equation-lexer.c"
				PreLexer* _tmp4_;
#line 740 "../lib/equation-lexer.vala"
				_tmp4_ = self->priv->prelexer;
#line 740 "../lib/equation-lexer.vala"
				if (!(pre_lexer_get_next_token (_tmp4_) == LEXER_TOKEN_TYPE_PL_SUB_DIGIT)) {
#line 740 "../lib/equation-lexer.vala"
					break;
#line 3992 "equation-lexer.c"
				}
			}
#line 741 "../lib/equation-lexer.vala"
			_tmp5_ = self->priv->prelexer;
#line 741 "../lib/equation-lexer.vala"
			pre_lexer_roll_back (_tmp5_);
#line 742 "../lib/equation-lexer.vala"
			_tmp6_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 742 "../lib/equation-lexer.vala"
			result = _tmp6_;
#line 742 "../lib/equation-lexer.vala"
			return result;
#line 4005 "equation-lexer.c"
		} else {
			Parser* _tmp8_;
			PreLexer* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			PreLexer* _tmp12_;
			PreLexer* _tmp13_;
			LexerToken* _tmp14_;
#line 746 "../lib/equation-lexer.vala"
			if (lexer_check_if_number (self)) {
#line 4016 "equation-lexer.c"
				LexerToken* _tmp7_;
#line 747 "../lib/equation-lexer.vala"
				_tmp7_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 747 "../lib/equation-lexer.vala"
				result = _tmp7_;
#line 747 "../lib/equation-lexer.vala"
				return result;
#line 4024 "equation-lexer.c"
			}
#line 749 "../lib/equation-lexer.vala"
			_tmp8_ = self->priv->parser;
#line 749 "../lib/equation-lexer.vala"
			_tmp9_ = self->priv->prelexer;
#line 749 "../lib/equation-lexer.vala"
			_tmp10_ = pre_lexer_get_marked_substring (_tmp9_);
#line 749 "../lib/equation-lexer.vala"
			_tmp11_ = _tmp10_;
#line 749 "../lib/equation-lexer.vala"
			_tmp12_ = self->priv->prelexer;
#line 749 "../lib/equation-lexer.vala"
			_tmp13_ = self->priv->prelexer;
#line 749 "../lib/equation-lexer.vala"
			parser_set_error (_tmp8_, ERROR_CODE_MP, _tmp11_, (guint) _tmp12_->mark_index, (guint) _tmp13_->index);
#line 749 "../lib/equation-lexer.vala"
			_g_free0 (_tmp11_);
#line 750 "../lib/equation-lexer.vala"
			_tmp14_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_UNKNOWN);
#line 750 "../lib/equation-lexer.vala"
			result = _tmp14_;
#line 750 "../lib/equation-lexer.vala"
			return result;
#line 4048 "equation-lexer.c"
		}
	}
}

static LexerToken*
lexer_insert_decimal_hex (Lexer* self)
{
	LexerTokenType type = 0;
	PreLexer* _tmp0_;
	gboolean _tmp1_ = FALSE;
	PreLexer* _tmp10_;
	LexerToken* _tmp11_;
	LexerToken* result;
#line 754 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 757 "../lib/equation-lexer.vala"
	_tmp0_ = self->priv->prelexer;
#line 757 "../lib/equation-lexer.vala"
	type = pre_lexer_get_next_token (_tmp0_);
#line 758 "../lib/equation-lexer.vala"
	if (type != LEXER_TOKEN_TYPE_PL_DIGIT) {
#line 758 "../lib/equation-lexer.vala"
		_tmp1_ = type != LEXER_TOKEN_TYPE_PL_HEX;
#line 4072 "equation-lexer.c"
	} else {
#line 758 "../lib/equation-lexer.vala"
		_tmp1_ = FALSE;
#line 4076 "equation-lexer.c"
	}
#line 758 "../lib/equation-lexer.vala"
	if (_tmp1_) {
#line 4080 "equation-lexer.c"
		PreLexer* _tmp2_;
		Parser* _tmp3_;
		PreLexer* _tmp4_;
		PreLexer* _tmp5_;
		LexerToken* _tmp6_;
#line 761 "../lib/equation-lexer.vala"
		_tmp2_ = self->priv->prelexer;
#line 761 "../lib/equation-lexer.vala"
		pre_lexer_roll_back (_tmp2_);
#line 762 "../lib/equation-lexer.vala"
		_tmp3_ = self->priv->parser;
#line 762 "../lib/equation-lexer.vala"
		_tmp4_ = self->priv->prelexer;
#line 762 "../lib/equation-lexer.vala"
		_tmp5_ = self->priv->prelexer;
#line 762 "../lib/equation-lexer.vala"
		parser_set_error (_tmp3_, ERROR_CODE_MP, _ ("Missing digits after decimal point"), (guint) _tmp4_->mark_index, (guint) _tmp5_->index);
#line 763 "../lib/equation-lexer.vala"
		_tmp6_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_UNKNOWN);
#line 763 "../lib/equation-lexer.vala"
		result = _tmp6_;
#line 763 "../lib/equation-lexer.vala"
		return result;
#line 4104 "equation-lexer.c"
	}
#line 765 "../lib/equation-lexer.vala"
	while (TRUE) {
#line 4108 "equation-lexer.c"
		gboolean _tmp7_ = FALSE;
		PreLexer* _tmp8_;
#line 765 "../lib/equation-lexer.vala"
		if (type == LEXER_TOKEN_TYPE_PL_DIGIT) {
#line 765 "../lib/equation-lexer.vala"
			_tmp7_ = TRUE;
#line 4115 "equation-lexer.c"
		} else {
#line 765 "../lib/equation-lexer.vala"
			_tmp7_ = type == LEXER_TOKEN_TYPE_PL_HEX;
#line 4119 "equation-lexer.c"
		}
#line 765 "../lib/equation-lexer.vala"
		if (!_tmp7_) {
#line 765 "../lib/equation-lexer.vala"
			break;
#line 4125 "equation-lexer.c"
		}
#line 766 "../lib/equation-lexer.vala"
		_tmp8_ = self->priv->prelexer;
#line 766 "../lib/equation-lexer.vala"
		type = pre_lexer_get_next_token (_tmp8_);
#line 4131 "equation-lexer.c"
	}
#line 769 "../lib/equation-lexer.vala"
	while (TRUE) {
#line 4135 "equation-lexer.c"
		PreLexer* _tmp9_;
#line 769 "../lib/equation-lexer.vala"
		if (!(type == LEXER_TOKEN_TYPE_PL_SUB_DIGIT)) {
#line 769 "../lib/equation-lexer.vala"
			break;
#line 4141 "equation-lexer.c"
		}
#line 770 "../lib/equation-lexer.vala"
		_tmp9_ = self->priv->prelexer;
#line 770 "../lib/equation-lexer.vala"
		type = pre_lexer_get_next_token (_tmp9_);
#line 4147 "equation-lexer.c"
	}
#line 772 "../lib/equation-lexer.vala"
	_tmp10_ = self->priv->prelexer;
#line 772 "../lib/equation-lexer.vala"
	pre_lexer_roll_back (_tmp10_);
#line 774 "../lib/equation-lexer.vala"
	_tmp11_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NUMBER);
#line 774 "../lib/equation-lexer.vala"
	result = _tmp11_;
#line 774 "../lib/equation-lexer.vala"
	return result;
#line 4159 "equation-lexer.c"
}

static LexerToken*
lexer_insert_letter (Lexer* self)
{
	LexerTokenType type = 0;
	PreLexer* _tmp0_;
	PreLexer* _tmp4_;
	gchar* name = NULL;
	PreLexer* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp12_;
	const gchar* _tmp14_;
	const gchar* _tmp16_;
	const gchar* _tmp18_;
	const gchar* _tmp20_;
	const gchar* _tmp22_;
	gboolean _tmp24_ = FALSE;
	const gchar* _tmp25_;
	const gchar* _tmp28_;
	gboolean _tmp30_ = FALSE;
	const gchar* _tmp31_;
	LexerToken* result;
#line 777 "../lib/equation-lexer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 780 "../lib/equation-lexer.vala"
	_tmp0_ = self->priv->prelexer;
#line 780 "../lib/equation-lexer.vala"
	type = pre_lexer_get_next_token (_tmp0_);
#line 781 "../lib/equation-lexer.vala"
	while (TRUE) {
#line 4195 "equation-lexer.c"
		gboolean _tmp1_ = FALSE;
		PreLexer* _tmp2_;
#line 781 "../lib/equation-lexer.vala"
		if (type == LEXER_TOKEN_TYPE_PL_LETTER) {
#line 781 "../lib/equation-lexer.vala"
			_tmp1_ = TRUE;
#line 4202 "equation-lexer.c"
		} else {
#line 781 "../lib/equation-lexer.vala"
			_tmp1_ = type == LEXER_TOKEN_TYPE_PL_HEX;
#line 4206 "equation-lexer.c"
		}
#line 781 "../lib/equation-lexer.vala"
		if (!_tmp1_) {
#line 781 "../lib/equation-lexer.vala"
			break;
#line 4212 "equation-lexer.c"
		}
#line 782 "../lib/equation-lexer.vala"
		_tmp2_ = self->priv->prelexer;
#line 782 "../lib/equation-lexer.vala"
		type = pre_lexer_get_next_token (_tmp2_);
#line 4218 "equation-lexer.c"
	}
#line 785 "../lib/equation-lexer.vala"
	while (TRUE) {
#line 4222 "equation-lexer.c"
		PreLexer* _tmp3_;
#line 785 "../lib/equation-lexer.vala"
		if (!(type == LEXER_TOKEN_TYPE_PL_SUB_DIGIT)) {
#line 785 "../lib/equation-lexer.vala"
			break;
#line 4228 "equation-lexer.c"
		}
#line 786 "../lib/equation-lexer.vala"
		_tmp3_ = self->priv->prelexer;
#line 786 "../lib/equation-lexer.vala"
		type = pre_lexer_get_next_token (_tmp3_);
#line 4234 "equation-lexer.c"
	}
#line 788 "../lib/equation-lexer.vala"
	_tmp4_ = self->priv->prelexer;
#line 788 "../lib/equation-lexer.vala"
	pre_lexer_roll_back (_tmp4_);
#line 790 "../lib/equation-lexer.vala"
	_tmp5_ = self->priv->prelexer;
#line 790 "../lib/equation-lexer.vala"
	_tmp6_ = pre_lexer_get_marked_substring (_tmp5_);
#line 790 "../lib/equation-lexer.vala"
	_tmp7_ = _tmp6_;
#line 790 "../lib/equation-lexer.vala"
	_tmp8_ = g_utf8_strdown (_tmp7_, (gssize) -1);
#line 790 "../lib/equation-lexer.vala"
	_tmp9_ = _tmp8_;
#line 790 "../lib/equation-lexer.vala"
	_g_free0 (_tmp7_);
#line 790 "../lib/equation-lexer.vala"
	name = _tmp9_;
#line 791 "../lib/equation-lexer.vala"
	_tmp10_ = name;
#line 791 "../lib/equation-lexer.vala"
	if (g_strcmp0 (_tmp10_, "mod") == 0) {
#line 4258 "equation-lexer.c"
		LexerToken* _tmp11_;
#line 792 "../lib/equation-lexer.vala"
		_tmp11_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_MOD);
#line 792 "../lib/equation-lexer.vala"
		result = _tmp11_;
#line 792 "../lib/equation-lexer.vala"
		_g_free0 (name);
#line 792 "../lib/equation-lexer.vala"
		return result;
#line 4268 "equation-lexer.c"
	}
#line 793 "../lib/equation-lexer.vala"
	_tmp12_ = name;
#line 793 "../lib/equation-lexer.vala"
	if (g_strcmp0 (_tmp12_, "and") == 0) {
#line 4274 "equation-lexer.c"
		LexerToken* _tmp13_;
#line 794 "../lib/equation-lexer.vala"
		_tmp13_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_AND);
#line 794 "../lib/equation-lexer.vala"
		result = _tmp13_;
#line 794 "../lib/equation-lexer.vala"
		_g_free0 (name);
#line 794 "../lib/equation-lexer.vala"
		return result;
#line 4284 "equation-lexer.c"
	}
#line 795 "../lib/equation-lexer.vala"
	_tmp14_ = name;
#line 795 "../lib/equation-lexer.vala"
	if (g_strcmp0 (_tmp14_, "nand") == 0) {
#line 4290 "equation-lexer.c"
		LexerToken* _tmp15_;
#line 796 "../lib/equation-lexer.vala"
		_tmp15_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NAND);
#line 796 "../lib/equation-lexer.vala"
		result = _tmp15_;
#line 796 "../lib/equation-lexer.vala"
		_g_free0 (name);
#line 796 "../lib/equation-lexer.vala"
		return result;
#line 4300 "equation-lexer.c"
	}
#line 797 "../lib/equation-lexer.vala"
	_tmp16_ = name;
#line 797 "../lib/equation-lexer.vala"
	if (g_strcmp0 (_tmp16_, "\\cdot") == 0) {
#line 4306 "equation-lexer.c"
		LexerToken* _tmp17_;
#line 798 "../lib/equation-lexer.vala"
		_tmp17_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_MULTIPLY);
#line 798 "../lib/equation-lexer.vala"
		result = _tmp17_;
#line 798 "../lib/equation-lexer.vala"
		_g_free0 (name);
#line 798 "../lib/equation-lexer.vala"
		return result;
#line 4316 "equation-lexer.c"
	}
#line 799 "../lib/equation-lexer.vala"
	_tmp18_ = name;
#line 799 "../lib/equation-lexer.vala"
	if (g_strcmp0 (_tmp18_, "or") == 0) {
#line 4322 "equation-lexer.c"
		LexerToken* _tmp19_;
#line 800 "../lib/equation-lexer.vala"
		_tmp19_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_OR);
#line 800 "../lib/equation-lexer.vala"
		result = _tmp19_;
#line 800 "../lib/equation-lexer.vala"
		_g_free0 (name);
#line 800 "../lib/equation-lexer.vala"
		return result;
#line 4332 "equation-lexer.c"
	}
#line 801 "../lib/equation-lexer.vala"
	_tmp20_ = name;
#line 801 "../lib/equation-lexer.vala"
	if (g_strcmp0 (_tmp20_, "nor") == 0) {
#line 4338 "equation-lexer.c"
		LexerToken* _tmp21_;
#line 802 "../lib/equation-lexer.vala"
		_tmp21_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NOR);
#line 802 "../lib/equation-lexer.vala"
		result = _tmp21_;
#line 802 "../lib/equation-lexer.vala"
		_g_free0 (name);
#line 802 "../lib/equation-lexer.vala"
		return result;
#line 4348 "equation-lexer.c"
	}
#line 803 "../lib/equation-lexer.vala"
	_tmp22_ = name;
#line 803 "../lib/equation-lexer.vala"
	if (g_strcmp0 (_tmp22_, "xor") == 0) {
#line 4354 "equation-lexer.c"
		LexerToken* _tmp23_;
#line 804 "../lib/equation-lexer.vala"
		_tmp23_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_XOR);
#line 804 "../lib/equation-lexer.vala"
		result = _tmp23_;
#line 804 "../lib/equation-lexer.vala"
		_g_free0 (name);
#line 804 "../lib/equation-lexer.vala"
		return result;
#line 4364 "equation-lexer.c"
	}
#line 805 "../lib/equation-lexer.vala"
	_tmp25_ = name;
#line 805 "../lib/equation-lexer.vala"
	if (g_strcmp0 (_tmp25_, "xnor") == 0) {
#line 805 "../lib/equation-lexer.vala"
		_tmp24_ = TRUE;
#line 4372 "equation-lexer.c"
	} else {
		const gchar* _tmp26_;
#line 805 "../lib/equation-lexer.vala"
		_tmp26_ = name;
#line 805 "../lib/equation-lexer.vala"
		_tmp24_ = g_strcmp0 (_tmp26_, "nxor") == 0;
#line 4379 "equation-lexer.c"
	}
#line 805 "../lib/equation-lexer.vala"
	if (_tmp24_) {
#line 4383 "equation-lexer.c"
		LexerToken* _tmp27_;
#line 806 "../lib/equation-lexer.vala"
		_tmp27_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_XNOR);
#line 806 "../lib/equation-lexer.vala"
		result = _tmp27_;
#line 806 "../lib/equation-lexer.vala"
		_g_free0 (name);
#line 806 "../lib/equation-lexer.vala"
		return result;
#line 4393 "equation-lexer.c"
	}
#line 807 "../lib/equation-lexer.vala"
	_tmp28_ = name;
#line 807 "../lib/equation-lexer.vala"
	if (g_strcmp0 (_tmp28_, "not") == 0) {
#line 4399 "equation-lexer.c"
		LexerToken* _tmp29_;
#line 808 "../lib/equation-lexer.vala"
		_tmp29_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_NOT);
#line 808 "../lib/equation-lexer.vala"
		result = _tmp29_;
#line 808 "../lib/equation-lexer.vala"
		_g_free0 (name);
#line 808 "../lib/equation-lexer.vala"
		return result;
#line 4409 "equation-lexer.c"
	}
#line 810 "../lib/equation-lexer.vala"
	_tmp31_ = name;
#line 810 "../lib/equation-lexer.vala"
	if (g_strcmp0 (_tmp31_, _ ("in")) == 0) {
#line 810 "../lib/equation-lexer.vala"
		_tmp30_ = TRUE;
#line 4417 "equation-lexer.c"
	} else {
		const gchar* _tmp32_;
#line 810 "../lib/equation-lexer.vala"
		_tmp32_ = name;
#line 810 "../lib/equation-lexer.vala"
		_tmp30_ = g_strcmp0 (_tmp32_, _ ("to")) == 0;
#line 4424 "equation-lexer.c"
	}
#line 810 "../lib/equation-lexer.vala"
	if (_tmp30_) {
#line 4428 "equation-lexer.c"
		LexerToken* _tmp33_;
#line 811 "../lib/equation-lexer.vala"
		_tmp33_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_IN);
#line 811 "../lib/equation-lexer.vala"
		result = _tmp33_;
#line 811 "../lib/equation-lexer.vala"
		_g_free0 (name);
#line 811 "../lib/equation-lexer.vala"
		return result;
#line 4438 "equation-lexer.c"
	}
#line 812 "../lib/equation-lexer.vala"
	if (lexer_check_if_function (self)) {
#line 4442 "equation-lexer.c"
		LexerToken* _tmp34_;
#line 813 "../lib/equation-lexer.vala"
		_tmp34_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_FUNCTION);
#line 813 "../lib/equation-lexer.vala"
		result = _tmp34_;
#line 813 "../lib/equation-lexer.vala"
		_g_free0 (name);
#line 813 "../lib/equation-lexer.vala"
		return result;
#line 4452 "equation-lexer.c"
	}
#line 814 "../lib/equation-lexer.vala"
	if (lexer_check_if_currency (self)) {
#line 4456 "equation-lexer.c"
		LexerToken* _tmp35_;
#line 815 "../lib/equation-lexer.vala"
		_tmp35_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_CURRENCY);
#line 815 "../lib/equation-lexer.vala"
		result = _tmp35_;
#line 815 "../lib/equation-lexer.vala"
		_g_free0 (name);
#line 815 "../lib/equation-lexer.vala"
		return result;
#line 4466 "equation-lexer.c"
	}
#line 816 "../lib/equation-lexer.vala"
	if (lexer_check_if_unit (self)) {
#line 4470 "equation-lexer.c"
		LexerToken* _tmp36_;
#line 817 "../lib/equation-lexer.vala"
		_tmp36_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_UNIT);
#line 817 "../lib/equation-lexer.vala"
		result = _tmp36_;
#line 817 "../lib/equation-lexer.vala"
		_g_free0 (name);
#line 817 "../lib/equation-lexer.vala"
		return result;
#line 4480 "equation-lexer.c"
	} else {
		LexerToken* _tmp37_;
#line 819 "../lib/equation-lexer.vala"
		_tmp37_ = lexer_insert_token (self, LEXER_TOKEN_TYPE_VARIABLE);
#line 819 "../lib/equation-lexer.vala"
		result = _tmp37_;
#line 819 "../lib/equation-lexer.vala"
		_g_free0 (name);
#line 819 "../lib/equation-lexer.vala"
		return result;
#line 4491 "equation-lexer.c"
	}
}

static void
lexer_class_init (LexerClass * klass,
                  gpointer klass_data)
{
#line 282 "../lib/equation-lexer.vala"
	lexer_parent_class = g_type_class_peek_parent (klass);
#line 282 "../lib/equation-lexer.vala"
	g_type_class_adjust_private_offset (klass, &Lexer_private_offset);
#line 282 "../lib/equation-lexer.vala"
	G_OBJECT_CLASS (klass)->finalize = lexer_finalize;
#line 4505 "equation-lexer.c"
}

static void
lexer_instance_init (Lexer * self,
                     gpointer klass)
{
#line 282 "../lib/equation-lexer.vala"
	self->priv = lexer_get_instance_private (self);
#line 4514 "equation-lexer.c"
}

static void
lexer_finalize (GObject * obj)
{
	Lexer * self;
#line 282 "../lib/equation-lexer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LEXER, Lexer);
#line 284 "../lib/equation-lexer.vala"
	_parser_unref0 (self->priv->parser);
#line 285 "../lib/equation-lexer.vala"
	_g_object_unref0 (self->priv->prelexer);
#line 286 "../lib/equation-lexer.vala"
	(self->tokens == NULL) ? NULL : (self->tokens = (_g_list_free__g_object_unref0_ (self->tokens), NULL));
#line 282 "../lib/equation-lexer.vala"
	G_OBJECT_CLASS (lexer_parent_class)->finalize (obj);
#line 4531 "equation-lexer.c"
}

static GType
lexer_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (LexerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) lexer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Lexer), 0, (GInstanceInitFunc) lexer_instance_init, NULL };
	GType lexer_type_id;
	lexer_type_id = g_type_register_static (G_TYPE_OBJECT, "Lexer", &g_define_type_info, 0);
	Lexer_private_offset = g_type_add_instance_private (lexer_type_id, sizeof (LexerPrivate));
	return lexer_type_id;
}

GType
lexer_get_type (void)
{
	static volatile gsize lexer_type_id__once = 0;
	if (g_once_init_enter (&lexer_type_id__once)) {
		GType lexer_type_id;
		lexer_type_id = lexer_get_type_once ();
		g_once_init_leave (&lexer_type_id__once, lexer_type_id);
	}
	return lexer_type_id__once;
}

