/* function-manager.c generated by valac 0.56.18, the Vala compiler
 * generated from function-manager.vala, do not modify */

/*
 * Copyright (C) 2013 Garima Joshi
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include "calculator.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <glib/gstdio.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	FUNCTION_MANAGER_0_PROPERTY,
	FUNCTION_MANAGER_NUM_PROPERTIES
};
static GParamSpec* function_manager_properties[FUNCTION_MANAGER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
enum  {
	FUNCTION_MANAGER_FUNCTION_ADDED_SIGNAL,
	FUNCTION_MANAGER_FUNCTION_EDITED_SIGNAL,
	FUNCTION_MANAGER_FUNCTION_DELETED_SIGNAL,
	FUNCTION_MANAGER_NUM_SIGNALS
};
static guint function_manager_signals[FUNCTION_MANAGER_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _FunctionManagerPrivate {
	gchar* file_name;
	GHashTable* functions;
	Serializer* serializer;
};

VALA_EXTERN FunctionManager* default_function_manager;
FunctionManager* default_function_manager = NULL;
static gint FunctionManager_private_offset;
static gpointer function_manager_parent_class = NULL;

static void _g_free0_ (gpointer var);
static void _g_object_unref0_ (gpointer var);
static void function_manager_reload_functions (FunctionManager* self);
static void function_manager_reload_custom_functions (FunctionManager* self);
static void function_manager_reload_builtin_functions (FunctionManager* self);
static gboolean function_manager_add (FunctionManager* self,
                               MathFunction* new_function);
static MathFunction* function_manager_parse_function_from_string (FunctionManager* self,
                                                           const gchar* data);
static void function_manager_save (FunctionManager* self);
static gchar** function_manager_array_sort_string (FunctionManager* self,
                                            gchar** array,
                                            gint array_length1,
                                            gint* result_length1);
static gchar** _vala_array_dup2 (gchar** self,
                          gssize length);
static Number** _vala_array_dup3 (Number** self,
                           gssize length);
static void _vala_array_add4 (Number** * array,
                       gint* length,
                       gint* size,
                       Number* value);
static MathFunction** function_manager_array_sort_math_function (FunctionManager* self,
                                                          MathFunction** array,
                                                          gint array_length1,
                                                          gint* result_length1);
static MathFunction** _vala_array_dup4 (MathFunction** self,
                                 gssize length);
static MathFunction** _vala_array_dup5 (MathFunction** self,
                                 gssize length);
static void _vala_array_add5 (MathFunction** * array,
                       gint* length,
                       gint* size,
                       MathFunction* value);
static void function_manager_finalize (GObject * obj);
static GType function_manager_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static gssize _vala_array_length (gpointer array);

static inline gpointer
function_manager_get_instance_private (FunctionManager* self)
{
	return G_STRUCT_MEMBER_P (self, FunctionManager_private_offset);
}

static void
_g_free0_ (gpointer var)
{
#line 25 "../lib/function-manager.vala"
	var = (g_free (var), NULL);
#line 119 "function-manager.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 25 "../lib/function-manager.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 127 "function-manager.c"
}

FunctionManager*
function_manager_construct (GType object_type)
{
	FunctionManager * self = NULL;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	Serializer* _tmp5_;
	Serializer* _tmp6_;
#line 23 "../lib/function-manager.vala"
	self = (FunctionManager*) g_object_new (object_type, NULL);
#line 25 "../lib/function-manager.vala"
	_tmp0_ = g_str_hash;
#line 25 "../lib/function-manager.vala"
	_tmp1_ = g_str_equal;
#line 25 "../lib/function-manager.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_object_unref0_);
#line 25 "../lib/function-manager.vala"
	_g_hash_table_unref0 (self->priv->functions);
#line 25 "../lib/function-manager.vala"
	self->priv->functions = _tmp2_;
#line 26 "../lib/function-manager.vala"
	_tmp3_ = g_get_user_data_dir ();
#line 26 "../lib/function-manager.vala"
	_tmp4_ = g_build_filename (_tmp3_, "gnome-calculator", "custom-functions", NULL);
#line 26 "../lib/function-manager.vala"
	_g_free0 (self->priv->file_name);
#line 26 "../lib/function-manager.vala"
	self->priv->file_name = _tmp4_;
#line 27 "../lib/function-manager.vala"
	_tmp5_ = serializer_new (DISPLAY_FORMAT_SCIENTIFIC, 10, 50);
#line 27 "../lib/function-manager.vala"
	_g_object_unref0 (self->priv->serializer);
#line 27 "../lib/function-manager.vala"
	self->priv->serializer = _tmp5_;
#line 28 "../lib/function-manager.vala"
	_tmp6_ = self->priv->serializer;
#line 28 "../lib/function-manager.vala"
	serializer_set_radix (_tmp6_, (gunichar) '.');
#line 29 "../lib/function-manager.vala"
	function_manager_reload_functions (self);
#line 23 "../lib/function-manager.vala"
	return self;
#line 175 "function-manager.c"
}

FunctionManager*
function_manager_new (void)
{
#line 23 "../lib/function-manager.vala"
	return function_manager_construct (TYPE_FUNCTION_MANAGER);
#line 183 "function-manager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 36 "../lib/function-manager.vala"
	return self ? g_object_ref (self) : NULL;
#line 191 "function-manager.c"
}

FunctionManager*
function_manager_get_default_function_manager (void)
{
	FunctionManager* _tmp0_;
	FunctionManager* _tmp2_;
	FunctionManager* _tmp3_;
	FunctionManager* result;
#line 34 "../lib/function-manager.vala"
	_tmp0_ = default_function_manager;
#line 34 "../lib/function-manager.vala"
	if (_tmp0_ == NULL) {
#line 205 "function-manager.c"
		FunctionManager* _tmp1_;
#line 35 "../lib/function-manager.vala"
		_tmp1_ = function_manager_new ();
#line 35 "../lib/function-manager.vala"
		_g_object_unref0 (default_function_manager);
#line 35 "../lib/function-manager.vala"
		default_function_manager = _tmp1_;
#line 213 "function-manager.c"
	}
#line 36 "../lib/function-manager.vala"
	_tmp2_ = default_function_manager;
#line 36 "../lib/function-manager.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 36 "../lib/function-manager.vala"
	result = _tmp3_;
#line 36 "../lib/function-manager.vala"
	return result;
#line 223 "function-manager.c"
}

static void
function_manager_reload_functions (FunctionManager* self)
{
	GHashTable* _tmp0_;
#line 39 "../lib/function-manager.vala"
	g_return_if_fail (self != NULL);
#line 41 "../lib/function-manager.vala"
	_tmp0_ = self->priv->functions;
#line 41 "../lib/function-manager.vala"
	g_hash_table_remove_all (_tmp0_);
#line 42 "../lib/function-manager.vala"
	function_manager_reload_custom_functions (self);
#line 43 "../lib/function-manager.vala"
	function_manager_reload_builtin_functions (self);
#line 240 "function-manager.c"
}

static void
function_manager_reload_builtin_functions (FunctionManager* self)
{
	gchar* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	BuiltInMathFunction* _tmp3_;
	BuiltInMathFunction* _tmp4_;
	gchar* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	BuiltInMathFunction* _tmp8_;
	BuiltInMathFunction* _tmp9_;
	gchar* _tmp10_;
	gchar** _tmp11_;
	gchar** _tmp12_;
	gint _tmp12__length1;
	BuiltInMathFunction* _tmp13_;
	BuiltInMathFunction* _tmp14_;
	gchar* _tmp15_;
	gchar** _tmp16_;
	gchar** _tmp17_;
	gint _tmp17__length1;
	BuiltInMathFunction* _tmp18_;
	BuiltInMathFunction* _tmp19_;
	gchar* _tmp20_;
	gchar** _tmp21_;
	gchar** _tmp22_;
	gint _tmp22__length1;
	BuiltInMathFunction* _tmp23_;
	BuiltInMathFunction* _tmp24_;
	gchar* _tmp25_;
	gchar** _tmp26_;
	gchar** _tmp27_;
	gint _tmp27__length1;
	BuiltInMathFunction* _tmp28_;
	BuiltInMathFunction* _tmp29_;
	gchar* _tmp30_;
	gchar** _tmp31_;
	gchar** _tmp32_;
	gint _tmp32__length1;
	BuiltInMathFunction* _tmp33_;
	BuiltInMathFunction* _tmp34_;
	gchar* _tmp35_;
	gchar** _tmp36_;
	gchar** _tmp37_;
	gint _tmp37__length1;
	BuiltInMathFunction* _tmp38_;
	BuiltInMathFunction* _tmp39_;
	gchar* _tmp40_;
	gchar** _tmp41_;
	gchar** _tmp42_;
	gint _tmp42__length1;
	BuiltInMathFunction* _tmp43_;
	BuiltInMathFunction* _tmp44_;
	gchar* _tmp45_;
	gchar** _tmp46_;
	gchar** _tmp47_;
	gint _tmp47__length1;
	BuiltInMathFunction* _tmp48_;
	BuiltInMathFunction* _tmp49_;
	gchar* _tmp50_;
	gchar** _tmp51_;
	gchar** _tmp52_;
	gint _tmp52__length1;
	BuiltInMathFunction* _tmp53_;
	BuiltInMathFunction* _tmp54_;
	gchar* _tmp55_;
	gchar** _tmp56_;
	gchar** _tmp57_;
	gint _tmp57__length1;
	BuiltInMathFunction* _tmp58_;
	BuiltInMathFunction* _tmp59_;
	gchar* _tmp60_;
	gchar** _tmp61_;
	gchar** _tmp62_;
	gint _tmp62__length1;
	BuiltInMathFunction* _tmp63_;
	BuiltInMathFunction* _tmp64_;
	gchar* _tmp65_;
	gchar** _tmp66_;
	gchar** _tmp67_;
	gint _tmp67__length1;
	BuiltInMathFunction* _tmp68_;
	BuiltInMathFunction* _tmp69_;
	gchar* _tmp70_;
	gchar** _tmp71_;
	gchar** _tmp72_;
	gint _tmp72__length1;
	BuiltInMathFunction* _tmp73_;
	BuiltInMathFunction* _tmp74_;
	gchar* _tmp75_;
	gchar** _tmp76_;
	gchar** _tmp77_;
	gint _tmp77__length1;
	BuiltInMathFunction* _tmp78_;
	BuiltInMathFunction* _tmp79_;
	gchar* _tmp80_;
	gchar** _tmp81_;
	gchar** _tmp82_;
	gint _tmp82__length1;
	BuiltInMathFunction* _tmp83_;
	BuiltInMathFunction* _tmp84_;
	gchar* _tmp85_;
	gchar** _tmp86_;
	gchar** _tmp87_;
	gint _tmp87__length1;
	BuiltInMathFunction* _tmp88_;
	BuiltInMathFunction* _tmp89_;
	gchar* _tmp90_;
	gchar** _tmp91_;
	gchar** _tmp92_;
	gint _tmp92__length1;
	BuiltInMathFunction* _tmp93_;
	BuiltInMathFunction* _tmp94_;
	gchar* _tmp95_;
	gchar** _tmp96_;
	gchar** _tmp97_;
	gint _tmp97__length1;
	BuiltInMathFunction* _tmp98_;
	BuiltInMathFunction* _tmp99_;
	gchar* _tmp100_;
	gchar** _tmp101_;
	gchar** _tmp102_;
	gint _tmp102__length1;
	BuiltInMathFunction* _tmp103_;
	BuiltInMathFunction* _tmp104_;
	gchar* _tmp105_;
	gchar** _tmp106_;
	gchar** _tmp107_;
	gint _tmp107__length1;
	BuiltInMathFunction* _tmp108_;
	BuiltInMathFunction* _tmp109_;
	gchar* _tmp110_;
	gchar** _tmp111_;
	gchar** _tmp112_;
	gint _tmp112__length1;
	BuiltInMathFunction* _tmp113_;
	BuiltInMathFunction* _tmp114_;
	gchar* _tmp115_;
	gchar** _tmp116_;
	gchar** _tmp117_;
	gint _tmp117__length1;
	BuiltInMathFunction* _tmp118_;
	BuiltInMathFunction* _tmp119_;
	gchar* _tmp120_;
	gchar** _tmp121_;
	gchar** _tmp122_;
	gint _tmp122__length1;
	BuiltInMathFunction* _tmp123_;
	BuiltInMathFunction* _tmp124_;
	gchar* _tmp125_;
	gchar** _tmp126_;
	gchar** _tmp127_;
	gint _tmp127__length1;
	BuiltInMathFunction* _tmp128_;
	BuiltInMathFunction* _tmp129_;
	gchar* _tmp130_;
	gchar** _tmp131_;
	gchar** _tmp132_;
	gint _tmp132__length1;
	BuiltInMathFunction* _tmp133_;
	BuiltInMathFunction* _tmp134_;
	gchar* _tmp135_;
	gchar** _tmp136_;
	gchar** _tmp137_;
	gint _tmp137__length1;
	BuiltInMathFunction* _tmp138_;
	BuiltInMathFunction* _tmp139_;
	gchar* _tmp140_;
	gchar** _tmp141_;
	gchar** _tmp142_;
	gint _tmp142__length1;
	BuiltInMathFunction* _tmp143_;
	BuiltInMathFunction* _tmp144_;
	gchar* _tmp145_;
	gchar** _tmp146_;
	gchar** _tmp147_;
	gint _tmp147__length1;
	BuiltInMathFunction* _tmp148_;
	BuiltInMathFunction* _tmp149_;
	gchar* _tmp150_;
	gchar** _tmp151_;
	gchar** _tmp152_;
	gint _tmp152__length1;
	BuiltInMathFunction* _tmp153_;
	BuiltInMathFunction* _tmp154_;
	gchar* _tmp155_;
	gchar** _tmp156_;
	gchar** _tmp157_;
	gint _tmp157__length1;
	BuiltInMathFunction* _tmp158_;
	BuiltInMathFunction* _tmp159_;
	gchar* _tmp160_;
	gchar** _tmp161_;
	gchar** _tmp162_;
	gint _tmp162__length1;
	BuiltInMathFunction* _tmp163_;
	BuiltInMathFunction* _tmp164_;
	gchar* _tmp165_;
	gchar** _tmp166_;
	gchar** _tmp167_;
	gint _tmp167__length1;
	BuiltInMathFunction* _tmp168_;
	BuiltInMathFunction* _tmp169_;
	gchar* _tmp170_;
	gchar* _tmp171_;
	gchar** _tmp172_;
	gchar** _tmp173_;
	gint _tmp173__length1;
	BuiltInMathFunction* _tmp174_;
	BuiltInMathFunction* _tmp175_;
	gchar* _tmp176_;
	gchar* _tmp177_;
	gchar** _tmp178_;
	gchar** _tmp179_;
	gint _tmp179__length1;
	BuiltInMathFunction* _tmp180_;
	BuiltInMathFunction* _tmp181_;
	gchar* _tmp182_;
	gchar* _tmp183_;
	gchar* _tmp184_;
	gchar** _tmp185_;
	gchar** _tmp186_;
	gint _tmp186__length1;
	BuiltInMathFunction* _tmp187_;
	BuiltInMathFunction* _tmp188_;
	gchar* _tmp189_;
	gchar* _tmp190_;
	gchar* _tmp191_;
	gchar** _tmp192_;
	gchar** _tmp193_;
	gint _tmp193__length1;
	BuiltInMathFunction* _tmp194_;
	BuiltInMathFunction* _tmp195_;
	gchar* _tmp196_;
	gchar* _tmp197_;
	gchar** _tmp198_;
	gchar** _tmp199_;
	gint _tmp199__length1;
	BuiltInMathFunction* _tmp200_;
	BuiltInMathFunction* _tmp201_;
	gchar* _tmp202_;
	gchar* _tmp203_;
	gchar* _tmp204_;
	gchar** _tmp205_;
	gchar** _tmp206_;
	gint _tmp206__length1;
	BuiltInMathFunction* _tmp207_;
	BuiltInMathFunction* _tmp208_;
	gchar* _tmp209_;
	gchar* _tmp210_;
	gchar** _tmp211_;
	gchar** _tmp212_;
	gint _tmp212__length1;
	BuiltInMathFunction* _tmp213_;
	BuiltInMathFunction* _tmp214_;
	gchar* _tmp215_;
	gchar* _tmp216_;
	gchar* _tmp217_;
	gchar** _tmp218_;
	gchar** _tmp219_;
	gint _tmp219__length1;
	BuiltInMathFunction* _tmp220_;
	BuiltInMathFunction* _tmp221_;
	gchar* _tmp222_;
	gchar* _tmp223_;
	gchar* _tmp224_;
	gchar** _tmp225_;
	gchar** _tmp226_;
	gint _tmp226__length1;
	BuiltInMathFunction* _tmp227_;
	BuiltInMathFunction* _tmp228_;
	gchar* _tmp229_;
	gchar* _tmp230_;
	gchar* _tmp231_;
	gchar** _tmp232_;
	gchar** _tmp233_;
	gint _tmp233__length1;
	BuiltInMathFunction* _tmp234_;
	BuiltInMathFunction* _tmp235_;
	gchar* _tmp236_;
	gchar* _tmp237_;
	gchar* _tmp238_;
	gchar** _tmp239_;
	gchar** _tmp240_;
	gint _tmp240__length1;
	BuiltInMathFunction* _tmp241_;
	BuiltInMathFunction* _tmp242_;
	gchar* _tmp243_;
	gchar* _tmp244_;
	gchar* _tmp245_;
	gchar** _tmp246_;
	gchar** _tmp247_;
	gint _tmp247__length1;
	BuiltInMathFunction* _tmp248_;
	BuiltInMathFunction* _tmp249_;
	gchar* _tmp250_;
	gchar* _tmp251_;
	gchar* _tmp252_;
	gchar** _tmp253_;
	gchar** _tmp254_;
	gint _tmp254__length1;
	BuiltInMathFunction* _tmp255_;
	BuiltInMathFunction* _tmp256_;
	gchar* _tmp257_;
	gchar* _tmp258_;
	gchar* _tmp259_;
	gchar** _tmp260_;
	gchar** _tmp261_;
	gint _tmp261__length1;
	BuiltInMathFunction* _tmp262_;
	BuiltInMathFunction* _tmp263_;
	gchar* _tmp264_;
	gchar* _tmp265_;
	gchar* _tmp266_;
	gchar** _tmp267_;
	gchar** _tmp268_;
	gint _tmp268__length1;
	BuiltInMathFunction* _tmp269_;
	BuiltInMathFunction* _tmp270_;
	gchar* _tmp271_;
	gchar* _tmp272_;
	gchar* _tmp273_;
	gchar** _tmp274_;
	gchar** _tmp275_;
	gint _tmp275__length1;
	BuiltInMathFunction* _tmp276_;
	BuiltInMathFunction* _tmp277_;
	gchar* _tmp278_;
	gchar* _tmp279_;
	gchar* _tmp280_;
	gchar** _tmp281_;
	gchar** _tmp282_;
	gint _tmp282__length1;
	BuiltInMathFunction* _tmp283_;
	BuiltInMathFunction* _tmp284_;
#line 46 "../lib/function-manager.vala"
	g_return_if_fail (self != NULL);
#line 48 "../lib/function-manager.vala"
	_tmp0_ = g_strdup ("x");
#line 48 "../lib/function-manager.vala"
	_tmp1_ = g_new0 (gchar*, 1 + 1);
#line 48 "../lib/function-manager.vala"
	_tmp1_[0] = _tmp0_;
#line 48 "../lib/function-manager.vala"
	_tmp2_ = _tmp1_;
#line 48 "../lib/function-manager.vala"
	_tmp2__length1 = 1;
#line 48 "../lib/function-manager.vala"
	_tmp3_ = built_in_math_function_new ("log", _ ("Logarithm"), _tmp2_, 1);
#line 48 "../lib/function-manager.vala"
	_tmp4_ = _tmp3_;
#line 48 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp4_);
#line 48 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp4_);
#line 48 "../lib/function-manager.vala"
	_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
#line 49 "../lib/function-manager.vala"
	_tmp5_ = g_strdup ("x");
#line 49 "../lib/function-manager.vala"
	_tmp6_ = g_new0 (gchar*, 1 + 1);
#line 49 "../lib/function-manager.vala"
	_tmp6_[0] = _tmp5_;
#line 49 "../lib/function-manager.vala"
	_tmp7_ = _tmp6_;
#line 49 "../lib/function-manager.vala"
	_tmp7__length1 = 1;
#line 49 "../lib/function-manager.vala"
	_tmp8_ = built_in_math_function_new ("ln", _ ("Natural Logarithm"), _tmp7_, 1);
#line 49 "../lib/function-manager.vala"
	_tmp9_ = _tmp8_;
#line 49 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp9_);
#line 49 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp9_);
#line 49 "../lib/function-manager.vala"
	_tmp7_ = (_vala_array_free (_tmp7_, _tmp7__length1, (GDestroyNotify) g_free), NULL);
#line 50 "../lib/function-manager.vala"
	_tmp10_ = g_strdup ("x");
#line 50 "../lib/function-manager.vala"
	_tmp11_ = g_new0 (gchar*, 1 + 1);
#line 50 "../lib/function-manager.vala"
	_tmp11_[0] = _tmp10_;
#line 50 "../lib/function-manager.vala"
	_tmp12_ = _tmp11_;
#line 50 "../lib/function-manager.vala"
	_tmp12__length1 = 1;
#line 50 "../lib/function-manager.vala"
	_tmp13_ = built_in_math_function_new ("sqrt", _ ("Square Root"), _tmp12_, 1);
#line 50 "../lib/function-manager.vala"
	_tmp14_ = _tmp13_;
#line 50 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp14_);
#line 50 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp14_);
#line 50 "../lib/function-manager.vala"
	_tmp12_ = (_vala_array_free (_tmp12_, _tmp12__length1, (GDestroyNotify) g_free), NULL);
#line 51 "../lib/function-manager.vala"
	_tmp15_ = g_strdup ("x");
#line 51 "../lib/function-manager.vala"
	_tmp16_ = g_new0 (gchar*, 1 + 1);
#line 51 "../lib/function-manager.vala"
	_tmp16_[0] = _tmp15_;
#line 51 "../lib/function-manager.vala"
	_tmp17_ = _tmp16_;
#line 51 "../lib/function-manager.vala"
	_tmp17__length1 = 1;
#line 51 "../lib/function-manager.vala"
	_tmp18_ = built_in_math_function_new ("abs", _ ("Absolute Value"), _tmp17_, 1);
#line 51 "../lib/function-manager.vala"
	_tmp19_ = _tmp18_;
#line 51 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp19_);
#line 51 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp19_);
#line 51 "../lib/function-manager.vala"
	_tmp17_ = (_vala_array_free (_tmp17_, _tmp17__length1, (GDestroyNotify) g_free), NULL);
#line 52 "../lib/function-manager.vala"
	_tmp20_ = g_strdup ("x");
#line 52 "../lib/function-manager.vala"
	_tmp21_ = g_new0 (gchar*, 1 + 1);
#line 52 "../lib/function-manager.vala"
	_tmp21_[0] = _tmp20_;
#line 52 "../lib/function-manager.vala"
	_tmp22_ = _tmp21_;
#line 52 "../lib/function-manager.vala"
	_tmp22__length1 = 1;
#line 52 "../lib/function-manager.vala"
	_tmp23_ = built_in_math_function_new ("sgn", _ ("Signum"), _tmp22_, 1);
#line 52 "../lib/function-manager.vala"
	_tmp24_ = _tmp23_;
#line 52 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp24_);
#line 52 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp24_);
#line 52 "../lib/function-manager.vala"
	_tmp22_ = (_vala_array_free (_tmp22_, _tmp22__length1, (GDestroyNotify) g_free), NULL);
#line 53 "../lib/function-manager.vala"
	_tmp25_ = g_strdup ("x");
#line 53 "../lib/function-manager.vala"
	_tmp26_ = g_new0 (gchar*, 1 + 1);
#line 53 "../lib/function-manager.vala"
	_tmp26_[0] = _tmp25_;
#line 53 "../lib/function-manager.vala"
	_tmp27_ = _tmp26_;
#line 53 "../lib/function-manager.vala"
	_tmp27__length1 = 1;
#line 53 "../lib/function-manager.vala"
	_tmp28_ = built_in_math_function_new ("arg", _ ("Complex Argument"), _tmp27_, 1);
#line 53 "../lib/function-manager.vala"
	_tmp29_ = _tmp28_;
#line 53 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp29_);
#line 53 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp29_);
#line 53 "../lib/function-manager.vala"
	_tmp27_ = (_vala_array_free (_tmp27_, _tmp27__length1, (GDestroyNotify) g_free), NULL);
#line 54 "../lib/function-manager.vala"
	_tmp30_ = g_strdup ("x");
#line 54 "../lib/function-manager.vala"
	_tmp31_ = g_new0 (gchar*, 1 + 1);
#line 54 "../lib/function-manager.vala"
	_tmp31_[0] = _tmp30_;
#line 54 "../lib/function-manager.vala"
	_tmp32_ = _tmp31_;
#line 54 "../lib/function-manager.vala"
	_tmp32__length1 = 1;
#line 54 "../lib/function-manager.vala"
	_tmp33_ = built_in_math_function_new ("conj", _ ("Complex Conjugate"), _tmp32_, 1);
#line 54 "../lib/function-manager.vala"
	_tmp34_ = _tmp33_;
#line 54 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp34_);
#line 54 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp34_);
#line 54 "../lib/function-manager.vala"
	_tmp32_ = (_vala_array_free (_tmp32_, _tmp32__length1, (GDestroyNotify) g_free), NULL);
#line 55 "../lib/function-manager.vala"
	_tmp35_ = g_strdup ("x");
#line 55 "../lib/function-manager.vala"
	_tmp36_ = g_new0 (gchar*, 1 + 1);
#line 55 "../lib/function-manager.vala"
	_tmp36_[0] = _tmp35_;
#line 55 "../lib/function-manager.vala"
	_tmp37_ = _tmp36_;
#line 55 "../lib/function-manager.vala"
	_tmp37__length1 = 1;
#line 55 "../lib/function-manager.vala"
	_tmp38_ = built_in_math_function_new ("int", _ ("Integer Component"), _tmp37_, 1);
#line 55 "../lib/function-manager.vala"
	_tmp39_ = _tmp38_;
#line 55 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp39_);
#line 55 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp39_);
#line 55 "../lib/function-manager.vala"
	_tmp37_ = (_vala_array_free (_tmp37_, _tmp37__length1, (GDestroyNotify) g_free), NULL);
#line 56 "../lib/function-manager.vala"
	_tmp40_ = g_strdup ("x");
#line 56 "../lib/function-manager.vala"
	_tmp41_ = g_new0 (gchar*, 1 + 1);
#line 56 "../lib/function-manager.vala"
	_tmp41_[0] = _tmp40_;
#line 56 "../lib/function-manager.vala"
	_tmp42_ = _tmp41_;
#line 56 "../lib/function-manager.vala"
	_tmp42__length1 = 1;
#line 56 "../lib/function-manager.vala"
	_tmp43_ = built_in_math_function_new ("frac", _ ("Fractional Component"), _tmp42_, 1);
#line 56 "../lib/function-manager.vala"
	_tmp44_ = _tmp43_;
#line 56 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp44_);
#line 56 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp44_);
#line 56 "../lib/function-manager.vala"
	_tmp42_ = (_vala_array_free (_tmp42_, _tmp42__length1, (GDestroyNotify) g_free), NULL);
#line 57 "../lib/function-manager.vala"
	_tmp45_ = g_strdup ("x");
#line 57 "../lib/function-manager.vala"
	_tmp46_ = g_new0 (gchar*, 1 + 1);
#line 57 "../lib/function-manager.vala"
	_tmp46_[0] = _tmp45_;
#line 57 "../lib/function-manager.vala"
	_tmp47_ = _tmp46_;
#line 57 "../lib/function-manager.vala"
	_tmp47__length1 = 1;
#line 57 "../lib/function-manager.vala"
	_tmp48_ = built_in_math_function_new ("floor", _ ("Floor"), _tmp47_, 1);
#line 57 "../lib/function-manager.vala"
	_tmp49_ = _tmp48_;
#line 57 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp49_);
#line 57 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp49_);
#line 57 "../lib/function-manager.vala"
	_tmp47_ = (_vala_array_free (_tmp47_, _tmp47__length1, (GDestroyNotify) g_free), NULL);
#line 58 "../lib/function-manager.vala"
	_tmp50_ = g_strdup ("x");
#line 58 "../lib/function-manager.vala"
	_tmp51_ = g_new0 (gchar*, 1 + 1);
#line 58 "../lib/function-manager.vala"
	_tmp51_[0] = _tmp50_;
#line 58 "../lib/function-manager.vala"
	_tmp52_ = _tmp51_;
#line 58 "../lib/function-manager.vala"
	_tmp52__length1 = 1;
#line 58 "../lib/function-manager.vala"
	_tmp53_ = built_in_math_function_new ("ceil", _ ("Ceiling"), _tmp52_, 1);
#line 58 "../lib/function-manager.vala"
	_tmp54_ = _tmp53_;
#line 58 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp54_);
#line 58 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp54_);
#line 58 "../lib/function-manager.vala"
	_tmp52_ = (_vala_array_free (_tmp52_, _tmp52__length1, (GDestroyNotify) g_free), NULL);
#line 59 "../lib/function-manager.vala"
	_tmp55_ = g_strdup ("x");
#line 59 "../lib/function-manager.vala"
	_tmp56_ = g_new0 (gchar*, 1 + 1);
#line 59 "../lib/function-manager.vala"
	_tmp56_[0] = _tmp55_;
#line 59 "../lib/function-manager.vala"
	_tmp57_ = _tmp56_;
#line 59 "../lib/function-manager.vala"
	_tmp57__length1 = 1;
#line 59 "../lib/function-manager.vala"
	_tmp58_ = built_in_math_function_new ("round", _ ("Round"), _tmp57_, 1);
#line 59 "../lib/function-manager.vala"
	_tmp59_ = _tmp58_;
#line 59 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp59_);
#line 59 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp59_);
#line 59 "../lib/function-manager.vala"
	_tmp57_ = (_vala_array_free (_tmp57_, _tmp57__length1, (GDestroyNotify) g_free), NULL);
#line 60 "../lib/function-manager.vala"
	_tmp60_ = g_strdup ("x");
#line 60 "../lib/function-manager.vala"
	_tmp61_ = g_new0 (gchar*, 1 + 1);
#line 60 "../lib/function-manager.vala"
	_tmp61_[0] = _tmp60_;
#line 60 "../lib/function-manager.vala"
	_tmp62_ = _tmp61_;
#line 60 "../lib/function-manager.vala"
	_tmp62__length1 = 1;
#line 60 "../lib/function-manager.vala"
	_tmp63_ = built_in_math_function_new ("re", _ ("Real Component"), _tmp62_, 1);
#line 60 "../lib/function-manager.vala"
	_tmp64_ = _tmp63_;
#line 60 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp64_);
#line 60 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp64_);
#line 60 "../lib/function-manager.vala"
	_tmp62_ = (_vala_array_free (_tmp62_, _tmp62__length1, (GDestroyNotify) g_free), NULL);
#line 61 "../lib/function-manager.vala"
	_tmp65_ = g_strdup ("x");
#line 61 "../lib/function-manager.vala"
	_tmp66_ = g_new0 (gchar*, 1 + 1);
#line 61 "../lib/function-manager.vala"
	_tmp66_[0] = _tmp65_;
#line 61 "../lib/function-manager.vala"
	_tmp67_ = _tmp66_;
#line 61 "../lib/function-manager.vala"
	_tmp67__length1 = 1;
#line 61 "../lib/function-manager.vala"
	_tmp68_ = built_in_math_function_new ("im", _ ("Imaginary Component"), _tmp67_, 1);
#line 61 "../lib/function-manager.vala"
	_tmp69_ = _tmp68_;
#line 61 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp69_);
#line 61 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp69_);
#line 61 "../lib/function-manager.vala"
	_tmp67_ = (_vala_array_free (_tmp67_, _tmp67__length1, (GDestroyNotify) g_free), NULL);
#line 62 "../lib/function-manager.vala"
	_tmp70_ = g_strdup ("x");
#line 62 "../lib/function-manager.vala"
	_tmp71_ = g_new0 (gchar*, 1 + 1);
#line 62 "../lib/function-manager.vala"
	_tmp71_[0] = _tmp70_;
#line 62 "../lib/function-manager.vala"
	_tmp72_ = _tmp71_;
#line 62 "../lib/function-manager.vala"
	_tmp72__length1 = 1;
#line 62 "../lib/function-manager.vala"
	_tmp73_ = built_in_math_function_new ("sin", _ ("Sine"), _tmp72_, 1);
#line 62 "../lib/function-manager.vala"
	_tmp74_ = _tmp73_;
#line 62 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp74_);
#line 62 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp74_);
#line 62 "../lib/function-manager.vala"
	_tmp72_ = (_vala_array_free (_tmp72_, _tmp72__length1, (GDestroyNotify) g_free), NULL);
#line 63 "../lib/function-manager.vala"
	_tmp75_ = g_strdup ("x");
#line 63 "../lib/function-manager.vala"
	_tmp76_ = g_new0 (gchar*, 1 + 1);
#line 63 "../lib/function-manager.vala"
	_tmp76_[0] = _tmp75_;
#line 63 "../lib/function-manager.vala"
	_tmp77_ = _tmp76_;
#line 63 "../lib/function-manager.vala"
	_tmp77__length1 = 1;
#line 63 "../lib/function-manager.vala"
	_tmp78_ = built_in_math_function_new ("cos", _ ("Cosine"), _tmp77_, 1);
#line 63 "../lib/function-manager.vala"
	_tmp79_ = _tmp78_;
#line 63 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp79_);
#line 63 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp79_);
#line 63 "../lib/function-manager.vala"
	_tmp77_ = (_vala_array_free (_tmp77_, _tmp77__length1, (GDestroyNotify) g_free), NULL);
#line 64 "../lib/function-manager.vala"
	_tmp80_ = g_strdup ("x");
#line 64 "../lib/function-manager.vala"
	_tmp81_ = g_new0 (gchar*, 1 + 1);
#line 64 "../lib/function-manager.vala"
	_tmp81_[0] = _tmp80_;
#line 64 "../lib/function-manager.vala"
	_tmp82_ = _tmp81_;
#line 64 "../lib/function-manager.vala"
	_tmp82__length1 = 1;
#line 64 "../lib/function-manager.vala"
	_tmp83_ = built_in_math_function_new ("tan", _ ("Tangent"), _tmp82_, 1);
#line 64 "../lib/function-manager.vala"
	_tmp84_ = _tmp83_;
#line 64 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp84_);
#line 64 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp84_);
#line 64 "../lib/function-manager.vala"
	_tmp82_ = (_vala_array_free (_tmp82_, _tmp82__length1, (GDestroyNotify) g_free), NULL);
#line 65 "../lib/function-manager.vala"
	_tmp85_ = g_strdup ("x");
#line 65 "../lib/function-manager.vala"
	_tmp86_ = g_new0 (gchar*, 1 + 1);
#line 65 "../lib/function-manager.vala"
	_tmp86_[0] = _tmp85_;
#line 65 "../lib/function-manager.vala"
	_tmp87_ = _tmp86_;
#line 65 "../lib/function-manager.vala"
	_tmp87__length1 = 1;
#line 65 "../lib/function-manager.vala"
	_tmp88_ = built_in_math_function_new ("asin", _ ("Inverse Sine"), _tmp87_, 1);
#line 65 "../lib/function-manager.vala"
	_tmp89_ = _tmp88_;
#line 65 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp89_);
#line 65 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp89_);
#line 65 "../lib/function-manager.vala"
	_tmp87_ = (_vala_array_free (_tmp87_, _tmp87__length1, (GDestroyNotify) g_free), NULL);
#line 66 "../lib/function-manager.vala"
	_tmp90_ = g_strdup ("x");
#line 66 "../lib/function-manager.vala"
	_tmp91_ = g_new0 (gchar*, 1 + 1);
#line 66 "../lib/function-manager.vala"
	_tmp91_[0] = _tmp90_;
#line 66 "../lib/function-manager.vala"
	_tmp92_ = _tmp91_;
#line 66 "../lib/function-manager.vala"
	_tmp92__length1 = 1;
#line 66 "../lib/function-manager.vala"
	_tmp93_ = built_in_math_function_new ("acos", _ ("Inverse Cosine"), _tmp92_, 1);
#line 66 "../lib/function-manager.vala"
	_tmp94_ = _tmp93_;
#line 66 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp94_);
#line 66 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp94_);
#line 66 "../lib/function-manager.vala"
	_tmp92_ = (_vala_array_free (_tmp92_, _tmp92__length1, (GDestroyNotify) g_free), NULL);
#line 67 "../lib/function-manager.vala"
	_tmp95_ = g_strdup ("x");
#line 67 "../lib/function-manager.vala"
	_tmp96_ = g_new0 (gchar*, 1 + 1);
#line 67 "../lib/function-manager.vala"
	_tmp96_[0] = _tmp95_;
#line 67 "../lib/function-manager.vala"
	_tmp97_ = _tmp96_;
#line 67 "../lib/function-manager.vala"
	_tmp97__length1 = 1;
#line 67 "../lib/function-manager.vala"
	_tmp98_ = built_in_math_function_new ("atan", _ ("Inverse Tangent"), _tmp97_, 1);
#line 67 "../lib/function-manager.vala"
	_tmp99_ = _tmp98_;
#line 67 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp99_);
#line 67 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp99_);
#line 67 "../lib/function-manager.vala"
	_tmp97_ = (_vala_array_free (_tmp97_, _tmp97__length1, (GDestroyNotify) g_free), NULL);
#line 68 "../lib/function-manager.vala"
	_tmp100_ = g_strdup ("x");
#line 68 "../lib/function-manager.vala"
	_tmp101_ = g_new0 (gchar*, 1 + 1);
#line 68 "../lib/function-manager.vala"
	_tmp101_[0] = _tmp100_;
#line 68 "../lib/function-manager.vala"
	_tmp102_ = _tmp101_;
#line 68 "../lib/function-manager.vala"
	_tmp102__length1 = 1;
#line 68 "../lib/function-manager.vala"
	_tmp103_ = built_in_math_function_new ("sin⁻¹", _ ("Inverse Sine"), _tmp102_, 1);
#line 68 "../lib/function-manager.vala"
	_tmp104_ = _tmp103_;
#line 68 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp104_);
#line 68 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp104_);
#line 68 "../lib/function-manager.vala"
	_tmp102_ = (_vala_array_free (_tmp102_, _tmp102__length1, (GDestroyNotify) g_free), NULL);
#line 69 "../lib/function-manager.vala"
	_tmp105_ = g_strdup ("x");
#line 69 "../lib/function-manager.vala"
	_tmp106_ = g_new0 (gchar*, 1 + 1);
#line 69 "../lib/function-manager.vala"
	_tmp106_[0] = _tmp105_;
#line 69 "../lib/function-manager.vala"
	_tmp107_ = _tmp106_;
#line 69 "../lib/function-manager.vala"
	_tmp107__length1 = 1;
#line 69 "../lib/function-manager.vala"
	_tmp108_ = built_in_math_function_new ("cos⁻¹", _ ("Inverse Cosine"), _tmp107_, 1);
#line 69 "../lib/function-manager.vala"
	_tmp109_ = _tmp108_;
#line 69 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp109_);
#line 69 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp109_);
#line 69 "../lib/function-manager.vala"
	_tmp107_ = (_vala_array_free (_tmp107_, _tmp107__length1, (GDestroyNotify) g_free), NULL);
#line 70 "../lib/function-manager.vala"
	_tmp110_ = g_strdup ("x");
#line 70 "../lib/function-manager.vala"
	_tmp111_ = g_new0 (gchar*, 1 + 1);
#line 70 "../lib/function-manager.vala"
	_tmp111_[0] = _tmp110_;
#line 70 "../lib/function-manager.vala"
	_tmp112_ = _tmp111_;
#line 70 "../lib/function-manager.vala"
	_tmp112__length1 = 1;
#line 70 "../lib/function-manager.vala"
	_tmp113_ = built_in_math_function_new ("tan⁻¹", _ ("Inverse Tangent"), _tmp112_, 1);
#line 70 "../lib/function-manager.vala"
	_tmp114_ = _tmp113_;
#line 70 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp114_);
#line 70 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp114_);
#line 70 "../lib/function-manager.vala"
	_tmp112_ = (_vala_array_free (_tmp112_, _tmp112__length1, (GDestroyNotify) g_free), NULL);
#line 71 "../lib/function-manager.vala"
	_tmp115_ = g_strdup ("x");
#line 71 "../lib/function-manager.vala"
	_tmp116_ = g_new0 (gchar*, 1 + 1);
#line 71 "../lib/function-manager.vala"
	_tmp116_[0] = _tmp115_;
#line 71 "../lib/function-manager.vala"
	_tmp117_ = _tmp116_;
#line 71 "../lib/function-manager.vala"
	_tmp117__length1 = 1;
#line 71 "../lib/function-manager.vala"
	_tmp118_ = built_in_math_function_new ("sinh", _ ("Hyperbolic Sine"), _tmp117_, 1);
#line 71 "../lib/function-manager.vala"
	_tmp119_ = _tmp118_;
#line 71 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp119_);
#line 71 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp119_);
#line 71 "../lib/function-manager.vala"
	_tmp117_ = (_vala_array_free (_tmp117_, _tmp117__length1, (GDestroyNotify) g_free), NULL);
#line 72 "../lib/function-manager.vala"
	_tmp120_ = g_strdup ("x");
#line 72 "../lib/function-manager.vala"
	_tmp121_ = g_new0 (gchar*, 1 + 1);
#line 72 "../lib/function-manager.vala"
	_tmp121_[0] = _tmp120_;
#line 72 "../lib/function-manager.vala"
	_tmp122_ = _tmp121_;
#line 72 "../lib/function-manager.vala"
	_tmp122__length1 = 1;
#line 72 "../lib/function-manager.vala"
	_tmp123_ = built_in_math_function_new ("cosh", _ ("Hyperbolic Cosine"), _tmp122_, 1);
#line 72 "../lib/function-manager.vala"
	_tmp124_ = _tmp123_;
#line 72 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp124_);
#line 72 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp124_);
#line 72 "../lib/function-manager.vala"
	_tmp122_ = (_vala_array_free (_tmp122_, _tmp122__length1, (GDestroyNotify) g_free), NULL);
#line 73 "../lib/function-manager.vala"
	_tmp125_ = g_strdup ("x");
#line 73 "../lib/function-manager.vala"
	_tmp126_ = g_new0 (gchar*, 1 + 1);
#line 73 "../lib/function-manager.vala"
	_tmp126_[0] = _tmp125_;
#line 73 "../lib/function-manager.vala"
	_tmp127_ = _tmp126_;
#line 73 "../lib/function-manager.vala"
	_tmp127__length1 = 1;
#line 73 "../lib/function-manager.vala"
	_tmp128_ = built_in_math_function_new ("tanh", _ ("Hyperbolic Tangent"), _tmp127_, 1);
#line 73 "../lib/function-manager.vala"
	_tmp129_ = _tmp128_;
#line 73 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp129_);
#line 73 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp129_);
#line 73 "../lib/function-manager.vala"
	_tmp127_ = (_vala_array_free (_tmp127_, _tmp127__length1, (GDestroyNotify) g_free), NULL);
#line 74 "../lib/function-manager.vala"
	_tmp130_ = g_strdup ("x");
#line 74 "../lib/function-manager.vala"
	_tmp131_ = g_new0 (gchar*, 1 + 1);
#line 74 "../lib/function-manager.vala"
	_tmp131_[0] = _tmp130_;
#line 74 "../lib/function-manager.vala"
	_tmp132_ = _tmp131_;
#line 74 "../lib/function-manager.vala"
	_tmp132__length1 = 1;
#line 74 "../lib/function-manager.vala"
	_tmp133_ = built_in_math_function_new ("sinh⁻¹", _ ("Inverse Hyperbolic Sine"), _tmp132_, 1);
#line 74 "../lib/function-manager.vala"
	_tmp134_ = _tmp133_;
#line 74 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp134_);
#line 74 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp134_);
#line 74 "../lib/function-manager.vala"
	_tmp132_ = (_vala_array_free (_tmp132_, _tmp132__length1, (GDestroyNotify) g_free), NULL);
#line 75 "../lib/function-manager.vala"
	_tmp135_ = g_strdup ("x");
#line 75 "../lib/function-manager.vala"
	_tmp136_ = g_new0 (gchar*, 1 + 1);
#line 75 "../lib/function-manager.vala"
	_tmp136_[0] = _tmp135_;
#line 75 "../lib/function-manager.vala"
	_tmp137_ = _tmp136_;
#line 75 "../lib/function-manager.vala"
	_tmp137__length1 = 1;
#line 75 "../lib/function-manager.vala"
	_tmp138_ = built_in_math_function_new ("cosh⁻¹", _ ("Inverse Hyperbolic Cosine"), _tmp137_, 1);
#line 75 "../lib/function-manager.vala"
	_tmp139_ = _tmp138_;
#line 75 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp139_);
#line 75 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp139_);
#line 75 "../lib/function-manager.vala"
	_tmp137_ = (_vala_array_free (_tmp137_, _tmp137__length1, (GDestroyNotify) g_free), NULL);
#line 76 "../lib/function-manager.vala"
	_tmp140_ = g_strdup ("x");
#line 76 "../lib/function-manager.vala"
	_tmp141_ = g_new0 (gchar*, 1 + 1);
#line 76 "../lib/function-manager.vala"
	_tmp141_[0] = _tmp140_;
#line 76 "../lib/function-manager.vala"
	_tmp142_ = _tmp141_;
#line 76 "../lib/function-manager.vala"
	_tmp142__length1 = 1;
#line 76 "../lib/function-manager.vala"
	_tmp143_ = built_in_math_function_new ("tanh⁻¹", _ ("Inverse Hyperbolic Tangent"), _tmp142_, 1);
#line 76 "../lib/function-manager.vala"
	_tmp144_ = _tmp143_;
#line 76 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp144_);
#line 76 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp144_);
#line 76 "../lib/function-manager.vala"
	_tmp142_ = (_vala_array_free (_tmp142_, _tmp142__length1, (GDestroyNotify) g_free), NULL);
#line 77 "../lib/function-manager.vala"
	_tmp145_ = g_strdup ("x");
#line 77 "../lib/function-manager.vala"
	_tmp146_ = g_new0 (gchar*, 1 + 1);
#line 77 "../lib/function-manager.vala"
	_tmp146_[0] = _tmp145_;
#line 77 "../lib/function-manager.vala"
	_tmp147_ = _tmp146_;
#line 77 "../lib/function-manager.vala"
	_tmp147__length1 = 1;
#line 77 "../lib/function-manager.vala"
	_tmp148_ = built_in_math_function_new ("asinh", _ ("Inverse Hyperbolic Sine"), _tmp147_, 1);
#line 77 "../lib/function-manager.vala"
	_tmp149_ = _tmp148_;
#line 77 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp149_);
#line 77 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp149_);
#line 77 "../lib/function-manager.vala"
	_tmp147_ = (_vala_array_free (_tmp147_, _tmp147__length1, (GDestroyNotify) g_free), NULL);
#line 78 "../lib/function-manager.vala"
	_tmp150_ = g_strdup ("x");
#line 78 "../lib/function-manager.vala"
	_tmp151_ = g_new0 (gchar*, 1 + 1);
#line 78 "../lib/function-manager.vala"
	_tmp151_[0] = _tmp150_;
#line 78 "../lib/function-manager.vala"
	_tmp152_ = _tmp151_;
#line 78 "../lib/function-manager.vala"
	_tmp152__length1 = 1;
#line 78 "../lib/function-manager.vala"
	_tmp153_ = built_in_math_function_new ("acosh", _ ("Inverse Hyperbolic Cosine"), _tmp152_, 1);
#line 78 "../lib/function-manager.vala"
	_tmp154_ = _tmp153_;
#line 78 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp154_);
#line 78 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp154_);
#line 78 "../lib/function-manager.vala"
	_tmp152_ = (_vala_array_free (_tmp152_, _tmp152__length1, (GDestroyNotify) g_free), NULL);
#line 79 "../lib/function-manager.vala"
	_tmp155_ = g_strdup ("x");
#line 79 "../lib/function-manager.vala"
	_tmp156_ = g_new0 (gchar*, 1 + 1);
#line 79 "../lib/function-manager.vala"
	_tmp156_[0] = _tmp155_;
#line 79 "../lib/function-manager.vala"
	_tmp157_ = _tmp156_;
#line 79 "../lib/function-manager.vala"
	_tmp157__length1 = 1;
#line 79 "../lib/function-manager.vala"
	_tmp158_ = built_in_math_function_new ("atanh", _ ("Inverse Hyperbolic Tangent"), _tmp157_, 1);
#line 79 "../lib/function-manager.vala"
	_tmp159_ = _tmp158_;
#line 79 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp159_);
#line 79 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp159_);
#line 79 "../lib/function-manager.vala"
	_tmp157_ = (_vala_array_free (_tmp157_, _tmp157__length1, (GDestroyNotify) g_free), NULL);
#line 80 "../lib/function-manager.vala"
	_tmp160_ = g_strdup ("x");
#line 80 "../lib/function-manager.vala"
	_tmp161_ = g_new0 (gchar*, 1 + 1);
#line 80 "../lib/function-manager.vala"
	_tmp161_[0] = _tmp160_;
#line 80 "../lib/function-manager.vala"
	_tmp162_ = _tmp161_;
#line 80 "../lib/function-manager.vala"
	_tmp162__length1 = 1;
#line 80 "../lib/function-manager.vala"
	_tmp163_ = built_in_math_function_new ("ones", _ ("One’s Complement"), _tmp162_, 1);
#line 80 "../lib/function-manager.vala"
	_tmp164_ = _tmp163_;
#line 80 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp164_);
#line 80 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp164_);
#line 80 "../lib/function-manager.vala"
	_tmp162_ = (_vala_array_free (_tmp162_, _tmp162__length1, (GDestroyNotify) g_free), NULL);
#line 81 "../lib/function-manager.vala"
	_tmp165_ = g_strdup ("x");
#line 81 "../lib/function-manager.vala"
	_tmp166_ = g_new0 (gchar*, 1 + 1);
#line 81 "../lib/function-manager.vala"
	_tmp166_[0] = _tmp165_;
#line 81 "../lib/function-manager.vala"
	_tmp167_ = _tmp166_;
#line 81 "../lib/function-manager.vala"
	_tmp167__length1 = 1;
#line 81 "../lib/function-manager.vala"
	_tmp168_ = built_in_math_function_new ("twos", _ ("Two’s Complement"), _tmp167_, 1);
#line 81 "../lib/function-manager.vala"
	_tmp169_ = _tmp168_;
#line 81 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp169_);
#line 81 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp169_);
#line 81 "../lib/function-manager.vala"
	_tmp167_ = (_vala_array_free (_tmp167_, _tmp167__length1, (GDestroyNotify) g_free), NULL);
#line 82 "../lib/function-manager.vala"
	_tmp170_ = g_strdup ("n");
#line 82 "../lib/function-manager.vala"
	_tmp171_ = g_strdup ("r");
#line 82 "../lib/function-manager.vala"
	_tmp172_ = g_new0 (gchar*, 2 + 1);
#line 82 "../lib/function-manager.vala"
	_tmp172_[0] = _tmp170_;
#line 82 "../lib/function-manager.vala"
	_tmp172_[1] = _tmp171_;
#line 82 "../lib/function-manager.vala"
	_tmp173_ = _tmp172_;
#line 82 "../lib/function-manager.vala"
	_tmp173__length1 = 2;
#line 82 "../lib/function-manager.vala"
	_tmp174_ = built_in_math_function_new ("ncr", _ ("Combination"), _tmp173_, 2);
#line 82 "../lib/function-manager.vala"
	_tmp175_ = _tmp174_;
#line 82 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp175_);
#line 82 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp175_);
#line 82 "../lib/function-manager.vala"
	_tmp173_ = (_vala_array_free (_tmp173_, _tmp173__length1, (GDestroyNotify) g_free), NULL);
#line 83 "../lib/function-manager.vala"
	_tmp176_ = g_strdup ("n");
#line 83 "../lib/function-manager.vala"
	_tmp177_ = g_strdup ("r");
#line 83 "../lib/function-manager.vala"
	_tmp178_ = g_new0 (gchar*, 2 + 1);
#line 83 "../lib/function-manager.vala"
	_tmp178_[0] = _tmp176_;
#line 83 "../lib/function-manager.vala"
	_tmp178_[1] = _tmp177_;
#line 83 "../lib/function-manager.vala"
	_tmp179_ = _tmp178_;
#line 83 "../lib/function-manager.vala"
	_tmp179__length1 = 2;
#line 83 "../lib/function-manager.vala"
	_tmp180_ = built_in_math_function_new ("npr", _ ("Permutation"), _tmp179_, 2);
#line 83 "../lib/function-manager.vala"
	_tmp181_ = _tmp180_;
#line 83 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp181_);
#line 83 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp181_);
#line 83 "../lib/function-manager.vala"
	_tmp179_ = (_vala_array_free (_tmp179_, _tmp179__length1, (GDestroyNotify) g_free), NULL);
#line 84 "../lib/function-manager.vala"
	_tmp182_ = g_strdup ("x₁");
#line 84 "../lib/function-manager.vala"
	_tmp183_ = g_strdup ("x₂");
#line 84 "../lib/function-manager.vala"
	_tmp184_ = g_strdup ("...");
#line 84 "../lib/function-manager.vala"
	_tmp185_ = g_new0 (gchar*, 3 + 1);
#line 84 "../lib/function-manager.vala"
	_tmp185_[0] = _tmp182_;
#line 84 "../lib/function-manager.vala"
	_tmp185_[1] = _tmp183_;
#line 84 "../lib/function-manager.vala"
	_tmp185_[2] = _tmp184_;
#line 84 "../lib/function-manager.vala"
	_tmp186_ = _tmp185_;
#line 84 "../lib/function-manager.vala"
	_tmp186__length1 = 3;
#line 84 "../lib/function-manager.vala"
	_tmp187_ = built_in_math_function_new ("gcd", _ ("Greatest Common Divisor"), _tmp186_, 3);
#line 84 "../lib/function-manager.vala"
	_tmp188_ = _tmp187_;
#line 84 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp188_);
#line 84 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp188_);
#line 84 "../lib/function-manager.vala"
	_tmp186_ = (_vala_array_free (_tmp186_, _tmp186__length1, (GDestroyNotify) g_free), NULL);
#line 85 "../lib/function-manager.vala"
	_tmp189_ = g_strdup ("x₁");
#line 85 "../lib/function-manager.vala"
	_tmp190_ = g_strdup ("x₂");
#line 85 "../lib/function-manager.vala"
	_tmp191_ = g_strdup ("...");
#line 85 "../lib/function-manager.vala"
	_tmp192_ = g_new0 (gchar*, 3 + 1);
#line 85 "../lib/function-manager.vala"
	_tmp192_[0] = _tmp189_;
#line 85 "../lib/function-manager.vala"
	_tmp192_[1] = _tmp190_;
#line 85 "../lib/function-manager.vala"
	_tmp192_[2] = _tmp191_;
#line 85 "../lib/function-manager.vala"
	_tmp193_ = _tmp192_;
#line 85 "../lib/function-manager.vala"
	_tmp193__length1 = 3;
#line 85 "../lib/function-manager.vala"
	_tmp194_ = built_in_math_function_new ("lcm", _ ("Least Common Multiple"), _tmp193_, 3);
#line 85 "../lib/function-manager.vala"
	_tmp195_ = _tmp194_;
#line 85 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp195_);
#line 85 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp195_);
#line 85 "../lib/function-manager.vala"
	_tmp193_ = (_vala_array_free (_tmp193_, _tmp193__length1, (GDestroyNotify) g_free), NULL);
#line 86 "../lib/function-manager.vala"
	_tmp196_ = g_strdup ("x");
#line 86 "../lib/function-manager.vala"
	_tmp197_ = g_strdup ("y");
#line 86 "../lib/function-manager.vala"
	_tmp198_ = g_new0 (gchar*, 2 + 1);
#line 86 "../lib/function-manager.vala"
	_tmp198_[0] = _tmp196_;
#line 86 "../lib/function-manager.vala"
	_tmp198_[1] = _tmp197_;
#line 86 "../lib/function-manager.vala"
	_tmp199_ = _tmp198_;
#line 86 "../lib/function-manager.vala"
	_tmp199__length1 = 2;
#line 86 "../lib/function-manager.vala"
	_tmp200_ = built_in_math_function_new ("modulus", _ ("Modulus Divide"), _tmp199_, 2);
#line 86 "../lib/function-manager.vala"
	_tmp201_ = _tmp200_;
#line 86 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp201_);
#line 86 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp201_);
#line 86 "../lib/function-manager.vala"
	_tmp199_ = (_vala_array_free (_tmp199_, _tmp199__length1, (GDestroyNotify) g_free), NULL);
#line 87 "../lib/function-manager.vala"
	_tmp202_ = g_strdup ("x");
#line 87 "../lib/function-manager.vala"
	_tmp203_ = g_strdup ("y");
#line 87 "../lib/function-manager.vala"
	_tmp204_ = g_strdup ("p");
#line 87 "../lib/function-manager.vala"
	_tmp205_ = g_new0 (gchar*, 3 + 1);
#line 87 "../lib/function-manager.vala"
	_tmp205_[0] = _tmp202_;
#line 87 "../lib/function-manager.vala"
	_tmp205_[1] = _tmp203_;
#line 87 "../lib/function-manager.vala"
	_tmp205_[2] = _tmp204_;
#line 87 "../lib/function-manager.vala"
	_tmp206_ = _tmp205_;
#line 87 "../lib/function-manager.vala"
	_tmp206__length1 = 3;
#line 87 "../lib/function-manager.vala"
	_tmp207_ = built_in_math_function_new ("modexp", _ ("Modular Exponentiation"), _tmp206_, 3);
#line 87 "../lib/function-manager.vala"
	_tmp208_ = _tmp207_;
#line 87 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp208_);
#line 87 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp208_);
#line 87 "../lib/function-manager.vala"
	_tmp206_ = (_vala_array_free (_tmp206_, _tmp206__length1, (GDestroyNotify) g_free), NULL);
#line 88 "../lib/function-manager.vala"
	_tmp209_ = g_strdup ("x");
#line 88 "../lib/function-manager.vala"
	_tmp210_ = g_strdup ("y");
#line 88 "../lib/function-manager.vala"
	_tmp211_ = g_new0 (gchar*, 2 + 1);
#line 88 "../lib/function-manager.vala"
	_tmp211_[0] = _tmp209_;
#line 88 "../lib/function-manager.vala"
	_tmp211_[1] = _tmp210_;
#line 88 "../lib/function-manager.vala"
	_tmp212_ = _tmp211_;
#line 88 "../lib/function-manager.vala"
	_tmp212__length1 = 2;
#line 88 "../lib/function-manager.vala"
	_tmp213_ = built_in_math_function_new ("cmp", _ ("Comparison"), _tmp212_, 2);
#line 88 "../lib/function-manager.vala"
	_tmp214_ = _tmp213_;
#line 88 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp214_);
#line 88 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp214_);
#line 88 "../lib/function-manager.vala"
	_tmp212_ = (_vala_array_free (_tmp212_, _tmp212__length1, (GDestroyNotify) g_free), NULL);
#line 89 "../lib/function-manager.vala"
	_tmp215_ = g_strdup ("x₁");
#line 89 "../lib/function-manager.vala"
	_tmp216_ = g_strdup ("x₂");
#line 89 "../lib/function-manager.vala"
	_tmp217_ = g_strdup ("...");
#line 89 "../lib/function-manager.vala"
	_tmp218_ = g_new0 (gchar*, 3 + 1);
#line 89 "../lib/function-manager.vala"
	_tmp218_[0] = _tmp215_;
#line 89 "../lib/function-manager.vala"
	_tmp218_[1] = _tmp216_;
#line 89 "../lib/function-manager.vala"
	_tmp218_[2] = _tmp217_;
#line 89 "../lib/function-manager.vala"
	_tmp219_ = _tmp218_;
#line 89 "../lib/function-manager.vala"
	_tmp219__length1 = 3;
#line 89 "../lib/function-manager.vala"
	_tmp220_ = built_in_math_function_new ("sum", _ ("Sum"), _tmp219_, 3);
#line 89 "../lib/function-manager.vala"
	_tmp221_ = _tmp220_;
#line 89 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp221_);
#line 89 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp221_);
#line 89 "../lib/function-manager.vala"
	_tmp219_ = (_vala_array_free (_tmp219_, _tmp219__length1, (GDestroyNotify) g_free), NULL);
#line 90 "../lib/function-manager.vala"
	_tmp222_ = g_strdup ("x₁");
#line 90 "../lib/function-manager.vala"
	_tmp223_ = g_strdup ("x₂");
#line 90 "../lib/function-manager.vala"
	_tmp224_ = g_strdup ("...");
#line 90 "../lib/function-manager.vala"
	_tmp225_ = g_new0 (gchar*, 3 + 1);
#line 90 "../lib/function-manager.vala"
	_tmp225_[0] = _tmp222_;
#line 90 "../lib/function-manager.vala"
	_tmp225_[1] = _tmp223_;
#line 90 "../lib/function-manager.vala"
	_tmp225_[2] = _tmp224_;
#line 90 "../lib/function-manager.vala"
	_tmp226_ = _tmp225_;
#line 90 "../lib/function-manager.vala"
	_tmp226__length1 = 3;
#line 90 "../lib/function-manager.vala"
	_tmp227_ = built_in_math_function_new ("sumsq", _ ("Sum of Squares"), _tmp226_, 3);
#line 90 "../lib/function-manager.vala"
	_tmp228_ = _tmp227_;
#line 90 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp228_);
#line 90 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp228_);
#line 90 "../lib/function-manager.vala"
	_tmp226_ = (_vala_array_free (_tmp226_, _tmp226__length1, (GDestroyNotify) g_free), NULL);
#line 91 "../lib/function-manager.vala"
	_tmp229_ = g_strdup ("x₁");
#line 91 "../lib/function-manager.vala"
	_tmp230_ = g_strdup ("x₂");
#line 91 "../lib/function-manager.vala"
	_tmp231_ = g_strdup ("...");
#line 91 "../lib/function-manager.vala"
	_tmp232_ = g_new0 (gchar*, 3 + 1);
#line 91 "../lib/function-manager.vala"
	_tmp232_[0] = _tmp229_;
#line 91 "../lib/function-manager.vala"
	_tmp232_[1] = _tmp230_;
#line 91 "../lib/function-manager.vala"
	_tmp232_[2] = _tmp231_;
#line 91 "../lib/function-manager.vala"
	_tmp233_ = _tmp232_;
#line 91 "../lib/function-manager.vala"
	_tmp233__length1 = 3;
#line 91 "../lib/function-manager.vala"
	_tmp234_ = built_in_math_function_new ("average", _ ("Average"), _tmp233_, 3);
#line 91 "../lib/function-manager.vala"
	_tmp235_ = _tmp234_;
#line 91 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp235_);
#line 91 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp235_);
#line 91 "../lib/function-manager.vala"
	_tmp233_ = (_vala_array_free (_tmp233_, _tmp233__length1, (GDestroyNotify) g_free), NULL);
#line 92 "../lib/function-manager.vala"
	_tmp236_ = g_strdup ("x₁");
#line 92 "../lib/function-manager.vala"
	_tmp237_ = g_strdup ("x₂");
#line 92 "../lib/function-manager.vala"
	_tmp238_ = g_strdup ("...");
#line 92 "../lib/function-manager.vala"
	_tmp239_ = g_new0 (gchar*, 3 + 1);
#line 92 "../lib/function-manager.vala"
	_tmp239_[0] = _tmp236_;
#line 92 "../lib/function-manager.vala"
	_tmp239_[1] = _tmp237_;
#line 92 "../lib/function-manager.vala"
	_tmp239_[2] = _tmp238_;
#line 92 "../lib/function-manager.vala"
	_tmp240_ = _tmp239_;
#line 92 "../lib/function-manager.vala"
	_tmp240__length1 = 3;
#line 92 "../lib/function-manager.vala"
	_tmp241_ = built_in_math_function_new ("median", _ ("Median"), _tmp240_, 3);
#line 92 "../lib/function-manager.vala"
	_tmp242_ = _tmp241_;
#line 92 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp242_);
#line 92 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp242_);
#line 92 "../lib/function-manager.vala"
	_tmp240_ = (_vala_array_free (_tmp240_, _tmp240__length1, (GDestroyNotify) g_free), NULL);
#line 93 "../lib/function-manager.vala"
	_tmp243_ = g_strdup ("x₁");
#line 93 "../lib/function-manager.vala"
	_tmp244_ = g_strdup ("x₂");
#line 93 "../lib/function-manager.vala"
	_tmp245_ = g_strdup ("...");
#line 93 "../lib/function-manager.vala"
	_tmp246_ = g_new0 (gchar*, 3 + 1);
#line 93 "../lib/function-manager.vala"
	_tmp246_[0] = _tmp243_;
#line 93 "../lib/function-manager.vala"
	_tmp246_[1] = _tmp244_;
#line 93 "../lib/function-manager.vala"
	_tmp246_[2] = _tmp245_;
#line 93 "../lib/function-manager.vala"
	_tmp247_ = _tmp246_;
#line 93 "../lib/function-manager.vala"
	_tmp247__length1 = 3;
#line 93 "../lib/function-manager.vala"
	_tmp248_ = built_in_math_function_new ("min", _ ("Minimum Value"), _tmp247_, 3);
#line 93 "../lib/function-manager.vala"
	_tmp249_ = _tmp248_;
#line 93 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp249_);
#line 93 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp249_);
#line 93 "../lib/function-manager.vala"
	_tmp247_ = (_vala_array_free (_tmp247_, _tmp247__length1, (GDestroyNotify) g_free), NULL);
#line 94 "../lib/function-manager.vala"
	_tmp250_ = g_strdup ("x₁");
#line 94 "../lib/function-manager.vala"
	_tmp251_ = g_strdup ("x₂");
#line 94 "../lib/function-manager.vala"
	_tmp252_ = g_strdup ("...");
#line 94 "../lib/function-manager.vala"
	_tmp253_ = g_new0 (gchar*, 3 + 1);
#line 94 "../lib/function-manager.vala"
	_tmp253_[0] = _tmp250_;
#line 94 "../lib/function-manager.vala"
	_tmp253_[1] = _tmp251_;
#line 94 "../lib/function-manager.vala"
	_tmp253_[2] = _tmp252_;
#line 94 "../lib/function-manager.vala"
	_tmp254_ = _tmp253_;
#line 94 "../lib/function-manager.vala"
	_tmp254__length1 = 3;
#line 94 "../lib/function-manager.vala"
	_tmp255_ = built_in_math_function_new ("max", _ ("Maximum Value"), _tmp254_, 3);
#line 94 "../lib/function-manager.vala"
	_tmp256_ = _tmp255_;
#line 94 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp256_);
#line 94 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp256_);
#line 94 "../lib/function-manager.vala"
	_tmp254_ = (_vala_array_free (_tmp254_, _tmp254__length1, (GDestroyNotify) g_free), NULL);
#line 95 "../lib/function-manager.vala"
	_tmp257_ = g_strdup ("x₁");
#line 95 "../lib/function-manager.vala"
	_tmp258_ = g_strdup ("x₂");
#line 95 "../lib/function-manager.vala"
	_tmp259_ = g_strdup ("...");
#line 95 "../lib/function-manager.vala"
	_tmp260_ = g_new0 (gchar*, 3 + 1);
#line 95 "../lib/function-manager.vala"
	_tmp260_[0] = _tmp257_;
#line 95 "../lib/function-manager.vala"
	_tmp260_[1] = _tmp258_;
#line 95 "../lib/function-manager.vala"
	_tmp260_[2] = _tmp259_;
#line 95 "../lib/function-manager.vala"
	_tmp261_ = _tmp260_;
#line 95 "../lib/function-manager.vala"
	_tmp261__length1 = 3;
#line 95 "../lib/function-manager.vala"
	_tmp262_ = built_in_math_function_new ("stdev", _ ("Sample Standard Deviation"), _tmp261_, 3);
#line 95 "../lib/function-manager.vala"
	_tmp263_ = _tmp262_;
#line 95 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp263_);
#line 95 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp263_);
#line 95 "../lib/function-manager.vala"
	_tmp261_ = (_vala_array_free (_tmp261_, _tmp261__length1, (GDestroyNotify) g_free), NULL);
#line 96 "../lib/function-manager.vala"
	_tmp264_ = g_strdup ("x₁");
#line 96 "../lib/function-manager.vala"
	_tmp265_ = g_strdup ("x₂");
#line 96 "../lib/function-manager.vala"
	_tmp266_ = g_strdup ("...");
#line 96 "../lib/function-manager.vala"
	_tmp267_ = g_new0 (gchar*, 3 + 1);
#line 96 "../lib/function-manager.vala"
	_tmp267_[0] = _tmp264_;
#line 96 "../lib/function-manager.vala"
	_tmp267_[1] = _tmp265_;
#line 96 "../lib/function-manager.vala"
	_tmp267_[2] = _tmp266_;
#line 96 "../lib/function-manager.vala"
	_tmp268_ = _tmp267_;
#line 96 "../lib/function-manager.vala"
	_tmp268__length1 = 3;
#line 96 "../lib/function-manager.vala"
	_tmp269_ = built_in_math_function_new ("stdevp", _ ("Population Standard Deviation"), _tmp268_, 3);
#line 96 "../lib/function-manager.vala"
	_tmp270_ = _tmp269_;
#line 96 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp270_);
#line 96 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp270_);
#line 96 "../lib/function-manager.vala"
	_tmp268_ = (_vala_array_free (_tmp268_, _tmp268__length1, (GDestroyNotify) g_free), NULL);
#line 97 "../lib/function-manager.vala"
	_tmp271_ = g_strdup ("x₁");
#line 97 "../lib/function-manager.vala"
	_tmp272_ = g_strdup ("x₂");
#line 97 "../lib/function-manager.vala"
	_tmp273_ = g_strdup ("...");
#line 97 "../lib/function-manager.vala"
	_tmp274_ = g_new0 (gchar*, 3 + 1);
#line 97 "../lib/function-manager.vala"
	_tmp274_[0] = _tmp271_;
#line 97 "../lib/function-manager.vala"
	_tmp274_[1] = _tmp272_;
#line 97 "../lib/function-manager.vala"
	_tmp274_[2] = _tmp273_;
#line 97 "../lib/function-manager.vala"
	_tmp275_ = _tmp274_;
#line 97 "../lib/function-manager.vala"
	_tmp275__length1 = 3;
#line 97 "../lib/function-manager.vala"
	_tmp276_ = built_in_math_function_new ("var", _ ("Sample Variance"), _tmp275_, 3);
#line 97 "../lib/function-manager.vala"
	_tmp277_ = _tmp276_;
#line 97 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp277_);
#line 97 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp277_);
#line 97 "../lib/function-manager.vala"
	_tmp275_ = (_vala_array_free (_tmp275_, _tmp275__length1, (GDestroyNotify) g_free), NULL);
#line 98 "../lib/function-manager.vala"
	_tmp278_ = g_strdup ("x₁");
#line 98 "../lib/function-manager.vala"
	_tmp279_ = g_strdup ("x₂");
#line 98 "../lib/function-manager.vala"
	_tmp280_ = g_strdup ("...");
#line 98 "../lib/function-manager.vala"
	_tmp281_ = g_new0 (gchar*, 3 + 1);
#line 98 "../lib/function-manager.vala"
	_tmp281_[0] = _tmp278_;
#line 98 "../lib/function-manager.vala"
	_tmp281_[1] = _tmp279_;
#line 98 "../lib/function-manager.vala"
	_tmp281_[2] = _tmp280_;
#line 98 "../lib/function-manager.vala"
	_tmp282_ = _tmp281_;
#line 98 "../lib/function-manager.vala"
	_tmp282__length1 = 3;
#line 98 "../lib/function-manager.vala"
	_tmp283_ = built_in_math_function_new ("varp", _ ("Population Variance"), _tmp282_, 3);
#line 98 "../lib/function-manager.vala"
	_tmp284_ = _tmp283_;
#line 98 "../lib/function-manager.vala"
	function_manager_add (self, (MathFunction*) _tmp284_);
#line 98 "../lib/function-manager.vala"
	_g_object_unref0 (_tmp284_);
#line 98 "../lib/function-manager.vala"
	_tmp282_ = (_vala_array_free (_tmp282_, _tmp282__length1, (GDestroyNotify) g_free), NULL);
#line 1724 "function-manager.c"
}

static void
function_manager_reload_custom_functions (FunctionManager* self)
{
	gchar* data = NULL;
	gchar** lines = NULL;
	const gchar* _tmp2_;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint lines_length1;
	gint _lines_size_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	GError* _inner_error0_ = NULL;
#line 101 "../lib/function-manager.vala"
	g_return_if_fail (self != NULL);
#line 1742 "function-manager.c"
	{
		const gchar* _tmp0_;
		gchar* _tmp1_ = NULL;
#line 106 "../lib/function-manager.vala"
		_tmp0_ = self->priv->file_name;
#line 106 "../lib/function-manager.vala"
		g_file_get_contents (_tmp0_, &_tmp1_, NULL, &_inner_error0_);
#line 106 "../lib/function-manager.vala"
		_g_free0 (data);
#line 106 "../lib/function-manager.vala"
		data = _tmp1_;
#line 106 "../lib/function-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 106 "../lib/function-manager.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 1758 "function-manager.c"
				goto __catch0_g_file_error;
			}
#line 106 "../lib/function-manager.vala"
			_g_free0 (data);
#line 106 "../lib/function-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 106 "../lib/function-manager.vala"
			g_clear_error (&_inner_error0_);
#line 106 "../lib/function-manager.vala"
			return;
#line 1769 "function-manager.c"
		}
	}
	goto __finally0;
	__catch0_g_file_error:
	{
#line 104 "../lib/function-manager.vala"
		g_clear_error (&_inner_error0_);
#line 110 "../lib/function-manager.vala"
		_g_free0 (data);
#line 110 "../lib/function-manager.vala"
		return;
#line 1781 "function-manager.c"
	}
	__finally0:
#line 104 "../lib/function-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 104 "../lib/function-manager.vala"
		_g_free0 (data);
#line 104 "../lib/function-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 104 "../lib/function-manager.vala"
		g_clear_error (&_inner_error0_);
#line 104 "../lib/function-manager.vala"
		return;
#line 1794 "function-manager.c"
	}
#line 112 "../lib/function-manager.vala"
	_tmp2_ = data;
#line 112 "../lib/function-manager.vala"
	_tmp4_ = _tmp3_ = g_strsplit (_tmp2_, "\n", 0);
#line 112 "../lib/function-manager.vala"
	lines = _tmp4_;
#line 112 "../lib/function-manager.vala"
	lines_length1 = _vala_array_length (_tmp3_);
#line 112 "../lib/function-manager.vala"
	_lines_size_ = lines_length1;
#line 114 "../lib/function-manager.vala"
	_tmp5_ = lines;
#line 114 "../lib/function-manager.vala"
	_tmp5__length1 = lines_length1;
#line 1810 "function-manager.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 114 "../lib/function-manager.vala"
		line_collection = _tmp5_;
#line 114 "../lib/function-manager.vala"
		line_collection_length1 = _tmp5__length1;
#line 114 "../lib/function-manager.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 1822 "function-manager.c"
			gchar* _tmp6_;
			gchar* line = NULL;
#line 114 "../lib/function-manager.vala"
			_tmp6_ = g_strdup (line_collection[line_it]);
#line 114 "../lib/function-manager.vala"
			line = _tmp6_;
#line 1829 "function-manager.c"
			{
				MathFunction* function = NULL;
				const gchar* _tmp7_;
				MathFunction* _tmp8_;
				MathFunction* _tmp9_;
#line 116 "../lib/function-manager.vala"
				_tmp7_ = line;
#line 116 "../lib/function-manager.vala"
				_tmp8_ = function_manager_parse_function_from_string (self, _tmp7_);
#line 116 "../lib/function-manager.vala"
				function = _tmp8_;
#line 117 "../lib/function-manager.vala"
				_tmp9_ = function;
#line 117 "../lib/function-manager.vala"
				if (_tmp9_ != NULL) {
#line 1845 "function-manager.c"
					GHashTable* _tmp10_;
					MathFunction* _tmp11_;
					const gchar* _tmp12_;
					const gchar* _tmp13_;
					gchar* _tmp14_;
					MathFunction* _tmp15_;
					MathFunction* _tmp16_;
#line 118 "../lib/function-manager.vala"
					_tmp10_ = self->priv->functions;
#line 118 "../lib/function-manager.vala"
					_tmp11_ = function;
#line 118 "../lib/function-manager.vala"
					_tmp12_ = math_function_get_name (_tmp11_);
#line 118 "../lib/function-manager.vala"
					_tmp13_ = _tmp12_;
#line 118 "../lib/function-manager.vala"
					_tmp14_ = g_strdup (_tmp13_);
#line 118 "../lib/function-manager.vala"
					_tmp15_ = function;
#line 118 "../lib/function-manager.vala"
					_tmp16_ = _g_object_ref0 (_tmp15_);
#line 118 "../lib/function-manager.vala"
					g_hash_table_insert (_tmp10_, _tmp14_, _tmp16_);
#line 1869 "function-manager.c"
				}
#line 114 "../lib/function-manager.vala"
				_g_object_unref0 (function);
#line 114 "../lib/function-manager.vala"
				_g_free0 (line);
#line 1875 "function-manager.c"
			}
		}
	}
#line 101 "../lib/function-manager.vala"
	lines = (_vala_array_free (lines, lines_length1, (GDestroyNotify) g_free), NULL);
#line 101 "../lib/function-manager.vala"
	_g_free0 (data);
#line 1883 "function-manager.c"
}

static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1204 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1205 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1205 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1207 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1207 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1905 "function-manager.c"
		gchar* _tmp2_;
#line 1208 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1208 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1208 "glib-2.0.vapi"
		return result;
#line 1913 "function-manager.c"
	} else {
#line 1210 "glib-2.0.vapi"
		result = -1;
#line 1210 "glib-2.0.vapi"
		return result;
#line 1919 "function-manager.c"
	}
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 1943 "function-manager.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 1952 "function-manager.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 1971 "function-manager.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 1975 "function-manager.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 1981 "function-manager.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 1991 "function-manager.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 1999 "function-manager.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 2003 "function-manager.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 2009 "function-manager.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 2019 "function-manager.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 2040 "function-manager.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 2062 "function-manager.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 2066 "function-manager.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 2072 "function-manager.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 2076 "function-manager.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 2080 "function-manager.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 2088 "function-manager.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2116 "function-manager.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 2125 "function-manager.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 2139 "function-manager.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 2148 "function-manager.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 2162 "function-manager.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 2171 "function-manager.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 2180 "function-manager.c"
}

static MathFunction*
function_manager_parse_function_from_string (FunctionManager* self,
                                             const gchar* data)
{
	gint i = 0;
	gchar* left = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* right = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_ = FALSE;
	const gchar* _tmp9_;
	gchar* expression = NULL;
	gchar* _tmp11_;
	gchar* description = NULL;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	gchar* name = NULL;
	const gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* argument_list = NULL;
	const gchar* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gboolean _tmp36_ = FALSE;
	const gchar* _tmp37_;
	const gchar* _tmp39_;
	gchar* _tmp40_;
	gchar** arguments = NULL;
	const gchar* _tmp41_;
	gchar** _tmp42_;
	gchar** _tmp43_;
	gint arguments_length1;
	gint _arguments_size_;
	const gchar* _tmp44_;
	gchar** _tmp45_;
	gint _tmp45__length1;
	const gchar* _tmp46_;
	const gchar* _tmp47_;
	MathFunction* _tmp48_;
	MathFunction* result;
#line 122 "../lib/function-manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 126 "../lib/function-manager.vala"
	if (data == NULL) {
#line 127 "../lib/function-manager.vala"
		result = NULL;
#line 127 "../lib/function-manager.vala"
		return result;
#line 2244 "function-manager.c"
	}
#line 129 "../lib/function-manager.vala"
	i = string_index_of_char (data, (gunichar) '=', 0);
#line 130 "../lib/function-manager.vala"
	if (i < 0) {
#line 131 "../lib/function-manager.vala"
		result = NULL;
#line 131 "../lib/function-manager.vala"
		return result;
#line 2254 "function-manager.c"
	}
#line 132 "../lib/function-manager.vala"
	_tmp0_ = string_substring (data, (glong) 0, (glong) i);
#line 132 "../lib/function-manager.vala"
	_tmp1_ = _tmp0_;
#line 132 "../lib/function-manager.vala"
	_tmp2_ = string_strip (_tmp1_);
#line 132 "../lib/function-manager.vala"
	_tmp3_ = _tmp2_;
#line 132 "../lib/function-manager.vala"
	_g_free0 (_tmp1_);
#line 132 "../lib/function-manager.vala"
	left = _tmp3_;
#line 133 "../lib/function-manager.vala"
	_tmp4_ = string_substring (data, (glong) (i + 1), (glong) -1);
#line 133 "../lib/function-manager.vala"
	_tmp5_ = _tmp4_;
#line 133 "../lib/function-manager.vala"
	_tmp6_ = string_strip (_tmp5_);
#line 133 "../lib/function-manager.vala"
	_tmp7_ = _tmp6_;
#line 133 "../lib/function-manager.vala"
	_g_free0 (_tmp5_);
#line 133 "../lib/function-manager.vala"
	right = _tmp7_;
#line 134 "../lib/function-manager.vala"
	_tmp9_ = left;
#line 134 "../lib/function-manager.vala"
	if (_tmp9_ == NULL) {
#line 134 "../lib/function-manager.vala"
		_tmp8_ = TRUE;
#line 2286 "function-manager.c"
	} else {
		const gchar* _tmp10_;
#line 134 "../lib/function-manager.vala"
		_tmp10_ = right;
#line 134 "../lib/function-manager.vala"
		_tmp8_ = _tmp10_ == NULL;
#line 2293 "function-manager.c"
	}
#line 134 "../lib/function-manager.vala"
	if (_tmp8_) {
#line 135 "../lib/function-manager.vala"
		result = NULL;
#line 135 "../lib/function-manager.vala"
		_g_free0 (right);
#line 135 "../lib/function-manager.vala"
		_g_free0 (left);
#line 135 "../lib/function-manager.vala"
		return result;
#line 2305 "function-manager.c"
	}
#line 137 "../lib/function-manager.vala"
	_tmp11_ = g_strdup ("");
#line 137 "../lib/function-manager.vala"
	expression = _tmp11_;
#line 138 "../lib/function-manager.vala"
	_tmp12_ = g_strdup ("");
#line 138 "../lib/function-manager.vala"
	description = _tmp12_;
#line 139 "../lib/function-manager.vala"
	_tmp13_ = right;
#line 139 "../lib/function-manager.vala"
	i = string_index_of_char (_tmp13_, (gunichar) '@', 0);
#line 140 "../lib/function-manager.vala"
	if (i < 0) {
#line 2321 "function-manager.c"
		const gchar* _tmp14_;
		gchar* _tmp15_;
#line 141 "../lib/function-manager.vala"
		_tmp14_ = right;
#line 141 "../lib/function-manager.vala"
		_tmp15_ = g_strdup (_tmp14_);
#line 141 "../lib/function-manager.vala"
		_g_free0 (expression);
#line 141 "../lib/function-manager.vala"
		expression = _tmp15_;
#line 2332 "function-manager.c"
	} else {
		const gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		const gchar* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
#line 144 "../lib/function-manager.vala"
		_tmp16_ = right;
#line 144 "../lib/function-manager.vala"
		_tmp17_ = string_substring (_tmp16_, (glong) 0, (glong) i);
#line 144 "../lib/function-manager.vala"
		_tmp18_ = _tmp17_;
#line 144 "../lib/function-manager.vala"
		_tmp19_ = string_strip (_tmp18_);
#line 144 "../lib/function-manager.vala"
		_g_free0 (expression);
#line 144 "../lib/function-manager.vala"
		expression = _tmp19_;
#line 144 "../lib/function-manager.vala"
		_g_free0 (_tmp18_);
#line 145 "../lib/function-manager.vala"
		_tmp20_ = right;
#line 145 "../lib/function-manager.vala"
		_tmp21_ = string_substring (_tmp20_, (glong) (i + 1), (glong) -1);
#line 145 "../lib/function-manager.vala"
		_tmp22_ = _tmp21_;
#line 145 "../lib/function-manager.vala"
		_tmp23_ = string_strip (_tmp22_);
#line 145 "../lib/function-manager.vala"
		_g_free0 (description);
#line 145 "../lib/function-manager.vala"
		description = _tmp23_;
#line 145 "../lib/function-manager.vala"
		_g_free0 (_tmp22_);
#line 2370 "function-manager.c"
	}
#line 147 "../lib/function-manager.vala"
	_tmp24_ = expression;
#line 147 "../lib/function-manager.vala"
	if (_tmp24_ == NULL) {
#line 148 "../lib/function-manager.vala"
		result = NULL;
#line 148 "../lib/function-manager.vala"
		_g_free0 (description);
#line 148 "../lib/function-manager.vala"
		_g_free0 (expression);
#line 148 "../lib/function-manager.vala"
		_g_free0 (right);
#line 148 "../lib/function-manager.vala"
		_g_free0 (left);
#line 148 "../lib/function-manager.vala"
		return result;
#line 2388 "function-manager.c"
	}
#line 150 "../lib/function-manager.vala"
	_tmp25_ = left;
#line 150 "../lib/function-manager.vala"
	i = string_index_of_char (_tmp25_, (gunichar) '(', 0);
#line 151 "../lib/function-manager.vala"
	if (i < 0) {
#line 152 "../lib/function-manager.vala"
		result = NULL;
#line 152 "../lib/function-manager.vala"
		_g_free0 (description);
#line 152 "../lib/function-manager.vala"
		_g_free0 (expression);
#line 152 "../lib/function-manager.vala"
		_g_free0 (right);
#line 152 "../lib/function-manager.vala"
		_g_free0 (left);
#line 152 "../lib/function-manager.vala"
		return result;
#line 2408 "function-manager.c"
	}
#line 153 "../lib/function-manager.vala"
	_tmp26_ = left;
#line 153 "../lib/function-manager.vala"
	_tmp27_ = string_substring (_tmp26_, (glong) 0, (glong) i);
#line 153 "../lib/function-manager.vala"
	_tmp28_ = _tmp27_;
#line 153 "../lib/function-manager.vala"
	_tmp29_ = string_strip (_tmp28_);
#line 153 "../lib/function-manager.vala"
	_tmp30_ = _tmp29_;
#line 153 "../lib/function-manager.vala"
	_g_free0 (_tmp28_);
#line 153 "../lib/function-manager.vala"
	name = _tmp30_;
#line 154 "../lib/function-manager.vala"
	_tmp31_ = left;
#line 154 "../lib/function-manager.vala"
	_tmp32_ = string_substring (_tmp31_, (glong) (i + 1), (glong) -1);
#line 154 "../lib/function-manager.vala"
	_tmp33_ = _tmp32_;
#line 154 "../lib/function-manager.vala"
	_tmp34_ = string_strip (_tmp33_);
#line 154 "../lib/function-manager.vala"
	_tmp35_ = _tmp34_;
#line 154 "../lib/function-manager.vala"
	_g_free0 (_tmp33_);
#line 154 "../lib/function-manager.vala"
	argument_list = _tmp35_;
#line 155 "../lib/function-manager.vala"
	_tmp37_ = name;
#line 155 "../lib/function-manager.vala"
	if (_tmp37_ == NULL) {
#line 155 "../lib/function-manager.vala"
		_tmp36_ = TRUE;
#line 2444 "function-manager.c"
	} else {
		const gchar* _tmp38_;
#line 155 "../lib/function-manager.vala"
		_tmp38_ = argument_list;
#line 155 "../lib/function-manager.vala"
		_tmp36_ = _tmp38_ == NULL;
#line 2451 "function-manager.c"
	}
#line 155 "../lib/function-manager.vala"
	if (_tmp36_) {
#line 156 "../lib/function-manager.vala"
		result = NULL;
#line 156 "../lib/function-manager.vala"
		_g_free0 (argument_list);
#line 156 "../lib/function-manager.vala"
		_g_free0 (name);
#line 156 "../lib/function-manager.vala"
		_g_free0 (description);
#line 156 "../lib/function-manager.vala"
		_g_free0 (expression);
#line 156 "../lib/function-manager.vala"
		_g_free0 (right);
#line 156 "../lib/function-manager.vala"
		_g_free0 (left);
#line 156 "../lib/function-manager.vala"
		return result;
#line 2471 "function-manager.c"
	}
#line 158 "../lib/function-manager.vala"
	_tmp39_ = argument_list;
#line 158 "../lib/function-manager.vala"
	_tmp40_ = string_replace (_tmp39_, ")", "");
#line 158 "../lib/function-manager.vala"
	_g_free0 (argument_list);
#line 158 "../lib/function-manager.vala"
	argument_list = _tmp40_;
#line 159 "../lib/function-manager.vala"
	_tmp41_ = argument_list;
#line 159 "../lib/function-manager.vala"
	_tmp43_ = _tmp42_ = g_strsplit_set (_tmp41_, ";", 0);
#line 159 "../lib/function-manager.vala"
	arguments = _tmp43_;
#line 159 "../lib/function-manager.vala"
	arguments_length1 = _vala_array_length (_tmp42_);
#line 159 "../lib/function-manager.vala"
	_arguments_size_ = arguments_length1;
#line 161 "../lib/function-manager.vala"
	_tmp44_ = name;
#line 161 "../lib/function-manager.vala"
	_tmp45_ = arguments;
#line 161 "../lib/function-manager.vala"
	_tmp45__length1 = arguments_length1;
#line 161 "../lib/function-manager.vala"
	_tmp46_ = expression;
#line 161 "../lib/function-manager.vala"
	_tmp47_ = description;
#line 161 "../lib/function-manager.vala"
	_tmp48_ = math_function_new (_tmp44_, _tmp45_, _tmp45__length1, _tmp46_, _tmp47_);
#line 161 "../lib/function-manager.vala"
	result = _tmp48_;
#line 161 "../lib/function-manager.vala"
	arguments = (_vala_array_free (arguments, arguments_length1, (GDestroyNotify) g_free), NULL);
#line 161 "../lib/function-manager.vala"
	_g_free0 (argument_list);
#line 161 "../lib/function-manager.vala"
	_g_free0 (name);
#line 161 "../lib/function-manager.vala"
	_g_free0 (description);
#line 161 "../lib/function-manager.vala"
	_g_free0 (expression);
#line 161 "../lib/function-manager.vala"
	_g_free0 (right);
#line 161 "../lib/function-manager.vala"
	_g_free0 (left);
#line 161 "../lib/function-manager.vala"
	return result;
#line 2521 "function-manager.c"
}

static gchar*
_vala_g_strjoinv (const gchar* separator,
                  gchar** str_array,
                  gint str_array_length1)
{
	gboolean _tmp0_ = FALSE;
	gchar* result;
#line 1251 "glib-2.0.vapi"
	if (separator == NULL) {
#line 1252 "glib-2.0.vapi"
		separator = "";
#line 2535 "function-manager.c"
	}
#line 1254 "glib-2.0.vapi"
	if (str_array != NULL) {
#line 2539 "function-manager.c"
		gboolean _tmp1_ = FALSE;
#line 1254 "glib-2.0.vapi"
		if (str_array_length1 > 0) {
#line 1254 "glib-2.0.vapi"
			_tmp1_ = TRUE;
#line 2545 "function-manager.c"
		} else {
			gboolean _tmp2_ = FALSE;
#line 1254 "glib-2.0.vapi"
			if (str_array_length1 == -1) {
#line 2550 "function-manager.c"
				const gchar* _tmp3_;
#line 1254 "glib-2.0.vapi"
				_tmp3_ = str_array[0];
#line 1254 "glib-2.0.vapi"
				_tmp2_ = _tmp3_ != NULL;
#line 2556 "function-manager.c"
			} else {
#line 1254 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 2560 "function-manager.c"
			}
#line 1254 "glib-2.0.vapi"
			_tmp1_ = _tmp2_;
#line 2564 "function-manager.c"
		}
#line 1254 "glib-2.0.vapi"
		_tmp0_ = _tmp1_;
#line 2568 "function-manager.c"
	} else {
#line 1254 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 2572 "function-manager.c"
	}
#line 1254 "glib-2.0.vapi"
	if (_tmp0_) {
#line 2576 "function-manager.c"
		gint i = 0;
		gsize len = 0UL;
		gint _tmp16_;
		gint _tmp17_;
		const gchar* res = NULL;
		void* _tmp18_;
		const gchar* _tmp19_ = NULL;
		const gchar* _tmp20_;
		void* ptr = NULL;
		const gchar* _tmp22_;
		void* _tmp23_;
		const gchar* _tmp33_;
#line 1256 "glib-2.0.vapi"
		len = (gsize) 1;
#line 2591 "function-manager.c"
		{
			gboolean _tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
			i = 0;
#line 1257 "glib-2.0.vapi"
			_tmp4_ = TRUE;
#line 1257 "glib-2.0.vapi"
			while (TRUE) {
#line 2600 "function-manager.c"
				gboolean _tmp6_ = FALSE;
				gboolean _tmp7_ = FALSE;
				gint _tmp10_ = 0;
				const gchar* _tmp11_;
#line 1257 "glib-2.0.vapi"
				if (!_tmp4_) {
#line 2607 "function-manager.c"
					gint _tmp5_;
#line 1257 "glib-2.0.vapi"
					_tmp5_ = i;
#line 1257 "glib-2.0.vapi"
					i = _tmp5_ + 1;
#line 2613 "function-manager.c"
				}
#line 1257 "glib-2.0.vapi"
				_tmp4_ = FALSE;
#line 1257 "glib-2.0.vapi"
				if (str_array_length1 != -1) {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = i < str_array_length1;
#line 2621 "function-manager.c"
				} else {
#line 1257 "glib-2.0.vapi"
					_tmp7_ = FALSE;
#line 2625 "function-manager.c"
				}
#line 1257 "glib-2.0.vapi"
				if (_tmp7_) {
#line 1257 "glib-2.0.vapi"
					_tmp6_ = TRUE;
#line 2631 "function-manager.c"
				} else {
					gboolean _tmp8_ = FALSE;
#line 1257 "glib-2.0.vapi"
					if (str_array_length1 == -1) {
#line 2636 "function-manager.c"
						const gchar* _tmp9_;
#line 1257 "glib-2.0.vapi"
						_tmp9_ = str_array[i];
#line 1257 "glib-2.0.vapi"
						_tmp8_ = _tmp9_ != NULL;
#line 2642 "function-manager.c"
					} else {
#line 1257 "glib-2.0.vapi"
						_tmp8_ = FALSE;
#line 2646 "function-manager.c"
					}
#line 1257 "glib-2.0.vapi"
					_tmp6_ = _tmp8_;
#line 2650 "function-manager.c"
				}
#line 1257 "glib-2.0.vapi"
				if (!_tmp6_) {
#line 1257 "glib-2.0.vapi"
					break;
#line 2656 "function-manager.c"
				}
#line 1258 "glib-2.0.vapi"
				_tmp11_ = str_array[i];
#line 1258 "glib-2.0.vapi"
				if (_tmp11_ != NULL) {
#line 2662 "function-manager.c"
					const gchar* _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
#line 1258 "glib-2.0.vapi"
					_tmp12_ = str_array[i];
#line 1258 "glib-2.0.vapi"
					_tmp13_ = strlen ((const gchar*) _tmp12_);
#line 1258 "glib-2.0.vapi"
					_tmp14_ = _tmp13_;
#line 1258 "glib-2.0.vapi"
					_tmp10_ = _tmp14_;
#line 2674 "function-manager.c"
				} else {
#line 1258 "glib-2.0.vapi"
					_tmp10_ = 0;
#line 2678 "function-manager.c"
				}
#line 1258 "glib-2.0.vapi"
				len += (gsize) _tmp10_;
#line 2682 "function-manager.c"
			}
		}
#line 1260 "glib-2.0.vapi"
		if (i == 0) {
#line 2687 "function-manager.c"
			gchar* _tmp15_;
#line 1261 "glib-2.0.vapi"
			_tmp15_ = g_strdup ("");
#line 1261 "glib-2.0.vapi"
			result = _tmp15_;
#line 1261 "glib-2.0.vapi"
			return result;
#line 2695 "function-manager.c"
		}
#line 1263 "glib-2.0.vapi"
		str_array_length1 = i;
#line 1264 "glib-2.0.vapi"
		_tmp16_ = strlen ((const gchar*) separator);
#line 1264 "glib-2.0.vapi"
		_tmp17_ = _tmp16_;
#line 1264 "glib-2.0.vapi"
		len += (gsize) (_tmp17_ * (i - 1));
#line 1266 "glib-2.0.vapi"
		_tmp18_ = g_malloc (len);
#line 1266 "glib-2.0.vapi"
		res = _tmp18_;
#line 1267 "glib-2.0.vapi"
		_tmp20_ = str_array[0];
#line 1267 "glib-2.0.vapi"
		if (_tmp20_ != NULL) {
#line 2713 "function-manager.c"
			const gchar* _tmp21_;
#line 1267 "glib-2.0.vapi"
			_tmp21_ = str_array[0];
#line 1267 "glib-2.0.vapi"
			_tmp19_ = (const gchar*) _tmp21_;
#line 2719 "function-manager.c"
		} else {
#line 1267 "glib-2.0.vapi"
			_tmp19_ = "";
#line 2723 "function-manager.c"
		}
#line 1267 "glib-2.0.vapi"
		_tmp22_ = res;
#line 1267 "glib-2.0.vapi"
		_tmp23_ = g_stpcpy ((void*) _tmp22_, _tmp19_);
#line 1267 "glib-2.0.vapi"
		ptr = _tmp23_;
#line 2731 "function-manager.c"
		{
			gboolean _tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
			i = 1;
#line 1268 "glib-2.0.vapi"
			_tmp24_ = TRUE;
#line 1268 "glib-2.0.vapi"
			while (TRUE) {
#line 2740 "function-manager.c"
				void* _tmp26_;
				void* _tmp27_;
				const gchar* _tmp28_ = NULL;
				const gchar* _tmp29_;
				void* _tmp31_;
				void* _tmp32_;
#line 1268 "glib-2.0.vapi"
				if (!_tmp24_) {
#line 2749 "function-manager.c"
					gint _tmp25_;
#line 1268 "glib-2.0.vapi"
					_tmp25_ = i;
#line 1268 "glib-2.0.vapi"
					i = _tmp25_ + 1;
#line 2755 "function-manager.c"
				}
#line 1268 "glib-2.0.vapi"
				_tmp24_ = FALSE;
#line 1268 "glib-2.0.vapi"
				if (!(i < str_array_length1)) {
#line 1268 "glib-2.0.vapi"
					break;
#line 2763 "function-manager.c"
				}
#line 1269 "glib-2.0.vapi"
				_tmp26_ = ptr;
#line 1269 "glib-2.0.vapi"
				_tmp27_ = g_stpcpy (_tmp26_, (const gchar*) separator);
#line 1269 "glib-2.0.vapi"
				ptr = _tmp27_;
#line 1270 "glib-2.0.vapi"
				_tmp29_ = str_array[i];
#line 1270 "glib-2.0.vapi"
				if (_tmp29_ != NULL) {
#line 2775 "function-manager.c"
					const gchar* _tmp30_;
#line 1270 "glib-2.0.vapi"
					_tmp30_ = str_array[i];
#line 1270 "glib-2.0.vapi"
					_tmp28_ = (const gchar*) _tmp30_;
#line 2781 "function-manager.c"
				} else {
#line 1270 "glib-2.0.vapi"
					_tmp28_ = "";
#line 2785 "function-manager.c"
				}
#line 1270 "glib-2.0.vapi"
				_tmp31_ = ptr;
#line 1270 "glib-2.0.vapi"
				_tmp32_ = g_stpcpy (_tmp31_, _tmp28_);
#line 1270 "glib-2.0.vapi"
				ptr = _tmp32_;
#line 2793 "function-manager.c"
			}
		}
#line 1273 "glib-2.0.vapi"
		_tmp33_ = res;
#line 1273 "glib-2.0.vapi"
		res = NULL;
#line 1273 "glib-2.0.vapi"
		result = (gchar*) _tmp33_;
#line 1273 "glib-2.0.vapi"
		return result;
#line 2804 "function-manager.c"
	} else {
		gchar* _tmp34_;
#line 1275 "glib-2.0.vapi"
		_tmp34_ = g_strdup ("");
#line 1275 "glib-2.0.vapi"
		result = _tmp34_;
#line 1275 "glib-2.0.vapi"
		return result;
#line 2813 "function-manager.c"
	}
}

static void
function_manager_save (FunctionManager* self)
{
	gchar* data = NULL;
	gchar* _tmp0_;
	GHashTableIter iter = {0};
	GHashTable* _tmp1_;
	gchar* name = NULL;
	MathFunction* math_function = NULL;
	gchar* dir = NULL;
	const gchar* _tmp27_;
	gchar* _tmp28_;
	GError* _inner_error0_ = NULL;
#line 164 "../lib/function-manager.vala"
	g_return_if_fail (self != NULL);
#line 166 "../lib/function-manager.vala"
	_tmp0_ = g_strdup ("");
#line 166 "../lib/function-manager.vala"
	data = _tmp0_;
#line 167 "../lib/function-manager.vala"
	_tmp1_ = self->priv->functions;
#line 167 "../lib/function-manager.vala"
	g_hash_table_iter_init (&iter, _tmp1_);
#line 170 "../lib/function-manager.vala"
	while (TRUE) {
#line 2842 "function-manager.c"
		gconstpointer _tmp2_ = NULL;
		gconstpointer _tmp3_ = NULL;
		gboolean _tmp4_;
		gchar* _tmp5_;
		MathFunction* _tmp6_;
		MathFunction* _tmp7_;
		const gchar* _tmp8_;
		MathFunction* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		MathFunction* _tmp12_;
		gchar** _tmp13_;
		gint _tmp13__length1;
		gint _tmp14_ = 0;
		gchar** _tmp15_;
		gint _tmp15__length1;
		gchar* _tmp16_;
		gchar* _tmp17_;
		MathFunction* _tmp18_;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		MathFunction* _tmp21_;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
#line 170 "../lib/function-manager.vala"
		_tmp4_ = g_hash_table_iter_next (&iter, (gpointer*) (&_tmp2_), (gpointer*) (&_tmp3_));
#line 170 "../lib/function-manager.vala"
		_g_free0 (name);
#line 170 "../lib/function-manager.vala"
		_tmp5_ = g_strdup ((const gchar*) _tmp2_);
#line 170 "../lib/function-manager.vala"
		name = _tmp5_;
#line 170 "../lib/function-manager.vala"
		_g_object_unref0 (math_function);
#line 170 "../lib/function-manager.vala"
		_tmp6_ = _g_object_ref0 ((MathFunction*) _tmp3_);
#line 170 "../lib/function-manager.vala"
		math_function = _tmp6_;
#line 170 "../lib/function-manager.vala"
		if (!_tmp4_) {
#line 170 "../lib/function-manager.vala"
			break;
#line 2888 "function-manager.c"
		}
#line 172 "../lib/function-manager.vala"
		_tmp7_ = math_function;
#line 172 "../lib/function-manager.vala"
		if (!math_function_is_custom_function (_tmp7_)) {
#line 173 "../lib/function-manager.vala"
			continue;
#line 2896 "function-manager.c"
		}
#line 175 "../lib/function-manager.vala"
		_tmp8_ = data;
#line 175 "../lib/function-manager.vala"
		_tmp9_ = math_function;
#line 175 "../lib/function-manager.vala"
		_tmp10_ = math_function_get_name (_tmp9_);
#line 175 "../lib/function-manager.vala"
		_tmp11_ = _tmp10_;
#line 175 "../lib/function-manager.vala"
		_tmp12_ = math_function;
#line 175 "../lib/function-manager.vala"
		_tmp13_ = math_function_get_arguments (_tmp12_, &_tmp14_);
#line 175 "../lib/function-manager.vala"
		_tmp13__length1 = _tmp14_;
#line 175 "../lib/function-manager.vala"
		_tmp15_ = _tmp13_;
#line 175 "../lib/function-manager.vala"
		_tmp15__length1 = _tmp13__length1;
#line 175 "../lib/function-manager.vala"
		_tmp16_ = _vala_g_strjoinv (";", _tmp15_, (gint) _tmp15__length1);
#line 175 "../lib/function-manager.vala"
		_tmp17_ = _tmp16_;
#line 175 "../lib/function-manager.vala"
		_tmp18_ = math_function;
#line 175 "../lib/function-manager.vala"
		_tmp19_ = math_function_get_expression (_tmp18_);
#line 175 "../lib/function-manager.vala"
		_tmp20_ = _tmp19_;
#line 175 "../lib/function-manager.vala"
		_tmp21_ = math_function;
#line 175 "../lib/function-manager.vala"
		_tmp22_ = math_function_get_description (_tmp21_);
#line 175 "../lib/function-manager.vala"
		_tmp23_ = _tmp22_;
#line 175 "../lib/function-manager.vala"
		_tmp24_ = g_strdup_printf ("%s(%s)=%s@%s\n", _tmp11_, _tmp17_, _tmp20_, _tmp23_);
#line 175 "../lib/function-manager.vala"
		_tmp25_ = _tmp24_;
#line 175 "../lib/function-manager.vala"
		_tmp26_ = g_strconcat (_tmp8_, _tmp25_, NULL);
#line 175 "../lib/function-manager.vala"
		_g_free0 (data);
#line 175 "../lib/function-manager.vala"
		data = _tmp26_;
#line 175 "../lib/function-manager.vala"
		_g_free0 (_tmp25_);
#line 175 "../lib/function-manager.vala"
		_g_free0 (_tmp17_);
#line 2946 "function-manager.c"
	}
#line 181 "../lib/function-manager.vala"
	_tmp27_ = self->priv->file_name;
#line 181 "../lib/function-manager.vala"
	_tmp28_ = g_path_get_dirname (_tmp27_);
#line 181 "../lib/function-manager.vala"
	dir = _tmp28_;
#line 182 "../lib/function-manager.vala"
	g_mkdir_with_parents (dir, 0700);
#line 2956 "function-manager.c"
	{
		const gchar* _tmp29_;
		const gchar* _tmp30_;
#line 185 "../lib/function-manager.vala"
		_tmp29_ = self->priv->file_name;
#line 185 "../lib/function-manager.vala"
		_tmp30_ = data;
#line 185 "../lib/function-manager.vala"
		g_file_set_contents (_tmp29_, _tmp30_, (gssize) -1, &_inner_error0_);
#line 185 "../lib/function-manager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 185 "../lib/function-manager.vala"
			if (_inner_error0_->domain == G_FILE_ERROR) {
#line 2970 "function-manager.c"
				goto __catch0_g_file_error;
			}
#line 185 "../lib/function-manager.vala"
			_g_free0 (dir);
#line 185 "../lib/function-manager.vala"
			_g_object_unref0 (math_function);
#line 185 "../lib/function-manager.vala"
			_g_free0 (name);
#line 185 "../lib/function-manager.vala"
			_g_free0 (data);
#line 185 "../lib/function-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 185 "../lib/function-manager.vala"
			g_clear_error (&_inner_error0_);
#line 185 "../lib/function-manager.vala"
			return;
#line 2987 "function-manager.c"
		}
	}
	goto __finally0;
	__catch0_g_file_error:
	{
#line 183 "../lib/function-manager.vala"
		g_clear_error (&_inner_error0_);
#line 2995 "function-manager.c"
	}
	__finally0:
#line 183 "../lib/function-manager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 183 "../lib/function-manager.vala"
		_g_free0 (dir);
#line 183 "../lib/function-manager.vala"
		_g_object_unref0 (math_function);
#line 183 "../lib/function-manager.vala"
		_g_free0 (name);
#line 183 "../lib/function-manager.vala"
		_g_free0 (data);
#line 183 "../lib/function-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 183 "../lib/function-manager.vala"
		g_clear_error (&_inner_error0_);
#line 183 "../lib/function-manager.vala"
		return;
#line 3014 "function-manager.c"
	}
#line 164 "../lib/function-manager.vala"
	_g_free0 (dir);
#line 164 "../lib/function-manager.vala"
	_g_object_unref0 (math_function);
#line 164 "../lib/function-manager.vala"
	_g_free0 (name);
#line 164 "../lib/function-manager.vala"
	_g_free0 (data);
#line 3024 "function-manager.c"
}

static gchar**
_vala_array_dup2 (gchar** self,
                  gssize length)
{
#line 213 "../lib/function-manager.vala"
	if (length >= 0) {
#line 3033 "function-manager.c"
		gchar** result;
		gssize i;
#line 213 "../lib/function-manager.vala"
		result = g_new0 (gchar*, length + 1);
#line 213 "../lib/function-manager.vala"
		for (i = 0; i < length; i++) {
#line 3040 "function-manager.c"
			gchar* _tmp0_;
#line 213 "../lib/function-manager.vala"
			_tmp0_ = g_strdup (self[i]);
#line 213 "../lib/function-manager.vala"
			result[i] = _tmp0_;
#line 3046 "function-manager.c"
		}
#line 213 "../lib/function-manager.vala"
		return result;
#line 3050 "function-manager.c"
	}
#line 213 "../lib/function-manager.vala"
	return NULL;
#line 3054 "function-manager.c"
}

static gchar**
function_manager_array_sort_string (FunctionManager* self,
                                    gchar** array,
                                    gint array_length1,
                                    gint* result_length1)
{
	gboolean swapped = FALSE;
	gint _tmp0_ = 0;
	const gchar* _tmp1_;
	gint j = 0;
	gchar* tmp = NULL;
	gchar** _tmp13_;
	gint _tmp13__length1;
	gchar** _tmp14_;
	gint _tmp14__length1;
	gchar** result;
#line 192 "../lib/function-manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 194 "../lib/function-manager.vala"
	swapped = TRUE;
#line 195 "../lib/function-manager.vala"
	_tmp1_ = array[array_length1 - 1];
#line 195 "../lib/function-manager.vala"
	if (_tmp1_ == NULL) {
#line 195 "../lib/function-manager.vala"
		_tmp0_ = 1;
#line 3083 "function-manager.c"
	} else {
#line 195 "../lib/function-manager.vala"
		_tmp0_ = 0;
#line 3087 "function-manager.c"
	}
#line 195 "../lib/function-manager.vala"
	j = _tmp0_;
#line 198 "../lib/function-manager.vala"
	while (TRUE) {
#line 3093 "function-manager.c"
		gint _tmp2_;
#line 198 "../lib/function-manager.vala"
		if (!swapped) {
#line 198 "../lib/function-manager.vala"
			break;
#line 3099 "function-manager.c"
		}
#line 200 "../lib/function-manager.vala"
		swapped = FALSE;
#line 201 "../lib/function-manager.vala"
		_tmp2_ = j;
#line 201 "../lib/function-manager.vala"
		j = _tmp2_ + 1;
#line 3107 "function-manager.c"
		{
			gint i = 0;
#line 202 "../lib/function-manager.vala"
			i = 0;
#line 3112 "function-manager.c"
			{
				gboolean _tmp3_ = FALSE;
#line 202 "../lib/function-manager.vala"
				_tmp3_ = TRUE;
#line 202 "../lib/function-manager.vala"
				while (TRUE) {
#line 3119 "function-manager.c"
					const gchar* _tmp5_;
					const gchar* _tmp6_;
#line 202 "../lib/function-manager.vala"
					if (!_tmp3_) {
#line 3124 "function-manager.c"
						gint _tmp4_;
#line 202 "../lib/function-manager.vala"
						_tmp4_ = i;
#line 202 "../lib/function-manager.vala"
						i = _tmp4_ + 1;
#line 3130 "function-manager.c"
					}
#line 202 "../lib/function-manager.vala"
					_tmp3_ = FALSE;
#line 202 "../lib/function-manager.vala"
					if (!(i < (array_length1 - j))) {
#line 202 "../lib/function-manager.vala"
						break;
#line 3138 "function-manager.c"
					}
#line 204 "../lib/function-manager.vala"
					_tmp5_ = array[i];
#line 204 "../lib/function-manager.vala"
					_tmp6_ = array[i + 1];
#line 204 "../lib/function-manager.vala"
					if (g_strcmp0 (_tmp5_, _tmp6_) < 0) {
#line 3146 "function-manager.c"
						const gchar* _tmp7_;
						gchar* _tmp8_;
						const gchar* _tmp9_;
						gchar* _tmp10_;
						const gchar* _tmp11_;
						gchar* _tmp12_;
#line 206 "../lib/function-manager.vala"
						_tmp7_ = array[i];
#line 206 "../lib/function-manager.vala"
						_tmp8_ = g_strdup (_tmp7_);
#line 206 "../lib/function-manager.vala"
						_g_free0 (tmp);
#line 206 "../lib/function-manager.vala"
						tmp = _tmp8_;
#line 207 "../lib/function-manager.vala"
						_tmp9_ = array[i + 1];
#line 207 "../lib/function-manager.vala"
						_tmp10_ = g_strdup (_tmp9_);
#line 207 "../lib/function-manager.vala"
						_g_free0 (array[i]);
#line 207 "../lib/function-manager.vala"
						array[i] = _tmp10_;
#line 208 "../lib/function-manager.vala"
						_tmp11_ = tmp;
#line 208 "../lib/function-manager.vala"
						_tmp12_ = g_strdup (_tmp11_);
#line 208 "../lib/function-manager.vala"
						_g_free0 (array[i + 1]);
#line 208 "../lib/function-manager.vala"
						array[i + 1] = _tmp12_;
#line 209 "../lib/function-manager.vala"
						swapped = TRUE;
#line 3179 "function-manager.c"
					}
				}
			}
		}
	}
#line 213 "../lib/function-manager.vala"
	_tmp13_ = (array != NULL) ? _vala_array_dup2 (array, array_length1) : array;
#line 213 "../lib/function-manager.vala"
	_tmp13__length1 = array_length1;
#line 213 "../lib/function-manager.vala"
	_tmp14_ = _tmp13_;
#line 213 "../lib/function-manager.vala"
	_tmp14__length1 = _tmp13__length1;
#line 213 "../lib/function-manager.vala"
	if (result_length1) {
#line 213 "../lib/function-manager.vala"
		*result_length1 = _tmp14__length1;
#line 3197 "function-manager.c"
	}
#line 213 "../lib/function-manager.vala"
	result = _tmp14_;
#line 213 "../lib/function-manager.vala"
	_g_free0 (tmp);
#line 213 "../lib/function-manager.vala"
	return result;
#line 3205 "function-manager.c"
}

gchar**
function_manager_get_names (FunctionManager* self,
                            gint* result_length1)
{
	gchar** names = NULL;
	GHashTable* _tmp0_;
	gchar** _tmp1_;
	gint names_length1;
	gint _names_size_;
	GHashTableIter iter = {0};
	GHashTable* _tmp2_;
	gint i = 0;
	gchar* name = NULL;
	MathFunction* definition = NULL;
	gchar** _tmp12_;
	gint _tmp12__length1;
	gchar** _tmp13_;
	gint _tmp13__length1;
	gint _tmp14_ = 0;
	gchar** _tmp15_;
	gchar** _tmp16_;
	gint _tmp16__length1;
	gchar** result;
#line 216 "../lib/function-manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 218 "../lib/function-manager.vala"
	_tmp0_ = self->priv->functions;
#line 218 "../lib/function-manager.vala"
	_tmp1_ = g_new0 (gchar*, (g_hash_table_size (_tmp0_) + 1) + 1);
#line 218 "../lib/function-manager.vala"
	names = _tmp1_;
#line 218 "../lib/function-manager.vala"
	names_length1 = g_hash_table_size (_tmp0_) + 1;
#line 218 "../lib/function-manager.vala"
	_names_size_ = names_length1;
#line 220 "../lib/function-manager.vala"
	_tmp2_ = self->priv->functions;
#line 220 "../lib/function-manager.vala"
	g_hash_table_iter_init (&iter, _tmp2_);
#line 221 "../lib/function-manager.vala"
	i = 0;
#line 224 "../lib/function-manager.vala"
	while (TRUE) {
#line 3251 "function-manager.c"
		gconstpointer _tmp3_ = NULL;
		gconstpointer _tmp4_ = NULL;
		gboolean _tmp5_;
		gchar* _tmp6_;
		MathFunction* _tmp7_;
		gchar** _tmp8_;
		gint _tmp8__length1;
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gint _tmp11_;
#line 224 "../lib/function-manager.vala"
		_tmp5_ = g_hash_table_iter_next (&iter, (gpointer*) (&_tmp3_), (gpointer*) (&_tmp4_));
#line 224 "../lib/function-manager.vala"
		_g_free0 (name);
#line 224 "../lib/function-manager.vala"
		_tmp6_ = g_strdup ((const gchar*) _tmp3_);
#line 224 "../lib/function-manager.vala"
		name = _tmp6_;
#line 224 "../lib/function-manager.vala"
		_g_object_unref0 (definition);
#line 224 "../lib/function-manager.vala"
		_tmp7_ = _g_object_ref0 ((MathFunction*) _tmp4_);
#line 224 "../lib/function-manager.vala"
		definition = _tmp7_;
#line 224 "../lib/function-manager.vala"
		if (!_tmp5_) {
#line 224 "../lib/function-manager.vala"
			break;
#line 3280 "function-manager.c"
		}
#line 226 "../lib/function-manager.vala"
		_tmp8_ = names;
#line 226 "../lib/function-manager.vala"
		_tmp8__length1 = names_length1;
#line 226 "../lib/function-manager.vala"
		_tmp9_ = name;
#line 226 "../lib/function-manager.vala"
		_tmp10_ = g_strdup (_tmp9_);
#line 226 "../lib/function-manager.vala"
		_g_free0 (_tmp8_[i]);
#line 226 "../lib/function-manager.vala"
		_tmp8_[i] = _tmp10_;
#line 227 "../lib/function-manager.vala"
		_tmp11_ = i;
#line 227 "../lib/function-manager.vala"
		i = _tmp11_ + 1;
#line 3298 "function-manager.c"
	}
#line 229 "../lib/function-manager.vala"
	_tmp12_ = names;
#line 229 "../lib/function-manager.vala"
	_tmp12__length1 = names_length1;
#line 229 "../lib/function-manager.vala"
	_g_free0 (_tmp12_[i]);
#line 229 "../lib/function-manager.vala"
	_tmp12_[i] = NULL;
#line 231 "../lib/function-manager.vala"
	_tmp13_ = names;
#line 231 "../lib/function-manager.vala"
	_tmp13__length1 = names_length1;
#line 231 "../lib/function-manager.vala"
	_tmp15_ = function_manager_array_sort_string (self, _tmp13_, (gint) _tmp13__length1, &_tmp14_);
#line 231 "../lib/function-manager.vala"
	_tmp16_ = _tmp15_;
#line 231 "../lib/function-manager.vala"
	_tmp16__length1 = _tmp14_;
#line 231 "../lib/function-manager.vala"
	if (result_length1) {
#line 231 "../lib/function-manager.vala"
		*result_length1 = _tmp16__length1;
#line 3322 "function-manager.c"
	}
#line 231 "../lib/function-manager.vala"
	result = _tmp16_;
#line 231 "../lib/function-manager.vala"
	_g_object_unref0 (definition);
#line 231 "../lib/function-manager.vala"
	_g_free0 (name);
#line 231 "../lib/function-manager.vala"
	names = (_vala_array_free (names, names_length1, (GDestroyNotify) g_free), NULL);
#line 231 "../lib/function-manager.vala"
	return result;
#line 3334 "function-manager.c"
}

/**
      * Adds a function to the manager, unless the given name is already taken
      * by a predefined function.
      * @return If the function was successfully added.
      */
static gboolean
function_manager_add (FunctionManager* self,
                      MathFunction* new_function)
{
	MathFunction* existing_function = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	MathFunction* _tmp2_;
	gboolean _tmp3_ = FALSE;
	MathFunction* _tmp4_;
	GHashTable* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	MathFunction* _tmp10_;
	MathFunction* _tmp11_;
	gboolean result;
#line 239 "../lib/function-manager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 239 "../lib/function-manager.vala"
	g_return_val_if_fail (new_function != NULL, FALSE);
#line 241 "../lib/function-manager.vala"
	_tmp0_ = math_function_get_name (new_function);
#line 241 "../lib/function-manager.vala"
	_tmp1_ = _tmp0_;
#line 241 "../lib/function-manager.vala"
	_tmp2_ = function_manager_get (self, _tmp1_);
#line 241 "../lib/function-manager.vala"
	existing_function = _tmp2_;
#line 243 "../lib/function-manager.vala"
	_tmp4_ = existing_function;
#line 243 "../lib/function-manager.vala"
	if (_tmp4_ != NULL) {
#line 3375 "function-manager.c"
		MathFunction* _tmp5_;
#line 243 "../lib/function-manager.vala"
		_tmp5_ = existing_function;
#line 243 "../lib/function-manager.vala"
		_tmp3_ = !math_function_is_custom_function (_tmp5_);
#line 3381 "function-manager.c"
	} else {
#line 243 "../lib/function-manager.vala"
		_tmp3_ = FALSE;
#line 3385 "function-manager.c"
	}
#line 243 "../lib/function-manager.vala"
	if (_tmp3_) {
#line 244 "../lib/function-manager.vala"
		result = FALSE;
#line 244 "../lib/function-manager.vala"
		_g_object_unref0 (existing_function);
#line 244 "../lib/function-manager.vala"
		return result;
#line 3395 "function-manager.c"
	}
#line 246 "../lib/function-manager.vala"
	_tmp6_ = self->priv->functions;
#line 246 "../lib/function-manager.vala"
	_tmp7_ = math_function_get_name (new_function);
#line 246 "../lib/function-manager.vala"
	_tmp8_ = _tmp7_;
#line 246 "../lib/function-manager.vala"
	_tmp9_ = g_strdup (_tmp8_);
#line 246 "../lib/function-manager.vala"
	_tmp10_ = _g_object_ref0 (new_function);
#line 246 "../lib/function-manager.vala"
	g_hash_table_insert (_tmp6_, _tmp9_, _tmp10_);
#line 247 "../lib/function-manager.vala"
	_tmp11_ = existing_function;
#line 247 "../lib/function-manager.vala"
	if (_tmp11_ != NULL) {
#line 248 "../lib/function-manager.vala"
		g_signal_emit (self, function_manager_signals[FUNCTION_MANAGER_FUNCTION_EDITED_SIGNAL], 0, new_function);
#line 3415 "function-manager.c"
	} else {
#line 250 "../lib/function-manager.vala"
		g_signal_emit (self, function_manager_signals[FUNCTION_MANAGER_FUNCTION_ADDED_SIGNAL], 0, new_function);
#line 3419 "function-manager.c"
	}
#line 252 "../lib/function-manager.vala"
	result = TRUE;
#line 252 "../lib/function-manager.vala"
	_g_object_unref0 (existing_function);
#line 252 "../lib/function-manager.vala"
	return result;
#line 3427 "function-manager.c"
}

gboolean
function_manager_add_function_with_properties (FunctionManager* self,
                                               const gchar* name,
                                               const gchar* arguments,
                                               const gchar* description,
                                               Parser* root_parser)
{
	gchar* function_string = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	MathFunction* new_function = NULL;
	const gchar* _tmp8_;
	MathFunction* _tmp9_;
	gboolean _tmp10_ = FALSE;
	MathFunction* _tmp11_;
	gboolean is_function_added = FALSE;
	MathFunction* _tmp13_;
	gboolean result;
#line 255 "../lib/function-manager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 255 "../lib/function-manager.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 255 "../lib/function-manager.vala"
	g_return_val_if_fail (arguments != NULL, FALSE);
#line 255 "../lib/function-manager.vala"
	g_return_val_if_fail (description != NULL, FALSE);
#line 257 "../lib/function-manager.vala"
	_tmp0_ = g_strconcat (name, "(", NULL);
#line 257 "../lib/function-manager.vala"
	_tmp1_ = _tmp0_;
#line 257 "../lib/function-manager.vala"
	_tmp2_ = g_strconcat (_tmp1_, arguments, NULL);
#line 257 "../lib/function-manager.vala"
	_tmp3_ = _tmp2_;
#line 257 "../lib/function-manager.vala"
	_tmp4_ = g_strconcat (_tmp3_, ")=", NULL);
#line 257 "../lib/function-manager.vala"
	_tmp5_ = _tmp4_;
#line 257 "../lib/function-manager.vala"
	_tmp6_ = g_strconcat (_tmp5_, description, NULL);
#line 257 "../lib/function-manager.vala"
	_tmp7_ = _tmp6_;
#line 257 "../lib/function-manager.vala"
	_g_free0 (_tmp5_);
#line 257 "../lib/function-manager.vala"
	_g_free0 (_tmp3_);
#line 257 "../lib/function-manager.vala"
	_g_free0 (_tmp1_);
#line 257 "../lib/function-manager.vala"
	function_string = _tmp7_;
#line 258 "../lib/function-manager.vala"
	_tmp8_ = function_string;
#line 258 "../lib/function-manager.vala"
	_tmp9_ = function_manager_parse_function_from_string (self, _tmp8_);
#line 258 "../lib/function-manager.vala"
	new_function = _tmp9_;
#line 260 "../lib/function-manager.vala"
	_tmp11_ = new_function;
#line 260 "../lib/function-manager.vala"
	if (_tmp11_ == NULL) {
#line 260 "../lib/function-manager.vala"
		_tmp10_ = TRUE;
#line 3498 "function-manager.c"
	} else {
		MathFunction* _tmp12_;
#line 260 "../lib/function-manager.vala"
		_tmp12_ = new_function;
#line 260 "../lib/function-manager.vala"
		_tmp10_ = math_function_validate (_tmp12_, root_parser) == FALSE;
#line 3505 "function-manager.c"
	}
#line 260 "../lib/function-manager.vala"
	if (_tmp10_) {
#line 262 "../lib/function-manager.vala"
		parser_set_error (root_parser, ERROR_CODE_INVALID, NULL, (guint) 0, (guint) 0);
#line 263 "../lib/function-manager.vala"
		result = FALSE;
#line 263 "../lib/function-manager.vala"
		_g_object_unref0 (new_function);
#line 263 "../lib/function-manager.vala"
		_g_free0 (function_string);
#line 263 "../lib/function-manager.vala"
		return result;
#line 3519 "function-manager.c"
	}
#line 266 "../lib/function-manager.vala"
	_tmp13_ = new_function;
#line 266 "../lib/function-manager.vala"
	is_function_added = function_manager_add (self, _tmp13_);
#line 267 "../lib/function-manager.vala"
	if (is_function_added) {
#line 268 "../lib/function-manager.vala"
		function_manager_save (self);
#line 3529 "function-manager.c"
	}
#line 270 "../lib/function-manager.vala"
	result = is_function_added;
#line 270 "../lib/function-manager.vala"
	_g_object_unref0 (new_function);
#line 270 "../lib/function-manager.vala"
	_g_free0 (function_string);
#line 270 "../lib/function-manager.vala"
	return result;
#line 3539 "function-manager.c"
}

MathFunction*
function_manager_get (FunctionManager* self,
                      const gchar* name)
{
	MathFunction* function = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	MathFunction* _tmp2_;
	MathFunction* _tmp3_;
	GHashTable* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gconstpointer _tmp7_;
	MathFunction* _tmp8_;
	MathFunction* _tmp9_;
	MathFunction* result;
#line 273 "../lib/function-manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 273 "../lib/function-manager.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 275 "../lib/function-manager.vala"
	_tmp0_ = self->priv->functions;
#line 275 "../lib/function-manager.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, name);
#line 275 "../lib/function-manager.vala"
	_tmp2_ = _g_object_ref0 ((MathFunction*) _tmp1_);
#line 275 "../lib/function-manager.vala"
	function = _tmp2_;
#line 276 "../lib/function-manager.vala"
	_tmp3_ = function;
#line 276 "../lib/function-manager.vala"
	if (_tmp3_ != NULL) {
#line 277 "../lib/function-manager.vala"
		result = function;
#line 277 "../lib/function-manager.vala"
		return result;
#line 3578 "function-manager.c"
	}
#line 278 "../lib/function-manager.vala"
	_tmp4_ = self->priv->functions;
#line 278 "../lib/function-manager.vala"
	_tmp5_ = g_utf8_strdown (name, (gssize) -1);
#line 278 "../lib/function-manager.vala"
	_tmp6_ = _tmp5_;
#line 278 "../lib/function-manager.vala"
	_tmp7_ = g_hash_table_lookup (_tmp4_, _tmp6_);
#line 278 "../lib/function-manager.vala"
	_tmp8_ = _g_object_ref0 ((MathFunction*) _tmp7_);
#line 278 "../lib/function-manager.vala"
	_tmp9_ = _tmp8_;
#line 278 "../lib/function-manager.vala"
	_g_free0 (_tmp6_);
#line 278 "../lib/function-manager.vala"
	result = _tmp9_;
#line 278 "../lib/function-manager.vala"
	_g_object_unref0 (function);
#line 278 "../lib/function-manager.vala"
	return result;
#line 3600 "function-manager.c"
}

void
function_manager_delete (FunctionManager* self,
                         const gchar* name)
{
	MathFunction* function = NULL;
	MathFunction* _tmp0_;
	gboolean _tmp1_ = FALSE;
	MathFunction* _tmp2_;
#line 281 "../lib/function-manager.vala"
	g_return_if_fail (self != NULL);
#line 281 "../lib/function-manager.vala"
	g_return_if_fail (name != NULL);
#line 283 "../lib/function-manager.vala"
	_tmp0_ = function_manager_get (self, name);
#line 283 "../lib/function-manager.vala"
	function = _tmp0_;
#line 284 "../lib/function-manager.vala"
	_tmp2_ = function;
#line 284 "../lib/function-manager.vala"
	if (_tmp2_ != NULL) {
#line 3623 "function-manager.c"
		MathFunction* _tmp3_;
#line 284 "../lib/function-manager.vala"
		_tmp3_ = function;
#line 284 "../lib/function-manager.vala"
		_tmp1_ = math_function_is_custom_function (_tmp3_);
#line 3629 "function-manager.c"
	} else {
#line 284 "../lib/function-manager.vala"
		_tmp1_ = FALSE;
#line 3633 "function-manager.c"
	}
#line 284 "../lib/function-manager.vala"
	if (_tmp1_) {
#line 3637 "function-manager.c"
		GHashTable* _tmp4_;
		MathFunction* _tmp5_;
#line 286 "../lib/function-manager.vala"
		_tmp4_ = self->priv->functions;
#line 286 "../lib/function-manager.vala"
		g_hash_table_remove (_tmp4_, name);
#line 287 "../lib/function-manager.vala"
		function_manager_save (self);
#line 288 "../lib/function-manager.vala"
		_tmp5_ = function;
#line 288 "../lib/function-manager.vala"
		g_signal_emit (self, function_manager_signals[FUNCTION_MANAGER_FUNCTION_DELETED_SIGNAL], 0, _tmp5_);
#line 3650 "function-manager.c"
	}
#line 281 "../lib/function-manager.vala"
	_g_object_unref0 (function);
#line 3654 "function-manager.c"
}

gboolean
function_manager_is_function_defined (FunctionManager* self,
                                      const gchar* name)
{
	gchar* lower_name = NULL;
	gchar* _tmp0_;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	gboolean _tmp6_ = FALSE;
	GHashTable* _tmp7_;
	gboolean result;
#line 292 "../lib/function-manager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 292 "../lib/function-manager.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 294 "../lib/function-manager.vala"
	_tmp0_ = g_utf8_strdown (name, (gssize) -1);
#line 294 "../lib/function-manager.vala"
	lower_name = _tmp0_;
#line 295 "../lib/function-manager.vala"
	_tmp2_ = lower_name;
#line 295 "../lib/function-manager.vala"
	if (g_str_has_prefix (_tmp2_, "log")) {
#line 3680 "function-manager.c"
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 295 "../lib/function-manager.vala"
		_tmp3_ = lower_name;
#line 295 "../lib/function-manager.vala"
		_tmp4_ = string_substring (_tmp3_, (glong) 3, (glong) -1);
#line 295 "../lib/function-manager.vala"
		_tmp5_ = _tmp4_;
#line 295 "../lib/function-manager.vala"
		_tmp1_ = sub_atoi (_tmp5_) >= 0;
#line 295 "../lib/function-manager.vala"
		_g_free0 (_tmp5_);
#line 3694 "function-manager.c"
	} else {
#line 295 "../lib/function-manager.vala"
		_tmp1_ = FALSE;
#line 3698 "function-manager.c"
	}
#line 295 "../lib/function-manager.vala"
	if (_tmp1_) {
#line 296 "../lib/function-manager.vala"
		result = TRUE;
#line 296 "../lib/function-manager.vala"
		_g_free0 (lower_name);
#line 296 "../lib/function-manager.vala"
		return result;
#line 3708 "function-manager.c"
	}
#line 297 "../lib/function-manager.vala"
	_tmp7_ = self->priv->functions;
#line 297 "../lib/function-manager.vala"
	if (g_hash_table_contains (_tmp7_, name)) {
#line 297 "../lib/function-manager.vala"
		_tmp6_ = TRUE;
#line 3716 "function-manager.c"
	} else {
		GHashTable* _tmp8_;
		const gchar* _tmp9_;
#line 297 "../lib/function-manager.vala"
		_tmp8_ = self->priv->functions;
#line 297 "../lib/function-manager.vala"
		_tmp9_ = lower_name;
#line 297 "../lib/function-manager.vala"
		_tmp6_ = g_hash_table_contains (_tmp8_, _tmp9_);
#line 3726 "function-manager.c"
	}
#line 297 "../lib/function-manager.vala"
	result = _tmp6_;
#line 297 "../lib/function-manager.vala"
	_g_free0 (lower_name);
#line 297 "../lib/function-manager.vala"
	return result;
#line 3734 "function-manager.c"
}

static Number**
_vala_array_dup3 (Number** self,
                  gssize length)
{
#line 303 "../lib/function-manager.vala"
	if (length >= 0) {
#line 3743 "function-manager.c"
		Number** result;
		gssize i;
#line 303 "../lib/function-manager.vala"
		result = g_new0 (Number*, length + 1);
#line 303 "../lib/function-manager.vala"
		for (i = 0; i < length; i++) {
#line 3750 "function-manager.c"
			Number* _tmp0_;
#line 303 "../lib/function-manager.vala"
			_tmp0_ = _g_object_ref0 (self[i]);
#line 303 "../lib/function-manager.vala"
			result[i] = _tmp0_;
#line 3756 "function-manager.c"
		}
#line 303 "../lib/function-manager.vala"
		return result;
#line 3760 "function-manager.c"
	}
#line 303 "../lib/function-manager.vala"
	return NULL;
#line 3764 "function-manager.c"
}

static void
_vala_array_add4 (Number** * array,
                  gint* length,
                  gint* size,
                  Number* value)
{
#line 307 "../lib/function-manager.vala"
	if ((*length) == (*size)) {
#line 307 "../lib/function-manager.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 307 "../lib/function-manager.vala"
		*array = g_renew (Number*, *array, (*size) + 1);
#line 3779 "function-manager.c"
	}
#line 307 "../lib/function-manager.vala"
	(*array)[(*length)++] = value;
#line 307 "../lib/function-manager.vala"
	(*array)[*length] = NULL;
#line 3785 "function-manager.c"
}

Number*
function_manager_evaluate_function (FunctionManager* self,
                                    const gchar* name,
                                    Number** arguments,
                                    gint arguments_length1,
                                    Parser* parser)
{
	gchar* lower_name = NULL;
	gchar* _tmp0_;
	Number** args = NULL;
	Number** _tmp1_;
	gint _tmp1__length1;
	gint args_length1;
	gint _args_size_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
	MathFunction* function = NULL;
	MathFunction* _tmp14_;
	MathFunction* _tmp15_;
	MathFunction* _tmp16_;
	Number** _tmp17_;
	gint _tmp17__length1;
	Number* _tmp18_;
	Number* result;
#line 300 "../lib/function-manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 300 "../lib/function-manager.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 300 "../lib/function-manager.vala"
	g_return_val_if_fail (parser != NULL, NULL);
#line 302 "../lib/function-manager.vala"
	_tmp0_ = g_utf8_strdown (name, (gssize) -1);
#line 302 "../lib/function-manager.vala"
	lower_name = _tmp0_;
#line 303 "../lib/function-manager.vala"
	_tmp1_ = (arguments != NULL) ? _vala_array_dup3 (arguments, arguments_length1) : arguments;
#line 303 "../lib/function-manager.vala"
	_tmp1__length1 = arguments_length1;
#line 303 "../lib/function-manager.vala"
	args = _tmp1_;
#line 303 "../lib/function-manager.vala"
	args_length1 = _tmp1__length1;
#line 303 "../lib/function-manager.vala"
	_args_size_ = args_length1;
#line 304 "../lib/function-manager.vala"
	_tmp3_ = lower_name;
#line 304 "../lib/function-manager.vala"
	if (g_str_has_prefix (_tmp3_, "log")) {
#line 3836 "function-manager.c"
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 304 "../lib/function-manager.vala"
		_tmp4_ = lower_name;
#line 304 "../lib/function-manager.vala"
		_tmp5_ = string_substring (_tmp4_, (glong) 3, (glong) -1);
#line 304 "../lib/function-manager.vala"
		_tmp6_ = _tmp5_;
#line 304 "../lib/function-manager.vala"
		_tmp2_ = sub_atoi (_tmp6_) > 0;
#line 304 "../lib/function-manager.vala"
		_g_free0 (_tmp6_);
#line 3850 "function-manager.c"
	} else {
#line 304 "../lib/function-manager.vala"
		_tmp2_ = FALSE;
#line 3854 "function-manager.c"
	}
#line 304 "../lib/function-manager.vala"
	if (_tmp2_) {
#line 3858 "function-manager.c"
		Number* log_base = NULL;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		Number* _tmp10_;
		Number* _tmp11_;
		Number* _tmp12_;
		Number* _tmp13_;
#line 306 "../lib/function-manager.vala"
		_tmp7_ = lower_name;
#line 306 "../lib/function-manager.vala"
		_tmp8_ = string_substring (_tmp7_, (glong) 3, (glong) -1);
#line 306 "../lib/function-manager.vala"
		_tmp9_ = _tmp8_;
#line 306 "../lib/function-manager.vala"
		_tmp10_ = number_new_integer ((gint64) sub_atoi (_tmp9_), (gint64) 0);
#line 306 "../lib/function-manager.vala"
		_tmp11_ = _tmp10_;
#line 306 "../lib/function-manager.vala"
		_g_free0 (_tmp9_);
#line 306 "../lib/function-manager.vala"
		log_base = _tmp11_;
#line 307 "../lib/function-manager.vala"
		_tmp12_ = log_base;
#line 307 "../lib/function-manager.vala"
		_tmp13_ = _g_object_ref0 (_tmp12_);
#line 307 "../lib/function-manager.vala"
		_vala_array_add4 (&args, &args_length1, &_args_size_, _tmp13_);
#line 308 "../lib/function-manager.vala"
		name = "log";
#line 304 "../lib/function-manager.vala"
		_g_object_unref0 (log_base);
#line 3891 "function-manager.c"
	}
#line 311 "../lib/function-manager.vala"
	_tmp14_ = function_manager_get (self, name);
#line 311 "../lib/function-manager.vala"
	function = _tmp14_;
#line 312 "../lib/function-manager.vala"
	_tmp15_ = function;
#line 312 "../lib/function-manager.vala"
	if (_tmp15_ == NULL) {
#line 314 "../lib/function-manager.vala"
		parser_set_error (parser, ERROR_CODE_UNKNOWN_FUNCTION, NULL, (guint) 0, (guint) 0);
#line 315 "../lib/function-manager.vala"
		result = NULL;
#line 315 "../lib/function-manager.vala"
		_g_object_unref0 (function);
#line 315 "../lib/function-manager.vala"
		args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_object_unref), NULL);
#line 315 "../lib/function-manager.vala"
		_g_free0 (lower_name);
#line 315 "../lib/function-manager.vala"
		return result;
#line 3913 "function-manager.c"
	}
#line 318 "../lib/function-manager.vala"
	_tmp16_ = function;
#line 318 "../lib/function-manager.vala"
	_tmp17_ = args;
#line 318 "../lib/function-manager.vala"
	_tmp17__length1 = args_length1;
#line 318 "../lib/function-manager.vala"
	_tmp18_ = math_function_evaluate (_tmp16_, _tmp17_, (gint) _tmp17__length1, parser);
#line 318 "../lib/function-manager.vala"
	result = _tmp18_;
#line 318 "../lib/function-manager.vala"
	_g_object_unref0 (function);
#line 318 "../lib/function-manager.vala"
	args = (_vala_array_free (args, args_length1, (GDestroyNotify) g_object_unref), NULL);
#line 318 "../lib/function-manager.vala"
	_g_free0 (lower_name);
#line 318 "../lib/function-manager.vala"
	return result;
#line 3933 "function-manager.c"
}

static MathFunction**
_vala_array_dup4 (MathFunction** self,
                  gssize length)
{
#line 324 "../lib/function-manager.vala"
	if (length >= 0) {
#line 3942 "function-manager.c"
		MathFunction** result;
		gssize i;
#line 324 "../lib/function-manager.vala"
		result = g_new0 (MathFunction*, length + 1);
#line 324 "../lib/function-manager.vala"
		for (i = 0; i < length; i++) {
#line 3949 "function-manager.c"
			MathFunction* _tmp0_;
#line 324 "../lib/function-manager.vala"
			_tmp0_ = _g_object_ref0 (self[i]);
#line 324 "../lib/function-manager.vala"
			result[i] = _tmp0_;
#line 3955 "function-manager.c"
		}
#line 324 "../lib/function-manager.vala"
		return result;
#line 3959 "function-manager.c"
	}
#line 324 "../lib/function-manager.vala"
	return NULL;
#line 3963 "function-manager.c"
}

static MathFunction**
_vala_array_dup5 (MathFunction** self,
                  gssize length)
{
#line 346 "../lib/function-manager.vala"
	if (length >= 0) {
#line 3972 "function-manager.c"
		MathFunction** result;
		gssize i;
#line 346 "../lib/function-manager.vala"
		result = g_new0 (MathFunction*, length + 1);
#line 346 "../lib/function-manager.vala"
		for (i = 0; i < length; i++) {
#line 3979 "function-manager.c"
			MathFunction* _tmp0_;
#line 346 "../lib/function-manager.vala"
			_tmp0_ = _g_object_ref0 (self[i]);
#line 346 "../lib/function-manager.vala"
			result[i] = _tmp0_;
#line 3985 "function-manager.c"
		}
#line 346 "../lib/function-manager.vala"
		return result;
#line 3989 "function-manager.c"
	}
#line 346 "../lib/function-manager.vala"
	return NULL;
#line 3993 "function-manager.c"
}

static MathFunction**
function_manager_array_sort_math_function (FunctionManager* self,
                                           MathFunction** array,
                                           gint array_length1,
                                           gint* result_length1)
{
	gboolean swapped = FALSE;
	gint _tmp2_ = 0;
	MathFunction* _tmp3_;
	gint j = 0;
	MathFunction* tmp = NULL;
	MathFunction** _tmp21_;
	gint _tmp21__length1;
	MathFunction** _tmp22_;
	gint _tmp22__length1;
	MathFunction** result;
#line 321 "../lib/function-manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 323 "../lib/function-manager.vala"
	if (array_length1 == 0) {
#line 4016 "function-manager.c"
		MathFunction** _tmp0_;
		gint _tmp0__length1;
		MathFunction** _tmp1_;
		gint _tmp1__length1;
#line 324 "../lib/function-manager.vala"
		_tmp0_ = (array != NULL) ? _vala_array_dup4 (array, array_length1) : array;
#line 324 "../lib/function-manager.vala"
		_tmp0__length1 = array_length1;
#line 324 "../lib/function-manager.vala"
		_tmp1_ = _tmp0_;
#line 324 "../lib/function-manager.vala"
		_tmp1__length1 = _tmp0__length1;
#line 324 "../lib/function-manager.vala"
		if (result_length1) {
#line 324 "../lib/function-manager.vala"
			*result_length1 = _tmp1__length1;
#line 4033 "function-manager.c"
		}
#line 324 "../lib/function-manager.vala"
		result = _tmp1_;
#line 324 "../lib/function-manager.vala"
		return result;
#line 4039 "function-manager.c"
	}
#line 325 "../lib/function-manager.vala"
	swapped = TRUE;
#line 326 "../lib/function-manager.vala"
	_tmp3_ = array[array_length1 - 1];
#line 326 "../lib/function-manager.vala"
	if (_tmp3_ == NULL) {
#line 326 "../lib/function-manager.vala"
		_tmp2_ = 1;
#line 4049 "function-manager.c"
	} else {
#line 326 "../lib/function-manager.vala"
		_tmp2_ = 0;
#line 4053 "function-manager.c"
	}
#line 326 "../lib/function-manager.vala"
	j = _tmp2_;
#line 329 "../lib/function-manager.vala"
	while (TRUE) {
#line 4059 "function-manager.c"
		gint _tmp4_;
		gint _tmp5_;
#line 329 "../lib/function-manager.vala"
		if (!swapped) {
#line 329 "../lib/function-manager.vala"
			break;
#line 4066 "function-manager.c"
		}
#line 331 "../lib/function-manager.vala"
		swapped = FALSE;
#line 332 "../lib/function-manager.vala"
		_tmp4_ = j;
#line 332 "../lib/function-manager.vala"
		j = _tmp4_ + 1;
#line 333 "../lib/function-manager.vala"
		_tmp5_ = j;
#line 333 "../lib/function-manager.vala"
		_vala_assert ((0 <= _tmp5_) && (_tmp5_ <= array_length1), "0 <= j <= array.length");
#line 4078 "function-manager.c"
		{
			gint i = 0;
#line 334 "../lib/function-manager.vala"
			i = 0;
#line 4083 "function-manager.c"
			{
				gboolean _tmp6_ = FALSE;
#line 334 "../lib/function-manager.vala"
				_tmp6_ = TRUE;
#line 334 "../lib/function-manager.vala"
				while (TRUE) {
#line 4090 "function-manager.c"
					gint _tmp8_;
					MathFunction* _tmp9_;
					const gchar* _tmp10_;
					const gchar* _tmp11_;
					MathFunction* _tmp12_;
					const gchar* _tmp13_;
					const gchar* _tmp14_;
#line 334 "../lib/function-manager.vala"
					if (!_tmp6_) {
#line 4100 "function-manager.c"
						gint _tmp7_;
#line 334 "../lib/function-manager.vala"
						_tmp7_ = i;
#line 334 "../lib/function-manager.vala"
						i = _tmp7_ + 1;
#line 4106 "function-manager.c"
					}
#line 334 "../lib/function-manager.vala"
					_tmp6_ = FALSE;
#line 334 "../lib/function-manager.vala"
					if (!(i < (array_length1 - j))) {
#line 334 "../lib/function-manager.vala"
						break;
#line 4114 "function-manager.c"
					}
#line 336 "../lib/function-manager.vala"
					_tmp8_ = i + 1;
#line 336 "../lib/function-manager.vala"
					_vala_assert ((0 <= _tmp8_) && (_tmp8_ < array_length1), "0 <= (i+1) < array.length");
#line 337 "../lib/function-manager.vala"
					_tmp9_ = array[i];
#line 337 "../lib/function-manager.vala"
					_tmp10_ = math_function_get_name (_tmp9_);
#line 337 "../lib/function-manager.vala"
					_tmp11_ = _tmp10_;
#line 337 "../lib/function-manager.vala"
					_tmp12_ = array[i + 1];
#line 337 "../lib/function-manager.vala"
					_tmp13_ = math_function_get_name (_tmp12_);
#line 337 "../lib/function-manager.vala"
					_tmp14_ = _tmp13_;
#line 337 "../lib/function-manager.vala"
					if (g_strcmp0 (_tmp11_, _tmp14_) > 0) {
#line 4134 "function-manager.c"
						MathFunction* _tmp15_;
						MathFunction* _tmp16_;
						MathFunction* _tmp17_;
						MathFunction* _tmp18_;
						MathFunction* _tmp19_;
						MathFunction* _tmp20_;
#line 339 "../lib/function-manager.vala"
						_tmp15_ = array[i];
#line 339 "../lib/function-manager.vala"
						_tmp16_ = _g_object_ref0 (_tmp15_);
#line 339 "../lib/function-manager.vala"
						_g_object_unref0 (tmp);
#line 339 "../lib/function-manager.vala"
						tmp = _tmp16_;
#line 340 "../lib/function-manager.vala"
						_tmp17_ = array[i + 1];
#line 340 "../lib/function-manager.vala"
						_tmp18_ = _g_object_ref0 (_tmp17_);
#line 340 "../lib/function-manager.vala"
						_g_object_unref0 (array[i]);
#line 340 "../lib/function-manager.vala"
						array[i] = _tmp18_;
#line 341 "../lib/function-manager.vala"
						_tmp19_ = tmp;
#line 341 "../lib/function-manager.vala"
						_tmp20_ = _g_object_ref0 (_tmp19_);
#line 341 "../lib/function-manager.vala"
						_g_object_unref0 (array[i + 1]);
#line 341 "../lib/function-manager.vala"
						array[i + 1] = _tmp20_;
#line 342 "../lib/function-manager.vala"
						swapped = TRUE;
#line 4167 "function-manager.c"
					}
				}
			}
		}
	}
#line 346 "../lib/function-manager.vala"
	_tmp21_ = (array != NULL) ? _vala_array_dup5 (array, array_length1) : array;
#line 346 "../lib/function-manager.vala"
	_tmp21__length1 = array_length1;
#line 346 "../lib/function-manager.vala"
	_tmp22_ = _tmp21_;
#line 346 "../lib/function-manager.vala"
	_tmp22__length1 = _tmp21__length1;
#line 346 "../lib/function-manager.vala"
	if (result_length1) {
#line 346 "../lib/function-manager.vala"
		*result_length1 = _tmp22__length1;
#line 4185 "function-manager.c"
	}
#line 346 "../lib/function-manager.vala"
	result = _tmp22_;
#line 346 "../lib/function-manager.vala"
	_g_object_unref0 (tmp);
#line 346 "../lib/function-manager.vala"
	return result;
#line 4193 "function-manager.c"
}

static void
_vala_array_add5 (MathFunction** * array,
                  gint* length,
                  gint* size,
                  MathFunction* value)
{
#line 361 "../lib/function-manager.vala"
	if ((*length) == (*size)) {
#line 361 "../lib/function-manager.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 361 "../lib/function-manager.vala"
		*array = g_renew (MathFunction*, *array, (*size) + 1);
#line 4208 "function-manager.c"
	}
#line 361 "../lib/function-manager.vala"
	(*array)[(*length)++] = value;
#line 361 "../lib/function-manager.vala"
	(*array)[*length] = NULL;
#line 4214 "function-manager.c"
}

MathFunction**
function_manager_functions_eligible_for_autocompletion (FunctionManager* self,
                                                        const gchar* text,
                                                        gint* result_length1)
{
	MathFunction** eligible_functions = NULL;
	MathFunction** _tmp0_;
	gint eligible_functions_length1;
	gint _eligible_functions_size_;
	gchar* text_case_insensitive = NULL;
	gchar* _tmp1_;
	GHashTableIter iter = {0};
	GHashTable* _tmp2_;
	gchar* function_name = NULL;
	MathFunction* function = NULL;
	MathFunction** _tmp14_;
	gint _tmp14__length1;
	gint _tmp15_ = 0;
	MathFunction** _tmp16_;
	MathFunction** _tmp17_;
	gint _tmp17__length1;
	MathFunction** result;
#line 349 "../lib/function-manager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 349 "../lib/function-manager.vala"
	g_return_val_if_fail (text != NULL, NULL);
#line 351 "../lib/function-manager.vala"
	_tmp0_ = g_new0 (MathFunction*, 0 + 1);
#line 351 "../lib/function-manager.vala"
	eligible_functions = _tmp0_;
#line 351 "../lib/function-manager.vala"
	eligible_functions_length1 = 0;
#line 351 "../lib/function-manager.vala"
	_eligible_functions_size_ = eligible_functions_length1;
#line 353 "../lib/function-manager.vala"
	_tmp1_ = g_utf8_strdown (text, (gssize) -1);
#line 353 "../lib/function-manager.vala"
	text_case_insensitive = _tmp1_;
#line 354 "../lib/function-manager.vala"
	_tmp2_ = self->priv->functions;
#line 354 "../lib/function-manager.vala"
	g_hash_table_iter_init (&iter, _tmp2_);
#line 357 "../lib/function-manager.vala"
	while (TRUE) {
#line 4261 "function-manager.c"
		gconstpointer _tmp3_ = NULL;
		gconstpointer _tmp4_ = NULL;
		gboolean _tmp5_;
		gchar* _tmp6_;
		MathFunction* _tmp7_;
		gchar* function_name_case_insensitive = NULL;
		const gchar* _tmp8_;
		gchar* _tmp9_;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
#line 357 "../lib/function-manager.vala"
		_tmp5_ = g_hash_table_iter_next (&iter, (gpointer*) (&_tmp3_), (gpointer*) (&_tmp4_));
#line 357 "../lib/function-manager.vala"
		_g_free0 (function_name);
#line 357 "../lib/function-manager.vala"
		_tmp6_ = g_strdup ((const gchar*) _tmp3_);
#line 357 "../lib/function-manager.vala"
		function_name = _tmp6_;
#line 357 "../lib/function-manager.vala"
		_g_object_unref0 (function);
#line 357 "../lib/function-manager.vala"
		_tmp7_ = _g_object_ref0 ((MathFunction*) _tmp4_);
#line 357 "../lib/function-manager.vala"
		function = _tmp7_;
#line 357 "../lib/function-manager.vala"
		if (!_tmp5_) {
#line 357 "../lib/function-manager.vala"
			break;
#line 4290 "function-manager.c"
		}
#line 359 "../lib/function-manager.vala"
		_tmp8_ = function_name;
#line 359 "../lib/function-manager.vala"
		_tmp9_ = g_utf8_strdown (_tmp8_, (gssize) -1);
#line 359 "../lib/function-manager.vala"
		function_name_case_insensitive = _tmp9_;
#line 360 "../lib/function-manager.vala"
		_tmp10_ = function_name_case_insensitive;
#line 360 "../lib/function-manager.vala"
		_tmp11_ = text_case_insensitive;
#line 360 "../lib/function-manager.vala"
		if (g_str_has_prefix (_tmp10_, _tmp11_)) {
#line 4304 "function-manager.c"
			MathFunction* _tmp12_;
			MathFunction* _tmp13_;
#line 361 "../lib/function-manager.vala"
			_tmp12_ = function;
#line 361 "../lib/function-manager.vala"
			_tmp13_ = _g_object_ref0 (_tmp12_);
#line 361 "../lib/function-manager.vala"
			_vala_array_add5 (&eligible_functions, &eligible_functions_length1, &_eligible_functions_size_, _tmp13_);
#line 4313 "function-manager.c"
		}
#line 357 "../lib/function-manager.vala"
		_g_free0 (function_name_case_insensitive);
#line 4317 "function-manager.c"
	}
#line 364 "../lib/function-manager.vala"
	_tmp14_ = eligible_functions;
#line 364 "../lib/function-manager.vala"
	_tmp14__length1 = eligible_functions_length1;
#line 364 "../lib/function-manager.vala"
	_tmp16_ = function_manager_array_sort_math_function (self, _tmp14_, (gint) _tmp14__length1, &_tmp15_);
#line 364 "../lib/function-manager.vala"
	_tmp17_ = _tmp16_;
#line 364 "../lib/function-manager.vala"
	_tmp17__length1 = _tmp15_;
#line 364 "../lib/function-manager.vala"
	if (result_length1) {
#line 364 "../lib/function-manager.vala"
		*result_length1 = _tmp17__length1;
#line 4333 "function-manager.c"
	}
#line 364 "../lib/function-manager.vala"
	result = _tmp17_;
#line 364 "../lib/function-manager.vala"
	_g_object_unref0 (function);
#line 364 "../lib/function-manager.vala"
	_g_free0 (function_name);
#line 364 "../lib/function-manager.vala"
	_g_free0 (text_case_insensitive);
#line 364 "../lib/function-manager.vala"
	eligible_functions = (_vala_array_free (eligible_functions, eligible_functions_length1, (GDestroyNotify) g_object_unref), NULL);
#line 364 "../lib/function-manager.vala"
	return result;
#line 4347 "function-manager.c"
}

static void
function_manager_class_init (FunctionManagerClass * klass,
                             gpointer klass_data)
{
#line 13 "../lib/function-manager.vala"
	function_manager_parent_class = g_type_class_peek_parent (klass);
#line 13 "../lib/function-manager.vala"
	g_type_class_adjust_private_offset (klass, &FunctionManager_private_offset);
#line 13 "../lib/function-manager.vala"
	G_OBJECT_CLASS (klass)->finalize = function_manager_finalize;
#line 13 "../lib/function-manager.vala"
	function_manager_signals[FUNCTION_MANAGER_FUNCTION_ADDED_SIGNAL] = g_signal_new ("function-added", TYPE_FUNCTION_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_MATH_FUNCTION);
#line 13 "../lib/function-manager.vala"
	function_manager_signals[FUNCTION_MANAGER_FUNCTION_EDITED_SIGNAL] = g_signal_new ("function-edited", TYPE_FUNCTION_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_MATH_FUNCTION);
#line 13 "../lib/function-manager.vala"
	function_manager_signals[FUNCTION_MANAGER_FUNCTION_DELETED_SIGNAL] = g_signal_new ("function-deleted", TYPE_FUNCTION_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_MATH_FUNCTION);
#line 4366 "function-manager.c"
}

static void
function_manager_instance_init (FunctionManager * self,
                                gpointer klass)
{
#line 13 "../lib/function-manager.vala"
	self->priv = function_manager_get_instance_private (self);
#line 4375 "function-manager.c"
}

static void
function_manager_finalize (GObject * obj)
{
	FunctionManager * self;
#line 13 "../lib/function-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FUNCTION_MANAGER, FunctionManager);
#line 15 "../lib/function-manager.vala"
	_g_free0 (self->priv->file_name);
#line 16 "../lib/function-manager.vala"
	_g_hash_table_unref0 (self->priv->functions);
#line 17 "../lib/function-manager.vala"
	_g_object_unref0 (self->priv->serializer);
#line 13 "../lib/function-manager.vala"
	G_OBJECT_CLASS (function_manager_parent_class)->finalize (obj);
#line 4392 "function-manager.c"
}

static GType
function_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FunctionManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) function_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FunctionManager), 0, (GInstanceInitFunc) function_manager_instance_init, NULL };
	GType function_manager_type_id;
	function_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "FunctionManager", &g_define_type_info, 0);
	FunctionManager_private_offset = g_type_add_instance_private (function_manager_type_id, sizeof (FunctionManagerPrivate));
	return function_manager_type_id;
}

GType
function_manager_get_type (void)
{
	static volatile gsize function_manager_type_id__once = 0;
	if (g_once_init_enter (&function_manager_type_id__once)) {
		GType function_manager_type_id;
		function_manager_type_id = function_manager_get_type_once ();
		g_once_init_leave (&function_manager_type_id__once, function_manager_type_id);
	}
	return function_manager_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gssize
_vala_array_length (gpointer array)
{
	gssize length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

