/* number.c generated by valac 0.56.18, the Vala compiler
 * generated from number.vala, do not modify */

/*
 * Copyright (C) 1987-2008 Sun Microsystems, Inc. All Rights Reserved.
 * Copyright (C) 2008-2012 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */
/*  This maths library is based on the MP multi-precision floating-point
 *  arithmetic package originally written in FORTRAN by Richard Brent,
 *  Computer Centre, Australian National University in the 1970's.
 *
 *  It has been converted from FORTRAN into C using the freely available
 *  f2c translator, available via netlib on research.att.com.
 *
 *  The subsequently converted C code has then been tidied up, mainly to
 *  remove any dependencies on the libI77 and libF77 support libraries.
 *
 *  FOR A GENERAL DESCRIPTION OF THE PHILOSOPHY AND DESIGN OF MP,
 *  SEE - R. P. BRENT, A FORTRAN MULTIPLE-PRECISION ARITHMETIC
 *  SOME ADDITIONAL DETAILS ARE GIVEN IN THE SAME ISSUE, 71-81.
 *  FOR DETAILS OF THE IMPLEMENTATION, CALLING SEQUENCES ETC. SEE
 *  THE MP USERS GUIDE.
 */

#include <glib.h>
#include "calculator.h"
#include "mpc.h"
#include "mpfr.h"
#include <stdlib.h>
#include <string.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include "mpfrg.h"
#include <glib/gi18n-lib.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

typedef gint (*BitwiseFunc) (gint v1, gint v2, gpointer user_data);
enum  {
	NUMBER_0_PROPERTY,
	NUMBER_NUM_PROPERTIES
};
static GParamSpec* number_properties[NUMBER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _NumberPrivate {
	__mpc_struct num;
};

struct _Block2Data {
	int _ref_count_;
	GPtrArray* self;
	GCompareFunc compare_func;
};

static gint Number_private_offset;
static gpointer number_parent_class = NULL;
static mpfr_prec_t number__precision;
static mpfr_prec_t number__precision = (mpfr_prec_t) 1000;
static gchar* number__error;
static gchar* number__error = NULL;

static void number_mpc_from_radians (__mpc_struct* res,
                              __mpc_struct* op,
                              AngleUnit unit);
static Number* number_copy (Number* self);
static void number_mpc_to_radians (__mpc_struct* res,
                            __mpc_struct* op,
                            AngleUnit unit);
static Number* number_bitwise (Number* self,
                        Number* y,
                        BitwiseFunc bitwise_operator,
                        gpointer bitwise_operator_target,
                        gint wordlen);
static gint __lambda4_ (Number* self,
                 gint v1,
                 gint v2);
static gint ___lambda4__bitwise_func (gint v1,
                               gint v2,
                               gpointer self);
static gint __lambda5_ (Number* self,
                 gint v1,
                 gint v2);
static gint ___lambda5__bitwise_func (gint v1,
                               gint v2,
                               gpointer self);
static gint __lambda7_ (Number* self,
                 gint v1,
                 gint v2);
static gint ___lambda7__bitwise_func (gint v1,
                               gint v2,
                               gpointer self);
static gint __lambda8_ (Number* self,
                 gint v1,
                 gint v2);
static gint ___lambda8__bitwise_func (gint v1,
                               gint v2,
                               gpointer self);
static gint __lambda9_ (Number* self,
                 gint v1,
                 gint v2);
static gint ___lambda9__bitwise_func (gint v1,
                               gint v2,
                               gpointer self);
static gint __lambda10_ (Number* self,
                  gint v1,
                  gint v2);
static gint ___lambda10__bitwise_func (gint v1,
                                gint v2,
                                gpointer self);
static gint __lambda6_ (Number* self,
                 gint v1,
                 gint v2);
static gint ___lambda6__bitwise_func (gint v1,
                               gint v2,
                               gpointer self);
static guint64 number_check_shift (Number* self,
                            Number* count,
                            gint wordlen);
static gint __lambda11_ (Number* self,
                  gint v1,
                  gint v2);
static gint ___lambda11__bitwise_func (gint v1,
                                gint v2,
                                gpointer self);
static Number* number_gcd_x_y (Number* x,
                        Number* y);
static Number* number_lcm_x_y (Number* x,
                        Number* y);
static void _g_object_unref0_ (gpointer var);
static Number** _vala_array_dup11 (Number** self,
                            gssize length);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static gint ___lambda0__gcompare_data_func (gconstpointer a,
                                     gconstpointer b,
                                     gpointer self);
static gint __lambda12_ (Number* a,
                  Number* b);
static gint ___lambda12__gcompare_func (gconstpointer a,
                                 gconstpointer b);
static gboolean number_is_sprp (Number* self,
                         Number* p,
                         guint64 b);
static gboolean number_is_prime (Number* self,
                          Number* x);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static gboolean _mpc_equal (const __mpc_struct * s1,
                     const __mpc_struct * s2);
static gchar* number_to_hex_string (Number* self);
static gint number_hex_to_int (Number* self,
                        gchar digit);
static void number_finalize (GObject * obj);
static GType number_get_type_once (void);
static void _vala_number_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec);
static void _vala_number_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec);
VALA_EXTERN gint parse_literal_prefix (const gchar* str,
                           gint* prefix_len);
VALA_EXTERN Number* set_from_sexagesimal (const gchar* s);
VALA_EXTERN gint char_val (gunichar c,
               gint number_base);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static GType
angle_unit_get_type_once (void)
{
	static const GEnumValue values[] = {{ANGLE_UNIT_RADIANS, "ANGLE_UNIT_RADIANS", "radians"}, {ANGLE_UNIT_DEGREES, "ANGLE_UNIT_DEGREES", "degrees"}, {ANGLE_UNIT_GRADIANS, "ANGLE_UNIT_GRADIANS", "gradians"}, {0, NULL, NULL}};
	GType angle_unit_type_id;
	angle_unit_type_id = g_enum_register_static ("AngleUnit", values);
	return angle_unit_type_id;
}

GType
angle_unit_get_type (void)
{
	static volatile gsize angle_unit_type_id__once = 0;
	if (g_once_init_enter (&angle_unit_type_id__once)) {
		GType angle_unit_type_id;
		angle_unit_type_id = angle_unit_get_type_once ();
		g_once_init_leave (&angle_unit_type_id__once, angle_unit_type_id);
	}
	return angle_unit_type_id__once;
}

static inline gpointer
number_get_instance_private (Number* self)
{
	return G_STRUCT_MEMBER_P (self, Number_private_offset);
}

Number*
number_construct_integer (GType object_type,
                          gint64 real,
                          gint64 imag)
{
	Number * self = NULL;
#line 51 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 53 "../lib/number.vala"
	mpc_set_si_si (&self->priv->num, (glong) real, (glong) imag, MPC_RNDNN);
#line 51 "../lib/number.vala"
	return self;
#line 233 "number.c"
}

Number*
number_new_integer (gint64 real,
                    gint64 imag)
{
#line 51 "../lib/number.vala"
	return number_construct_integer (TYPE_NUMBER, real, imag);
#line 242 "number.c"
}

Number*
number_construct_unsigned_integer (GType object_type,
                                   guint64 real,
                                   guint64 imag)
{
	Number * self = NULL;
#line 56 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 58 "../lib/number.vala"
	mpc_set_ui_ui (&self->priv->num, (gulong) real, (gulong) imag, MPC_RNDNN);
#line 56 "../lib/number.vala"
	return self;
#line 257 "number.c"
}

Number*
number_new_unsigned_integer (guint64 real,
                             guint64 imag)
{
#line 56 "../lib/number.vala"
	return number_construct_unsigned_integer (TYPE_NUMBER, real, imag);
#line 266 "number.c"
}

Number*
number_construct_fraction (GType object_type,
                           gint64 numerator,
                           gint64 denominator)
{
	Number * self = NULL;
#line 63 "../lib/number.vala"
	if (denominator < ((gint64) 0)) {
#line 65 "../lib/number.vala"
		numerator = -numerator;
#line 66 "../lib/number.vala"
		denominator = -denominator;
#line 281 "number.c"
	}
#line 69 "../lib/number.vala"
	self = (Number*) number_construct_integer (object_type, numerator, (gint64) 0);
#line 70 "../lib/number.vala"
	if (denominator != ((gint64) 1)) {
#line 72 "../lib/number.vala"
		mpc_div_ui (&self->priv->num, &self->priv->num, (gulong) ((glong) denominator), MPC_RNDNN);
#line 289 "number.c"
	}
#line 61 "../lib/number.vala"
	return self;
#line 293 "number.c"
}

Number*
number_new_fraction (gint64 numerator,
                     gint64 denominator)
{
#line 61 "../lib/number.vala"
	return number_construct_fraction (TYPE_NUMBER, numerator, denominator);
#line 302 "number.c"
}

static gint
mpc_set_mpreal (__mpc_struct *self,
                __mpfr_struct* re,
                __mpfr_struct* im,
                mpc_rnd_t rnd)
{
	__mpfr_struct _tmp1_;
	__mpfr_struct _tmp2_;
	gint result;
#line 61 "/builddir/build/BUILD/gnome-calculator-49_alpha-build/gnome-calculator-49.alpha/vapi/mpc.vapi"
	g_return_val_if_fail (re != NULL, 0);
#line 63 "/builddir/build/BUILD/gnome-calculator-49_alpha-build/gnome-calculator-49.alpha/vapi/mpc.vapi"
	if (im == NULL) {
#line 318 "number.c"
		__mpfr_struct _tmp0_;
#line 64 "/builddir/build/BUILD/gnome-calculator-49_alpha-build/gnome-calculator-49.alpha/vapi/mpc.vapi"
		_tmp0_ = *re;
#line 64 "/builddir/build/BUILD/gnome-calculator-49_alpha-build/gnome-calculator-49.alpha/vapi/mpc.vapi"
		result = mpc_set_fr (&(*self), &_tmp0_, rnd);
#line 64 "/builddir/build/BUILD/gnome-calculator-49_alpha-build/gnome-calculator-49.alpha/vapi/mpc.vapi"
		return result;
#line 326 "number.c"
	}
#line 66 "/builddir/build/BUILD/gnome-calculator-49_alpha-build/gnome-calculator-49.alpha/vapi/mpc.vapi"
	_tmp1_ = *re;
#line 66 "/builddir/build/BUILD/gnome-calculator-49_alpha-build/gnome-calculator-49.alpha/vapi/mpc.vapi"
	_tmp2_ = *im;
#line 66 "/builddir/build/BUILD/gnome-calculator-49_alpha-build/gnome-calculator-49.alpha/vapi/mpc.vapi"
	result = mpc_set_fr_fr (&(*self), &_tmp1_, &_tmp2_, rnd);
#line 66 "/builddir/build/BUILD/gnome-calculator-49_alpha-build/gnome-calculator-49.alpha/vapi/mpc.vapi"
	return result;
#line 336 "number.c"
}

Number*
number_construct_mpreal (GType object_type,
                         __mpfr_struct* real,
                         __mpfr_struct* imag)
{
	Number * self = NULL;
	__mpfr_struct _tmp0_;
#line 77 "../lib/number.vala"
	g_return_val_if_fail (real != NULL, NULL);
#line 77 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 79 "../lib/number.vala"
	_tmp0_ = *real;
#line 79 "../lib/number.vala"
	mpc_set_mpreal (&self->priv->num, &_tmp0_, imag, MPC_RNDNN);
#line 77 "../lib/number.vala"
	return self;
#line 356 "number.c"
}

Number*
number_new_mpreal (__mpfr_struct* real,
                   __mpfr_struct* imag)
{
#line 77 "../lib/number.vala"
	return number_construct_mpreal (TYPE_NUMBER, real, imag);
#line 365 "number.c"
}

Number*
number_construct_double (GType object_type,
                         gdouble real,
                         gdouble imag)
{
	Number * self = NULL;
#line 82 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 84 "../lib/number.vala"
	mpc_set_d_d (&self->priv->num, real, imag, MPC_RNDNN);
#line 82 "../lib/number.vala"
	return self;
#line 380 "number.c"
}

Number*
number_new_double (gdouble real,
                   gdouble imag)
{
#line 82 "../lib/number.vala"
	return number_construct_double (TYPE_NUMBER, real, imag);
#line 389 "number.c"
}

Number*
number_construct_complex (GType object_type,
                          Number* r,
                          Number* i)
{
	Number * self = NULL;
	MPFRGRealRef* _tmp0_;
	MPFRGRealRef* _tmp1_;
#line 87 "../lib/number.vala"
	g_return_val_if_fail (r != NULL, NULL);
#line 87 "../lib/number.vala"
	g_return_val_if_fail (i != NULL, NULL);
#line 87 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 89 "../lib/number.vala"
	_tmp0_ = mpc_realref (&r->priv->num);
#line 89 "../lib/number.vala"
	_tmp1_ = mpc_realref (&i->priv->num);
#line 89 "../lib/number.vala"
	mpc_set_mpreal (&self->priv->num, &_tmp0_->val, &_tmp1_->val, MPC_RNDNN);
#line 87 "../lib/number.vala"
	return self;
#line 414 "number.c"
}

Number*
number_new_complex (Number* r,
                    Number* i)
{
#line 87 "../lib/number.vala"
	return number_construct_complex (TYPE_NUMBER, r, i);
#line 423 "number.c"
}

Number*
number_construct_polar (GType object_type,
                        Number* r,
                        Number* theta,
                        AngleUnit unit)
{
	Number * self = NULL;
	Number* x = NULL;
	Number* _tmp0_;
	Number* y = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
#line 92 "../lib/number.vala"
	g_return_val_if_fail (r != NULL, NULL);
#line 92 "../lib/number.vala"
	g_return_val_if_fail (theta != NULL, NULL);
#line 94 "../lib/number.vala"
	_tmp0_ = number_cos (theta, unit);
#line 94 "../lib/number.vala"
	x = _tmp0_;
#line 95 "../lib/number.vala"
	_tmp1_ = number_sin (theta, unit);
#line 95 "../lib/number.vala"
	y = _tmp1_;
#line 96 "../lib/number.vala"
	_tmp2_ = number_multiply (x, r);
#line 96 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 96 "../lib/number.vala"
	_tmp4_ = number_multiply (y, r);
#line 96 "../lib/number.vala"
	_tmp5_ = _tmp4_;
#line 96 "../lib/number.vala"
	self = (Number*) number_construct_complex (object_type, _tmp3_, _tmp5_);
#line 96 "../lib/number.vala"
	_g_object_unref0 (_tmp5_);
#line 96 "../lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 92 "../lib/number.vala"
	_g_object_unref0 (y);
#line 92 "../lib/number.vala"
	_g_object_unref0 (x);
#line 92 "../lib/number.vala"
	return self;
#line 473 "number.c"
}

Number*
number_new_polar (Number* r,
                  Number* theta,
                  AngleUnit unit)
{
#line 92 "../lib/number.vala"
	return number_construct_polar (TYPE_NUMBER, r, theta, unit);
#line 483 "number.c"
}

Number*
number_construct_eulers (GType object_type)
{
	Number * self = NULL;
	MPFRGRealRef* _tmp0_;
	MPFRGRealRef* _tmp1_;
	MPFRGRealRef* _tmp2_;
	MPFRGRealRef* _tmp3_;
#line 99 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 101 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 101 "../lib/number.vala"
	mpfr_set_ui (&_tmp0_->val, (gulong) 1, MPFR_RNDN);
#line 103 "../lib/number.vala"
	_tmp1_ = mpc_realref (&self->priv->num);
#line 103 "../lib/number.vala"
	_tmp2_ = mpc_realref (&self->priv->num);
#line 103 "../lib/number.vala"
	mpfr_exp (&_tmp1_->val, &_tmp2_->val, MPFR_RNDN);
#line 104 "../lib/number.vala"
	_tmp3_ = mpc_imagref (&self->priv->num);
#line 104 "../lib/number.vala"
	mpfr_set_zero (&_tmp3_->val, MPFR_RNDN);
#line 99 "../lib/number.vala"
	return self;
#line 512 "number.c"
}

Number*
number_new_eulers (void)
{
#line 99 "../lib/number.vala"
	return number_construct_eulers (TYPE_NUMBER);
#line 520 "number.c"
}

Number*
number_construct_i (GType object_type)
{
	Number * self = NULL;
#line 107 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 109 "../lib/number.vala"
	mpc_set_si_si (&self->priv->num, (glong) 0, (glong) 1, MPC_RNDNN);
#line 107 "../lib/number.vala"
	return self;
#line 533 "number.c"
}

Number*
number_new_i (void)
{
#line 107 "../lib/number.vala"
	return number_construct_i (TYPE_NUMBER);
#line 541 "number.c"
}

Number*
number_construct_pi (GType object_type)
{
	Number * self = NULL;
	MPFRGRealRef* _tmp0_;
	MPFRGRealRef* _tmp1_;
#line 112 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 114 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 114 "../lib/number.vala"
	mpfr_const_pi (&_tmp0_->val, MPFR_RNDN);
#line 115 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&self->priv->num);
#line 115 "../lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 112 "../lib/number.vala"
	return self;
#line 562 "number.c"
}

Number*
number_new_pi (void)
{
#line 112 "../lib/number.vala"
	return number_construct_pi (TYPE_NUMBER);
#line 570 "number.c"
}

static gint
mpfr_const_tau (__mpfr_struct *self,
                mpfr_rnd_t rnd)
{
	gint i = 0;
	gint result;
#line 78 "/builddir/build/BUILD/gnome-calculator-49_alpha-build/gnome-calculator-49.alpha/vapi/mpfr.vapi"
	i = mpfr_const_pi (&(*self), rnd);
#line 79 "/builddir/build/BUILD/gnome-calculator-49_alpha-build/gnome-calculator-49.alpha/vapi/mpfr.vapi"
	mpfr_mul_si (&(*self), &(*self), (glong) 2, rnd);
#line 80 "/builddir/build/BUILD/gnome-calculator-49_alpha-build/gnome-calculator-49.alpha/vapi/mpfr.vapi"
	result = i;
#line 80 "/builddir/build/BUILD/gnome-calculator-49_alpha-build/gnome-calculator-49.alpha/vapi/mpfr.vapi"
	return result;
#line 587 "number.c"
}

Number*
number_construct_tau (GType object_type)
{
	Number * self = NULL;
	MPFRGRealRef* _tmp0_;
	MPFRGRealRef* _tmp1_;
#line 118 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 120 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 120 "../lib/number.vala"
	mpfr_const_tau (&_tmp0_->val, MPFR_RNDN);
#line 121 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&self->priv->num);
#line 121 "../lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 118 "../lib/number.vala"
	return self;
#line 608 "number.c"
}

Number*
number_new_tau (void)
{
#line 118 "../lib/number.vala"
	return number_construct_tau (TYPE_NUMBER);
#line 616 "number.c"
}

Number*
number_construct_random (GType object_type)
{
	Number * self = NULL;
#line 127 "../lib/number.vala"
	self = (Number*) number_construct_double (object_type, g_random_double (), (gdouble) 0);
#line 125 "../lib/number.vala"
	return self;
#line 627 "number.c"
}

Number*
number_new_random (void)
{
#line 125 "../lib/number.vala"
	return number_construct_random (TYPE_NUMBER);
#line 635 "number.c"
}

gint64
number_to_integer (Number* self)
{
	MPFRGRealRef* _tmp0_;
	gint64 result;
#line 130 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, 0LL);
#line 132 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 132 "../lib/number.vala"
	result = (gint64) mpfr_get_si (&_tmp0_->val, MPFR_RNDN);
#line 132 "../lib/number.vala"
	return result;
#line 651 "number.c"
}

guint64
number_to_unsigned_integer (Number* self)
{
	MPFRGRealRef* _tmp0_;
	guint64 result;
#line 135 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 137 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 137 "../lib/number.vala"
	result = (guint64) mpfr_get_ui (&_tmp0_->val, MPFR_RNDN);
#line 137 "../lib/number.vala"
	return result;
#line 667 "number.c"
}

gdouble
number_to_double (Number* self)
{
	MPFRGRealRef* _tmp0_;
	gdouble result;
#line 140 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 142 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 142 "../lib/number.vala"
	result = mpfr_get_d (&_tmp0_->val, MPFR_RNDN);
#line 142 "../lib/number.vala"
	return result;
#line 683 "number.c"
}

static gboolean
mpc_is_zero (__mpc_struct *self)
{
	gint res = 0;
	gboolean _tmp0_ = FALSE;
	gboolean result;
#line 74 "/builddir/build/BUILD/gnome-calculator-49_alpha-build/gnome-calculator-49.alpha/vapi/mpc.vapi"
	res = mpc_cmp_si_si (&(*self), (glong) 0, (glong) 0);
#line 74 "/builddir/build/BUILD/gnome-calculator-49_alpha-build/gnome-calculator-49.alpha/vapi/mpc.vapi"
	if (MPC_INEX_RE (res) == 0) {
#line 74 "/builddir/build/BUILD/gnome-calculator-49_alpha-build/gnome-calculator-49.alpha/vapi/mpc.vapi"
		_tmp0_ = MPC_INEX_IM (res) == 0;
#line 698 "number.c"
	} else {
#line 74 "/builddir/build/BUILD/gnome-calculator-49_alpha-build/gnome-calculator-49.alpha/vapi/mpc.vapi"
		_tmp0_ = FALSE;
#line 702 "number.c"
	}
#line 74 "/builddir/build/BUILD/gnome-calculator-49_alpha-build/gnome-calculator-49.alpha/vapi/mpc.vapi"
	result = _tmp0_;
#line 74 "/builddir/build/BUILD/gnome-calculator-49_alpha-build/gnome-calculator-49.alpha/vapi/mpc.vapi"
	return result;
#line 708 "number.c"
}

gboolean
number_is_zero (Number* self)
{
	gboolean result;
#line 146 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 148 "../lib/number.vala"
	result = mpc_is_zero (&self->priv->num);
#line 148 "../lib/number.vala"
	return result;
#line 721 "number.c"
}

gboolean
number_is_negative (Number* self)
{
	MPFRGRealRef* _tmp0_;
	gboolean result;
#line 152 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 154 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 154 "../lib/number.vala"
	result = mpfr_sgn (&_tmp0_->val) < 0;
#line 154 "../lib/number.vala"
	return result;
#line 737 "number.c"
}

gboolean
number_is_integer (Number* self)
{
	MPFRGRealRef* _tmp0_;
	gboolean result;
#line 158 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 160 "../lib/number.vala"
	if (number_is_complex (self)) {
#line 161 "../lib/number.vala"
		result = FALSE;
#line 161 "../lib/number.vala"
		return result;
#line 753 "number.c"
	}
#line 163 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 163 "../lib/number.vala"
	result = mpfr_integer_p (&_tmp0_->val) != 0;
#line 163 "../lib/number.vala"
	return result;
#line 761 "number.c"
}

gboolean
number_is_natural (Number* self)
{
	gboolean result;
#line 167 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 169 "../lib/number.vala"
	if (number_is_complex (self)) {
#line 170 "../lib/number.vala"
		result = FALSE;
#line 170 "../lib/number.vala"
		return result;
#line 776 "number.c"
	} else {
		gboolean _tmp0_ = FALSE;
		MPFRGRealRef* _tmp1_;
#line 172 "../lib/number.vala"
		_tmp1_ = mpc_realref (&self->priv->num);
#line 172 "../lib/number.vala"
		if (mpfr_sgn (&_tmp1_->val) >= 0) {
#line 172 "../lib/number.vala"
			_tmp0_ = number_is_integer (self);
#line 786 "number.c"
		} else {
#line 172 "../lib/number.vala"
			_tmp0_ = FALSE;
#line 790 "number.c"
		}
#line 172 "../lib/number.vala"
		result = _tmp0_;
#line 172 "../lib/number.vala"
		return result;
#line 796 "number.c"
	}
}

gboolean
number_is_complex (Number* self)
{
	MPFRGRealRef* _tmp0_;
	gboolean result;
#line 176 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 178 "../lib/number.vala"
	_tmp0_ = mpc_imagref (&self->priv->num);
#line 178 "../lib/number.vala"
	result = !mpfr_zero_p (&_tmp0_->val);
#line 178 "../lib/number.vala"
	return result;
#line 813 "number.c"
}

gboolean
number_is_180n_degrees (Number* self,
                        AngleUnit unit)
{
	Number* check = NULL;
	gboolean is_180n = FALSE;
	Number* _tmp9_;
	gboolean _tmp10_ = FALSE;
	gboolean result;
#line 182 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 184 "../lib/number.vala"
	if (number_is_complex (self)) {
#line 185 "../lib/number.vala"
		result = FALSE;
#line 185 "../lib/number.vala"
		return result;
#line 833 "number.c"
	}
#line 188 "../lib/number.vala"
	switch (unit) {
#line 188 "../lib/number.vala"
		case ANGLE_UNIT_RADIANS:
#line 839 "number.c"
		{
			Number* _tmp0_;
			Number* _tmp1_;
			Number* _tmp2_;
#line 191 "../lib/number.vala"
			_tmp0_ = number_new_pi ();
#line 191 "../lib/number.vala"
			_tmp1_ = _tmp0_;
#line 191 "../lib/number.vala"
			_tmp2_ = number_divide (self, _tmp1_);
#line 191 "../lib/number.vala"
			_g_object_unref0 (check);
#line 191 "../lib/number.vala"
			check = _tmp2_;
#line 191 "../lib/number.vala"
			_g_object_unref0 (_tmp1_);
#line 192 "../lib/number.vala"
			break;
#line 858 "number.c"
		}
#line 188 "../lib/number.vala"
		case ANGLE_UNIT_DEGREES:
#line 862 "number.c"
		{
			Number* _tmp3_;
			Number* _tmp4_;
			Number* _tmp5_;
#line 194 "../lib/number.vala"
			_tmp3_ = number_new_integer ((gint64) 180, (gint64) 0);
#line 194 "../lib/number.vala"
			_tmp4_ = _tmp3_;
#line 194 "../lib/number.vala"
			_tmp5_ = number_divide (self, _tmp4_);
#line 194 "../lib/number.vala"
			_g_object_unref0 (check);
#line 194 "../lib/number.vala"
			check = _tmp5_;
#line 194 "../lib/number.vala"
			_g_object_unref0 (_tmp4_);
#line 195 "../lib/number.vala"
			break;
#line 881 "number.c"
		}
#line 188 "../lib/number.vala"
		case ANGLE_UNIT_GRADIANS:
#line 885 "number.c"
		{
			Number* _tmp6_;
			Number* _tmp7_;
			Number* _tmp8_;
#line 197 "../lib/number.vala"
			_tmp6_ = number_new_integer ((gint64) 200, (gint64) 0);
#line 197 "../lib/number.vala"
			_tmp7_ = _tmp6_;
#line 197 "../lib/number.vala"
			_tmp8_ = number_divide (self, _tmp7_);
#line 197 "../lib/number.vala"
			_g_object_unref0 (check);
#line 197 "../lib/number.vala"
			check = _tmp8_;
#line 197 "../lib/number.vala"
			_g_object_unref0 (_tmp7_);
#line 198 "../lib/number.vala"
			break;
#line 904 "number.c"
		}
		default:
		{
#line 200 "../lib/number.vala"
			g_assert_not_reached ();
#line 201 "../lib/number.vala"
			result = TRUE;
#line 201 "../lib/number.vala"
			_g_object_unref0 (check);
#line 201 "../lib/number.vala"
			return result;
#line 916 "number.c"
		}
	}
#line 204 "../lib/number.vala"
	_tmp9_ = check;
#line 204 "../lib/number.vala"
	is_180n = number_is_integer (_tmp9_);
#line 205 "../lib/number.vala"
	if (!is_180n) {
#line 205 "../lib/number.vala"
		_tmp10_ = unit == ANGLE_UNIT_RADIANS;
#line 927 "number.c"
	} else {
#line 205 "../lib/number.vala"
		_tmp10_ = FALSE;
#line 931 "number.c"
	}
#line 205 "../lib/number.vala"
	if (_tmp10_) {
#line 935 "number.c"
		Number* eps = NULL;
		Number* _tmp11_;
		Number* _tmp12_;
		mpfr_prec_t _tmp13_;
		mpfr_prec_t _tmp14_;
		Number* _tmp15_;
		Number* _tmp16_;
		Number* _tmp17_;
		Number* _tmp18_;
		Number* _tmp19_;
		Number* _tmp20_;
		Number* _tmp21_;
		Number* _tmp22_;
		Number* _tmp23_;
		Number* _tmp24_;
		Number* _tmp25_;
		Number* _tmp26_;
		Number* _tmp27_;
		Number* _tmp28_;
		Number* _tmp29_;
#line 207 "../lib/number.vala"
		_tmp11_ = number_new_integer ((gint64) 2, (gint64) 0);
#line 207 "../lib/number.vala"
		_tmp12_ = _tmp11_;
#line 207 "../lib/number.vala"
		_tmp13_ = number_get_precision ();
#line 207 "../lib/number.vala"
		_tmp14_ = _tmp13_;
#line 207 "../lib/number.vala"
		_tmp15_ = number_xpowy_integer (_tmp12_, (gint64) (-_tmp14_));
#line 207 "../lib/number.vala"
		_tmp16_ = _tmp15_;
#line 207 "../lib/number.vala"
		_tmp17_ = number_multiply (self, _tmp16_);
#line 207 "../lib/number.vala"
		_tmp18_ = _tmp17_;
#line 207 "../lib/number.vala"
		_tmp19_ = number_abs (_tmp18_);
#line 207 "../lib/number.vala"
		_tmp20_ = _tmp19_;
#line 207 "../lib/number.vala"
		_g_object_unref0 (_tmp18_);
#line 207 "../lib/number.vala"
		_g_object_unref0 (_tmp16_);
#line 207 "../lib/number.vala"
		_g_object_unref0 (_tmp12_);
#line 207 "../lib/number.vala"
		eps = _tmp20_;
#line 208 "../lib/number.vala"
		_tmp21_ = check;
#line 208 "../lib/number.vala"
		_tmp22_ = check;
#line 208 "../lib/number.vala"
		_tmp23_ = number_round (_tmp22_);
#line 208 "../lib/number.vala"
		_tmp24_ = _tmp23_;
#line 208 "../lib/number.vala"
		_tmp25_ = number_subtract (_tmp21_, _tmp24_);
#line 208 "../lib/number.vala"
		_tmp26_ = _tmp25_;
#line 208 "../lib/number.vala"
		_tmp27_ = number_abs (_tmp26_);
#line 208 "../lib/number.vala"
		_tmp28_ = _tmp27_;
#line 208 "../lib/number.vala"
		_tmp29_ = eps;
#line 208 "../lib/number.vala"
		is_180n = number_compare (_tmp28_, _tmp29_) < 0;
#line 208 "../lib/number.vala"
		_g_object_unref0 (_tmp28_);
#line 208 "../lib/number.vala"
		_g_object_unref0 (_tmp26_);
#line 208 "../lib/number.vala"
		_g_object_unref0 (_tmp24_);
#line 205 "../lib/number.vala"
		_g_object_unref0 (eps);
#line 1012 "number.c"
	}
#line 210 "../lib/number.vala"
	result = is_180n;
#line 210 "../lib/number.vala"
	_g_object_unref0 (check);
#line 210 "../lib/number.vala"
	return result;
#line 1020 "number.c"
}

gboolean
number_is_180n_plus_90_degrees (Number* self,
                                AngleUnit unit)
{
	gboolean result;
#line 214 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 216 "../lib/number.vala"
	switch (unit) {
#line 216 "../lib/number.vala"
		case ANGLE_UNIT_RADIANS:
#line 1034 "number.c"
		{
			Number* _tmp0_;
			Number* _tmp1_;
			Number* _tmp2_;
			Number* _tmp3_;
			Number* _tmp4_;
			Number* _tmp5_;
			gboolean _tmp6_;
#line 219 "../lib/number.vala"
			_tmp0_ = number_new_pi ();
#line 219 "../lib/number.vala"
			_tmp1_ = _tmp0_;
#line 219 "../lib/number.vala"
			_tmp2_ = number_divide_integer (_tmp1_, (gint64) 2);
#line 219 "../lib/number.vala"
			_tmp3_ = _tmp2_;
#line 219 "../lib/number.vala"
			_tmp4_ = number_subtract (self, _tmp3_);
#line 219 "../lib/number.vala"
			_tmp5_ = _tmp4_;
#line 219 "../lib/number.vala"
			_tmp6_ = number_is_180n_degrees (_tmp5_, unit);
#line 219 "../lib/number.vala"
			_g_object_unref0 (_tmp5_);
#line 219 "../lib/number.vala"
			_g_object_unref0 (_tmp3_);
#line 219 "../lib/number.vala"
			_g_object_unref0 (_tmp1_);
#line 219 "../lib/number.vala"
			result = _tmp6_;
#line 219 "../lib/number.vala"
			return result;
#line 1067 "number.c"
		}
#line 216 "../lib/number.vala"
		case ANGLE_UNIT_DEGREES:
#line 1071 "number.c"
		{
			Number* _tmp7_;
			Number* _tmp8_;
			Number* _tmp9_;
			Number* _tmp10_;
			gboolean _tmp11_;
#line 221 "../lib/number.vala"
			_tmp7_ = number_new_integer ((gint64) 90, (gint64) 0);
#line 221 "../lib/number.vala"
			_tmp8_ = _tmp7_;
#line 221 "../lib/number.vala"
			_tmp9_ = number_subtract (self, _tmp8_);
#line 221 "../lib/number.vala"
			_tmp10_ = _tmp9_;
#line 221 "../lib/number.vala"
			_tmp11_ = number_is_180n_degrees (_tmp10_, unit);
#line 221 "../lib/number.vala"
			_g_object_unref0 (_tmp10_);
#line 221 "../lib/number.vala"
			_g_object_unref0 (_tmp8_);
#line 221 "../lib/number.vala"
			result = _tmp11_;
#line 221 "../lib/number.vala"
			return result;
#line 1096 "number.c"
		}
#line 216 "../lib/number.vala"
		case ANGLE_UNIT_GRADIANS:
#line 1100 "number.c"
		{
			Number* _tmp12_;
			Number* _tmp13_;
			Number* _tmp14_;
			Number* _tmp15_;
			gboolean _tmp16_;
#line 223 "../lib/number.vala"
			_tmp12_ = number_new_integer ((gint64) 100, (gint64) 0);
#line 223 "../lib/number.vala"
			_tmp13_ = _tmp12_;
#line 223 "../lib/number.vala"
			_tmp14_ = number_subtract (self, _tmp13_);
#line 223 "../lib/number.vala"
			_tmp15_ = _tmp14_;
#line 223 "../lib/number.vala"
			_tmp16_ = number_is_180n_degrees (_tmp15_, unit);
#line 223 "../lib/number.vala"
			_g_object_unref0 (_tmp15_);
#line 223 "../lib/number.vala"
			_g_object_unref0 (_tmp13_);
#line 223 "../lib/number.vala"
			result = _tmp16_;
#line 223 "../lib/number.vala"
			return result;
#line 1125 "number.c"
		}
		default:
		{
#line 225 "../lib/number.vala"
			g_assert_not_reached ();
#line 226 "../lib/number.vala"
			result = TRUE;
#line 226 "../lib/number.vala"
			return result;
#line 1135 "number.c"
		}
	}
}

void
number_check_flags (void)
{
#line 233 "../lib/number.vala"
	if (mpfr_underflow_p () != 0) {
#line 236 "../lib/number.vala"
		number_set_error (_ ("Underflow error"));
#line 1147 "number.c"
	} else {
#line 238 "../lib/number.vala"
		if (mpfr_overflow_p () != 0) {
#line 241 "../lib/number.vala"
			number_set_error (_ ("Overflow error"));
#line 1153 "number.c"
		}
	}
}

static gboolean
mpc_is_equal (__mpc_struct *self,
              __mpc_struct* c)
{
	gint res = 0;
	__mpc_struct _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean result;
#line 75 "/builddir/build/BUILD/gnome-calculator-49_alpha-build/gnome-calculator-49.alpha/vapi/mpc.vapi"
	g_return_val_if_fail (c != NULL, FALSE);
#line 75 "/builddir/build/BUILD/gnome-calculator-49_alpha-build/gnome-calculator-49.alpha/vapi/mpc.vapi"
	_tmp0_ = *c;
#line 75 "/builddir/build/BUILD/gnome-calculator-49_alpha-build/gnome-calculator-49.alpha/vapi/mpc.vapi"
	res = mpc_cmp (&(*self), &_tmp0_);
#line 75 "/builddir/build/BUILD/gnome-calculator-49_alpha-build/gnome-calculator-49.alpha/vapi/mpc.vapi"
	if (MPC_INEX_RE (res) == 0) {
#line 75 "/builddir/build/BUILD/gnome-calculator-49_alpha-build/gnome-calculator-49.alpha/vapi/mpc.vapi"
		_tmp1_ = MPC_INEX_IM (res) == 0;
#line 1176 "number.c"
	} else {
#line 75 "/builddir/build/BUILD/gnome-calculator-49_alpha-build/gnome-calculator-49.alpha/vapi/mpc.vapi"
		_tmp1_ = FALSE;
#line 1180 "number.c"
	}
#line 75 "/builddir/build/BUILD/gnome-calculator-49_alpha-build/gnome-calculator-49.alpha/vapi/mpc.vapi"
	result = _tmp1_;
#line 75 "/builddir/build/BUILD/gnome-calculator-49_alpha-build/gnome-calculator-49.alpha/vapi/mpc.vapi"
	return result;
#line 1186 "number.c"
}

gboolean
number_equals (Number* self,
               Number* y)
{
	gboolean result;
#line 246 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 246 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, FALSE);
#line 248 "../lib/number.vala"
	result = mpc_is_equal (&self->priv->num, &y->priv->num);
#line 248 "../lib/number.vala"
	return result;
#line 1202 "number.c"
}

gint
number_compare (Number* self,
                Number* y)
{
	MPFRGRealRef* _tmp0_;
	MPFRGRealRef* _tmp1_;
	gint result;
#line 256 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 256 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, 0);
#line 258 "../lib/number.vala"
	_tmp0_ = mpc_realref (&self->priv->num);
#line 258 "../lib/number.vala"
	_tmp1_ = mpc_realref (&y->priv->num);
#line 258 "../lib/number.vala"
	result = mpfr_cmp (&_tmp0_->val, &_tmp1_->val);
#line 258 "../lib/number.vala"
	return result;
#line 1224 "number.c"
}

Number*
number_kronecker_delta (Number* self,
                        Number* y)
{
	gint _tmp0_ = 0;
	Number* _tmp1_;
	Number* result;
#line 265 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 265 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 267 "../lib/number.vala"
	if (number_equals (self, y)) {
#line 267 "../lib/number.vala"
		_tmp0_ = 1;
#line 1242 "number.c"
	} else {
#line 267 "../lib/number.vala"
		_tmp0_ = 0;
#line 1246 "number.c"
	}
#line 267 "../lib/number.vala"
	_tmp1_ = number_new_integer ((gint64) _tmp0_, (gint64) 0);
#line 267 "../lib/number.vala"
	result = _tmp1_;
#line 267 "../lib/number.vala"
	return result;
#line 1254 "number.c"
}

Number*
number_sgn (Number* self)
{
	Number* z = NULL;
	MPFRGRealRef* _tmp4_;
	Number* _tmp5_;
	Number* result;
#line 271 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 273 "../lib/number.vala"
	if (number_is_complex (self)) {
#line 1268 "number.c"
		Number* _tmp0_;
		Number* _tmp1_;
		Number* _tmp2_;
		Number* _tmp3_;
#line 274 "../lib/number.vala"
		_tmp0_ = number_abs (self);
#line 274 "../lib/number.vala"
		_tmp1_ = _tmp0_;
#line 274 "../lib/number.vala"
		_tmp2_ = number_divide (self, _tmp1_);
#line 274 "../lib/number.vala"
		_tmp3_ = _tmp2_;
#line 274 "../lib/number.vala"
		_g_object_unref0 (_tmp1_);
#line 274 "../lib/number.vala"
		result = _tmp3_;
#line 274 "../lib/number.vala"
		return result;
#line 1287 "number.c"
	}
#line 275 "../lib/number.vala"
	_tmp4_ = mpc_realref (&self->priv->num);
#line 275 "../lib/number.vala"
	_tmp5_ = number_new_integer ((gint64) mpfr_sgn (&_tmp4_->val), (gint64) 0);
#line 275 "../lib/number.vala"
	z = _tmp5_;
#line 276 "../lib/number.vala"
	result = z;
#line 276 "../lib/number.vala"
	return result;
#line 1299 "number.c"
}

Number*
number_invert_sign (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 280 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 282 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 282 "../lib/number.vala"
	z = _tmp0_;
#line 283 "../lib/number.vala"
	mpc_neg (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 284 "../lib/number.vala"
	result = z;
#line 284 "../lib/number.vala"
	return result;
#line 1320 "number.c"
}

Number*
number_abs (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	MPFRGRealRef* _tmp1_;
	MPFRGRealRef* _tmp2_;
	Number* result;
#line 288 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 290 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 290 "../lib/number.vala"
	z = _tmp0_;
#line 291 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&z->priv->num);
#line 291 "../lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 292 "../lib/number.vala"
	_tmp2_ = mpc_realref (&z->priv->num);
#line 292 "../lib/number.vala"
	mpc_abs (&_tmp2_->val, &self->priv->num, MPFR_RNDN);
#line 293 "../lib/number.vala"
	result = z;
#line 293 "../lib/number.vala"
	return result;
#line 1349 "number.c"
}

Number*
number_arg (Number* self,
            AngleUnit unit)
{
	Number* z = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	MPFRGRealRef* _tmp3_;
	Number* _tmp4_;
	MPFRGRealRef* _tmp5_;
	Number* _tmp6_;
	Number* _tmp7_;
	gboolean _tmp8_ = FALSE;
	Number* result;
#line 297 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 299 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 1370 "number.c"
		Number* _tmp0_;
#line 302 "../lib/number.vala"
		number_set_error (_ ("Argument not defined for zero"));
#line 303 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 303 "../lib/number.vala"
		result = _tmp0_;
#line 303 "../lib/number.vala"
		return result;
#line 1380 "number.c"
	}
#line 305 "../lib/number.vala"
	_tmp1_ = number_new ();
#line 305 "../lib/number.vala"
	z = _tmp1_;
#line 306 "../lib/number.vala"
	_tmp2_ = z;
#line 306 "../lib/number.vala"
	_tmp3_ = mpc_imagref (&_tmp2_->priv->num);
#line 306 "../lib/number.vala"
	mpfr_set_zero (&_tmp3_->val, MPFR_RNDN);
#line 307 "../lib/number.vala"
	_tmp4_ = z;
#line 307 "../lib/number.vala"
	_tmp5_ = mpc_realref (&_tmp4_->priv->num);
#line 307 "../lib/number.vala"
	mpc_arg (&_tmp5_->val, &self->priv->num, MPFR_RNDN);
#line 308 "../lib/number.vala"
	_tmp6_ = z;
#line 308 "../lib/number.vala"
	_tmp7_ = z;
#line 308 "../lib/number.vala"
	number_mpc_from_radians (&_tmp6_->priv->num, &_tmp7_->priv->num, unit);
#line 313 "../lib/number.vala"
	if (!number_is_complex (self)) {
#line 313 "../lib/number.vala"
		_tmp8_ = number_is_negative (self);
#line 1408 "number.c"
	} else {
#line 313 "../lib/number.vala"
		_tmp8_ = FALSE;
#line 1412 "number.c"
	}
#line 313 "../lib/number.vala"
	if (_tmp8_) {
#line 1416 "number.c"
		Number* _tmp9_;
		MPFRGRealRef* _tmp10_;
		Number* _tmp11_;
		MPFRGRealRef* _tmp12_;
#line 314 "../lib/number.vala"
		_tmp9_ = z;
#line 314 "../lib/number.vala"
		_tmp10_ = mpc_realref (&_tmp9_->priv->num);
#line 314 "../lib/number.vala"
		_tmp11_ = z;
#line 314 "../lib/number.vala"
		_tmp12_ = mpc_realref (&_tmp11_->priv->num);
#line 314 "../lib/number.vala"
		mpfr_abs (&_tmp10_->val, &_tmp12_->val, MPFR_RNDN);
#line 1431 "number.c"
	}
#line 316 "../lib/number.vala"
	result = z;
#line 316 "../lib/number.vala"
	return result;
#line 1437 "number.c"
}

Number*
number_conjugate (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 320 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 322 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 322 "../lib/number.vala"
	z = _tmp0_;
#line 323 "../lib/number.vala"
	mpc_conj (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 324 "../lib/number.vala"
	result = z;
#line 324 "../lib/number.vala"
	return result;
#line 1458 "number.c"
}

Number*
number_real_component (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	MPFRGRealRef* _tmp1_;
	Number* result;
#line 328 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 330 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 330 "../lib/number.vala"
	z = _tmp0_;
#line 331 "../lib/number.vala"
	_tmp1_ = mpc_realref (&self->priv->num);
#line 331 "../lib/number.vala"
	mpc_set_mpreal (&z->priv->num, &_tmp1_->val, NULL, MPC_RNDNN);
#line 332 "../lib/number.vala"
	result = z;
#line 332 "../lib/number.vala"
	return result;
#line 1482 "number.c"
}

Number*
number_imaginary_component (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	MPFRGRealRef* _tmp1_;
	Number* result;
#line 336 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 339 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 339 "../lib/number.vala"
	z = _tmp0_;
#line 340 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&self->priv->num);
#line 340 "../lib/number.vala"
	mpc_set_mpreal (&z->priv->num, &_tmp1_->val, NULL, MPC_RNDNN);
#line 341 "../lib/number.vala"
	result = z;
#line 341 "../lib/number.vala"
	return result;
#line 1506 "number.c"
}

Number*
number_integer_component (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	MPFRGRealRef* _tmp1_;
	MPFRGRealRef* _tmp2_;
	MPFRGRealRef* _tmp3_;
	Number* result;
#line 344 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 346 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 346 "../lib/number.vala"
	z = _tmp0_;
#line 347 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&z->priv->num);
#line 347 "../lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 348 "../lib/number.vala"
	_tmp2_ = mpc_realref (&z->priv->num);
#line 348 "../lib/number.vala"
	_tmp3_ = mpc_realref (&self->priv->num);
#line 348 "../lib/number.vala"
	mpfr_trunc (&_tmp2_->val, &_tmp3_->val);
#line 349 "../lib/number.vala"
	result = z;
#line 349 "../lib/number.vala"
	return result;
#line 1538 "number.c"
}

Number*
number_fractional_component (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	MPFRGRealRef* _tmp1_;
	MPFRGRealRef* _tmp2_;
	MPFRGRealRef* _tmp3_;
	Number* result;
#line 353 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 355 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 355 "../lib/number.vala"
	z = _tmp0_;
#line 356 "../lib/number.vala"
	_tmp1_ = mpc_imagref (&z->priv->num);
#line 356 "../lib/number.vala"
	mpfr_set_zero (&_tmp1_->val, MPFR_RNDN);
#line 357 "../lib/number.vala"
	_tmp2_ = mpc_realref (&z->priv->num);
#line 357 "../lib/number.vala"
	_tmp3_ = mpc_realref (&self->priv->num);
#line 357 "../lib/number.vala"
	mpfr_frac (&_tmp2_->val, &_tmp3_->val, MPFR_RNDN);
#line 358 "../lib/number.vala"
	result = z;
#line 358 "../lib/number.vala"
	return result;
#line 1570 "number.c"
}

Number*
number_fractional_part (Number* self)
{
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* result;
#line 362 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 364 "../lib/number.vala"
	_tmp0_ = number_floor (self);
#line 364 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 364 "../lib/number.vala"
	_tmp2_ = number_subtract (self, _tmp1_);
#line 364 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 364 "../lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 364 "../lib/number.vala"
	result = _tmp3_;
#line 364 "../lib/number.vala"
	return result;
#line 1597 "number.c"
}

Number*
number_floor (Number* self)
{
	Number* z = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	MPFRGRealRef* _tmp3_;
	Number* _tmp4_;
	MPFRGRealRef* _tmp5_;
	MPFRGRealRef* _tmp6_;
	Number* result;
#line 368 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 370 "../lib/number.vala"
	if (number_is_complex (self)) {
#line 1615 "number.c"
		Number* _tmp0_;
#line 372 "../lib/number.vala"
		number_set_error (_ ("Floor is only defined for real numbers"));
#line 373 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 373 "../lib/number.vala"
		result = _tmp0_;
#line 373 "../lib/number.vala"
		return result;
#line 1625 "number.c"
	}
#line 376 "../lib/number.vala"
	_tmp1_ = number_new ();
#line 376 "../lib/number.vala"
	z = _tmp1_;
#line 377 "../lib/number.vala"
	_tmp2_ = z;
#line 377 "../lib/number.vala"
	_tmp3_ = mpc_imagref (&_tmp2_->priv->num);
#line 377 "../lib/number.vala"
	mpfr_set_zero (&_tmp3_->val, MPFR_RNDN);
#line 378 "../lib/number.vala"
	_tmp4_ = z;
#line 378 "../lib/number.vala"
	_tmp5_ = mpc_realref (&_tmp4_->priv->num);
#line 378 "../lib/number.vala"
	_tmp6_ = mpc_realref (&self->priv->num);
#line 378 "../lib/number.vala"
	mpfr_floor (&_tmp5_->val, &_tmp6_->val);
#line 379 "../lib/number.vala"
	result = z;
#line 379 "../lib/number.vala"
	return result;
#line 1649 "number.c"
}

Number*
number_ceiling (Number* self)
{
	Number* z = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	MPFRGRealRef* _tmp3_;
	Number* _tmp4_;
	MPFRGRealRef* _tmp5_;
	MPFRGRealRef* _tmp6_;
	Number* result;
#line 383 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 385 "../lib/number.vala"
	if (number_is_complex (self)) {
#line 1667 "number.c"
		Number* _tmp0_;
#line 387 "../lib/number.vala"
		number_set_error (_ ("Ceiling is only defined for real numbers"));
#line 388 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 388 "../lib/number.vala"
		result = _tmp0_;
#line 388 "../lib/number.vala"
		return result;
#line 1677 "number.c"
	}
#line 391 "../lib/number.vala"
	_tmp1_ = number_new ();
#line 391 "../lib/number.vala"
	z = _tmp1_;
#line 392 "../lib/number.vala"
	_tmp2_ = z;
#line 392 "../lib/number.vala"
	_tmp3_ = mpc_imagref (&_tmp2_->priv->num);
#line 392 "../lib/number.vala"
	mpfr_set_zero (&_tmp3_->val, MPFR_RNDN);
#line 393 "../lib/number.vala"
	_tmp4_ = z;
#line 393 "../lib/number.vala"
	_tmp5_ = mpc_realref (&_tmp4_->priv->num);
#line 393 "../lib/number.vala"
	_tmp6_ = mpc_realref (&self->priv->num);
#line 393 "../lib/number.vala"
	mpfr_ceil (&_tmp5_->val, &_tmp6_->val);
#line 394 "../lib/number.vala"
	result = z;
#line 394 "../lib/number.vala"
	return result;
#line 1701 "number.c"
}

Number*
number_round (Number* self)
{
	Number* z = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	MPFRGRealRef* _tmp3_;
	Number* _tmp4_;
	MPFRGRealRef* _tmp5_;
	MPFRGRealRef* _tmp6_;
	Number* result;
#line 398 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 400 "../lib/number.vala"
	if (number_is_complex (self)) {
#line 1719 "number.c"
		Number* _tmp0_;
#line 402 "../lib/number.vala"
		number_set_error (_ ("Round is only defined for real numbers"));
#line 403 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 403 "../lib/number.vala"
		result = _tmp0_;
#line 403 "../lib/number.vala"
		return result;
#line 1729 "number.c"
	}
#line 406 "../lib/number.vala"
	_tmp1_ = number_new ();
#line 406 "../lib/number.vala"
	z = _tmp1_;
#line 407 "../lib/number.vala"
	_tmp2_ = z;
#line 407 "../lib/number.vala"
	_tmp3_ = mpc_imagref (&_tmp2_->priv->num);
#line 407 "../lib/number.vala"
	mpfr_set_zero (&_tmp3_->val, MPFR_RNDN);
#line 408 "../lib/number.vala"
	_tmp4_ = z;
#line 408 "../lib/number.vala"
	_tmp5_ = mpc_realref (&_tmp4_->priv->num);
#line 408 "../lib/number.vala"
	_tmp6_ = mpc_realref (&self->priv->num);
#line 408 "../lib/number.vala"
	mpfr_round (&_tmp5_->val, &_tmp6_->val);
#line 409 "../lib/number.vala"
	result = z;
#line 409 "../lib/number.vala"
	return result;
#line 1753 "number.c"
}

Number*
number_reciprocal (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	MPFRGRealRef* _tmp1_;
	Number* result;
#line 413 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 415 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 415 "../lib/number.vala"
	z = _tmp0_;
#line 416 "../lib/number.vala"
	mpc_set_si_si (&z->priv->num, (glong) 1, (glong) 0, MPC_RNDNN);
#line 417 "../lib/number.vala"
	_tmp1_ = mpc_realref (&z->priv->num);
#line 417 "../lib/number.vala"
	mpc_fr_div (&z->priv->num, &_tmp1_->val, &self->priv->num, MPC_RNDNN);
#line 418 "../lib/number.vala"
	result = z;
#line 418 "../lib/number.vala"
	return result;
#line 1779 "number.c"
}

Number*
number_epowy (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 422 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 424 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 424 "../lib/number.vala"
	z = _tmp0_;
#line 425 "../lib/number.vala"
	mpc_exp (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 426 "../lib/number.vala"
	result = z;
#line 426 "../lib/number.vala"
	return result;
#line 1800 "number.c"
}

Number*
number_xpowy (Number* self,
              Number* y)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	Number* z = NULL;
	Number* _tmp10_;
	Number* _tmp11_;
	Number* result;
#line 430 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 430 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 433 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 433 "../lib/number.vala"
		_tmp0_ = number_is_negative (y);
#line 1823 "number.c"
	} else {
#line 433 "../lib/number.vala"
		_tmp0_ = FALSE;
#line 1827 "number.c"
	}
#line 433 "../lib/number.vala"
	if (_tmp0_) {
#line 1831 "number.c"
		Number* _tmp1_;
#line 436 "../lib/number.vala"
		number_set_error (_ ("The power of zero is undefined for a negative exponent"));
#line 437 "../lib/number.vala"
		_tmp1_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 437 "../lib/number.vala"
		result = _tmp1_;
#line 437 "../lib/number.vala"
		return result;
#line 1841 "number.c"
	}
#line 441 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 441 "../lib/number.vala"
		_tmp2_ = number_is_zero (y);
#line 1847 "number.c"
	} else {
#line 441 "../lib/number.vala"
		_tmp2_ = FALSE;
#line 1851 "number.c"
	}
#line 441 "../lib/number.vala"
	if (_tmp2_) {
#line 1855 "number.c"
		Number* _tmp3_;
#line 444 "../lib/number.vala"
		number_set_error (_ ("Zero raised to zero is undefined"));
#line 445 "../lib/number.vala"
		_tmp3_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 445 "../lib/number.vala"
		result = _tmp3_;
#line 445 "../lib/number.vala"
		return result;
#line 1865 "number.c"
	}
#line 447 "../lib/number.vala"
	if (!number_is_complex (self)) {
#line 447 "../lib/number.vala"
		_tmp5_ = !number_is_complex (y);
#line 1871 "number.c"
	} else {
#line 447 "../lib/number.vala"
		_tmp5_ = FALSE;
#line 1875 "number.c"
	}
#line 447 "../lib/number.vala"
	if (_tmp5_) {
#line 447 "../lib/number.vala"
		_tmp4_ = !number_is_integer (y);
#line 1881 "number.c"
	} else {
#line 447 "../lib/number.vala"
		_tmp4_ = FALSE;
#line 1885 "number.c"
	}
#line 447 "../lib/number.vala"
	if (_tmp4_) {
#line 1889 "number.c"
		Number* reciprocal = NULL;
		Number* _tmp6_;
		Number* _tmp7_;
#line 449 "../lib/number.vala"
		_tmp6_ = number_reciprocal (y);
#line 449 "../lib/number.vala"
		reciprocal = _tmp6_;
#line 450 "../lib/number.vala"
		_tmp7_ = reciprocal;
#line 450 "../lib/number.vala"
		if (number_is_integer (_tmp7_)) {
#line 1901 "number.c"
			Number* _tmp8_;
			Number* _tmp9_;
#line 451 "../lib/number.vala"
			_tmp8_ = reciprocal;
#line 451 "../lib/number.vala"
			_tmp9_ = number_root (self, number_to_integer (_tmp8_));
#line 451 "../lib/number.vala"
			result = _tmp9_;
#line 451 "../lib/number.vala"
			_g_object_unref0 (reciprocal);
#line 451 "../lib/number.vala"
			return result;
#line 1914 "number.c"
		}
#line 447 "../lib/number.vala"
		_g_object_unref0 (reciprocal);
#line 1918 "number.c"
	}
#line 454 "../lib/number.vala"
	_tmp10_ = number_new ();
#line 454 "../lib/number.vala"
	z = _tmp10_;
#line 455 "../lib/number.vala"
	_tmp11_ = z;
#line 455 "../lib/number.vala"
	mpc_pow (&_tmp11_->priv->num, &self->priv->num, &y->priv->num, MPC_RNDNN);
#line 456 "../lib/number.vala"
	result = z;
#line 456 "../lib/number.vala"
	return result;
#line 1932 "number.c"
}

Number*
number_xpowy_integer (Number* self,
                      gint64 n)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp2_ = FALSE;
	Number* z = NULL;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* result;
#line 460 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 463 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 463 "../lib/number.vala"
		_tmp0_ = n < ((gint64) 0);
#line 1951 "number.c"
	} else {
#line 463 "../lib/number.vala"
		_tmp0_ = FALSE;
#line 1955 "number.c"
	}
#line 463 "../lib/number.vala"
	if (_tmp0_) {
#line 1959 "number.c"
		Number* _tmp1_;
#line 466 "../lib/number.vala"
		number_set_error (_ ("The power of zero is undefined for a negative exponent"));
#line 467 "../lib/number.vala"
		_tmp1_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 467 "../lib/number.vala"
		result = _tmp1_;
#line 467 "../lib/number.vala"
		return result;
#line 1969 "number.c"
	}
#line 471 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 471 "../lib/number.vala"
		_tmp2_ = n == ((gint64) 0);
#line 1975 "number.c"
	} else {
#line 471 "../lib/number.vala"
		_tmp2_ = FALSE;
#line 1979 "number.c"
	}
#line 471 "../lib/number.vala"
	if (_tmp2_) {
#line 1983 "number.c"
		Number* _tmp3_;
#line 474 "../lib/number.vala"
		number_set_error (_ ("Zero raised to zero is undefined"));
#line 475 "../lib/number.vala"
		_tmp3_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 475 "../lib/number.vala"
		result = _tmp3_;
#line 475 "../lib/number.vala"
		return result;
#line 1993 "number.c"
	}
#line 477 "../lib/number.vala"
	_tmp4_ = number_new ();
#line 477 "../lib/number.vala"
	z = _tmp4_;
#line 478 "../lib/number.vala"
	_tmp5_ = z;
#line 478 "../lib/number.vala"
	mpc_pow_si (&_tmp5_->priv->num, &self->priv->num, (glong) n, MPC_RNDNN);
#line 479 "../lib/number.vala"
	result = z;
#line 479 "../lib/number.vala"
	return result;
#line 2007 "number.c"
}

Number*
number_root (Number* self,
             gint64 n)
{
	guint64 p = 0ULL;
	Number* z = NULL;
	Number* _tmp0_;
	gboolean _tmp4_ = FALSE;
	Number* result;
#line 483 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 486 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 486 "../lib/number.vala"
	z = _tmp0_;
#line 487 "../lib/number.vala"
	if (n < ((gint64) 0)) {
#line 2027 "number.c"
		Number* _tmp1_;
#line 489 "../lib/number.vala"
		_tmp1_ = z;
#line 489 "../lib/number.vala"
		mpc_ui_div (&_tmp1_->priv->num, (gulong) 1, &self->priv->num, MPC_RNDNN);
#line 490 "../lib/number.vala"
		if (n == G_MININT64) {
#line 491 "../lib/number.vala"
			p = ((guint64) G_MAXINT64) + 1;
#line 2037 "number.c"
		} else {
#line 493 "../lib/number.vala"
			p = (guint64) (-n);
#line 2041 "number.c"
		}
	} else {
#line 494 "../lib/number.vala"
		if (n > ((gint64) 0)) {
#line 2046 "number.c"
			Number* _tmp2_;
#line 495 "../lib/number.vala"
			_tmp2_ = z;
#line 495 "../lib/number.vala"
			mpc_set (&_tmp2_->priv->num, &self->priv->num, MPC_RNDNN);
#line 496 "../lib/number.vala"
			p = (guint64) n;
#line 2054 "number.c"
		} else {
			Number* _tmp3_;
#line 498 "../lib/number.vala"
			number_set_error (_ ("The zeroth root of a number is undefined"));
#line 499 "../lib/number.vala"
			_tmp3_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 499 "../lib/number.vala"
			result = _tmp3_;
#line 499 "../lib/number.vala"
			_g_object_unref0 (z);
#line 499 "../lib/number.vala"
			return result;
#line 2067 "number.c"
		}
	}
#line 502 "../lib/number.vala"
	if (!number_is_complex (self)) {
#line 2072 "number.c"
		gboolean _tmp5_ = FALSE;
#line 502 "../lib/number.vala"
		if (!number_is_negative (self)) {
#line 502 "../lib/number.vala"
			_tmp5_ = TRUE;
#line 2078 "number.c"
		} else {
#line 502 "../lib/number.vala"
			_tmp5_ = (p & 1) == ((guint64) 1);
#line 2082 "number.c"
		}
#line 502 "../lib/number.vala"
		_tmp4_ = _tmp5_;
#line 2086 "number.c"
	} else {
#line 502 "../lib/number.vala"
		_tmp4_ = FALSE;
#line 2090 "number.c"
	}
#line 502 "../lib/number.vala"
	if (_tmp4_) {
#line 2094 "number.c"
		Number* _tmp6_;
		MPFRGRealRef* _tmp7_;
		Number* _tmp8_;
		MPFRGRealRef* _tmp9_;
		Number* _tmp10_;
		MPFRGRealRef* _tmp11_;
#line 504 "../lib/number.vala"
		_tmp6_ = z;
#line 504 "../lib/number.vala"
		_tmp7_ = mpc_realref (&_tmp6_->priv->num);
#line 504 "../lib/number.vala"
		_tmp8_ = z;
#line 504 "../lib/number.vala"
		_tmp9_ = mpc_realref (&_tmp8_->priv->num);
#line 504 "../lib/number.vala"
		mpfr_root (&_tmp7_->val, &_tmp9_->val, (gulong) p, MPFR_RNDN);
#line 505 "../lib/number.vala"
		_tmp10_ = z;
#line 505 "../lib/number.vala"
		_tmp11_ = mpc_imagref (&_tmp10_->priv->num);
#line 505 "../lib/number.vala"
		mpfr_set_zero (&_tmp11_->val, MPFR_RNDN);
#line 2117 "number.c"
	} else {
		__mpfr_struct tmp = {0};
		mpfr_prec_t _tmp12_;
		mpfr_prec_t _tmp13_;
		Number* _tmp14_;
		Number* _tmp15_;
#line 507 "../lib/number.vala"
		_tmp12_ = number_get_precision ();
#line 507 "../lib/number.vala"
		_tmp13_ = _tmp12_;
#line 507 "../lib/number.vala"
		mpfr_init2 (&tmp, _tmp13_);
#line 508 "../lib/number.vala"
		mpfr_set_ui (&tmp, (gulong) p, MPFR_RNDN);
#line 509 "../lib/number.vala"
		mpfr_ui_div (&tmp, (gulong) 1, &tmp, MPFR_RNDN);
#line 510 "../lib/number.vala"
		_tmp14_ = z;
#line 510 "../lib/number.vala"
		_tmp15_ = z;
#line 510 "../lib/number.vala"
		mpc_pow_fr (&_tmp14_->priv->num, &_tmp15_->priv->num, &tmp, MPC_RNDNN);
#line 502 "../lib/number.vala"
		mpfr_clear (&tmp);
#line 2142 "number.c"
	}
#line 512 "../lib/number.vala"
	result = z;
#line 512 "../lib/number.vala"
	return result;
#line 2148 "number.c"
}

Number*
number_sqrt (Number* self)
{
	Number* _tmp0_;
	Number* result;
#line 516 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 518 "../lib/number.vala"
	_tmp0_ = number_root (self, (gint64) 2);
#line 518 "../lib/number.vala"
	result = _tmp0_;
#line 518 "../lib/number.vala"
	return result;
#line 2164 "number.c"
}

Number*
number_ln (Number* self)
{
	Number* z = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	gboolean _tmp3_ = FALSE;
	Number* result;
#line 522 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 525 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 2179 "number.c"
		Number* _tmp0_;
#line 528 "../lib/number.vala"
		number_set_error (_ ("Logarithm of zero is undefined"));
#line 529 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 529 "../lib/number.vala"
		result = _tmp0_;
#line 529 "../lib/number.vala"
		return result;
#line 2189 "number.c"
	}
#line 541 "../lib/number.vala"
	_tmp1_ = number_new ();
#line 541 "../lib/number.vala"
	z = _tmp1_;
#line 542 "../lib/number.vala"
	_tmp2_ = z;
#line 542 "../lib/number.vala"
	mpc_log (&_tmp2_->priv->num, &self->priv->num, MPC_RNDNN);
#line 546 "../lib/number.vala"
	if (!number_is_complex (self)) {
#line 546 "../lib/number.vala"
		_tmp3_ = number_is_negative (self);
#line 2203 "number.c"
	} else {
#line 546 "../lib/number.vala"
		_tmp3_ = FALSE;
#line 2207 "number.c"
	}
#line 546 "../lib/number.vala"
	if (_tmp3_) {
#line 2211 "number.c"
		Number* _tmp4_;
		MPFRGRealRef* _tmp5_;
		Number* _tmp6_;
		MPFRGRealRef* _tmp7_;
#line 547 "../lib/number.vala"
		_tmp4_ = z;
#line 547 "../lib/number.vala"
		_tmp5_ = mpc_imagref (&_tmp4_->priv->num);
#line 547 "../lib/number.vala"
		_tmp6_ = z;
#line 547 "../lib/number.vala"
		_tmp7_ = mpc_imagref (&_tmp6_->priv->num);
#line 547 "../lib/number.vala"
		mpfr_abs (&_tmp5_->val, &_tmp7_->val, MPFR_RNDN);
#line 2226 "number.c"
	}
#line 549 "../lib/number.vala"
	result = z;
#line 549 "../lib/number.vala"
	return result;
#line 2232 "number.c"
}

Number*
number_logarithm (Number* self,
                  gint64 n)
{
	Number* t1 = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* _tmp6_;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* result;
#line 553 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 556 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 2253 "number.c"
		Number* _tmp0_;
#line 559 "../lib/number.vala"
		number_set_error (_ ("Logarithm of zero is undefined"));
#line 560 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 560 "../lib/number.vala"
		result = _tmp0_;
#line 560 "../lib/number.vala"
		return result;
#line 2263 "number.c"
	}
#line 564 "../lib/number.vala"
	_tmp1_ = number_new_integer (n, (gint64) 0);
#line 564 "../lib/number.vala"
	t1 = _tmp1_;
#line 565 "../lib/number.vala"
	_tmp2_ = number_ln (self);
#line 565 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 565 "../lib/number.vala"
	_tmp4_ = t1;
#line 565 "../lib/number.vala"
	_tmp5_ = number_ln (_tmp4_);
#line 565 "../lib/number.vala"
	_tmp6_ = _tmp5_;
#line 565 "../lib/number.vala"
	_tmp7_ = number_divide (_tmp3_, _tmp6_);
#line 565 "../lib/number.vala"
	_tmp8_ = _tmp7_;
#line 565 "../lib/number.vala"
	_g_object_unref0 (_tmp6_);
#line 565 "../lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 565 "../lib/number.vala"
	result = _tmp8_;
#line 565 "../lib/number.vala"
	_g_object_unref0 (t1);
#line 565 "../lib/number.vala"
	return result;
#line 2293 "number.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 596 "../lib/number.vala"
	return self ? g_object_ref (self) : NULL;
#line 2301 "number.c"
}

Number*
number_factorial (Number* self)
{
	gint64 value = 0LL;
	Number* z = NULL;
	Number* _tmp12_;
	Number* result;
#line 569 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 572 "../lib/number.vala"
	if (number_is_zero (self)) {
#line 2315 "number.c"
		Number* _tmp0_;
#line 573 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 573 "../lib/number.vala"
		result = _tmp0_;
#line 573 "../lib/number.vala"
		return result;
#line 2323 "number.c"
	}
#line 574 "../lib/number.vala"
	if (!number_is_natural (self)) {
#line 2327 "number.c"
		gboolean _tmp1_ = FALSE;
		Number* tmp = NULL;
		Number* _tmp3_;
		Number* _tmp4_;
		Number* _tmp5_;
		Number* _tmp6_;
		__mpfr_struct tmp2 = {0};
		mpfr_prec_t _tmp7_;
		mpfr_prec_t _tmp8_;
		Number* _tmp9_;
		MPFRGRealRef* _tmp10_;
		Number* _tmp11_;
#line 578 "../lib/number.vala"
		if (number_is_negative (self)) {
#line 578 "../lib/number.vala"
			_tmp1_ = TRUE;
#line 2344 "number.c"
		} else {
#line 578 "../lib/number.vala"
			_tmp1_ = number_is_complex (self);
#line 2348 "number.c"
		}
#line 578 "../lib/number.vala"
		if (_tmp1_) {
#line 2352 "number.c"
			Number* _tmp2_;
#line 581 "../lib/number.vala"
			number_set_error (_ ("Factorial is only defined for non-negative real numbers"));
#line 582 "../lib/number.vala"
			_tmp2_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 582 "../lib/number.vala"
			result = _tmp2_;
#line 582 "../lib/number.vala"
			return result;
#line 2362 "number.c"
		}
#line 585 "../lib/number.vala"
		_tmp3_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 585 "../lib/number.vala"
		_tmp4_ = _tmp3_;
#line 585 "../lib/number.vala"
		_tmp5_ = number_add (self, _tmp4_);
#line 585 "../lib/number.vala"
		_tmp6_ = _tmp5_;
#line 585 "../lib/number.vala"
		_g_object_unref0 (_tmp4_);
#line 585 "../lib/number.vala"
		tmp = _tmp6_;
#line 586 "../lib/number.vala"
		_tmp7_ = number_get_precision ();
#line 586 "../lib/number.vala"
		_tmp8_ = _tmp7_;
#line 586 "../lib/number.vala"
		mpfr_init2 (&tmp2, _tmp8_);
#line 589 "../lib/number.vala"
		_tmp9_ = tmp;
#line 589 "../lib/number.vala"
		_tmp10_ = mpc_realref (&_tmp9_->priv->num);
#line 589 "../lib/number.vala"
		mpfr_gamma (&tmp2, &_tmp10_->val, MPFR_RNDN);
#line 591 "../lib/number.vala"
		_tmp11_ = number_new_mpreal (&tmp2, NULL);
#line 591 "../lib/number.vala"
		result = _tmp11_;
#line 591 "../lib/number.vala"
		mpfr_clear (&tmp2);
#line 591 "../lib/number.vala"
		_g_object_unref0 (tmp);
#line 591 "../lib/number.vala"
		return result;
#line 2398 "number.c"
	}
#line 595 "../lib/number.vala"
	value = number_to_integer (self);
#line 596 "../lib/number.vala"
	_tmp12_ = _g_object_ref0 (self);
#line 596 "../lib/number.vala"
	z = _tmp12_;
#line 2406 "number.c"
	{
		gint i = 0;
#line 597 "../lib/number.vala"
		i = 2;
#line 2411 "number.c"
		{
			gboolean _tmp13_ = FALSE;
#line 597 "../lib/number.vala"
			_tmp13_ = TRUE;
#line 597 "../lib/number.vala"
			while (TRUE) {
#line 2418 "number.c"
				Number* _tmp15_;
				Number* _tmp16_;
#line 597 "../lib/number.vala"
				if (!_tmp13_) {
#line 2423 "number.c"
					gint _tmp14_;
#line 597 "../lib/number.vala"
					_tmp14_ = i;
#line 597 "../lib/number.vala"
					i = _tmp14_ + 1;
#line 2429 "number.c"
				}
#line 597 "../lib/number.vala"
				_tmp13_ = FALSE;
#line 597 "../lib/number.vala"
				if (!(((gint64) i) < value)) {
#line 597 "../lib/number.vala"
					break;
#line 2437 "number.c"
				}
#line 598 "../lib/number.vala"
				_tmp15_ = z;
#line 598 "../lib/number.vala"
				_tmp16_ = number_multiply_integer (_tmp15_, (gint64) i);
#line 598 "../lib/number.vala"
				_g_object_unref0 (z);
#line 598 "../lib/number.vala"
				z = _tmp16_;
#line 2447 "number.c"
			}
		}
	}
#line 600 "../lib/number.vala"
	result = z;
#line 600 "../lib/number.vala"
	return result;
#line 2455 "number.c"
}

Number*
number_add (Number* self,
            Number* y)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 604 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 604 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 606 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 606 "../lib/number.vala"
	z = _tmp0_;
#line 607 "../lib/number.vala"
	mpc_add (&z->priv->num, &self->priv->num, &y->priv->num, MPC_RNDNN);
#line 608 "../lib/number.vala"
	result = z;
#line 608 "../lib/number.vala"
	return result;
#line 2479 "number.c"
}

Number*
number_subtract (Number* self,
                 Number* y)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 612 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 612 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 614 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 614 "../lib/number.vala"
	z = _tmp0_;
#line 615 "../lib/number.vala"
	mpc_sub (&z->priv->num, &self->priv->num, &y->priv->num, MPC_RNDNN);
#line 616 "../lib/number.vala"
	result = z;
#line 616 "../lib/number.vala"
	return result;
#line 2503 "number.c"
}

Number*
number_multiply (Number* self,
                 Number* y)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 620 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 620 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 622 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 622 "../lib/number.vala"
	z = _tmp0_;
#line 623 "../lib/number.vala"
	mpc_mul (&z->priv->num, &self->priv->num, &y->priv->num, MPC_RNDNN);
#line 624 "../lib/number.vala"
	result = z;
#line 624 "../lib/number.vala"
	return result;
#line 2527 "number.c"
}

Number*
number_multiply_integer (Number* self,
                         gint64 y)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 628 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 630 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 630 "../lib/number.vala"
	z = _tmp0_;
#line 631 "../lib/number.vala"
	mpc_mul_si (&z->priv->num, &self->priv->num, (glong) y, MPC_RNDNN);
#line 632 "../lib/number.vala"
	result = z;
#line 632 "../lib/number.vala"
	return result;
#line 2549 "number.c"
}

Number*
number_divide (Number* self,
               Number* y)
{
	Number* z = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* result;
#line 636 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 636 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 638 "../lib/number.vala"
	if (number_is_zero (y)) {
#line 2566 "number.c"
		Number* _tmp0_;
#line 641 "../lib/number.vala"
		number_set_error (_ ("Division by zero is undefined"));
#line 642 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 642 "../lib/number.vala"
		result = _tmp0_;
#line 642 "../lib/number.vala"
		return result;
#line 2576 "number.c"
	}
#line 645 "../lib/number.vala"
	_tmp1_ = number_new ();
#line 645 "../lib/number.vala"
	z = _tmp1_;
#line 646 "../lib/number.vala"
	_tmp2_ = z;
#line 646 "../lib/number.vala"
	mpc_div (&_tmp2_->priv->num, &self->priv->num, &y->priv->num, MPC_RNDNN);
#line 647 "../lib/number.vala"
	result = z;
#line 647 "../lib/number.vala"
	return result;
#line 2590 "number.c"
}

Number*
number_divide_integer (Number* self,
                       gint64 y)
{
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* result;
#line 651 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 653 "../lib/number.vala"
	_tmp0_ = number_new_integer (y, (gint64) 0);
#line 653 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 653 "../lib/number.vala"
	_tmp2_ = number_divide (self, _tmp1_);
#line 653 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 653 "../lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 653 "../lib/number.vala"
	result = _tmp3_;
#line 653 "../lib/number.vala"
	return result;
#line 2618 "number.c"
}

Number*
number_modulus_divide (Number* self,
                       Number* y)
{
	gboolean _tmp0_ = FALSE;
	Number* t1 = NULL;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* t2 = NULL;
	Number* _tmp6_;
	Number* _tmp7_;
	Number* z = NULL;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* _tmp10_;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	Number* _tmp13_;
	Number* result;
#line 657 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 657 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 659 "../lib/number.vala"
	if (!number_is_integer (self)) {
#line 659 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 2650 "number.c"
	} else {
#line 659 "../lib/number.vala"
		_tmp0_ = !number_is_integer (y);
#line 2654 "number.c"
	}
#line 659 "../lib/number.vala"
	if (_tmp0_) {
#line 2658 "number.c"
		Number* _tmp1_;
#line 662 "../lib/number.vala"
		number_set_error (_ ("Modulus division is only defined for integers"));
#line 663 "../lib/number.vala"
		_tmp1_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 663 "../lib/number.vala"
		result = _tmp1_;
#line 663 "../lib/number.vala"
		return result;
#line 2668 "number.c"
	}
#line 666 "../lib/number.vala"
	_tmp2_ = number_divide (self, y);
#line 666 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 666 "../lib/number.vala"
	_tmp4_ = number_floor (_tmp3_);
#line 666 "../lib/number.vala"
	_tmp5_ = _tmp4_;
#line 666 "../lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 666 "../lib/number.vala"
	t1 = _tmp5_;
#line 667 "../lib/number.vala"
	_tmp6_ = t1;
#line 667 "../lib/number.vala"
	_tmp7_ = number_multiply (_tmp6_, y);
#line 667 "../lib/number.vala"
	t2 = _tmp7_;
#line 668 "../lib/number.vala"
	_tmp8_ = t2;
#line 668 "../lib/number.vala"
	_tmp9_ = number_subtract (self, _tmp8_);
#line 668 "../lib/number.vala"
	z = _tmp9_;
#line 670 "../lib/number.vala"
	_tmp10_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 670 "../lib/number.vala"
	_g_object_unref0 (t1);
#line 670 "../lib/number.vala"
	t1 = _tmp10_;
#line 671 "../lib/number.vala"
	_tmp13_ = t1;
#line 671 "../lib/number.vala"
	if (number_compare (y, _tmp13_) < 0) {
#line 2704 "number.c"
		Number* _tmp14_;
		Number* _tmp15_;
#line 671 "../lib/number.vala"
		_tmp14_ = z;
#line 671 "../lib/number.vala"
		_tmp15_ = t1;
#line 671 "../lib/number.vala"
		_tmp12_ = number_compare (_tmp14_, _tmp15_) > 0;
#line 2713 "number.c"
	} else {
#line 671 "../lib/number.vala"
		_tmp12_ = FALSE;
#line 2717 "number.c"
	}
#line 671 "../lib/number.vala"
	if (_tmp12_) {
#line 671 "../lib/number.vala"
		_tmp11_ = TRUE;
#line 2723 "number.c"
	} else {
		gboolean _tmp16_ = FALSE;
		Number* _tmp17_;
#line 671 "../lib/number.vala"
		_tmp17_ = t1;
#line 671 "../lib/number.vala"
		if (number_compare (y, _tmp17_) > 0) {
#line 2731 "number.c"
			Number* _tmp18_;
			Number* _tmp19_;
#line 671 "../lib/number.vala"
			_tmp18_ = z;
#line 671 "../lib/number.vala"
			_tmp19_ = t1;
#line 671 "../lib/number.vala"
			_tmp16_ = number_compare (_tmp18_, _tmp19_) < 0;
#line 2740 "number.c"
		} else {
#line 671 "../lib/number.vala"
			_tmp16_ = FALSE;
#line 2744 "number.c"
		}
#line 671 "../lib/number.vala"
		_tmp11_ = _tmp16_;
#line 2748 "number.c"
	}
#line 671 "../lib/number.vala"
	if (_tmp11_) {
#line 2752 "number.c"
		Number* _tmp20_;
		Number* _tmp21_;
#line 672 "../lib/number.vala"
		_tmp20_ = z;
#line 672 "../lib/number.vala"
		_tmp21_ = number_add (_tmp20_, y);
#line 672 "../lib/number.vala"
		_g_object_unref0 (z);
#line 672 "../lib/number.vala"
		z = _tmp21_;
#line 2763 "number.c"
	}
#line 674 "../lib/number.vala"
	result = z;
#line 674 "../lib/number.vala"
	_g_object_unref0 (t2);
#line 674 "../lib/number.vala"
	_g_object_unref0 (t1);
#line 674 "../lib/number.vala"
	return result;
#line 2773 "number.c"
}

Number*
number_modular_exponentiation (Number* self,
                               Number* exp,
                               Number* mod)
{
	Number* base_value = NULL;
	Number* _tmp0_;
	Number* exp_value = NULL;
	Number* _tmp3_;
	Number* ans = NULL;
	Number* _tmp4_;
	Number* two = NULL;
	Number* _tmp5_;
	Number* _tmp26_;
	Number* _tmp27_;
	Number* result;
#line 678 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 678 "../lib/number.vala"
	g_return_val_if_fail (exp != NULL, NULL);
#line 678 "../lib/number.vala"
	g_return_val_if_fail (mod != NULL, NULL);
#line 680 "../lib/number.vala"
	_tmp0_ = number_copy (self);
#line 680 "../lib/number.vala"
	base_value = _tmp0_;
#line 681 "../lib/number.vala"
	if (number_is_negative (exp)) {
#line 2804 "number.c"
		Number* _tmp1_;
		Number* _tmp2_;
#line 682 "../lib/number.vala"
		_tmp1_ = base_value;
#line 682 "../lib/number.vala"
		_tmp2_ = number_reciprocal (_tmp1_);
#line 682 "../lib/number.vala"
		_g_object_unref0 (base_value);
#line 682 "../lib/number.vala"
		base_value = _tmp2_;
#line 2815 "number.c"
	}
#line 683 "../lib/number.vala"
	_tmp3_ = number_abs (exp);
#line 683 "../lib/number.vala"
	exp_value = _tmp3_;
#line 684 "../lib/number.vala"
	_tmp4_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 684 "../lib/number.vala"
	ans = _tmp4_;
#line 685 "../lib/number.vala"
	_tmp5_ = number_new_integer ((gint64) 2, (gint64) 0);
#line 685 "../lib/number.vala"
	two = _tmp5_;
#line 686 "../lib/number.vala"
	while (TRUE) {
#line 2831 "number.c"
		Number* _tmp6_;
		gboolean is_even = FALSE;
		Number* _tmp7_;
		Number* _tmp8_;
		Number* _tmp9_;
		Number* _tmp10_;
		gboolean _tmp11_;
		Number* _tmp17_;
		Number* _tmp18_;
		Number* _tmp19_;
		Number* _tmp20_;
		Number* _tmp21_;
		Number* _tmp22_;
		Number* _tmp23_;
		Number* _tmp24_;
		Number* _tmp25_;
#line 686 "../lib/number.vala"
		_tmp6_ = exp_value;
#line 686 "../lib/number.vala"
		if (!(!number_is_zero (_tmp6_))) {
#line 686 "../lib/number.vala"
			break;
#line 2854 "number.c"
		}
#line 688 "../lib/number.vala"
		_tmp7_ = exp_value;
#line 688 "../lib/number.vala"
		_tmp8_ = two;
#line 688 "../lib/number.vala"
		_tmp9_ = number_modulus_divide (_tmp7_, _tmp8_);
#line 688 "../lib/number.vala"
		_tmp10_ = _tmp9_;
#line 688 "../lib/number.vala"
		_tmp11_ = number_is_zero (_tmp10_);
#line 688 "../lib/number.vala"
		_g_object_unref0 (_tmp10_);
#line 688 "../lib/number.vala"
		is_even = _tmp11_;
#line 689 "../lib/number.vala"
		if (!is_even) {
#line 2872 "number.c"
			Number* _tmp12_;
			Number* _tmp13_;
			Number* _tmp14_;
			Number* _tmp15_;
			Number* _tmp16_;
#line 691 "../lib/number.vala"
			_tmp12_ = ans;
#line 691 "../lib/number.vala"
			_tmp13_ = base_value;
#line 691 "../lib/number.vala"
			_tmp14_ = number_multiply (_tmp12_, _tmp13_);
#line 691 "../lib/number.vala"
			_g_object_unref0 (ans);
#line 691 "../lib/number.vala"
			ans = _tmp14_;
#line 692 "../lib/number.vala"
			_tmp15_ = ans;
#line 692 "../lib/number.vala"
			_tmp16_ = number_modulus_divide (_tmp15_, mod);
#line 692 "../lib/number.vala"
			_g_object_unref0 (ans);
#line 692 "../lib/number.vala"
			ans = _tmp16_;
#line 2896 "number.c"
		}
#line 694 "../lib/number.vala"
		_tmp17_ = base_value;
#line 694 "../lib/number.vala"
		_tmp18_ = base_value;
#line 694 "../lib/number.vala"
		_tmp19_ = number_multiply (_tmp17_, _tmp18_);
#line 694 "../lib/number.vala"
		_g_object_unref0 (base_value);
#line 694 "../lib/number.vala"
		base_value = _tmp19_;
#line 695 "../lib/number.vala"
		_tmp20_ = base_value;
#line 695 "../lib/number.vala"
		_tmp21_ = number_modulus_divide (_tmp20_, mod);
#line 695 "../lib/number.vala"
		_g_object_unref0 (base_value);
#line 695 "../lib/number.vala"
		base_value = _tmp21_;
#line 696 "../lib/number.vala"
		_tmp22_ = exp_value;
#line 696 "../lib/number.vala"
		_tmp23_ = number_divide_integer (_tmp22_, (gint64) 2);
#line 696 "../lib/number.vala"
		_tmp24_ = _tmp23_;
#line 696 "../lib/number.vala"
		_tmp25_ = number_floor (_tmp24_);
#line 696 "../lib/number.vala"
		_g_object_unref0 (exp_value);
#line 696 "../lib/number.vala"
		exp_value = _tmp25_;
#line 696 "../lib/number.vala"
		_g_object_unref0 (_tmp24_);
#line 2930 "number.c"
	}
#line 698 "../lib/number.vala"
	_tmp26_ = ans;
#line 698 "../lib/number.vala"
	_tmp27_ = number_modulus_divide (_tmp26_, mod);
#line 698 "../lib/number.vala"
	result = _tmp27_;
#line 698 "../lib/number.vala"
	_g_object_unref0 (two);
#line 698 "../lib/number.vala"
	_g_object_unref0 (ans);
#line 698 "../lib/number.vala"
	_g_object_unref0 (exp_value);
#line 698 "../lib/number.vala"
	_g_object_unref0 (base_value);
#line 698 "../lib/number.vala"
	return result;
#line 2948 "number.c"
}

Number*
number_sin (Number* self,
            AngleUnit unit)
{
	Number* z = NULL;
	Number* _tmp1_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* result;
#line 702 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 705 "../lib/number.vala"
	if (number_is_180n_degrees (self, unit)) {
#line 2964 "number.c"
		Number* _tmp0_;
#line 706 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 706 "../lib/number.vala"
		result = _tmp0_;
#line 706 "../lib/number.vala"
		return result;
#line 2972 "number.c"
	}
#line 708 "../lib/number.vala"
	_tmp1_ = number_new ();
#line 708 "../lib/number.vala"
	z = _tmp1_;
#line 709 "../lib/number.vala"
	if (number_is_complex (self)) {
#line 2980 "number.c"
		Number* _tmp2_;
#line 710 "../lib/number.vala"
		_tmp2_ = z;
#line 710 "../lib/number.vala"
		mpc_set (&_tmp2_->priv->num, &self->priv->num, MPC_RNDNN);
#line 2986 "number.c"
	} else {
		Number* _tmp3_;
#line 712 "../lib/number.vala"
		_tmp3_ = z;
#line 712 "../lib/number.vala"
		number_mpc_to_radians (&_tmp3_->priv->num, &self->priv->num, unit);
#line 2993 "number.c"
	}
#line 713 "../lib/number.vala"
	_tmp4_ = z;
#line 713 "../lib/number.vala"
	_tmp5_ = z;
#line 713 "../lib/number.vala"
	mpc_sin (&_tmp4_->priv->num, &_tmp5_->priv->num, MPC_RNDNN);
#line 714 "../lib/number.vala"
	result = z;
#line 714 "../lib/number.vala"
	return result;
#line 3005 "number.c"
}

Number*
number_cos (Number* self,
            AngleUnit unit)
{
	Number* z = NULL;
	Number* _tmp1_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* result;
#line 718 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 721 "../lib/number.vala"
	if (number_is_180n_plus_90_degrees (self, unit)) {
#line 3021 "number.c"
		Number* _tmp0_;
#line 722 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 722 "../lib/number.vala"
		result = _tmp0_;
#line 722 "../lib/number.vala"
		return result;
#line 3029 "number.c"
	}
#line 724 "../lib/number.vala"
	_tmp1_ = number_new ();
#line 724 "../lib/number.vala"
	z = _tmp1_;
#line 725 "../lib/number.vala"
	if (number_is_complex (self)) {
#line 3037 "number.c"
		Number* _tmp2_;
#line 726 "../lib/number.vala"
		_tmp2_ = z;
#line 726 "../lib/number.vala"
		mpc_set (&_tmp2_->priv->num, &self->priv->num, MPC_RNDNN);
#line 3043 "number.c"
	} else {
		Number* _tmp3_;
#line 728 "../lib/number.vala"
		_tmp3_ = z;
#line 728 "../lib/number.vala"
		number_mpc_to_radians (&_tmp3_->priv->num, &self->priv->num, unit);
#line 3050 "number.c"
	}
#line 729 "../lib/number.vala"
	_tmp4_ = z;
#line 729 "../lib/number.vala"
	_tmp5_ = z;
#line 729 "../lib/number.vala"
	mpc_cos (&_tmp4_->priv->num, &_tmp5_->priv->num, MPC_RNDNN);
#line 730 "../lib/number.vala"
	result = z;
#line 730 "../lib/number.vala"
	return result;
#line 3062 "number.c"
}

Number*
number_tan (Number* self,
            AngleUnit unit)
{
	Number* z = NULL;
	Number* _tmp2_;
	Number* _tmp5_;
	Number* _tmp6_;
	Number* result;
#line 734 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 737 "../lib/number.vala"
	if (number_is_180n_degrees (self, unit)) {
#line 3078 "number.c"
		Number* _tmp0_;
#line 738 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 738 "../lib/number.vala"
		result = _tmp0_;
#line 738 "../lib/number.vala"
		return result;
#line 3086 "number.c"
	} else {
#line 739 "../lib/number.vala"
		if (number_is_180n_plus_90_degrees (self, unit)) {
#line 3090 "number.c"
			Number* _tmp1_;
#line 742 "../lib/number.vala"
			number_set_error (_ ("Tangent is undefined for angles that are multiples of π (180°) from π∕" \
"2 (90°)"));
#line 743 "../lib/number.vala"
			_tmp1_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 743 "../lib/number.vala"
			result = _tmp1_;
#line 743 "../lib/number.vala"
			return result;
#line 3100 "number.c"
		}
	}
#line 746 "../lib/number.vala"
	_tmp2_ = number_new ();
#line 746 "../lib/number.vala"
	z = _tmp2_;
#line 747 "../lib/number.vala"
	if (number_is_complex (self)) {
#line 3109 "number.c"
		Number* _tmp3_;
#line 748 "../lib/number.vala"
		_tmp3_ = z;
#line 748 "../lib/number.vala"
		mpc_set (&_tmp3_->priv->num, &self->priv->num, MPC_RNDNN);
#line 3115 "number.c"
	} else {
		Number* _tmp4_;
#line 750 "../lib/number.vala"
		_tmp4_ = z;
#line 750 "../lib/number.vala"
		number_mpc_to_radians (&_tmp4_->priv->num, &self->priv->num, unit);
#line 3122 "number.c"
	}
#line 751 "../lib/number.vala"
	_tmp5_ = z;
#line 751 "../lib/number.vala"
	_tmp6_ = z;
#line 751 "../lib/number.vala"
	mpc_tan (&_tmp5_->priv->num, &_tmp6_->priv->num, MPC_RNDNN);
#line 752 "../lib/number.vala"
	result = z;
#line 752 "../lib/number.vala"
	return result;
#line 3134 "number.c"
}

Number*
number_asin (Number* self,
             AngleUnit unit)
{
	gboolean _tmp0_ = FALSE;
	Number* z = NULL;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* _tmp10_;
	Number* result;
#line 756 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 758 "../lib/number.vala"
	if (!number_is_complex (self)) {
#line 3151 "number.c"
		gboolean _tmp1_ = FALSE;
		Number* _tmp2_;
		Number* _tmp3_;
		gboolean _tmp4_;
#line 758 "../lib/number.vala"
		_tmp2_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 758 "../lib/number.vala"
		_tmp3_ = _tmp2_;
#line 758 "../lib/number.vala"
		_tmp4_ = number_compare (self, _tmp3_) > 0;
#line 758 "../lib/number.vala"
		_g_object_unref0 (_tmp3_);
#line 758 "../lib/number.vala"
		if (_tmp4_) {
#line 758 "../lib/number.vala"
			_tmp1_ = TRUE;
#line 3168 "number.c"
		} else {
			Number* _tmp5_;
			Number* _tmp6_;
#line 758 "../lib/number.vala"
			_tmp5_ = number_new_integer ((gint64) -1, (gint64) 0);
#line 758 "../lib/number.vala"
			_tmp6_ = _tmp5_;
#line 758 "../lib/number.vala"
			_tmp1_ = number_compare (self, _tmp6_) < 0;
#line 758 "../lib/number.vala"
			_g_object_unref0 (_tmp6_);
#line 3180 "number.c"
		}
#line 758 "../lib/number.vala"
		_tmp0_ = _tmp1_;
#line 3184 "number.c"
	} else {
#line 758 "../lib/number.vala"
		_tmp0_ = FALSE;
#line 3188 "number.c"
	}
#line 758 "../lib/number.vala"
	if (_tmp0_) {
#line 3192 "number.c"
		Number* _tmp7_;
#line 761 "../lib/number.vala"
		number_set_error (_ ("Inverse sine is undefined for values outside [-1, 1]"));
#line 762 "../lib/number.vala"
		_tmp7_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 762 "../lib/number.vala"
		result = _tmp7_;
#line 762 "../lib/number.vala"
		return result;
#line 3202 "number.c"
	}
#line 765 "../lib/number.vala"
	_tmp8_ = number_new ();
#line 765 "../lib/number.vala"
	z = _tmp8_;
#line 766 "../lib/number.vala"
	_tmp9_ = z;
#line 766 "../lib/number.vala"
	mpc_asin (&_tmp9_->priv->num, &self->priv->num, MPC_RNDNN);
#line 767 "../lib/number.vala"
	_tmp10_ = z;
#line 767 "../lib/number.vala"
	if (!number_is_complex (_tmp10_)) {
#line 3216 "number.c"
		Number* _tmp11_;
		Number* _tmp12_;
#line 768 "../lib/number.vala"
		_tmp11_ = z;
#line 768 "../lib/number.vala"
		_tmp12_ = z;
#line 768 "../lib/number.vala"
		number_mpc_from_radians (&_tmp11_->priv->num, &_tmp12_->priv->num, unit);
#line 3225 "number.c"
	}
#line 769 "../lib/number.vala"
	result = z;
#line 769 "../lib/number.vala"
	return result;
#line 3231 "number.c"
}

Number*
number_acos (Number* self,
             AngleUnit unit)
{
	gboolean _tmp0_ = FALSE;
	Number* z = NULL;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* _tmp10_;
	Number* result;
#line 773 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 775 "../lib/number.vala"
	if (!number_is_complex (self)) {
#line 3248 "number.c"
		gboolean _tmp1_ = FALSE;
		Number* _tmp2_;
		Number* _tmp3_;
		gboolean _tmp4_;
#line 775 "../lib/number.vala"
		_tmp2_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 775 "../lib/number.vala"
		_tmp3_ = _tmp2_;
#line 775 "../lib/number.vala"
		_tmp4_ = number_compare (self, _tmp3_) > 0;
#line 775 "../lib/number.vala"
		_g_object_unref0 (_tmp3_);
#line 775 "../lib/number.vala"
		if (_tmp4_) {
#line 775 "../lib/number.vala"
			_tmp1_ = TRUE;
#line 3265 "number.c"
		} else {
			Number* _tmp5_;
			Number* _tmp6_;
#line 775 "../lib/number.vala"
			_tmp5_ = number_new_integer ((gint64) -1, (gint64) 0);
#line 775 "../lib/number.vala"
			_tmp6_ = _tmp5_;
#line 775 "../lib/number.vala"
			_tmp1_ = number_compare (self, _tmp6_) < 0;
#line 775 "../lib/number.vala"
			_g_object_unref0 (_tmp6_);
#line 3277 "number.c"
		}
#line 775 "../lib/number.vala"
		_tmp0_ = _tmp1_;
#line 3281 "number.c"
	} else {
#line 775 "../lib/number.vala"
		_tmp0_ = FALSE;
#line 3285 "number.c"
	}
#line 775 "../lib/number.vala"
	if (_tmp0_) {
#line 3289 "number.c"
		Number* _tmp7_;
#line 778 "../lib/number.vala"
		number_set_error (_ ("Inverse cosine is undefined for values outside [-1, 1]"));
#line 779 "../lib/number.vala"
		_tmp7_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 779 "../lib/number.vala"
		result = _tmp7_;
#line 779 "../lib/number.vala"
		return result;
#line 3299 "number.c"
	}
#line 782 "../lib/number.vala"
	_tmp8_ = number_new ();
#line 782 "../lib/number.vala"
	z = _tmp8_;
#line 783 "../lib/number.vala"
	_tmp9_ = z;
#line 783 "../lib/number.vala"
	mpc_acos (&_tmp9_->priv->num, &self->priv->num, MPC_RNDNN);
#line 784 "../lib/number.vala"
	_tmp10_ = z;
#line 784 "../lib/number.vala"
	if (!number_is_complex (_tmp10_)) {
#line 3313 "number.c"
		Number* _tmp11_;
		Number* _tmp12_;
#line 785 "../lib/number.vala"
		_tmp11_ = z;
#line 785 "../lib/number.vala"
		_tmp12_ = z;
#line 785 "../lib/number.vala"
		number_mpc_from_radians (&_tmp11_->priv->num, &_tmp12_->priv->num, unit);
#line 3322 "number.c"
	}
#line 786 "../lib/number.vala"
	result = z;
#line 786 "../lib/number.vala"
	return result;
#line 3328 "number.c"
}

Number*
number_atan (Number* self,
             AngleUnit unit)
{
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
	Number* _tmp2_;
	gboolean _tmp3_;
	Number* z = NULL;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* result;
#line 790 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 793 "../lib/number.vala"
	_tmp1_ = number_new_integer ((gint64) 0, (gint64) 1);
#line 793 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 793 "../lib/number.vala"
	_tmp3_ = number_equals (self, _tmp2_);
#line 793 "../lib/number.vala"
	_g_object_unref0 (_tmp2_);
#line 793 "../lib/number.vala"
	if (_tmp3_) {
#line 793 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 3358 "number.c"
	} else {
		Number* _tmp4_;
		Number* _tmp5_;
#line 793 "../lib/number.vala"
		_tmp4_ = number_new_integer ((gint64) 0, (gint64) -1);
#line 793 "../lib/number.vala"
		_tmp5_ = _tmp4_;
#line 793 "../lib/number.vala"
		_tmp0_ = number_equals (self, _tmp5_);
#line 793 "../lib/number.vala"
		_g_object_unref0 (_tmp5_);
#line 3370 "number.c"
	}
#line 793 "../lib/number.vala"
	if (_tmp0_) {
#line 3374 "number.c"
		Number* _tmp6_;
#line 796 "../lib/number.vala"
		number_set_error (_ ("Inverse tangent is undefined for values i and -i"));
#line 797 "../lib/number.vala"
		_tmp6_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 797 "../lib/number.vala"
		result = _tmp6_;
#line 797 "../lib/number.vala"
		return result;
#line 3384 "number.c"
	}
#line 799 "../lib/number.vala"
	_tmp7_ = number_new ();
#line 799 "../lib/number.vala"
	z = _tmp7_;
#line 800 "../lib/number.vala"
	_tmp8_ = z;
#line 800 "../lib/number.vala"
	mpc_atan (&_tmp8_->priv->num, &self->priv->num, MPC_RNDNN);
#line 801 "../lib/number.vala"
	_tmp9_ = z;
#line 801 "../lib/number.vala"
	if (!number_is_complex (_tmp9_)) {
#line 3398 "number.c"
		Number* _tmp10_;
		Number* _tmp11_;
#line 802 "../lib/number.vala"
		_tmp10_ = z;
#line 802 "../lib/number.vala"
		_tmp11_ = z;
#line 802 "../lib/number.vala"
		number_mpc_from_radians (&_tmp10_->priv->num, &_tmp11_->priv->num, unit);
#line 3407 "number.c"
	}
#line 803 "../lib/number.vala"
	result = z;
#line 803 "../lib/number.vala"
	return result;
#line 3413 "number.c"
}

Number*
number_sinh (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 807 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 809 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 809 "../lib/number.vala"
	z = _tmp0_;
#line 810 "../lib/number.vala"
	mpc_sinh (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 811 "../lib/number.vala"
	result = z;
#line 811 "../lib/number.vala"
	return result;
#line 3434 "number.c"
}

Number*
number_cosh (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 815 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 817 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 817 "../lib/number.vala"
	z = _tmp0_;
#line 818 "../lib/number.vala"
	mpc_cosh (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 819 "../lib/number.vala"
	result = z;
#line 819 "../lib/number.vala"
	return result;
#line 3455 "number.c"
}

Number*
number_tanh (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 823 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 825 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 825 "../lib/number.vala"
	z = _tmp0_;
#line 826 "../lib/number.vala"
	mpc_tanh (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 827 "../lib/number.vala"
	result = z;
#line 827 "../lib/number.vala"
	return result;
#line 3476 "number.c"
}

Number*
number_asinh (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 831 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 833 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 833 "../lib/number.vala"
	z = _tmp0_;
#line 834 "../lib/number.vala"
	mpc_asinh (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 835 "../lib/number.vala"
	result = z;
#line 835 "../lib/number.vala"
	return result;
#line 3497 "number.c"
}

Number*
number_acosh (Number* self)
{
	Number* t = NULL;
	Number* _tmp0_;
	gboolean _tmp1_ = FALSE;
	Number* z = NULL;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* result;
#line 839 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 842 "../lib/number.vala"
	_tmp0_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 842 "../lib/number.vala"
	t = _tmp0_;
#line 843 "../lib/number.vala"
	if (!number_is_complex (self)) {
#line 3518 "number.c"
		Number* _tmp2_;
#line 843 "../lib/number.vala"
		_tmp2_ = t;
#line 843 "../lib/number.vala"
		_tmp1_ = number_compare (self, _tmp2_) < 0;
#line 3524 "number.c"
	} else {
#line 843 "../lib/number.vala"
		_tmp1_ = FALSE;
#line 3528 "number.c"
	}
#line 843 "../lib/number.vala"
	if (_tmp1_) {
#line 3532 "number.c"
		Number* _tmp3_;
#line 846 "../lib/number.vala"
		number_set_error (_ ("Inverse hyperbolic cosine is undefined for values less than one"));
#line 847 "../lib/number.vala"
		_tmp3_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 847 "../lib/number.vala"
		result = _tmp3_;
#line 847 "../lib/number.vala"
		_g_object_unref0 (t);
#line 847 "../lib/number.vala"
		return result;
#line 3544 "number.c"
	}
#line 850 "../lib/number.vala"
	_tmp4_ = number_new ();
#line 850 "../lib/number.vala"
	z = _tmp4_;
#line 851 "../lib/number.vala"
	_tmp5_ = z;
#line 851 "../lib/number.vala"
	mpc_acosh (&_tmp5_->priv->num, &self->priv->num, MPC_RNDNN);
#line 852 "../lib/number.vala"
	result = z;
#line 852 "../lib/number.vala"
	_g_object_unref0 (t);
#line 852 "../lib/number.vala"
	return result;
#line 3560 "number.c"
}

Number*
number_atanh (Number* self)
{
	gboolean _tmp0_ = FALSE;
	Number* z = NULL;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* result;
#line 856 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 859 "../lib/number.vala"
	if (!number_is_complex (self)) {
#line 3575 "number.c"
		gboolean _tmp1_ = FALSE;
		Number* _tmp2_;
		Number* _tmp3_;
		gboolean _tmp4_;
#line 859 "../lib/number.vala"
		_tmp2_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 859 "../lib/number.vala"
		_tmp3_ = _tmp2_;
#line 859 "../lib/number.vala"
		_tmp4_ = number_compare (self, _tmp3_) >= 0;
#line 859 "../lib/number.vala"
		_g_object_unref0 (_tmp3_);
#line 859 "../lib/number.vala"
		if (_tmp4_) {
#line 859 "../lib/number.vala"
			_tmp1_ = TRUE;
#line 3592 "number.c"
		} else {
			Number* _tmp5_;
			Number* _tmp6_;
#line 859 "../lib/number.vala"
			_tmp5_ = number_new_integer ((gint64) -1, (gint64) 0);
#line 859 "../lib/number.vala"
			_tmp6_ = _tmp5_;
#line 859 "../lib/number.vala"
			_tmp1_ = number_compare (self, _tmp6_) <= 0;
#line 859 "../lib/number.vala"
			_g_object_unref0 (_tmp6_);
#line 3604 "number.c"
		}
#line 859 "../lib/number.vala"
		_tmp0_ = _tmp1_;
#line 3608 "number.c"
	} else {
#line 859 "../lib/number.vala"
		_tmp0_ = FALSE;
#line 3612 "number.c"
	}
#line 859 "../lib/number.vala"
	if (_tmp0_) {
#line 3616 "number.c"
		Number* _tmp7_;
#line 862 "../lib/number.vala"
		number_set_error (_ ("Inverse hyperbolic tangent is undefined for values outside [-1, 1]"));
#line 863 "../lib/number.vala"
		_tmp7_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 863 "../lib/number.vala"
		result = _tmp7_;
#line 863 "../lib/number.vala"
		return result;
#line 3626 "number.c"
	}
#line 866 "../lib/number.vala"
	_tmp8_ = number_new ();
#line 866 "../lib/number.vala"
	z = _tmp8_;
#line 867 "../lib/number.vala"
	_tmp9_ = z;
#line 867 "../lib/number.vala"
	mpc_atanh (&_tmp9_->priv->num, &self->priv->num, MPC_RNDNN);
#line 868 "../lib/number.vala"
	result = z;
#line 868 "../lib/number.vala"
	return result;
#line 3640 "number.c"
}

static gint
__lambda4_ (Number* self,
            gint v1,
            gint v2)
{
	gint result;
#line 880 "../lib/number.vala"
	result = v1 & v2;
#line 880 "../lib/number.vala"
	return result;
#line 3653 "number.c"
}

static gint
___lambda4__bitwise_func (gint v1,
                          gint v2,
                          gpointer self)
{
	gint result;
	result = __lambda4_ ((Number*) self, v1, v2);
#line 880 "../lib/number.vala"
	return result;
#line 3665 "number.c"
}

Number*
number_and (Number* self,
            Number* y)
{
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
	Number* result;
#line 872 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 872 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 874 "../lib/number.vala"
	if (!number_is_natural (self)) {
#line 874 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 3683 "number.c"
	} else {
#line 874 "../lib/number.vala"
		_tmp0_ = !number_is_natural (y);
#line 3687 "number.c"
	}
#line 874 "../lib/number.vala"
	if (_tmp0_) {
#line 877 "../lib/number.vala"
		number_set_error (_ ("Boolean AND is only defined for non-negative integers"));
#line 3693 "number.c"
	}
#line 880 "../lib/number.vala"
	_tmp1_ = number_bitwise (self, y, ___lambda4__bitwise_func, self, 0);
#line 880 "../lib/number.vala"
	result = _tmp1_;
#line 880 "../lib/number.vala"
	return result;
#line 3701 "number.c"
}

static gint
__lambda5_ (Number* self,
            gint v1,
            gint v2)
{
	gint result;
#line 892 "../lib/number.vala"
	result = v1 & v2;
#line 892 "../lib/number.vala"
	return result;
#line 3714 "number.c"
}

static gint
___lambda5__bitwise_func (gint v1,
                          gint v2,
                          gpointer self)
{
	gint result;
	result = __lambda5_ ((Number*) self, v1, v2);
#line 892 "../lib/number.vala"
	return result;
#line 3726 "number.c"
}

Number*
number_nand (Number* self,
             Number* y,
             gint wordlen)
{
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* result;
#line 884 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 884 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 886 "../lib/number.vala"
	if (!number_is_natural (self)) {
#line 886 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 3748 "number.c"
	} else {
#line 886 "../lib/number.vala"
		_tmp0_ = !number_is_natural (y);
#line 3752 "number.c"
	}
#line 886 "../lib/number.vala"
	if (_tmp0_) {
#line 889 "../lib/number.vala"
		number_set_error (_ ("Boolean NAND is only defined for non-negative integers"));
#line 3758 "number.c"
	}
#line 892 "../lib/number.vala"
	_tmp1_ = number_bitwise (self, y, ___lambda5__bitwise_func, self, wordlen);
#line 892 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 892 "../lib/number.vala"
	_tmp3_ = number_not (_tmp2_, wordlen);
#line 892 "../lib/number.vala"
	_tmp4_ = _tmp3_;
#line 892 "../lib/number.vala"
	_g_object_unref0 (_tmp2_);
#line 892 "../lib/number.vala"
	result = _tmp4_;
#line 892 "../lib/number.vala"
	return result;
#line 3774 "number.c"
}

static gint
__lambda7_ (Number* self,
            gint v1,
            gint v2)
{
	gint result;
#line 904 "../lib/number.vala"
	result = v1 | v2;
#line 904 "../lib/number.vala"
	return result;
#line 3787 "number.c"
}

static gint
___lambda7__bitwise_func (gint v1,
                          gint v2,
                          gpointer self)
{
	gint result;
	result = __lambda7_ ((Number*) self, v1, v2);
#line 904 "../lib/number.vala"
	return result;
#line 3799 "number.c"
}

Number*
number_or (Number* self,
           Number* y)
{
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
	Number* result;
#line 896 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 896 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 898 "../lib/number.vala"
	if (!number_is_natural (self)) {
#line 898 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 3817 "number.c"
	} else {
#line 898 "../lib/number.vala"
		_tmp0_ = !number_is_natural (y);
#line 3821 "number.c"
	}
#line 898 "../lib/number.vala"
	if (_tmp0_) {
#line 901 "../lib/number.vala"
		number_set_error (_ ("Boolean OR is only defined for non-negative integers"));
#line 3827 "number.c"
	}
#line 904 "../lib/number.vala"
	_tmp1_ = number_bitwise (self, y, ___lambda7__bitwise_func, self, 0);
#line 904 "../lib/number.vala"
	result = _tmp1_;
#line 904 "../lib/number.vala"
	return result;
#line 3835 "number.c"
}

static gint
__lambda8_ (Number* self,
            gint v1,
            gint v2)
{
	gint result;
#line 916 "../lib/number.vala"
	result = v1 | v2;
#line 916 "../lib/number.vala"
	return result;
#line 3848 "number.c"
}

static gint
___lambda8__bitwise_func (gint v1,
                          gint v2,
                          gpointer self)
{
	gint result;
	result = __lambda8_ ((Number*) self, v1, v2);
#line 916 "../lib/number.vala"
	return result;
#line 3860 "number.c"
}

Number*
number_nor (Number* self,
            Number* y,
            gint wordlen)
{
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* result;
#line 908 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 908 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 910 "../lib/number.vala"
	if (!number_is_natural (self)) {
#line 910 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 3882 "number.c"
	} else {
#line 910 "../lib/number.vala"
		_tmp0_ = !number_is_natural (y);
#line 3886 "number.c"
	}
#line 910 "../lib/number.vala"
	if (_tmp0_) {
#line 913 "../lib/number.vala"
		number_set_error (_ ("Boolean NOR is only defined for non-negative integers"));
#line 3892 "number.c"
	}
#line 916 "../lib/number.vala"
	_tmp1_ = number_bitwise (self, y, ___lambda8__bitwise_func, self, wordlen);
#line 916 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 916 "../lib/number.vala"
	_tmp3_ = number_not (_tmp2_, wordlen);
#line 916 "../lib/number.vala"
	_tmp4_ = _tmp3_;
#line 916 "../lib/number.vala"
	_g_object_unref0 (_tmp2_);
#line 916 "../lib/number.vala"
	result = _tmp4_;
#line 916 "../lib/number.vala"
	return result;
#line 3908 "number.c"
}

static gint
__lambda9_ (Number* self,
            gint v1,
            gint v2)
{
	gint result;
#line 928 "../lib/number.vala"
	result = v1 ^ v2;
#line 928 "../lib/number.vala"
	return result;
#line 3921 "number.c"
}

static gint
___lambda9__bitwise_func (gint v1,
                          gint v2,
                          gpointer self)
{
	gint result;
	result = __lambda9_ ((Number*) self, v1, v2);
#line 928 "../lib/number.vala"
	return result;
#line 3933 "number.c"
}

Number*
number_xor (Number* self,
            Number* y)
{
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
	Number* result;
#line 920 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 920 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 922 "../lib/number.vala"
	if (!number_is_natural (self)) {
#line 922 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 3951 "number.c"
	} else {
#line 922 "../lib/number.vala"
		_tmp0_ = !number_is_natural (y);
#line 3955 "number.c"
	}
#line 922 "../lib/number.vala"
	if (_tmp0_) {
#line 925 "../lib/number.vala"
		number_set_error (_ ("Boolean XOR is only defined for non-negative integers"));
#line 3961 "number.c"
	}
#line 928 "../lib/number.vala"
	_tmp1_ = number_bitwise (self, y, ___lambda9__bitwise_func, self, 0);
#line 928 "../lib/number.vala"
	result = _tmp1_;
#line 928 "../lib/number.vala"
	return result;
#line 3969 "number.c"
}

static gint
__lambda10_ (Number* self,
             gint v1,
             gint v2)
{
	gint result;
#line 940 "../lib/number.vala"
	result = v1 ^ v2;
#line 940 "../lib/number.vala"
	return result;
#line 3982 "number.c"
}

static gint
___lambda10__bitwise_func (gint v1,
                           gint v2,
                           gpointer self)
{
	gint result;
	result = __lambda10_ ((Number*) self, v1, v2);
#line 940 "../lib/number.vala"
	return result;
#line 3994 "number.c"
}

Number*
number_xnor (Number* self,
             Number* y,
             gint wordlen)
{
	gboolean _tmp0_ = FALSE;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* result;
#line 932 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 932 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 934 "../lib/number.vala"
	if (!number_is_natural (self)) {
#line 934 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 4016 "number.c"
	} else {
#line 934 "../lib/number.vala"
		_tmp0_ = !number_is_natural (y);
#line 4020 "number.c"
	}
#line 934 "../lib/number.vala"
	if (_tmp0_) {
#line 937 "../lib/number.vala"
		number_set_error (_ ("Boolean XNOR is only defined for non-negative integers"));
#line 4026 "number.c"
	}
#line 940 "../lib/number.vala"
	_tmp1_ = number_bitwise (self, y, ___lambda10__bitwise_func, self, wordlen);
#line 940 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 940 "../lib/number.vala"
	_tmp3_ = number_not (_tmp2_, wordlen);
#line 940 "../lib/number.vala"
	_tmp4_ = _tmp3_;
#line 940 "../lib/number.vala"
	_g_object_unref0 (_tmp2_);
#line 940 "../lib/number.vala"
	result = _tmp4_;
#line 940 "../lib/number.vala"
	return result;
#line 4042 "number.c"
}

static gint
__lambda6_ (Number* self,
            gint v1,
            gint v2)
{
	gint result;
#line 952 "../lib/number.vala"
	result = v1 ^ 0xF;
#line 952 "../lib/number.vala"
	return result;
#line 4055 "number.c"
}

static gint
___lambda6__bitwise_func (gint v1,
                          gint v2,
                          gpointer self)
{
	gint result;
	result = __lambda6_ ((Number*) self, v1, v2);
#line 952 "../lib/number.vala"
	return result;
#line 4067 "number.c"
}

Number*
number_not (Number* self,
            gint wordlen)
{
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* result;
#line 944 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 946 "../lib/number.vala"
	if (!number_is_natural (self)) {
#line 949 "../lib/number.vala"
		number_set_error (_ ("Boolean NOT is only defined for non-negative integers"));
#line 4085 "number.c"
	}
#line 952 "../lib/number.vala"
	_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 952 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 952 "../lib/number.vala"
	_tmp2_ = number_bitwise (self, _tmp1_, ___lambda6__bitwise_func, self, wordlen);
#line 952 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 952 "../lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 952 "../lib/number.vala"
	result = _tmp3_;
#line 952 "../lib/number.vala"
	return result;
#line 4101 "number.c"
}

Number*
number_left_shift (Number* self,
                   Number* count,
                   gint wordlen)
{
	guint64 mask = 0ULL;
	guint64 _tmp1_ = 0ULL;
	guint64 bits = 0ULL;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* _tmp8_;
	Number* result;
#line 956 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 956 "../lib/number.vala"
	g_return_val_if_fail (count != NULL, NULL);
#line 958 "../lib/number.vala"
	mask = number_check_shift (self, count, wordlen);
#line 959 "../lib/number.vala"
	if (mask == ((guint64) 0)) {
#line 4126 "number.c"
		Number* _tmp0_;
#line 960 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 960 "../lib/number.vala"
		result = _tmp0_;
#line 960 "../lib/number.vala"
		return result;
#line 4134 "number.c"
	}
#line 962 "../lib/number.vala"
	if (number_is_negative (self)) {
#line 962 "../lib/number.vala"
		_tmp1_ = (guint64) number_to_integer (self);
#line 4140 "number.c"
	} else {
#line 962 "../lib/number.vala"
		_tmp1_ = number_to_unsigned_integer (self);
#line 4144 "number.c"
	}
#line 962 "../lib/number.vala"
	bits = _tmp1_;
#line 963 "../lib/number.vala"
	_tmp2_ = number_new_integer ((gint64) wordlen, (gint64) 0);
#line 963 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 963 "../lib/number.vala"
	_tmp4_ = number_modulus_divide (count, _tmp3_);
#line 963 "../lib/number.vala"
	_tmp5_ = _tmp4_;
#line 963 "../lib/number.vala"
	bits <<= (guint64) number_to_integer (_tmp5_);
#line 963 "../lib/number.vala"
	_g_object_unref0 (_tmp5_);
#line 963 "../lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 964 "../lib/number.vala"
	if (wordlen != 64) {
#line 4164 "number.c"
		gboolean _tmp6_ = FALSE;
#line 966 "../lib/number.vala"
		if (number_is_negative (self)) {
#line 966 "../lib/number.vala"
			_tmp6_ = (bits & (1ULL << (wordlen - 1))) != ((guint64) 0);
#line 4170 "number.c"
		} else {
#line 966 "../lib/number.vala"
			_tmp6_ = FALSE;
#line 4174 "number.c"
		}
#line 966 "../lib/number.vala"
		if (_tmp6_) {
#line 967 "../lib/number.vala"
			bits |= ~mask;
#line 4180 "number.c"
		} else {
#line 969 "../lib/number.vala"
			bits &= mask;
#line 4184 "number.c"
		}
	}
#line 971 "../lib/number.vala"
	if (number_is_negative (self)) {
#line 4189 "number.c"
		Number* _tmp7_;
#line 972 "../lib/number.vala"
		_tmp7_ = number_new_integer ((gint64) bits, (gint64) 0);
#line 972 "../lib/number.vala"
		result = _tmp7_;
#line 972 "../lib/number.vala"
		return result;
#line 4197 "number.c"
	}
#line 973 "../lib/number.vala"
	_tmp8_ = number_new_unsigned_integer (bits, (guint64) 0);
#line 973 "../lib/number.vala"
	result = _tmp8_;
#line 973 "../lib/number.vala"
	return result;
#line 4205 "number.c"
}

Number*
number_right_shift (Number* self,
                    Number* count,
                    gint wordlen)
{
	guint64 bits = 0ULL;
	Number* _tmp6_;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* _tmp9_;
	Number* _tmp10_;
	Number* result;
#line 977 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 977 "../lib/number.vala"
	g_return_val_if_fail (count != NULL, NULL);
#line 979 "../lib/number.vala"
	if (number_check_shift (self, count, wordlen) == ((guint64) 0)) {
#line 4226 "number.c"
		Number* _tmp0_;
#line 980 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 980 "../lib/number.vala"
		result = _tmp0_;
#line 980 "../lib/number.vala"
		return result;
#line 4234 "number.c"
	}
#line 982 "../lib/number.vala"
	if (number_is_negative (self)) {
#line 4238 "number.c"
		gint64 bits = 0LL;
		Number* _tmp1_;
		Number* _tmp2_;
		Number* _tmp3_;
		Number* _tmp4_;
		Number* _tmp5_;
#line 984 "../lib/number.vala"
		bits = number_to_integer (self);
#line 985 "../lib/number.vala"
		_tmp1_ = number_new_integer ((gint64) wordlen, (gint64) 0);
#line 985 "../lib/number.vala"
		_tmp2_ = _tmp1_;
#line 985 "../lib/number.vala"
		_tmp3_ = number_modulus_divide (count, _tmp2_);
#line 985 "../lib/number.vala"
		_tmp4_ = _tmp3_;
#line 985 "../lib/number.vala"
		bits >>= number_to_integer (_tmp4_);
#line 985 "../lib/number.vala"
		_g_object_unref0 (_tmp4_);
#line 985 "../lib/number.vala"
		_g_object_unref0 (_tmp2_);
#line 986 "../lib/number.vala"
		_tmp5_ = number_new_integer (bits, (gint64) 0);
#line 986 "../lib/number.vala"
		result = _tmp5_;
#line 986 "../lib/number.vala"
		return result;
#line 4267 "number.c"
	}
#line 988 "../lib/number.vala"
	bits = number_to_unsigned_integer (self);
#line 989 "../lib/number.vala"
	_tmp6_ = number_new_integer ((gint64) wordlen, (gint64) 0);
#line 989 "../lib/number.vala"
	_tmp7_ = _tmp6_;
#line 989 "../lib/number.vala"
	_tmp8_ = number_modulus_divide (count, _tmp7_);
#line 989 "../lib/number.vala"
	_tmp9_ = _tmp8_;
#line 989 "../lib/number.vala"
	bits >>= (guint64) number_to_integer (_tmp9_);
#line 989 "../lib/number.vala"
	_g_object_unref0 (_tmp9_);
#line 989 "../lib/number.vala"
	_g_object_unref0 (_tmp7_);
#line 990 "../lib/number.vala"
	_tmp10_ = number_new_unsigned_integer (bits, (guint64) 0);
#line 990 "../lib/number.vala"
	result = _tmp10_;
#line 990 "../lib/number.vala"
	return result;
#line 4291 "number.c"
}

Number*
number_unsigned_right_shift (Number* self,
                             Number* count,
                             gint wordlen)
{
	guint64 mask = 0ULL;
	guint64 _tmp1_ = 0ULL;
	guint64 bits = 0ULL;
	gboolean _tmp2_ = FALSE;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* _tmp6_;
	Number* _tmp7_;
	Number* result;
#line 994 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 994 "../lib/number.vala"
	g_return_val_if_fail (count != NULL, NULL);
#line 996 "../lib/number.vala"
	mask = number_check_shift (self, count, wordlen);
#line 997 "../lib/number.vala"
	if (mask == ((guint64) 0)) {
#line 4317 "number.c"
		Number* _tmp0_;
#line 998 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 998 "../lib/number.vala"
		result = _tmp0_;
#line 998 "../lib/number.vala"
		return result;
#line 4325 "number.c"
	}
#line 1000 "../lib/number.vala"
	if (number_is_negative (self)) {
#line 1000 "../lib/number.vala"
		_tmp1_ = (guint64) number_to_integer (self);
#line 4331 "number.c"
	} else {
#line 1000 "../lib/number.vala"
		_tmp1_ = number_to_unsigned_integer (self);
#line 4335 "number.c"
	}
#line 1000 "../lib/number.vala"
	bits = _tmp1_;
#line 1001 "../lib/number.vala"
	if (wordlen != 64) {
#line 1001 "../lib/number.vala"
		_tmp2_ = number_is_negative (self);
#line 4343 "number.c"
	} else {
#line 1001 "../lib/number.vala"
		_tmp2_ = FALSE;
#line 4347 "number.c"
	}
#line 1001 "../lib/number.vala"
	if (_tmp2_) {
#line 1002 "../lib/number.vala"
		bits &= mask;
#line 4353 "number.c"
	}
#line 1003 "../lib/number.vala"
	_tmp3_ = number_new_integer ((gint64) wordlen, (gint64) 0);
#line 1003 "../lib/number.vala"
	_tmp4_ = _tmp3_;
#line 1003 "../lib/number.vala"
	_tmp5_ = number_modulus_divide (count, _tmp4_);
#line 1003 "../lib/number.vala"
	_tmp6_ = _tmp5_;
#line 1003 "../lib/number.vala"
	bits >>= (guint64) number_to_integer (_tmp6_);
#line 1003 "../lib/number.vala"
	_g_object_unref0 (_tmp6_);
#line 1003 "../lib/number.vala"
	_g_object_unref0 (_tmp4_);
#line 1004 "../lib/number.vala"
	_tmp7_ = number_new_unsigned_integer (bits, (guint64) 0);
#line 1004 "../lib/number.vala"
	result = _tmp7_;
#line 1004 "../lib/number.vala"
	return result;
#line 4375 "number.c"
}

static guint64
number_check_shift (Number* self,
                    Number* count,
                    gint wordlen)
{
	gboolean _tmp0_ = FALSE;
	gint64 min = 0LL;
	guint64 max = 0ULL;
	gboolean _tmp1_ = FALSE;
	Number* _tmp2_;
	Number* _tmp3_;
	gboolean _tmp4_;
	guint64 result;
#line 1007 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, 0ULL);
#line 1007 "../lib/number.vala"
	g_return_val_if_fail (count != NULL, 0ULL);
#line 1009 "../lib/number.vala"
	if (!number_is_integer (self)) {
#line 1009 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 4399 "number.c"
	} else {
#line 1009 "../lib/number.vala"
		_tmp0_ = !number_is_integer (count);
#line 4403 "number.c"
	}
#line 1009 "../lib/number.vala"
	if (_tmp0_) {
#line 1012 "../lib/number.vala"
		number_set_error (_ ("Shift is only possible on integer values"));
#line 1013 "../lib/number.vala"
		result = (guint64) 0;
#line 1013 "../lib/number.vala"
		return result;
#line 4413 "number.c"
	}
#line 1016 "../lib/number.vala"
	min = G_MININT64;
#line 1017 "../lib/number.vala"
	max = G_MAXUINT64;
#line 1018 "../lib/number.vala"
	switch (wordlen) {
#line 1018 "../lib/number.vala"
		case 8:
#line 4423 "number.c"
		{
#line 1021 "../lib/number.vala"
			min = (gint64) G_MININT8;
#line 1022 "../lib/number.vala"
			max = (guint64) G_MAXUINT8;
#line 1023 "../lib/number.vala"
			break;
#line 4431 "number.c"
		}
#line 1018 "../lib/number.vala"
		case 16:
#line 4435 "number.c"
		{
#line 1025 "../lib/number.vala"
			min = (gint64) G_MININT16;
#line 1026 "../lib/number.vala"
			max = (guint64) G_MAXUINT16;
#line 1027 "../lib/number.vala"
			break;
#line 4443 "number.c"
		}
#line 1018 "../lib/number.vala"
		case 32:
#line 4447 "number.c"
		{
#line 1029 "../lib/number.vala"
			min = (gint64) G_MININT32;
#line 1030 "../lib/number.vala"
			max = (guint64) G_MAXUINT32;
#line 1031 "../lib/number.vala"
			break;
#line 4455 "number.c"
		}
		default:
#line 1018 "../lib/number.vala"
		break;
#line 4460 "number.c"
	}
#line 1033 "../lib/number.vala"
	_tmp2_ = number_new_unsigned_integer (max, (guint64) 0);
#line 1033 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 1033 "../lib/number.vala"
	_tmp4_ = number_compare (self, _tmp3_) > 0;
#line 1033 "../lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 1033 "../lib/number.vala"
	if (_tmp4_) {
#line 1033 "../lib/number.vala"
		_tmp1_ = TRUE;
#line 4474 "number.c"
	} else {
		Number* _tmp5_;
		Number* _tmp6_;
#line 1033 "../lib/number.vala"
		_tmp5_ = number_new_integer (min, (gint64) 0);
#line 1033 "../lib/number.vala"
		_tmp6_ = _tmp5_;
#line 1033 "../lib/number.vala"
		_tmp1_ = number_compare (self, _tmp6_) < 0;
#line 1033 "../lib/number.vala"
		_g_object_unref0 (_tmp6_);
#line 4486 "number.c"
	}
#line 1033 "../lib/number.vala"
	if (_tmp1_) {
#line 1035 "../lib/number.vala"
		number_set_error ("Overflow. Try a bigger word size");
#line 1036 "../lib/number.vala"
		result = (guint64) 0;
#line 1036 "../lib/number.vala"
		return result;
#line 4496 "number.c"
	}
#line 1038 "../lib/number.vala"
	result = max;
#line 1038 "../lib/number.vala"
	return result;
#line 4502 "number.c"
}

static gint
__lambda11_ (Number* self,
             gint v1,
             gint v2)
{
	gint result;
#line 1050 "../lib/number.vala"
	result = v1 ^ v2;
#line 1050 "../lib/number.vala"
	return result;
#line 4515 "number.c"
}

static gint
___lambda11__bitwise_func (gint v1,
                           gint v2,
                           gpointer self)
{
	gint result;
	result = __lambda11_ ((Number*) self, v1, v2);
#line 1050 "../lib/number.vala"
	return result;
#line 4527 "number.c"
}

Number*
number_ones_complement (Number* self,
                        gint wordlen)
{
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* _tmp6_;
	Number* result;
#line 1042 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1044 "../lib/number.vala"
	if (!number_is_natural (self)) {
#line 4545 "number.c"
		Number* _tmp0_;
#line 1046 "../lib/number.vala"
		number_set_error (_ ("One’s complement is only defined for non-negative integers"));
#line 1047 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1047 "../lib/number.vala"
		result = _tmp0_;
#line 1047 "../lib/number.vala"
		return result;
#line 4555 "number.c"
	}
#line 1050 "../lib/number.vala"
	_tmp1_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1050 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 1050 "../lib/number.vala"
	_tmp3_ = number_bitwise (self, _tmp2_, ___lambda11__bitwise_func, self, wordlen);
#line 1050 "../lib/number.vala"
	_tmp4_ = _tmp3_;
#line 1050 "../lib/number.vala"
	_tmp5_ = number_not (_tmp4_, wordlen);
#line 1050 "../lib/number.vala"
	_tmp6_ = _tmp5_;
#line 1050 "../lib/number.vala"
	_g_object_unref0 (_tmp4_);
#line 1050 "../lib/number.vala"
	_g_object_unref0 (_tmp2_);
#line 1050 "../lib/number.vala"
	result = _tmp6_;
#line 1050 "../lib/number.vala"
	return result;
#line 4577 "number.c"
}

Number*
number_twos_complement (Number* self,
                        gint wordlen)
{
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* _tmp6_;
	Number* result;
#line 1054 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1056 "../lib/number.vala"
	if (!number_is_natural (self)) {
#line 4595 "number.c"
		Number* _tmp0_;
#line 1058 "../lib/number.vala"
		number_set_error (_ ("Two’s complement is only defined for non-negative integers"));
#line 1059 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1059 "../lib/number.vala"
		result = _tmp0_;
#line 1059 "../lib/number.vala"
		return result;
#line 4605 "number.c"
	}
#line 1062 "../lib/number.vala"
	_tmp1_ = number_ones_complement (self, wordlen);
#line 1062 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 1062 "../lib/number.vala"
	_tmp3_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 1062 "../lib/number.vala"
	_tmp4_ = _tmp3_;
#line 1062 "../lib/number.vala"
	_tmp5_ = number_add (_tmp2_, _tmp4_);
#line 1062 "../lib/number.vala"
	_tmp6_ = _tmp5_;
#line 1062 "../lib/number.vala"
	_g_object_unref0 (_tmp4_);
#line 1062 "../lib/number.vala"
	_g_object_unref0 (_tmp2_);
#line 1062 "../lib/number.vala"
	result = _tmp6_;
#line 1062 "../lib/number.vala"
	return result;
#line 4627 "number.c"
}

Number*
number_combination (Number* self,
                    Number* r)
{
	gboolean _tmp0_ = FALSE;
	Number* _tmp3_ = NULL;
	Number* _tmp4_;
	Number* _tmp5_;
	gboolean _tmp6_;
	Number* r1 = NULL;
	Number* _tmp9_;
	Number* _tmp10_;
	Number* _tmp11_;
	Number* _tmp12_;
	Number* _tmp13_;
	Number* _tmp14_;
	Number* _tmp15_;
	Number* _tmp16_;
	Number* _tmp17_;
	Number* result;
#line 1066 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1066 "../lib/number.vala"
	g_return_val_if_fail (r != NULL, NULL);
#line 1068 "../lib/number.vala"
	if (!number_is_natural (self)) {
#line 1068 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 4658 "number.c"
	} else {
#line 1068 "../lib/number.vala"
		_tmp0_ = !number_is_natural (r);
#line 4662 "number.c"
	}
#line 1068 "../lib/number.vala"
	if (_tmp0_) {
#line 4666 "number.c"
		Number* _tmp1_;
#line 1070 "../lib/number.vala"
		number_set_error (_ ("Combination is only defined for non-negative integers"));
#line 1071 "../lib/number.vala"
		_tmp1_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1071 "../lib/number.vala"
		result = _tmp1_;
#line 1071 "../lib/number.vala"
		return result;
#line 4676 "number.c"
	}
#line 1073 "../lib/number.vala"
	if (number_compare (self, r) < 0) {
#line 4680 "number.c"
		Number* _tmp2_;
#line 1075 "../lib/number.vala"
		number_set_error (_ ("Combination is undefined if n is less than r"));
#line 1076 "../lib/number.vala"
		_tmp2_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1076 "../lib/number.vala"
		result = _tmp2_;
#line 1076 "../lib/number.vala"
		return result;
#line 4690 "number.c"
	}
#line 1079 "../lib/number.vala"
	_tmp4_ = number_divide_integer (self, (gint64) 2);
#line 1079 "../lib/number.vala"
	_tmp5_ = _tmp4_;
#line 1079 "../lib/number.vala"
	_tmp6_ = number_compare (r, _tmp5_) <= 0;
#line 1079 "../lib/number.vala"
	_g_object_unref0 (_tmp5_);
#line 1079 "../lib/number.vala"
	if (_tmp6_) {
#line 4702 "number.c"
		Number* _tmp7_;
#line 1079 "../lib/number.vala"
		_tmp7_ = _g_object_ref0 (r);
#line 1079 "../lib/number.vala"
		_g_object_unref0 (_tmp3_);
#line 1079 "../lib/number.vala"
		_tmp3_ = _tmp7_;
#line 4710 "number.c"
	} else {
		Number* _tmp8_;
#line 1079 "../lib/number.vala"
		_tmp8_ = number_subtract (self, r);
#line 1079 "../lib/number.vala"
		_g_object_unref0 (_tmp3_);
#line 1079 "../lib/number.vala"
		_tmp3_ = _tmp8_;
#line 4719 "number.c"
	}
#line 1079 "../lib/number.vala"
	_tmp9_ = _g_object_ref0 (_tmp3_);
#line 1079 "../lib/number.vala"
	r1 = _tmp9_;
#line 1080 "../lib/number.vala"
	_tmp10_ = r1;
#line 1080 "../lib/number.vala"
	_tmp11_ = number_permutation (self, _tmp10_);
#line 1080 "../lib/number.vala"
	_tmp12_ = _tmp11_;
#line 1080 "../lib/number.vala"
	_tmp13_ = r1;
#line 1080 "../lib/number.vala"
	_tmp14_ = number_factorial (_tmp13_);
#line 1080 "../lib/number.vala"
	_tmp15_ = _tmp14_;
#line 1080 "../lib/number.vala"
	_tmp16_ = number_divide (_tmp12_, _tmp15_);
#line 1080 "../lib/number.vala"
	_tmp17_ = _tmp16_;
#line 1080 "../lib/number.vala"
	_g_object_unref0 (_tmp15_);
#line 1080 "../lib/number.vala"
	_g_object_unref0 (_tmp12_);
#line 1080 "../lib/number.vala"
	result = _tmp17_;
#line 1080 "../lib/number.vala"
	_g_object_unref0 (r1);
#line 1080 "../lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 1080 "../lib/number.vala"
	return result;
#line 4753 "number.c"
}

Number*
number_permutation (Number* self,
                    Number* r)
{
	gboolean _tmp0_ = FALSE;
	gint64 value = 0LL;
	Number* z = NULL;
	Number* _tmp4_;
	Number* result;
#line 1084 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1084 "../lib/number.vala"
	g_return_val_if_fail (r != NULL, NULL);
#line 1086 "../lib/number.vala"
	if (!number_is_natural (self)) {
#line 1086 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 4773 "number.c"
	} else {
#line 1086 "../lib/number.vala"
		_tmp0_ = !number_is_natural (r);
#line 4777 "number.c"
	}
#line 1086 "../lib/number.vala"
	if (_tmp0_) {
#line 4781 "number.c"
		Number* _tmp1_;
#line 1088 "../lib/number.vala"
		number_set_error (_ ("Permutation is only defined for non-negative integers"));
#line 1089 "../lib/number.vala"
		_tmp1_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1089 "../lib/number.vala"
		result = _tmp1_;
#line 1089 "../lib/number.vala"
		return result;
#line 4791 "number.c"
	}
#line 1091 "../lib/number.vala"
	if (number_compare (self, r) < 0) {
#line 4795 "number.c"
		Number* _tmp2_;
#line 1093 "../lib/number.vala"
		number_set_error (_ ("Permutation is undefined if n is less than r"));
#line 1094 "../lib/number.vala"
		_tmp2_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1094 "../lib/number.vala"
		result = _tmp2_;
#line 1094 "../lib/number.vala"
		return result;
#line 4805 "number.c"
	}
#line 1097 "../lib/number.vala"
	if (number_is_zero (r)) {
#line 4809 "number.c"
		Number* _tmp3_;
#line 1098 "../lib/number.vala"
		_tmp3_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 1098 "../lib/number.vala"
		result = _tmp3_;
#line 1098 "../lib/number.vala"
		return result;
#line 4817 "number.c"
	}
#line 1100 "../lib/number.vala"
	value = number_to_integer (self);
#line 1101 "../lib/number.vala"
	_tmp4_ = _g_object_ref0 (self);
#line 1101 "../lib/number.vala"
	z = _tmp4_;
#line 4825 "number.c"
	{
		gint64 i = 0LL;
#line 1102 "../lib/number.vala"
		i = (value - number_to_integer (r)) + 1;
#line 4830 "number.c"
		{
			gboolean _tmp5_ = FALSE;
#line 1102 "../lib/number.vala"
			_tmp5_ = TRUE;
#line 1102 "../lib/number.vala"
			while (TRUE) {
#line 4837 "number.c"
				Number* _tmp7_;
				Number* _tmp8_;
#line 1102 "../lib/number.vala"
				if (!_tmp5_) {
#line 4842 "number.c"
					gint64 _tmp6_;
#line 1102 "../lib/number.vala"
					_tmp6_ = i;
#line 1102 "../lib/number.vala"
					i = _tmp6_ + 1;
#line 4848 "number.c"
				}
#line 1102 "../lib/number.vala"
				_tmp5_ = FALSE;
#line 1102 "../lib/number.vala"
				if (!(i < value)) {
#line 1102 "../lib/number.vala"
					break;
#line 4856 "number.c"
				}
#line 1103 "../lib/number.vala"
				_tmp7_ = z;
#line 1103 "../lib/number.vala"
				_tmp8_ = number_multiply_integer (_tmp7_, i);
#line 1103 "../lib/number.vala"
				_g_object_unref0 (z);
#line 1103 "../lib/number.vala"
				z = _tmp8_;
#line 4866 "number.c"
			}
		}
	}
#line 1105 "../lib/number.vala"
	result = z;
#line 1105 "../lib/number.vala"
	return result;
#line 4874 "number.c"
}

Number*
number_gcd (Number** args,
            gint args_length1)
{
	Number* z = NULL;
	Number* _tmp6_;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* _tmp14_;
	Number* _tmp15_;
	Number* result;
	{
		gint i = 0;
#line 1111 "../lib/number.vala"
		i = 0;
#line 4892 "number.c"
		{
			gboolean _tmp0_ = FALSE;
#line 1111 "../lib/number.vala"
			_tmp0_ = TRUE;
#line 1111 "../lib/number.vala"
			while (TRUE) {
#line 4899 "number.c"
				Number* _tmp2_;
#line 1111 "../lib/number.vala"
				if (!_tmp0_) {
#line 4903 "number.c"
					gint _tmp1_;
#line 1111 "../lib/number.vala"
					_tmp1_ = i;
#line 1111 "../lib/number.vala"
					i = _tmp1_ + 1;
#line 4909 "number.c"
				}
#line 1111 "../lib/number.vala"
				_tmp0_ = FALSE;
#line 1111 "../lib/number.vala"
				if (!(i < args_length1)) {
#line 1111 "../lib/number.vala"
					break;
#line 4917 "number.c"
				}
#line 1112 "../lib/number.vala"
				_tmp2_ = args[i];
#line 1112 "../lib/number.vala"
				if (!number_is_integer (_tmp2_)) {
#line 4923 "number.c"
					Number* _tmp3_;
#line 1114 "../lib/number.vala"
					number_set_error (_ ("Greatest common divisor is only defined for integers"));
#line 1115 "../lib/number.vala"
					_tmp3_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1115 "../lib/number.vala"
					result = _tmp3_;
#line 1115 "../lib/number.vala"
					return result;
#line 4933 "number.c"
				}
			}
		}
	}
#line 1118 "../lib/number.vala"
	if (args_length1 == 1) {
#line 4940 "number.c"
		Number* _tmp4_;
		Number* _tmp5_;
#line 1119 "../lib/number.vala"
		_tmp4_ = args[0];
#line 1119 "../lib/number.vala"
		_tmp5_ = number_abs (_tmp4_);
#line 1119 "../lib/number.vala"
		result = _tmp5_;
#line 1119 "../lib/number.vala"
		return result;
#line 4951 "number.c"
	}
#line 1121 "../lib/number.vala"
	_tmp6_ = args[0];
#line 1121 "../lib/number.vala"
	_tmp7_ = args[1];
#line 1121 "../lib/number.vala"
	_tmp8_ = number_gcd_x_y (_tmp6_, _tmp7_);
#line 1121 "../lib/number.vala"
	z = _tmp8_;
#line 4961 "number.c"
	{
		gint i = 0;
#line 1122 "../lib/number.vala"
		i = 2;
#line 4966 "number.c"
		{
			gboolean _tmp9_ = FALSE;
#line 1122 "../lib/number.vala"
			_tmp9_ = TRUE;
#line 1122 "../lib/number.vala"
			while (TRUE) {
#line 4973 "number.c"
				Number* _tmp11_;
				Number* _tmp12_;
				Number* _tmp13_;
#line 1122 "../lib/number.vala"
				if (!_tmp9_) {
#line 4979 "number.c"
					gint _tmp10_;
#line 1122 "../lib/number.vala"
					_tmp10_ = i;
#line 1122 "../lib/number.vala"
					i = _tmp10_ + 1;
#line 4985 "number.c"
				}
#line 1122 "../lib/number.vala"
				_tmp9_ = FALSE;
#line 1122 "../lib/number.vala"
				if (!(i < args_length1)) {
#line 1122 "../lib/number.vala"
					break;
#line 4993 "number.c"
				}
#line 1123 "../lib/number.vala"
				_tmp11_ = z;
#line 1123 "../lib/number.vala"
				_tmp12_ = args[i];
#line 1123 "../lib/number.vala"
				_tmp13_ = number_gcd_x_y (_tmp11_, _tmp12_);
#line 1123 "../lib/number.vala"
				_g_object_unref0 (z);
#line 1123 "../lib/number.vala"
				z = _tmp13_;
#line 5005 "number.c"
			}
		}
	}
#line 1125 "../lib/number.vala"
	_tmp14_ = z;
#line 1125 "../lib/number.vala"
	_tmp15_ = number_abs (_tmp14_);
#line 1125 "../lib/number.vala"
	result = _tmp15_;
#line 1125 "../lib/number.vala"
	_g_object_unref0 (z);
#line 1125 "../lib/number.vala"
	return result;
#line 5019 "number.c"
}

Number*
number_lcm (Number** args,
            gint args_length1)
{
	Number* z = NULL;
	Number* _tmp6_;
	Number* _tmp7_;
	Number* _tmp8_;
	Number* _tmp14_;
	Number* _tmp15_;
	Number* result;
	{
		gint i = 0;
#line 1131 "../lib/number.vala"
		i = 0;
#line 5037 "number.c"
		{
			gboolean _tmp0_ = FALSE;
#line 1131 "../lib/number.vala"
			_tmp0_ = TRUE;
#line 1131 "../lib/number.vala"
			while (TRUE) {
#line 5044 "number.c"
				Number* _tmp2_;
#line 1131 "../lib/number.vala"
				if (!_tmp0_) {
#line 5048 "number.c"
					gint _tmp1_;
#line 1131 "../lib/number.vala"
					_tmp1_ = i;
#line 1131 "../lib/number.vala"
					i = _tmp1_ + 1;
#line 5054 "number.c"
				}
#line 1131 "../lib/number.vala"
				_tmp0_ = FALSE;
#line 1131 "../lib/number.vala"
				if (!(i < args_length1)) {
#line 1131 "../lib/number.vala"
					break;
#line 5062 "number.c"
				}
#line 1132 "../lib/number.vala"
				_tmp2_ = args[i];
#line 1132 "../lib/number.vala"
				if (!number_is_integer (_tmp2_)) {
#line 5068 "number.c"
					Number* _tmp3_;
#line 1134 "../lib/number.vala"
					number_set_error (_ ("Least common multiple is only defined for integers"));
#line 1135 "../lib/number.vala"
					_tmp3_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1135 "../lib/number.vala"
					result = _tmp3_;
#line 1135 "../lib/number.vala"
					return result;
#line 5078 "number.c"
				}
			}
		}
	}
#line 1138 "../lib/number.vala"
	if (args_length1 == 1) {
#line 5085 "number.c"
		Number* _tmp4_;
		Number* _tmp5_;
#line 1139 "../lib/number.vala"
		_tmp4_ = args[0];
#line 1139 "../lib/number.vala"
		_tmp5_ = number_abs (_tmp4_);
#line 1139 "../lib/number.vala"
		result = _tmp5_;
#line 1139 "../lib/number.vala"
		return result;
#line 5096 "number.c"
	}
#line 1141 "../lib/number.vala"
	_tmp6_ = args[0];
#line 1141 "../lib/number.vala"
	_tmp7_ = args[1];
#line 1141 "../lib/number.vala"
	_tmp8_ = number_lcm_x_y (_tmp6_, _tmp7_);
#line 1141 "../lib/number.vala"
	z = _tmp8_;
#line 5106 "number.c"
	{
		gint i = 0;
#line 1142 "../lib/number.vala"
		i = 2;
#line 5111 "number.c"
		{
			gboolean _tmp9_ = FALSE;
#line 1142 "../lib/number.vala"
			_tmp9_ = TRUE;
#line 1142 "../lib/number.vala"
			while (TRUE) {
#line 5118 "number.c"
				Number* _tmp11_;
				Number* _tmp12_;
				Number* _tmp13_;
#line 1142 "../lib/number.vala"
				if (!_tmp9_) {
#line 5124 "number.c"
					gint _tmp10_;
#line 1142 "../lib/number.vala"
					_tmp10_ = i;
#line 1142 "../lib/number.vala"
					i = _tmp10_ + 1;
#line 5130 "number.c"
				}
#line 1142 "../lib/number.vala"
				_tmp9_ = FALSE;
#line 1142 "../lib/number.vala"
				if (!(i < args_length1)) {
#line 1142 "../lib/number.vala"
					break;
#line 5138 "number.c"
				}
#line 1143 "../lib/number.vala"
				_tmp11_ = z;
#line 1143 "../lib/number.vala"
				_tmp12_ = args[i];
#line 1143 "../lib/number.vala"
				_tmp13_ = number_lcm_x_y (_tmp11_, _tmp12_);
#line 1143 "../lib/number.vala"
				_g_object_unref0 (z);
#line 1143 "../lib/number.vala"
				z = _tmp13_;
#line 5150 "number.c"
			}
		}
	}
#line 1145 "../lib/number.vala"
	_tmp14_ = z;
#line 1145 "../lib/number.vala"
	_tmp15_ = number_abs (_tmp14_);
#line 1145 "../lib/number.vala"
	result = _tmp15_;
#line 1145 "../lib/number.vala"
	_g_object_unref0 (z);
#line 1145 "../lib/number.vala"
	return result;
#line 5164 "number.c"
}

static Number*
number_gcd_x_y (Number* x,
                Number* y)
{
	Number* a = NULL;
	Number* _tmp0_;
	Number* b = NULL;
	Number* _tmp1_;
	Number* result;
#line 1148 "../lib/number.vala"
	g_return_val_if_fail (x != NULL, NULL);
#line 1148 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 1150 "../lib/number.vala"
	_tmp0_ = _g_object_ref0 (x);
#line 1150 "../lib/number.vala"
	a = _tmp0_;
#line 1150 "../lib/number.vala"
	_tmp1_ = _g_object_ref0 (y);
#line 1150 "../lib/number.vala"
	b = _tmp1_;
#line 1151 "../lib/number.vala"
	while (TRUE) {
#line 5190 "number.c"
		Number* _tmp2_;
		Number* remainder = NULL;
		Number* _tmp3_;
		Number* _tmp4_;
		Number* _tmp5_;
		Number* _tmp6_;
		Number* _tmp7_;
		Number* _tmp8_;
		Number* _tmp9_;
#line 1151 "../lib/number.vala"
		_tmp2_ = b;
#line 1151 "../lib/number.vala"
		if (!(!number_is_zero (_tmp2_))) {
#line 1151 "../lib/number.vala"
			break;
#line 5206 "number.c"
		}
#line 1153 "../lib/number.vala"
		_tmp3_ = a;
#line 1153 "../lib/number.vala"
		_tmp4_ = b;
#line 1153 "../lib/number.vala"
		_tmp5_ = number_modulus_divide (_tmp3_, _tmp4_);
#line 1153 "../lib/number.vala"
		remainder = _tmp5_;
#line 1154 "../lib/number.vala"
		_tmp6_ = b;
#line 1154 "../lib/number.vala"
		_tmp7_ = _g_object_ref0 (_tmp6_);
#line 1154 "../lib/number.vala"
		_g_object_unref0 (a);
#line 1154 "../lib/number.vala"
		a = _tmp7_;
#line 1155 "../lib/number.vala"
		_tmp8_ = remainder;
#line 1155 "../lib/number.vala"
		_tmp9_ = _g_object_ref0 (_tmp8_);
#line 1155 "../lib/number.vala"
		_g_object_unref0 (b);
#line 1155 "../lib/number.vala"
		b = _tmp9_;
#line 1151 "../lib/number.vala"
		_g_object_unref0 (remainder);
#line 5234 "number.c"
	}
#line 1157 "../lib/number.vala"
	result = a;
#line 1157 "../lib/number.vala"
	_g_object_unref0 (b);
#line 1157 "../lib/number.vala"
	return result;
#line 5242 "number.c"
}

static Number*
number_lcm_x_y (Number* x,
                Number* y)
{
	gboolean _tmp0_ = FALSE;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* _tmp6_;
	Number* _tmp7_;
	Number* result;
#line 1160 "../lib/number.vala"
	g_return_val_if_fail (x != NULL, NULL);
#line 1160 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 1162 "../lib/number.vala"
	if (number_is_zero (x)) {
#line 1162 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 5265 "number.c"
	} else {
#line 1162 "../lib/number.vala"
		_tmp0_ = number_is_zero (y);
#line 5269 "number.c"
	}
#line 1162 "../lib/number.vala"
	if (_tmp0_) {
#line 5273 "number.c"
		Number* _tmp1_;
#line 1163 "../lib/number.vala"
		_tmp1_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1163 "../lib/number.vala"
		result = _tmp1_;
#line 1163 "../lib/number.vala"
		return result;
#line 5281 "number.c"
	}
#line 1164 "../lib/number.vala"
	_tmp2_ = number_gcd_x_y (x, y);
#line 1164 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 1164 "../lib/number.vala"
	_tmp4_ = number_divide (x, _tmp3_);
#line 1164 "../lib/number.vala"
	_tmp5_ = _tmp4_;
#line 1164 "../lib/number.vala"
	_tmp6_ = number_multiply (_tmp5_, y);
#line 1164 "../lib/number.vala"
	_tmp7_ = _tmp6_;
#line 1164 "../lib/number.vala"
	_g_object_unref0 (_tmp5_);
#line 1164 "../lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 1164 "../lib/number.vala"
	result = _tmp7_;
#line 1164 "../lib/number.vala"
	return result;
#line 5303 "number.c"
}

Number*
number_sum (Number** args,
            gint args_length1)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 1170 "../lib/number.vala"
	_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1170 "../lib/number.vala"
	z = _tmp0_;
#line 5317 "number.c"
	{
		Number** x_collection = NULL;
		gint x_collection_length1 = 0;
		gint _x_collection_size_ = 0;
		gint x_it = 0;
#line 1171 "../lib/number.vala"
		x_collection = args;
#line 1171 "../lib/number.vala"
		x_collection_length1 = args_length1;
#line 1171 "../lib/number.vala"
		for (x_it = 0; x_it < x_collection_length1; x_it = x_it + 1) {
#line 5329 "number.c"
			Number* _tmp1_;
			Number* x = NULL;
#line 1171 "../lib/number.vala"
			_tmp1_ = _g_object_ref0 (x_collection[x_it]);
#line 1171 "../lib/number.vala"
			x = _tmp1_;
#line 5336 "number.c"
			{
				Number* _tmp2_;
				Number* _tmp3_;
				Number* _tmp4_;
#line 1172 "../lib/number.vala"
				_tmp2_ = z;
#line 1172 "../lib/number.vala"
				_tmp3_ = x;
#line 1172 "../lib/number.vala"
				_tmp4_ = number_add (_tmp2_, _tmp3_);
#line 1172 "../lib/number.vala"
				_g_object_unref0 (z);
#line 1172 "../lib/number.vala"
				z = _tmp4_;
#line 1171 "../lib/number.vala"
				_g_object_unref0 (x);
#line 5353 "number.c"
			}
		}
	}
#line 1173 "../lib/number.vala"
	result = z;
#line 1173 "../lib/number.vala"
	return result;
#line 5361 "number.c"
}

Number*
number_sum_squares (Number** args,
                    gint args_length1)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 1179 "../lib/number.vala"
	_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1179 "../lib/number.vala"
	z = _tmp0_;
#line 5375 "number.c"
	{
		Number** x_collection = NULL;
		gint x_collection_length1 = 0;
		gint _x_collection_size_ = 0;
		gint x_it = 0;
#line 1180 "../lib/number.vala"
		x_collection = args;
#line 1180 "../lib/number.vala"
		x_collection_length1 = args_length1;
#line 1180 "../lib/number.vala"
		for (x_it = 0; x_it < x_collection_length1; x_it = x_it + 1) {
#line 5387 "number.c"
			Number* _tmp1_;
			Number* x = NULL;
#line 1180 "../lib/number.vala"
			_tmp1_ = _g_object_ref0 (x_collection[x_it]);
#line 1180 "../lib/number.vala"
			x = _tmp1_;
#line 5394 "number.c"
			{
				Number* _tmp2_;
				Number* _tmp3_;
				Number* _tmp4_;
				Number* _tmp5_;
				Number* _tmp6_;
#line 1181 "../lib/number.vala"
				_tmp2_ = z;
#line 1181 "../lib/number.vala"
				_tmp3_ = x;
#line 1181 "../lib/number.vala"
				_tmp4_ = number_xpowy_integer (_tmp3_, (gint64) 2);
#line 1181 "../lib/number.vala"
				_tmp5_ = _tmp4_;
#line 1181 "../lib/number.vala"
				_tmp6_ = number_add (_tmp2_, _tmp5_);
#line 1181 "../lib/number.vala"
				_g_object_unref0 (z);
#line 1181 "../lib/number.vala"
				z = _tmp6_;
#line 1181 "../lib/number.vala"
				_g_object_unref0 (_tmp5_);
#line 1180 "../lib/number.vala"
				_g_object_unref0 (x);
#line 5419 "number.c"
			}
		}
	}
#line 1182 "../lib/number.vala"
	result = z;
#line 1182 "../lib/number.vala"
	return result;
#line 5427 "number.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 1195 "../lib/number.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 5435 "number.c"
}

static Number**
_vala_array_dup11 (Number** self,
                   gssize length)
{
#line 1196 "../lib/number.vala"
	if (length >= 0) {
#line 5444 "number.c"
		Number** result;
		gssize i;
#line 1196 "../lib/number.vala"
		result = g_new0 (Number*, length + 1);
#line 1196 "../lib/number.vala"
		for (i = 0; i < length; i++) {
#line 5451 "number.c"
			Number* _tmp0_;
#line 1196 "../lib/number.vala"
			_tmp0_ = _g_object_ref0 (self[i]);
#line 1196 "../lib/number.vala"
			result[i] = _tmp0_;
#line 5457 "number.c"
		}
#line 1196 "../lib/number.vala"
		return result;
#line 5461 "number.c"
	}
#line 1196 "../lib/number.vala"
	return NULL;
#line 5465 "number.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 5926 "glib-2.0.vapi"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 5926 "glib-2.0.vapi"
	return _data2_;
#line 5475 "number.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 5926 "glib-2.0.vapi"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 5485 "number.c"
		GPtrArray* self;
#line 5926 "glib-2.0.vapi"
		self = _data2_->self;
#line 5926 "glib-2.0.vapi"
		_g_ptr_array_unref0 (self);
#line 5926 "glib-2.0.vapi"
		g_slice_free (Block2Data, _data2_);
#line 5493 "number.c"
	}
}

static gint
__lambda0_ (Block2Data* _data2_,
            gconstpointer** a,
            gconstpointer** b)
{
	GPtrArray* self;
	gint result;
#line 5927 "glib-2.0.vapi"
	self = _data2_->self;
#line 5928 "glib-2.0.vapi"
	result = _data2_->compare_func ((gconstpointer**) (*a), (gconstpointer**) (*b));
#line 5928 "glib-2.0.vapi"
	return result;
#line 5510 "number.c"
}

static gint
___lambda0__gcompare_data_func (gconstpointer a,
                                gconstpointer b,
                                gpointer self)
{
	gint result;
	result = __lambda0_ (self, a, b);
#line 5927 "glib-2.0.vapi"
	return result;
#line 5522 "number.c"
}

static void
vala_g_ptr_array_sort (GPtrArray* self,
                       GCompareFunc compare_func)
{
	Block2Data* _data2_;
#line 5926 "glib-2.0.vapi"
	g_return_if_fail (self != NULL);
#line 5926 "glib-2.0.vapi"
	_data2_ = g_slice_new0 (Block2Data);
#line 5926 "glib-2.0.vapi"
	_data2_->_ref_count_ = 1;
#line 5926 "glib-2.0.vapi"
	_data2_->self = g_ptr_array_ref (self);
#line 5926 "glib-2.0.vapi"
	_data2_->compare_func = compare_func;
#line 5927 "glib-2.0.vapi"
	g_ptr_array_sort_with_data (self, ___lambda0__gcompare_data_func, _data2_);
#line 5926 "glib-2.0.vapi"
	block2_data_unref (_data2_);
#line 5926 "glib-2.0.vapi"
	_data2_ = NULL;
#line 5546 "number.c"
}

static gint
__lambda12_ (Number* a,
             Number* b)
{
	gint result;
#line 1197 "../lib/number.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 1197 "../lib/number.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 1197 "../lib/number.vala"
	result = number_compare (a, b);
#line 1197 "../lib/number.vala"
	return result;
#line 5562 "number.c"
}

static gint
___lambda12__gcompare_func (gconstpointer a,
                            gconstpointer b)
{
	gint result;
	result = __lambda12_ ((Number*) a, (Number*) b);
#line 1197 "../lib/number.vala"
	return result;
#line 5573 "number.c"
}

Number*
number_median (Number** args,
               gint args_length1)
{
	GPtrArray* array = NULL;
	GPtrArray* _tmp3_;
	GPtrArray* _tmp4_;
	Number** _tmp5_;
	gint _tmp5__length1;
	GPtrArray* _tmp6_;
	GPtrArray* _tmp10_;
	gconstpointer _tmp11_;
	GPtrArray* _tmp12_;
	gconstpointer _tmp13_;
	Number* _tmp14_;
	Number* _tmp15_;
	Number* _tmp16_;
	Number* _tmp17_;
	Number* result;
	{
		Number** x_collection = NULL;
		gint x_collection_length1 = 0;
		gint _x_collection_size_ = 0;
		gint x_it = 0;
#line 1188 "../lib/number.vala"
		x_collection = args;
#line 1188 "../lib/number.vala"
		x_collection_length1 = args_length1;
#line 1188 "../lib/number.vala"
		for (x_it = 0; x_it < x_collection_length1; x_it = x_it + 1) {
#line 5606 "number.c"
			Number* _tmp0_;
			Number* x = NULL;
#line 1188 "../lib/number.vala"
			_tmp0_ = _g_object_ref0 (x_collection[x_it]);
#line 1188 "../lib/number.vala"
			x = _tmp0_;
#line 5613 "number.c"
			{
				Number* _tmp1_;
#line 1189 "../lib/number.vala"
				_tmp1_ = x;
#line 1189 "../lib/number.vala"
				if (number_is_complex (_tmp1_)) {
#line 5620 "number.c"
					Number* _tmp2_;
#line 1191 "../lib/number.vala"
					number_set_error (_ ("Median is only defined for real numbers"));
#line 1192 "../lib/number.vala"
					_tmp2_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1192 "../lib/number.vala"
					result = _tmp2_;
#line 1192 "../lib/number.vala"
					_g_object_unref0 (x);
#line 1192 "../lib/number.vala"
					return result;
#line 5632 "number.c"
				}
#line 1188 "../lib/number.vala"
				_g_object_unref0 (x);
#line 5636 "number.c"
			}
		}
	}
#line 1195 "../lib/number.vala"
	_tmp3_ = g_ptr_array_new_full ((guint) 0, _g_object_unref0_);
#line 1195 "../lib/number.vala"
	array = _tmp3_;
#line 1196 "../lib/number.vala"
	_tmp4_ = array;
#line 1196 "../lib/number.vala"
	_tmp5_ = (args != NULL) ? _vala_array_dup11 (args, args_length1) : args;
#line 1196 "../lib/number.vala"
	_tmp5__length1 = args_length1;
#line 1196 "../lib/number.vala"
	_tmp4_->pdata = (_vala_array_free (_tmp4_->pdata, _tmp4_->len, (GDestroyNotify) g_object_unref), NULL);
#line 1196 "../lib/number.vala"
	_tmp4_->pdata = _tmp5_;
#line 1196 "../lib/number.vala"
	_tmp4_->len = _tmp5__length1;
#line 1197 "../lib/number.vala"
	_tmp6_ = array;
#line 1197 "../lib/number.vala"
	vala_g_ptr_array_sort (_tmp6_, ___lambda12__gcompare_func);
#line 1198 "../lib/number.vala"
	if ((args_length1 % 2) != 0) {
#line 5662 "number.c"
		GPtrArray* _tmp7_;
		gconstpointer _tmp8_;
		Number* _tmp9_;
#line 1199 "../lib/number.vala"
		_tmp7_ = array;
#line 1199 "../lib/number.vala"
		_tmp8_ = g_ptr_array_index (_tmp7_, (guint) (args_length1 / 2));
#line 1199 "../lib/number.vala"
		_tmp9_ = _g_object_ref0 ((Number*) _tmp8_);
#line 1199 "../lib/number.vala"
		result = _tmp9_;
#line 1199 "../lib/number.vala"
		_g_ptr_array_unref0 (array);
#line 1199 "../lib/number.vala"
		return result;
#line 5678 "number.c"
	}
#line 1200 "../lib/number.vala"
	_tmp10_ = array;
#line 1200 "../lib/number.vala"
	_tmp11_ = g_ptr_array_index (_tmp10_, (guint) (args_length1 / 2));
#line 1200 "../lib/number.vala"
	_tmp12_ = array;
#line 1200 "../lib/number.vala"
	_tmp13_ = g_ptr_array_index (_tmp12_, (guint) ((args_length1 / 2) - 1));
#line 1200 "../lib/number.vala"
	_tmp14_ = number_add ((Number*) _tmp11_, (Number*) _tmp13_);
#line 1200 "../lib/number.vala"
	_tmp15_ = _tmp14_;
#line 1200 "../lib/number.vala"
	_tmp16_ = number_divide_integer (_tmp15_, (gint64) 2);
#line 1200 "../lib/number.vala"
	_tmp17_ = _tmp16_;
#line 1200 "../lib/number.vala"
	_g_object_unref0 (_tmp15_);
#line 1200 "../lib/number.vala"
	result = _tmp17_;
#line 1200 "../lib/number.vala"
	_g_ptr_array_unref0 (array);
#line 1200 "../lib/number.vala"
	return result;
#line 5704 "number.c"
}

Number*
number_min (Number** args,
            gint args_length1)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* result;
#line 1206 "../lib/number.vala"
	_tmp0_ = args[0];
#line 1206 "../lib/number.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1206 "../lib/number.vala"
	z = _tmp1_;
#line 5721 "number.c"
	{
		Number** x_collection = NULL;
		gint x_collection_length1 = 0;
		gint _x_collection_size_ = 0;
		gint x_it = 0;
#line 1207 "../lib/number.vala"
		x_collection = args;
#line 1207 "../lib/number.vala"
		x_collection_length1 = args_length1;
#line 1207 "../lib/number.vala"
		for (x_it = 0; x_it < x_collection_length1; x_it = x_it + 1) {
#line 5733 "number.c"
			Number* _tmp2_;
			Number* x = NULL;
#line 1207 "../lib/number.vala"
			_tmp2_ = _g_object_ref0 (x_collection[x_it]);
#line 1207 "../lib/number.vala"
			x = _tmp2_;
#line 5740 "number.c"
			{
				Number* _tmp3_;
				Number* _tmp5_;
				Number* _tmp6_;
#line 1209 "../lib/number.vala"
				_tmp3_ = x;
#line 1209 "../lib/number.vala"
				if (number_is_complex (_tmp3_)) {
#line 5749 "number.c"
					Number* _tmp4_;
#line 1211 "../lib/number.vala"
					number_set_error (_ ("Minimum value is only defined for real numbers"));
#line 1212 "../lib/number.vala"
					_tmp4_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1212 "../lib/number.vala"
					result = _tmp4_;
#line 1212 "../lib/number.vala"
					_g_object_unref0 (x);
#line 1212 "../lib/number.vala"
					_g_object_unref0 (z);
#line 1212 "../lib/number.vala"
					return result;
#line 5763 "number.c"
				}
#line 1214 "../lib/number.vala"
				_tmp5_ = x;
#line 1214 "../lib/number.vala"
				_tmp6_ = z;
#line 1214 "../lib/number.vala"
				if (number_compare (_tmp5_, _tmp6_) < 0) {
#line 5771 "number.c"
					Number* _tmp7_;
					Number* _tmp8_;
#line 1215 "../lib/number.vala"
					_tmp7_ = x;
#line 1215 "../lib/number.vala"
					_tmp8_ = _g_object_ref0 (_tmp7_);
#line 1215 "../lib/number.vala"
					_g_object_unref0 (z);
#line 1215 "../lib/number.vala"
					z = _tmp8_;
#line 5782 "number.c"
				}
#line 1207 "../lib/number.vala"
				_g_object_unref0 (x);
#line 5786 "number.c"
			}
		}
	}
#line 1217 "../lib/number.vala"
	result = z;
#line 1217 "../lib/number.vala"
	return result;
#line 5794 "number.c"
}

Number*
number_max (Number** args,
            gint args_length1)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* result;
#line 1223 "../lib/number.vala"
	_tmp0_ = args[0];
#line 1223 "../lib/number.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 1223 "../lib/number.vala"
	z = _tmp1_;
#line 5811 "number.c"
	{
		Number** x_collection = NULL;
		gint x_collection_length1 = 0;
		gint _x_collection_size_ = 0;
		gint x_it = 0;
#line 1224 "../lib/number.vala"
		x_collection = args;
#line 1224 "../lib/number.vala"
		x_collection_length1 = args_length1;
#line 1224 "../lib/number.vala"
		for (x_it = 0; x_it < x_collection_length1; x_it = x_it + 1) {
#line 5823 "number.c"
			Number* _tmp2_;
			Number* x = NULL;
#line 1224 "../lib/number.vala"
			_tmp2_ = _g_object_ref0 (x_collection[x_it]);
#line 1224 "../lib/number.vala"
			x = _tmp2_;
#line 5830 "number.c"
			{
				Number* _tmp3_;
				Number* _tmp5_;
				Number* _tmp6_;
#line 1226 "../lib/number.vala"
				_tmp3_ = x;
#line 1226 "../lib/number.vala"
				if (number_is_complex (_tmp3_)) {
#line 5839 "number.c"
					Number* _tmp4_;
#line 1228 "../lib/number.vala"
					number_set_error (_ ("Maximum value is only defined for real numbers"));
#line 1229 "../lib/number.vala"
					_tmp4_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1229 "../lib/number.vala"
					result = _tmp4_;
#line 1229 "../lib/number.vala"
					_g_object_unref0 (x);
#line 1229 "../lib/number.vala"
					_g_object_unref0 (z);
#line 1229 "../lib/number.vala"
					return result;
#line 5853 "number.c"
				}
#line 1231 "../lib/number.vala"
				_tmp5_ = x;
#line 1231 "../lib/number.vala"
				_tmp6_ = z;
#line 1231 "../lib/number.vala"
				if (number_compare (_tmp5_, _tmp6_) > 0) {
#line 5861 "number.c"
					Number* _tmp7_;
					Number* _tmp8_;
#line 1232 "../lib/number.vala"
					_tmp7_ = x;
#line 1232 "../lib/number.vala"
					_tmp8_ = _g_object_ref0 (_tmp7_);
#line 1232 "../lib/number.vala"
					_g_object_unref0 (z);
#line 1232 "../lib/number.vala"
					z = _tmp8_;
#line 5872 "number.c"
				}
#line 1224 "../lib/number.vala"
				_g_object_unref0 (x);
#line 5876 "number.c"
			}
		}
	}
#line 1234 "../lib/number.vala"
	result = z;
#line 1234 "../lib/number.vala"
	return result;
#line 5884 "number.c"
}

Number*
number_sample_standard_deviation (Number** args,
                                  gint args_length1)
{
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* result;
#line 1240 "../lib/number.vala"
	if (args_length1 == 1) {
#line 5898 "number.c"
		Number* _tmp0_;
#line 1242 "../lib/number.vala"
		number_set_error (_ ("Sample standard deviation of a single number is undefined"));
#line 1243 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1243 "../lib/number.vala"
		result = _tmp0_;
#line 1243 "../lib/number.vala"
		return result;
#line 5908 "number.c"
	}
#line 1246 "../lib/number.vala"
	_tmp1_ = number_sample_variance (args, (gint) args_length1);
#line 1246 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 1246 "../lib/number.vala"
	_tmp3_ = number_sqrt (_tmp2_);
#line 1246 "../lib/number.vala"
	_tmp4_ = _tmp3_;
#line 1246 "../lib/number.vala"
	_g_object_unref0 (_tmp2_);
#line 1246 "../lib/number.vala"
	result = _tmp4_;
#line 1246 "../lib/number.vala"
	return result;
#line 5924 "number.c"
}

Number*
number_sample_variance (Number** args,
                        gint args_length1)
{
	Number* z = NULL;
	Number* _tmp1_;
	Number* average = NULL;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* _tmp17_;
	Number* _tmp18_;
	Number* result;
#line 1252 "../lib/number.vala"
	if (args_length1 == 1) {
#line 5943 "number.c"
		Number* _tmp0_;
#line 1254 "../lib/number.vala"
		number_set_error (_ ("Sample variance of a single number is undefined"));
#line 1255 "../lib/number.vala"
		_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1255 "../lib/number.vala"
		result = _tmp0_;
#line 1255 "../lib/number.vala"
		return result;
#line 5953 "number.c"
	}
#line 1258 "../lib/number.vala"
	_tmp1_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1258 "../lib/number.vala"
	z = _tmp1_;
#line 1259 "../lib/number.vala"
	_tmp2_ = number_sum (args, (gint) args_length1);
#line 1259 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 1259 "../lib/number.vala"
	_tmp4_ = number_divide_integer (_tmp3_, (gint64) args_length1);
#line 1259 "../lib/number.vala"
	_tmp5_ = _tmp4_;
#line 1259 "../lib/number.vala"
	_g_object_unref0 (_tmp3_);
#line 1259 "../lib/number.vala"
	average = _tmp5_;
#line 5971 "number.c"
	{
		Number** x_collection = NULL;
		gint x_collection_length1 = 0;
		gint _x_collection_size_ = 0;
		gint x_it = 0;
#line 1260 "../lib/number.vala"
		x_collection = args;
#line 1260 "../lib/number.vala"
		x_collection_length1 = args_length1;
#line 1260 "../lib/number.vala"
		for (x_it = 0; x_it < x_collection_length1; x_it = x_it + 1) {
#line 5983 "number.c"
			Number* _tmp6_;
			Number* x = NULL;
#line 1260 "../lib/number.vala"
			_tmp6_ = _g_object_ref0 (x_collection[x_it]);
#line 1260 "../lib/number.vala"
			x = _tmp6_;
#line 5990 "number.c"
			{
				Number* _tmp7_;
				Number* _tmp8_;
				Number* _tmp9_;
				Number* _tmp10_;
				Number* _tmp11_;
				Number* _tmp12_;
				Number* _tmp13_;
				Number* _tmp14_;
				Number* _tmp15_;
				Number* _tmp16_;
#line 1261 "../lib/number.vala"
				_tmp7_ = z;
#line 1261 "../lib/number.vala"
				_tmp8_ = x;
#line 1261 "../lib/number.vala"
				_tmp9_ = average;
#line 1261 "../lib/number.vala"
				_tmp10_ = number_subtract (_tmp8_, _tmp9_);
#line 1261 "../lib/number.vala"
				_tmp11_ = _tmp10_;
#line 1261 "../lib/number.vala"
				_tmp12_ = number_abs (_tmp11_);
#line 1261 "../lib/number.vala"
				_tmp13_ = _tmp12_;
#line 1261 "../lib/number.vala"
				_tmp14_ = number_xpowy_integer (_tmp13_, (gint64) 2);
#line 1261 "../lib/number.vala"
				_tmp15_ = _tmp14_;
#line 1261 "../lib/number.vala"
				_tmp16_ = number_add (_tmp7_, _tmp15_);
#line 1261 "../lib/number.vala"
				_g_object_unref0 (z);
#line 1261 "../lib/number.vala"
				z = _tmp16_;
#line 1261 "../lib/number.vala"
				_g_object_unref0 (_tmp15_);
#line 1261 "../lib/number.vala"
				_g_object_unref0 (_tmp13_);
#line 1261 "../lib/number.vala"
				_g_object_unref0 (_tmp11_);
#line 1260 "../lib/number.vala"
				_g_object_unref0 (x);
#line 6034 "number.c"
			}
		}
	}
#line 1262 "../lib/number.vala"
	_tmp17_ = z;
#line 1262 "../lib/number.vala"
	_tmp18_ = number_divide_integer (_tmp17_, (gint64) (args_length1 - 1));
#line 1262 "../lib/number.vala"
	result = _tmp18_;
#line 1262 "../lib/number.vala"
	_g_object_unref0 (average);
#line 1262 "../lib/number.vala"
	_g_object_unref0 (z);
#line 1262 "../lib/number.vala"
	return result;
#line 6050 "number.c"
}

Number*
number_population_variance (Number** args,
                            gint args_length1)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* average = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* _tmp16_;
	Number* _tmp17_;
	Number* result;
#line 1268 "../lib/number.vala"
	_tmp0_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1268 "../lib/number.vala"
	z = _tmp0_;
#line 1269 "../lib/number.vala"
	_tmp1_ = number_sum (args, (gint) args_length1);
#line 1269 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 1269 "../lib/number.vala"
	_tmp3_ = number_divide_integer (_tmp2_, (gint64) args_length1);
#line 1269 "../lib/number.vala"
	_tmp4_ = _tmp3_;
#line 1269 "../lib/number.vala"
	_g_object_unref0 (_tmp2_);
#line 1269 "../lib/number.vala"
	average = _tmp4_;
#line 6083 "number.c"
	{
		Number** x_collection = NULL;
		gint x_collection_length1 = 0;
		gint _x_collection_size_ = 0;
		gint x_it = 0;
#line 1270 "../lib/number.vala"
		x_collection = args;
#line 1270 "../lib/number.vala"
		x_collection_length1 = args_length1;
#line 1270 "../lib/number.vala"
		for (x_it = 0; x_it < x_collection_length1; x_it = x_it + 1) {
#line 6095 "number.c"
			Number* _tmp5_;
			Number* x = NULL;
#line 1270 "../lib/number.vala"
			_tmp5_ = _g_object_ref0 (x_collection[x_it]);
#line 1270 "../lib/number.vala"
			x = _tmp5_;
#line 6102 "number.c"
			{
				Number* _tmp6_;
				Number* _tmp7_;
				Number* _tmp8_;
				Number* _tmp9_;
				Number* _tmp10_;
				Number* _tmp11_;
				Number* _tmp12_;
				Number* _tmp13_;
				Number* _tmp14_;
				Number* _tmp15_;
#line 1271 "../lib/number.vala"
				_tmp6_ = z;
#line 1271 "../lib/number.vala"
				_tmp7_ = x;
#line 1271 "../lib/number.vala"
				_tmp8_ = average;
#line 1271 "../lib/number.vala"
				_tmp9_ = number_subtract (_tmp7_, _tmp8_);
#line 1271 "../lib/number.vala"
				_tmp10_ = _tmp9_;
#line 1271 "../lib/number.vala"
				_tmp11_ = number_abs (_tmp10_);
#line 1271 "../lib/number.vala"
				_tmp12_ = _tmp11_;
#line 1271 "../lib/number.vala"
				_tmp13_ = number_xpowy_integer (_tmp12_, (gint64) 2);
#line 1271 "../lib/number.vala"
				_tmp14_ = _tmp13_;
#line 1271 "../lib/number.vala"
				_tmp15_ = number_add (_tmp6_, _tmp14_);
#line 1271 "../lib/number.vala"
				_g_object_unref0 (z);
#line 1271 "../lib/number.vala"
				z = _tmp15_;
#line 1271 "../lib/number.vala"
				_g_object_unref0 (_tmp14_);
#line 1271 "../lib/number.vala"
				_g_object_unref0 (_tmp12_);
#line 1271 "../lib/number.vala"
				_g_object_unref0 (_tmp10_);
#line 1270 "../lib/number.vala"
				_g_object_unref0 (x);
#line 6146 "number.c"
			}
		}
	}
#line 1272 "../lib/number.vala"
	_tmp16_ = z;
#line 1272 "../lib/number.vala"
	_tmp17_ = number_divide_integer (_tmp16_, (gint64) args_length1);
#line 1272 "../lib/number.vala"
	result = _tmp17_;
#line 1272 "../lib/number.vala"
	_g_object_unref0 (average);
#line 1272 "../lib/number.vala"
	_g_object_unref0 (z);
#line 1272 "../lib/number.vala"
	return result;
#line 6162 "number.c"
}

static gboolean
number_is_sprp (Number* self,
                Number* p,
                guint64 b)
{
	Number* unit = NULL;
	Number* _tmp0_;
	Number* pminus = NULL;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* d = NULL;
	Number* _tmp3_;
	Number* _tmp4_;
	Number* two = NULL;
	Number* _tmp5_;
	guint64 twofactor = 0ULL;
	Number* x = NULL;
	Number* _tmp12_;
	Number* _tmp13_;
	Number* _tmp14_;
	Number* _tmp15_;
	Number* _tmp16_;
	gboolean _tmp17_ = FALSE;
	Number* _tmp18_;
	Number* _tmp19_;
	gboolean result;
#line 1277 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1277 "../lib/number.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 1279 "../lib/number.vala"
	_tmp0_ = number_new_unsigned_integer ((guint64) 1, (guint64) 0);
#line 1279 "../lib/number.vala"
	unit = _tmp0_;
#line 1280 "../lib/number.vala"
	_tmp1_ = unit;
#line 1280 "../lib/number.vala"
	_tmp2_ = number_subtract (p, _tmp1_);
#line 1280 "../lib/number.vala"
	pminus = _tmp2_;
#line 1281 "../lib/number.vala"
	_tmp3_ = pminus;
#line 1281 "../lib/number.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 1281 "../lib/number.vala"
	d = _tmp4_;
#line 1282 "../lib/number.vala"
	_tmp5_ = number_new_unsigned_integer ((guint64) 2, (guint64) 0);
#line 1282 "../lib/number.vala"
	two = _tmp5_;
#line 1284 "../lib/number.vala"
	twofactor = (guint64) 0;
#line 1286 "../lib/number.vala"
	while (TRUE) {
#line 6219 "number.c"
		Number* tmp = NULL;
		Number* _tmp6_;
		Number* _tmp7_;
		Number* _tmp8_;
		Number* _tmp9_;
#line 1288 "../lib/number.vala"
		_tmp6_ = d;
#line 1288 "../lib/number.vala"
		_tmp7_ = two;
#line 1288 "../lib/number.vala"
		_tmp8_ = number_divide (_tmp6_, _tmp7_);
#line 1288 "../lib/number.vala"
		tmp = _tmp8_;
#line 1289 "../lib/number.vala"
		_tmp9_ = tmp;
#line 1289 "../lib/number.vala"
		if (number_is_integer (_tmp9_)) {
#line 6237 "number.c"
			Number* _tmp10_;
			Number* _tmp11_;
#line 1291 "../lib/number.vala"
			_tmp10_ = tmp;
#line 1291 "../lib/number.vala"
			_tmp11_ = _g_object_ref0 (_tmp10_);
#line 1291 "../lib/number.vala"
			_g_object_unref0 (d);
#line 1291 "../lib/number.vala"
			d = _tmp11_;
#line 1292 "../lib/number.vala"
			twofactor = twofactor + 1;
#line 6250 "number.c"
		} else {
#line 1295 "../lib/number.vala"
			_g_object_unref0 (tmp);
#line 1295 "../lib/number.vala"
			break;
#line 6256 "number.c"
		}
#line 1286 "../lib/number.vala"
		_g_object_unref0 (tmp);
#line 6260 "number.c"
	}
#line 1298 "../lib/number.vala"
	_tmp12_ = number_new_unsigned_integer (b, (guint64) 0);
#line 1298 "../lib/number.vala"
	_tmp13_ = _tmp12_;
#line 1298 "../lib/number.vala"
	_tmp14_ = d;
#line 1298 "../lib/number.vala"
	_tmp15_ = number_modular_exponentiation (_tmp13_, _tmp14_, p);
#line 1298 "../lib/number.vala"
	_tmp16_ = _tmp15_;
#line 1298 "../lib/number.vala"
	_g_object_unref0 (_tmp13_);
#line 1298 "../lib/number.vala"
	x = _tmp16_;
#line 1300 "../lib/number.vala"
	_tmp18_ = x;
#line 1300 "../lib/number.vala"
	_tmp19_ = unit;
#line 1300 "../lib/number.vala"
	if (number_equals (_tmp18_, _tmp19_)) {
#line 1300 "../lib/number.vala"
		_tmp17_ = TRUE;
#line 6284 "number.c"
	} else {
		Number* _tmp20_;
		Number* _tmp21_;
#line 1300 "../lib/number.vala"
		_tmp20_ = x;
#line 1300 "../lib/number.vala"
		_tmp21_ = pminus;
#line 1300 "../lib/number.vala"
		_tmp17_ = number_equals (_tmp20_, _tmp21_);
#line 6294 "number.c"
	}
#line 1300 "../lib/number.vala"
	if (_tmp17_) {
#line 1302 "../lib/number.vala"
		result = TRUE;
#line 1302 "../lib/number.vala"
		_g_object_unref0 (x);
#line 1302 "../lib/number.vala"
		_g_object_unref0 (two);
#line 1302 "../lib/number.vala"
		_g_object_unref0 (d);
#line 1302 "../lib/number.vala"
		_g_object_unref0 (pminus);
#line 1302 "../lib/number.vala"
		_g_object_unref0 (unit);
#line 1302 "../lib/number.vala"
		return result;
#line 6312 "number.c"
	}
	{
		gint i = 0;
#line 1305 "../lib/number.vala"
		i = 1;
#line 6318 "number.c"
		{
			gboolean _tmp22_ = FALSE;
#line 1305 "../lib/number.vala"
			_tmp22_ = TRUE;
#line 1305 "../lib/number.vala"
			while (TRUE) {
#line 6325 "number.c"
				Number* _tmp24_;
				Number* _tmp25_;
				Number* _tmp26_;
				Number* _tmp27_;
				Number* _tmp28_;
				Number* _tmp29_;
				Number* _tmp30_;
#line 1305 "../lib/number.vala"
				if (!_tmp22_) {
#line 6335 "number.c"
					gint _tmp23_;
#line 1305 "../lib/number.vala"
					_tmp23_ = i;
#line 1305 "../lib/number.vala"
					i = _tmp23_ + 1;
#line 6341 "number.c"
				}
#line 1305 "../lib/number.vala"
				_tmp22_ = FALSE;
#line 1305 "../lib/number.vala"
				if (!(((guint64) i) < twofactor)) {
#line 1305 "../lib/number.vala"
					break;
#line 6349 "number.c"
				}
#line 1307 "../lib/number.vala"
				_tmp24_ = x;
#line 1307 "../lib/number.vala"
				_tmp25_ = x;
#line 1307 "../lib/number.vala"
				_tmp26_ = number_multiply (_tmp24_, _tmp25_);
#line 1307 "../lib/number.vala"
				_g_object_unref0 (x);
#line 1307 "../lib/number.vala"
				x = _tmp26_;
#line 1308 "../lib/number.vala"
				_tmp27_ = x;
#line 1308 "../lib/number.vala"
				_tmp28_ = number_modulus_divide (_tmp27_, p);
#line 1308 "../lib/number.vala"
				_g_object_unref0 (x);
#line 1308 "../lib/number.vala"
				x = _tmp28_;
#line 1310 "../lib/number.vala"
				_tmp29_ = x;
#line 1310 "../lib/number.vala"
				_tmp30_ = pminus;
#line 1310 "../lib/number.vala"
				if (number_equals (_tmp29_, _tmp30_)) {
#line 1312 "../lib/number.vala"
					result = TRUE;
#line 1312 "../lib/number.vala"
					_g_object_unref0 (x);
#line 1312 "../lib/number.vala"
					_g_object_unref0 (two);
#line 1312 "../lib/number.vala"
					_g_object_unref0 (d);
#line 1312 "../lib/number.vala"
					_g_object_unref0 (pminus);
#line 1312 "../lib/number.vala"
					_g_object_unref0 (unit);
#line 1312 "../lib/number.vala"
					return result;
#line 6389 "number.c"
				}
			}
		}
	}
#line 1315 "../lib/number.vala"
	result = FALSE;
#line 1315 "../lib/number.vala"
	_g_object_unref0 (x);
#line 1315 "../lib/number.vala"
	_g_object_unref0 (two);
#line 1315 "../lib/number.vala"
	_g_object_unref0 (d);
#line 1315 "../lib/number.vala"
	_g_object_unref0 (pminus);
#line 1315 "../lib/number.vala"
	_g_object_unref0 (unit);
#line 1315 "../lib/number.vala"
	return result;
#line 6408 "number.c"
}

static gboolean
number_is_prime (Number* self,
                 Number* x)
{
#line 1326 "../lib/number.vala"
	static const guint64 BASES[13] = {(guint64) 2, (guint64) 3, (guint64) 5, (guint64) 7, (guint64) 11, (guint64) 13, (guint64) 17, (guint64) 19, (guint64) 23, (guint64) 29, (guint64) 31, (guint64) 37, (guint64) 41};
#line 6417 "number.c"
	guint64 sup = 0ULL;
	Number* _tmp0_;
	Number* _tmp1_;
	guint64 _tmp2_;
	gboolean result;
#line 1324 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1324 "../lib/number.vala"
	g_return_val_if_fail (x != NULL, FALSE);
#line 1328 "../lib/number.vala"
	_tmp0_ = number_ln (x);
#line 1328 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 1328 "../lib/number.vala"
	_tmp2_ = number_to_unsigned_integer (_tmp1_) + 1;
#line 1328 "../lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 1328 "../lib/number.vala"
	sup = _tmp2_;
#line 1330 "../lib/number.vala"
	if (sup < ((guint64) 56)) {
#line 6439 "number.c"
		{
			gint i = 0;
#line 1332 "../lib/number.vala"
			i = 0;
#line 6444 "number.c"
			{
				gboolean _tmp3_ = FALSE;
#line 1332 "../lib/number.vala"
				_tmp3_ = TRUE;
#line 1332 "../lib/number.vala"
				while (TRUE) {
#line 6451 "number.c"
					guint64 _tmp5_;
#line 1332 "../lib/number.vala"
					if (!_tmp3_) {
#line 6455 "number.c"
						gint _tmp4_;
#line 1332 "../lib/number.vala"
						_tmp4_ = i;
#line 1332 "../lib/number.vala"
						i = _tmp4_ + 1;
#line 6461 "number.c"
					}
#line 1332 "../lib/number.vala"
					_tmp3_ = FALSE;
#line 1332 "../lib/number.vala"
					if (!(i < 13)) {
#line 1332 "../lib/number.vala"
						break;
#line 6469 "number.c"
					}
#line 1334 "../lib/number.vala"
					_tmp5_ = BASES[i];
#line 1334 "../lib/number.vala"
					if (!number_is_sprp (self, x, _tmp5_)) {
#line 1336 "../lib/number.vala"
						result = FALSE;
#line 1336 "../lib/number.vala"
						return result;
#line 6479 "number.c"
					}
				}
			}
		}
#line 1339 "../lib/number.vala"
		result = TRUE;
#line 1339 "../lib/number.vala"
		return result;
#line 6488 "number.c"
	} else {
#line 1343 "../lib/number.vala"
		sup = (sup * sup) * 2;
#line 6492 "number.c"
		{
			gint i = 0;
#line 1345 "../lib/number.vala"
			i = 0;
#line 6497 "number.c"
			{
				gboolean _tmp6_ = FALSE;
#line 1345 "../lib/number.vala"
				_tmp6_ = TRUE;
#line 1345 "../lib/number.vala"
				while (TRUE) {
#line 1345 "../lib/number.vala"
					if (!_tmp6_) {
#line 6506 "number.c"
						gint _tmp7_;
#line 1345 "../lib/number.vala"
						_tmp7_ = i;
#line 1345 "../lib/number.vala"
						i = _tmp7_ + 1;
#line 6512 "number.c"
					}
#line 1345 "../lib/number.vala"
					_tmp6_ = FALSE;
#line 1345 "../lib/number.vala"
					if (!(((guint64) i) < sup)) {
#line 1345 "../lib/number.vala"
						break;
#line 6520 "number.c"
					}
#line 1347 "../lib/number.vala"
					if (!number_is_sprp (self, x, (guint64) i)) {
#line 1349 "../lib/number.vala"
						result = FALSE;
#line 1349 "../lib/number.vala"
						return result;
#line 6528 "number.c"
					}
				}
			}
		}
#line 1352 "../lib/number.vala"
		result = TRUE;
#line 1352 "../lib/number.vala"
		return result;
#line 6537 "number.c"
	}
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 1392 "../lib/number.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 6546 "number.c"
}

GList*
number_factorize (Number* self)
{
	GList* factors = NULL;
	Number* value = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp4_;
	Number* _tmp5_;
	Number* _tmp6_;
	gboolean _tmp7_;
	Number* _tmp9_;
	Number* _tmp10_;
	Number* _tmp11_;
	gboolean _tmp12_;
	Number* int_max = NULL;
	Number* _tmp16_;
	Number* _tmp17_;
	Number* _tmp18_;
	Number* divisor = NULL;
	Number* _tmp25_;
	Number* _tmp34_;
	Number* root = NULL;
	Number* _tmp35_;
	Number* _tmp36_;
	Number* _tmp55_;
	Number* _tmp56_;
	Number* _tmp57_;
	gboolean _tmp58_;
	GList* result;
#line 1357 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1359 "../lib/number.vala"
	factors = NULL;
#line 1361 "../lib/number.vala"
	_tmp0_ = number_abs (self);
#line 1361 "../lib/number.vala"
	value = _tmp0_;
#line 1363 "../lib/number.vala"
	_tmp1_ = value;
#line 1363 "../lib/number.vala"
	if (number_is_zero (_tmp1_)) {
#line 6591 "number.c"
		Number* _tmp2_;
		Number* _tmp3_;
#line 1365 "../lib/number.vala"
		_tmp2_ = value;
#line 1365 "../lib/number.vala"
		_tmp3_ = _g_object_ref0 (_tmp2_);
#line 1365 "../lib/number.vala"
		factors = g_list_append (factors, _tmp3_);
#line 1366 "../lib/number.vala"
		result = factors;
#line 1366 "../lib/number.vala"
		_g_object_unref0 (value);
#line 1366 "../lib/number.vala"
		return result;
#line 6606 "number.c"
	}
#line 1369 "../lib/number.vala"
	_tmp4_ = value;
#line 1369 "../lib/number.vala"
	_tmp5_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 1369 "../lib/number.vala"
	_tmp6_ = _tmp5_;
#line 1369 "../lib/number.vala"
	_tmp7_ = number_equals (_tmp4_, _tmp6_);
#line 1369 "../lib/number.vala"
	_g_object_unref0 (_tmp6_);
#line 1369 "../lib/number.vala"
	if (_tmp7_) {
#line 6620 "number.c"
		Number* _tmp8_;
#line 1371 "../lib/number.vala"
		_tmp8_ = _g_object_ref0 (self);
#line 1371 "../lib/number.vala"
		factors = g_list_append (factors, _tmp8_);
#line 1372 "../lib/number.vala"
		result = factors;
#line 1372 "../lib/number.vala"
		_g_object_unref0 (value);
#line 1372 "../lib/number.vala"
		return result;
#line 6632 "number.c"
	}
#line 1375 "../lib/number.vala"
	_tmp9_ = value;
#line 1375 "../lib/number.vala"
	_tmp10_ = number_new_integer (0xFFFFFFFFLL, (gint64) 0);
#line 1375 "../lib/number.vala"
	_tmp11_ = _tmp10_;
#line 1375 "../lib/number.vala"
	_tmp12_ = number_compare (_tmp9_, _tmp11_) > 0;
#line 1375 "../lib/number.vala"
	_g_object_unref0 (_tmp11_);
#line 1375 "../lib/number.vala"
	if (_tmp12_) {
#line 6646 "number.c"
		Number* _tmp13_;
#line 1377 "../lib/number.vala"
		_tmp13_ = value;
#line 1377 "../lib/number.vala"
		if (number_is_prime (self, _tmp13_)) {
#line 6652 "number.c"
			Number* _tmp14_;
			Number* _tmp15_;
#line 1379 "../lib/number.vala"
			_tmp14_ = value;
#line 1379 "../lib/number.vala"
			_tmp15_ = _g_object_ref0 (_tmp14_);
#line 1379 "../lib/number.vala"
			factors = g_list_append (factors, _tmp15_);
#line 1380 "../lib/number.vala"
			result = factors;
#line 1380 "../lib/number.vala"
			_g_object_unref0 (value);
#line 1380 "../lib/number.vala"
			return result;
#line 6667 "number.c"
		}
	}
#line 1385 "../lib/number.vala"
	_tmp16_ = number_new_unsigned_integer ((guint64) 0xFFFFFFFFFFFFFFFFLL, (guint64) 0);
#line 1385 "../lib/number.vala"
	int_max = _tmp16_;
#line 1387 "../lib/number.vala"
	_tmp17_ = value;
#line 1387 "../lib/number.vala"
	_tmp18_ = int_max;
#line 1387 "../lib/number.vala"
	if (number_compare (_tmp17_, _tmp18_) <= 0) {
#line 6680 "number.c"
		GList* factors_int64 = NULL;
		Number* _tmp19_;
		GList* _tmp20_;
#line 1389 "../lib/number.vala"
		_tmp19_ = value;
#line 1389 "../lib/number.vala"
		_tmp20_ = number_factorize_uint64 (self, number_to_unsigned_integer (_tmp19_));
#line 1389 "../lib/number.vala"
		factors_int64 = _tmp20_;
#line 1390 "../lib/number.vala"
		if (number_is_negative (self)) {
#line 6692 "number.c"
			GList* _tmp21_;
			GList* _tmp22_;
			gconstpointer _tmp23_;
			Number* _tmp24_;
#line 1391 "../lib/number.vala"
			_tmp21_ = factors_int64;
#line 1391 "../lib/number.vala"
			_tmp22_ = factors_int64;
#line 1391 "../lib/number.vala"
			_tmp23_ = _tmp22_->data;
#line 1391 "../lib/number.vala"
			_tmp24_ = number_invert_sign ((Number*) _tmp23_);
#line 1391 "../lib/number.vala"
			_g_object_unref0 (_tmp21_->data);
#line 1391 "../lib/number.vala"
			_tmp21_->data = _tmp24_;
#line 6709 "number.c"
		}
#line 1392 "../lib/number.vala"
		result = factors_int64;
#line 1392 "../lib/number.vala"
		_g_object_unref0 (int_max);
#line 1392 "../lib/number.vala"
		_g_object_unref0 (value);
#line 1392 "../lib/number.vala"
		(factors == NULL) ? NULL : (factors = (_g_list_free__g_object_unref0_ (factors), NULL));
#line 1392 "../lib/number.vala"
		return result;
#line 6721 "number.c"
	}
#line 1395 "../lib/number.vala"
	_tmp25_ = number_new_integer ((gint64) 2, (gint64) 0);
#line 1395 "../lib/number.vala"
	divisor = _tmp25_;
#line 1396 "../lib/number.vala"
	while (TRUE) {
#line 6729 "number.c"
		Number* tmp = NULL;
		Number* _tmp26_;
		Number* _tmp27_;
		Number* _tmp28_;
		Number* _tmp29_;
#line 1398 "../lib/number.vala"
		_tmp26_ = value;
#line 1398 "../lib/number.vala"
		_tmp27_ = divisor;
#line 1398 "../lib/number.vala"
		_tmp28_ = number_divide (_tmp26_, _tmp27_);
#line 1398 "../lib/number.vala"
		tmp = _tmp28_;
#line 1399 "../lib/number.vala"
		_tmp29_ = tmp;
#line 1399 "../lib/number.vala"
		if (number_is_integer (_tmp29_)) {
#line 6747 "number.c"
			Number* _tmp30_;
			Number* _tmp31_;
			Number* _tmp32_;
			Number* _tmp33_;
#line 1401 "../lib/number.vala"
			_tmp30_ = tmp;
#line 1401 "../lib/number.vala"
			_tmp31_ = _g_object_ref0 (_tmp30_);
#line 1401 "../lib/number.vala"
			_g_object_unref0 (value);
#line 1401 "../lib/number.vala"
			value = _tmp31_;
#line 1402 "../lib/number.vala"
			_tmp32_ = divisor;
#line 1402 "../lib/number.vala"
			_tmp33_ = _g_object_ref0 (_tmp32_);
#line 1402 "../lib/number.vala"
			factors = g_list_append (factors, _tmp33_);
#line 6766 "number.c"
		} else {
#line 1405 "../lib/number.vala"
			_g_object_unref0 (tmp);
#line 1405 "../lib/number.vala"
			break;
#line 6772 "number.c"
		}
#line 1396 "../lib/number.vala"
		_g_object_unref0 (tmp);
#line 6776 "number.c"
	}
#line 1408 "../lib/number.vala"
	_tmp34_ = number_new_integer ((gint64) 3, (gint64) 0);
#line 1408 "../lib/number.vala"
	_g_object_unref0 (divisor);
#line 1408 "../lib/number.vala"
	divisor = _tmp34_;
#line 1409 "../lib/number.vala"
	_tmp35_ = value;
#line 1409 "../lib/number.vala"
	_tmp36_ = number_sqrt (_tmp35_);
#line 1409 "../lib/number.vala"
	root = _tmp36_;
#line 1410 "../lib/number.vala"
	while (TRUE) {
#line 6792 "number.c"
		Number* _tmp37_;
		Number* _tmp38_;
		Number* tmp = NULL;
		Number* _tmp39_;
		Number* _tmp40_;
		Number* _tmp41_;
		Number* _tmp42_;
#line 1410 "../lib/number.vala"
		_tmp37_ = divisor;
#line 1410 "../lib/number.vala"
		_tmp38_ = root;
#line 1410 "../lib/number.vala"
		if (!(number_compare (_tmp37_, _tmp38_) <= 0)) {
#line 1410 "../lib/number.vala"
			break;
#line 6808 "number.c"
		}
#line 1412 "../lib/number.vala"
		_tmp39_ = value;
#line 1412 "../lib/number.vala"
		_tmp40_ = divisor;
#line 1412 "../lib/number.vala"
		_tmp41_ = number_divide (_tmp39_, _tmp40_);
#line 1412 "../lib/number.vala"
		tmp = _tmp41_;
#line 1413 "../lib/number.vala"
		_tmp42_ = tmp;
#line 1413 "../lib/number.vala"
		if (number_is_integer (_tmp42_)) {
#line 6822 "number.c"
			Number* _tmp43_;
			Number* _tmp44_;
			Number* _tmp45_;
			Number* _tmp46_;
			Number* _tmp47_;
			Number* _tmp48_;
#line 1415 "../lib/number.vala"
			_tmp43_ = tmp;
#line 1415 "../lib/number.vala"
			_tmp44_ = _g_object_ref0 (_tmp43_);
#line 1415 "../lib/number.vala"
			_g_object_unref0 (value);
#line 1415 "../lib/number.vala"
			value = _tmp44_;
#line 1416 "../lib/number.vala"
			_tmp45_ = value;
#line 1416 "../lib/number.vala"
			_tmp46_ = number_sqrt (_tmp45_);
#line 1416 "../lib/number.vala"
			_g_object_unref0 (root);
#line 1416 "../lib/number.vala"
			root = _tmp46_;
#line 1417 "../lib/number.vala"
			_tmp47_ = divisor;
#line 1417 "../lib/number.vala"
			_tmp48_ = _g_object_ref0 (_tmp47_);
#line 1417 "../lib/number.vala"
			factors = g_list_append (factors, _tmp48_);
#line 6851 "number.c"
		} else {
			Number* _tmp49_;
			Number* _tmp50_;
			Number* _tmp51_;
			Number* _tmp52_;
			Number* _tmp53_;
			Number* _tmp54_;
#line 1421 "../lib/number.vala"
			_tmp49_ = divisor;
#line 1421 "../lib/number.vala"
			_tmp50_ = number_new_integer ((gint64) 2, (gint64) 0);
#line 1421 "../lib/number.vala"
			_tmp51_ = _tmp50_;
#line 1421 "../lib/number.vala"
			_tmp52_ = number_add (_tmp49_, _tmp51_);
#line 1421 "../lib/number.vala"
			_g_object_unref0 (tmp);
#line 1421 "../lib/number.vala"
			tmp = _tmp52_;
#line 1421 "../lib/number.vala"
			_g_object_unref0 (_tmp51_);
#line 1422 "../lib/number.vala"
			_tmp53_ = tmp;
#line 1422 "../lib/number.vala"
			_tmp54_ = _g_object_ref0 (_tmp53_);
#line 1422 "../lib/number.vala"
			_g_object_unref0 (divisor);
#line 1422 "../lib/number.vala"
			divisor = _tmp54_;
#line 6881 "number.c"
		}
#line 1410 "../lib/number.vala"
		_g_object_unref0 (tmp);
#line 6885 "number.c"
	}
#line 1426 "../lib/number.vala"
	_tmp55_ = value;
#line 1426 "../lib/number.vala"
	_tmp56_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 1426 "../lib/number.vala"
	_tmp57_ = _tmp56_;
#line 1426 "../lib/number.vala"
	_tmp58_ = number_compare (_tmp55_, _tmp57_) > 0;
#line 1426 "../lib/number.vala"
	_g_object_unref0 (_tmp57_);
#line 1426 "../lib/number.vala"
	if (_tmp58_) {
#line 6899 "number.c"
		Number* _tmp59_;
		Number* _tmp60_;
#line 1427 "../lib/number.vala"
		_tmp59_ = value;
#line 1427 "../lib/number.vala"
		_tmp60_ = _g_object_ref0 (_tmp59_);
#line 1427 "../lib/number.vala"
		factors = g_list_append (factors, _tmp60_);
#line 6908 "number.c"
	}
#line 1429 "../lib/number.vala"
	if (number_is_negative (self)) {
#line 6912 "number.c"
		GList* _tmp61_;
		GList* _tmp62_;
		gconstpointer _tmp63_;
		Number* _tmp64_;
#line 1430 "../lib/number.vala"
		_tmp61_ = factors;
#line 1430 "../lib/number.vala"
		_tmp62_ = factors;
#line 1430 "../lib/number.vala"
		_tmp63_ = _tmp62_->data;
#line 1430 "../lib/number.vala"
		_tmp64_ = number_invert_sign ((Number*) _tmp63_);
#line 1430 "../lib/number.vala"
		_g_object_unref0 (_tmp61_->data);
#line 1430 "../lib/number.vala"
		_tmp61_->data = _tmp64_;
#line 6929 "number.c"
	}
#line 1432 "../lib/number.vala"
	result = factors;
#line 1432 "../lib/number.vala"
	_g_object_unref0 (root);
#line 1432 "../lib/number.vala"
	_g_object_unref0 (divisor);
#line 1432 "../lib/number.vala"
	_g_object_unref0 (int_max);
#line 1432 "../lib/number.vala"
	_g_object_unref0 (value);
#line 1432 "../lib/number.vala"
	return result;
#line 6943 "number.c"
}

GList*
number_factorize_uint64 (Number* self,
                         guint64 n)
{
	GList* factors = NULL;
	GList* result;
#line 1435 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1437 "../lib/number.vala"
	factors = NULL;
#line 1438 "../lib/number.vala"
	while (TRUE) {
#line 6958 "number.c"
		Number* _tmp0_;
#line 1438 "../lib/number.vala"
		if (!((n % 2) == ((guint64) 0))) {
#line 1438 "../lib/number.vala"
			break;
#line 6964 "number.c"
		}
#line 1440 "../lib/number.vala"
		n = n / 2;
#line 1441 "../lib/number.vala"
		_tmp0_ = number_new_unsigned_integer ((guint64) 2, (guint64) 0);
#line 1441 "../lib/number.vala"
		factors = g_list_append (factors, _tmp0_);
#line 6972 "number.c"
	}
	{
		guint64 divisor = 0ULL;
#line 1444 "../lib/number.vala"
		divisor = (guint64) 3;
#line 6978 "number.c"
		{
			gboolean _tmp1_ = FALSE;
#line 1444 "../lib/number.vala"
			_tmp1_ = TRUE;
#line 1444 "../lib/number.vala"
			while (TRUE) {
#line 1444 "../lib/number.vala"
				if (!_tmp1_) {
#line 1444 "../lib/number.vala"
					divisor += (guint64) 2;
#line 6989 "number.c"
				}
#line 1444 "../lib/number.vala"
				_tmp1_ = FALSE;
#line 1444 "../lib/number.vala"
				if (!(divisor <= (n / divisor))) {
#line 1444 "../lib/number.vala"
					break;
#line 6997 "number.c"
				}
#line 1446 "../lib/number.vala"
				while (TRUE) {
#line 7001 "number.c"
					Number* _tmp2_;
#line 1446 "../lib/number.vala"
					if (!((n % divisor) == ((guint64) 0))) {
#line 1446 "../lib/number.vala"
						break;
#line 7007 "number.c"
					}
#line 1448 "../lib/number.vala"
					n = n / divisor;
#line 1449 "../lib/number.vala"
					_tmp2_ = number_new_unsigned_integer (divisor, (guint64) 0);
#line 1449 "../lib/number.vala"
					factors = g_list_append (factors, _tmp2_);
#line 7015 "number.c"
				}
			}
		}
	}
#line 1453 "../lib/number.vala"
	if (n > ((guint64) 1)) {
#line 7022 "number.c"
		Number* _tmp3_;
#line 1454 "../lib/number.vala"
		_tmp3_ = number_new_unsigned_integer (n, (guint64) 0);
#line 1454 "../lib/number.vala"
		factors = g_list_append (factors, _tmp3_);
#line 7028 "number.c"
	}
#line 1455 "../lib/number.vala"
	result = factors;
#line 1455 "../lib/number.vala"
	return result;
#line 7034 "number.c"
}

static Number*
number_copy (Number* self)
{
	Number* z = NULL;
	Number* _tmp0_;
	Number* result;
#line 1458 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1460 "../lib/number.vala"
	_tmp0_ = number_new ();
#line 1460 "../lib/number.vala"
	z = _tmp0_;
#line 1461 "../lib/number.vala"
	mpc_set (&z->priv->num, &self->priv->num, MPC_RNDNN);
#line 1462 "../lib/number.vala"
	result = z;
#line 1462 "../lib/number.vala"
	return result;
#line 7055 "number.c"
}

static gboolean
_mpc_equal (const __mpc_struct * s1,
            const __mpc_struct * s2)
{
#line 1473 "../lib/number.vala"
	if (s1 == s2) {
#line 1473 "../lib/number.vala"
		return TRUE;
#line 7066 "number.c"
	}
#line 1473 "../lib/number.vala"
	if (s1 == NULL) {
#line 1473 "../lib/number.vala"
		return FALSE;
#line 7072 "number.c"
	}
#line 1473 "../lib/number.vala"
	if (s2 == NULL) {
#line 1473 "../lib/number.vala"
		return FALSE;
#line 7078 "number.c"
	}
#line 1473 "../lib/number.vala"
	return FALSE;
#line 7082 "number.c"
}

static void
number_mpc_from_radians (__mpc_struct* res,
                         __mpc_struct* op,
                         AngleUnit unit)
{
	gint i = 0;
	__mpfr_struct scale = {0};
	mpfr_prec_t _tmp1_;
	mpfr_prec_t _tmp2_;
	__mpc_struct _tmp3_;
#line 1465 "../lib/number.vala"
	g_return_if_fail (res != NULL);
#line 1465 "../lib/number.vala"
	g_return_if_fail (op != NULL);
#line 1469 "../lib/number.vala"
	switch (unit) {
#line 7101 "number.c"
		default:
#line 1469 "../lib/number.vala"
		case ANGLE_UNIT_RADIANS:
#line 7105 "number.c"
		{
#line 1473 "../lib/number.vala"
			if (_mpc_equal (res, op) != TRUE) {
#line 7109 "number.c"
				__mpc_struct _tmp0_;
#line 1474 "../lib/number.vala"
				_tmp0_ = *op;
#line 1474 "../lib/number.vala"
				mpc_set (res, &_tmp0_, MPC_RNDNN);
#line 7115 "number.c"
			}
#line 1475 "../lib/number.vala"
			return;
#line 7119 "number.c"
		}
#line 1469 "../lib/number.vala"
		case ANGLE_UNIT_DEGREES:
#line 7123 "number.c"
		{
#line 1478 "../lib/number.vala"
			i = 180;
#line 1479 "../lib/number.vala"
			break;
#line 7129 "number.c"
		}
#line 1469 "../lib/number.vala"
		case ANGLE_UNIT_GRADIANS:
#line 7133 "number.c"
		{
#line 1482 "../lib/number.vala"
			i = 200;
#line 1483 "../lib/number.vala"
			break;
#line 7139 "number.c"
		}
	}
#line 1485 "../lib/number.vala"
	_tmp1_ = number_get_precision ();
#line 1485 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 1485 "../lib/number.vala"
	mpfr_init2 (&scale, _tmp2_);
#line 1486 "../lib/number.vala"
	mpfr_const_pi (&scale, MPFR_RNDN);
#line 1487 "../lib/number.vala"
	mpfr_si_div (&scale, (glong) i, &scale, MPFR_RNDN);
#line 1488 "../lib/number.vala"
	_tmp3_ = *op;
#line 1488 "../lib/number.vala"
	mpc_mul_fr (res, &_tmp3_, &scale, MPC_RNDNN);
#line 1465 "../lib/number.vala"
	mpfr_clear (&scale);
#line 7158 "number.c"
}

static void
number_mpc_to_radians (__mpc_struct* res,
                       __mpc_struct* op,
                       AngleUnit unit)
{
	gint i = 0;
	__mpfr_struct scale = {0};
	mpfr_prec_t _tmp1_;
	mpfr_prec_t _tmp2_;
	__mpc_struct _tmp3_;
#line 1491 "../lib/number.vala"
	g_return_if_fail (res != NULL);
#line 1491 "../lib/number.vala"
	g_return_if_fail (op != NULL);
#line 1495 "../lib/number.vala"
	switch (unit) {
#line 7177 "number.c"
		default:
#line 1495 "../lib/number.vala"
		case ANGLE_UNIT_RADIANS:
#line 7181 "number.c"
		{
#line 1499 "../lib/number.vala"
			if (_mpc_equal (res, op) != TRUE) {
#line 7185 "number.c"
				__mpc_struct _tmp0_;
#line 1500 "../lib/number.vala"
				_tmp0_ = *op;
#line 1500 "../lib/number.vala"
				mpc_set (res, &_tmp0_, MPC_RNDNN);
#line 7191 "number.c"
			}
#line 1501 "../lib/number.vala"
			return;
#line 7195 "number.c"
		}
#line 1495 "../lib/number.vala"
		case ANGLE_UNIT_DEGREES:
#line 7199 "number.c"
		{
#line 1504 "../lib/number.vala"
			i = 180;
#line 1505 "../lib/number.vala"
			break;
#line 7205 "number.c"
		}
#line 1495 "../lib/number.vala"
		case ANGLE_UNIT_GRADIANS:
#line 7209 "number.c"
		{
#line 1508 "../lib/number.vala"
			i = 200;
#line 1509 "../lib/number.vala"
			break;
#line 7215 "number.c"
		}
	}
#line 1511 "../lib/number.vala"
	_tmp1_ = number_get_precision ();
#line 1511 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 1511 "../lib/number.vala"
	mpfr_init2 (&scale, _tmp2_);
#line 1512 "../lib/number.vala"
	mpfr_const_pi (&scale, MPFR_RNDN);
#line 1513 "../lib/number.vala"
	mpfr_div_si (&scale, &scale, (glong) i, MPFR_RNDN);
#line 1514 "../lib/number.vala"
	_tmp3_ = *op;
#line 1514 "../lib/number.vala"
	mpc_mul_fr (res, &_tmp3_, &scale, MPC_RNDNN);
#line 1491 "../lib/number.vala"
	mpfr_clear (&scale);
#line 7234 "number.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
#line 1283 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1284 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1284 "glib-2.0.vapi"
	result = _tmp0_;
#line 1284 "glib-2.0.vapi"
	return result;
#line 7251 "number.c"
}

static Number*
number_bitwise (Number* self,
                Number* y,
                BitwiseFunc bitwise_operator,
                gpointer bitwise_operator_target,
                gint wordlen)
{
	gchar* text1 = NULL;
	gchar* _tmp0_;
	gchar* text2 = NULL;
	gchar* _tmp1_;
	gint offset1 = 0;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint offset2 = 0;
	const gchar* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint offset_out = 0;
	gboolean _tmp9_ = FALSE;
	gchar* text_out = NULL;
	gchar* _tmp12_;
	gint text_out_length1;
	gint _text_out_size_;
	gchar* _tmp22_;
	gint _tmp22__length1;
	Number* _tmp23_;
	Number* result;
#line 1517 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1517 "../lib/number.vala"
	g_return_val_if_fail (y != NULL, NULL);
#line 1519 "../lib/number.vala"
	_tmp0_ = number_to_hex_string (self);
#line 1519 "../lib/number.vala"
	text1 = _tmp0_;
#line 1520 "../lib/number.vala"
	_tmp1_ = number_to_hex_string (y);
#line 1520 "../lib/number.vala"
	text2 = _tmp1_;
#line 1521 "../lib/number.vala"
	_tmp2_ = text1;
#line 1521 "../lib/number.vala"
	_tmp3_ = strlen (_tmp2_);
#line 1521 "../lib/number.vala"
	_tmp4_ = _tmp3_;
#line 1521 "../lib/number.vala"
	offset1 = _tmp4_ - 1;
#line 1522 "../lib/number.vala"
	_tmp5_ = text2;
#line 1522 "../lib/number.vala"
	_tmp6_ = strlen (_tmp5_);
#line 1522 "../lib/number.vala"
	_tmp7_ = _tmp6_;
#line 1522 "../lib/number.vala"
	offset2 = _tmp7_ - 1;
#line 1523 "../lib/number.vala"
	offset_out = (wordlen / 4) - 1;
#line 1524 "../lib/number.vala"
	if (offset_out <= 0) {
#line 7315 "number.c"
		gint _tmp8_ = 0;
#line 1525 "../lib/number.vala"
		if (offset1 > offset2) {
#line 1525 "../lib/number.vala"
			_tmp8_ = offset1;
#line 7321 "number.c"
		} else {
#line 1525 "../lib/number.vala"
			_tmp8_ = offset2;
#line 7325 "number.c"
		}
#line 1525 "../lib/number.vala"
		offset_out = _tmp8_;
#line 7329 "number.c"
	}
#line 1526 "../lib/number.vala"
	if (offset_out > 0) {
#line 7333 "number.c"
		gboolean _tmp10_ = FALSE;
#line 1526 "../lib/number.vala"
		if (offset_out < offset1) {
#line 1526 "../lib/number.vala"
			_tmp10_ = TRUE;
#line 7339 "number.c"
		} else {
#line 1526 "../lib/number.vala"
			_tmp10_ = offset_out < offset2;
#line 7343 "number.c"
		}
#line 1526 "../lib/number.vala"
		_tmp9_ = _tmp10_;
#line 7347 "number.c"
	} else {
#line 1526 "../lib/number.vala"
		_tmp9_ = FALSE;
#line 7351 "number.c"
	}
#line 1526 "../lib/number.vala"
	if (_tmp9_) {
#line 7355 "number.c"
		Number* _tmp11_;
#line 1528 "../lib/number.vala"
		number_set_error ("Overflow. Try a bigger word size");
#line 1529 "../lib/number.vala"
		_tmp11_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1529 "../lib/number.vala"
		result = _tmp11_;
#line 1529 "../lib/number.vala"
		_g_free0 (text2);
#line 1529 "../lib/number.vala"
		_g_free0 (text1);
#line 1529 "../lib/number.vala"
		return result;
#line 7369 "number.c"
	}
#line 1532 "../lib/number.vala"
	_tmp12_ = g_new0 (gchar, offset_out + 2);
#line 1532 "../lib/number.vala"
	text_out = _tmp12_;
#line 1532 "../lib/number.vala"
	text_out_length1 = offset_out + 2;
#line 1532 "../lib/number.vala"
	_text_out_size_ = text_out_length1;
#line 7379 "number.c"
	{
		gchar* _tmp13_;
		gint _tmp13__length1;
		gboolean _tmp14_ = FALSE;
#line 1535 "../lib/number.vala"
		_tmp13_ = text_out;
#line 1535 "../lib/number.vala"
		_tmp13__length1 = text_out_length1;
#line 1535 "../lib/number.vala"
		_tmp13_[offset_out + 1] = '\0';
#line 1535 "../lib/number.vala"
		_tmp14_ = TRUE;
#line 1535 "../lib/number.vala"
		while (TRUE) {
#line 7394 "number.c"
			gint v1 = 0;
			gint v2 = 0;
#line 1538 "../lib/number.vala"
			static const gchar digits[16] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};
#line 7399 "number.c"
			gchar* _tmp20_;
			gint _tmp20__length1;
			gchar _tmp21_;
#line 1535 "../lib/number.vala"
			if (!_tmp14_) {
#line 7405 "number.c"
				gint _tmp15_;
#line 1535 "../lib/number.vala"
				_tmp15_ = offset_out;
#line 1535 "../lib/number.vala"
				offset_out = _tmp15_ - 1;
#line 7411 "number.c"
			}
#line 1535 "../lib/number.vala"
			_tmp14_ = FALSE;
#line 1535 "../lib/number.vala"
			if (!(offset_out >= 0)) {
#line 1535 "../lib/number.vala"
				break;
#line 7419 "number.c"
			}
#line 1537 "../lib/number.vala"
			v1 = 0;
#line 1537 "../lib/number.vala"
			v2 = 0;
#line 1540 "../lib/number.vala"
			if (offset1 >= 0) {
#line 7427 "number.c"
				const gchar* _tmp16_;
				gint _tmp17_;
#line 1542 "../lib/number.vala"
				_tmp16_ = text1;
#line 1542 "../lib/number.vala"
				v1 = number_hex_to_int (self, string_get (_tmp16_, (glong) offset1));
#line 1543 "../lib/number.vala"
				_tmp17_ = offset1;
#line 1543 "../lib/number.vala"
				offset1 = _tmp17_ - 1;
#line 7438 "number.c"
			}
#line 1545 "../lib/number.vala"
			if (offset2 >= 0) {
#line 7442 "number.c"
				const gchar* _tmp18_;
				gint _tmp19_;
#line 1547 "../lib/number.vala"
				_tmp18_ = text2;
#line 1547 "../lib/number.vala"
				v2 = number_hex_to_int (self, string_get (_tmp18_, (glong) offset2));
#line 1548 "../lib/number.vala"
				_tmp19_ = offset2;
#line 1548 "../lib/number.vala"
				offset2 = _tmp19_ - 1;
#line 7453 "number.c"
			}
#line 1550 "../lib/number.vala"
			_tmp20_ = text_out;
#line 1550 "../lib/number.vala"
			_tmp20__length1 = text_out_length1;
#line 1550 "../lib/number.vala"
			_tmp21_ = digits[bitwise_operator (v1, v2, bitwise_operator_target)];
#line 1550 "../lib/number.vala"
			_tmp20_[offset_out] = _tmp21_;
#line 7463 "number.c"
		}
	}
#line 1553 "../lib/number.vala"
	_tmp22_ = text_out;
#line 1553 "../lib/number.vala"
	_tmp22__length1 = text_out_length1;
#line 1553 "../lib/number.vala"
	_tmp23_ = mp_set_from_string ((const gchar*) _tmp22_, 16, FALSE);
#line 1553 "../lib/number.vala"
	result = _tmp23_;
#line 1553 "../lib/number.vala"
	text_out = (g_free (text_out), NULL);
#line 1553 "../lib/number.vala"
	_g_free0 (text2);
#line 1553 "../lib/number.vala"
	_g_free0 (text1);
#line 1553 "../lib/number.vala"
	return result;
#line 7482 "number.c"
}

static gint
number_hex_to_int (Number* self,
                   gchar digit)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gint result;
#line 1556 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1558 "../lib/number.vala"
	if (digit >= '0') {
#line 1558 "../lib/number.vala"
		_tmp0_ = digit <= '9';
#line 7499 "number.c"
	} else {
#line 1558 "../lib/number.vala"
		_tmp0_ = FALSE;
#line 7503 "number.c"
	}
#line 1558 "../lib/number.vala"
	if (_tmp0_) {
#line 1559 "../lib/number.vala"
		result = (gint) (digit - '0');
#line 1559 "../lib/number.vala"
		return result;
#line 7511 "number.c"
	}
#line 1560 "../lib/number.vala"
	if (digit >= 'A') {
#line 1560 "../lib/number.vala"
		_tmp1_ = digit <= 'F';
#line 7517 "number.c"
	} else {
#line 1560 "../lib/number.vala"
		_tmp1_ = FALSE;
#line 7521 "number.c"
	}
#line 1560 "../lib/number.vala"
	if (_tmp1_) {
#line 1561 "../lib/number.vala"
		result = (digit - 'A') + 10;
#line 1561 "../lib/number.vala"
		return result;
#line 7529 "number.c"
	}
#line 1562 "../lib/number.vala"
	if (digit >= 'a') {
#line 1562 "../lib/number.vala"
		_tmp2_ = digit <= 'f';
#line 7535 "number.c"
	} else {
#line 1562 "../lib/number.vala"
		_tmp2_ = FALSE;
#line 7539 "number.c"
	}
#line 1562 "../lib/number.vala"
	if (_tmp2_) {
#line 1563 "../lib/number.vala"
		result = (digit - 'a') + 10;
#line 1563 "../lib/number.vala"
		return result;
#line 7547 "number.c"
	}
#line 1564 "../lib/number.vala"
	result = 0;
#line 1564 "../lib/number.vala"
	return result;
#line 7553 "number.c"
}

static gchar*
number_to_hex_string (Number* self)
{
	Serializer* serializer = NULL;
	Serializer* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 1567 "../lib/number.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1569 "../lib/number.vala"
	_tmp0_ = serializer_new (DISPLAY_FORMAT_FIXED, 16, 0);
#line 1569 "../lib/number.vala"
	serializer = _tmp0_;
#line 1570 "../lib/number.vala"
	_tmp1_ = serializer_to_string (serializer, self);
#line 1570 "../lib/number.vala"
	result = _tmp1_;
#line 1570 "../lib/number.vala"
	_g_object_unref0 (serializer);
#line 1570 "../lib/number.vala"
	return result;
#line 7577 "number.c"
}

Number*
number_construct (GType object_type)
{
	Number * self = NULL;
#line 41 "../lib/number.vala"
	self = (Number*) g_object_new (object_type, NULL);
#line 41 "../lib/number.vala"
	return self;
#line 7588 "number.c"
}

Number*
number_new (void)
{
#line 41 "../lib/number.vala"
	return number_construct (TYPE_NUMBER);
#line 7596 "number.c"
}

mpfr_prec_t
number_get_precision (void)
{
	mpfr_prec_t result;
#line 46 "../lib/number.vala"
	result = number__precision;
#line 46 "../lib/number.vala"
	return result;
#line 7607 "number.c"
}

void
number_set_precision (mpfr_prec_t value)
{
#line 46 "../lib/number.vala"
	number__precision = value;
#line 7615 "number.c"
}

const gchar*
number_get_error (void)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 49 "../lib/number.vala"
	_tmp0_ = number__error;
#line 49 "../lib/number.vala"
	result = _tmp0_;
#line 49 "../lib/number.vala"
	return result;
#line 7629 "number.c"
}

void
number_set_error (const gchar* value)
{
	gchar* _tmp0_;
#line 49 "../lib/number.vala"
	_tmp0_ = g_strdup (value);
#line 49 "../lib/number.vala"
	_g_free0 (number__error);
#line 49 "../lib/number.vala"
	number__error = _tmp0_;
#line 7642 "number.c"
}

static void
number_class_init (NumberClass * klass,
                   gpointer klass_data)
{
#line 41 "../lib/number.vala"
	number_parent_class = g_type_class_peek_parent (klass);
#line 41 "../lib/number.vala"
	g_type_class_adjust_private_offset (klass, &Number_private_offset);
#line 41 "../lib/number.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_number_get_property;
#line 41 "../lib/number.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_number_set_property;
#line 41 "../lib/number.vala"
	G_OBJECT_CLASS (klass)->finalize = number_finalize;
#line 7659 "number.c"
}

static void
number_instance_init (Number * self,
                      gpointer klass)
{
	mpfr_prec_t _tmp0_;
	mpfr_prec_t _tmp1_;
#line 41 "../lib/number.vala"
	self->priv = number_get_instance_private (self);
#line 44 "../lib/number.vala"
	_tmp0_ = number_get_precision ();
#line 44 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 44 "../lib/number.vala"
	mpc_init2 (&self->priv->num, _tmp1_);
#line 7676 "number.c"
}

static void
number_finalize (GObject * obj)
{
	Number * self;
#line 41 "../lib/number.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NUMBER, Number);
#line 44 "../lib/number.vala"
	mpc_clear (&self->priv->num);
#line 41 "../lib/number.vala"
	G_OBJECT_CLASS (number_parent_class)->finalize (obj);
#line 7689 "number.c"
}

static GType
number_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NumberClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) number_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Number), 0, (GInstanceInitFunc) number_instance_init, NULL };
	GType number_type_id;
	number_type_id = g_type_register_static (G_TYPE_OBJECT, "Number", &g_define_type_info, 0);
	Number_private_offset = g_type_add_instance_private (number_type_id, sizeof (NumberPrivate));
	return number_type_id;
}

GType
number_get_type (void)
{
	static volatile gsize number_type_id__once = 0;
	if (g_once_init_enter (&number_type_id__once)) {
		GType number_type_id;
		number_type_id = number_get_type_once ();
		g_once_init_leave (&number_type_id__once, number_type_id);
	}
	return number_type_id__once;
}

static void
_vala_number_get_property (GObject * object,
                           guint property_id,
                           GValue * value,
                           GParamSpec * pspec)
{
	Number * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NUMBER, Number);
#line 41 "../lib/number.vala"
	switch (property_id) {
#line 7724 "number.c"
		default:
#line 41 "../lib/number.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 41 "../lib/number.vala"
		break;
#line 7730 "number.c"
	}
}

static void
_vala_number_set_property (GObject * object,
                           guint property_id,
                           const GValue * value,
                           GParamSpec * pspec)
{
	Number * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_NUMBER, Number);
#line 41 "../lib/number.vala"
	switch (property_id) {
#line 7744 "number.c"
		default:
#line 41 "../lib/number.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 41 "../lib/number.vala"
		break;
#line 7750 "number.c"
	}
}

gint
parse_literal_prefix (const gchar* str,
                      gint* prefix_len)
{
	gint new_base = 0;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gchar prefix = '\0';
	gint result;
#line 1574 "../lib/number.vala"
	g_return_val_if_fail (str != NULL, 0);
#line 1576 "../lib/number.vala"
	new_base = 0;
#line 1578 "../lib/number.vala"
	_tmp1_ = strlen (str);
#line 1578 "../lib/number.vala"
	_tmp2_ = _tmp1_;
#line 1578 "../lib/number.vala"
	if (_tmp2_ < 3) {
#line 1578 "../lib/number.vala"
		_tmp0_ = TRUE;
#line 7776 "number.c"
	} else {
#line 1578 "../lib/number.vala"
		_tmp0_ = string_get (str, (glong) 0) != '0';
#line 7780 "number.c"
	}
#line 1578 "../lib/number.vala"
	if (_tmp0_) {
#line 1579 "../lib/number.vala"
		result = new_base;
#line 1579 "../lib/number.vala"
		return result;
#line 7788 "number.c"
	}
#line 1581 "../lib/number.vala"
	prefix = g_ascii_tolower (string_get (str, (glong) 1));
#line 1583 "../lib/number.vala"
	if (prefix == 'b') {
#line 1584 "../lib/number.vala"
		new_base = 2;
#line 7796 "number.c"
	} else {
#line 1585 "../lib/number.vala"
		if (prefix == 'o') {
#line 1586 "../lib/number.vala"
			new_base = 8;
#line 7802 "number.c"
		} else {
#line 1587 "../lib/number.vala"
			if (prefix == 'x') {
#line 1588 "../lib/number.vala"
				new_base = 16;
#line 7808 "number.c"
			}
		}
	}
#line 1590 "../lib/number.vala"
	if (new_base != 0) {
#line 1591 "../lib/number.vala"
		*prefix_len = 2;
#line 7816 "number.c"
	}
#line 1593 "../lib/number.vala"
	result = new_base;
#line 1593 "../lib/number.vala"
	return result;
#line 7822 "number.c"
}

static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint result;
#line 1204 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1205 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1205 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1207 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1207 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 7844 "number.c"
		gchar* _tmp2_;
#line 1208 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1208 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1208 "glib-2.0.vapi"
		return result;
#line 7852 "number.c"
	} else {
#line 1210 "glib-2.0.vapi"
		result = -1;
#line 1210 "glib-2.0.vapi"
		return result;
#line 7858 "number.c"
	}
}

static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result;
#line 1302 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1303 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1304 "glib-2.0.vapi"
	if (_vala_c != ((gunichar) 0)) {
#line 7875 "number.c"
		gchar* _tmp0_;
#line 1305 "glib-2.0.vapi"
		_tmp0_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1305 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1306 "glib-2.0.vapi"
		result = TRUE;
#line 1306 "glib-2.0.vapi"
		if (c) {
#line 1306 "glib-2.0.vapi"
			*c = _vala_c;
#line 7887 "number.c"
		}
#line 1306 "glib-2.0.vapi"
		return result;
#line 7891 "number.c"
	} else {
#line 1308 "glib-2.0.vapi"
		result = FALSE;
#line 1308 "glib-2.0.vapi"
		if (c) {
#line 1308 "glib-2.0.vapi"
			*c = _vala_c;
#line 7899 "number.c"
		}
#line 1308 "glib-2.0.vapi"
		return result;
#line 7903 "number.c"
	}
}

static gboolean
string_get_prev_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result;
#line 1341 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1342 "glib-2.0.vapi"
	if (0 < (*index)) {
#line 7918 "number.c"
		gchar* _tmp0_;
#line 1343 "glib-2.0.vapi"
		_tmp0_ = g_utf8_prev_char (((gchar*) self) + (*index));
#line 1343 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1344 "glib-2.0.vapi"
		_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1345 "glib-2.0.vapi"
		result = TRUE;
#line 1345 "glib-2.0.vapi"
		if (c) {
#line 1345 "glib-2.0.vapi"
			*c = _vala_c;
#line 7932 "number.c"
		}
#line 1345 "glib-2.0.vapi"
		return result;
#line 7936 "number.c"
	} else {
#line 1347 "glib-2.0.vapi"
		_vala_c = (gunichar) 0;
#line 1348 "glib-2.0.vapi"
		result = FALSE;
#line 1348 "glib-2.0.vapi"
		if (c) {
#line 1348 "glib-2.0.vapi"
			*c = _vala_c;
#line 7946 "number.c"
		}
#line 1348 "glib-2.0.vapi"
		return result;
#line 7950 "number.c"
	}
}

Number*
mp_set_from_string (const gchar* str,
                    gint default_base,
                    gboolean may_have_prefix)
{
#line 1607 "../lib/number.vala"
	static const gunichar base_digits[10] = {8320U, 8321U, 8322U, 8323U, 8324U, 8325U, 8326U, 8327U, 8328U, 8329U};
#line 7961 "number.c"
	gint index = 0;
	gint base_prefix = 0;
	gunichar c = 0U;
	gint end = 0;
	gint number_base = 0;
	gint literal_base = 0;
	gint base_multiplier = 0;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean negate = FALSE;
	gunichar _tmp12_ = 0U;
	Number* z = NULL;
	Number* _tmp15_;
#line 1673 "../lib/number.vala"
	static const gunichar fractions[15] = {189U, 8531U, 8532U, 188U, 190U, 8533U, 8534U, 8535U, 8536U, 8537U, 8538U, 8539U, 8540U, 8541U, 8542U};
#line 1674 "../lib/number.vala"
	static const gint numerators[15] = {1, 1, 2, 1, 3, 1, 2, 3, 4, 1, 5, 1, 3, 5, 7};
#line 1675 "../lib/number.vala"
	static const gint denominators[15] = {2, 3, 3, 4, 4, 5, 5, 5, 5, 6, 6, 8, 8, 8, 8};
#line 7981 "number.c"
	gboolean has_fraction = FALSE;
	gunichar _tmp25_ = 0U;
	gboolean _tmp26_;
	Number* result;
#line 1601 "../lib/number.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 1603 "../lib/number.vala"
	if (string_index_of_char (str, 176U, 0) >= 0) {
#line 7990 "number.c"
		Number* _tmp0_;
#line 1604 "../lib/number.vala"
		_tmp0_ = set_from_sexagesimal (str);
#line 1604 "../lib/number.vala"
		result = _tmp0_;
#line 1604 "../lib/number.vala"
		return result;
#line 7998 "number.c"
	}
#line 1608 "../lib/number.vala"
	index = 0;
#line 1609 "../lib/number.vala"
	base_prefix = 0;
#line 1611 "../lib/number.vala"
	while (TRUE) {
#line 8006 "number.c"
		gunichar _tmp1_ = 0U;
		gboolean _tmp2_;
#line 1611 "../lib/number.vala"
		_tmp2_ = string_get_next_char (str, &index, &_tmp1_);
#line 1611 "../lib/number.vala"
		c = _tmp1_;
#line 1611 "../lib/number.vala"
		if (!_tmp2_) {
#line 1611 "../lib/number.vala"
			break;
#line 8017 "number.c"
		}
	}
#line 1612 "../lib/number.vala"
	end = index;
#line 1613 "../lib/number.vala"
	number_base = 0;
#line 1614 "../lib/number.vala"
	literal_base = 0;
#line 1615 "../lib/number.vala"
	base_multiplier = 1;
#line 1616 "../lib/number.vala"
	while (TRUE) {
#line 8030 "number.c"
		gunichar _tmp3_ = 0U;
		gboolean _tmp4_;
		gint value = 0;
#line 1616 "../lib/number.vala"
		_tmp4_ = string_get_prev_char (str, &index, &_tmp3_);
#line 1616 "../lib/number.vala"
		c = _tmp3_;
#line 1616 "../lib/number.vala"
		if (!_tmp4_) {
#line 1616 "../lib/number.vala"
			break;
#line 8042 "number.c"
		}
#line 1618 "../lib/number.vala"
		value = -1;
#line 8046 "number.c"
		{
			gint i = 0;
#line 1619 "../lib/number.vala"
			i = 0;
#line 8051 "number.c"
			{
				gboolean _tmp5_ = FALSE;
#line 1619 "../lib/number.vala"
				_tmp5_ = TRUE;
#line 1619 "../lib/number.vala"
				while (TRUE) {
#line 8058 "number.c"
					gunichar _tmp7_;
#line 1619 "../lib/number.vala"
					if (!_tmp5_) {
#line 8062 "number.c"
						gint _tmp6_;
#line 1619 "../lib/number.vala"
						_tmp6_ = i;
#line 1619 "../lib/number.vala"
						i = _tmp6_ + 1;
#line 8068 "number.c"
					}
#line 1619 "../lib/number.vala"
					_tmp5_ = FALSE;
#line 1619 "../lib/number.vala"
					if (!(i < G_N_ELEMENTS (base_digits))) {
#line 1619 "../lib/number.vala"
						break;
#line 8076 "number.c"
					}
#line 1621 "../lib/number.vala"
					_tmp7_ = base_digits[i];
#line 1621 "../lib/number.vala"
					if (c == _tmp7_) {
#line 1623 "../lib/number.vala"
						value = i;
#line 1624 "../lib/number.vala"
						break;
#line 8086 "number.c"
					}
				}
			}
		}
#line 1627 "../lib/number.vala"
		if (value < 0) {
#line 1628 "../lib/number.vala"
			break;
#line 8095 "number.c"
		}
#line 1630 "../lib/number.vala"
		end = index;
#line 1631 "../lib/number.vala"
		number_base += value * base_multiplier;
#line 1632 "../lib/number.vala"
		base_multiplier *= 10;
#line 8103 "number.c"
	}
#line 1635 "../lib/number.vala"
	if (may_have_prefix) {
#line 8107 "number.c"
		gint _tmp8_;
#line 1636 "../lib/number.vala"
		_tmp8_ = parse_literal_prefix (str, &base_prefix);
#line 1636 "../lib/number.vala"
		literal_base = _tmp8_;
#line 8113 "number.c"
	}
#line 1638 "../lib/number.vala"
	if (number_base != 0) {
#line 1638 "../lib/number.vala"
		_tmp10_ = literal_base != 0;
#line 8119 "number.c"
	} else {
#line 1638 "../lib/number.vala"
		_tmp10_ = FALSE;
#line 8123 "number.c"
	}
#line 1638 "../lib/number.vala"
	if (_tmp10_) {
#line 1638 "../lib/number.vala"
		_tmp9_ = literal_base != number_base;
#line 8129 "number.c"
	} else {
#line 1638 "../lib/number.vala"
		_tmp9_ = FALSE;
#line 8133 "number.c"
	}
#line 1638 "../lib/number.vala"
	if (_tmp9_) {
#line 1639 "../lib/number.vala"
		result = NULL;
#line 1639 "../lib/number.vala"
		return result;
#line 8141 "number.c"
	}
#line 1641 "../lib/number.vala"
	if (number_base == 0) {
#line 8145 "number.c"
		gint _tmp11_ = 0;
#line 1642 "../lib/number.vala"
		if (literal_base != 0) {
#line 1642 "../lib/number.vala"
			_tmp11_ = literal_base;
#line 8151 "number.c"
		} else {
#line 1642 "../lib/number.vala"
			_tmp11_ = default_base;
#line 8155 "number.c"
		}
#line 1642 "../lib/number.vala"
		number_base = _tmp11_;
#line 8159 "number.c"
	}
#line 1645 "../lib/number.vala"
	negate = FALSE;
#line 1646 "../lib/number.vala"
	index = base_prefix;
#line 1647 "../lib/number.vala"
	string_get_next_char (str, &index, &_tmp12_);
#line 1647 "../lib/number.vala"
	c = _tmp12_;
#line 1648 "../lib/number.vala"
	if (c == ((gunichar) '+')) {
#line 1649 "../lib/number.vala"
		negate = FALSE;
#line 8173 "number.c"
	} else {
		gboolean _tmp13_ = FALSE;
#line 1650 "../lib/number.vala"
		if (c == ((gunichar) '-')) {
#line 1650 "../lib/number.vala"
			_tmp13_ = TRUE;
#line 8180 "number.c"
		} else {
#line 1650 "../lib/number.vala"
			_tmp13_ = c == 8722U;
#line 8184 "number.c"
		}
#line 1650 "../lib/number.vala"
		if (_tmp13_) {
#line 1651 "../lib/number.vala"
			negate = TRUE;
#line 8190 "number.c"
		} else {
			gunichar _tmp14_ = 0U;
#line 1653 "../lib/number.vala"
			string_get_prev_char (str, &index, &_tmp14_);
#line 1653 "../lib/number.vala"
			c = _tmp14_;
#line 8197 "number.c"
		}
	}
#line 1656 "../lib/number.vala"
	_tmp15_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1656 "../lib/number.vala"
	z = _tmp15_;
#line 1658 "../lib/number.vala"
	while (TRUE) {
#line 8206 "number.c"
		gunichar _tmp16_ = 0U;
		gboolean _tmp17_;
		gint i = 0;
		Number* _tmp19_;
		Number* _tmp20_;
		Number* _tmp21_;
		Number* _tmp22_;
		Number* _tmp23_;
		Number* _tmp24_;
#line 1658 "../lib/number.vala"
		_tmp17_ = string_get_next_char (str, &index, &_tmp16_);
#line 1658 "../lib/number.vala"
		c = _tmp16_;
#line 1658 "../lib/number.vala"
		if (!_tmp17_) {
#line 1658 "../lib/number.vala"
			break;
#line 8224 "number.c"
		}
#line 1660 "../lib/number.vala"
		i = char_val (c, number_base);
#line 1661 "../lib/number.vala"
		if (i > number_base) {
#line 1662 "../lib/number.vala"
			result = NULL;
#line 1662 "../lib/number.vala"
			_g_object_unref0 (z);
#line 1662 "../lib/number.vala"
			return result;
#line 8236 "number.c"
		}
#line 1663 "../lib/number.vala"
		if (i < 0) {
#line 8240 "number.c"
			gunichar _tmp18_ = 0U;
#line 1665 "../lib/number.vala"
			string_get_prev_char (str, &index, &_tmp18_);
#line 1665 "../lib/number.vala"
			c = _tmp18_;
#line 1666 "../lib/number.vala"
			break;
#line 8248 "number.c"
		}
#line 1669 "../lib/number.vala"
		_tmp19_ = z;
#line 1669 "../lib/number.vala"
		_tmp20_ = number_multiply_integer (_tmp19_, (gint64) number_base);
#line 1669 "../lib/number.vala"
		_tmp21_ = _tmp20_;
#line 1669 "../lib/number.vala"
		_tmp22_ = number_new_integer ((gint64) i, (gint64) 0);
#line 1669 "../lib/number.vala"
		_tmp23_ = _tmp22_;
#line 1669 "../lib/number.vala"
		_tmp24_ = number_add (_tmp21_, _tmp23_);
#line 1669 "../lib/number.vala"
		_g_object_unref0 (z);
#line 1669 "../lib/number.vala"
		z = _tmp24_;
#line 1669 "../lib/number.vala"
		_g_object_unref0 (_tmp23_);
#line 1669 "../lib/number.vala"
		_g_object_unref0 (_tmp21_);
#line 8270 "number.c"
	}
#line 1676 "../lib/number.vala"
	has_fraction = FALSE;
#line 1677 "../lib/number.vala"
	_tmp26_ = string_get_next_char (str, &index, &_tmp25_);
#line 1677 "../lib/number.vala"
	c = _tmp25_;
#line 1677 "../lib/number.vala"
	if (_tmp26_) {
#line 8280 "number.c"
		{
			gint i = 0;
#line 1679 "../lib/number.vala"
			i = 0;
#line 8285 "number.c"
			{
				gboolean _tmp27_ = FALSE;
#line 1679 "../lib/number.vala"
				_tmp27_ = TRUE;
#line 1679 "../lib/number.vala"
				while (TRUE) {
#line 8292 "number.c"
					gunichar _tmp29_;
#line 1679 "../lib/number.vala"
					if (!_tmp27_) {
#line 8296 "number.c"
						gint _tmp28_;
#line 1679 "../lib/number.vala"
						_tmp28_ = i;
#line 1679 "../lib/number.vala"
						i = _tmp28_ + 1;
#line 8302 "number.c"
					}
#line 1679 "../lib/number.vala"
					_tmp27_ = FALSE;
#line 1679 "../lib/number.vala"
					if (!(i < G_N_ELEMENTS (fractions))) {
#line 1679 "../lib/number.vala"
						break;
#line 8310 "number.c"
					}
#line 1681 "../lib/number.vala"
					_tmp29_ = fractions[i];
#line 1681 "../lib/number.vala"
					if (c == _tmp29_) {
#line 8316 "number.c"
						Number* fraction = NULL;
						gint _tmp30_;
						gint _tmp31_;
						Number* _tmp32_;
						Number* _tmp33_;
						Number* _tmp34_;
						Number* _tmp35_;
						gunichar _tmp36_ = 0U;
						gboolean _tmp37_;
#line 1683 "../lib/number.vala"
						_tmp30_ = numerators[i];
#line 1683 "../lib/number.vala"
						_tmp31_ = denominators[i];
#line 1683 "../lib/number.vala"
						_tmp32_ = number_new_fraction ((gint64) _tmp30_, (gint64) _tmp31_);
#line 1683 "../lib/number.vala"
						fraction = _tmp32_;
#line 1684 "../lib/number.vala"
						_tmp33_ = z;
#line 1684 "../lib/number.vala"
						_tmp34_ = fraction;
#line 1684 "../lib/number.vala"
						_tmp35_ = number_add (_tmp33_, _tmp34_);
#line 1684 "../lib/number.vala"
						_g_object_unref0 (z);
#line 1684 "../lib/number.vala"
						z = _tmp35_;
#line 1687 "../lib/number.vala"
						_tmp37_ = string_get_next_char (str, &index, &_tmp36_);
#line 1687 "../lib/number.vala"
						c = _tmp36_;
#line 1687 "../lib/number.vala"
						if (!_tmp37_) {
#line 1688 "../lib/number.vala"
							result = z;
#line 1688 "../lib/number.vala"
							_g_object_unref0 (fraction);
#line 1688 "../lib/number.vala"
							return result;
#line 8356 "number.c"
						} else {
#line 1690 "../lib/number.vala"
							result = NULL;
#line 1690 "../lib/number.vala"
							_g_object_unref0 (fraction);
#line 1690 "../lib/number.vala"
							_g_object_unref0 (z);
#line 1690 "../lib/number.vala"
							return result;
#line 8366 "number.c"
						}
#line 1681 "../lib/number.vala"
						_g_object_unref0 (fraction);
#line 8370 "number.c"
					}
				}
			}
		}
#line 1695 "../lib/number.vala"
		if (c == ((gunichar) '.')) {
#line 1696 "../lib/number.vala"
			has_fraction = TRUE;
#line 8379 "number.c"
		} else {
			gunichar _tmp38_ = 0U;
#line 1698 "../lib/number.vala"
			string_get_prev_char (str, &index, &_tmp38_);
#line 1698 "../lib/number.vala"
			c = _tmp38_;
#line 8386 "number.c"
		}
	}
#line 1702 "../lib/number.vala"
	if (has_fraction) {
#line 8391 "number.c"
		Number* numerator = NULL;
		Number* _tmp39_;
		Number* denominator = NULL;
		Number* _tmp40_;
		Number* _tmp52_;
		Number* _tmp53_;
		Number* _tmp54_;
		Number* _tmp55_;
		Number* _tmp56_;
		Number* _tmp57_;
#line 1704 "../lib/number.vala"
		_tmp39_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 1704 "../lib/number.vala"
		numerator = _tmp39_;
#line 1705 "../lib/number.vala"
		_tmp40_ = number_new_integer ((gint64) 1, (gint64) 0);
#line 1705 "../lib/number.vala"
		denominator = _tmp40_;
#line 1707 "../lib/number.vala"
		while (TRUE) {
#line 8412 "number.c"
			gunichar _tmp41_ = 0U;
			gboolean _tmp42_;
			gint i = 0;
			Number* _tmp44_;
			Number* _tmp45_;
			Number* _tmp46_;
			Number* _tmp47_;
			Number* _tmp48_;
			Number* _tmp49_;
			Number* _tmp50_;
			Number* _tmp51_;
#line 1707 "../lib/number.vala"
			_tmp42_ = string_get_next_char (str, &index, &_tmp41_);
#line 1707 "../lib/number.vala"
			c = _tmp41_;
#line 1707 "../lib/number.vala"
			if (!_tmp42_) {
#line 1707 "../lib/number.vala"
				break;
#line 8432 "number.c"
			}
#line 1709 "../lib/number.vala"
			i = char_val (c, number_base);
#line 1710 "../lib/number.vala"
			if (i < 0) {
#line 8438 "number.c"
				gunichar _tmp43_ = 0U;
#line 1712 "../lib/number.vala"
				string_get_prev_char (str, &index, &_tmp43_);
#line 1712 "../lib/number.vala"
				c = _tmp43_;
#line 1713 "../lib/number.vala"
				break;
#line 8446 "number.c"
			}
#line 1716 "../lib/number.vala"
			_tmp44_ = denominator;
#line 1716 "../lib/number.vala"
			_tmp45_ = number_multiply_integer (_tmp44_, (gint64) number_base);
#line 1716 "../lib/number.vala"
			_g_object_unref0 (denominator);
#line 1716 "../lib/number.vala"
			denominator = _tmp45_;
#line 1717 "../lib/number.vala"
			_tmp46_ = numerator;
#line 1717 "../lib/number.vala"
			_tmp47_ = number_multiply_integer (_tmp46_, (gint64) number_base);
#line 1717 "../lib/number.vala"
			_g_object_unref0 (numerator);
#line 1717 "../lib/number.vala"
			numerator = _tmp47_;
#line 1718 "../lib/number.vala"
			_tmp48_ = numerator;
#line 1718 "../lib/number.vala"
			_tmp49_ = number_new_integer ((gint64) i, (gint64) 0);
#line 1718 "../lib/number.vala"
			_tmp50_ = _tmp49_;
#line 1718 "../lib/number.vala"
			_tmp51_ = number_add (_tmp48_, _tmp50_);
#line 1718 "../lib/number.vala"
			_g_object_unref0 (numerator);
#line 1718 "../lib/number.vala"
			numerator = _tmp51_;
#line 1718 "../lib/number.vala"
			_g_object_unref0 (_tmp50_);
#line 8478 "number.c"
		}
#line 1721 "../lib/number.vala"
		_tmp52_ = numerator;
#line 1721 "../lib/number.vala"
		_tmp53_ = denominator;
#line 1721 "../lib/number.vala"
		_tmp54_ = number_divide (_tmp52_, _tmp53_);
#line 1721 "../lib/number.vala"
		_g_object_unref0 (numerator);
#line 1721 "../lib/number.vala"
		numerator = _tmp54_;
#line 1722 "../lib/number.vala"
		_tmp55_ = z;
#line 1722 "../lib/number.vala"
		_tmp56_ = numerator;
#line 1722 "../lib/number.vala"
		_tmp57_ = number_add (_tmp55_, _tmp56_);
#line 1722 "../lib/number.vala"
		_g_object_unref0 (z);
#line 1722 "../lib/number.vala"
		z = _tmp57_;
#line 1702 "../lib/number.vala"
		_g_object_unref0 (denominator);
#line 1702 "../lib/number.vala"
		_g_object_unref0 (numerator);
#line 8504 "number.c"
	}
#line 1725 "../lib/number.vala"
	if (index != end) {
#line 1726 "../lib/number.vala"
		result = NULL;
#line 1726 "../lib/number.vala"
		_g_object_unref0 (z);
#line 1726 "../lib/number.vala"
		return result;
#line 8514 "number.c"
	}
#line 1728 "../lib/number.vala"
	if (negate) {
#line 8518 "number.c"
		Number* _tmp58_;
		Number* _tmp59_;
#line 1729 "../lib/number.vala"
		_tmp58_ = z;
#line 1729 "../lib/number.vala"
		_tmp59_ = number_invert_sign (_tmp58_);
#line 1729 "../lib/number.vala"
		_g_object_unref0 (z);
#line 1729 "../lib/number.vala"
		z = _tmp59_;
#line 8529 "number.c"
	}
#line 1731 "../lib/number.vala"
	result = z;
#line 1731 "../lib/number.vala"
	return result;
#line 8535 "number.c"
}

gint
char_val (gunichar c,
          gint number_base)
{
	gint value = 0;
	gint result;
#line 1736 "../lib/number.vala"
	if (!g_unichar_isxdigit (c)) {
#line 1737 "../lib/number.vala"
		result = -1;
#line 1737 "../lib/number.vala"
		return result;
#line 8550 "number.c"
	}
#line 1739 "../lib/number.vala"
	value = g_unichar_xdigit_value (c);
#line 1741 "../lib/number.vala"
	if (value >= number_base) {
#line 1742 "../lib/number.vala"
		result = -1;
#line 1742 "../lib/number.vala"
		return result;
#line 8560 "number.c"
	}
#line 1744 "../lib/number.vala"
	result = value;
#line 1744 "../lib/number.vala"
	return result;
#line 8566 "number.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 8588 "number.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 8592 "number.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 8598 "number.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 8602 "number.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 8606 "number.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 8614 "number.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 8642 "number.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 8651 "number.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 8665 "number.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 8674 "number.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 8688 "number.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 8697 "number.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 8706 "number.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 8729 "number.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 8738 "number.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 8757 "number.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 8761 "number.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 8767 "number.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 8777 "number.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 8785 "number.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 8789 "number.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 8795 "number.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 8805 "number.c"
}

Number*
set_from_sexagesimal (const gchar* s)
{
	gchar* str = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gint degree_index = 0;
	const gchar* _tmp10_;
	Number* degrees = NULL;
	const gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	Number* _tmp14_;
	Number* _tmp15_;
	Number* _tmp16_;
	gint minute_start = 0;
	gunichar c = 0U;
	const gchar* _tmp17_;
	gunichar _tmp18_ = 0U;
	const gchar* _tmp19_;
	gint minute_index = 0;
	const gchar* _tmp20_;
	Number* minutes = NULL;
	const gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	Number* _tmp27_;
	Number* _tmp28_;
	Number* _tmp29_;
	Number* _tmp30_;
	Number* _tmp31_;
	Number* _tmp32_;
	Number* _tmp33_;
	Number* _tmp34_;
	gint second_start = 0;
	const gchar* _tmp35_;
	gunichar _tmp36_ = 0U;
	const gchar* _tmp37_;
	gint second_index = 0;
	const gchar* _tmp38_;
	Number* seconds = NULL;
	const gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	Number* _tmp45_;
	Number* _tmp46_;
	Number* _tmp47_;
	Number* _tmp48_;
	Number* _tmp49_;
	Number* _tmp50_;
	Number* _tmp51_;
	Number* _tmp52_;
	const gchar* _tmp53_;
	gunichar _tmp54_ = 0U;
	const gchar* _tmp55_;
	Number* result;
#line 1747 "../lib/number.vala"
	g_return_val_if_fail (s != NULL, NULL);
#line 1749 "../lib/number.vala"
	_tmp0_ = string_replace (s, "′", "'");
#line 1749 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 1749 "../lib/number.vala"
	_tmp2_ = string_replace (_tmp1_, "’", "'");
#line 1749 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 1749 "../lib/number.vala"
	_g_free0 (_tmp1_);
#line 1749 "../lib/number.vala"
	str = _tmp3_;
#line 1750 "../lib/number.vala"
	_tmp4_ = str;
#line 1750 "../lib/number.vala"
	_tmp5_ = string_replace (_tmp4_, "''", "\"");
#line 1750 "../lib/number.vala"
	_tmp6_ = _tmp5_;
#line 1750 "../lib/number.vala"
	_tmp7_ = string_replace (_tmp6_, "″", "\"");
#line 1750 "../lib/number.vala"
	_tmp8_ = _tmp7_;
#line 1750 "../lib/number.vala"
	_tmp9_ = string_replace (_tmp8_, "”", "\"");
#line 1750 "../lib/number.vala"
	_g_free0 (str);
#line 1750 "../lib/number.vala"
	str = _tmp9_;
#line 1750 "../lib/number.vala"
	_g_free0 (_tmp8_);
#line 1750 "../lib/number.vala"
	_g_free0 (_tmp6_);
#line 1752 "../lib/number.vala"
	_tmp10_ = str;
#line 1752 "../lib/number.vala"
	degree_index = string_index_of_char (_tmp10_, 176U, 0);
#line 1753 "../lib/number.vala"
	if (degree_index < 0) {
#line 1754 "../lib/number.vala"
		result = NULL;
#line 1754 "../lib/number.vala"
		_g_free0 (str);
#line 1754 "../lib/number.vala"
		return result;
#line 8918 "number.c"
	}
#line 1755 "../lib/number.vala"
	_tmp11_ = str;
#line 1755 "../lib/number.vala"
	_tmp12_ = string_substring (_tmp11_, (glong) 0, (glong) degree_index);
#line 1755 "../lib/number.vala"
	_tmp13_ = _tmp12_;
#line 1755 "../lib/number.vala"
	_tmp14_ = mp_set_from_string (_tmp13_, 10, TRUE);
#line 1755 "../lib/number.vala"
	_tmp15_ = _tmp14_;
#line 1755 "../lib/number.vala"
	_g_free0 (_tmp13_);
#line 1755 "../lib/number.vala"
	degrees = _tmp15_;
#line 1756 "../lib/number.vala"
	_tmp16_ = degrees;
#line 1756 "../lib/number.vala"
	if (_tmp16_ == NULL) {
#line 1757 "../lib/number.vala"
		result = NULL;
#line 1757 "../lib/number.vala"
		_g_object_unref0 (degrees);
#line 1757 "../lib/number.vala"
		_g_free0 (str);
#line 1757 "../lib/number.vala"
		return result;
#line 8946 "number.c"
	}
#line 1758 "../lib/number.vala"
	minute_start = degree_index;
#line 1760 "../lib/number.vala"
	_tmp17_ = str;
#line 1760 "../lib/number.vala"
	string_get_next_char (_tmp17_, &minute_start, &_tmp18_);
#line 1760 "../lib/number.vala"
	c = _tmp18_;
#line 1762 "../lib/number.vala"
	_tmp19_ = str;
#line 1762 "../lib/number.vala"
	if (string_get (_tmp19_, (glong) minute_start) == '\0') {
#line 1763 "../lib/number.vala"
		result = degrees;
#line 1763 "../lib/number.vala"
		_g_free0 (str);
#line 1763 "../lib/number.vala"
		return result;
#line 8966 "number.c"
	}
#line 1764 "../lib/number.vala"
	_tmp20_ = str;
#line 1764 "../lib/number.vala"
	minute_index = string_index_of_char (_tmp20_, (gunichar) '\'', minute_start);
#line 1765 "../lib/number.vala"
	if (minute_index < 0) {
#line 8974 "number.c"
		const gchar* _tmp21_;
		gint _tmp22_;
		gint _tmp23_;
#line 1766 "../lib/number.vala"
		_tmp21_ = str;
#line 1766 "../lib/number.vala"
		_tmp22_ = strlen (_tmp21_);
#line 1766 "../lib/number.vala"
		_tmp23_ = _tmp22_;
#line 1766 "../lib/number.vala"
		minute_index = _tmp23_;
#line 8986 "number.c"
	}
#line 1767 "../lib/number.vala"
	_tmp24_ = str;
#line 1767 "../lib/number.vala"
	_tmp25_ = string_substring (_tmp24_, (glong) minute_start, (glong) (minute_index - minute_start));
#line 1767 "../lib/number.vala"
	_tmp26_ = _tmp25_;
#line 1767 "../lib/number.vala"
	_tmp27_ = mp_set_from_string (_tmp26_, 10, TRUE);
#line 1767 "../lib/number.vala"
	_tmp28_ = _tmp27_;
#line 1767 "../lib/number.vala"
	_g_free0 (_tmp26_);
#line 1767 "../lib/number.vala"
	minutes = _tmp28_;
#line 1768 "../lib/number.vala"
	_tmp29_ = minutes;
#line 1768 "../lib/number.vala"
	if (_tmp29_ == NULL) {
#line 1769 "../lib/number.vala"
		result = NULL;
#line 1769 "../lib/number.vala"
		_g_object_unref0 (minutes);
#line 1769 "../lib/number.vala"
		_g_object_unref0 (degrees);
#line 1769 "../lib/number.vala"
		_g_free0 (str);
#line 1769 "../lib/number.vala"
		return result;
#line 9016 "number.c"
	}
#line 1770 "../lib/number.vala"
	_tmp30_ = degrees;
#line 1770 "../lib/number.vala"
	_tmp31_ = minutes;
#line 1770 "../lib/number.vala"
	_tmp32_ = number_divide_integer (_tmp31_, (gint64) 60);
#line 1770 "../lib/number.vala"
	_tmp33_ = _tmp32_;
#line 1770 "../lib/number.vala"
	_tmp34_ = number_add (_tmp30_, _tmp33_);
#line 1770 "../lib/number.vala"
	_g_object_unref0 (degrees);
#line 1770 "../lib/number.vala"
	degrees = _tmp34_;
#line 1770 "../lib/number.vala"
	_g_object_unref0 (_tmp33_);
#line 1771 "../lib/number.vala"
	second_start = minute_index;
#line 1772 "../lib/number.vala"
	_tmp35_ = str;
#line 1772 "../lib/number.vala"
	string_get_next_char (_tmp35_, &second_start, &_tmp36_);
#line 1772 "../lib/number.vala"
	c = _tmp36_;
#line 1774 "../lib/number.vala"
	_tmp37_ = str;
#line 1774 "../lib/number.vala"
	if (string_get (_tmp37_, (glong) second_start) == '\0') {
#line 1775 "../lib/number.vala"
		result = degrees;
#line 1775 "../lib/number.vala"
		_g_object_unref0 (minutes);
#line 1775 "../lib/number.vala"
		_g_free0 (str);
#line 1775 "../lib/number.vala"
		return result;
#line 9054 "number.c"
	}
#line 1776 "../lib/number.vala"
	_tmp38_ = str;
#line 1776 "../lib/number.vala"
	second_index = string_index_of_char (_tmp38_, (gunichar) '"', second_start);
#line 1777 "../lib/number.vala"
	if (second_index < 0) {
#line 9062 "number.c"
		const gchar* _tmp39_;
		gint _tmp40_;
		gint _tmp41_;
#line 1778 "../lib/number.vala"
		_tmp39_ = str;
#line 1778 "../lib/number.vala"
		_tmp40_ = strlen (_tmp39_);
#line 1778 "../lib/number.vala"
		_tmp41_ = _tmp40_;
#line 1778 "../lib/number.vala"
		second_index = _tmp41_;
#line 9074 "number.c"
	}
#line 1779 "../lib/number.vala"
	_tmp42_ = str;
#line 1779 "../lib/number.vala"
	_tmp43_ = string_substring (_tmp42_, (glong) second_start, (glong) (second_index - second_start));
#line 1779 "../lib/number.vala"
	_tmp44_ = _tmp43_;
#line 1779 "../lib/number.vala"
	_tmp45_ = mp_set_from_string (_tmp44_, 10, TRUE);
#line 1779 "../lib/number.vala"
	_tmp46_ = _tmp45_;
#line 1779 "../lib/number.vala"
	_g_free0 (_tmp44_);
#line 1779 "../lib/number.vala"
	seconds = _tmp46_;
#line 1780 "../lib/number.vala"
	_tmp47_ = seconds;
#line 1780 "../lib/number.vala"
	if (_tmp47_ == NULL) {
#line 1781 "../lib/number.vala"
		result = NULL;
#line 1781 "../lib/number.vala"
		_g_object_unref0 (seconds);
#line 1781 "../lib/number.vala"
		_g_object_unref0 (minutes);
#line 1781 "../lib/number.vala"
		_g_object_unref0 (degrees);
#line 1781 "../lib/number.vala"
		_g_free0 (str);
#line 1781 "../lib/number.vala"
		return result;
#line 9106 "number.c"
	}
#line 1782 "../lib/number.vala"
	_tmp48_ = degrees;
#line 1782 "../lib/number.vala"
	_tmp49_ = seconds;
#line 1782 "../lib/number.vala"
	_tmp50_ = number_divide_integer (_tmp49_, (gint64) 3600);
#line 1782 "../lib/number.vala"
	_tmp51_ = _tmp50_;
#line 1782 "../lib/number.vala"
	_tmp52_ = number_add (_tmp48_, _tmp51_);
#line 1782 "../lib/number.vala"
	_g_object_unref0 (degrees);
#line 1782 "../lib/number.vala"
	degrees = _tmp52_;
#line 1782 "../lib/number.vala"
	_g_object_unref0 (_tmp51_);
#line 1783 "../lib/number.vala"
	_tmp53_ = str;
#line 1783 "../lib/number.vala"
	string_get_next_char (_tmp53_, &second_index, &_tmp54_);
#line 1783 "../lib/number.vala"
	c = _tmp54_;
#line 1786 "../lib/number.vala"
	_tmp55_ = str;
#line 1786 "../lib/number.vala"
	if (string_get (_tmp55_, (glong) second_index) == '\0') {
#line 1787 "../lib/number.vala"
		result = degrees;
#line 1787 "../lib/number.vala"
		_g_object_unref0 (seconds);
#line 1787 "../lib/number.vala"
		_g_object_unref0 (minutes);
#line 1787 "../lib/number.vala"
		_g_free0 (str);
#line 1787 "../lib/number.vala"
		return result;
#line 9144 "number.c"
	} else {
#line 1789 "../lib/number.vala"
		result = NULL;
#line 1789 "../lib/number.vala"
		_g_object_unref0 (seconds);
#line 1789 "../lib/number.vala"
		_g_object_unref0 (minutes);
#line 1789 "../lib/number.vala"
		_g_object_unref0 (degrees);
#line 1789 "../lib/number.vala"
		_g_free0 (str);
#line 1789 "../lib/number.vala"
		return result;
#line 9158 "number.c"
	}
}

gboolean
mp_is_overflow (Number* x,
                gint wordlen)
{
	Number* t2 = NULL;
	Number* _tmp0_;
	Number* _tmp1_;
	Number* _tmp2_;
	Number* _tmp3_;
	gboolean result;
#line 1793 "../lib/number.vala"
	g_return_val_if_fail (x != NULL, FALSE);
#line 1795 "../lib/number.vala"
	_tmp0_ = number_new_integer ((gint64) 2, (gint64) 0);
#line 1795 "../lib/number.vala"
	_tmp1_ = _tmp0_;
#line 1795 "../lib/number.vala"
	_tmp2_ = number_xpowy_integer (_tmp1_, (gint64) wordlen);
#line 1795 "../lib/number.vala"
	_tmp3_ = _tmp2_;
#line 1795 "../lib/number.vala"
	_g_object_unref0 (_tmp1_);
#line 1795 "../lib/number.vala"
	t2 = _tmp3_;
#line 1796 "../lib/number.vala"
	result = number_compare (t2, x) > 0;
#line 1796 "../lib/number.vala"
	_g_object_unref0 (t2);
#line 1796 "../lib/number.vala"
	return result;
#line 9192 "number.c"
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

