/* math-converter.c generated by valac 0.56.18, the Vala compiler
 * generated from math-converter.vala, do not modify */

/*
 * Copyright (C) 2008-2012 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib-object.h>
#include <gtk/gtk.h>
#include "calculator.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <langinfo.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

typedef enum  {
	CURRENCY_DISPLAY_CODE,
	CURRENCY_DISPLAY_NAME,
	CURRENCY_DISPLAY_BOTH
} CurrencyDisplay;

#define TYPE_CURRENCY_DISPLAY (currency_display_get_type ())

#define TYPE_MATH_CONVERTER (math_converter_get_type ())
#define MATH_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MATH_CONVERTER, MathConverter))
#define MATH_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MATH_CONVERTER, MathConverterClass))
#define IS_MATH_CONVERTER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MATH_CONVERTER))
#define IS_MATH_CONVERTER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MATH_CONVERTER))
#define MATH_CONVERTER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MATH_CONVERTER, MathConverterClass))

typedef struct _MathConverter MathConverter;
typedef struct _MathConverterClass MathConverterClass;
typedef struct _MathConverterPrivate MathConverterPrivate;
enum  {
	MATH_CONVERTER_0_PROPERTY,
	MATH_CONVERTER_EQUATION_PROPERTY,
	MATH_CONVERTER_SOURCE_UNITS_PROPERTY,
	MATH_CONVERTER_TARGET_UNITS_PROPERTY,
	MATH_CONVERTER_CURRENCY_DISPLAY_PROPERTY,
	MATH_CONVERTER_BOX_VISIBLE_PROPERTY,
	MATH_CONVERTER_NUM_PROPERTIES
};
static GParamSpec* math_converter_properties[MATH_CONVERTER_NUM_PROPERTIES];
typedef void (*GSimpleActionActivateCallback) (GSimpleAction* action, GVariant* parameter, gpointer user_data);
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _gtk_expression_unref0(var) ((var == NULL) ? NULL : (var = (gtk_expression_unref (var), NULL)))
typedef struct _Block5Data Block5Data;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _Block6Data Block6Data;
typedef struct _Block7Data Block7Data;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define __vala_GdkEventSequence_free0(var) ((var == NULL) ? NULL : (var = (_vala_GdkEventSequence_free (var), NULL)))
#define _gdk_event_unref0(var) ((var == NULL) ? NULL : (var = (gdk_event_unref (var), NULL)))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
enum  {
	MATH_CONVERTER_CHANGED_SIGNAL,
	MATH_CONVERTER_NUM_SIGNALS
};
static guint math_converter_signals[MATH_CONVERTER_NUM_SIGNALS] = {0};

struct _MathConverter {
	GtkBox parent_instance;
	MathConverterPrivate * priv;
};

struct _MathConverterClass {
	GtkBoxClass parent_class;
};

struct _MathConverterPrivate {
	MathEquation* _equation;
	gchar* category;
	Number* from_number;
	Number* to_number;
	GHashTable* _source_units;
	GHashTable* _target_units;
	CurrencyDisplay _currency_display;
	GtkDropDown* category_combo;
	GtkDropDown* from_combo;
	GtkDropDown* to_combo;
	GtkTextView* from_entry;
	GtkTextView* to_entry;
	GtkPopoverMenu* from_context_menu;
	GtkPopoverMenu* to_context_menu;
	Serializer* fixed_serializer;
	GtkSignalListItemFactory* from_currency_factory;
	GtkSignalListItemFactory* to_currency_factory;
	GtkEventControllerKey* from_event_controller;
	GtkEventControllerKey* to_event_controller;
	gulong from_combobox_changed;
	gulong from_entry_changed;
	gulong to_entry_changed;
	GSimpleActionGroup* action_group;
	gboolean _box_visible;
};

struct _Block5Data {
	int _ref_count_;
	MathConverter* self;
	GdkClipboard* clipboard;
};

struct _Block6Data {
	int _ref_count_;
	MathConverter* self;
	CurrencyManager* currency_manager;
};

struct _Block7Data {
	int _ref_count_;
	MathConverter* self;
	GtkWidget* box;
	Unit* unit;
	GtkDropDown* combo;
};

static gint MathConverter_private_offset;
static gpointer math_converter_parent_class = NULL;

VALA_EXTERN GType currency_display_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType math_converter_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (MathConverter, g_object_unref)
static void math_converter_popup_cb (MathConverter* self,
                              GSimpleAction* action,
                              GVariant* param);
static void _math_converter_popup_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self);
static void math_converter_copy_cb (MathConverter* self,
                             GSimpleAction* action,
                             GVariant* param);
static void _math_converter_copy_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                               GVariant* parameter,
                                                               gpointer self);
static void math_converter_paste_cb (MathConverter* self,
                              GSimpleAction* action,
                              GVariant* param);
static void _math_converter_paste_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                                GVariant* parameter,
                                                                gpointer self);
static void _g_free0_ (gpointer var);
VALA_EXTERN MathConverter* math_converter_new (MathEquation* equation);
VALA_EXTERN MathConverter* math_converter_construct (GType object_type,
                                         MathEquation* equation);
static void math_converter_construct_finish (MathConverter* self);
VALA_EXTERN MathEquation* math_converter_get_equation (MathConverter* self);
static void math_converter_update_visibility (MathConverter* self);
static void _math_converter_update_visibility_currency_manager_updated (CurrencyManager* _sender,
                                                                 const gchar* symbol,
                                                                 gpointer self);
static void __lambda5_ (MathConverter* self);
static void math_converter_category_combobox_changed_cb (MathConverter* self);
static void ___lambda5__currency_manager_favorites_changed (CurrencyManager* _sender,
                                                     gpointer self);
static void math_converter_build_category_model (MathConverter* self);
static void math_converter_build_units_model (MathConverter* self);
static void math_converter_reformat_display (MathConverter* self);
static void _math_converter_reformat_display_math_equation_display_changed (MathEquation* _sender,
                                                                     Serializer* serializer,
                                                                     gpointer self);
static void math_converter_from_combobox_changed_cb (MathConverter* self);
static void _math_converter_from_combobox_changed_cb_g_object_notify (GObject* _sender,
                                                               GParamSpec* pspec,
                                                               gpointer self);
static void math_converter_update_entry (MathConverter* self,
                                  GtkTextView* entry,
                                  Serializer* serializer);
static void math_converter_from_entry_changed_cb (MathConverter* self);
static void _math_converter_from_entry_changed_cb_gtk_text_buffer_changed (GtkTextBuffer* _sender,
                                                                    gpointer self);
static void math_converter_to_entry_changed_cb (MathConverter* self);
static void _math_converter_to_entry_changed_cb_gtk_text_buffer_changed (GtkTextBuffer* _sender,
                                                                  gpointer self);
static void math_converter_setup_currency (MathConverter* self,
                                    GObject* item);
static void _math_converter_setup_currency_gtk_signal_list_item_factory_setup (GtkSignalListItemFactory* _sender,
                                                                        GObject* object,
                                                                        gpointer self);
static void __lambda8_ (MathConverter* self,
                 GObject* item);
static void math_converter_bind_currency (MathConverter* self,
                                   GObject* item,
                                   GtkDropDown* combo);
static void ___lambda8__gtk_signal_list_item_factory_bind (GtkSignalListItemFactory* _sender,
                                                    GObject* object,
                                                    gpointer self);
static void __lambda10_ (MathConverter* self,
                  GObject* item);
static void math_converter_unbind_currency (MathConverter* self,
                                     GObject* item,
                                     GtkDropDown* combo);
static void ___lambda10__gtk_signal_list_item_factory_unbind (GtkSignalListItemFactory* _sender,
                                                       GObject* object,
                                                       gpointer self);
static void __lambda11_ (MathConverter* self,
                  GObject* item);
static void ___lambda11__gtk_signal_list_item_factory_bind (GtkSignalListItemFactory* _sender,
                                                     GObject* object,
                                                     gpointer self);
static void __lambda12_ (MathConverter* self,
                  GObject* item);
static void ___lambda12__gtk_signal_list_item_factory_unbind (GtkSignalListItemFactory* _sender,
                                                       GObject* object,
                                                       gpointer self);
static gint ____lambda7_ (MathConverter* self,
                   GObject* c1,
                   GObject* c2);
static gint _____lambda7__gcompare_data_func (gconstpointer a,
                                       gconstpointer b,
                                       gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void math_converter_load_selected_units (MathConverter* self,
                                         GHashTable* units,
                                         gchar** value,
                                         gint value_length1);
VALA_EXTERN void math_converter_set_category (MathConverter* self,
                                  const gchar* category);
VALA_EXTERN gchar* math_converter_get_category (MathConverter* self);
VALA_EXTERN gchar* math_converter_get_focus_unit (MathConverter* self);
VALA_EXTERN void math_converter_insert_text (MathConverter* self,
                                 const gchar* text,
                                 gboolean replace_zero);
VALA_EXTERN gboolean math_converter_get_box_visible (MathConverter* self);
VALA_EXTERN void math_converter_insert_numeric_point (MathConverter* self);
VALA_EXTERN void math_converter_insert_dms (MathConverter* self);
VALA_EXTERN void math_converter_change_sign (MathConverter* self);
VALA_EXTERN void math_converter_clear (MathConverter* self);
VALA_EXTERN void math_converter_swap_units (MathConverter* self);
static gboolean math_converter_set_active_unit (MathConverter* self,
                                         GtkDropDown* combo,
                                         Unit* unit);
static void math_converter_to_combobox_changed_cb (MathConverter* self);
static void math_converter_reformat_from_entry (MathConverter* self);
VALA_EXTERN void math_converter_backspace (MathConverter* self);
VALA_EXTERN void math_converter_paste (MathConverter* self);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void __lambda4_ (Block5Data* _data5_,
                 GObject* obj,
                 GAsyncResult* res);
static void math_converter_on_paste (MathConverter* self,
                              const gchar* text);
static void ___lambda4__gasync_ready_callback (GObject* source_object,
                                        GAsyncResult* res,
                                        gpointer self);
VALA_EXTERN void math_converter_set_box_visible (MathConverter* self,
                                     gboolean value);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static gchar* math_converter_currency_item (Unit* unit);
static gint ___lambda6_ (Block6Data* _data6_,
                  GObject* a,
                  GObject* b);
static gint ____lambda6__gcompare_data_func (gconstpointer a,
                                      gconstpointer b,
                                      gpointer self);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void __lambda9_ (Block7Data* _data7_);
static void ___lambda9__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void _math_converter_category_combobox_changed_cb_g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self);
static Number* math_converter_convert_equation (MathConverter* self,
                                         Number* x,
                                         Unit** source_unit,
                                         Unit** target_unit);
static void _math_converter_to_combobox_changed_cb_g_object_notify (GObject* _sender,
                                                             GParamSpec* pspec,
                                                             gpointer self);
static void math_converter_from_entry_focus_cb (MathConverter* self);
static Number* math_converter_get_number_from_entry (MathConverter* self,
                                              GtkTextView* entry);
static void _math_converter_from_entry_focus_cb_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void math_converter_to_entry_focus_cb (MathConverter* self);
static void _math_converter_to_entry_focus_cb_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self);
static gboolean math_converter_key_press_cb (MathConverter* self,
                                      GtkEventControllerKey* controller,
                                      guint keyval,
                                      guint keycode,
                                      GdkModifierType mod_state);
static gboolean _math_converter_key_press_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                            guint keyval,
                                                                            guint keycode,
                                                                            GdkModifierType state,
                                                                            gpointer self);
static void math_converter_from_entry_click_cb (MathConverter* self,
                                         GtkGestureClick* gesture,
                                         gint n_click,
                                         gdouble x,
                                         gdouble y);
static void _vala_GdkEventSequence_free (GdkEventSequence* self);
static void math_converter_show_context_menu (MathConverter* self,
                                       GtkTextView* entry,
                                       gdouble x,
                                       gdouble y);
static void _math_converter_from_entry_click_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                    gint n_press,
                                                                    gdouble x,
                                                                    gdouble y,
                                                                    gpointer self);
static void math_converter_to_entry_click_cb (MathConverter* self,
                                       GtkGestureClick* gesture,
                                       gint n_click,
                                       gdouble x,
                                       gdouble y);
static void _math_converter_to_entry_click_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                                  gint n_press,
                                                                  gdouble x,
                                                                  gdouble y,
                                                                  gpointer self);
VALA_EXTERN void math_converter_set_equation (MathConverter* self,
                                  MathEquation* value);
VALA_EXTERN gchar** math_converter_get_source_units (MathConverter* self,
                                         gint* result_length1);
static gchar** _vala_array_dup6 (gchar** self,
                          gssize length);
VALA_EXTERN void math_converter_set_source_units (MathConverter* self,
                                      gchar** value,
                                      gint value_length1);
VALA_EXTERN gchar** math_converter_get_target_units (MathConverter* self,
                                         gint* result_length1);
static gchar** _vala_array_dup7 (gchar** self,
                          gssize length);
VALA_EXTERN void math_converter_set_target_units (MathConverter* self,
                                      gchar** value,
                                      gint value_length1);
VALA_EXTERN void math_converter_set_currency_display (MathConverter* self,
                                          CurrencyDisplay value);
static GObject * math_converter_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties);
static void _math_converter_construct_finish_g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self);
static void math_converter_finalize (GObject * obj);
static GType math_converter_get_type_once (void);
static void _vala_math_converter_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec);
static void _vala_math_converter_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GActionEntry MATH_CONVERTER_action_entries[3] = {{"popup", _math_converter_popup_cb_gsimple_action_activate_callback}, {"copy", _math_converter_copy_cb_gsimple_action_activate_callback}, {"paste", _math_converter_paste_cb_gsimple_action_activate_callback}};

static GType
currency_display_get_type_once (void)
{
	static const GEnumValue values[] = {{CURRENCY_DISPLAY_CODE, "CURRENCY_DISPLAY_CODE", "code"}, {CURRENCY_DISPLAY_NAME, "CURRENCY_DISPLAY_NAME", "name"}, {CURRENCY_DISPLAY_BOTH, "CURRENCY_DISPLAY_BOTH", "both"}, {0, NULL, NULL}};
	GType currency_display_type_id;
	currency_display_type_id = g_enum_register_static ("CurrencyDisplay", values);
	return currency_display_type_id;
}

GType
currency_display_get_type (void)
{
	static volatile gsize currency_display_type_id__once = 0;
	if (g_once_init_enter (&currency_display_type_id__once)) {
		GType currency_display_type_id;
		currency_display_type_id = currency_display_get_type_once ();
		g_once_init_leave (&currency_display_type_id__once, currency_display_type_id);
	}
	return currency_display_type_id__once;
}

static inline gpointer
math_converter_get_instance_private (MathConverter* self)
{
	return G_STRUCT_MEMBER_P (self, MathConverter_private_offset);
}

static void
_math_converter_popup_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self)
{
#line 80 "../src/math-converter.vala"
	math_converter_popup_cb ((MathConverter*) self, action, parameter);
#line 430 "math-converter.c"
}

static void
_math_converter_copy_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                          GVariant* parameter,
                                                          gpointer self)
{
#line 80 "../src/math-converter.vala"
	math_converter_copy_cb ((MathConverter*) self, action, parameter);
#line 440 "math-converter.c"
}

static void
_math_converter_paste_cb_gsimple_action_activate_callback (GSimpleAction* action,
                                                           GVariant* parameter,
                                                           gpointer self)
{
#line 80 "../src/math-converter.vala"
	math_converter_paste_cb ((MathConverter*) self, action, parameter);
#line 450 "math-converter.c"
}

static void
_g_free0_ (gpointer var)
{
#line 27 "../src/math-converter.vala"
	var = (g_free (var), NULL);
#line 458 "math-converter.c"
}

MathConverter*
math_converter_construct (GType object_type,
                          MathEquation* equation)
{
	MathConverter * self = NULL;
#line 94 "../src/math-converter.vala"
	g_return_val_if_fail (equation != NULL, NULL);
#line 96 "../src/math-converter.vala"
	self = (MathConverter*) g_object_new (object_type, "equation", equation, NULL);
#line 94 "../src/math-converter.vala"
	return self;
#line 472 "math-converter.c"
}

MathConverter*
math_converter_new (MathEquation* equation)
{
#line 94 "../src/math-converter.vala"
	return math_converter_construct (TYPE_MATH_CONVERTER, equation);
#line 480 "math-converter.c"
}

static void
_math_converter_update_visibility_currency_manager_updated (CurrencyManager* _sender,
                                                            const gchar* symbol,
                                                            gpointer self)
{
#line 111 "../src/math-converter.vala"
	math_converter_update_visibility ((MathConverter*) self);
#line 490 "math-converter.c"
}

static void
__lambda5_ (MathConverter* self)
{
	const gchar* _tmp0_;
#line 113 "../src/math-converter.vala"
	_tmp0_ = self->priv->category;
#line 113 "../src/math-converter.vala"
	if (g_strcmp0 (_tmp0_, "currency") == 0) {
#line 114 "../src/math-converter.vala"
		math_converter_category_combobox_changed_cb (self);
#line 503 "math-converter.c"
	}
}

static void
___lambda5__currency_manager_favorites_changed (CurrencyManager* _sender,
                                                gpointer self)
{
#line 112 "../src/math-converter.vala"
	__lambda5_ ((MathConverter*) self);
#line 513 "math-converter.c"
}

static void
_math_converter_reformat_display_math_equation_display_changed (MathEquation* _sender,
                                                                Serializer* serializer,
                                                                gpointer self)
{
#line 121 "../src/math-converter.vala"
	math_converter_reformat_display ((MathConverter*) self);
#line 523 "math-converter.c"
}

static void
_math_converter_from_combobox_changed_cb_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self)
{
#line 122 "../src/math-converter.vala"
	math_converter_from_combobox_changed_cb ((MathConverter*) self);
#line 533 "math-converter.c"
}

static void
_math_converter_from_entry_changed_cb_gtk_text_buffer_changed (GtkTextBuffer* _sender,
                                                               gpointer self)
{
#line 129 "../src/math-converter.vala"
	math_converter_from_entry_changed_cb ((MathConverter*) self);
#line 542 "math-converter.c"
}

static void
_math_converter_to_entry_changed_cb_gtk_text_buffer_changed (GtkTextBuffer* _sender,
                                                             gpointer self)
{
#line 130 "../src/math-converter.vala"
	math_converter_to_entry_changed_cb ((MathConverter*) self);
#line 551 "math-converter.c"
}

static void
_math_converter_setup_currency_gtk_signal_list_item_factory_setup (GtkSignalListItemFactory* _sender,
                                                                   GObject* object,
                                                                   gpointer self)
{
#line 139 "../src/math-converter.vala"
	math_converter_setup_currency ((MathConverter*) self, object);
#line 561 "math-converter.c"
}

static void
__lambda8_ (MathConverter* self,
            GObject* item)
{
	GtkDropDown* _tmp0_;
#line 140 "../src/math-converter.vala"
	g_return_if_fail (item != NULL);
#line 140 "../src/math-converter.vala"
	_tmp0_ = self->priv->from_combo;
#line 140 "../src/math-converter.vala"
	math_converter_bind_currency (self, item, _tmp0_);
#line 575 "math-converter.c"
}

static void
___lambda8__gtk_signal_list_item_factory_bind (GtkSignalListItemFactory* _sender,
                                               GObject* object,
                                               gpointer self)
{
#line 140 "../src/math-converter.vala"
	__lambda8_ ((MathConverter*) self, object);
#line 585 "math-converter.c"
}

static void
__lambda10_ (MathConverter* self,
             GObject* item)
{
	GtkDropDown* _tmp0_;
#line 141 "../src/math-converter.vala"
	g_return_if_fail (item != NULL);
#line 141 "../src/math-converter.vala"
	_tmp0_ = self->priv->from_combo;
#line 141 "../src/math-converter.vala"
	math_converter_unbind_currency (self, item, _tmp0_);
#line 599 "math-converter.c"
}

static void
___lambda10__gtk_signal_list_item_factory_unbind (GtkSignalListItemFactory* _sender,
                                                  GObject* object,
                                                  gpointer self)
{
#line 141 "../src/math-converter.vala"
	__lambda10_ ((MathConverter*) self, object);
#line 609 "math-converter.c"
}

static void
__lambda11_ (MathConverter* self,
             GObject* item)
{
	GtkDropDown* _tmp0_;
#line 145 "../src/math-converter.vala"
	g_return_if_fail (item != NULL);
#line 145 "../src/math-converter.vala"
	_tmp0_ = self->priv->to_combo;
#line 145 "../src/math-converter.vala"
	math_converter_bind_currency (self, item, _tmp0_);
#line 623 "math-converter.c"
}

static void
___lambda11__gtk_signal_list_item_factory_bind (GtkSignalListItemFactory* _sender,
                                                GObject* object,
                                                gpointer self)
{
#line 145 "../src/math-converter.vala"
	__lambda11_ ((MathConverter*) self, object);
#line 633 "math-converter.c"
}

static void
__lambda12_ (MathConverter* self,
             GObject* item)
{
	GtkDropDown* _tmp0_;
#line 146 "../src/math-converter.vala"
	g_return_if_fail (item != NULL);
#line 146 "../src/math-converter.vala"
	_tmp0_ = self->priv->to_combo;
#line 146 "../src/math-converter.vala"
	math_converter_unbind_currency (self, item, _tmp0_);
#line 647 "math-converter.c"
}

static void
___lambda12__gtk_signal_list_item_factory_unbind (GtkSignalListItemFactory* _sender,
                                                  GObject* object,
                                                  gpointer self)
{
#line 146 "../src/math-converter.vala"
	__lambda12_ ((MathConverter*) self, object);
#line 657 "math-converter.c"
}

static void
math_converter_construct_finish (MathConverter* self)
{
	MathEquation* _tmp0_;
	CurrencyManager* _tmp1_;
	CurrencyManager* _tmp2_;
	CurrencyManager* _tmp3_;
	CurrencyManager* _tmp4_;
	MathEquation* _tmp5_;
	GtkDropDown* _tmp6_;
	gulong _tmp7_;
	MathEquation* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	Serializer* _tmp11_;
	Number* _tmp12_;
	Number* _tmp13_;
	GtkTextView* _tmp14_;
	MathEquation* _tmp15_;
	Serializer* _tmp16_;
	Serializer* _tmp17_;
	GtkTextView* _tmp18_;
	MathEquation* _tmp19_;
	Serializer* _tmp20_;
	Serializer* _tmp21_;
	GtkTextView* _tmp22_;
	GtkTextBuffer* _tmp23_;
	GtkTextBuffer* _tmp24_;
	gulong _tmp25_;
	GtkTextView* _tmp26_;
	GtkTextBuffer* _tmp27_;
	GtkTextBuffer* _tmp28_;
	gulong _tmp29_;
	GtkSignalListItemFactory* _tmp32_;
	GtkSignalListItemFactory* _tmp33_;
	GtkSignalListItemFactory* _tmp34_;
	GtkSignalListItemFactory* _tmp35_;
	GtkSignalListItemFactory* _tmp36_;
	GtkSignalListItemFactory* _tmp37_;
	GtkSignalListItemFactory* _tmp38_;
	GtkSignalListItemFactory* _tmp39_;
	GSettings* settings = NULL;
	GSettings* _tmp40_;
	GSettings* _tmp41_;
#line 106 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 108 "../src/math-converter.vala"
	_tmp0_ = self->priv->_equation;
#line 108 "../src/math-converter.vala"
	if (_tmp0_ == NULL) {
#line 109 "../src/math-converter.vala"
		return;
#line 712 "math-converter.c"
	}
#line 111 "../src/math-converter.vala"
	_tmp1_ = currency_manager_get_default (TRUE, TRUE);
#line 111 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 111 "../src/math-converter.vala"
	g_signal_connect_object (_tmp2_, "updated", (GCallback) _math_converter_update_visibility_currency_manager_updated, self, 0);
#line 111 "../src/math-converter.vala"
	_g_object_unref0 (_tmp2_);
#line 112 "../src/math-converter.vala"
	_tmp3_ = currency_manager_get_default (TRUE, TRUE);
#line 112 "../src/math-converter.vala"
	_tmp4_ = _tmp3_;
#line 112 "../src/math-converter.vala"
	g_signal_connect_object (_tmp4_, "favorites-changed", (GCallback) ___lambda5__currency_manager_favorites_changed, self, 0);
#line 112 "../src/math-converter.vala"
	_g_object_unref0 (_tmp4_);
#line 117 "../src/math-converter.vala"
	math_converter_build_category_model (self);
#line 118 "../src/math-converter.vala"
	math_converter_update_visibility (self);
#line 119 "../src/math-converter.vala"
	math_converter_build_units_model (self);
#line 121 "../src/math-converter.vala"
	_tmp5_ = self->priv->_equation;
#line 121 "../src/math-converter.vala"
	g_signal_connect_object (_tmp5_, "display-changed", (GCallback) _math_converter_reformat_display_math_equation_display_changed, self, 0);
#line 122 "../src/math-converter.vala"
	_tmp6_ = self->priv->from_combo;
#line 122 "../src/math-converter.vala"
	_tmp7_ = g_signal_connect_object ((GObject*) _tmp6_, "notify::selected", (GCallback) _math_converter_from_combobox_changed_cb_g_object_notify, self, 0);
#line 122 "../src/math-converter.vala"
	self->priv->from_combobox_changed = _tmp7_;
#line 123 "../src/math-converter.vala"
	_tmp8_ = self->priv->_equation;
#line 123 "../src/math-converter.vala"
	_tmp9_ = math_equation_get_accuracy (_tmp8_);
#line 123 "../src/math-converter.vala"
	_tmp10_ = _tmp9_;
#line 123 "../src/math-converter.vala"
	_tmp11_ = serializer_new (DISPLAY_FORMAT_FIXED, 10, _tmp10_);
#line 123 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->fixed_serializer);
#line 123 "../src/math-converter.vala"
	self->priv->fixed_serializer = _tmp11_;
#line 125 "../src/math-converter.vala"
	_tmp12_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 125 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->from_number);
#line 125 "../src/math-converter.vala"
	self->priv->from_number = _tmp12_;
#line 126 "../src/math-converter.vala"
	_tmp13_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 126 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->to_number);
#line 126 "../src/math-converter.vala"
	self->priv->to_number = _tmp13_;
#line 127 "../src/math-converter.vala"
	_tmp14_ = self->priv->from_entry;
#line 127 "../src/math-converter.vala"
	_tmp15_ = self->priv->_equation;
#line 127 "../src/math-converter.vala"
	_tmp16_ = math_equation_get_serializer (_tmp15_);
#line 127 "../src/math-converter.vala"
	_tmp17_ = _tmp16_;
#line 127 "../src/math-converter.vala"
	math_converter_update_entry (self, _tmp14_, _tmp17_);
#line 128 "../src/math-converter.vala"
	_tmp18_ = self->priv->to_entry;
#line 128 "../src/math-converter.vala"
	_tmp19_ = self->priv->_equation;
#line 128 "../src/math-converter.vala"
	_tmp20_ = math_equation_get_serializer (_tmp19_);
#line 128 "../src/math-converter.vala"
	_tmp21_ = _tmp20_;
#line 128 "../src/math-converter.vala"
	math_converter_update_entry (self, _tmp18_, _tmp21_);
#line 129 "../src/math-converter.vala"
	_tmp22_ = self->priv->from_entry;
#line 129 "../src/math-converter.vala"
	_tmp23_ = gtk_text_view_get_buffer (_tmp22_);
#line 129 "../src/math-converter.vala"
	_tmp24_ = _tmp23_;
#line 129 "../src/math-converter.vala"
	_tmp25_ = g_signal_connect_object (_tmp24_, "changed", (GCallback) _math_converter_from_entry_changed_cb_gtk_text_buffer_changed, self, 0);
#line 129 "../src/math-converter.vala"
	self->priv->from_entry_changed = _tmp25_;
#line 130 "../src/math-converter.vala"
	_tmp26_ = self->priv->to_entry;
#line 130 "../src/math-converter.vala"
	_tmp27_ = gtk_text_view_get_buffer (_tmp26_);
#line 130 "../src/math-converter.vala"
	_tmp28_ = _tmp27_;
#line 130 "../src/math-converter.vala"
	_tmp29_ = g_signal_connect_object (_tmp28_, "changed", (GCallback) _math_converter_to_entry_changed_cb_gtk_text_buffer_changed, self, 0);
#line 130 "../src/math-converter.vala"
	self->priv->to_entry_changed = _tmp29_;
#line 132 "../src/math-converter.vala"
	if (gtk_widget_get_default_direction () == GTK_TEXT_DIR_RTL) {
#line 812 "math-converter.c"
		GtkTextView* _tmp30_;
		GtkTextView* _tmp31_;
#line 134 "../src/math-converter.vala"
		_tmp30_ = self->priv->from_entry;
#line 134 "../src/math-converter.vala"
		gtk_text_view_set_justification (_tmp30_, GTK_JUSTIFY_RIGHT);
#line 135 "../src/math-converter.vala"
		_tmp31_ = self->priv->to_entry;
#line 135 "../src/math-converter.vala"
		gtk_text_view_set_justification (_tmp31_, GTK_JUSTIFY_RIGHT);
#line 823 "math-converter.c"
	}
#line 138 "../src/math-converter.vala"
	_tmp32_ = (GtkSignalListItemFactory*) gtk_signal_list_item_factory_new ();
#line 138 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->from_currency_factory);
#line 138 "../src/math-converter.vala"
	self->priv->from_currency_factory = _tmp32_;
#line 139 "../src/math-converter.vala"
	_tmp33_ = self->priv->from_currency_factory;
#line 139 "../src/math-converter.vala"
	g_signal_connect_object (_tmp33_, "setup", (GCallback) _math_converter_setup_currency_gtk_signal_list_item_factory_setup, self, 0);
#line 140 "../src/math-converter.vala"
	_tmp34_ = self->priv->from_currency_factory;
#line 140 "../src/math-converter.vala"
	g_signal_connect_object (_tmp34_, "bind", (GCallback) ___lambda8__gtk_signal_list_item_factory_bind, self, 0);
#line 141 "../src/math-converter.vala"
	_tmp35_ = self->priv->from_currency_factory;
#line 141 "../src/math-converter.vala"
	g_signal_connect_object (_tmp35_, "unbind", (GCallback) ___lambda10__gtk_signal_list_item_factory_unbind, self, 0);
#line 143 "../src/math-converter.vala"
	_tmp36_ = (GtkSignalListItemFactory*) gtk_signal_list_item_factory_new ();
#line 143 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->to_currency_factory);
#line 143 "../src/math-converter.vala"
	self->priv->to_currency_factory = _tmp36_;
#line 144 "../src/math-converter.vala"
	_tmp37_ = self->priv->to_currency_factory;
#line 144 "../src/math-converter.vala"
	g_signal_connect_object (_tmp37_, "setup", (GCallback) _math_converter_setup_currency_gtk_signal_list_item_factory_setup, self, 0);
#line 145 "../src/math-converter.vala"
	_tmp38_ = self->priv->to_currency_factory;
#line 145 "../src/math-converter.vala"
	g_signal_connect_object (_tmp38_, "bind", (GCallback) ___lambda11__gtk_signal_list_item_factory_bind, self, 0);
#line 146 "../src/math-converter.vala"
	_tmp39_ = self->priv->to_currency_factory;
#line 146 "../src/math-converter.vala"
	g_signal_connect_object (_tmp39_, "unbind", (GCallback) ___lambda12__gtk_signal_list_item_factory_unbind, self, 0);
#line 148 "../src/math-converter.vala"
	_tmp40_ = g_settings_new ("org.gnome.calculator");
#line 148 "../src/math-converter.vala"
	settings = _tmp40_;
#line 149 "../src/math-converter.vala"
	_tmp41_ = settings;
#line 149 "../src/math-converter.vala"
	g_settings_bind (_tmp41_, "currency-display", (GObject*) self, "currency_display", G_SETTINGS_BIND_GET);
#line 106 "../src/math-converter.vala"
	_g_object_unref0 (settings);
#line 871 "math-converter.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 160 "../src/math-converter.vala"
	return self ? g_object_ref (self) : NULL;
#line 879 "math-converter.c"
}

static gint
____lambda7_ (MathConverter* self,
              GObject* c1,
              GObject* c2)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gint _tmp6_;
	gint result;
#line 162 "../src/math-converter.vala"
	g_return_val_if_fail (c1 != NULL, 0);
#line 162 "../src/math-converter.vala"
	g_return_val_if_fail (c2 != NULL, 0);
#line 163 "../src/math-converter.vala"
	_tmp0_ = unit_category_get_display_name (G_TYPE_CHECK_INSTANCE_TYPE (c1, TYPE_UNIT_CATEGORY) ? ((UnitCategory*) c1) : NULL);
#line 163 "../src/math-converter.vala"
	_tmp1_ = _tmp0_;
#line 163 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 163 "../src/math-converter.vala"
	_tmp3_ = unit_category_get_display_name (G_TYPE_CHECK_INSTANCE_TYPE (c2, TYPE_UNIT_CATEGORY) ? ((UnitCategory*) c2) : NULL);
#line 163 "../src/math-converter.vala"
	_tmp4_ = _tmp3_;
#line 163 "../src/math-converter.vala"
	_tmp5_ = _tmp4_;
#line 163 "../src/math-converter.vala"
	_tmp6_ = g_utf8_collate (_tmp2_, _tmp5_);
#line 163 "../src/math-converter.vala"
	_g_free0 (_tmp5_);
#line 163 "../src/math-converter.vala"
	_g_free0 (_tmp2_);
#line 163 "../src/math-converter.vala"
	result = _tmp6_;
#line 163 "../src/math-converter.vala"
	return result;
#line 921 "math-converter.c"
}

static gint
_____lambda7__gcompare_data_func (gconstpointer a,
                                  gconstpointer b,
                                  gpointer self)
{
	gint result;
	result = ____lambda7_ ((MathConverter*) self, (GObject*) a, (GObject*) b);
#line 162 "../src/math-converter.vala"
	return result;
#line 933 "math-converter.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 152 "../src/math-converter.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 941 "math-converter.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 152 "../src/math-converter.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 949 "math-converter.c"
}

static void
math_converter_build_category_model (MathConverter* self)
{
	GListStore* category_model = NULL;
	GListStore* _tmp0_;
	GtkPropertyExpression* expression = NULL;
	GtkPropertyExpression* _tmp1_;
	GList* categories = NULL;
	UnitManager* _tmp2_;
	UnitManager* _tmp3_;
	GList* _tmp4_;
	GList* _tmp5_;
	GList* _tmp6_;
	GtkDropDown* _tmp10_;
	GtkPropertyExpression* _tmp11_;
	GtkDropDown* _tmp12_;
	GListStore* _tmp13_;
#line 152 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 154 "../src/math-converter.vala"
	_tmp0_ = g_list_store_new (TYPE_UNIT_CATEGORY);
#line 154 "../src/math-converter.vala"
	category_model = _tmp0_;
#line 155 "../src/math-converter.vala"
	_tmp1_ = (GtkPropertyExpression*) gtk_property_expression_new (TYPE_UNIT_CATEGORY, NULL, "display_name");
#line 155 "../src/math-converter.vala"
	expression = _tmp1_;
#line 159 "../src/math-converter.vala"
	_tmp2_ = unit_manager_get_default ();
#line 159 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 159 "../src/math-converter.vala"
	_tmp4_ = unit_manager_get_categories (_tmp3_);
#line 159 "../src/math-converter.vala"
	_tmp5_ = _tmp4_;
#line 159 "../src/math-converter.vala"
	_g_object_unref0 (_tmp3_);
#line 159 "../src/math-converter.vala"
	categories = _tmp5_;
#line 160 "../src/math-converter.vala"
	_tmp6_ = categories;
#line 993 "math-converter.c"
	{
		GList* category_collection = NULL;
		GList* category_it = NULL;
#line 160 "../src/math-converter.vala"
		category_collection = _tmp6_;
#line 160 "../src/math-converter.vala"
		for (category_it = category_collection; category_it != NULL; category_it = category_it->next) {
#line 1001 "math-converter.c"
			UnitCategory* _tmp7_;
			UnitCategory* category = NULL;
#line 160 "../src/math-converter.vala"
			_tmp7_ = _g_object_ref0 ((UnitCategory*) category_it->data);
#line 160 "../src/math-converter.vala"
			category = _tmp7_;
#line 1008 "math-converter.c"
			{
				GListStore* _tmp8_;
				UnitCategory* _tmp9_;
#line 162 "../src/math-converter.vala"
				_tmp8_ = category_model;
#line 162 "../src/math-converter.vala"
				_tmp9_ = category;
#line 162 "../src/math-converter.vala"
				g_list_store_insert_sorted (_tmp8_, (GObject*) _tmp9_, _____lambda7__gcompare_data_func, self);
#line 160 "../src/math-converter.vala"
				_g_object_unref0 (category);
#line 1020 "math-converter.c"
			}
		}
	}
#line 166 "../src/math-converter.vala"
	_tmp10_ = self->priv->category_combo;
#line 166 "../src/math-converter.vala"
	_tmp11_ = expression;
#line 166 "../src/math-converter.vala"
	gtk_drop_down_set_expression (_tmp10_, (GtkExpression*) _tmp11_);
#line 167 "../src/math-converter.vala"
	_tmp12_ = self->priv->category_combo;
#line 167 "../src/math-converter.vala"
	_tmp13_ = category_model;
#line 167 "../src/math-converter.vala"
	gtk_drop_down_set_model (_tmp12_, (GListModel*) _tmp13_);
#line 152 "../src/math-converter.vala"
	(categories == NULL) ? NULL : (categories = (_g_list_free__g_object_unref0_ (categories), NULL));
#line 152 "../src/math-converter.vala"
	_gtk_expression_unref0 (expression);
#line 152 "../src/math-converter.vala"
	_g_object_unref0 (category_model);
#line 1042 "math-converter.c"
}

static void
math_converter_load_selected_units (MathConverter* self,
                                    GHashTable* units,
                                    gchar** value,
                                    gint value_length1)
{
#line 170 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/math-converter.vala"
	g_return_if_fail (units != NULL);
#line 1055 "math-converter.c"
	{
		gchar** unit_collection = NULL;
		gint unit_collection_length1 = 0;
		gint _unit_collection_size_ = 0;
		gint unit_it = 0;
#line 173 "../src/math-converter.vala"
		unit_collection = value;
#line 173 "../src/math-converter.vala"
		unit_collection_length1 = value_length1;
#line 173 "../src/math-converter.vala"
		for (unit_it = 0; unit_it < unit_collection_length1; unit_it = unit_it + 1) {
#line 1067 "math-converter.c"
			gchar* _tmp0_;
			gchar* unit = NULL;
#line 173 "../src/math-converter.vala"
			_tmp0_ = g_strdup (unit_collection[unit_it]);
#line 173 "../src/math-converter.vala"
			unit = _tmp0_;
#line 1074 "math-converter.c"
			{
				UnitCategory* category = NULL;
				UnitManager* _tmp1_;
				UnitManager* _tmp2_;
				const gchar* _tmp3_;
				UnitCategory* _tmp4_;
				UnitCategory* _tmp5_;
				UnitCategory* _tmp6_;
#line 175 "../src/math-converter.vala"
				_tmp1_ = unit_manager_get_default ();
#line 175 "../src/math-converter.vala"
				_tmp2_ = _tmp1_;
#line 175 "../src/math-converter.vala"
				_tmp3_ = unit;
#line 175 "../src/math-converter.vala"
				_tmp4_ = unit_manager_get_category_of_unit (_tmp2_, _tmp3_);
#line 175 "../src/math-converter.vala"
				_tmp5_ = _tmp4_;
#line 175 "../src/math-converter.vala"
				_g_object_unref0 (_tmp2_);
#line 175 "../src/math-converter.vala"
				category = _tmp5_;
#line 176 "../src/math-converter.vala"
				_tmp6_ = category;
#line 176 "../src/math-converter.vala"
				if (_tmp6_ != NULL) {
#line 1101 "math-converter.c"
					UnitCategory* _tmp7_;
					gchar* _tmp8_;
					gchar* _tmp9_;
					const gchar* _tmp10_;
					gchar* _tmp11_;
#line 177 "../src/math-converter.vala"
					_tmp7_ = category;
#line 177 "../src/math-converter.vala"
					_tmp8_ = unit_category_get_name (_tmp7_);
#line 177 "../src/math-converter.vala"
					_tmp9_ = _tmp8_;
#line 177 "../src/math-converter.vala"
					_tmp10_ = unit;
#line 177 "../src/math-converter.vala"
					_tmp11_ = g_strdup (_tmp10_);
#line 177 "../src/math-converter.vala"
					g_hash_table_insert (units, _tmp9_, _tmp11_);
#line 1119 "math-converter.c"
				}
#line 173 "../src/math-converter.vala"
				_g_object_unref0 (category);
#line 173 "../src/math-converter.vala"
				_g_free0 (unit);
#line 1125 "math-converter.c"
			}
		}
	}
}

void
math_converter_set_category (MathConverter* self,
                             const gchar* category)
{
	const gchar* _tmp0_;
	UnitCategory* unit_category = NULL;
	UnitManager* _tmp1_;
	UnitManager* _tmp2_;
	UnitCategory* _tmp3_;
	UnitCategory* _tmp4_;
	UnitCategory* _tmp5_;
#line 181 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 181 "../src/math-converter.vala"
	g_return_if_fail (category != NULL);
#line 183 "../src/math-converter.vala"
	_tmp0_ = self->priv->category;
#line 183 "../src/math-converter.vala"
	if (g_strcmp0 (_tmp0_, category) == 0) {
#line 185 "../src/math-converter.vala"
		math_converter_category_combobox_changed_cb (self);
#line 186 "../src/math-converter.vala"
		return;
#line 1154 "math-converter.c"
	}
#line 188 "../src/math-converter.vala"
	_tmp1_ = unit_manager_get_default ();
#line 188 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 188 "../src/math-converter.vala"
	_tmp3_ = unit_manager_get_category (_tmp2_, category);
#line 188 "../src/math-converter.vala"
	_tmp4_ = _tmp3_;
#line 188 "../src/math-converter.vala"
	_g_object_unref0 (_tmp2_);
#line 188 "../src/math-converter.vala"
	unit_category = _tmp4_;
#line 189 "../src/math-converter.vala"
	_tmp5_ = unit_category;
#line 189 "../src/math-converter.vala"
	if (_tmp5_ != NULL) {
#line 1172 "math-converter.c"
		gchar* _tmp6_;
		guint position = 0U;
		GListStore* model = NULL;
		GtkDropDown* _tmp7_;
		GListModel* _tmp8_;
		GListStore* _tmp9_;
		GListStore* _tmp10_;
		UnitCategory* _tmp11_;
		guint _tmp12_ = 0U;
		GtkDropDown* _tmp13_;
#line 191 "../src/math-converter.vala"
		_tmp6_ = g_strdup (category);
#line 191 "../src/math-converter.vala"
		_g_free0 (self->priv->category);
#line 191 "../src/math-converter.vala"
		self->priv->category = _tmp6_;
#line 192 "../src/math-converter.vala"
		position = (guint) 0;
#line 193 "../src/math-converter.vala"
		_tmp7_ = self->priv->category_combo;
#line 193 "../src/math-converter.vala"
		_tmp8_ = gtk_drop_down_get_model (_tmp7_);
#line 193 "../src/math-converter.vala"
		_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, g_list_store_get_type ()) ? ((GListStore*) _tmp8_) : NULL);
#line 193 "../src/math-converter.vala"
		model = _tmp9_;
#line 194 "../src/math-converter.vala"
		_tmp10_ = model;
#line 194 "../src/math-converter.vala"
		_tmp11_ = unit_category;
#line 194 "../src/math-converter.vala"
		g_list_store_find (_tmp10_, (GObject*) _tmp11_, &_tmp12_);
#line 194 "../src/math-converter.vala"
		position = _tmp12_;
#line 195 "../src/math-converter.vala"
		_tmp13_ = self->priv->category_combo;
#line 195 "../src/math-converter.vala"
		gtk_drop_down_set_selected (_tmp13_, position);
#line 189 "../src/math-converter.vala"
		_g_object_unref0 (model);
#line 1213 "math-converter.c"
	} else {
		GtkDropDown* _tmp14_;
#line 198 "../src/math-converter.vala"
		_tmp14_ = self->priv->category_combo;
#line 198 "../src/math-converter.vala"
		gtk_drop_down_set_selected (_tmp14_, (guint) 0);
#line 1220 "math-converter.c"
	}
#line 181 "../src/math-converter.vala"
	_g_object_unref0 (unit_category);
#line 1224 "math-converter.c"
}

gchar*
math_converter_get_category (MathConverter* self)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* result;
#line 201 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 203 "../src/math-converter.vala"
	_tmp0_ = self->priv->category;
#line 203 "../src/math-converter.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 203 "../src/math-converter.vala"
	result = _tmp1_;
#line 203 "../src/math-converter.vala"
	return result;
#line 1243 "math-converter.c"
}

gchar*
math_converter_get_focus_unit (MathConverter* self)
{
	GtkDropDown* _tmp0_ = NULL;
	GtkTextView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkDropDown* combo = NULL;
	GtkDropDown* _tmp6_;
	GObject* _tmp7_;
	GObject* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* result;
#line 206 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 208 "../src/math-converter.vala"
	_tmp1_ = self->priv->to_entry;
#line 208 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
#line 208 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 208 "../src/math-converter.vala"
	if (_tmp3_) {
#line 1270 "math-converter.c"
		GtkDropDown* _tmp4_;
#line 208 "../src/math-converter.vala"
		_tmp4_ = self->priv->to_combo;
#line 208 "../src/math-converter.vala"
		_tmp0_ = _tmp4_;
#line 1276 "math-converter.c"
	} else {
		GtkDropDown* _tmp5_;
#line 208 "../src/math-converter.vala"
		_tmp5_ = self->priv->from_combo;
#line 208 "../src/math-converter.vala"
		_tmp0_ = _tmp5_;
#line 1283 "math-converter.c"
	}
#line 208 "../src/math-converter.vala"
	_tmp6_ = _g_object_ref0 (_tmp0_);
#line 208 "../src/math-converter.vala"
	combo = _tmp6_;
#line 209 "../src/math-converter.vala"
	_tmp7_ = gtk_drop_down_get_selected_item (combo);
#line 209 "../src/math-converter.vala"
	_tmp8_ = _tmp7_;
#line 209 "../src/math-converter.vala"
	_tmp9_ = unit_get_name (G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, TYPE_UNIT) ? ((Unit*) _tmp8_) : NULL);
#line 209 "../src/math-converter.vala"
	_tmp10_ = _tmp9_;
#line 209 "../src/math-converter.vala"
	result = _tmp10_;
#line 209 "../src/math-converter.vala"
	_g_object_unref0 (combo);
#line 209 "../src/math-converter.vala"
	return result;
#line 1303 "math-converter.c"
}

void
math_converter_insert_text (MathConverter* self,
                            const gchar* text,
                            gboolean replace_zero)
{
	gboolean _tmp0_;
	GtkTextView* _tmp1_ = NULL;
	GtkTextView* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GtkTextView* entry = NULL;
	GtkTextView* _tmp7_;
	GtkTextView* _tmp8_;
	GtkTextView* _tmp9_;
	gboolean _tmp11_ = FALSE;
	GtkTextView* _tmp29_;
	GtkTextBuffer* _tmp30_;
	GtkTextBuffer* _tmp31_;
	GtkTextView* _tmp32_;
	GtkTextBuffer* _tmp33_;
	GtkTextBuffer* _tmp34_;
	gint _tmp35_;
	gint _tmp36_;
#line 212 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 212 "../src/math-converter.vala"
	g_return_if_fail (text != NULL);
#line 214 "../src/math-converter.vala"
	_tmp0_ = self->priv->_box_visible;
#line 214 "../src/math-converter.vala"
	if (!_tmp0_) {
#line 215 "../src/math-converter.vala"
		return;
#line 1339 "math-converter.c"
	}
#line 217 "../src/math-converter.vala"
	_tmp2_ = self->priv->to_entry;
#line 217 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp2_, "has-focus", &_tmp3_, NULL);
#line 217 "../src/math-converter.vala"
	_tmp4_ = _tmp3_;
#line 217 "../src/math-converter.vala"
	if (_tmp4_) {
#line 1349 "math-converter.c"
		GtkTextView* _tmp5_;
#line 217 "../src/math-converter.vala"
		_tmp5_ = self->priv->to_entry;
#line 217 "../src/math-converter.vala"
		_tmp1_ = _tmp5_;
#line 1355 "math-converter.c"
	} else {
		GtkTextView* _tmp6_;
#line 217 "../src/math-converter.vala"
		_tmp6_ = self->priv->from_entry;
#line 217 "../src/math-converter.vala"
		_tmp1_ = _tmp6_;
#line 1362 "math-converter.c"
	}
#line 217 "../src/math-converter.vala"
	_tmp7_ = _g_object_ref0 (_tmp1_);
#line 217 "../src/math-converter.vala"
	entry = _tmp7_;
#line 218 "../src/math-converter.vala"
	_tmp8_ = entry;
#line 218 "../src/math-converter.vala"
	_tmp9_ = self->priv->from_entry;
#line 218 "../src/math-converter.vala"
	if (_tmp8_ == _tmp9_) {
#line 1374 "math-converter.c"
		GtkTextView* _tmp10_;
#line 219 "../src/math-converter.vala"
		_tmp10_ = self->priv->from_entry;
#line 219 "../src/math-converter.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp10_);
#line 1380 "math-converter.c"
	}
#line 220 "../src/math-converter.vala"
	if (replace_zero) {
#line 1384 "math-converter.c"
		GtkTextView* _tmp12_;
		GtkTextBuffer* _tmp13_;
		GtkTextBuffer* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
#line 220 "../src/math-converter.vala"
		_tmp12_ = entry;
#line 220 "../src/math-converter.vala"
		_tmp13_ = gtk_text_view_get_buffer (_tmp12_);
#line 220 "../src/math-converter.vala"
		_tmp14_ = _tmp13_;
#line 220 "../src/math-converter.vala"
		g_object_get (_tmp14_, "text", &_tmp15_, NULL);
#line 220 "../src/math-converter.vala"
		_tmp16_ = _tmp15_;
#line 220 "../src/math-converter.vala"
		_tmp17_ = _tmp16_;
#line 220 "../src/math-converter.vala"
		_tmp11_ = g_strcmp0 (_tmp17_, "0") == 0;
#line 220 "../src/math-converter.vala"
		_g_free0 (_tmp17_);
#line 1407 "math-converter.c"
	} else {
#line 220 "../src/math-converter.vala"
		_tmp11_ = FALSE;
#line 1411 "math-converter.c"
	}
#line 220 "../src/math-converter.vala"
	if (_tmp11_) {
#line 1415 "math-converter.c"
		GtkTextIter iter = {0};
		GtkTextView* _tmp18_;
		GtkTextBuffer* _tmp19_;
		GtkTextBuffer* _tmp20_;
		GtkTextView* _tmp21_;
		GtkTextBuffer* _tmp22_;
		GtkTextBuffer* _tmp23_;
		GtkTextMark* _tmp24_;
		GtkTextIter _tmp25_ = {0};
#line 223 "../src/math-converter.vala"
		_tmp18_ = entry;
#line 223 "../src/math-converter.vala"
		_tmp19_ = gtk_text_view_get_buffer (_tmp18_);
#line 223 "../src/math-converter.vala"
		_tmp20_ = _tmp19_;
#line 223 "../src/math-converter.vala"
		_tmp21_ = entry;
#line 223 "../src/math-converter.vala"
		_tmp22_ = gtk_text_view_get_buffer (_tmp21_);
#line 223 "../src/math-converter.vala"
		_tmp23_ = _tmp22_;
#line 223 "../src/math-converter.vala"
		_tmp24_ = gtk_text_buffer_get_insert (_tmp23_);
#line 223 "../src/math-converter.vala"
		gtk_text_buffer_get_iter_at_mark (_tmp20_, &_tmp25_, _tmp24_);
#line 223 "../src/math-converter.vala"
		iter = _tmp25_;
#line 224 "../src/math-converter.vala"
		if (gtk_text_iter_is_end (&iter)) {
#line 1445 "math-converter.c"
			GtkTextView* _tmp26_;
			GtkTextBuffer* _tmp27_;
			GtkTextBuffer* _tmp28_;
#line 225 "../src/math-converter.vala"
			_tmp26_ = entry;
#line 225 "../src/math-converter.vala"
			_tmp27_ = gtk_text_view_get_buffer (_tmp26_);
#line 225 "../src/math-converter.vala"
			_tmp28_ = _tmp27_;
#line 225 "../src/math-converter.vala"
			g_object_set (_tmp28_, "text", "", NULL);
#line 1457 "math-converter.c"
		}
	}
#line 227 "../src/math-converter.vala"
	_tmp29_ = entry;
#line 227 "../src/math-converter.vala"
	_tmp30_ = gtk_text_view_get_buffer (_tmp29_);
#line 227 "../src/math-converter.vala"
	_tmp31_ = _tmp30_;
#line 227 "../src/math-converter.vala"
	gtk_text_buffer_delete_selection (_tmp31_, TRUE, TRUE);
#line 228 "../src/math-converter.vala"
	_tmp32_ = entry;
#line 228 "../src/math-converter.vala"
	_tmp33_ = gtk_text_view_get_buffer (_tmp32_);
#line 228 "../src/math-converter.vala"
	_tmp34_ = _tmp33_;
#line 228 "../src/math-converter.vala"
	_tmp35_ = strlen (text);
#line 228 "../src/math-converter.vala"
	_tmp36_ = _tmp35_;
#line 228 "../src/math-converter.vala"
	gtk_text_buffer_insert_at_cursor (_tmp34_, text, _tmp36_);
#line 212 "../src/math-converter.vala"
	_g_object_unref0 (entry);
#line 1482 "math-converter.c"
}

static gchar*
g_unichar_to_string (gunichar self)
{
	gchar* str = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1122 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, 7);
#line 1122 "glib-2.0.vapi"
	str = (gchar*) _tmp0_;
#line 1123 "glib-2.0.vapi"
	g_unichar_to_utf8 (self, str);
#line 1124 "glib-2.0.vapi"
	result = str;
#line 1124 "glib-2.0.vapi"
	return result;
#line 1501 "math-converter.c"
}

void
math_converter_insert_numeric_point (MathConverter* self)
{
	Serializer* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 231 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 233 "../src/math-converter.vala"
	_tmp0_ = self->priv->fixed_serializer;
#line 233 "../src/math-converter.vala"
	_tmp1_ = g_unichar_to_string (serializer_get_radix (_tmp0_));
#line 233 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 233 "../src/math-converter.vala"
	math_converter_insert_text (self, _tmp2_, FALSE);
#line 233 "../src/math-converter.vala"
	_g_free0 (_tmp2_);
#line 1522 "math-converter.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1584 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1585 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1585 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1585 "glib-2.0.vapi"
	return result;
#line 1541 "math-converter.c"
}

void
math_converter_insert_dms (MathConverter* self)
{
	GtkTextView* _tmp0_ = NULL;
	GtkTextView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkTextView* entry = NULL;
	GtkTextView* _tmp6_;
	GtkTextView* _tmp7_;
	GtkTextView* _tmp8_;
	gchar** dms = NULL;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar** _tmp13_;
	gint dms_length1;
	gint _dms_size_;
#line 236 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 238 "../src/math-converter.vala"
	_tmp1_ = self->priv->to_entry;
#line 238 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
#line 238 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 238 "../src/math-converter.vala"
	if (_tmp3_) {
#line 1572 "math-converter.c"
		GtkTextView* _tmp4_;
#line 238 "../src/math-converter.vala"
		_tmp4_ = self->priv->to_entry;
#line 238 "../src/math-converter.vala"
		_tmp0_ = _tmp4_;
#line 1578 "math-converter.c"
	} else {
		GtkTextView* _tmp5_;
#line 238 "../src/math-converter.vala"
		_tmp5_ = self->priv->from_entry;
#line 238 "../src/math-converter.vala"
		_tmp0_ = _tmp5_;
#line 1585 "math-converter.c"
	}
#line 238 "../src/math-converter.vala"
	_tmp6_ = _g_object_ref0 (_tmp0_);
#line 238 "../src/math-converter.vala"
	entry = _tmp6_;
#line 239 "../src/math-converter.vala"
	_tmp7_ = entry;
#line 239 "../src/math-converter.vala"
	_tmp8_ = self->priv->from_entry;
#line 239 "../src/math-converter.vala"
	if (_tmp7_ == _tmp8_) {
#line 1597 "math-converter.c"
		GtkTextView* _tmp9_;
#line 240 "../src/math-converter.vala"
		_tmp9_ = self->priv->from_entry;
#line 240 "../src/math-converter.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp9_);
#line 1603 "math-converter.c"
	}
#line 241 "../src/math-converter.vala"
	_tmp10_ = g_strdup ("°");
#line 241 "../src/math-converter.vala"
	_tmp11_ = g_strdup ("′");
#line 241 "../src/math-converter.vala"
	_tmp12_ = g_strdup ("″");
#line 241 "../src/math-converter.vala"
	_tmp13_ = g_new0 (gchar*, 3 + 1);
#line 241 "../src/math-converter.vala"
	_tmp13_[0] = _tmp10_;
#line 241 "../src/math-converter.vala"
	_tmp13_[1] = _tmp11_;
#line 241 "../src/math-converter.vala"
	_tmp13_[2] = _tmp12_;
#line 241 "../src/math-converter.vala"
	dms = _tmp13_;
#line 241 "../src/math-converter.vala"
	dms_length1 = 3;
#line 241 "../src/math-converter.vala"
	_dms_size_ = dms_length1;
#line 1625 "math-converter.c"
	{
		gint i = 0;
#line 242 "../src/math-converter.vala"
		i = 0;
#line 1630 "math-converter.c"
		{
			gboolean _tmp14_ = FALSE;
#line 242 "../src/math-converter.vala"
			_tmp14_ = TRUE;
#line 242 "../src/math-converter.vala"
			while (TRUE) {
#line 1637 "math-converter.c"
				GtkTextView* _tmp16_;
				GtkTextBuffer* _tmp17_;
				GtkTextBuffer* _tmp18_;
				gchar* _tmp19_;
				gchar* _tmp20_;
				gchar* _tmp21_;
				gchar** _tmp22_;
				gint _tmp22__length1;
				const gchar* _tmp23_;
				gboolean _tmp24_;
#line 242 "../src/math-converter.vala"
				if (!_tmp14_) {
#line 1650 "math-converter.c"
					gint _tmp15_;
#line 242 "../src/math-converter.vala"
					_tmp15_ = i;
#line 242 "../src/math-converter.vala"
					i = _tmp15_ + 1;
#line 1656 "math-converter.c"
				}
#line 242 "../src/math-converter.vala"
				_tmp14_ = FALSE;
#line 242 "../src/math-converter.vala"
				if (!(i < 3)) {
#line 242 "../src/math-converter.vala"
					break;
#line 1664 "math-converter.c"
				}
#line 243 "../src/math-converter.vala"
				_tmp16_ = entry;
#line 243 "../src/math-converter.vala"
				_tmp17_ = gtk_text_view_get_buffer (_tmp16_);
#line 243 "../src/math-converter.vala"
				_tmp18_ = _tmp17_;
#line 243 "../src/math-converter.vala"
				g_object_get (_tmp18_, "text", &_tmp19_, NULL);
#line 243 "../src/math-converter.vala"
				_tmp20_ = _tmp19_;
#line 243 "../src/math-converter.vala"
				_tmp21_ = _tmp20_;
#line 243 "../src/math-converter.vala"
				_tmp22_ = dms;
#line 243 "../src/math-converter.vala"
				_tmp22__length1 = dms_length1;
#line 243 "../src/math-converter.vala"
				_tmp23_ = _tmp22_[i];
#line 243 "../src/math-converter.vala"
				_tmp24_ = !string_contains (_tmp21_, _tmp23_);
#line 243 "../src/math-converter.vala"
				_g_free0 (_tmp21_);
#line 243 "../src/math-converter.vala"
				if (_tmp24_) {
#line 1690 "math-converter.c"
					GtkTextView* _tmp25_;
					GtkTextBuffer* _tmp26_;
					GtkTextBuffer* _tmp27_;
					GtkTextView* _tmp28_;
					GtkTextBuffer* _tmp29_;
					GtkTextBuffer* _tmp30_;
					gchar** _tmp31_;
					gint _tmp31__length1;
					const gchar* _tmp32_;
					gchar** _tmp33_;
					gint _tmp33__length1;
					const gchar* _tmp34_;
					gint _tmp35_;
					gint _tmp36_;
#line 245 "../src/math-converter.vala"
					_tmp25_ = entry;
#line 245 "../src/math-converter.vala"
					_tmp26_ = gtk_text_view_get_buffer (_tmp25_);
#line 245 "../src/math-converter.vala"
					_tmp27_ = _tmp26_;
#line 245 "../src/math-converter.vala"
					gtk_text_buffer_delete_selection (_tmp27_, TRUE, TRUE);
#line 246 "../src/math-converter.vala"
					_tmp28_ = entry;
#line 246 "../src/math-converter.vala"
					_tmp29_ = gtk_text_view_get_buffer (_tmp28_);
#line 246 "../src/math-converter.vala"
					_tmp30_ = _tmp29_;
#line 246 "../src/math-converter.vala"
					_tmp31_ = dms;
#line 246 "../src/math-converter.vala"
					_tmp31__length1 = dms_length1;
#line 246 "../src/math-converter.vala"
					_tmp32_ = _tmp31_[i];
#line 246 "../src/math-converter.vala"
					_tmp33_ = dms;
#line 246 "../src/math-converter.vala"
					_tmp33__length1 = dms_length1;
#line 246 "../src/math-converter.vala"
					_tmp34_ = _tmp33_[i];
#line 246 "../src/math-converter.vala"
					_tmp35_ = strlen (_tmp34_);
#line 246 "../src/math-converter.vala"
					_tmp36_ = _tmp35_;
#line 246 "../src/math-converter.vala"
					gtk_text_buffer_insert_at_cursor (_tmp30_, _tmp32_, _tmp36_);
#line 247 "../src/math-converter.vala"
					dms = (_vala_array_free (dms, dms_length1, (GDestroyNotify) g_free), NULL);
#line 247 "../src/math-converter.vala"
					_g_object_unref0 (entry);
#line 247 "../src/math-converter.vala"
					return;
#line 1743 "math-converter.c"
				}
			}
		}
	}
#line 236 "../src/math-converter.vala"
	dms = (_vala_array_free (dms, dms_length1, (GDestroyNotify) g_free), NULL);
#line 236 "../src/math-converter.vala"
	_g_object_unref0 (entry);
#line 1752 "math-converter.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1535 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1535 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1536 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1537 "glib-2.0.vapi"
		start = string_length + start;
#line 1779 "math-converter.c"
	}
#line 1539 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1540 "glib-2.0.vapi"
		end = string_length + end;
#line 1785 "math-converter.c"
	}
#line 1542 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 1791 "math-converter.c"
	} else {
#line 1542 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 1795 "math-converter.c"
	}
#line 1542 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1543 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 1803 "math-converter.c"
	} else {
#line 1543 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 1807 "math-converter.c"
	}
#line 1543 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1544 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1545 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1545 "glib-2.0.vapi"
	result = _tmp4_;
#line 1545 "glib-2.0.vapi"
	return result;
#line 1819 "math-converter.c"
}

void
math_converter_change_sign (MathConverter* self)
{
	GtkTextView* _tmp0_ = NULL;
	GtkTextView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkTextView* entry = NULL;
	GtkTextView* _tmp6_;
	GtkTextView* _tmp7_;
	GtkTextView* _tmp8_;
	gchar* text = NULL;
	GtkTextView* _tmp10_;
	GtkTextBuffer* _tmp11_;
	GtkTextBuffer* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_;
#line 251 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 253 "../src/math-converter.vala"
	_tmp1_ = self->priv->to_entry;
#line 253 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
#line 253 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 253 "../src/math-converter.vala"
	if (_tmp3_) {
#line 1850 "math-converter.c"
		GtkTextView* _tmp4_;
#line 253 "../src/math-converter.vala"
		_tmp4_ = self->priv->to_entry;
#line 253 "../src/math-converter.vala"
		_tmp0_ = _tmp4_;
#line 1856 "math-converter.c"
	} else {
		GtkTextView* _tmp5_;
#line 253 "../src/math-converter.vala"
		_tmp5_ = self->priv->from_entry;
#line 253 "../src/math-converter.vala"
		_tmp0_ = _tmp5_;
#line 1863 "math-converter.c"
	}
#line 253 "../src/math-converter.vala"
	_tmp6_ = _g_object_ref0 (_tmp0_);
#line 253 "../src/math-converter.vala"
	entry = _tmp6_;
#line 254 "../src/math-converter.vala"
	_tmp7_ = entry;
#line 254 "../src/math-converter.vala"
	_tmp8_ = self->priv->from_entry;
#line 254 "../src/math-converter.vala"
	if (_tmp7_ == _tmp8_) {
#line 1875 "math-converter.c"
		GtkTextView* _tmp9_;
#line 255 "../src/math-converter.vala"
		_tmp9_ = self->priv->from_entry;
#line 255 "../src/math-converter.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp9_);
#line 1881 "math-converter.c"
	}
#line 256 "../src/math-converter.vala"
	_tmp10_ = entry;
#line 256 "../src/math-converter.vala"
	_tmp11_ = gtk_text_view_get_buffer (_tmp10_);
#line 256 "../src/math-converter.vala"
	_tmp12_ = _tmp11_;
#line 256 "../src/math-converter.vala"
	g_object_get (_tmp12_, "text", &_tmp13_, NULL);
#line 256 "../src/math-converter.vala"
	_tmp14_ = _tmp13_;
#line 256 "../src/math-converter.vala"
	text = _tmp14_;
#line 257 "../src/math-converter.vala"
	_tmp15_ = text;
#line 257 "../src/math-converter.vala"
	if (g_strcmp0 (_tmp15_, "0") == 0) {
#line 1899 "math-converter.c"
		GtkTextView* _tmp16_;
		GtkTextBuffer* _tmp17_;
		GtkTextBuffer* _tmp18_;
#line 258 "../src/math-converter.vala"
		_tmp16_ = entry;
#line 258 "../src/math-converter.vala"
		_tmp17_ = gtk_text_view_get_buffer (_tmp16_);
#line 258 "../src/math-converter.vala"
		_tmp18_ = _tmp17_;
#line 258 "../src/math-converter.vala"
		g_object_set (_tmp18_, "text", "−", NULL);
#line 1911 "math-converter.c"
	} else {
		const gchar* _tmp19_;
#line 259 "../src/math-converter.vala"
		_tmp19_ = text;
#line 259 "../src/math-converter.vala"
		if (g_str_has_prefix (_tmp19_, "−")) {
#line 1918 "math-converter.c"
			GtkTextView* _tmp20_;
			GtkTextBuffer* _tmp21_;
			GtkTextBuffer* _tmp22_;
			const gchar* _tmp23_;
			gint _tmp24_;
			gint _tmp25_;
			const gchar* _tmp26_;
			gint _tmp27_;
			gint _tmp28_;
			gchar* _tmp29_;
			gchar* _tmp30_;
#line 260 "../src/math-converter.vala"
			_tmp20_ = entry;
#line 260 "../src/math-converter.vala"
			_tmp21_ = gtk_text_view_get_buffer (_tmp20_);
#line 260 "../src/math-converter.vala"
			_tmp22_ = _tmp21_;
#line 260 "../src/math-converter.vala"
			_tmp23_ = text;
#line 260 "../src/math-converter.vala"
			_tmp24_ = strlen ("−");
#line 260 "../src/math-converter.vala"
			_tmp25_ = _tmp24_;
#line 260 "../src/math-converter.vala"
			_tmp26_ = text;
#line 260 "../src/math-converter.vala"
			_tmp27_ = strlen (_tmp26_);
#line 260 "../src/math-converter.vala"
			_tmp28_ = _tmp27_;
#line 260 "../src/math-converter.vala"
			_tmp29_ = string_slice (_tmp26_, (glong) _tmp25_, (glong) _tmp28_);
#line 260 "../src/math-converter.vala"
			_tmp30_ = _tmp29_;
#line 260 "../src/math-converter.vala"
			g_object_set (_tmp22_, "text", _tmp30_, NULL);
#line 260 "../src/math-converter.vala"
			_g_free0 (_tmp30_);
#line 1956 "math-converter.c"
		} else {
			const gchar* _tmp31_;
#line 261 "../src/math-converter.vala"
			_tmp31_ = text;
#line 261 "../src/math-converter.vala"
			if (g_str_has_prefix (_tmp31_, "-")) {
#line 1963 "math-converter.c"
				GtkTextView* _tmp32_;
				GtkTextBuffer* _tmp33_;
				GtkTextBuffer* _tmp34_;
				const gchar* _tmp35_;
				gint _tmp36_;
				gint _tmp37_;
				const gchar* _tmp38_;
				gint _tmp39_;
				gint _tmp40_;
				gchar* _tmp41_;
				gchar* _tmp42_;
#line 262 "../src/math-converter.vala"
				_tmp32_ = entry;
#line 262 "../src/math-converter.vala"
				_tmp33_ = gtk_text_view_get_buffer (_tmp32_);
#line 262 "../src/math-converter.vala"
				_tmp34_ = _tmp33_;
#line 262 "../src/math-converter.vala"
				_tmp35_ = text;
#line 262 "../src/math-converter.vala"
				_tmp36_ = strlen ("-");
#line 262 "../src/math-converter.vala"
				_tmp37_ = _tmp36_;
#line 262 "../src/math-converter.vala"
				_tmp38_ = text;
#line 262 "../src/math-converter.vala"
				_tmp39_ = strlen (_tmp38_);
#line 262 "../src/math-converter.vala"
				_tmp40_ = _tmp39_;
#line 262 "../src/math-converter.vala"
				_tmp41_ = string_slice (_tmp38_, (glong) _tmp37_, (glong) _tmp40_);
#line 262 "../src/math-converter.vala"
				_tmp42_ = _tmp41_;
#line 262 "../src/math-converter.vala"
				g_object_set (_tmp34_, "text", _tmp42_, NULL);
#line 262 "../src/math-converter.vala"
				_g_free0 (_tmp42_);
#line 2001 "math-converter.c"
			} else {
				GtkTextView* _tmp43_;
				GtkTextBuffer* _tmp44_;
				GtkTextBuffer* _tmp45_;
				const gchar* _tmp46_;
				gchar* _tmp47_;
				gchar* _tmp48_;
#line 264 "../src/math-converter.vala"
				_tmp43_ = entry;
#line 264 "../src/math-converter.vala"
				_tmp44_ = gtk_text_view_get_buffer (_tmp43_);
#line 264 "../src/math-converter.vala"
				_tmp45_ = _tmp44_;
#line 264 "../src/math-converter.vala"
				_tmp46_ = text;
#line 264 "../src/math-converter.vala"
				_tmp47_ = g_strconcat ("−", _tmp46_, NULL);
#line 264 "../src/math-converter.vala"
				_tmp48_ = _tmp47_;
#line 264 "../src/math-converter.vala"
				g_object_set (_tmp45_, "text", _tmp48_, NULL);
#line 264 "../src/math-converter.vala"
				_g_free0 (_tmp48_);
#line 2025 "math-converter.c"
			}
		}
	}
#line 251 "../src/math-converter.vala"
	_g_free0 (text);
#line 251 "../src/math-converter.vala"
	_g_object_unref0 (entry);
#line 2033 "math-converter.c"
}

void
math_converter_clear (MathConverter* self)
{
	gboolean _tmp0_;
	GtkTextView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 267 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 269 "../src/math-converter.vala"
	_tmp0_ = self->priv->_box_visible;
#line 269 "../src/math-converter.vala"
	if (!_tmp0_) {
#line 270 "../src/math-converter.vala"
		return;
#line 2051 "math-converter.c"
	}
#line 272 "../src/math-converter.vala"
	_tmp1_ = self->priv->from_entry;
#line 272 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
#line 272 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 272 "../src/math-converter.vala"
	if (_tmp3_) {
#line 2061 "math-converter.c"
		GtkTextView* _tmp4_;
		GtkTextBuffer* _tmp5_;
		GtkTextBuffer* _tmp6_;
#line 273 "../src/math-converter.vala"
		_tmp4_ = self->priv->from_entry;
#line 273 "../src/math-converter.vala"
		_tmp5_ = gtk_text_view_get_buffer (_tmp4_);
#line 273 "../src/math-converter.vala"
		_tmp6_ = _tmp5_;
#line 273 "../src/math-converter.vala"
		g_object_set (_tmp6_, "text", "0", NULL);
#line 2073 "math-converter.c"
	} else {
		GtkTextView* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 274 "../src/math-converter.vala"
		_tmp7_ = self->priv->to_entry;
#line 274 "../src/math-converter.vala"
		g_object_get ((GtkWidget*) _tmp7_, "has-focus", &_tmp8_, NULL);
#line 274 "../src/math-converter.vala"
		_tmp9_ = _tmp8_;
#line 274 "../src/math-converter.vala"
		if (_tmp9_) {
#line 2086 "math-converter.c"
			GtkTextView* _tmp10_;
			GtkTextBuffer* _tmp11_;
			GtkTextBuffer* _tmp12_;
#line 275 "../src/math-converter.vala"
			_tmp10_ = self->priv->to_entry;
#line 275 "../src/math-converter.vala"
			_tmp11_ = gtk_text_view_get_buffer (_tmp10_);
#line 275 "../src/math-converter.vala"
			_tmp12_ = _tmp11_;
#line 275 "../src/math-converter.vala"
			g_object_set (_tmp12_, "text", "0", NULL);
#line 2098 "math-converter.c"
		} else {
			Number* _tmp13_;
			GtkTextView* _tmp14_;
			MathEquation* _tmp15_;
			Serializer* _tmp16_;
			Serializer* _tmp17_;
#line 278 "../src/math-converter.vala"
			_tmp13_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 278 "../src/math-converter.vala"
			_g_object_unref0 (self->priv->from_number);
#line 278 "../src/math-converter.vala"
			self->priv->from_number = _tmp13_;
#line 279 "../src/math-converter.vala"
			_tmp14_ = self->priv->from_entry;
#line 279 "../src/math-converter.vala"
			_tmp15_ = self->priv->_equation;
#line 279 "../src/math-converter.vala"
			_tmp16_ = math_equation_get_serializer (_tmp15_);
#line 279 "../src/math-converter.vala"
			_tmp17_ = _tmp16_;
#line 279 "../src/math-converter.vala"
			math_converter_update_entry (self, _tmp14_, _tmp17_);
#line 2121 "math-converter.c"
		}
	}
}

void
math_converter_swap_units (MathConverter* self)
{
	gboolean _tmp0_;
	Unit* from_unit = NULL;
	GtkDropDown* _tmp1_;
	GObject* _tmp2_;
	GObject* _tmp3_;
	Unit* _tmp4_;
	Unit* to_unit = NULL;
	GtkDropDown* _tmp5_;
	GObject* _tmp6_;
	GObject* _tmp7_;
	Unit* _tmp8_;
	GtkDropDown* _tmp9_;
	GtkDropDown* _tmp10_;
	Unit* _tmp11_;
	GtkDropDown* _tmp12_;
	GtkDropDown* _tmp13_;
	Unit* _tmp14_;
#line 283 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 285 "../src/math-converter.vala"
	_tmp0_ = self->priv->_box_visible;
#line 285 "../src/math-converter.vala"
	if (!_tmp0_) {
#line 286 "../src/math-converter.vala"
		return;
#line 2154 "math-converter.c"
	}
#line 288 "../src/math-converter.vala"
	_tmp1_ = self->priv->from_combo;
#line 288 "../src/math-converter.vala"
	_tmp2_ = gtk_drop_down_get_selected_item (_tmp1_);
#line 288 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 288 "../src/math-converter.vala"
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, TYPE_UNIT) ? ((Unit*) _tmp3_) : NULL);
#line 288 "../src/math-converter.vala"
	from_unit = _tmp4_;
#line 289 "../src/math-converter.vala"
	_tmp5_ = self->priv->to_combo;
#line 289 "../src/math-converter.vala"
	_tmp6_ = gtk_drop_down_get_selected_item (_tmp5_);
#line 289 "../src/math-converter.vala"
	_tmp7_ = _tmp6_;
#line 289 "../src/math-converter.vala"
	_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, TYPE_UNIT) ? ((Unit*) _tmp7_) : NULL);
#line 289 "../src/math-converter.vala"
	to_unit = _tmp8_;
#line 291 "../src/math-converter.vala"
	_tmp9_ = self->priv->from_combo;
#line 291 "../src/math-converter.vala"
	g_signal_handler_block (_tmp9_, self->priv->from_combobox_changed);
#line 292 "../src/math-converter.vala"
	_tmp10_ = self->priv->from_combo;
#line 292 "../src/math-converter.vala"
	_tmp11_ = to_unit;
#line 292 "../src/math-converter.vala"
	math_converter_set_active_unit (self, _tmp10_, _tmp11_);
#line 293 "../src/math-converter.vala"
	_tmp12_ = self->priv->from_combo;
#line 293 "../src/math-converter.vala"
	g_signal_handler_unblock (_tmp12_, self->priv->from_combobox_changed);
#line 294 "../src/math-converter.vala"
	_tmp13_ = self->priv->to_combo;
#line 294 "../src/math-converter.vala"
	_tmp14_ = from_unit;
#line 294 "../src/math-converter.vala"
	math_converter_set_active_unit (self, _tmp13_, _tmp14_);
#line 295 "../src/math-converter.vala"
	math_converter_to_combobox_changed_cb (self);
#line 296 "../src/math-converter.vala"
	math_converter_reformat_from_entry (self);
#line 283 "../src/math-converter.vala"
	_g_object_unref0 (to_unit);
#line 283 "../src/math-converter.vala"
	_g_object_unref0 (from_unit);
#line 2204 "math-converter.c"
}

void
math_converter_backspace (MathConverter* self)
{
	gboolean _tmp0_;
	GtkTextView* _tmp1_ = NULL;
	GtkTextView* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GtkTextView* entry = NULL;
	GtkTextView* _tmp7_;
	GtkTextView* _tmp8_;
	GtkTextView* _tmp9_;
	GtkTextView* _tmp11_;
	GtkTextBuffer* _tmp12_;
	GtkTextBuffer* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
#line 299 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 301 "../src/math-converter.vala"
	_tmp0_ = self->priv->_box_visible;
#line 301 "../src/math-converter.vala"
	if (!_tmp0_) {
#line 302 "../src/math-converter.vala"
		return;
#line 2232 "math-converter.c"
	}
#line 304 "../src/math-converter.vala"
	_tmp2_ = self->priv->to_entry;
#line 304 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp2_, "has-focus", &_tmp3_, NULL);
#line 304 "../src/math-converter.vala"
	_tmp4_ = _tmp3_;
#line 304 "../src/math-converter.vala"
	if (_tmp4_) {
#line 2242 "math-converter.c"
		GtkTextView* _tmp5_;
#line 304 "../src/math-converter.vala"
		_tmp5_ = self->priv->to_entry;
#line 304 "../src/math-converter.vala"
		_tmp1_ = _tmp5_;
#line 2248 "math-converter.c"
	} else {
		GtkTextView* _tmp6_;
#line 304 "../src/math-converter.vala"
		_tmp6_ = self->priv->from_entry;
#line 304 "../src/math-converter.vala"
		_tmp1_ = _tmp6_;
#line 2255 "math-converter.c"
	}
#line 304 "../src/math-converter.vala"
	_tmp7_ = _g_object_ref0 (_tmp1_);
#line 304 "../src/math-converter.vala"
	entry = _tmp7_;
#line 305 "../src/math-converter.vala"
	_tmp8_ = entry;
#line 305 "../src/math-converter.vala"
	_tmp9_ = self->priv->from_entry;
#line 305 "../src/math-converter.vala"
	if (_tmp8_ == _tmp9_) {
#line 2267 "math-converter.c"
		GtkTextView* _tmp10_;
#line 306 "../src/math-converter.vala"
		_tmp10_ = self->priv->from_entry;
#line 306 "../src/math-converter.vala"
		gtk_widget_grab_focus ((GtkWidget*) _tmp10_);
#line 2273 "math-converter.c"
	}
#line 307 "../src/math-converter.vala"
	_tmp11_ = entry;
#line 307 "../src/math-converter.vala"
	_tmp12_ = gtk_text_view_get_buffer (_tmp11_);
#line 307 "../src/math-converter.vala"
	_tmp13_ = _tmp12_;
#line 307 "../src/math-converter.vala"
	_tmp14_ = gtk_text_buffer_get_has_selection (_tmp13_);
#line 307 "../src/math-converter.vala"
	_tmp15_ = _tmp14_;
#line 307 "../src/math-converter.vala"
	if (_tmp15_) {
#line 2287 "math-converter.c"
		GtkTextView* _tmp16_;
		GtkTextBuffer* _tmp17_;
		GtkTextBuffer* _tmp18_;
#line 309 "../src/math-converter.vala"
		_tmp16_ = entry;
#line 309 "../src/math-converter.vala"
		_tmp17_ = gtk_text_view_get_buffer (_tmp16_);
#line 309 "../src/math-converter.vala"
		_tmp18_ = _tmp17_;
#line 309 "../src/math-converter.vala"
		gtk_text_buffer_delete_selection (_tmp18_, TRUE, TRUE);
#line 2299 "math-converter.c"
	} else {
		GtkTextIter iter = {0};
		GtkTextView* _tmp19_;
		GtkTextBuffer* _tmp20_;
		GtkTextBuffer* _tmp21_;
		GtkTextView* _tmp22_;
		GtkTextBuffer* _tmp23_;
		GtkTextBuffer* _tmp24_;
		GtkTextMark* _tmp25_;
		GtkTextIter _tmp26_ = {0};
		GtkTextView* _tmp27_;
		GtkTextBuffer* _tmp28_;
		GtkTextBuffer* _tmp29_;
#line 314 "../src/math-converter.vala"
		_tmp19_ = entry;
#line 314 "../src/math-converter.vala"
		_tmp20_ = gtk_text_view_get_buffer (_tmp19_);
#line 314 "../src/math-converter.vala"
		_tmp21_ = _tmp20_;
#line 314 "../src/math-converter.vala"
		_tmp22_ = entry;
#line 314 "../src/math-converter.vala"
		_tmp23_ = gtk_text_view_get_buffer (_tmp22_);
#line 314 "../src/math-converter.vala"
		_tmp24_ = _tmp23_;
#line 314 "../src/math-converter.vala"
		_tmp25_ = gtk_text_buffer_get_insert (_tmp24_);
#line 314 "../src/math-converter.vala"
		gtk_text_buffer_get_iter_at_mark (_tmp21_, &_tmp26_, _tmp25_);
#line 314 "../src/math-converter.vala"
		iter = _tmp26_;
#line 315 "../src/math-converter.vala"
		_tmp27_ = entry;
#line 315 "../src/math-converter.vala"
		_tmp28_ = gtk_text_view_get_buffer (_tmp27_);
#line 315 "../src/math-converter.vala"
		_tmp29_ = _tmp28_;
#line 315 "../src/math-converter.vala"
		gtk_text_buffer_backspace (_tmp29_, &iter, TRUE, TRUE);
#line 2339 "math-converter.c"
	}
#line 299 "../src/math-converter.vala"
	_g_object_unref0 (entry);
#line 2343 "math-converter.c"
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 319 "../src/math-converter.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 319 "../src/math-converter.vala"
	return _data5_;
#line 2353 "math-converter.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 319 "../src/math-converter.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 2363 "math-converter.c"
		MathConverter* self;
#line 319 "../src/math-converter.vala"
		self = _data5_->self;
#line 319 "../src/math-converter.vala"
		_g_object_unref0 (_data5_->clipboard);
#line 319 "../src/math-converter.vala"
		_g_object_unref0 (self);
#line 319 "../src/math-converter.vala"
		g_slice_free (Block5Data, _data5_);
#line 2373 "math-converter.c"
	}
}

static void
__lambda4_ (Block5Data* _data5_,
            GObject* obj,
            GAsyncResult* res)
{
	MathConverter* self;
	GError* _inner_error0_ = NULL;
#line 324 "../src/math-converter.vala"
	self = _data5_->self;
#line 324 "../src/math-converter.vala"
	g_return_if_fail (res != NULL);
#line 2388 "math-converter.c"
	{
		gchar* _tmp0_ = NULL;
		GdkClipboard* _tmp1_;
		gchar* _tmp2_;
#line 326 "../src/math-converter.vala"
		_tmp1_ = _data5_->clipboard;
#line 326 "../src/math-converter.vala"
		_tmp2_ = gdk_clipboard_read_text_finish (_tmp1_, res, &_inner_error0_);
#line 326 "../src/math-converter.vala"
		_tmp0_ = _tmp2_;
#line 326 "../src/math-converter.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2401 "math-converter.c"
			goto __catch0_g_error;
		}
#line 326 "../src/math-converter.vala"
		math_converter_on_paste (self, _tmp0_);
#line 325 "../src/math-converter.vala"
		_g_free0 (_tmp0_);
#line 2408 "math-converter.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 325 "../src/math-converter.vala"
		err = _inner_error0_;
#line 325 "../src/math-converter.vala"
		_inner_error0_ = NULL;
#line 328 "../src/math-converter.vala"
		_tmp3_ = err;
#line 328 "../src/math-converter.vala"
		_tmp4_ = _tmp3_->message;
#line 328 "../src/math-converter.vala"
		g_print ("%s", _tmp4_);
#line 325 "../src/math-converter.vala"
		_g_error_free0 (err);
#line 2428 "math-converter.c"
	}
	__finally0:
#line 325 "../src/math-converter.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 325 "../src/math-converter.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 325 "../src/math-converter.vala"
		g_clear_error (&_inner_error0_);
#line 325 "../src/math-converter.vala"
		return;
#line 2439 "math-converter.c"
	}
}

static void
___lambda4__gasync_ready_callback (GObject* source_object,
                                   GAsyncResult* res,
                                   gpointer self)
{
#line 324 "../src/math-converter.vala"
	__lambda4_ (self, source_object, res);
#line 324 "../src/math-converter.vala"
	block5_data_unref (self);
#line 2452 "math-converter.c"
}

void
math_converter_paste (MathConverter* self)
{
	Block5Data* _data5_;
	gboolean _tmp0_ = FALSE;
	GtkTextView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GdkDisplay* _tmp7_;
	GdkClipboard* _tmp8_;
	GdkClipboard* _tmp9_;
	GdkClipboard* _tmp10_;
#line 319 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 319 "../src/math-converter.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 319 "../src/math-converter.vala"
	_data5_->_ref_count_ = 1;
#line 319 "../src/math-converter.vala"
	_data5_->self = g_object_ref (self);
#line 321 "../src/math-converter.vala"
	_tmp1_ = self->priv->from_entry;
#line 321 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
#line 321 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 321 "../src/math-converter.vala"
	if (!_tmp3_) {
#line 2483 "math-converter.c"
		GtkTextView* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 321 "../src/math-converter.vala"
		_tmp4_ = self->priv->to_entry;
#line 321 "../src/math-converter.vala"
		g_object_get ((GtkWidget*) _tmp4_, "has-focus", &_tmp5_, NULL);
#line 321 "../src/math-converter.vala"
		_tmp6_ = _tmp5_;
#line 321 "../src/math-converter.vala"
		_tmp0_ = !_tmp6_;
#line 2495 "math-converter.c"
	} else {
#line 321 "../src/math-converter.vala"
		_tmp0_ = FALSE;
#line 2499 "math-converter.c"
	}
#line 321 "../src/math-converter.vala"
	if (_tmp0_) {
#line 322 "../src/math-converter.vala"
		block5_data_unref (_data5_);
#line 322 "../src/math-converter.vala"
		_data5_ = NULL;
#line 322 "../src/math-converter.vala"
		return;
#line 2509 "math-converter.c"
	}
#line 323 "../src/math-converter.vala"
	_tmp7_ = gdk_display_get_default ();
#line 323 "../src/math-converter.vala"
	_tmp8_ = gdk_display_get_clipboard (_tmp7_);
#line 323 "../src/math-converter.vala"
	_tmp9_ = _g_object_ref0 (_tmp8_);
#line 323 "../src/math-converter.vala"
	_data5_->clipboard = _tmp9_;
#line 324 "../src/math-converter.vala"
	_tmp10_ = _data5_->clipboard;
#line 324 "../src/math-converter.vala"
	gdk_clipboard_read_text_async (_tmp10_, NULL, ___lambda4__gasync_ready_callback, block5_data_ref (_data5_));
#line 319 "../src/math-converter.vala"
	block5_data_unref (_data5_);
#line 319 "../src/math-converter.vala"
	_data5_ = NULL;
#line 2527 "math-converter.c"
}

static gchar*
string_delimit (const gchar* self,
                const gchar* delimiters,
                gchar new_delimiter)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1421 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1421 "glib-2.0.vapi"
	g_return_val_if_fail (delimiters != NULL, NULL);
#line 1422 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1422 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1423 "glib-2.0.vapi"
	g_strdelimit (_result_, delimiters, new_delimiter);
#line 1424 "glib-2.0.vapi"
	result = _result_;
#line 1424 "glib-2.0.vapi"
	return result;
#line 2552 "math-converter.c"
}

static void
math_converter_on_paste (MathConverter* self,
                         const gchar* text)
{
#line 333 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 335 "../src/math-converter.vala"
	if (text != NULL) {
#line 2563 "math-converter.c"
		gchar* _tmp0_;
		gchar* _tmp1_;
#line 337 "../src/math-converter.vala"
		_tmp0_ = string_delimit (text, "\n", ' ');
#line 337 "../src/math-converter.vala"
		_tmp1_ = _tmp0_;
#line 337 "../src/math-converter.vala"
		math_converter_insert_text (self, _tmp1_, TRUE);
#line 337 "../src/math-converter.vala"
		_g_free0 (_tmp1_);
#line 2574 "math-converter.c"
	}
}

static void
math_converter_update_visibility (MathConverter* self)
{
	const gchar* _tmp0_;
	CurrencyManager* _tmp1_;
	CurrencyManager* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
#line 340 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 342 "../src/math-converter.vala"
	_tmp0_ = self->priv->category;
#line 342 "../src/math-converter.vala"
	if (g_strcmp0 (_tmp0_, "currency") != 0) {
#line 344 "../src/math-converter.vala"
		math_converter_set_box_visible (self, TRUE);
#line 345 "../src/math-converter.vala"
		return;
#line 2596 "math-converter.c"
	}
#line 348 "../src/math-converter.vala"
	_tmp1_ = currency_manager_get_default (TRUE, TRUE);
#line 348 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 348 "../src/math-converter.vala"
	_tmp3_ = currency_manager_get_loaded (_tmp2_);
#line 348 "../src/math-converter.vala"
	_tmp4_ = _tmp3_;
#line 348 "../src/math-converter.vala"
	math_converter_set_box_visible (self, _tmp4_);
#line 348 "../src/math-converter.vala"
	_g_object_unref0 (_tmp2_);
#line 2610 "math-converter.c"
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
#line 351 "../src/math-converter.vala"
	g_atomic_int_inc (&_data6_->_ref_count_);
#line 351 "../src/math-converter.vala"
	return _data6_;
#line 2620 "math-converter.c"
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
#line 351 "../src/math-converter.vala"
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
#line 2630 "math-converter.c"
		MathConverter* self;
#line 351 "../src/math-converter.vala"
		self = _data6_->self;
#line 351 "../src/math-converter.vala"
		_g_object_unref0 (_data6_->currency_manager);
#line 351 "../src/math-converter.vala"
		_g_object_unref0 (self);
#line 351 "../src/math-converter.vala"
		g_slice_free (Block6Data, _data6_);
#line 2640 "math-converter.c"
	}
}

static gint
___lambda6_ (Block6Data* _data6_,
             GObject* a,
             GObject* b)
{
	MathConverter* self;
	gboolean a_is_favorite = FALSE;
	CurrencyManager* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
	gboolean b_is_favorite = FALSE;
	CurrencyManager* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gint _tmp18_;
	gint result;
#line 396 "../src/math-converter.vala"
	self = _data6_->self;
#line 396 "../src/math-converter.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 396 "../src/math-converter.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 397 "../src/math-converter.vala"
	_tmp0_ = _data6_->currency_manager;
#line 397 "../src/math-converter.vala"
	_tmp1_ = unit_get_name (G_TYPE_CHECK_INSTANCE_CAST (a, TYPE_UNIT, Unit));
#line 397 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 397 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 397 "../src/math-converter.vala"
	_tmp4_ = currency_manager_is_favorite (_tmp0_, _tmp3_);
#line 397 "../src/math-converter.vala"
	_g_free0 (_tmp3_);
#line 397 "../src/math-converter.vala"
	a_is_favorite = _tmp4_;
#line 398 "../src/math-converter.vala"
	_tmp5_ = _data6_->currency_manager;
#line 398 "../src/math-converter.vala"
	_tmp6_ = unit_get_name (G_TYPE_CHECK_INSTANCE_CAST (b, TYPE_UNIT, Unit));
#line 398 "../src/math-converter.vala"
	_tmp7_ = _tmp6_;
#line 398 "../src/math-converter.vala"
	_tmp8_ = _tmp7_;
#line 398 "../src/math-converter.vala"
	_tmp9_ = currency_manager_is_favorite (_tmp5_, _tmp8_);
#line 398 "../src/math-converter.vala"
	_g_free0 (_tmp8_);
#line 398 "../src/math-converter.vala"
	b_is_favorite = _tmp9_;
#line 399 "../src/math-converter.vala"
	if (a_is_favorite) {
#line 399 "../src/math-converter.vala"
		_tmp10_ = !b_is_favorite;
#line 2710 "math-converter.c"
	} else {
#line 399 "../src/math-converter.vala"
		_tmp10_ = FALSE;
#line 2714 "math-converter.c"
	}
#line 399 "../src/math-converter.vala"
	if (_tmp10_) {
#line 400 "../src/math-converter.vala"
		result = -1;
#line 400 "../src/math-converter.vala"
		return result;
#line 2722 "math-converter.c"
	}
#line 401 "../src/math-converter.vala"
	if (!a_is_favorite) {
#line 401 "../src/math-converter.vala"
		_tmp11_ = b_is_favorite;
#line 2728 "math-converter.c"
	} else {
#line 401 "../src/math-converter.vala"
		_tmp11_ = FALSE;
#line 2732 "math-converter.c"
	}
#line 401 "../src/math-converter.vala"
	if (_tmp11_) {
#line 402 "../src/math-converter.vala"
		result = 1;
#line 402 "../src/math-converter.vala"
		return result;
#line 2740 "math-converter.c"
	}
#line 403 "../src/math-converter.vala"
	_tmp12_ = unit_get_name (G_TYPE_CHECK_INSTANCE_CAST (a, TYPE_UNIT, Unit));
#line 403 "../src/math-converter.vala"
	_tmp13_ = _tmp12_;
#line 403 "../src/math-converter.vala"
	_tmp14_ = _tmp13_;
#line 403 "../src/math-converter.vala"
	_tmp15_ = unit_get_name (G_TYPE_CHECK_INSTANCE_CAST (b, TYPE_UNIT, Unit));
#line 403 "../src/math-converter.vala"
	_tmp16_ = _tmp15_;
#line 403 "../src/math-converter.vala"
	_tmp17_ = _tmp16_;
#line 403 "../src/math-converter.vala"
	_tmp18_ = g_ascii_strcasecmp (_tmp14_, _tmp17_);
#line 403 "../src/math-converter.vala"
	_g_free0 (_tmp17_);
#line 403 "../src/math-converter.vala"
	_g_free0 (_tmp14_);
#line 403 "../src/math-converter.vala"
	result = _tmp18_;
#line 403 "../src/math-converter.vala"
	return result;
#line 2764 "math-converter.c"
}

static gint
____lambda6__gcompare_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gint result;
	result = ___lambda6_ (self, (GObject*) a, (GObject*) b);
#line 396 "../src/math-converter.vala"
	return result;
#line 2776 "math-converter.c"
}

static void
math_converter_build_units_model (MathConverter* self)
{
	Block6Data* _data6_;
	GListStore* unit_model = NULL;
	GListStore* _tmp0_;
	GtkExpression* expression = NULL;
	gboolean _tmp1_ = FALSE;
	const gchar* _tmp2_;
	GtkDropDown* _tmp7_;
	GtkExpression* _tmp8_;
	GtkDropDown* _tmp9_;
	GtkExpression* _tmp10_;
	const gchar* _tmp11_;
	CurrencyManager* _tmp16_;
	UnitCategory* c = NULL;
	UnitManager* _tmp17_;
	UnitManager* _tmp18_;
	const gchar* _tmp19_;
	UnitCategory* _tmp20_;
	UnitCategory* _tmp21_;
	gboolean _tmp22_ = FALSE;
	const gchar* _tmp23_;
	gboolean _tmp43_ = FALSE;
	const gchar* _tmp44_;
	guint model_size = 0U;
	GListStore* _tmp46_;
	GtkDropDown* _tmp47_;
	GListStore* _tmp48_;
	GtkDropDown* _tmp49_;
	GtkDropDown* _tmp50_;
	GListStore* _tmp51_;
	GtkDropDown* _tmp52_;
#line 351 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 351 "../src/math-converter.vala"
	_data6_ = g_slice_new0 (Block6Data);
#line 351 "../src/math-converter.vala"
	_data6_->_ref_count_ = 1;
#line 351 "../src/math-converter.vala"
	_data6_->self = g_object_ref (self);
#line 353 "../src/math-converter.vala"
	_tmp0_ = g_list_store_new (TYPE_UNIT);
#line 353 "../src/math-converter.vala"
	unit_model = _tmp0_;
#line 355 "../src/math-converter.vala"
	expression = NULL;
#line 356 "../src/math-converter.vala"
	_tmp2_ = self->priv->category;
#line 356 "../src/math-converter.vala"
	if (g_strcmp0 (_tmp2_, "currency") != 0) {
#line 356 "../src/math-converter.vala"
		_tmp1_ = TRUE;
#line 2832 "math-converter.c"
	} else {
#line 356 "../src/math-converter.vala"
		_tmp1_ = self->priv->_currency_display == CURRENCY_DISPLAY_NAME;
#line 2836 "math-converter.c"
	}
#line 356 "../src/math-converter.vala"
	if (_tmp1_) {
#line 2840 "math-converter.c"
		GtkPropertyExpression* _tmp3_;
#line 357 "../src/math-converter.vala"
		_tmp3_ = (GtkPropertyExpression*) gtk_property_expression_new (TYPE_UNIT, NULL, "display_name");
#line 357 "../src/math-converter.vala"
		_gtk_expression_unref0 (expression);
#line 357 "../src/math-converter.vala"
		expression = (GtkExpression*) _tmp3_;
#line 2848 "math-converter.c"
	} else {
#line 358 "../src/math-converter.vala"
		if (self->priv->_currency_display == CURRENCY_DISPLAY_CODE) {
#line 2852 "math-converter.c"
			GtkPropertyExpression* _tmp4_;
#line 359 "../src/math-converter.vala"
			_tmp4_ = (GtkPropertyExpression*) gtk_property_expression_new (TYPE_UNIT, NULL, "name");
#line 359 "../src/math-converter.vala"
			_gtk_expression_unref0 (expression);
#line 359 "../src/math-converter.vala"
			expression = (GtkExpression*) _tmp4_;
#line 2860 "math-converter.c"
		} else {
			GtkExpression** _tmp5_;
			GtkCClosureExpression* _tmp6_;
#line 361 "../src/math-converter.vala"
			_tmp5_ = g_new0 (GtkExpression*, 0 + 1);
#line 361 "../src/math-converter.vala"
			_tmp6_ = (GtkCClosureExpression*) gtk_cclosure_expression_new (G_TYPE_STRING, NULL, 0, _tmp5_, (GCallback) math_converter_currency_item, NULL, NULL);
#line 361 "../src/math-converter.vala"
			_gtk_expression_unref0 (expression);
#line 361 "../src/math-converter.vala"
			expression = (GtkExpression*) _tmp6_;
#line 2872 "math-converter.c"
		}
	}
#line 365 "../src/math-converter.vala"
	_tmp7_ = self->priv->from_combo;
#line 365 "../src/math-converter.vala"
	_tmp8_ = expression;
#line 365 "../src/math-converter.vala"
	gtk_drop_down_set_expression (_tmp7_, _tmp8_);
#line 366 "../src/math-converter.vala"
	_tmp9_ = self->priv->to_combo;
#line 366 "../src/math-converter.vala"
	_tmp10_ = expression;
#line 366 "../src/math-converter.vala"
	gtk_drop_down_set_expression (_tmp9_, _tmp10_);
#line 368 "../src/math-converter.vala"
	_tmp11_ = self->priv->category;
#line 368 "../src/math-converter.vala"
	if (g_strcmp0 (_tmp11_, "currency") == 0) {
#line 2891 "math-converter.c"
		GtkDropDown* _tmp12_;
		GtkSignalListItemFactory* _tmp13_;
		GtkDropDown* _tmp14_;
		GtkSignalListItemFactory* _tmp15_;
#line 370 "../src/math-converter.vala"
		_tmp12_ = self->priv->from_combo;
#line 370 "../src/math-converter.vala"
		_tmp13_ = self->priv->from_currency_factory;
#line 370 "../src/math-converter.vala"
		gtk_drop_down_set_list_factory (_tmp12_, (GtkListItemFactory*) _tmp13_);
#line 371 "../src/math-converter.vala"
		_tmp14_ = self->priv->to_combo;
#line 371 "../src/math-converter.vala"
		_tmp15_ = self->priv->to_currency_factory;
#line 371 "../src/math-converter.vala"
		gtk_drop_down_set_list_factory (_tmp14_, (GtkListItemFactory*) _tmp15_);
#line 2908 "math-converter.c"
	}
#line 374 "../src/math-converter.vala"
	_tmp16_ = currency_manager_get_default (TRUE, TRUE);
#line 374 "../src/math-converter.vala"
	_data6_->currency_manager = _tmp16_;
#line 375 "../src/math-converter.vala"
	_tmp17_ = unit_manager_get_default ();
#line 375 "../src/math-converter.vala"
	_tmp18_ = _tmp17_;
#line 375 "../src/math-converter.vala"
	_tmp19_ = self->priv->category;
#line 375 "../src/math-converter.vala"
	_tmp20_ = unit_manager_get_category (_tmp18_, _tmp19_);
#line 375 "../src/math-converter.vala"
	_tmp21_ = _tmp20_;
#line 375 "../src/math-converter.vala"
	_g_object_unref0 (_tmp18_);
#line 375 "../src/math-converter.vala"
	c = _tmp21_;
#line 376 "../src/math-converter.vala"
	_tmp23_ = self->priv->category;
#line 376 "../src/math-converter.vala"
	if (g_strcmp0 (_tmp23_, "currency") != 0) {
#line 376 "../src/math-converter.vala"
		_tmp22_ = TRUE;
#line 2934 "math-converter.c"
	} else {
#line 376 "../src/math-converter.vala"
		_tmp22_ = self->priv->_currency_display != CURRENCY_DISPLAY_NAME;
#line 2938 "math-converter.c"
	}
#line 376 "../src/math-converter.vala"
	if (_tmp22_) {
#line 2942 "math-converter.c"
		UnitCategory* _tmp24_;
		GList* _tmp25_;
#line 377 "../src/math-converter.vala"
		_tmp24_ = c;
#line 377 "../src/math-converter.vala"
		_tmp25_ = unit_category_get_units (_tmp24_);
#line 2949 "math-converter.c"
		{
			GList* unit_collection = NULL;
			GList* unit_it = NULL;
#line 377 "../src/math-converter.vala"
			unit_collection = _tmp25_;
#line 377 "../src/math-converter.vala"
			for (unit_it = unit_collection; unit_it != NULL; unit_it = unit_it->next) {
#line 2957 "math-converter.c"
				Unit* _tmp26_;
				Unit* unit = NULL;
#line 377 "../src/math-converter.vala"
				_tmp26_ = _g_object_ref0 ((Unit*) unit_it->data);
#line 377 "../src/math-converter.vala"
				unit = _tmp26_;
#line 2964 "math-converter.c"
				{
					GListStore* _tmp27_;
					Unit* _tmp28_;
#line 379 "../src/math-converter.vala"
					_tmp27_ = unit_model;
#line 379 "../src/math-converter.vala"
					_tmp28_ = unit;
#line 379 "../src/math-converter.vala"
					g_list_store_append (_tmp27_, (GObject*) _tmp28_);
#line 377 "../src/math-converter.vala"
					_g_object_unref0 (unit);
#line 2976 "math-converter.c"
				}
			}
		}
	} else {
		gint i = 0;
		UnitCategory* _tmp29_;
		GList* _tmp30_;
#line 383 "../src/math-converter.vala"
		i = 0;
#line 384 "../src/math-converter.vala"
		_tmp29_ = c;
#line 384 "../src/math-converter.vala"
		_tmp30_ = unit_category_get_units (_tmp29_);
#line 2990 "math-converter.c"
		{
			GList* unit_collection = NULL;
			GList* unit_it = NULL;
#line 384 "../src/math-converter.vala"
			unit_collection = _tmp30_;
#line 384 "../src/math-converter.vala"
			for (unit_it = unit_collection; unit_it != NULL; unit_it = unit_it->next) {
#line 2998 "math-converter.c"
				Unit* _tmp31_;
				Unit* unit = NULL;
#line 384 "../src/math-converter.vala"
				_tmp31_ = _g_object_ref0 ((Unit*) unit_it->data);
#line 384 "../src/math-converter.vala"
				unit = _tmp31_;
#line 3005 "math-converter.c"
				{
					CurrencyManager* _tmp32_;
					Unit* _tmp33_;
					gchar* _tmp34_;
					gchar* _tmp35_;
					gchar* _tmp36_;
					gboolean _tmp37_;
#line 386 "../src/math-converter.vala"
					_tmp32_ = _data6_->currency_manager;
#line 386 "../src/math-converter.vala"
					_tmp33_ = unit;
#line 386 "../src/math-converter.vala"
					_tmp34_ = unit_get_name (_tmp33_);
#line 386 "../src/math-converter.vala"
					_tmp35_ = _tmp34_;
#line 386 "../src/math-converter.vala"
					_tmp36_ = _tmp35_;
#line 386 "../src/math-converter.vala"
					_tmp37_ = currency_manager_is_favorite (_tmp32_, _tmp36_);
#line 386 "../src/math-converter.vala"
					_g_free0 (_tmp36_);
#line 386 "../src/math-converter.vala"
					if (_tmp37_) {
#line 3029 "math-converter.c"
						GListStore* _tmp38_;
						Unit* _tmp39_;
						gint _tmp40_;
#line 388 "../src/math-converter.vala"
						_tmp38_ = unit_model;
#line 388 "../src/math-converter.vala"
						_tmp39_ = unit;
#line 388 "../src/math-converter.vala"
						g_list_store_insert (_tmp38_, (guint) i, (GObject*) _tmp39_);
#line 389 "../src/math-converter.vala"
						_tmp40_ = i;
#line 389 "../src/math-converter.vala"
						i = _tmp40_ + 1;
#line 3043 "math-converter.c"
					} else {
						GListStore* _tmp41_;
						Unit* _tmp42_;
#line 392 "../src/math-converter.vala"
						_tmp41_ = unit_model;
#line 392 "../src/math-converter.vala"
						_tmp42_ = unit;
#line 392 "../src/math-converter.vala"
						g_list_store_append (_tmp41_, (GObject*) _tmp42_);
#line 3053 "math-converter.c"
					}
#line 384 "../src/math-converter.vala"
					_g_object_unref0 (unit);
#line 3057 "math-converter.c"
				}
			}
		}
	}
#line 395 "../src/math-converter.vala"
	_tmp44_ = self->priv->category;
#line 395 "../src/math-converter.vala"
	if (g_strcmp0 (_tmp44_, "currency") == 0) {
#line 395 "../src/math-converter.vala"
		_tmp43_ = self->priv->_currency_display != CURRENCY_DISPLAY_NAME;
#line 3068 "math-converter.c"
	} else {
#line 395 "../src/math-converter.vala"
		_tmp43_ = FALSE;
#line 3072 "math-converter.c"
	}
#line 395 "../src/math-converter.vala"
	if (_tmp43_) {
#line 3076 "math-converter.c"
		GListStore* _tmp45_;
#line 396 "../src/math-converter.vala"
		_tmp45_ = unit_model;
#line 396 "../src/math-converter.vala"
		g_list_store_sort (_tmp45_, ____lambda6__gcompare_data_func, _data6_);
#line 3082 "math-converter.c"
	}
#line 406 "../src/math-converter.vala"
	_tmp46_ = unit_model;
#line 406 "../src/math-converter.vala"
	model_size = g_list_model_get_n_items ((GListModel*) _tmp46_);
#line 407 "../src/math-converter.vala"
	_tmp47_ = self->priv->to_combo;
#line 407 "../src/math-converter.vala"
	_tmp48_ = unit_model;
#line 407 "../src/math-converter.vala"
	gtk_drop_down_set_model (_tmp47_, (GListModel*) _tmp48_);
#line 408 "../src/math-converter.vala"
	_tmp49_ = self->priv->to_combo;
#line 408 "../src/math-converter.vala"
	gtk_drop_down_set_enable_search (_tmp49_, model_size > ((guint) 10));
#line 409 "../src/math-converter.vala"
	_tmp50_ = self->priv->from_combo;
#line 409 "../src/math-converter.vala"
	_tmp51_ = unit_model;
#line 409 "../src/math-converter.vala"
	gtk_drop_down_set_model (_tmp50_, (GListModel*) _tmp51_);
#line 410 "../src/math-converter.vala"
	_tmp52_ = self->priv->from_combo;
#line 410 "../src/math-converter.vala"
	gtk_drop_down_set_enable_search (_tmp52_, model_size > ((guint) 10));
#line 351 "../src/math-converter.vala"
	_g_object_unref0 (c);
#line 351 "../src/math-converter.vala"
	_gtk_expression_unref0 (expression);
#line 351 "../src/math-converter.vala"
	_g_object_unref0 (unit_model);
#line 351 "../src/math-converter.vala"
	block6_data_unref (_data6_);
#line 351 "../src/math-converter.vala"
	_data6_ = NULL;
#line 3118 "math-converter.c"
}

static gchar*
math_converter_currency_item (Unit* unit)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* result;
#line 413 "../src/math-converter.vala"
	g_return_val_if_fail (unit != NULL, NULL);
#line 415 "../src/math-converter.vala"
	_tmp0_ = unit_get_name (unit);
#line 415 "../src/math-converter.vala"
	_tmp1_ = _tmp0_;
#line 415 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 415 "../src/math-converter.vala"
	_tmp3_ = unit_get_display_name (unit);
#line 415 "../src/math-converter.vala"
	_tmp4_ = _tmp3_;
#line 415 "../src/math-converter.vala"
	_tmp5_ = _tmp4_;
#line 415 "../src/math-converter.vala"
	_tmp6_ = g_strdup_printf ("%s (%s)", _tmp2_, _tmp5_);
#line 415 "../src/math-converter.vala"
	_tmp7_ = _tmp6_;
#line 415 "../src/math-converter.vala"
	_g_free0 (_tmp5_);
#line 415 "../src/math-converter.vala"
	_g_free0 (_tmp2_);
#line 415 "../src/math-converter.vala"
	result = _tmp7_;
#line 415 "../src/math-converter.vala"
	return result;
#line 3159 "math-converter.c"
}

static void
math_converter_setup_currency (MathConverter* self,
                               GObject* item)
{
	GtkBox* box = NULL;
	GtkBox* _tmp0_;
	GtkImage* _tmp1_;
	GtkImage* _tmp2_;
	GtkLabel* label = NULL;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	GtkImage* _tmp5_;
	GtkImage* _tmp6_;
#line 418 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 418 "../src/math-converter.vala"
	g_return_if_fail (item != NULL);
#line 420 "../src/math-converter.vala"
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
#line 420 "../src/math-converter.vala"
	g_object_ref_sink (_tmp0_);
#line 420 "../src/math-converter.vala"
	box = _tmp0_;
#line 421 "../src/math-converter.vala"
	_tmp1_ = (GtkImage*) gtk_image_new_from_icon_name ("starred-symbolic");
#line 421 "../src/math-converter.vala"
	g_object_ref_sink (_tmp1_);
#line 421 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 421 "../src/math-converter.vala"
	gtk_box_append (box, (GtkWidget*) _tmp2_);
#line 421 "../src/math-converter.vala"
	_g_object_unref0 (_tmp2_);
#line 422 "../src/math-converter.vala"
	_tmp3_ = (GtkLabel*) gtk_label_new ("");
#line 422 "../src/math-converter.vala"
	g_object_ref_sink (_tmp3_);
#line 422 "../src/math-converter.vala"
	label = _tmp3_;
#line 423 "../src/math-converter.vala"
	_tmp4_ = _g_object_ref0 (label);
#line 423 "../src/math-converter.vala"
	g_object_set_data_full (item, "label", _tmp4_, g_object_unref);
#line 424 "../src/math-converter.vala"
	gtk_box_append (box, (GtkWidget*) label);
#line 425 "../src/math-converter.vala"
	_tmp5_ = (GtkImage*) gtk_image_new_from_icon_name ("object-select-symbolic");
#line 425 "../src/math-converter.vala"
	g_object_ref_sink (_tmp5_);
#line 425 "../src/math-converter.vala"
	_tmp6_ = _tmp5_;
#line 425 "../src/math-converter.vala"
	gtk_box_append (box, (GtkWidget*) _tmp6_);
#line 425 "../src/math-converter.vala"
	_g_object_unref0 (_tmp6_);
#line 426 "../src/math-converter.vala"
	gtk_list_item_set_child (G_TYPE_CHECK_INSTANCE_TYPE (item, gtk_list_item_get_type ()) ? ((GtkListItem*) item) : NULL, (GtkWidget*) box);
#line 418 "../src/math-converter.vala"
	_g_object_unref0 (label);
#line 418 "../src/math-converter.vala"
	_g_object_unref0 (box);
#line 3223 "math-converter.c"
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 429 "../src/math-converter.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 429 "../src/math-converter.vala"
	return _data7_;
#line 3233 "math-converter.c"
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 429 "../src/math-converter.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 3243 "math-converter.c"
		MathConverter* self;
#line 429 "../src/math-converter.vala"
		self = _data7_->self;
#line 429 "../src/math-converter.vala"
		_g_object_unref0 (_data7_->unit);
#line 429 "../src/math-converter.vala"
		_g_object_unref0 (_data7_->box);
#line 429 "../src/math-converter.vala"
		_g_object_unref0 (_data7_->combo);
#line 429 "../src/math-converter.vala"
		_g_object_unref0 (self);
#line 429 "../src/math-converter.vala"
		g_slice_free (Block7Data, _data7_);
#line 3257 "math-converter.c"
	}
}

static void
__lambda9_ (Block7Data* _data7_)
{
	MathConverter* self;
	gint _tmp0_ = 0;
	GObject* _tmp1_;
	GObject* _tmp2_;
	Unit* _tmp3_;
	GtkWidget* _tmp4_;
	GtkWidget* _tmp5_;
#line 448 "../src/math-converter.vala"
	self = _data7_->self;
#line 449 "../src/math-converter.vala"
	_tmp1_ = gtk_drop_down_get_selected_item (_data7_->combo);
#line 449 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 449 "../src/math-converter.vala"
	_tmp3_ = _data7_->unit;
#line 449 "../src/math-converter.vala"
	if (_tmp2_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, G_TYPE_OBJECT, GObject)) {
#line 449 "../src/math-converter.vala"
		_tmp0_ = 1;
#line 3283 "math-converter.c"
	} else {
#line 449 "../src/math-converter.vala"
		_tmp0_ = 0;
#line 3287 "math-converter.c"
	}
#line 449 "../src/math-converter.vala"
	_tmp4_ = _data7_->box;
#line 449 "../src/math-converter.vala"
	_tmp5_ = gtk_widget_get_last_child (_tmp4_);
#line 449 "../src/math-converter.vala"
	gtk_widget_set_opacity (_tmp5_, (gdouble) _tmp0_);
#line 3295 "math-converter.c"
}

static void
___lambda9__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
#line 448 "../src/math-converter.vala"
	__lambda9_ (self);
#line 3305 "math-converter.c"
}

static void
math_converter_bind_currency (MathConverter* self,
                              GObject* item,
                              GtkDropDown* combo)
{
	Block7Data* _data7_;
	GtkDropDown* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	GObject* _tmp4_;
	GObject* _tmp5_;
	Unit* _tmp6_;
	GtkWidget* _tmp7_;
	GtkWidget* _tmp8_;
	CurrencyManager* _tmp9_;
	CurrencyManager* _tmp10_;
	Unit* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gulong handler = 0UL;
	gulong _tmp29_;
	gint _tmp30_ = 0;
	GObject* _tmp31_;
	GObject* _tmp32_;
	Unit* _tmp33_;
	GtkWidget* _tmp34_;
	GtkWidget* _tmp35_;
#line 429 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 429 "../src/math-converter.vala"
	g_return_if_fail (item != NULL);
#line 429 "../src/math-converter.vala"
	g_return_if_fail (combo != NULL);
#line 429 "../src/math-converter.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 429 "../src/math-converter.vala"
	_data7_->_ref_count_ = 1;
#line 429 "../src/math-converter.vala"
	_data7_->self = g_object_ref (self);
#line 429 "../src/math-converter.vala"
	_tmp0_ = _g_object_ref0 (combo);
#line 429 "../src/math-converter.vala"
	_g_object_unref0 (_data7_->combo);
#line 429 "../src/math-converter.vala"
	_data7_->combo = _tmp0_;
#line 431 "../src/math-converter.vala"
	_tmp1_ = gtk_list_item_get_child (G_TYPE_CHECK_INSTANCE_TYPE (item, gtk_list_item_get_type ()) ? ((GtkListItem*) item) : NULL);
#line 431 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 431 "../src/math-converter.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 431 "../src/math-converter.vala"
	_data7_->box = _tmp3_;
#line 432 "../src/math-converter.vala"
	_tmp4_ = gtk_list_item_get_item (G_TYPE_CHECK_INSTANCE_TYPE (item, gtk_list_item_get_type ()) ? ((GtkListItem*) item) : NULL);
#line 432 "../src/math-converter.vala"
	_tmp5_ = _tmp4_;
#line 432 "../src/math-converter.vala"
	_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, TYPE_UNIT) ? ((Unit*) _tmp5_) : NULL);
#line 432 "../src/math-converter.vala"
	_data7_->unit = _tmp6_;
#line 433 "../src/math-converter.vala"
	_tmp7_ = _data7_->box;
#line 433 "../src/math-converter.vala"
	_tmp8_ = gtk_widget_get_first_child (_tmp7_);
#line 433 "../src/math-converter.vala"
	_tmp9_ = currency_manager_get_default (TRUE, TRUE);
#line 433 "../src/math-converter.vala"
	_tmp10_ = _tmp9_;
#line 433 "../src/math-converter.vala"
	_tmp11_ = _data7_->unit;
#line 433 "../src/math-converter.vala"
	_tmp12_ = unit_get_name (_tmp11_);
#line 433 "../src/math-converter.vala"
	_tmp13_ = _tmp12_;
#line 433 "../src/math-converter.vala"
	_tmp14_ = _tmp13_;
#line 433 "../src/math-converter.vala"
	gtk_widget_set_visible (_tmp8_, currency_manager_is_favorite (_tmp10_, _tmp14_));
#line 433 "../src/math-converter.vala"
	_g_free0 (_tmp14_);
#line 433 "../src/math-converter.vala"
	_g_object_unref0 (_tmp10_);
#line 435 "../src/math-converter.vala"
	switch (self->priv->_currency_display) {
#line 435 "../src/math-converter.vala"
		case CURRENCY_DISPLAY_CODE:
#line 3397 "math-converter.c"
		{
			gconstpointer _tmp15_;
			Unit* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
#line 438 "../src/math-converter.vala"
			_tmp15_ = g_object_get_data (item, "label");
#line 438 "../src/math-converter.vala"
			_tmp16_ = _data7_->unit;
#line 438 "../src/math-converter.vala"
			_tmp17_ = unit_get_name (_tmp16_);
#line 438 "../src/math-converter.vala"
			_tmp18_ = _tmp17_;
#line 438 "../src/math-converter.vala"
			_tmp19_ = _tmp18_;
#line 438 "../src/math-converter.vala"
			gtk_label_set_label ((GtkLabel*) _tmp15_, _tmp19_);
#line 438 "../src/math-converter.vala"
			_g_free0 (_tmp19_);
#line 439 "../src/math-converter.vala"
			break;
#line 3420 "math-converter.c"
		}
#line 435 "../src/math-converter.vala"
		case CURRENCY_DISPLAY_BOTH:
#line 3424 "math-converter.c"
		{
			gconstpointer _tmp20_;
			Unit* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
#line 441 "../src/math-converter.vala"
			_tmp20_ = g_object_get_data (item, "label");
#line 441 "../src/math-converter.vala"
			_tmp21_ = _data7_->unit;
#line 441 "../src/math-converter.vala"
			_tmp22_ = math_converter_currency_item (_tmp21_);
#line 441 "../src/math-converter.vala"
			_tmp23_ = _tmp22_;
#line 441 "../src/math-converter.vala"
			gtk_label_set_label ((GtkLabel*) _tmp20_, _tmp23_);
#line 441 "../src/math-converter.vala"
			_g_free0 (_tmp23_);
#line 442 "../src/math-converter.vala"
			break;
#line 3444 "math-converter.c"
		}
		default:
		{
			gconstpointer _tmp24_;
			Unit* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
#line 444 "../src/math-converter.vala"
			_tmp24_ = g_object_get_data (item, "label");
#line 444 "../src/math-converter.vala"
			_tmp25_ = _data7_->unit;
#line 444 "../src/math-converter.vala"
			_tmp26_ = unit_get_display_name (_tmp25_);
#line 444 "../src/math-converter.vala"
			_tmp27_ = _tmp26_;
#line 444 "../src/math-converter.vala"
			_tmp28_ = _tmp27_;
#line 444 "../src/math-converter.vala"
			gtk_label_set_label ((GtkLabel*) _tmp24_, _tmp28_);
#line 444 "../src/math-converter.vala"
			_g_free0 (_tmp28_);
#line 445 "../src/math-converter.vala"
			break;
#line 3469 "math-converter.c"
		}
	}
#line 448 "../src/math-converter.vala"
	_tmp29_ = g_signal_connect_data ((GObject*) _data7_->combo, "notify::selected", (GCallback) ___lambda9__g_object_notify, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 448 "../src/math-converter.vala"
	handler = _tmp29_;
#line 451 "../src/math-converter.vala"
	g_object_set_data_full (item, "handler", (gpointer) ((guintptr) handler), NULL);
#line 452 "../src/math-converter.vala"
	_tmp31_ = gtk_drop_down_get_selected_item (_data7_->combo);
#line 452 "../src/math-converter.vala"
	_tmp32_ = _tmp31_;
#line 452 "../src/math-converter.vala"
	_tmp33_ = _data7_->unit;
#line 452 "../src/math-converter.vala"
	if (_tmp32_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, G_TYPE_OBJECT, GObject)) {
#line 452 "../src/math-converter.vala"
		_tmp30_ = 1;
#line 3488 "math-converter.c"
	} else {
#line 452 "../src/math-converter.vala"
		_tmp30_ = 0;
#line 3492 "math-converter.c"
	}
#line 452 "../src/math-converter.vala"
	_tmp34_ = _data7_->box;
#line 452 "../src/math-converter.vala"
	_tmp35_ = gtk_widget_get_last_child (_tmp34_);
#line 452 "../src/math-converter.vala"
	gtk_widget_set_opacity (_tmp35_, (gdouble) _tmp30_);
#line 429 "../src/math-converter.vala"
	block7_data_unref (_data7_);
#line 429 "../src/math-converter.vala"
	_data7_ = NULL;
#line 3504 "math-converter.c"
}

static void
math_converter_unbind_currency (MathConverter* self,
                                GObject* item,
                                GtkDropDown* combo)
{
	gconstpointer _tmp0_;
#line 455 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 455 "../src/math-converter.vala"
	g_return_if_fail (item != NULL);
#line 455 "../src/math-converter.vala"
	g_return_if_fail (combo != NULL);
#line 457 "../src/math-converter.vala"
	_tmp0_ = g_object_get_data (item, "handler");
#line 457 "../src/math-converter.vala"
	g_signal_handler_disconnect ((GObject*) combo, (gulong) ((guintptr) _tmp0_));
#line 3523 "math-converter.c"
}

static gboolean
math_converter_set_active_unit (MathConverter* self,
                                GtkDropDown* combo,
                                Unit* unit)
{
	guint position = 0U;
	GListStore* model = NULL;
	GListModel* _tmp0_;
	GListStore* _tmp1_;
	GListStore* _tmp2_;
	guint _tmp3_ = 0U;
	gboolean result;
#line 460 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 460 "../src/math-converter.vala"
	g_return_val_if_fail (combo != NULL, FALSE);
#line 460 "../src/math-converter.vala"
	g_return_val_if_fail (unit != NULL, FALSE);
#line 462 "../src/math-converter.vala"
	position = (guint) 0;
#line 463 "../src/math-converter.vala"
	_tmp0_ = gtk_drop_down_get_model (combo);
#line 463 "../src/math-converter.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, g_list_store_get_type ()) ? ((GListStore*) _tmp0_) : NULL);
#line 463 "../src/math-converter.vala"
	model = _tmp1_;
#line 464 "../src/math-converter.vala"
	_tmp2_ = model;
#line 464 "../src/math-converter.vala"
	g_list_store_find (_tmp2_, (GObject*) unit, &_tmp3_);
#line 464 "../src/math-converter.vala"
	position = _tmp3_;
#line 465 "../src/math-converter.vala"
	if (position == ((guint) -1)) {
#line 466 "../src/math-converter.vala"
		result = FALSE;
#line 466 "../src/math-converter.vala"
		_g_object_unref0 (model);
#line 466 "../src/math-converter.vala"
		return result;
#line 3566 "math-converter.c"
	}
#line 467 "../src/math-converter.vala"
	gtk_drop_down_set_selected (combo, position);
#line 468 "../src/math-converter.vala"
	result = TRUE;
#line 468 "../src/math-converter.vala"
	_g_object_unref0 (model);
#line 468 "../src/math-converter.vala"
	return result;
#line 3576 "math-converter.c"
}

static void
math_converter_category_combobox_changed_cb (MathConverter* self)
{
	UnitCategory* category = NULL;
	GtkDropDown* _tmp0_;
	GObject* _tmp1_;
	GObject* _tmp2_;
	UnitCategory* _tmp3_;
	UnitCategory* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* source_unit = NULL;
	GHashTable* _tmp8_;
	UnitCategory* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gconstpointer _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* target_unit = NULL;
	GHashTable* _tmp16_;
	UnitCategory* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gconstpointer _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp32_;
#line 472 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 474 "../src/math-converter.vala"
	_tmp0_ = self->priv->category_combo;
#line 474 "../src/math-converter.vala"
	_tmp1_ = gtk_drop_down_get_selected_item (_tmp0_);
#line 474 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 474 "../src/math-converter.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, TYPE_UNIT_CATEGORY) ? ((UnitCategory*) _tmp2_) : NULL);
#line 474 "../src/math-converter.vala"
	category = _tmp3_;
#line 475 "../src/math-converter.vala"
	_tmp4_ = category;
#line 475 "../src/math-converter.vala"
	_tmp5_ = unit_category_get_name (_tmp4_);
#line 475 "../src/math-converter.vala"
	_tmp6_ = _tmp5_;
#line 475 "../src/math-converter.vala"
	_g_free0 (self->priv->category);
#line 475 "../src/math-converter.vala"
	self->priv->category = _tmp6_;
#line 477 "../src/math-converter.vala"
	math_converter_update_visibility (self);
#line 478 "../src/math-converter.vala"
	if (self->priv->from_combobox_changed > ((gulong) 0)) {
#line 3636 "math-converter.c"
		GtkDropDown* _tmp7_;
#line 479 "../src/math-converter.vala"
		_tmp7_ = self->priv->from_combo;
#line 479 "../src/math-converter.vala"
		g_signal_handler_block (_tmp7_, self->priv->from_combobox_changed);
#line 3642 "math-converter.c"
	}
#line 480 "../src/math-converter.vala"
	_tmp8_ = self->priv->_source_units;
#line 480 "../src/math-converter.vala"
	_tmp9_ = category;
#line 480 "../src/math-converter.vala"
	_tmp10_ = unit_category_get_name (_tmp9_);
#line 480 "../src/math-converter.vala"
	_tmp11_ = _tmp10_;
#line 480 "../src/math-converter.vala"
	_tmp12_ = _tmp11_;
#line 480 "../src/math-converter.vala"
	_tmp13_ = g_hash_table_lookup (_tmp8_, _tmp12_);
#line 480 "../src/math-converter.vala"
	_tmp14_ = g_strdup ((const gchar*) _tmp13_);
#line 480 "../src/math-converter.vala"
	_tmp15_ = _tmp14_;
#line 480 "../src/math-converter.vala"
	_g_free0 (_tmp12_);
#line 480 "../src/math-converter.vala"
	source_unit = _tmp15_;
#line 481 "../src/math-converter.vala"
	_tmp16_ = self->priv->_target_units;
#line 481 "../src/math-converter.vala"
	_tmp17_ = category;
#line 481 "../src/math-converter.vala"
	_tmp18_ = unit_category_get_name (_tmp17_);
#line 481 "../src/math-converter.vala"
	_tmp19_ = _tmp18_;
#line 481 "../src/math-converter.vala"
	_tmp20_ = _tmp19_;
#line 481 "../src/math-converter.vala"
	_tmp21_ = g_hash_table_lookup (_tmp16_, _tmp20_);
#line 481 "../src/math-converter.vala"
	_tmp22_ = g_strdup ((const gchar*) _tmp21_);
#line 481 "../src/math-converter.vala"
	_tmp23_ = _tmp22_;
#line 481 "../src/math-converter.vala"
	_g_free0 (_tmp20_);
#line 481 "../src/math-converter.vala"
	target_unit = _tmp23_;
#line 482 "../src/math-converter.vala"
	math_converter_build_units_model (self);
#line 483 "../src/math-converter.vala"
	_tmp24_ = source_unit;
#line 483 "../src/math-converter.vala"
	if (_tmp24_ == NULL) {
#line 3690 "math-converter.c"
		GtkDropDown* _tmp25_;
#line 484 "../src/math-converter.vala"
		_tmp25_ = self->priv->from_combo;
#line 484 "../src/math-converter.vala"
		gtk_drop_down_set_selected (_tmp25_, (guint) 0);
#line 3696 "math-converter.c"
	} else {
		GtkDropDown* _tmp26_;
		UnitManager* _tmp27_;
		UnitManager* _tmp28_;
		const gchar* _tmp29_;
		Unit* _tmp30_;
		Unit* _tmp31_;
#line 486 "../src/math-converter.vala"
		_tmp26_ = self->priv->from_combo;
#line 486 "../src/math-converter.vala"
		_tmp27_ = unit_manager_get_default ();
#line 486 "../src/math-converter.vala"
		_tmp28_ = _tmp27_;
#line 486 "../src/math-converter.vala"
		_tmp29_ = source_unit;
#line 486 "../src/math-converter.vala"
		_tmp30_ = unit_manager_get_unit_by_name (_tmp28_, _tmp29_);
#line 486 "../src/math-converter.vala"
		_tmp31_ = _tmp30_;
#line 486 "../src/math-converter.vala"
		math_converter_set_active_unit (self, _tmp26_, _tmp31_);
#line 486 "../src/math-converter.vala"
		_g_object_unref0 (_tmp31_);
#line 486 "../src/math-converter.vala"
		_g_object_unref0 (_tmp28_);
#line 3722 "math-converter.c"
	}
#line 487 "../src/math-converter.vala"
	_tmp32_ = target_unit;
#line 487 "../src/math-converter.vala"
	if (_tmp32_ == NULL) {
#line 3728 "math-converter.c"
		GtkDropDown* _tmp33_;
#line 488 "../src/math-converter.vala"
		_tmp33_ = self->priv->to_combo;
#line 488 "../src/math-converter.vala"
		gtk_drop_down_set_selected (_tmp33_, (guint) 0);
#line 3734 "math-converter.c"
	} else {
		GtkDropDown* _tmp34_;
		UnitManager* _tmp35_;
		UnitManager* _tmp36_;
		const gchar* _tmp37_;
		Unit* _tmp38_;
		Unit* _tmp39_;
#line 490 "../src/math-converter.vala"
		_tmp34_ = self->priv->to_combo;
#line 490 "../src/math-converter.vala"
		_tmp35_ = unit_manager_get_default ();
#line 490 "../src/math-converter.vala"
		_tmp36_ = _tmp35_;
#line 490 "../src/math-converter.vala"
		_tmp37_ = target_unit;
#line 490 "../src/math-converter.vala"
		_tmp38_ = unit_manager_get_unit_by_name (_tmp36_, _tmp37_);
#line 490 "../src/math-converter.vala"
		_tmp39_ = _tmp38_;
#line 490 "../src/math-converter.vala"
		math_converter_set_active_unit (self, _tmp34_, _tmp39_);
#line 490 "../src/math-converter.vala"
		_g_object_unref0 (_tmp39_);
#line 490 "../src/math-converter.vala"
		_g_object_unref0 (_tmp36_);
#line 3760 "math-converter.c"
	}
#line 491 "../src/math-converter.vala"
	if (self->priv->from_combobox_changed > ((gulong) 0)) {
#line 3764 "math-converter.c"
		GtkDropDown* _tmp40_;
#line 492 "../src/math-converter.vala"
		_tmp40_ = self->priv->from_combo;
#line 492 "../src/math-converter.vala"
		g_signal_handler_unblock (_tmp40_, self->priv->from_combobox_changed);
#line 3770 "math-converter.c"
	}
#line 493 "../src/math-converter.vala"
	math_converter_to_combobox_changed_cb (self);
#line 494 "../src/math-converter.vala"
	math_converter_reformat_from_entry (self);
#line 472 "../src/math-converter.vala"
	_g_free0 (target_unit);
#line 472 "../src/math-converter.vala"
	_g_free0 (source_unit);
#line 472 "../src/math-converter.vala"
	_g_object_unref0 (category);
#line 3782 "math-converter.c"
}

static void
_math_converter_category_combobox_changed_cb_g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self)
{
#line 19 "../src/math-converter.vala"
	math_converter_category_combobox_changed_cb ((MathConverter*) self);
#line 3792 "math-converter.c"
}

static void
math_converter_from_combobox_changed_cb (MathConverter* self)
{
	Number* _tmp0_;
	Unit* source_unit = NULL;
	Unit* target_unit = NULL;
	Number* _tmp1_;
	Unit* _tmp2_ = NULL;
	Unit* _tmp3_ = NULL;
	Number* _tmp4_;
	Number* _tmp5_;
	GtkTextView* _tmp7_;
	GtkTextBuffer* _tmp8_;
	GtkTextBuffer* _tmp9_;
	GtkTextView* _tmp10_;
	MathEquation* _tmp11_;
	Serializer* _tmp12_;
	Serializer* _tmp13_;
	GtkTextView* _tmp14_;
	GtkTextBuffer* _tmp15_;
	GtkTextBuffer* _tmp16_;
	GHashTable* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	Unit* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
#line 497 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 499 "../src/math-converter.vala"
	_tmp0_ = self->priv->to_number;
#line 499 "../src/math-converter.vala"
	if (_tmp0_ == NULL) {
#line 500 "../src/math-converter.vala"
		return;
#line 3830 "math-converter.c"
	}
#line 502 "../src/math-converter.vala"
	_tmp1_ = self->priv->to_number;
#line 502 "../src/math-converter.vala"
	_tmp4_ = math_converter_convert_equation (self, _tmp1_, &_tmp2_, &_tmp3_);
#line 502 "../src/math-converter.vala"
	_g_object_unref0 (source_unit);
#line 502 "../src/math-converter.vala"
	source_unit = _tmp2_;
#line 502 "../src/math-converter.vala"
	_g_object_unref0 (target_unit);
#line 502 "../src/math-converter.vala"
	target_unit = _tmp3_;
#line 502 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->from_number);
#line 502 "../src/math-converter.vala"
	self->priv->from_number = _tmp4_;
#line 503 "../src/math-converter.vala"
	_tmp5_ = self->priv->from_number;
#line 503 "../src/math-converter.vala"
	if (_tmp5_ == NULL) {
#line 3852 "math-converter.c"
		Number* _tmp6_;
#line 504 "../src/math-converter.vala"
		_tmp6_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 504 "../src/math-converter.vala"
		_g_object_unref0 (self->priv->from_number);
#line 504 "../src/math-converter.vala"
		self->priv->from_number = _tmp6_;
#line 3860 "math-converter.c"
	}
#line 505 "../src/math-converter.vala"
	_tmp7_ = self->priv->from_entry;
#line 505 "../src/math-converter.vala"
	_tmp8_ = gtk_text_view_get_buffer (_tmp7_);
#line 505 "../src/math-converter.vala"
	_tmp9_ = _tmp8_;
#line 505 "../src/math-converter.vala"
	g_signal_handler_block (_tmp9_, self->priv->from_entry_changed);
#line 506 "../src/math-converter.vala"
	_tmp10_ = self->priv->from_entry;
#line 506 "../src/math-converter.vala"
	_tmp11_ = self->priv->_equation;
#line 506 "../src/math-converter.vala"
	_tmp12_ = math_equation_get_serializer (_tmp11_);
#line 506 "../src/math-converter.vala"
	_tmp13_ = _tmp12_;
#line 506 "../src/math-converter.vala"
	math_converter_update_entry (self, _tmp10_, _tmp13_);
#line 507 "../src/math-converter.vala"
	_tmp14_ = self->priv->from_entry;
#line 507 "../src/math-converter.vala"
	_tmp15_ = gtk_text_view_get_buffer (_tmp14_);
#line 507 "../src/math-converter.vala"
	_tmp16_ = _tmp15_;
#line 507 "../src/math-converter.vala"
	g_signal_handler_unblock (_tmp16_, self->priv->from_entry_changed);
#line 508 "../src/math-converter.vala"
	_tmp17_ = self->priv->_source_units;
#line 508 "../src/math-converter.vala"
	_tmp18_ = self->priv->category;
#line 508 "../src/math-converter.vala"
	_tmp19_ = g_strdup (_tmp18_);
#line 508 "../src/math-converter.vala"
	_tmp20_ = source_unit;
#line 508 "../src/math-converter.vala"
	_tmp21_ = unit_get_name (_tmp20_);
#line 508 "../src/math-converter.vala"
	_tmp22_ = _tmp21_;
#line 508 "../src/math-converter.vala"
	g_hash_table_insert (_tmp17_, _tmp19_, _tmp22_);
#line 509 "../src/math-converter.vala"
	g_signal_emit (self, math_converter_signals[MATH_CONVERTER_CHANGED_SIGNAL], 0);
#line 497 "../src/math-converter.vala"
	_g_object_unref0 (target_unit);
#line 497 "../src/math-converter.vala"
	_g_object_unref0 (source_unit);
#line 3908 "math-converter.c"
}

static void
math_converter_to_combobox_changed_cb (MathConverter* self)
{
	Number* _tmp0_;
	Unit* source_unit = NULL;
	Unit* target_unit = NULL;
	Number* _tmp1_;
	Unit* _tmp2_ = NULL;
	Unit* _tmp3_ = NULL;
	Number* _tmp4_;
	Number* _tmp5_;
	GtkTextView* _tmp7_;
	GtkTextBuffer* _tmp8_;
	GtkTextBuffer* _tmp9_;
	GtkTextView* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	GtkTextView* _tmp19_;
	GtkTextBuffer* _tmp20_;
	GtkTextBuffer* _tmp21_;
	GHashTable* _tmp22_;
	const gchar* _tmp23_;
	gchar* _tmp24_;
	Unit* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
#line 513 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 515 "../src/math-converter.vala"
	_tmp0_ = self->priv->from_number;
#line 515 "../src/math-converter.vala"
	if (_tmp0_ == NULL) {
#line 516 "../src/math-converter.vala"
		return;
#line 3945 "math-converter.c"
	}
#line 518 "../src/math-converter.vala"
	_tmp1_ = self->priv->from_number;
#line 518 "../src/math-converter.vala"
	_tmp4_ = math_converter_convert_equation (self, _tmp1_, &_tmp2_, &_tmp3_);
#line 518 "../src/math-converter.vala"
	_g_object_unref0 (source_unit);
#line 518 "../src/math-converter.vala"
	source_unit = _tmp2_;
#line 518 "../src/math-converter.vala"
	_g_object_unref0 (target_unit);
#line 518 "../src/math-converter.vala"
	target_unit = _tmp3_;
#line 518 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->to_number);
#line 518 "../src/math-converter.vala"
	self->priv->to_number = _tmp4_;
#line 519 "../src/math-converter.vala"
	_tmp5_ = self->priv->to_number;
#line 519 "../src/math-converter.vala"
	if (_tmp5_ == NULL) {
#line 3967 "math-converter.c"
		Number* _tmp6_;
#line 520 "../src/math-converter.vala"
		_tmp6_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 520 "../src/math-converter.vala"
		_g_object_unref0 (self->priv->to_number);
#line 520 "../src/math-converter.vala"
		self->priv->to_number = _tmp6_;
#line 3975 "math-converter.c"
	}
#line 521 "../src/math-converter.vala"
	_tmp7_ = self->priv->to_entry;
#line 521 "../src/math-converter.vala"
	_tmp8_ = gtk_text_view_get_buffer (_tmp7_);
#line 521 "../src/math-converter.vala"
	_tmp9_ = _tmp8_;
#line 521 "../src/math-converter.vala"
	g_signal_handler_block (_tmp9_, self->priv->to_entry_changed);
#line 522 "../src/math-converter.vala"
	_tmp10_ = self->priv->to_entry;
#line 522 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp10_, "has-focus", &_tmp11_, NULL);
#line 522 "../src/math-converter.vala"
	_tmp12_ = _tmp11_;
#line 522 "../src/math-converter.vala"
	if (_tmp12_) {
#line 3993 "math-converter.c"
		GtkTextView* _tmp13_;
		Serializer* _tmp14_;
#line 523 "../src/math-converter.vala"
		_tmp13_ = self->priv->to_entry;
#line 523 "../src/math-converter.vala"
		_tmp14_ = self->priv->fixed_serializer;
#line 523 "../src/math-converter.vala"
		math_converter_update_entry (self, _tmp13_, _tmp14_);
#line 4002 "math-converter.c"
	} else {
		GtkTextView* _tmp15_;
		MathEquation* _tmp16_;
		Serializer* _tmp17_;
		Serializer* _tmp18_;
#line 525 "../src/math-converter.vala"
		_tmp15_ = self->priv->to_entry;
#line 525 "../src/math-converter.vala"
		_tmp16_ = self->priv->_equation;
#line 525 "../src/math-converter.vala"
		_tmp17_ = math_equation_get_serializer (_tmp16_);
#line 525 "../src/math-converter.vala"
		_tmp18_ = _tmp17_;
#line 525 "../src/math-converter.vala"
		math_converter_update_entry (self, _tmp15_, _tmp18_);
#line 4018 "math-converter.c"
	}
#line 526 "../src/math-converter.vala"
	_tmp19_ = self->priv->to_entry;
#line 526 "../src/math-converter.vala"
	_tmp20_ = gtk_text_view_get_buffer (_tmp19_);
#line 526 "../src/math-converter.vala"
	_tmp21_ = _tmp20_;
#line 526 "../src/math-converter.vala"
	g_signal_handler_unblock (_tmp21_, self->priv->to_entry_changed);
#line 527 "../src/math-converter.vala"
	_tmp22_ = self->priv->_target_units;
#line 527 "../src/math-converter.vala"
	_tmp23_ = self->priv->category;
#line 527 "../src/math-converter.vala"
	_tmp24_ = g_strdup (_tmp23_);
#line 527 "../src/math-converter.vala"
	_tmp25_ = target_unit;
#line 527 "../src/math-converter.vala"
	_tmp26_ = unit_get_name (_tmp25_);
#line 527 "../src/math-converter.vala"
	_tmp27_ = _tmp26_;
#line 527 "../src/math-converter.vala"
	g_hash_table_insert (_tmp22_, _tmp24_, _tmp27_);
#line 528 "../src/math-converter.vala"
	g_signal_emit (self, math_converter_signals[MATH_CONVERTER_CHANGED_SIGNAL], 0);
#line 513 "../src/math-converter.vala"
	_g_object_unref0 (target_unit);
#line 513 "../src/math-converter.vala"
	_g_object_unref0 (source_unit);
#line 4048 "math-converter.c"
}

static void
_math_converter_to_combobox_changed_cb_g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self)
{
#line 19 "../src/math-converter.vala"
	math_converter_to_combobox_changed_cb ((MathConverter*) self);
#line 4058 "math-converter.c"
}

static void
math_converter_from_entry_focus_cb (MathConverter* self)
{
	GtkTextView* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	GtkTextView* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GtkTextView* _tmp16_;
	GtkTextBuffer* _tmp17_;
	GtkTextBuffer* _tmp18_;
#line 532 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 534 "../src/math-converter.vala"
	_tmp0_ = self->priv->from_entry;
#line 534 "../src/math-converter.vala"
	_tmp1_ = gtk_text_view_get_buffer (_tmp0_);
#line 534 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 534 "../src/math-converter.vala"
	g_signal_handler_block (_tmp2_, self->priv->from_entry_changed);
#line 535 "../src/math-converter.vala"
	_tmp3_ = self->priv->from_entry;
#line 535 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp3_, "has-focus", &_tmp4_, NULL);
#line 535 "../src/math-converter.vala"
	_tmp5_ = _tmp4_;
#line 535 "../src/math-converter.vala"
	if (_tmp5_) {
#line 4091 "math-converter.c"
		GtkTextView* _tmp6_;
		Serializer* _tmp7_;
#line 537 "../src/math-converter.vala"
		_tmp6_ = self->priv->from_entry;
#line 537 "../src/math-converter.vala"
		_tmp7_ = self->priv->fixed_serializer;
#line 537 "../src/math-converter.vala"
		math_converter_update_entry (self, _tmp6_, _tmp7_);
#line 4100 "math-converter.c"
	} else {
		GtkTextView* _tmp8_;
		Number* _tmp9_;
		Number* _tmp10_;
		GtkTextView* _tmp12_;
		MathEquation* _tmp13_;
		Serializer* _tmp14_;
		Serializer* _tmp15_;
#line 541 "../src/math-converter.vala"
		_tmp8_ = self->priv->from_entry;
#line 541 "../src/math-converter.vala"
		_tmp9_ = math_converter_get_number_from_entry (self, _tmp8_);
#line 541 "../src/math-converter.vala"
		_g_object_unref0 (self->priv->from_number);
#line 541 "../src/math-converter.vala"
		self->priv->from_number = _tmp9_;
#line 542 "../src/math-converter.vala"
		_tmp10_ = self->priv->from_number;
#line 542 "../src/math-converter.vala"
		if (_tmp10_ == NULL) {
#line 4121 "math-converter.c"
			Number* _tmp11_;
#line 544 "../src/math-converter.vala"
			_tmp11_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 544 "../src/math-converter.vala"
			_g_object_unref0 (self->priv->from_number);
#line 544 "../src/math-converter.vala"
			self->priv->from_number = _tmp11_;
#line 545 "../src/math-converter.vala"
			math_converter_to_combobox_changed_cb (self);
#line 4131 "math-converter.c"
		}
#line 547 "../src/math-converter.vala"
		_tmp12_ = self->priv->from_entry;
#line 547 "../src/math-converter.vala"
		_tmp13_ = self->priv->_equation;
#line 547 "../src/math-converter.vala"
		_tmp14_ = math_equation_get_serializer (_tmp13_);
#line 547 "../src/math-converter.vala"
		_tmp15_ = _tmp14_;
#line 547 "../src/math-converter.vala"
		math_converter_update_entry (self, _tmp12_, _tmp15_);
#line 4143 "math-converter.c"
	}
#line 549 "../src/math-converter.vala"
	_tmp16_ = self->priv->from_entry;
#line 549 "../src/math-converter.vala"
	_tmp17_ = gtk_text_view_get_buffer (_tmp16_);
#line 549 "../src/math-converter.vala"
	_tmp18_ = _tmp17_;
#line 549 "../src/math-converter.vala"
	g_signal_handler_unblock (_tmp18_, self->priv->from_entry_changed);
#line 550 "../src/math-converter.vala"
	g_signal_emit (self, math_converter_signals[MATH_CONVERTER_CHANGED_SIGNAL], 0);
#line 4155 "math-converter.c"
}

static void
_math_converter_from_entry_focus_cb_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
#line 19 "../src/math-converter.vala"
	math_converter_from_entry_focus_cb ((MathConverter*) self);
#line 4165 "math-converter.c"
}

static void
math_converter_to_entry_focus_cb (MathConverter* self)
{
	GtkTextView* _tmp0_;
	GtkTextBuffer* _tmp1_;
	GtkTextBuffer* _tmp2_;
	GtkTextView* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GtkTextView* _tmp16_;
	GtkTextBuffer* _tmp17_;
	GtkTextBuffer* _tmp18_;
#line 554 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 556 "../src/math-converter.vala"
	_tmp0_ = self->priv->to_entry;
#line 556 "../src/math-converter.vala"
	_tmp1_ = gtk_text_view_get_buffer (_tmp0_);
#line 556 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 556 "../src/math-converter.vala"
	g_signal_handler_block (_tmp2_, self->priv->to_entry_changed);
#line 557 "../src/math-converter.vala"
	_tmp3_ = self->priv->to_entry;
#line 557 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp3_, "has-focus", &_tmp4_, NULL);
#line 557 "../src/math-converter.vala"
	_tmp5_ = _tmp4_;
#line 557 "../src/math-converter.vala"
	if (_tmp5_) {
#line 4198 "math-converter.c"
		GtkTextView* _tmp6_;
		Serializer* _tmp7_;
#line 559 "../src/math-converter.vala"
		_tmp6_ = self->priv->to_entry;
#line 559 "../src/math-converter.vala"
		_tmp7_ = self->priv->fixed_serializer;
#line 559 "../src/math-converter.vala"
		math_converter_update_entry (self, _tmp6_, _tmp7_);
#line 4207 "math-converter.c"
	} else {
		GtkTextView* _tmp8_;
		Number* _tmp9_;
		Number* _tmp10_;
		GtkTextView* _tmp12_;
		MathEquation* _tmp13_;
		Serializer* _tmp14_;
		Serializer* _tmp15_;
#line 563 "../src/math-converter.vala"
		_tmp8_ = self->priv->to_entry;
#line 563 "../src/math-converter.vala"
		_tmp9_ = math_converter_get_number_from_entry (self, _tmp8_);
#line 563 "../src/math-converter.vala"
		_g_object_unref0 (self->priv->to_number);
#line 563 "../src/math-converter.vala"
		self->priv->to_number = _tmp9_;
#line 564 "../src/math-converter.vala"
		_tmp10_ = self->priv->to_number;
#line 564 "../src/math-converter.vala"
		if (_tmp10_ == NULL) {
#line 4228 "math-converter.c"
			Number* _tmp11_;
#line 566 "../src/math-converter.vala"
			_tmp11_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 566 "../src/math-converter.vala"
			_g_object_unref0 (self->priv->to_number);
#line 566 "../src/math-converter.vala"
			self->priv->to_number = _tmp11_;
#line 567 "../src/math-converter.vala"
			math_converter_from_combobox_changed_cb (self);
#line 4238 "math-converter.c"
		}
#line 569 "../src/math-converter.vala"
		_tmp12_ = self->priv->to_entry;
#line 569 "../src/math-converter.vala"
		_tmp13_ = self->priv->_equation;
#line 569 "../src/math-converter.vala"
		_tmp14_ = math_equation_get_serializer (_tmp13_);
#line 569 "../src/math-converter.vala"
		_tmp15_ = _tmp14_;
#line 569 "../src/math-converter.vala"
		math_converter_update_entry (self, _tmp12_, _tmp15_);
#line 4250 "math-converter.c"
	}
#line 571 "../src/math-converter.vala"
	_tmp16_ = self->priv->to_entry;
#line 571 "../src/math-converter.vala"
	_tmp17_ = gtk_text_view_get_buffer (_tmp16_);
#line 571 "../src/math-converter.vala"
	_tmp18_ = _tmp17_;
#line 571 "../src/math-converter.vala"
	g_signal_handler_unblock (_tmp18_, self->priv->to_entry_changed);
#line 572 "../src/math-converter.vala"
	g_signal_emit (self, math_converter_signals[MATH_CONVERTER_CHANGED_SIGNAL], 0);
#line 4262 "math-converter.c"
}

static void
_math_converter_to_entry_focus_cb_g_object_notify (GObject* _sender,
                                                   GParamSpec* pspec,
                                                   gpointer self)
{
#line 19 "../src/math-converter.vala"
	math_converter_to_entry_focus_cb ((MathConverter*) self);
#line 4272 "math-converter.c"
}

static void
math_converter_from_entry_changed_cb (MathConverter* self)
{
	GtkTextView* _tmp0_;
	Number* _tmp1_;
	gboolean _error_ = FALSE;
	Number* _tmp2_;
	Unit* source_unit = NULL;
	Unit* target_unit = NULL;
	Number* _tmp4_;
	Unit* _tmp5_ = NULL;
	Unit* _tmp6_ = NULL;
	Number* _tmp7_;
	Number* _tmp8_;
	GtkTextView* _tmp10_;
	GtkTextBuffer* _tmp11_;
	GtkTextBuffer* _tmp12_;
	GtkTextView* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	GtkTextView* _tmp25_;
	GtkTextBuffer* _tmp26_;
	GtkTextBuffer* _tmp27_;
#line 575 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 577 "../src/math-converter.vala"
	_tmp0_ = self->priv->from_entry;
#line 577 "../src/math-converter.vala"
	_tmp1_ = math_converter_get_number_from_entry (self, _tmp0_);
#line 577 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->from_number);
#line 577 "../src/math-converter.vala"
	self->priv->from_number = _tmp1_;
#line 578 "../src/math-converter.vala"
	_tmp2_ = self->priv->from_number;
#line 578 "../src/math-converter.vala"
	_error_ = _tmp2_ == NULL;
#line 579 "../src/math-converter.vala"
	if (_error_) {
#line 4314 "math-converter.c"
		Number* _tmp3_;
#line 580 "../src/math-converter.vala"
		_tmp3_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 580 "../src/math-converter.vala"
		_g_object_unref0 (self->priv->from_number);
#line 580 "../src/math-converter.vala"
		self->priv->from_number = _tmp3_;
#line 4322 "math-converter.c"
	}
#line 582 "../src/math-converter.vala"
	_tmp4_ = self->priv->from_number;
#line 582 "../src/math-converter.vala"
	_tmp7_ = math_converter_convert_equation (self, _tmp4_, &_tmp5_, &_tmp6_);
#line 582 "../src/math-converter.vala"
	_g_object_unref0 (source_unit);
#line 582 "../src/math-converter.vala"
	source_unit = _tmp5_;
#line 582 "../src/math-converter.vala"
	_g_object_unref0 (target_unit);
#line 582 "../src/math-converter.vala"
	target_unit = _tmp6_;
#line 582 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->to_number);
#line 582 "../src/math-converter.vala"
	self->priv->to_number = _tmp7_;
#line 583 "../src/math-converter.vala"
	_tmp8_ = self->priv->to_number;
#line 583 "../src/math-converter.vala"
	if (_tmp8_ == NULL) {
#line 4344 "math-converter.c"
		Number* _tmp9_;
#line 584 "../src/math-converter.vala"
		_tmp9_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 584 "../src/math-converter.vala"
		_g_object_unref0 (self->priv->to_number);
#line 584 "../src/math-converter.vala"
		self->priv->to_number = _tmp9_;
#line 4352 "math-converter.c"
	}
#line 585 "../src/math-converter.vala"
	_tmp10_ = self->priv->to_entry;
#line 585 "../src/math-converter.vala"
	_tmp11_ = gtk_text_view_get_buffer (_tmp10_);
#line 585 "../src/math-converter.vala"
	_tmp12_ = _tmp11_;
#line 585 "../src/math-converter.vala"
	g_signal_handler_block (_tmp12_, self->priv->to_entry_changed);
#line 586 "../src/math-converter.vala"
	_tmp13_ = self->priv->to_entry;
#line 586 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp13_, "has-focus", &_tmp14_, NULL);
#line 586 "../src/math-converter.vala"
	_tmp15_ = _tmp14_;
#line 586 "../src/math-converter.vala"
	if (_tmp15_) {
#line 4370 "math-converter.c"
		GtkTextView* _tmp16_;
		Serializer* _tmp17_;
#line 587 "../src/math-converter.vala"
		_tmp16_ = self->priv->to_entry;
#line 587 "../src/math-converter.vala"
		_tmp17_ = self->priv->fixed_serializer;
#line 587 "../src/math-converter.vala"
		math_converter_update_entry (self, _tmp16_, _tmp17_);
#line 4379 "math-converter.c"
	} else {
#line 588 "../src/math-converter.vala"
		if (!_error_) {
#line 4383 "math-converter.c"
			GtkTextView* _tmp18_;
			MathEquation* _tmp19_;
			Serializer* _tmp20_;
			Serializer* _tmp21_;
#line 589 "../src/math-converter.vala"
			_tmp18_ = self->priv->to_entry;
#line 589 "../src/math-converter.vala"
			_tmp19_ = self->priv->_equation;
#line 589 "../src/math-converter.vala"
			_tmp20_ = math_equation_get_serializer (_tmp19_);
#line 589 "../src/math-converter.vala"
			_tmp21_ = _tmp20_;
#line 589 "../src/math-converter.vala"
			math_converter_update_entry (self, _tmp18_, _tmp21_);
#line 4398 "math-converter.c"
		} else {
			GtkTextView* _tmp22_;
			GtkTextBuffer* _tmp23_;
			GtkTextBuffer* _tmp24_;
#line 591 "../src/math-converter.vala"
			_tmp22_ = self->priv->to_entry;
#line 591 "../src/math-converter.vala"
			_tmp23_ = gtk_text_view_get_buffer (_tmp22_);
#line 591 "../src/math-converter.vala"
			_tmp24_ = _tmp23_;
#line 591 "../src/math-converter.vala"
			g_object_set (_tmp24_, "text", _ ("Error"), NULL);
#line 4411 "math-converter.c"
		}
	}
#line 592 "../src/math-converter.vala"
	_tmp25_ = self->priv->to_entry;
#line 592 "../src/math-converter.vala"
	_tmp26_ = gtk_text_view_get_buffer (_tmp25_);
#line 592 "../src/math-converter.vala"
	_tmp27_ = _tmp26_;
#line 592 "../src/math-converter.vala"
	g_signal_handler_unblock (_tmp27_, self->priv->to_entry_changed);
#line 575 "../src/math-converter.vala"
	_g_object_unref0 (target_unit);
#line 575 "../src/math-converter.vala"
	_g_object_unref0 (source_unit);
#line 4426 "math-converter.c"
}

static void
math_converter_to_entry_changed_cb (MathConverter* self)
{
	GtkTextView* _tmp0_;
	Number* _tmp1_;
	gboolean _error_ = FALSE;
	Number* _tmp2_;
	Unit* source_unit = NULL;
	Unit* target_unit = NULL;
	Number* _tmp4_;
	Unit* _tmp5_ = NULL;
	Unit* _tmp6_ = NULL;
	Number* _tmp7_;
	Number* _tmp8_;
	GtkTextView* _tmp10_;
	GtkTextBuffer* _tmp11_;
	GtkTextBuffer* _tmp12_;
	GtkTextView* _tmp20_;
	GtkTextBuffer* _tmp21_;
	GtkTextBuffer* _tmp22_;
#line 595 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 597 "../src/math-converter.vala"
	_tmp0_ = self->priv->to_entry;
#line 597 "../src/math-converter.vala"
	_tmp1_ = math_converter_get_number_from_entry (self, _tmp0_);
#line 597 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->to_number);
#line 597 "../src/math-converter.vala"
	self->priv->to_number = _tmp1_;
#line 598 "../src/math-converter.vala"
	_tmp2_ = self->priv->to_number;
#line 598 "../src/math-converter.vala"
	_error_ = _tmp2_ == NULL;
#line 599 "../src/math-converter.vala"
	if (_error_) {
#line 4465 "math-converter.c"
		Number* _tmp3_;
#line 600 "../src/math-converter.vala"
		_tmp3_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 600 "../src/math-converter.vala"
		_g_object_unref0 (self->priv->to_number);
#line 600 "../src/math-converter.vala"
		self->priv->to_number = _tmp3_;
#line 4473 "math-converter.c"
	}
#line 602 "../src/math-converter.vala"
	_tmp4_ = self->priv->to_number;
#line 602 "../src/math-converter.vala"
	_tmp7_ = math_converter_convert_equation (self, _tmp4_, &_tmp5_, &_tmp6_);
#line 602 "../src/math-converter.vala"
	_g_object_unref0 (source_unit);
#line 602 "../src/math-converter.vala"
	source_unit = _tmp5_;
#line 602 "../src/math-converter.vala"
	_g_object_unref0 (target_unit);
#line 602 "../src/math-converter.vala"
	target_unit = _tmp6_;
#line 602 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->from_number);
#line 602 "../src/math-converter.vala"
	self->priv->from_number = _tmp7_;
#line 603 "../src/math-converter.vala"
	_tmp8_ = self->priv->from_number;
#line 603 "../src/math-converter.vala"
	if (_tmp8_ == NULL) {
#line 4495 "math-converter.c"
		Number* _tmp9_;
#line 604 "../src/math-converter.vala"
		_tmp9_ = number_new_integer ((gint64) 0, (gint64) 0);
#line 604 "../src/math-converter.vala"
		_g_object_unref0 (self->priv->from_number);
#line 604 "../src/math-converter.vala"
		self->priv->from_number = _tmp9_;
#line 4503 "math-converter.c"
	}
#line 605 "../src/math-converter.vala"
	_tmp10_ = self->priv->from_entry;
#line 605 "../src/math-converter.vala"
	_tmp11_ = gtk_text_view_get_buffer (_tmp10_);
#line 605 "../src/math-converter.vala"
	_tmp12_ = _tmp11_;
#line 605 "../src/math-converter.vala"
	g_signal_handler_block (_tmp12_, self->priv->from_entry_changed);
#line 606 "../src/math-converter.vala"
	if (!_error_) {
#line 4515 "math-converter.c"
		GtkTextView* _tmp13_;
		MathEquation* _tmp14_;
		Serializer* _tmp15_;
		Serializer* _tmp16_;
#line 607 "../src/math-converter.vala"
		_tmp13_ = self->priv->from_entry;
#line 607 "../src/math-converter.vala"
		_tmp14_ = self->priv->_equation;
#line 607 "../src/math-converter.vala"
		_tmp15_ = math_equation_get_serializer (_tmp14_);
#line 607 "../src/math-converter.vala"
		_tmp16_ = _tmp15_;
#line 607 "../src/math-converter.vala"
		math_converter_update_entry (self, _tmp13_, _tmp16_);
#line 4530 "math-converter.c"
	} else {
		GtkTextView* _tmp17_;
		GtkTextBuffer* _tmp18_;
		GtkTextBuffer* _tmp19_;
#line 609 "../src/math-converter.vala"
		_tmp17_ = self->priv->from_entry;
#line 609 "../src/math-converter.vala"
		_tmp18_ = gtk_text_view_get_buffer (_tmp17_);
#line 609 "../src/math-converter.vala"
		_tmp19_ = _tmp18_;
#line 609 "../src/math-converter.vala"
		g_object_set (_tmp19_, "text", _ ("Error"), NULL);
#line 4543 "math-converter.c"
	}
#line 610 "../src/math-converter.vala"
	_tmp20_ = self->priv->from_entry;
#line 610 "../src/math-converter.vala"
	_tmp21_ = gtk_text_view_get_buffer (_tmp20_);
#line 610 "../src/math-converter.vala"
	_tmp22_ = _tmp21_;
#line 610 "../src/math-converter.vala"
	g_signal_handler_unblock (_tmp22_, self->priv->from_entry_changed);
#line 595 "../src/math-converter.vala"
	_g_object_unref0 (target_unit);
#line 595 "../src/math-converter.vala"
	_g_object_unref0 (source_unit);
#line 4557 "math-converter.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result;
#line 1413 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1414 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1414 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1415 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1416 "glib-2.0.vapi"
	result = _result_;
#line 1416 "glib-2.0.vapi"
	return result;
#line 4578 "math-converter.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1588 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1589 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 4600 "math-converter.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 4604 "math-converter.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 4610 "math-converter.c"
	} else {
#line 1589 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 4614 "math-converter.c"
	}
#line 1589 "glib-2.0.vapi"
	if (_tmp0_) {
#line 4618 "math-converter.c"
		gchar* _tmp2_;
#line 1590 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1590 "glib-2.0.vapi"
		result = _tmp2_;
#line 1590 "glib-2.0.vapi"
		return result;
#line 4626 "math-converter.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1593 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1593 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1593 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1593 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1593 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1593 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1593 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1593 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 4654 "math-converter.c"
				goto __catch0_g_regex_error;
			}
#line 1593 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1593 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1593 "glib-2.0.vapi"
			return NULL;
#line 4663 "math-converter.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1594 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1594 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1594 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1594 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 4677 "math-converter.c"
				goto __catch0_g_regex_error;
			}
#line 1594 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1594 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1594 "glib-2.0.vapi"
			return NULL;
#line 4686 "math-converter.c"
		}
#line 1594 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1594 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1594 "glib-2.0.vapi"
		result = _tmp10_;
#line 1594 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1594 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1594 "glib-2.0.vapi"
		return result;
#line 4700 "math-converter.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1592 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1596 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 4709 "math-converter.c"
	}
	__finally0:
#line 1592 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1592 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1592 "glib-2.0.vapi"
	return NULL;
#line 4718 "math-converter.c"
}

static Number*
math_converter_get_number_from_entry (MathConverter* self,
                                      GtkTextView* entry)
{
	gchar* str = NULL;
	GtkTextBuffer* _tmp0_;
	GtkTextBuffer* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	Serializer* _tmp7_;
	gint number_base = 0;
	const gchar* _tmp13_;
	const gchar* _tmp25_;
	const gchar* _tmp48_;
	Number* _tmp49_;
	Number* result;
#line 613 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 613 "../src/math-converter.vala"
	g_return_val_if_fail (entry != NULL, NULL);
#line 615 "../src/math-converter.vala"
	_tmp0_ = gtk_text_view_get_buffer (entry);
#line 615 "../src/math-converter.vala"
	_tmp1_ = _tmp0_;
#line 615 "../src/math-converter.vala"
	g_object_get (_tmp1_, "text", &_tmp2_, NULL);
#line 615 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 615 "../src/math-converter.vala"
	_tmp4_ = _tmp3_;
#line 615 "../src/math-converter.vala"
	_tmp5_ = string_strip (_tmp4_);
#line 615 "../src/math-converter.vala"
	_tmp6_ = _tmp5_;
#line 615 "../src/math-converter.vala"
	_g_free0 (_tmp4_);
#line 615 "../src/math-converter.vala"
	str = _tmp6_;
#line 616 "../src/math-converter.vala"
	_tmp7_ = self->priv->fixed_serializer;
#line 616 "../src/math-converter.vala"
	if (serializer_get_radix (_tmp7_) != ((gunichar) '.')) {
#line 4766 "math-converter.c"
		const gchar* _tmp8_;
		Serializer* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 617 "../src/math-converter.vala"
		_tmp8_ = str;
#line 617 "../src/math-converter.vala"
		_tmp9_ = self->priv->fixed_serializer;
#line 617 "../src/math-converter.vala"
		_tmp10_ = g_unichar_to_string (serializer_get_radix (_tmp9_));
#line 617 "../src/math-converter.vala"
		_tmp11_ = _tmp10_;
#line 617 "../src/math-converter.vala"
		_tmp12_ = string_replace (_tmp8_, _tmp11_, ".");
#line 617 "../src/math-converter.vala"
		_g_free0 (str);
#line 617 "../src/math-converter.vala"
		str = _tmp12_;
#line 617 "../src/math-converter.vala"
		_g_free0 (_tmp11_);
#line 4788 "math-converter.c"
	}
#line 618 "../src/math-converter.vala"
	number_base = 10;
#line 619 "../src/math-converter.vala"
	_tmp13_ = self->priv->category;
#line 619 "../src/math-converter.vala"
	if (g_strcmp0 (_tmp13_, "numberbase") == 0) {
#line 4796 "math-converter.c"
		GtkDropDown* _tmp14_ = NULL;
		GtkTextView* _tmp15_;
		GtkDropDown* combo = NULL;
		GtkDropDown* _tmp18_;
		GtkDropDown* _tmp19_;
		GObject* _tmp20_;
		GObject* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
#line 621 "../src/math-converter.vala"
		_tmp15_ = self->priv->from_entry;
#line 621 "../src/math-converter.vala"
		if (entry == _tmp15_) {
#line 4811 "math-converter.c"
			GtkDropDown* _tmp16_;
#line 621 "../src/math-converter.vala"
			_tmp16_ = self->priv->from_combo;
#line 621 "../src/math-converter.vala"
			_tmp14_ = _tmp16_;
#line 4817 "math-converter.c"
		} else {
			GtkDropDown* _tmp17_;
#line 621 "../src/math-converter.vala"
			_tmp17_ = self->priv->to_combo;
#line 621 "../src/math-converter.vala"
			_tmp14_ = _tmp17_;
#line 4824 "math-converter.c"
		}
#line 621 "../src/math-converter.vala"
		_tmp18_ = _g_object_ref0 (_tmp14_);
#line 621 "../src/math-converter.vala"
		combo = _tmp18_;
#line 622 "../src/math-converter.vala"
		_tmp19_ = combo;
#line 622 "../src/math-converter.vala"
		_tmp20_ = gtk_drop_down_get_selected_item (_tmp19_);
#line 622 "../src/math-converter.vala"
		_tmp21_ = _tmp20_;
#line 622 "../src/math-converter.vala"
		_tmp22_ = unit_get_name (G_TYPE_CHECK_INSTANCE_TYPE (_tmp21_, TYPE_UNIT) ? ((Unit*) _tmp21_) : NULL);
#line 622 "../src/math-converter.vala"
		_tmp23_ = _tmp22_;
#line 622 "../src/math-converter.vala"
		_tmp24_ = _tmp23_;
#line 622 "../src/math-converter.vala"
		number_base = atoi (_tmp24_);
#line 622 "../src/math-converter.vala"
		_g_free0 (_tmp24_);
#line 619 "../src/math-converter.vala"
		_g_object_unref0 (combo);
#line 4848 "math-converter.c"
	}
#line 624 "../src/math-converter.vala"
	_tmp25_ = str;
#line 624 "../src/math-converter.vala"
	if (g_str_has_suffix (_tmp25_, "π")) {
#line 4854 "math-converter.c"
		const gchar* _tmp26_;
		gboolean _tmp28_ = FALSE;
		const gchar* _tmp29_;
		Number* number = NULL;
		const gchar* _tmp35_;
		gint _tmp36_;
		gint _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		Number* _tmp40_;
		Number* _tmp41_;
		Number* _tmp42_;
		Number* _tmp43_;
		Number* _tmp44_;
		Number* _tmp45_;
		Number* _tmp46_;
		Number* _tmp47_;
#line 626 "../src/math-converter.vala"
		_tmp26_ = str;
#line 626 "../src/math-converter.vala"
		if (g_strcmp0 (_tmp26_, "π") == 0) {
#line 4876 "math-converter.c"
			Number* _tmp27_;
#line 627 "../src/math-converter.vala"
			_tmp27_ = number_new_pi ();
#line 627 "../src/math-converter.vala"
			result = _tmp27_;
#line 627 "../src/math-converter.vala"
			_g_free0 (str);
#line 627 "../src/math-converter.vala"
			return result;
#line 4886 "math-converter.c"
		}
#line 628 "../src/math-converter.vala"
		_tmp29_ = str;
#line 628 "../src/math-converter.vala"
		if (g_strcmp0 (_tmp29_, "−π") == 0) {
#line 628 "../src/math-converter.vala"
			_tmp28_ = TRUE;
#line 4894 "math-converter.c"
		} else {
			const gchar* _tmp30_;
#line 628 "../src/math-converter.vala"
			_tmp30_ = str;
#line 628 "../src/math-converter.vala"
			_tmp28_ = g_strcmp0 (_tmp30_, "-π") == 0;
#line 4901 "math-converter.c"
		}
#line 628 "../src/math-converter.vala"
		if (_tmp28_) {
#line 4905 "math-converter.c"
			Number* _tmp31_;
			Number* _tmp32_;
			Number* _tmp33_;
			Number* _tmp34_;
#line 629 "../src/math-converter.vala"
			_tmp31_ = number_new_pi ();
#line 629 "../src/math-converter.vala"
			_tmp32_ = _tmp31_;
#line 629 "../src/math-converter.vala"
			_tmp33_ = number_invert_sign (_tmp32_);
#line 629 "../src/math-converter.vala"
			_tmp34_ = _tmp33_;
#line 629 "../src/math-converter.vala"
			_g_object_unref0 (_tmp32_);
#line 629 "../src/math-converter.vala"
			result = _tmp34_;
#line 629 "../src/math-converter.vala"
			_g_free0 (str);
#line 629 "../src/math-converter.vala"
			return result;
#line 4926 "math-converter.c"
		}
#line 630 "../src/math-converter.vala"
		_tmp35_ = str;
#line 630 "../src/math-converter.vala"
		_tmp36_ = strlen ("π");
#line 630 "../src/math-converter.vala"
		_tmp37_ = _tmp36_;
#line 630 "../src/math-converter.vala"
		_tmp38_ = string_slice (_tmp35_, (glong) 0, (glong) (-_tmp37_));
#line 630 "../src/math-converter.vala"
		_tmp39_ = _tmp38_;
#line 630 "../src/math-converter.vala"
		_tmp40_ = mp_set_from_string (_tmp39_, number_base, TRUE);
#line 630 "../src/math-converter.vala"
		_tmp41_ = _tmp40_;
#line 630 "../src/math-converter.vala"
		_g_free0 (_tmp39_);
#line 630 "../src/math-converter.vala"
		number = _tmp41_;
#line 631 "../src/math-converter.vala"
		_tmp42_ = number;
#line 631 "../src/math-converter.vala"
		if (_tmp42_ == NULL) {
#line 632 "../src/math-converter.vala"
			result = NULL;
#line 632 "../src/math-converter.vala"
			_g_object_unref0 (number);
#line 632 "../src/math-converter.vala"
			_g_free0 (str);
#line 632 "../src/math-converter.vala"
			return result;
#line 4958 "math-converter.c"
		}
#line 633 "../src/math-converter.vala"
		_tmp43_ = number_new_pi ();
#line 633 "../src/math-converter.vala"
		_tmp44_ = _tmp43_;
#line 633 "../src/math-converter.vala"
		_tmp45_ = number;
#line 633 "../src/math-converter.vala"
		_tmp46_ = number_multiply (_tmp44_, _tmp45_);
#line 633 "../src/math-converter.vala"
		_tmp47_ = _tmp46_;
#line 633 "../src/math-converter.vala"
		_g_object_unref0 (_tmp44_);
#line 633 "../src/math-converter.vala"
		result = _tmp47_;
#line 633 "../src/math-converter.vala"
		_g_object_unref0 (number);
#line 633 "../src/math-converter.vala"
		_g_free0 (str);
#line 633 "../src/math-converter.vala"
		return result;
#line 4980 "math-converter.c"
	}
#line 635 "../src/math-converter.vala"
	_tmp48_ = str;
#line 635 "../src/math-converter.vala"
	_tmp49_ = mp_set_from_string (_tmp48_, number_base, TRUE);
#line 635 "../src/math-converter.vala"
	result = _tmp49_;
#line 635 "../src/math-converter.vala"
	_g_free0 (str);
#line 635 "../src/math-converter.vala"
	return result;
#line 4992 "math-converter.c"
}

static void
math_converter_update_entry (MathConverter* self,
                             GtkTextView* entry,
                             Serializer* serializer)
{
	Number* _tmp0_ = NULL;
	GtkTextView* _tmp1_;
	Number* number = NULL;
	Number* _tmp4_;
	GtkDropDown* _tmp5_ = NULL;
	GtkTextView* _tmp6_;
	GtkDropDown* combo = NULL;
	GtkDropDown* _tmp9_;
	GtkDropDown* _tmp10_;
	GObject* _tmp11_;
	GObject* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gboolean _tmp16_;
#line 638 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 638 "../src/math-converter.vala"
	g_return_if_fail (entry != NULL);
#line 638 "../src/math-converter.vala"
	g_return_if_fail (serializer != NULL);
#line 640 "../src/math-converter.vala"
	_tmp1_ = self->priv->from_entry;
#line 640 "../src/math-converter.vala"
	if (entry == _tmp1_) {
#line 5025 "math-converter.c"
		Number* _tmp2_;
#line 640 "../src/math-converter.vala"
		_tmp2_ = self->priv->from_number;
#line 640 "../src/math-converter.vala"
		_tmp0_ = _tmp2_;
#line 5031 "math-converter.c"
	} else {
		Number* _tmp3_;
#line 640 "../src/math-converter.vala"
		_tmp3_ = self->priv->to_number;
#line 640 "../src/math-converter.vala"
		_tmp0_ = _tmp3_;
#line 5038 "math-converter.c"
	}
#line 640 "../src/math-converter.vala"
	_tmp4_ = _g_object_ref0 (_tmp0_);
#line 640 "../src/math-converter.vala"
	number = _tmp4_;
#line 641 "../src/math-converter.vala"
	_tmp6_ = self->priv->from_entry;
#line 641 "../src/math-converter.vala"
	if (entry == _tmp6_) {
#line 5048 "math-converter.c"
		GtkDropDown* _tmp7_;
#line 641 "../src/math-converter.vala"
		_tmp7_ = self->priv->from_combo;
#line 641 "../src/math-converter.vala"
		_tmp5_ = _tmp7_;
#line 5054 "math-converter.c"
	} else {
		GtkDropDown* _tmp8_;
#line 641 "../src/math-converter.vala"
		_tmp8_ = self->priv->to_combo;
#line 641 "../src/math-converter.vala"
		_tmp5_ = _tmp8_;
#line 5061 "math-converter.c"
	}
#line 641 "../src/math-converter.vala"
	_tmp9_ = _g_object_ref0 (_tmp5_);
#line 641 "../src/math-converter.vala"
	combo = _tmp9_;
#line 642 "../src/math-converter.vala"
	_tmp10_ = combo;
#line 642 "../src/math-converter.vala"
	_tmp11_ = gtk_drop_down_get_selected_item (_tmp10_);
#line 642 "../src/math-converter.vala"
	_tmp12_ = _tmp11_;
#line 642 "../src/math-converter.vala"
	_tmp13_ = unit_get_name (G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, TYPE_UNIT) ? ((Unit*) _tmp12_) : NULL);
#line 642 "../src/math-converter.vala"
	_tmp14_ = _tmp13_;
#line 642 "../src/math-converter.vala"
	_tmp15_ = _tmp14_;
#line 642 "../src/math-converter.vala"
	_tmp16_ = g_strcmp0 (_tmp15_, "dms") == 0;
#line 642 "../src/math-converter.vala"
	_g_free0 (_tmp15_);
#line 642 "../src/math-converter.vala"
	if (_tmp16_) {
#line 5085 "math-converter.c"
		gboolean _tmp17_ = FALSE;
		Serializer* _tmp18_;
#line 644 "../src/math-converter.vala"
		_tmp18_ = self->priv->fixed_serializer;
#line 644 "../src/math-converter.vala"
		if (serializer == _tmp18_) {
#line 5092 "math-converter.c"
			Number* _tmp19_;
#line 644 "../src/math-converter.vala"
			_tmp19_ = number;
#line 644 "../src/math-converter.vala"
			_tmp17_ = number_is_zero (_tmp19_);
#line 5098 "math-converter.c"
		} else {
#line 644 "../src/math-converter.vala"
			_tmp17_ = FALSE;
#line 5102 "math-converter.c"
		}
#line 644 "../src/math-converter.vala"
		if (_tmp17_) {
#line 5106 "math-converter.c"
			GtkTextBuffer* _tmp20_;
			GtkTextBuffer* _tmp21_;
			Number* _tmp22_;
			gchar* _tmp23_;
			gchar* _tmp24_;
#line 645 "../src/math-converter.vala"
			_tmp20_ = gtk_text_view_get_buffer (entry);
#line 645 "../src/math-converter.vala"
			_tmp21_ = _tmp20_;
#line 645 "../src/math-converter.vala"
			_tmp22_ = number;
#line 645 "../src/math-converter.vala"
			_tmp23_ = serializer_to_string (serializer, _tmp22_);
#line 645 "../src/math-converter.vala"
			_tmp24_ = _tmp23_;
#line 645 "../src/math-converter.vala"
			g_object_set (_tmp21_, "text", _tmp24_, NULL);
#line 645 "../src/math-converter.vala"
			_g_free0 (_tmp24_);
#line 5126 "math-converter.c"
		} else {
			GtkTextBuffer* _tmp25_;
			GtkTextBuffer* _tmp26_;
			Number* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
#line 647 "../src/math-converter.vala"
			_tmp25_ = gtk_text_view_get_buffer (entry);
#line 647 "../src/math-converter.vala"
			_tmp26_ = _tmp25_;
#line 647 "../src/math-converter.vala"
			_tmp27_ = number;
#line 647 "../src/math-converter.vala"
			_tmp28_ = serializer_to_dms_string (serializer, _tmp27_);
#line 647 "../src/math-converter.vala"
			_tmp29_ = _tmp28_;
#line 647 "../src/math-converter.vala"
			g_object_set (_tmp26_, "text", _tmp29_, NULL);
#line 647 "../src/math-converter.vala"
			_g_free0 (_tmp29_);
#line 5147 "math-converter.c"
		}
	} else {
		const gchar* _tmp30_;
#line 649 "../src/math-converter.vala"
		_tmp30_ = self->priv->category;
#line 649 "../src/math-converter.vala"
		if (g_strcmp0 (_tmp30_, "numberbase") == 0) {
#line 5155 "math-converter.c"
			gint number_base = 0;
			GtkDropDown* _tmp31_;
			GObject* _tmp32_;
			GObject* _tmp33_;
			gchar* _tmp34_;
			gchar* _tmp35_;
			gchar* _tmp36_;
			gint _tmp37_;
			gint original_base = 0;
			guint original_representation_base = 0U;
			gchar* str = NULL;
			Number* _tmp38_;
			gchar* _tmp39_;
			GtkTextBuffer* _tmp40_;
			GtkTextBuffer* _tmp41_;
			const gchar* _tmp42_;
#line 651 "../src/math-converter.vala"
			_tmp31_ = combo;
#line 651 "../src/math-converter.vala"
			_tmp32_ = gtk_drop_down_get_selected_item (_tmp31_);
#line 651 "../src/math-converter.vala"
			_tmp33_ = _tmp32_;
#line 651 "../src/math-converter.vala"
			_tmp34_ = unit_get_name (G_TYPE_CHECK_INSTANCE_TYPE (_tmp33_, TYPE_UNIT) ? ((Unit*) _tmp33_) : NULL);
#line 651 "../src/math-converter.vala"
			_tmp35_ = _tmp34_;
#line 651 "../src/math-converter.vala"
			_tmp36_ = _tmp35_;
#line 651 "../src/math-converter.vala"
			_tmp37_ = atoi (_tmp36_);
#line 651 "../src/math-converter.vala"
			_g_free0 (_tmp36_);
#line 651 "../src/math-converter.vala"
			number_base = _tmp37_;
#line 652 "../src/math-converter.vala"
			original_base = serializer_get_base (serializer);
#line 653 "../src/math-converter.vala"
			original_representation_base = serializer_get_representation_base (serializer);
#line 654 "../src/math-converter.vala"
			serializer_set_base (serializer, number_base);
#line 655 "../src/math-converter.vala"
			serializer_set_representation_base (serializer, (guint) number_base);
#line 656 "../src/math-converter.vala"
			_tmp38_ = number;
#line 656 "../src/math-converter.vala"
			_tmp39_ = serializer_to_string (serializer, _tmp38_);
#line 656 "../src/math-converter.vala"
			str = _tmp39_;
#line 657 "../src/math-converter.vala"
			serializer_set_base (serializer, original_base);
#line 658 "../src/math-converter.vala"
			serializer_set_representation_base (serializer, original_representation_base);
#line 659 "../src/math-converter.vala"
			_tmp40_ = gtk_text_view_get_buffer (entry);
#line 659 "../src/math-converter.vala"
			_tmp41_ = _tmp40_;
#line 659 "../src/math-converter.vala"
			_tmp42_ = str;
#line 659 "../src/math-converter.vala"
			g_object_set (_tmp41_, "text", _tmp42_, NULL);
#line 649 "../src/math-converter.vala"
			_g_free0 (str);
#line 5218 "math-converter.c"
		} else {
			GtkTextBuffer* _tmp43_;
			GtkTextBuffer* _tmp44_;
			Number* _tmp45_;
			gchar* _tmp46_;
			gchar* _tmp47_;
#line 662 "../src/math-converter.vala"
			_tmp43_ = gtk_text_view_get_buffer (entry);
#line 662 "../src/math-converter.vala"
			_tmp44_ = _tmp43_;
#line 662 "../src/math-converter.vala"
			_tmp45_ = number;
#line 662 "../src/math-converter.vala"
			_tmp46_ = serializer_to_string (serializer, _tmp45_);
#line 662 "../src/math-converter.vala"
			_tmp47_ = _tmp46_;
#line 662 "../src/math-converter.vala"
			g_object_set (_tmp44_, "text", _tmp47_, NULL);
#line 662 "../src/math-converter.vala"
			_g_free0 (_tmp47_);
#line 5239 "math-converter.c"
		}
	}
#line 638 "../src/math-converter.vala"
	_g_object_unref0 (combo);
#line 638 "../src/math-converter.vala"
	_g_object_unref0 (number);
#line 5246 "math-converter.c"
}

static gboolean
math_converter_key_press_cb (MathConverter* self,
                             GtkEventControllerKey* controller,
                             guint keyval,
                             guint keycode,
                             GdkModifierType mod_state)
{
	GdkModifierType state = 0U;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	guint new_keyval = 0U;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean result;
#line 666 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 666 "../src/math-converter.vala"
	g_return_val_if_fail (controller != NULL, FALSE);
#line 669 "../src/math-converter.vala"
	state = mod_state & (GDK_CONTROL_MASK | GDK_ALT_MASK);
#line 671 "../src/math-converter.vala"
	if (keyval == GDK_KEY_Escape) {
#line 671 "../src/math-converter.vala"
		_tmp1_ = state == 0;
#line 5276 "math-converter.c"
	} else {
#line 671 "../src/math-converter.vala"
		_tmp1_ = FALSE;
#line 5280 "math-converter.c"
	}
#line 671 "../src/math-converter.vala"
	if (_tmp1_) {
#line 671 "../src/math-converter.vala"
		_tmp0_ = TRUE;
#line 5286 "math-converter.c"
	} else {
		gboolean _tmp2_ = FALSE;
#line 672 "../src/math-converter.vala"
		if (keyval == GDK_KEY_Delete) {
#line 672 "../src/math-converter.vala"
			_tmp2_ = (mod_state & GDK_CONTROL_MASK) == GDK_CONTROL_MASK;
#line 5293 "math-converter.c"
		} else {
#line 672 "../src/math-converter.vala"
			_tmp2_ = FALSE;
#line 5297 "math-converter.c"
		}
#line 672 "../src/math-converter.vala"
		_tmp0_ = _tmp2_;
#line 5301 "math-converter.c"
	}
#line 671 "../src/math-converter.vala"
	if (_tmp0_) {
#line 674 "../src/math-converter.vala"
		math_converter_clear (self);
#line 675 "../src/math-converter.vala"
		result = TRUE;
#line 675 "../src/math-converter.vala"
		return result;
#line 5311 "math-converter.c"
	}
#line 679 "../src/math-converter.vala"
	new_keyval = (guint) 0;
#line 680 "../src/math-converter.vala"
	switch (keyval) {
#line 680 "../src/math-converter.vala"
		case GDK_KEY_KP_Insert:
#line 5319 "math-converter.c"
		{
#line 683 "../src/math-converter.vala"
			new_keyval = GDK_KEY_0;
#line 684 "../src/math-converter.vala"
			break;
#line 5325 "math-converter.c"
		}
#line 680 "../src/math-converter.vala"
		case GDK_KEY_KP_End:
#line 5329 "math-converter.c"
		{
#line 686 "../src/math-converter.vala"
			new_keyval = GDK_KEY_1;
#line 687 "../src/math-converter.vala"
			break;
#line 5335 "math-converter.c"
		}
#line 680 "../src/math-converter.vala"
		case GDK_KEY_KP_Down:
#line 5339 "math-converter.c"
		{
#line 689 "../src/math-converter.vala"
			new_keyval = GDK_KEY_2;
#line 690 "../src/math-converter.vala"
			break;
#line 5345 "math-converter.c"
		}
#line 680 "../src/math-converter.vala"
		case GDK_KEY_KP_Page_Down:
#line 5349 "math-converter.c"
		{
#line 692 "../src/math-converter.vala"
			new_keyval = GDK_KEY_3;
#line 693 "../src/math-converter.vala"
			break;
#line 5355 "math-converter.c"
		}
#line 680 "../src/math-converter.vala"
		case GDK_KEY_KP_Left:
#line 5359 "math-converter.c"
		{
#line 695 "../src/math-converter.vala"
			new_keyval = GDK_KEY_4;
#line 696 "../src/math-converter.vala"
			break;
#line 5365 "math-converter.c"
		}
#line 680 "../src/math-converter.vala"
		case GDK_KEY_KP_Begin:
#line 5369 "math-converter.c"
		{
#line 698 "../src/math-converter.vala"
			new_keyval = GDK_KEY_5;
#line 699 "../src/math-converter.vala"
			break;
#line 5375 "math-converter.c"
		}
#line 680 "../src/math-converter.vala"
		case GDK_KEY_KP_Right:
#line 5379 "math-converter.c"
		{
#line 701 "../src/math-converter.vala"
			new_keyval = GDK_KEY_6;
#line 702 "../src/math-converter.vala"
			break;
#line 5385 "math-converter.c"
		}
#line 680 "../src/math-converter.vala"
		case GDK_KEY_KP_Home:
#line 5389 "math-converter.c"
		{
#line 704 "../src/math-converter.vala"
			new_keyval = GDK_KEY_7;
#line 705 "../src/math-converter.vala"
			break;
#line 5395 "math-converter.c"
		}
#line 680 "../src/math-converter.vala"
		case GDK_KEY_KP_Up:
#line 5399 "math-converter.c"
		{
#line 707 "../src/math-converter.vala"
			new_keyval = GDK_KEY_8;
#line 708 "../src/math-converter.vala"
			break;
#line 5405 "math-converter.c"
		}
#line 680 "../src/math-converter.vala"
		case GDK_KEY_KP_Page_Up:
#line 5409 "math-converter.c"
		{
#line 710 "../src/math-converter.vala"
			new_keyval = GDK_KEY_9;
#line 711 "../src/math-converter.vala"
			break;
#line 5415 "math-converter.c"
		}
#line 680 "../src/math-converter.vala"
		case GDK_KEY_KP_Delete:
#line 5419 "math-converter.c"
		{
#line 713 "../src/math-converter.vala"
			new_keyval = GDK_KEY_period;
#line 714 "../src/math-converter.vala"
			break;
#line 5425 "math-converter.c"
		}
		default:
#line 680 "../src/math-converter.vala"
		break;
#line 5430 "math-converter.c"
	}
#line 717 "../src/math-converter.vala"
	if (new_keyval != ((guint) 0)) {
#line 719 "../src/math-converter.vala"
		g_info ("math-converter.vala:719: forwarding\n");
#line 720 "../src/math-converter.vala"
		result = math_converter_key_press_cb (self, controller, new_keyval, keycode, mod_state);
#line 720 "../src/math-converter.vala"
		return result;
#line 5440 "math-converter.c"
	}
#line 723 "../src/math-converter.vala"
	if (keyval == GDK_KEY_Return) {
#line 723 "../src/math-converter.vala"
		_tmp3_ = TRUE;
#line 5446 "math-converter.c"
	} else {
#line 723 "../src/math-converter.vala"
		_tmp3_ = keyval == GDK_KEY_KP_Enter;
#line 5450 "math-converter.c"
	}
#line 723 "../src/math-converter.vala"
	if (_tmp3_) {
#line 724 "../src/math-converter.vala"
		result = TRUE;
#line 724 "../src/math-converter.vala"
		return result;
#line 5458 "math-converter.c"
	}
#line 727 "../src/math-converter.vala"
	if (keyval == GDK_KEY_KP_Decimal) {
#line 727 "../src/math-converter.vala"
		_tmp7_ = TRUE;
#line 5464 "math-converter.c"
	} else {
#line 728 "../src/math-converter.vala"
		_tmp7_ = keyval == GDK_KEY_KP_Separator;
#line 5468 "math-converter.c"
	}
#line 727 "../src/math-converter.vala"
	if (_tmp7_) {
#line 727 "../src/math-converter.vala"
		_tmp6_ = TRUE;
#line 5474 "math-converter.c"
	} else {
#line 729 "../src/math-converter.vala"
		_tmp6_ = keyval == GDK_KEY_period;
#line 5478 "math-converter.c"
	}
#line 727 "../src/math-converter.vala"
	if (_tmp6_) {
#line 727 "../src/math-converter.vala"
		_tmp5_ = TRUE;
#line 5484 "math-converter.c"
	} else {
#line 730 "../src/math-converter.vala"
		_tmp5_ = keyval == GDK_KEY_decimalpoint;
#line 5488 "math-converter.c"
	}
#line 727 "../src/math-converter.vala"
	if (_tmp5_) {
#line 727 "../src/math-converter.vala"
		_tmp4_ = TRUE;
#line 5494 "math-converter.c"
	} else {
#line 731 "../src/math-converter.vala"
		_tmp4_ = keyval == GDK_KEY_comma;
#line 5498 "math-converter.c"
	}
#line 727 "../src/math-converter.vala"
	if (_tmp4_) {
#line 733 "../src/math-converter.vala"
		math_converter_insert_numeric_point (self);
#line 734 "../src/math-converter.vala"
		result = TRUE;
#line 734 "../src/math-converter.vala"
		return result;
#line 5508 "math-converter.c"
	}
#line 738 "../src/math-converter.vala"
	if (state == 0) {
#line 5512 "math-converter.c"
		guint32 c = 0U;
		gboolean _tmp8_ = FALSE;
		const gchar* _tmp11_;
#line 740 "../src/math-converter.vala"
		c = gdk_keyval_to_unicode (keyval);
#line 741 "../src/math-converter.vala"
		if (c >= ((guint32) '0')) {
#line 741 "../src/math-converter.vala"
			_tmp8_ = c <= ((guint32) '9');
#line 5522 "math-converter.c"
		} else {
#line 741 "../src/math-converter.vala"
			_tmp8_ = FALSE;
#line 5526 "math-converter.c"
		}
#line 741 "../src/math-converter.vala"
		if (_tmp8_) {
#line 5530 "math-converter.c"
			gchar* _tmp9_;
			gchar* _tmp10_;
#line 743 "../src/math-converter.vala"
			_tmp9_ = g_strdup_printf ("%c", c);
#line 743 "../src/math-converter.vala"
			_tmp10_ = _tmp9_;
#line 743 "../src/math-converter.vala"
			math_converter_insert_text (self, _tmp10_, TRUE);
#line 743 "../src/math-converter.vala"
			_g_free0 (_tmp10_);
#line 744 "../src/math-converter.vala"
			result = TRUE;
#line 744 "../src/math-converter.vala"
			return result;
#line 5545 "math-converter.c"
		}
#line 746 "../src/math-converter.vala"
		_tmp11_ = self->priv->category;
#line 746 "../src/math-converter.vala"
		if (g_strcmp0 (_tmp11_, "numberbase") == 0) {
#line 5551 "math-converter.c"
			gboolean _tmp12_ = FALSE;
			gboolean _tmp13_ = FALSE;
#line 748 "../src/math-converter.vala"
			if (c >= ((guint32) 'a')) {
#line 748 "../src/math-converter.vala"
				_tmp12_ = c <= ((guint32) 'f');
#line 5558 "math-converter.c"
			} else {
#line 748 "../src/math-converter.vala"
				_tmp12_ = FALSE;
#line 5562 "math-converter.c"
			}
#line 748 "../src/math-converter.vala"
			if (_tmp12_) {
#line 749 "../src/math-converter.vala"
				c = (c - 'a') + 'A';
#line 5568 "math-converter.c"
			}
#line 750 "../src/math-converter.vala"
			if (c >= ((guint32) 'A')) {
#line 750 "../src/math-converter.vala"
				_tmp13_ = c <= ((guint32) 'F');
#line 5574 "math-converter.c"
			} else {
#line 750 "../src/math-converter.vala"
				_tmp13_ = FALSE;
#line 5578 "math-converter.c"
			}
#line 750 "../src/math-converter.vala"
			if (_tmp13_) {
#line 5582 "math-converter.c"
				gchar* _tmp14_;
				gchar* _tmp15_;
#line 752 "../src/math-converter.vala"
				_tmp14_ = g_strdup_printf ("%c", c);
#line 752 "../src/math-converter.vala"
				_tmp15_ = _tmp14_;
#line 752 "../src/math-converter.vala"
				math_converter_insert_text (self, _tmp15_, TRUE);
#line 752 "../src/math-converter.vala"
				_g_free0 (_tmp15_);
#line 753 "../src/math-converter.vala"
				result = TRUE;
#line 753 "../src/math-converter.vala"
				return result;
#line 5597 "math-converter.c"
			}
		}
#line 756 "../src/math-converter.vala"
		if (c == ((guint32) '-')) {
#line 758 "../src/math-converter.vala"
			math_converter_insert_text (self, "−", TRUE);
#line 759 "../src/math-converter.vala"
			result = TRUE;
#line 759 "../src/math-converter.vala"
			return result;
#line 5608 "math-converter.c"
		}
#line 761 "../src/math-converter.vala"
		if (c == ((guint32) '\'')) {
#line 763 "../src/math-converter.vala"
			math_converter_insert_text (self, "′", TRUE);
#line 764 "../src/math-converter.vala"
			result = TRUE;
#line 764 "../src/math-converter.vala"
			return result;
#line 5618 "math-converter.c"
		}
#line 766 "../src/math-converter.vala"
		if (c == ((guint32) '"')) {
#line 768 "../src/math-converter.vala"
			math_converter_insert_text (self, "″", TRUE);
#line 769 "../src/math-converter.vala"
			result = TRUE;
#line 769 "../src/math-converter.vala"
			return result;
#line 5628 "math-converter.c"
		}
	}
#line 774 "../src/math-converter.vala"
	if (state == GDK_CONTROL_MASK) {
#line 776 "../src/math-converter.vala"
		switch (keyval) {
#line 776 "../src/math-converter.vala"
			case GDK_KEY_p:
#line 5637 "math-converter.c"
			{
#line 779 "../src/math-converter.vala"
				math_converter_insert_text (self, "π", TRUE);
#line 780 "../src/math-converter.vala"
				result = TRUE;
#line 780 "../src/math-converter.vala"
				return result;
#line 5645 "math-converter.c"
			}
#line 776 "../src/math-converter.vala"
			case GDK_KEY_o:
#line 776 "../src/math-converter.vala"
			case GDK_KEY_apostrophe:
#line 5651 "math-converter.c"
			{
#line 783 "../src/math-converter.vala"
				math_converter_insert_text (self, "°", FALSE);
#line 784 "../src/math-converter.vala"
				result = TRUE;
#line 784 "../src/math-converter.vala"
				return result;
#line 5659 "math-converter.c"
			}
			default:
#line 776 "../src/math-converter.vala"
			break;
#line 5664 "math-converter.c"
		}
	}
#line 788 "../src/math-converter.vala"
	result = FALSE;
#line 788 "../src/math-converter.vala"
	return result;
#line 5671 "math-converter.c"
}

static gboolean
_math_converter_key_press_cb_gtk_event_controller_key_key_pressed (GtkEventControllerKey* _sender,
                                                                   guint keyval,
                                                                   guint keycode,
                                                                   GdkModifierType state,
                                                                   gpointer self)
{
	gboolean result;
	result = math_converter_key_press_cb ((MathConverter*) self, _sender, keyval, keycode, state);
#line 19 "../src/math-converter.vala"
	return result;
#line 5685 "math-converter.c"
}

static gpointer
_gdk_event_ref0 (gpointer self)
{
#line 794 "../src/math-converter.vala"
	return self ? gdk_event_ref (self) : NULL;
#line 5693 "math-converter.c"
}

static void
_vala_GdkEventSequence_free (GdkEventSequence* self)
{
#line 794 "../src/math-converter.vala"
	g_boxed_free (gdk_event_sequence_get_type (), self);
#line 5701 "math-converter.c"
}

static void
math_converter_from_entry_click_cb (MathConverter* self,
                                    GtkGestureClick* gesture,
                                    gint n_click,
                                    gdouble x,
                                    gdouble y)
{
	GdkEvent* event = NULL;
	GdkEventSequence* _tmp0_;
	GdkEventSequence* _tmp1_;
	GdkEvent* _tmp2_;
	GdkEvent* _tmp3_;
	GdkEvent* _tmp4_;
	GdkEvent* _tmp5_;
#line 792 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 792 "../src/math-converter.vala"
	g_return_if_fail (gesture != NULL);
#line 794 "../src/math-converter.vala"
	_tmp0_ = gtk_gesture_single_get_current_sequence ((GtkGestureSingle*) gesture);
#line 794 "../src/math-converter.vala"
	_tmp1_ = _tmp0_;
#line 794 "../src/math-converter.vala"
	_tmp2_ = gtk_gesture_get_last_event ((GtkGesture*) gesture, _tmp1_);
#line 794 "../src/math-converter.vala"
	_tmp3_ = _gdk_event_ref0 (_tmp2_);
#line 794 "../src/math-converter.vala"
	_tmp4_ = _tmp3_;
#line 794 "../src/math-converter.vala"
	__vala_GdkEventSequence_free0 (_tmp1_);
#line 794 "../src/math-converter.vala"
	event = _tmp4_;
#line 795 "../src/math-converter.vala"
	_tmp5_ = event;
#line 795 "../src/math-converter.vala"
	if (gdk_event_triggers_context_menu (_tmp5_)) {
#line 5740 "math-converter.c"
		GtkTextView* _tmp6_;
#line 797 "../src/math-converter.vala"
		_tmp6_ = self->priv->from_entry;
#line 797 "../src/math-converter.vala"
		math_converter_show_context_menu (self, _tmp6_, x, y);
#line 798 "../src/math-converter.vala"
		gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 5748 "math-converter.c"
	}
#line 792 "../src/math-converter.vala"
	_gdk_event_unref0 (event);
#line 5752 "math-converter.c"
}

static void
_math_converter_from_entry_click_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                               gint n_press,
                                                               gdouble x,
                                                               gdouble y,
                                                               gpointer self)
{
#line 19 "../src/math-converter.vala"
	math_converter_from_entry_click_cb ((MathConverter*) self, _sender, n_press, x, y);
#line 5764 "math-converter.c"
}

static void
math_converter_to_entry_click_cb (MathConverter* self,
                                  GtkGestureClick* gesture,
                                  gint n_click,
                                  gdouble x,
                                  gdouble y)
{
	GdkEvent* event = NULL;
	GdkEventSequence* _tmp0_;
	GdkEventSequence* _tmp1_;
	GdkEvent* _tmp2_;
	GdkEvent* _tmp3_;
	GdkEvent* _tmp4_;
	GdkEvent* _tmp5_;
#line 803 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 803 "../src/math-converter.vala"
	g_return_if_fail (gesture != NULL);
#line 805 "../src/math-converter.vala"
	_tmp0_ = gtk_gesture_single_get_current_sequence ((GtkGestureSingle*) gesture);
#line 805 "../src/math-converter.vala"
	_tmp1_ = _tmp0_;
#line 805 "../src/math-converter.vala"
	_tmp2_ = gtk_gesture_get_last_event ((GtkGesture*) gesture, _tmp1_);
#line 805 "../src/math-converter.vala"
	_tmp3_ = _gdk_event_ref0 (_tmp2_);
#line 805 "../src/math-converter.vala"
	_tmp4_ = _tmp3_;
#line 805 "../src/math-converter.vala"
	__vala_GdkEventSequence_free0 (_tmp1_);
#line 805 "../src/math-converter.vala"
	event = _tmp4_;
#line 806 "../src/math-converter.vala"
	_tmp5_ = event;
#line 806 "../src/math-converter.vala"
	if (gdk_event_triggers_context_menu (_tmp5_)) {
#line 5803 "math-converter.c"
		GtkTextView* _tmp6_;
#line 808 "../src/math-converter.vala"
		_tmp6_ = self->priv->to_entry;
#line 808 "../src/math-converter.vala"
		math_converter_show_context_menu (self, _tmp6_, x, y);
#line 809 "../src/math-converter.vala"
		gtk_gesture_set_state ((GtkGesture*) gesture, GTK_EVENT_SEQUENCE_CLAIMED);
#line 5811 "math-converter.c"
	}
#line 803 "../src/math-converter.vala"
	_gdk_event_unref0 (event);
#line 5815 "math-converter.c"
}

static void
_math_converter_to_entry_click_cb_gtk_gesture_click_pressed (GtkGestureClick* _sender,
                                                             gint n_press,
                                                             gdouble x,
                                                             gdouble y,
                                                             gpointer self)
{
#line 19 "../src/math-converter.vala"
	math_converter_to_entry_click_cb ((MathConverter*) self, _sender, n_press, x, y);
#line 5827 "math-converter.c"
}

static void
math_converter_show_context_menu (MathConverter* self,
                                  GtkTextView* entry,
                                  gdouble x,
                                  gdouble y)
{
	GdkClipboard* clipboard = NULL;
	GdkDisplay* _tmp0_;
	GdkClipboard* _tmp1_;
	GdkClipboard* _tmp2_;
	gboolean can_paste = FALSE;
	GdkClipboard* _tmp3_;
	GdkContentFormats* _tmp4_;
	GtkRoot* _tmp5_;
	GtkTextIter start = {0};
	GtkTextIter end = {0};
	GtkTextBuffer* _tmp6_;
	GtkTextBuffer* _tmp7_;
	GtkTextIter _tmp8_ = {0};
	GtkTextIter _tmp9_ = {0};
	GtkTextBuffer* _tmp10_;
	GtkTextBuffer* _tmp11_;
	GtkTextIter _tmp12_;
	GtkTextIter _tmp13_;
	GtkPopoverMenu* _tmp14_ = NULL;
	GtkTextView* _tmp15_;
	GtkPopoverMenu* context_menu = NULL;
	GtkPopoverMenu* _tmp18_;
	gboolean _tmp19_ = FALSE;
	GtkPopoverMenu* _tmp23_;
#line 813 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 813 "../src/math-converter.vala"
	g_return_if_fail (entry != NULL);
#line 815 "../src/math-converter.vala"
	_tmp0_ = gdk_display_get_default ();
#line 815 "../src/math-converter.vala"
	_tmp1_ = gdk_display_get_clipboard (_tmp0_);
#line 815 "../src/math-converter.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 815 "../src/math-converter.vala"
	clipboard = _tmp2_;
#line 816 "../src/math-converter.vala"
	_tmp3_ = clipboard;
#line 816 "../src/math-converter.vala"
	_tmp4_ = gdk_clipboard_get_formats (_tmp3_);
#line 816 "../src/math-converter.vala"
	can_paste = gdk_content_formats_contain_gtype (_tmp4_, G_TYPE_STRING);
#line 817 "../src/math-converter.vala"
	gtk_widget_action_set_enabled ((GtkWidget*) self, "context-menu.paste", can_paste);
#line 818 "../src/math-converter.vala"
	_tmp5_ = gtk_widget_get_root ((GtkWidget*) self);
#line 818 "../src/math-converter.vala"
	gtk_root_set_focus (_tmp5_, NULL);
#line 820 "../src/math-converter.vala"
	_tmp6_ = gtk_text_view_get_buffer (entry);
#line 820 "../src/math-converter.vala"
	_tmp7_ = _tmp6_;
#line 820 "../src/math-converter.vala"
	gtk_text_buffer_get_bounds (_tmp7_, &_tmp8_, &_tmp9_);
#line 820 "../src/math-converter.vala"
	start = _tmp8_;
#line 820 "../src/math-converter.vala"
	end = _tmp9_;
#line 821 "../src/math-converter.vala"
	_tmp10_ = gtk_text_view_get_buffer (entry);
#line 821 "../src/math-converter.vala"
	_tmp11_ = _tmp10_;
#line 821 "../src/math-converter.vala"
	_tmp12_ = start;
#line 821 "../src/math-converter.vala"
	_tmp13_ = end;
#line 821 "../src/math-converter.vala"
	gtk_text_buffer_select_range (_tmp11_, &_tmp12_, &_tmp13_);
#line 822 "../src/math-converter.vala"
	_tmp15_ = self->priv->from_entry;
#line 822 "../src/math-converter.vala"
	if (entry == _tmp15_) {
#line 5908 "math-converter.c"
		GtkPopoverMenu* _tmp16_;
#line 822 "../src/math-converter.vala"
		_tmp16_ = self->priv->from_context_menu;
#line 822 "../src/math-converter.vala"
		_tmp14_ = _tmp16_;
#line 5914 "math-converter.c"
	} else {
		GtkPopoverMenu* _tmp17_;
#line 822 "../src/math-converter.vala"
		_tmp17_ = self->priv->to_context_menu;
#line 822 "../src/math-converter.vala"
		_tmp14_ = _tmp17_;
#line 5921 "math-converter.c"
	}
#line 822 "../src/math-converter.vala"
	_tmp18_ = _g_object_ref0 (_tmp14_);
#line 822 "../src/math-converter.vala"
	context_menu = _tmp18_;
#line 823 "../src/math-converter.vala"
	if (x != ((gdouble) -1)) {
#line 823 "../src/math-converter.vala"
		_tmp19_ = y != ((gdouble) -1);
#line 5931 "math-converter.c"
	} else {
#line 823 "../src/math-converter.vala"
		_tmp19_ = FALSE;
#line 5935 "math-converter.c"
	}
#line 823 "../src/math-converter.vala"
	if (_tmp19_) {
#line 5939 "math-converter.c"
		GtkPopoverMenu* _tmp20_;
		GdkRectangle _tmp21_ = {0};
#line 824 "../src/math-converter.vala"
		_tmp20_ = context_menu;
#line 824 "../src/math-converter.vala"
		_tmp21_.x = (gint) x;
#line 824 "../src/math-converter.vala"
		_tmp21_.y = (gint) y;
#line 824 "../src/math-converter.vala"
		_tmp21_.width = 1;
#line 824 "../src/math-converter.vala"
		_tmp21_.height = 1;
#line 824 "../src/math-converter.vala"
		gtk_popover_set_pointing_to ((GtkPopover*) _tmp20_, &_tmp21_);
#line 5954 "math-converter.c"
	} else {
		GtkPopoverMenu* _tmp22_;
#line 826 "../src/math-converter.vala"
		_tmp22_ = context_menu;
#line 826 "../src/math-converter.vala"
		gtk_popover_set_pointing_to ((GtkPopover*) _tmp22_, NULL);
#line 5961 "math-converter.c"
	}
#line 827 "../src/math-converter.vala"
	_tmp23_ = context_menu;
#line 827 "../src/math-converter.vala"
	gtk_popover_popup ((GtkPopover*) _tmp23_);
#line 813 "../src/math-converter.vala"
	_g_object_unref0 (context_menu);
#line 813 "../src/math-converter.vala"
	_g_object_unref0 (clipboard);
#line 5971 "math-converter.c"
}

static void
math_converter_popup_cb (MathConverter* self,
                         GSimpleAction* action,
                         GVariant* param)
{
	GtkTextView* _tmp0_ = NULL;
	GtkTextView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkTextView* entry = NULL;
	GtkTextView* _tmp6_;
#line 830 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 830 "../src/math-converter.vala"
	g_return_if_fail (action != NULL);
#line 832 "../src/math-converter.vala"
	_tmp1_ = self->priv->from_entry;
#line 832 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
#line 832 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 832 "../src/math-converter.vala"
	if (_tmp3_) {
#line 5997 "math-converter.c"
		GtkTextView* _tmp4_;
#line 832 "../src/math-converter.vala"
		_tmp4_ = self->priv->from_entry;
#line 832 "../src/math-converter.vala"
		_tmp0_ = _tmp4_;
#line 6003 "math-converter.c"
	} else {
		GtkTextView* _tmp5_;
#line 832 "../src/math-converter.vala"
		_tmp5_ = self->priv->to_entry;
#line 832 "../src/math-converter.vala"
		_tmp0_ = _tmp5_;
#line 6010 "math-converter.c"
	}
#line 832 "../src/math-converter.vala"
	_tmp6_ = _g_object_ref0 (_tmp0_);
#line 832 "../src/math-converter.vala"
	entry = _tmp6_;
#line 833 "../src/math-converter.vala"
	math_converter_show_context_menu (self, entry, (gdouble) -1, (gdouble) -1);
#line 830 "../src/math-converter.vala"
	_g_object_unref0 (entry);
#line 6020 "math-converter.c"
}

static void
math_converter_copy_cb (MathConverter* self,
                        GSimpleAction* action,
                        GVariant* param)
{
	GtkTextView* _tmp0_ = NULL;
	GtkTextView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkTextView* entry = NULL;
	GtkTextView* _tmp6_;
	gchar* tsep_string = NULL;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gboolean _tmp9_ = FALSE;
	const gchar* _tmp10_;
	GtkRoot* _tmp13_;
	GtkRoot* _tmp14_;
	gchar* text = NULL;
	GtkTextView* _tmp15_;
	GtkTextBuffer* _tmp16_;
	GtkTextBuffer* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	GdkClipboard* clipboard = NULL;
	GdkDisplay* _tmp24_;
	GdkClipboard* _tmp25_;
	GdkClipboard* _tmp26_;
#line 836 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 836 "../src/math-converter.vala"
	g_return_if_fail (action != NULL);
#line 838 "../src/math-converter.vala"
	_tmp1_ = self->priv->from_entry;
#line 838 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
#line 838 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 838 "../src/math-converter.vala"
	if (_tmp3_) {
#line 6067 "math-converter.c"
		GtkTextView* _tmp4_;
#line 838 "../src/math-converter.vala"
		_tmp4_ = self->priv->from_entry;
#line 838 "../src/math-converter.vala"
		_tmp0_ = _tmp4_;
#line 6073 "math-converter.c"
	} else {
		GtkTextView* _tmp5_;
#line 838 "../src/math-converter.vala"
		_tmp5_ = self->priv->to_entry;
#line 838 "../src/math-converter.vala"
		_tmp0_ = _tmp5_;
#line 6080 "math-converter.c"
	}
#line 838 "../src/math-converter.vala"
	_tmp6_ = _g_object_ref0 (_tmp0_);
#line 838 "../src/math-converter.vala"
	entry = _tmp6_;
#line 839 "../src/math-converter.vala"
	_tmp7_ = nl_langinfo (THOUSEP);
#line 839 "../src/math-converter.vala"
	_tmp8_ = g_strdup (_tmp7_);
#line 839 "../src/math-converter.vala"
	tsep_string = _tmp8_;
#line 840 "../src/math-converter.vala"
	_tmp10_ = tsep_string;
#line 840 "../src/math-converter.vala"
	if (_tmp10_ == NULL) {
#line 840 "../src/math-converter.vala"
		_tmp9_ = TRUE;
#line 6098 "math-converter.c"
	} else {
		const gchar* _tmp11_;
#line 840 "../src/math-converter.vala"
		_tmp11_ = tsep_string;
#line 840 "../src/math-converter.vala"
		_tmp9_ = g_strcmp0 (_tmp11_, "") == 0;
#line 6105 "math-converter.c"
	}
#line 840 "../src/math-converter.vala"
	if (_tmp9_) {
#line 6109 "math-converter.c"
		gchar* _tmp12_;
#line 841 "../src/math-converter.vala"
		_tmp12_ = g_strdup (" ");
#line 841 "../src/math-converter.vala"
		_g_free0 (tsep_string);
#line 841 "../src/math-converter.vala"
		tsep_string = _tmp12_;
#line 6117 "math-converter.c"
	}
#line 842 "../src/math-converter.vala"
	_tmp13_ = gtk_widget_get_root ((GtkWidget*) self);
#line 842 "../src/math-converter.vala"
	_tmp14_ = _tmp13_;
#line 842 "../src/math-converter.vala"
	gtk_root_set_focus (_tmp14_, NULL);
#line 843 "../src/math-converter.vala"
	_tmp15_ = entry;
#line 843 "../src/math-converter.vala"
	_tmp16_ = gtk_text_view_get_buffer (_tmp15_);
#line 843 "../src/math-converter.vala"
	_tmp17_ = _tmp16_;
#line 843 "../src/math-converter.vala"
	g_object_get (_tmp17_, "text", &_tmp18_, NULL);
#line 843 "../src/math-converter.vala"
	_tmp19_ = _tmp18_;
#line 843 "../src/math-converter.vala"
	_tmp20_ = _tmp19_;
#line 843 "../src/math-converter.vala"
	_tmp21_ = tsep_string;
#line 843 "../src/math-converter.vala"
	_tmp22_ = string_replace (_tmp20_, _tmp21_, "");
#line 843 "../src/math-converter.vala"
	_tmp23_ = _tmp22_;
#line 843 "../src/math-converter.vala"
	_g_free0 (_tmp20_);
#line 843 "../src/math-converter.vala"
	text = _tmp23_;
#line 844 "../src/math-converter.vala"
	_tmp24_ = gdk_display_get_default ();
#line 844 "../src/math-converter.vala"
	_tmp25_ = gdk_display_get_clipboard (_tmp24_);
#line 844 "../src/math-converter.vala"
	_tmp26_ = _g_object_ref0 (_tmp25_);
#line 844 "../src/math-converter.vala"
	clipboard = _tmp26_;
#line 845 "../src/math-converter.vala"
	gdk_clipboard_set_text (clipboard, text);
#line 836 "../src/math-converter.vala"
	_g_object_unref0 (clipboard);
#line 836 "../src/math-converter.vala"
	_g_free0 (text);
#line 836 "../src/math-converter.vala"
	_g_free0 (tsep_string);
#line 836 "../src/math-converter.vala"
	_g_object_unref0 (entry);
#line 6165 "math-converter.c"
}

static void
math_converter_paste_cb (MathConverter* self,
                         GSimpleAction* action,
                         GVariant* param)
{
	GtkTextView* _tmp0_ = NULL;
	GtkTextView* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GtkTextView* entry = NULL;
	GtkTextView* _tmp6_;
	GtkTextBuffer* _tmp7_;
	GtkTextBuffer* _tmp8_;
#line 848 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 848 "../src/math-converter.vala"
	g_return_if_fail (action != NULL);
#line 850 "../src/math-converter.vala"
	_tmp1_ = self->priv->from_entry;
#line 850 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp1_, "has-focus", &_tmp2_, NULL);
#line 850 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 850 "../src/math-converter.vala"
	if (_tmp3_) {
#line 6193 "math-converter.c"
		GtkTextView* _tmp4_;
#line 850 "../src/math-converter.vala"
		_tmp4_ = self->priv->from_entry;
#line 850 "../src/math-converter.vala"
		_tmp0_ = _tmp4_;
#line 6199 "math-converter.c"
	} else {
		GtkTextView* _tmp5_;
#line 850 "../src/math-converter.vala"
		_tmp5_ = self->priv->to_entry;
#line 850 "../src/math-converter.vala"
		_tmp0_ = _tmp5_;
#line 6206 "math-converter.c"
	}
#line 850 "../src/math-converter.vala"
	_tmp6_ = _g_object_ref0 (_tmp0_);
#line 850 "../src/math-converter.vala"
	entry = _tmp6_;
#line 851 "../src/math-converter.vala"
	_tmp7_ = gtk_text_view_get_buffer (entry);
#line 851 "../src/math-converter.vala"
	_tmp8_ = _tmp7_;
#line 851 "../src/math-converter.vala"
	g_object_set (_tmp8_, "text", "", NULL);
#line 852 "../src/math-converter.vala"
	math_converter_paste (self);
#line 848 "../src/math-converter.vala"
	_g_object_unref0 (entry);
#line 6222 "math-converter.c"
}

static void
math_converter_reformat_display (MathConverter* self)
{
	Serializer* _tmp0_;
	MathEquation* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GtkTextView* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	GtkTextView* _tmp21_;
	gboolean _tmp22_;
	gboolean _tmp23_;
#line 855 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 857 "../src/math-converter.vala"
	_tmp0_ = self->priv->fixed_serializer;
#line 857 "../src/math-converter.vala"
	_tmp1_ = self->priv->_equation;
#line 857 "../src/math-converter.vala"
	_tmp2_ = math_equation_get_accuracy (_tmp1_);
#line 857 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 857 "../src/math-converter.vala"
	if (serializer_get_trailing_digits (_tmp0_) != _tmp3_) {
#line 6250 "math-converter.c"
		Serializer* _tmp4_;
		MathEquation* _tmp5_;
		gint _tmp6_;
		gint _tmp7_;
#line 858 "../src/math-converter.vala"
		_tmp4_ = self->priv->fixed_serializer;
#line 858 "../src/math-converter.vala"
		_tmp5_ = self->priv->_equation;
#line 858 "../src/math-converter.vala"
		_tmp6_ = math_equation_get_accuracy (_tmp5_);
#line 858 "../src/math-converter.vala"
		_tmp7_ = _tmp6_;
#line 858 "../src/math-converter.vala"
		serializer_set_trailing_digits (_tmp4_, _tmp7_);
#line 6265 "math-converter.c"
	}
#line 859 "../src/math-converter.vala"
	_tmp8_ = self->priv->from_entry;
#line 859 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp8_, "has-focus", &_tmp9_, NULL);
#line 859 "../src/math-converter.vala"
	_tmp10_ = _tmp9_;
#line 859 "../src/math-converter.vala"
	if (!_tmp10_) {
#line 6275 "math-converter.c"
		GtkTextView* _tmp11_;
		GtkTextBuffer* _tmp12_;
		GtkTextBuffer* _tmp13_;
		GtkTextView* _tmp14_;
		MathEquation* _tmp15_;
		Serializer* _tmp16_;
		Serializer* _tmp17_;
		GtkTextView* _tmp18_;
		GtkTextBuffer* _tmp19_;
		GtkTextBuffer* _tmp20_;
#line 861 "../src/math-converter.vala"
		_tmp11_ = self->priv->from_entry;
#line 861 "../src/math-converter.vala"
		_tmp12_ = gtk_text_view_get_buffer (_tmp11_);
#line 861 "../src/math-converter.vala"
		_tmp13_ = _tmp12_;
#line 861 "../src/math-converter.vala"
		g_signal_handler_block (_tmp13_, self->priv->from_entry_changed);
#line 862 "../src/math-converter.vala"
		_tmp14_ = self->priv->from_entry;
#line 862 "../src/math-converter.vala"
		_tmp15_ = self->priv->_equation;
#line 862 "../src/math-converter.vala"
		_tmp16_ = math_equation_get_serializer (_tmp15_);
#line 862 "../src/math-converter.vala"
		_tmp17_ = _tmp16_;
#line 862 "../src/math-converter.vala"
		math_converter_update_entry (self, _tmp14_, _tmp17_);
#line 863 "../src/math-converter.vala"
		_tmp18_ = self->priv->from_entry;
#line 863 "../src/math-converter.vala"
		_tmp19_ = gtk_text_view_get_buffer (_tmp18_);
#line 863 "../src/math-converter.vala"
		_tmp20_ = _tmp19_;
#line 863 "../src/math-converter.vala"
		g_signal_handler_unblock (_tmp20_, self->priv->from_entry_changed);
#line 6312 "math-converter.c"
	}
#line 865 "../src/math-converter.vala"
	_tmp21_ = self->priv->to_entry;
#line 865 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp21_, "has-focus", &_tmp22_, NULL);
#line 865 "../src/math-converter.vala"
	_tmp23_ = _tmp22_;
#line 865 "../src/math-converter.vala"
	if (!_tmp23_) {
#line 6322 "math-converter.c"
		GtkTextView* _tmp24_;
		GtkTextBuffer* _tmp25_;
		GtkTextBuffer* _tmp26_;
		GtkTextView* _tmp27_;
		MathEquation* _tmp28_;
		Serializer* _tmp29_;
		Serializer* _tmp30_;
		GtkTextView* _tmp31_;
		GtkTextBuffer* _tmp32_;
		GtkTextBuffer* _tmp33_;
#line 867 "../src/math-converter.vala"
		_tmp24_ = self->priv->to_entry;
#line 867 "../src/math-converter.vala"
		_tmp25_ = gtk_text_view_get_buffer (_tmp24_);
#line 867 "../src/math-converter.vala"
		_tmp26_ = _tmp25_;
#line 867 "../src/math-converter.vala"
		g_signal_handler_block (_tmp26_, self->priv->to_entry_changed);
#line 868 "../src/math-converter.vala"
		_tmp27_ = self->priv->to_entry;
#line 868 "../src/math-converter.vala"
		_tmp28_ = self->priv->_equation;
#line 868 "../src/math-converter.vala"
		_tmp29_ = math_equation_get_serializer (_tmp28_);
#line 868 "../src/math-converter.vala"
		_tmp30_ = _tmp29_;
#line 868 "../src/math-converter.vala"
		math_converter_update_entry (self, _tmp27_, _tmp30_);
#line 869 "../src/math-converter.vala"
		_tmp31_ = self->priv->to_entry;
#line 869 "../src/math-converter.vala"
		_tmp32_ = gtk_text_view_get_buffer (_tmp31_);
#line 869 "../src/math-converter.vala"
		_tmp33_ = _tmp32_;
#line 869 "../src/math-converter.vala"
		g_signal_handler_unblock (_tmp33_, self->priv->to_entry_changed);
#line 6359 "math-converter.c"
	}
}

static void
math_converter_reformat_from_entry (MathConverter* self)
{
	Number* _tmp0_;
	GtkTextView* _tmp1_;
	GtkTextBuffer* _tmp2_;
	GtkTextBuffer* _tmp3_;
	GtkTextView* _tmp4_;
	gboolean _tmp5_;
	gboolean _tmp6_;
	GtkTextView* _tmp13_;
	GtkTextBuffer* _tmp14_;
	GtkTextBuffer* _tmp15_;
#line 873 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 875 "../src/math-converter.vala"
	_tmp0_ = self->priv->from_number;
#line 875 "../src/math-converter.vala"
	if (_tmp0_ == NULL) {
#line 876 "../src/math-converter.vala"
		return;
#line 6384 "math-converter.c"
	}
#line 877 "../src/math-converter.vala"
	_tmp1_ = self->priv->from_entry;
#line 877 "../src/math-converter.vala"
	_tmp2_ = gtk_text_view_get_buffer (_tmp1_);
#line 877 "../src/math-converter.vala"
	_tmp3_ = _tmp2_;
#line 877 "../src/math-converter.vala"
	g_signal_handler_block (_tmp3_, self->priv->from_entry_changed);
#line 878 "../src/math-converter.vala"
	_tmp4_ = self->priv->from_entry;
#line 878 "../src/math-converter.vala"
	g_object_get ((GtkWidget*) _tmp4_, "has-focus", &_tmp5_, NULL);
#line 878 "../src/math-converter.vala"
	_tmp6_ = _tmp5_;
#line 878 "../src/math-converter.vala"
	if (_tmp6_) {
#line 6402 "math-converter.c"
		GtkTextView* _tmp7_;
		Serializer* _tmp8_;
#line 879 "../src/math-converter.vala"
		_tmp7_ = self->priv->from_entry;
#line 879 "../src/math-converter.vala"
		_tmp8_ = self->priv->fixed_serializer;
#line 879 "../src/math-converter.vala"
		math_converter_update_entry (self, _tmp7_, _tmp8_);
#line 6411 "math-converter.c"
	} else {
		GtkTextView* _tmp9_;
		MathEquation* _tmp10_;
		Serializer* _tmp11_;
		Serializer* _tmp12_;
#line 881 "../src/math-converter.vala"
		_tmp9_ = self->priv->from_entry;
#line 881 "../src/math-converter.vala"
		_tmp10_ = self->priv->_equation;
#line 881 "../src/math-converter.vala"
		_tmp11_ = math_equation_get_serializer (_tmp10_);
#line 881 "../src/math-converter.vala"
		_tmp12_ = _tmp11_;
#line 881 "../src/math-converter.vala"
		math_converter_update_entry (self, _tmp9_, _tmp12_);
#line 6427 "math-converter.c"
	}
#line 882 "../src/math-converter.vala"
	_tmp13_ = self->priv->from_entry;
#line 882 "../src/math-converter.vala"
	_tmp14_ = gtk_text_view_get_buffer (_tmp13_);
#line 882 "../src/math-converter.vala"
	_tmp15_ = _tmp14_;
#line 882 "../src/math-converter.vala"
	g_signal_handler_unblock (_tmp15_, self->priv->from_entry_changed);
#line 6437 "math-converter.c"
}

static Number*
math_converter_convert_equation (MathConverter* self,
                                 Number* x,
                                 Unit** source_unit,
                                 Unit** target_unit)
{
	Unit* _vala_source_unit = NULL;
	Unit* _vala_target_unit = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GtkDropDown* _tmp2_;
	UnitCategory* category = NULL;
	GtkDropDown* _tmp5_;
	GObject* _tmp6_;
	GObject* _tmp7_;
	UnitCategory* _tmp8_;
	GtkDropDown* _tmp9_;
	GObject* _tmp10_;
	GObject* _tmp11_;
	Unit* _tmp12_;
	GtkDropDown* _tmp13_;
	GObject* _tmp14_;
	GObject* _tmp15_;
	Unit* _tmp16_;
	gboolean _tmp17_ = FALSE;
	gboolean _tmp18_ = FALSE;
	UnitCategory* _tmp19_;
	Number* _tmp22_;
	Number* result;
#line 885 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 885 "../src/math-converter.vala"
	g_return_val_if_fail (x != NULL, NULL);
#line 889 "../src/math-converter.vala"
	_tmp2_ = self->priv->category_combo;
#line 889 "../src/math-converter.vala"
	if (_tmp2_ == NULL) {
#line 889 "../src/math-converter.vala"
		_tmp1_ = TRUE;
#line 6479 "math-converter.c"
	} else {
		GtkDropDown* _tmp3_;
#line 889 "../src/math-converter.vala"
		_tmp3_ = self->priv->from_combo;
#line 889 "../src/math-converter.vala"
		_tmp1_ = _tmp3_ == NULL;
#line 6486 "math-converter.c"
	}
#line 889 "../src/math-converter.vala"
	if (_tmp1_) {
#line 889 "../src/math-converter.vala"
		_tmp0_ = TRUE;
#line 6492 "math-converter.c"
	} else {
		GtkDropDown* _tmp4_;
#line 889 "../src/math-converter.vala"
		_tmp4_ = self->priv->to_combo;
#line 889 "../src/math-converter.vala"
		_tmp0_ = _tmp4_ == NULL;
#line 6499 "math-converter.c"
	}
#line 889 "../src/math-converter.vala"
	if (_tmp0_) {
#line 890 "../src/math-converter.vala"
		result = NULL;
#line 890 "../src/math-converter.vala"
		if (source_unit) {
#line 890 "../src/math-converter.vala"
			*source_unit = _vala_source_unit;
#line 6509 "math-converter.c"
		} else {
#line 890 "../src/math-converter.vala"
			_g_object_unref0 (_vala_source_unit);
#line 6513 "math-converter.c"
		}
#line 890 "../src/math-converter.vala"
		if (target_unit) {
#line 890 "../src/math-converter.vala"
			*target_unit = _vala_target_unit;
#line 6519 "math-converter.c"
		} else {
#line 890 "../src/math-converter.vala"
			_g_object_unref0 (_vala_target_unit);
#line 6523 "math-converter.c"
		}
#line 890 "../src/math-converter.vala"
		return result;
#line 6527 "math-converter.c"
	}
#line 891 "../src/math-converter.vala"
	_tmp5_ = self->priv->category_combo;
#line 891 "../src/math-converter.vala"
	_tmp6_ = gtk_drop_down_get_selected_item (_tmp5_);
#line 891 "../src/math-converter.vala"
	_tmp7_ = _tmp6_;
#line 891 "../src/math-converter.vala"
	_tmp8_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, TYPE_UNIT_CATEGORY) ? ((UnitCategory*) _tmp7_) : NULL);
#line 891 "../src/math-converter.vala"
	category = _tmp8_;
#line 892 "../src/math-converter.vala"
	_tmp9_ = self->priv->from_combo;
#line 892 "../src/math-converter.vala"
	_tmp10_ = gtk_drop_down_get_selected_item (_tmp9_);
#line 892 "../src/math-converter.vala"
	_tmp11_ = _tmp10_;
#line 892 "../src/math-converter.vala"
	_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp11_, TYPE_UNIT) ? ((Unit*) _tmp11_) : NULL);
#line 892 "../src/math-converter.vala"
	_g_object_unref0 (_vala_source_unit);
#line 892 "../src/math-converter.vala"
	_vala_source_unit = _tmp12_;
#line 893 "../src/math-converter.vala"
	_tmp13_ = self->priv->to_combo;
#line 893 "../src/math-converter.vala"
	_tmp14_ = gtk_drop_down_get_selected_item (_tmp13_);
#line 893 "../src/math-converter.vala"
	_tmp15_ = _tmp14_;
#line 893 "../src/math-converter.vala"
	_tmp16_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp15_, TYPE_UNIT) ? ((Unit*) _tmp15_) : NULL);
#line 893 "../src/math-converter.vala"
	_g_object_unref0 (_vala_target_unit);
#line 893 "../src/math-converter.vala"
	_vala_target_unit = _tmp16_;
#line 895 "../src/math-converter.vala"
	_tmp19_ = category;
#line 895 "../src/math-converter.vala"
	if (_tmp19_ == NULL) {
#line 895 "../src/math-converter.vala"
		_tmp18_ = TRUE;
#line 6569 "math-converter.c"
	} else {
		Unit* _tmp20_;
#line 895 "../src/math-converter.vala"
		_tmp20_ = _vala_source_unit;
#line 895 "../src/math-converter.vala"
		_tmp18_ = _tmp20_ == NULL;
#line 6576 "math-converter.c"
	}
#line 895 "../src/math-converter.vala"
	if (_tmp18_) {
#line 895 "../src/math-converter.vala"
		_tmp17_ = TRUE;
#line 6582 "math-converter.c"
	} else {
		Unit* _tmp21_;
#line 895 "../src/math-converter.vala"
		_tmp21_ = _vala_target_unit;
#line 895 "../src/math-converter.vala"
		_tmp17_ = _tmp21_ == NULL;
#line 6589 "math-converter.c"
	}
#line 895 "../src/math-converter.vala"
	if (_tmp17_) {
#line 896 "../src/math-converter.vala"
		result = NULL;
#line 896 "../src/math-converter.vala"
		_g_object_unref0 (category);
#line 896 "../src/math-converter.vala"
		if (source_unit) {
#line 896 "../src/math-converter.vala"
			*source_unit = _vala_source_unit;
#line 6601 "math-converter.c"
		} else {
#line 896 "../src/math-converter.vala"
			_g_object_unref0 (_vala_source_unit);
#line 6605 "math-converter.c"
		}
#line 896 "../src/math-converter.vala"
		if (target_unit) {
#line 896 "../src/math-converter.vala"
			*target_unit = _vala_target_unit;
#line 6611 "math-converter.c"
		} else {
#line 896 "../src/math-converter.vala"
			_g_object_unref0 (_vala_target_unit);
#line 6615 "math-converter.c"
		}
#line 896 "../src/math-converter.vala"
		return result;
#line 6619 "math-converter.c"
	}
#line 897 "../src/math-converter.vala"
	_tmp22_ = self->priv->from_number;
#line 897 "../src/math-converter.vala"
	if (x == _tmp22_) {
#line 6625 "math-converter.c"
		UnitCategory* _tmp23_;
		Unit* _tmp24_;
		Unit* _tmp25_;
		Number* _tmp26_;
#line 898 "../src/math-converter.vala"
		_tmp23_ = category;
#line 898 "../src/math-converter.vala"
		_tmp24_ = _vala_source_unit;
#line 898 "../src/math-converter.vala"
		_tmp25_ = _vala_target_unit;
#line 898 "../src/math-converter.vala"
		_tmp26_ = unit_category_convert (_tmp23_, x, _tmp24_, _tmp25_);
#line 898 "../src/math-converter.vala"
		result = _tmp26_;
#line 898 "../src/math-converter.vala"
		_g_object_unref0 (category);
#line 898 "../src/math-converter.vala"
		if (source_unit) {
#line 898 "../src/math-converter.vala"
			*source_unit = _vala_source_unit;
#line 6646 "math-converter.c"
		} else {
#line 898 "../src/math-converter.vala"
			_g_object_unref0 (_vala_source_unit);
#line 6650 "math-converter.c"
		}
#line 898 "../src/math-converter.vala"
		if (target_unit) {
#line 898 "../src/math-converter.vala"
			*target_unit = _vala_target_unit;
#line 6656 "math-converter.c"
		} else {
#line 898 "../src/math-converter.vala"
			_g_object_unref0 (_vala_target_unit);
#line 6660 "math-converter.c"
		}
#line 898 "../src/math-converter.vala"
		return result;
#line 6664 "math-converter.c"
	} else {
		UnitCategory* _tmp27_;
		Unit* _tmp28_;
		Unit* _tmp29_;
		Number* _tmp30_;
#line 900 "../src/math-converter.vala"
		_tmp27_ = category;
#line 900 "../src/math-converter.vala"
		_tmp28_ = _vala_target_unit;
#line 900 "../src/math-converter.vala"
		_tmp29_ = _vala_source_unit;
#line 900 "../src/math-converter.vala"
		_tmp30_ = unit_category_convert (_tmp27_, x, _tmp28_, _tmp29_);
#line 900 "../src/math-converter.vala"
		result = _tmp30_;
#line 900 "../src/math-converter.vala"
		_g_object_unref0 (category);
#line 900 "../src/math-converter.vala"
		if (source_unit) {
#line 900 "../src/math-converter.vala"
			*source_unit = _vala_source_unit;
#line 6686 "math-converter.c"
		} else {
#line 900 "../src/math-converter.vala"
			_g_object_unref0 (_vala_source_unit);
#line 6690 "math-converter.c"
		}
#line 900 "../src/math-converter.vala"
		if (target_unit) {
#line 900 "../src/math-converter.vala"
			*target_unit = _vala_target_unit;
#line 6696 "math-converter.c"
		} else {
#line 900 "../src/math-converter.vala"
			_g_object_unref0 (_vala_target_unit);
#line 6700 "math-converter.c"
		}
#line 900 "../src/math-converter.vala"
		return result;
#line 6704 "math-converter.c"
	}
}

MathEquation*
math_converter_get_equation (MathConverter* self)
{
	MathEquation* result;
	MathEquation* _tmp0_;
#line 21 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 21 "../src/math-converter.vala"
	_tmp0_ = self->priv->_equation;
#line 21 "../src/math-converter.vala"
	result = _tmp0_;
#line 21 "../src/math-converter.vala"
	return result;
#line 6721 "math-converter.c"
}

void
math_converter_set_equation (MathConverter* self,
                             MathEquation* value)
{
	MathEquation* old_value;
#line 21 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 21 "../src/math-converter.vala"
	old_value = math_converter_get_equation (self);
#line 21 "../src/math-converter.vala"
	if (old_value != value) {
#line 6735 "math-converter.c"
		MathEquation* _tmp0_;
#line 21 "../src/math-converter.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 21 "../src/math-converter.vala"
		_g_object_unref0 (self->priv->_equation);
#line 21 "../src/math-converter.vala"
		self->priv->_equation = _tmp0_;
#line 21 "../src/math-converter.vala"
		g_object_notify_by_pspec ((GObject *) self, math_converter_properties[MATH_CONVERTER_EQUATION_PROPERTY]);
#line 6745 "math-converter.c"
	}
}

static gchar**
_vala_array_dup6 (gchar** self,
                  gssize length)
{
#line 30 "../src/math-converter.vala"
	if (length >= 0) {
#line 6755 "math-converter.c"
		gchar** result;
		gssize i;
#line 30 "../src/math-converter.vala"
		result = g_new0 (gchar*, length + 1);
#line 30 "../src/math-converter.vala"
		for (i = 0; i < length; i++) {
#line 6762 "math-converter.c"
			gchar* _tmp0_;
#line 30 "../src/math-converter.vala"
			_tmp0_ = g_strdup (self[i]);
#line 30 "../src/math-converter.vala"
			result[i] = _tmp0_;
#line 6768 "math-converter.c"
		}
#line 30 "../src/math-converter.vala"
		return result;
#line 6772 "math-converter.c"
	}
#line 30 "../src/math-converter.vala"
	return NULL;
#line 6776 "math-converter.c"
}

gchar**
math_converter_get_source_units (MathConverter* self,
                                 gint* result_length1)
{
	gchar** result;
	GHashTable* _tmp0_;
	GPtrArray* _tmp1_;
	GPtrArray* _tmp2_;
	gpointer* _tmp3_;
	gint _tmp3__length1;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gchar** _tmp6_;
	gint _tmp6__length1;
#line 30 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/math-converter.vala"
	_tmp0_ = self->priv->_source_units;
#line 30 "../src/math-converter.vala"
	_tmp1_ = g_hash_table_get_values_as_ptr_array (_tmp0_);
#line 30 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 30 "../src/math-converter.vala"
	_tmp3_ = _tmp2_->pdata;
#line 30 "../src/math-converter.vala"
	_tmp3__length1 = _tmp2_->len;
#line 30 "../src/math-converter.vala"
	_tmp4_ = (_tmp3_ != NULL) ? _vala_array_dup6 (_tmp3_, _tmp3__length1) : _tmp3_;
#line 30 "../src/math-converter.vala"
	_tmp4__length1 = _tmp3__length1;
#line 30 "../src/math-converter.vala"
	_tmp5_ = _tmp4_;
#line 30 "../src/math-converter.vala"
	_tmp5__length1 = _tmp4__length1;
#line 30 "../src/math-converter.vala"
	_g_ptr_array_unref0 (_tmp2_);
#line 30 "../src/math-converter.vala"
	_tmp6_ = _tmp5_;
#line 30 "../src/math-converter.vala"
	_tmp6__length1 = _tmp5__length1;
#line 30 "../src/math-converter.vala"
	if (result_length1) {
#line 30 "../src/math-converter.vala"
		*result_length1 = _tmp6__length1;
#line 6825 "math-converter.c"
	}
#line 30 "../src/math-converter.vala"
	result = _tmp6_;
#line 30 "../src/math-converter.vala"
	return result;
#line 6831 "math-converter.c"
}

void
math_converter_set_source_units (MathConverter* self,
                                 gchar** value,
                                 gint value_length1)
{
	GHashTable* _tmp0_;
#line 31 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/math-converter.vala"
	_tmp0_ = self->priv->_source_units;
#line 31 "../src/math-converter.vala"
	math_converter_load_selected_units (self, _tmp0_, value, (gint) value_length1);
#line 31 "../src/math-converter.vala"
	g_object_notify_by_pspec ((GObject *) self, math_converter_properties[MATH_CONVERTER_SOURCE_UNITS_PROPERTY]);
#line 6848 "math-converter.c"
}

static gchar**
_vala_array_dup7 (gchar** self,
                  gssize length)
{
#line 36 "../src/math-converter.vala"
	if (length >= 0) {
#line 6857 "math-converter.c"
		gchar** result;
		gssize i;
#line 36 "../src/math-converter.vala"
		result = g_new0 (gchar*, length + 1);
#line 36 "../src/math-converter.vala"
		for (i = 0; i < length; i++) {
#line 6864 "math-converter.c"
			gchar* _tmp0_;
#line 36 "../src/math-converter.vala"
			_tmp0_ = g_strdup (self[i]);
#line 36 "../src/math-converter.vala"
			result[i] = _tmp0_;
#line 6870 "math-converter.c"
		}
#line 36 "../src/math-converter.vala"
		return result;
#line 6874 "math-converter.c"
	}
#line 36 "../src/math-converter.vala"
	return NULL;
#line 6878 "math-converter.c"
}

gchar**
math_converter_get_target_units (MathConverter* self,
                                 gint* result_length1)
{
	gchar** result;
	GHashTable* _tmp0_;
	GPtrArray* _tmp1_;
	GPtrArray* _tmp2_;
	gpointer* _tmp3_;
	gint _tmp3__length1;
	gchar** _tmp4_;
	gint _tmp4__length1;
	gchar** _tmp5_;
	gint _tmp5__length1;
	gchar** _tmp6_;
	gint _tmp6__length1;
#line 36 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "../src/math-converter.vala"
	_tmp0_ = self->priv->_target_units;
#line 36 "../src/math-converter.vala"
	_tmp1_ = g_hash_table_get_values_as_ptr_array (_tmp0_);
#line 36 "../src/math-converter.vala"
	_tmp2_ = _tmp1_;
#line 36 "../src/math-converter.vala"
	_tmp3_ = _tmp2_->pdata;
#line 36 "../src/math-converter.vala"
	_tmp3__length1 = _tmp2_->len;
#line 36 "../src/math-converter.vala"
	_tmp4_ = (_tmp3_ != NULL) ? _vala_array_dup7 (_tmp3_, _tmp3__length1) : _tmp3_;
#line 36 "../src/math-converter.vala"
	_tmp4__length1 = _tmp3__length1;
#line 36 "../src/math-converter.vala"
	_tmp5_ = _tmp4_;
#line 36 "../src/math-converter.vala"
	_tmp5__length1 = _tmp4__length1;
#line 36 "../src/math-converter.vala"
	_g_ptr_array_unref0 (_tmp2_);
#line 36 "../src/math-converter.vala"
	_tmp6_ = _tmp5_;
#line 36 "../src/math-converter.vala"
	_tmp6__length1 = _tmp5__length1;
#line 36 "../src/math-converter.vala"
	if (result_length1) {
#line 36 "../src/math-converter.vala"
		*result_length1 = _tmp6__length1;
#line 6927 "math-converter.c"
	}
#line 36 "../src/math-converter.vala"
	result = _tmp6_;
#line 36 "../src/math-converter.vala"
	return result;
#line 6933 "math-converter.c"
}

void
math_converter_set_target_units (MathConverter* self,
                                 gchar** value,
                                 gint value_length1)
{
	GHashTable* _tmp0_;
#line 37 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/math-converter.vala"
	_tmp0_ = self->priv->_target_units;
#line 37 "../src/math-converter.vala"
	math_converter_load_selected_units (self, _tmp0_, value, (gint) value_length1);
#line 37 "../src/math-converter.vala"
	g_object_notify_by_pspec ((GObject *) self, math_converter_properties[MATH_CONVERTER_TARGET_UNITS_PROPERTY]);
#line 6950 "math-converter.c"
}

void
math_converter_set_currency_display (MathConverter* self,
                                     CurrencyDisplay value)
{
	const gchar* _tmp0_;
#line 43 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/math-converter.vala"
	if (self->priv->_currency_display == value) {
#line 46 "../src/math-converter.vala"
		return;
#line 6964 "math-converter.c"
	}
#line 47 "../src/math-converter.vala"
	self->priv->_currency_display = value;
#line 48 "../src/math-converter.vala"
	_tmp0_ = self->priv->category;
#line 48 "../src/math-converter.vala"
	if (g_strcmp0 (_tmp0_, "currency") == 0) {
#line 49 "../src/math-converter.vala"
		math_converter_category_combobox_changed_cb (self);
#line 6974 "math-converter.c"
	}
#line 43 "../src/math-converter.vala"
	g_object_notify_by_pspec ((GObject *) self, math_converter_properties[MATH_CONVERTER_CURRENCY_DISPLAY_PROPERTY]);
#line 6978 "math-converter.c"
}

gboolean
math_converter_get_box_visible (MathConverter* self)
{
	gboolean result;
#line 86 "../src/math-converter.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 86 "../src/math-converter.vala"
	result = self->priv->_box_visible;
#line 86 "../src/math-converter.vala"
	return result;
#line 6991 "math-converter.c"
}

void
math_converter_set_box_visible (MathConverter* self,
                                gboolean value)
{
	gboolean old_value;
#line 86 "../src/math-converter.vala"
	g_return_if_fail (self != NULL);
#line 86 "../src/math-converter.vala"
	old_value = math_converter_get_box_visible (self);
#line 86 "../src/math-converter.vala"
	if (old_value != value) {
#line 86 "../src/math-converter.vala"
		self->priv->_box_visible = value;
#line 86 "../src/math-converter.vala"
		g_object_notify_by_pspec ((GObject *) self, math_converter_properties[MATH_CONVERTER_BOX_VISIBLE_PROPERTY]);
#line 7009 "math-converter.c"
	}
}

static void
_math_converter_construct_finish_g_object_notify (GObject* _sender,
                                                  GParamSpec* pspec,
                                                  gpointer self)
{
#line 103 "../src/math-converter.vala"
	math_converter_construct_finish ((MathConverter*) self);
#line 7020 "math-converter.c"
}

static GObject *
math_converter_constructor (GType type,
                            guint n_construct_properties,
                            GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	MathConverter * self;
	GSimpleActionGroup* _tmp0_;
	GSimpleActionGroup* _tmp1_;
#line 99 "../src/math-converter.vala"
	parent_class = G_OBJECT_CLASS (math_converter_parent_class);
#line 99 "../src/math-converter.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 99 "../src/math-converter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MATH_CONVERTER, MathConverter);
#line 101 "../src/math-converter.vala"
	_tmp0_ = self->priv->action_group;
#line 101 "../src/math-converter.vala"
	g_action_map_add_action_entries ((GActionMap*) _tmp0_, MATH_CONVERTER_action_entries, (gint) G_N_ELEMENTS (MATH_CONVERTER_action_entries), self);
#line 102 "../src/math-converter.vala"
	_tmp1_ = self->priv->action_group;
#line 102 "../src/math-converter.vala"
	gtk_widget_insert_action_group ((GtkWidget*) self, "context-menu", (GActionGroup*) _tmp1_);
#line 103 "../src/math-converter.vala"
	g_signal_connect_object ((GObject*) self, "notify::equation", (GCallback) _math_converter_construct_finish_g_object_notify, self, 0);
#line 99 "../src/math-converter.vala"
	return obj;
#line 7051 "math-converter.c"
}

static void
math_converter_class_init (MathConverterClass * klass,
                           gpointer klass_data)
{
#line 19 "../src/math-converter.vala"
	math_converter_parent_class = g_type_class_peek_parent (klass);
#line 19 "../src/math-converter.vala"
	g_type_class_adjust_private_offset (klass, &MathConverter_private_offset);
#line 19 "../src/math-converter.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_math_converter_get_property;
#line 19 "../src/math-converter.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_math_converter_set_property;
#line 19 "../src/math-converter.vala"
	G_OBJECT_CLASS (klass)->constructor = math_converter_constructor;
#line 19 "../src/math-converter.vala"
	G_OBJECT_CLASS (klass)->finalize = math_converter_finalize;
#line 19 "../src/math-converter.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MATH_CONVERTER_EQUATION_PROPERTY, math_converter_properties[MATH_CONVERTER_EQUATION_PROPERTY] = g_param_spec_object ("equation", "equation", "equation", TYPE_MATH_EQUATION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
#line 19 "../src/math-converter.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MATH_CONVERTER_SOURCE_UNITS_PROPERTY, math_converter_properties[MATH_CONVERTER_SOURCE_UNITS_PROPERTY] = g_param_spec_boxed ("source-units", "source-units", "source-units", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 19 "../src/math-converter.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MATH_CONVERTER_TARGET_UNITS_PROPERTY, math_converter_properties[MATH_CONVERTER_TARGET_UNITS_PROPERTY] = g_param_spec_boxed ("target-units", "target-units", "target-units", G_TYPE_STRV, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 19 "../src/math-converter.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MATH_CONVERTER_CURRENCY_DISPLAY_PROPERTY, math_converter_properties[MATH_CONVERTER_CURRENCY_DISPLAY_PROPERTY] = g_param_spec_enum ("currency-display", "currency-display", "currency-display", TYPE_CURRENCY_DISPLAY, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 19 "../src/math-converter.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MATH_CONVERTER_BOX_VISIBLE_PROPERTY, math_converter_properties[MATH_CONVERTER_BOX_VISIBLE_PROPERTY] = g_param_spec_boolean ("box-visible", "box-visible", "box-visible", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 19 "../src/math-converter.vala"
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/gnome/calculator/math-converter.ui");
#line 19 "../src/math-converter.vala"
	math_converter_signals[MATH_CONVERTER_CHANGED_SIGNAL] = g_signal_new ("changed", TYPE_MATH_CONVERTER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 19 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "category_combo", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, category_combo));
#line 19 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "from_combo", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, from_combo));
#line 19 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "to_combo", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, to_combo));
#line 19 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "from_entry", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, from_entry));
#line 19 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "to_entry", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, to_entry));
#line 19 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "from_context_menu", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, from_context_menu));
#line 19 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "to_context_menu", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, to_context_menu));
#line 19 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "from_event_controller", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, from_event_controller));
#line 19 "../src/math-converter.vala"
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "to_event_controller", FALSE, MathConverter_private_offset + G_STRUCT_OFFSET (MathConverterPrivate, to_event_controller));
#line 19 "../src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "category_combobox_changed_cb", G_CALLBACK(_math_converter_category_combobox_changed_cb_g_object_notify));
#line 19 "../src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "to_combobox_changed_cb", G_CALLBACK(_math_converter_to_combobox_changed_cb_g_object_notify));
#line 19 "../src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "from_entry_focus_cb", G_CALLBACK(_math_converter_from_entry_focus_cb_g_object_notify));
#line 19 "../src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "to_entry_focus_cb", G_CALLBACK(_math_converter_to_entry_focus_cb_g_object_notify));
#line 19 "../src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "key_press_cb", G_CALLBACK(_math_converter_key_press_cb_gtk_event_controller_key_key_pressed));
#line 19 "../src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "from_entry_click_cb", G_CALLBACK(_math_converter_from_entry_click_cb_gtk_gesture_click_pressed));
#line 19 "../src/math-converter.vala"
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "to_entry_click_cb", G_CALLBACK(_math_converter_to_entry_click_cb_gtk_gesture_click_pressed));
#line 91 "../src/math-converter.vala"
	gtk_widget_class_set_css_name (GTK_WIDGET_CLASS (klass), "mathconverter");
#line 7118 "math-converter.c"
}

static void
math_converter_instance_init (MathConverter * self,
                              gpointer klass)
{
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GHashFunc _tmp3_;
	GEqualFunc _tmp4_;
	GHashTable* _tmp5_;
	GSimpleActionGroup* _tmp6_;
#line 19 "../src/math-converter.vala"
	self->priv = math_converter_get_instance_private (self);
#line 27 "../src/math-converter.vala"
	_tmp0_ = g_str_hash;
#line 27 "../src/math-converter.vala"
	_tmp1_ = g_str_equal;
#line 27 "../src/math-converter.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_free0_);
#line 27 "../src/math-converter.vala"
	self->priv->_source_units = _tmp2_;
#line 33 "../src/math-converter.vala"
	_tmp3_ = g_str_hash;
#line 33 "../src/math-converter.vala"
	_tmp4_ = g_str_equal;
#line 33 "../src/math-converter.vala"
	_tmp5_ = g_hash_table_new_full (_tmp3_, _tmp4_, _g_free0_, _g_free0_);
#line 33 "../src/math-converter.vala"
	self->priv->_target_units = _tmp5_;
#line 75 "../src/math-converter.vala"
	self->priv->from_combobox_changed = (gulong) 0;
#line 79 "../src/math-converter.vala"
	_tmp6_ = g_simple_action_group_new ();
#line 79 "../src/math-converter.vala"
	self->priv->action_group = _tmp6_;
#line 86 "../src/math-converter.vala"
	self->priv->_box_visible = FALSE;
#line 19 "../src/math-converter.vala"
	gtk_widget_init_template (GTK_WIDGET (self));
#line 7160 "math-converter.c"
}

static void
math_converter_finalize (GObject * obj)
{
	MathConverter * self;
#line 19 "../src/math-converter.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MATH_CONVERTER, MathConverter);
#line 21 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->_equation);
#line 23 "../src/math-converter.vala"
	_g_free0 (self->priv->category);
#line 24 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->from_number);
#line 25 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->to_number);
#line 27 "../src/math-converter.vala"
	_g_hash_table_unref0 (self->priv->_source_units);
#line 33 "../src/math-converter.vala"
	_g_hash_table_unref0 (self->priv->_target_units);
#line 68 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->fixed_serializer);
#line 69 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->from_currency_factory);
#line 70 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->to_currency_factory);
#line 79 "../src/math-converter.vala"
	_g_object_unref0 (self->priv->action_group);
#line 19 "../src/math-converter.vala"
	G_OBJECT_CLASS (math_converter_parent_class)->finalize (obj);
#line 7191 "math-converter.c"
}

static GType
math_converter_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MathConverterClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) math_converter_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MathConverter), 0, (GInstanceInitFunc) math_converter_instance_init, NULL };
	GType math_converter_type_id;
	math_converter_type_id = g_type_register_static (gtk_box_get_type (), "MathConverter", &g_define_type_info, 0);
	MathConverter_private_offset = g_type_add_instance_private (math_converter_type_id, sizeof (MathConverterPrivate));
	return math_converter_type_id;
}

GType
math_converter_get_type (void)
{
	static volatile gsize math_converter_type_id__once = 0;
	if (g_once_init_enter (&math_converter_type_id__once)) {
		GType math_converter_type_id;
		math_converter_type_id = math_converter_get_type_once ();
		g_once_init_leave (&math_converter_type_id__once, math_converter_type_id);
	}
	return math_converter_type_id__once;
}

static void
_vala_math_converter_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec)
{
	MathConverter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MATH_CONVERTER, MathConverter);
#line 19 "../src/math-converter.vala"
	switch (property_id) {
#line 19 "../src/math-converter.vala"
		case MATH_CONVERTER_EQUATION_PROPERTY:
#line 19 "../src/math-converter.vala"
		g_value_set_object (value, math_converter_get_equation (self));
#line 19 "../src/math-converter.vala"
		break;
#line 19 "../src/math-converter.vala"
		case MATH_CONVERTER_SOURCE_UNITS_PROPERTY:
#line 7234 "math-converter.c"
		{
			int length;
#line 19 "../src/math-converter.vala"
			g_value_take_boxed (value, math_converter_get_source_units (self, &length));
#line 7239 "math-converter.c"
		}
#line 19 "../src/math-converter.vala"
		break;
#line 19 "../src/math-converter.vala"
		case MATH_CONVERTER_TARGET_UNITS_PROPERTY:
#line 7245 "math-converter.c"
		{
			int length;
#line 19 "../src/math-converter.vala"
			g_value_take_boxed (value, math_converter_get_target_units (self, &length));
#line 7250 "math-converter.c"
		}
#line 19 "../src/math-converter.vala"
		break;
#line 19 "../src/math-converter.vala"
		case MATH_CONVERTER_BOX_VISIBLE_PROPERTY:
#line 19 "../src/math-converter.vala"
		g_value_set_boolean (value, math_converter_get_box_visible (self));
#line 19 "../src/math-converter.vala"
		break;
#line 7260 "math-converter.c"
		default:
#line 19 "../src/math-converter.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/math-converter.vala"
		break;
#line 7266 "math-converter.c"
	}
}

static void
_vala_math_converter_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec)
{
	MathConverter * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MATH_CONVERTER, MathConverter);
#line 19 "../src/math-converter.vala"
	switch (property_id) {
#line 19 "../src/math-converter.vala"
		case MATH_CONVERTER_EQUATION_PROPERTY:
#line 19 "../src/math-converter.vala"
		math_converter_set_equation (self, g_value_get_object (value));
#line 19 "../src/math-converter.vala"
		break;
#line 19 "../src/math-converter.vala"
		case MATH_CONVERTER_SOURCE_UNITS_PROPERTY:
#line 7288 "math-converter.c"
		{
			gpointer boxed;
#line 19 "../src/math-converter.vala"
			boxed = g_value_get_boxed (value);
#line 19 "../src/math-converter.vala"
			math_converter_set_source_units (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 7295 "math-converter.c"
		}
#line 19 "../src/math-converter.vala"
		break;
#line 19 "../src/math-converter.vala"
		case MATH_CONVERTER_TARGET_UNITS_PROPERTY:
#line 7301 "math-converter.c"
		{
			gpointer boxed;
#line 19 "../src/math-converter.vala"
			boxed = g_value_get_boxed (value);
#line 19 "../src/math-converter.vala"
			math_converter_set_target_units (self, boxed, (boxed == NULL) ? 0 : g_strv_length (boxed));
#line 7308 "math-converter.c"
		}
#line 19 "../src/math-converter.vala"
		break;
#line 19 "../src/math-converter.vala"
		case MATH_CONVERTER_CURRENCY_DISPLAY_PROPERTY:
#line 19 "../src/math-converter.vala"
		math_converter_set_currency_display (self, g_value_get_enum (value));
#line 19 "../src/math-converter.vala"
		break;
#line 19 "../src/math-converter.vala"
		case MATH_CONVERTER_BOX_VISIBLE_PROPERTY:
#line 19 "../src/math-converter.vala"
		math_converter_set_box_visible (self, g_value_get_boolean (value));
#line 19 "../src/math-converter.vala"
		break;
#line 7324 "math-converter.c"
		default:
#line 19 "../src/math-converter.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 19 "../src/math-converter.vala"
		break;
#line 7330 "math-converter.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

